<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUser->forceUserAdmin();

$appOps=$OS->getAppOps();
$apps=$appOps->getAvailableApps();
$uninstalledApps=$appOps->getUninstalledApps();

if (!empty($_GET['op']))
{
	if ($_GET['op']=='remove' AND !empty($_GET['app_id']) AND isset($apps[$_GET['app_id']]))
	{
		if (!$apps[$_GET['app_id']]->uninstall())
		{
			$OS->addBoxError("Unable to uninstall application");
		}
		else
		{
			$OS->addInfo("Application uninstalled successfully");
			
			unset($apps[$_GET['app_id']]);
		}
	}
	elseif ($_GET['op']=='remove_uninstalled' AND !empty($_GET['app']) AND isset($uninstalledApps[$_GET['app']]))
	{
		if (!$appOps->removeUninstalledApp($_GET['app']))
		{
			$OS->addBoxError("Unable to remove application");
		}
		else
		{
			$OS->addInfo("Application removed successfully");
			
			unset($uninstalledApps[$_GET['app']]);
		}
	}
}

if (!empty($_GET['msg']))
{
	if ($_GET['msg']=='add_ok')
	{
		$OS->addInfo("Application installed successfully");
	}
}

$allApps=array();
if (!empty($apps))
{
	foreach ($apps as $app_id=>$app)
	{
		$allApps[$app_id]=array(
			'name' => $app->name,
			'title' => $app->title,
			'description' => $app->description,
			'remove_link' => $OS->getConfigVar('root_url')."/admin/apps.php?op=remove&app_id={$app_id}",
		);
	}
}

foreach ($uninstalledApps as $appName=>$appPath)
{
	$uninstalledApps[$appName]=array(
		'path'=>$appPath,
		'remove_link'=>"?op=remove_uninstalled&app={$appName}",
		'install_link'=>"/admin/apps_install.php?app={$appName}"
	);
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle("Manage Applications");
$tpl->addTopSectionOption('add_app',array('type'=>'link','name'=>"Add Application",'url'=>$OS->getConfigVar('root_url')."/admin/apps_add.php"));	

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('allApps',$allApps);
$tpl->setVar('uninstalledApps',$uninstalledApps);



$tpl->bodyTemplateName = "admin_apps";

echo $tpl->mainTemplateRender();
?>