<?php
include('../init.php');

$OS=getOS();

$osUser = $OS->getUser();
$osUser->forceUserAdmin();
$utils=$OS->getUtils();

$today=strtotime(date('Y-m-d'));
$current=$today;

if (!empty($_GET['date']))
{
	if ($timestamp=strtotime($_GET['date']) AND $timestamp<=$current)
	{
		if (checkdate(date('m',$timestamp),date('d',$timestamp),date('Y',$timestamp)))
		{
			$current=$timestamp;
		}
	}
}

$auditOps=$OS->getAuditOps();

$start_dt=date('Y-m-d 00:00',$current);
$end_dt=date('Y-m-d 23:59',$current);

$audits=$auditOps->getAudits($start_dt,$end_dt);

$audits_by_hour=array();

foreach ($audits as $audit_id=>$audit)
{
	if (!isset($audits_by_hour[$audit->hour]))
	{
		$audits_by_hour[$audit->hour]=array(
			'hour_human'=>$utils->humanizeDate($audit->hour,'time'),
			'messages'=>array()
		);
	}
	
	$details_link=$OS->getConfigVar('root_url').'/admin/audit_details.php?audit_id='.$audit_id;
	
	$audits_by_hour[$audit->hour]['messages'][$audit->id]=array('type'=>$audit->type,'message'=>$audit->message,'occurances'=>$audit->occurances,'details_link'=>$details_link);
}

$tpl = $OS->getTemplate();

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('ptitle',"System Audit - ".$utils->humanizeDate($current,'date'));
$tpl->setVar('audits',$audits_by_hour);

$tpl->setVar('prev_date',date('Y-m-d',$current-86400));

if ($current<$today)
{
	$tpl->setVar('next_date',date('Y-m-d',$current+86400));
}
else
{
	$tpl->setVar('next_date',false);
}



$tpl->bodyTemplateName = "admin_audit";

echo $tpl->mainTemplateRender();
?>