<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUser->forceUserAdmin();

$crons=OS_Crons::getCrons();

if (!empty($_GET['op']))
{
	if ($_GET['op']=='disable_cron' AND isset($_GET['cron_id']) AND isset($crons[$_GET['cron_id']]) AND $crons[$_GET['cron_id']]['status']=='E')
	{
		if (OS_Crons::disableCron($crons[$_GET['cron_id']]['action'],$crons[$_GET['cron_id']]['module'],$crons[$_GET['cron_id']]['module_name']))
		{
			$crons[$_GET['cron_id']]['status']='D';
			
			$OS->addInfo("Cron disabled successfully");
		}
		else
		{
			$OS->addBoxError("Unable to disable cron");
		}
	}
	elseif ($_GET['op']=='enable_cron' AND isset($_GET['cron_id']) AND isset($crons[$_GET['cron_id']]) AND $crons[$_GET['cron_id']]['status']=='D')
	{
		if (OS_Crons::enableCron($crons[$_GET['cron_id']]['action'],$crons[$_GET['cron_id']]['module'],$crons[$_GET['cron_id']]['module_name']))
		{
			$crons[$_GET['cron_id']]['status']='E';
			
			$OS->addInfo("Cron enabled successfully");
		}
		else
		{
			$OS->addBoxError("Unable to enable cron");
		}
	}
}

$interval_types=OS_Crons::getIntervalTypesHuman();
$availableApps=array();

$appOps=$OS->getAppOps();
$utils=$OS->getUtils();

if ($crons)
{
	foreach ($crons as $cron_id=>$cron_details)
	{
		if ($cron_details['module']=='app')
		{
			if (!isset($availableApps[$cron_details['module_name']]))
			{
				$availableApps[$cron_details['module_name']]=$appOps->getAppByName($cron_details['module_name']);
			}
	
			if (isset($availableApps[$cron_details['module_name']]))
			{
				$cron_details['_module_title']=$availableApps[$cron_details['module_name']]->title;
			}
			else
			{
				$cron_details['_module_title']='Unknown application';
			}
		}
		else
		{
			$cron_details['_module_title']='CORE';
		}
		
		$cron_details['_interval_human']='Every '.($cron_details['interval']==1?$interval_types[$cron_details['interval_type']]['singular']:$cron_details['interval'].' '.$interval_types[$cron_details['interval_type']]['plural']);
	
		if ($cron_details['runs']>0)
		{
			$cron_details['_run_dt_human']=$utils->humanizeDate($cron_details['run_dt']);
		}
		
		if ($cron_details['fails']>0)
		{
			$cron_details['_fail_dt_human']=$utils->humanizeDate($cron_details['fail_dt']);
		}
		
		$cron_details['action_url']=($cron_details['status']=='E'?"?op=disable_cron&cron_id={$cron_id}":"?op=enable_cron&cron_id={$cron_id}");
		$cron_details['action_name']=($cron_details['status']=='E'?'Disable cron':'Enable cron');
		
		$crons[$cron_id]=$cron_details;
	}
}
else
{
	$crons=array();
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle("Manage Crons");

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('crons',$crons);



$tpl->bodyTemplateName = "admin_crons";

echo $tpl->mainTemplateRender();
?>