<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUser->forceUserAdmin();

$datasourceOps=$OS->getDatasourceOps();

if (!$datasources=$datasourceOps->getDatasources())
{
	$datasources=array();
}

if (!empty($_GET['op']))
{
	if ($_GET['op']=='disable_datasource' AND isset($_GET['datasource_id']) AND isset($datasources[$_GET['datasource_id']]) AND $datasources[$_GET['datasource_id']]->status=='E')
	{
		if ($datasources[$_GET['datasource_id']]->disable())
		{
			$OS->addInfo("Datasource disabled successfully");
		}
		else
		{
			$OS->addBoxError("Unable to disable datasource");
		}
	}
	elseif ($_GET['op']=='enable_datasource' AND isset($_GET['datasource_id']) AND isset($datasources[$_GET['datasource_id']]) AND $datasources[$_GET['datasource_id']]->status=='D')
	{
		if ($datasources[$_GET['datasource_id']]->enable())
		{
			$OS->addInfo("Datasource enabled successfully");
		}
		else
		{
			$OS->addBoxError("Unable to enable datasource");
		}
	}
}

$connections=array();

foreach ($datasources as $datasource_id=>$datasource)
{
	$datasources[$datasource_id]=$datasource->toTemplate();
	$connections[$datasource_id]=$datasourceOps->getDatasourceConnections($datasource);
}

$availableApps=array();
$appOps=$OS->getAppOps();

foreach ($datasources as $datasource_id=>$datasource_details)
{
	if ($datasource_details['module']=='app')
	{
		if (!isset($availableApps[$datasource_details['module_name']]))
		{
			$availableApps[$datasource_details['module_name']]=$appOps->getAppByName($datasource_details['module_name']);
		}

		if (isset($availableApps[$datasource_details['module_name']]))
		{
			$datasource_details['_module_title']=$availableApps[$datasource_details['module_name']]->title;
		}
		else
		{
			$datasource_details['_module_title']='Unknown application';
		}
	}
	else
	{
		$datasource_details['_module_title']='CORE';
	}
	
	$datasource_details['action_url']=($datasource_details['status']=='E'?"?op=disable_datasource&datasource_id={$datasource_id}":"?op=enable_datasource&datasource_id={$datasource_id}");
	$datasource_details['action_name']=($datasource_details['status']=='E'?'Disable datasource':'Enable datasource');
	
	$datasources[$datasource_id]=$datasource_details;
}

foreach ($connections as $connection_id=>$connection_details)
{
	if ($connection_details)
	{
		if ($connection_details['module']=='app')
		{
			if (!isset($availableApps[$connection_details['module_name']]))
			{
				$availableApps[$connection_details['module_name']]=$appOps->getAppByName($connection_details['module_name']);
			}
	
			if (isset($availableApps[$connection_details['module_name']]))
			{
				$connection_details['_module_title']=$availableApps[$connection_details['module_name']]->title;
			}
			else
			{
				$connection_details['_module_title']='Unknown application';
			}
		}
		else
		{
			$connection_details['_module_title']='CORE';
		}
		
		$connections[$connection_id]=$connection_details;
	}
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle("Manage Datasources");

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('datasources',$datasources);
$tpl->setVar('connections',$connections);



$tpl->bodyTemplateName = "admin_datasources";

echo $tpl->mainTemplateRender();
?>