<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUser->forceUserAdmin();

if ($events=OS_Events::getEvents())
{
	foreach ($events as $event_id=>$event_details)
	{
		$events[$event_id]['_handlers']=OS_Events::getEventHandlers($event_details['name']);
	}
}

if (!empty($_GET['op']))
{
	if ($_GET['op']=='disable_event' AND isset($_GET['event_id']) AND isset($events[$_GET['event_id']]) AND $events[$_GET['event_id']]['status']=='E')
	{
		if (OS_Events::disableEvent($events[$_GET['event_id']]['name']))
		{
			$events[$_GET['event_id']]['status']='D';
			
			$OS->addInfo("Event disabled successfully");
		}
		else
		{
			$OS->addBoxError("Unable to disable event");
		}
	}
	elseif ($_GET['op']=='enable_event' AND isset($_GET['event_id']) AND isset($events[$_GET['event_id']]) AND $events[$_GET['event_id']]['status']=='D')
	{
		if (OS_Events::enableEvent($events[$_GET['event_id']]['name']))
		{
			$events[$_GET['event_id']]['status']='E';
			
			$OS->addInfo("Event enabled successfully");
		}
		else
		{
			$OS->addBoxError("Unable to enable event");
		}
	}
	elseif ($_GET['op']=='disable_event_handler' AND isset($_GET['event_id']) AND isset($_GET['event_handler_id']) AND isset($events[$_GET['event_id']]) AND isset($events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]) AND $events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['status']=='E')
	{
		if (OS_Events::disableEventHandler($events[$_GET['event_id']]['name'],$events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['module'],$events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['module_name'],$events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['method']))
		{
			$events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['status']='D';
			
			$OS->addInfo("Event handler disabled successfully");
		}
		else
		{
			$OS->addBoxError("Unable to disable event handler");
		}
	}
	elseif ($_GET['op']=='enable_event_handler' AND isset($_GET['event_id']) AND isset($_GET['event_handler_id']) AND isset($events[$_GET['event_id']]) AND isset($events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]) AND $events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['status']=='D')
	{
		if (OS_Events::enableEventHandler($events[$_GET['event_id']]['name'],$events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['module'],$events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['module_name'],$events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['method']))
		{
			$events[$_GET['event_id']]['_handlers'][$_GET['event_handler_id']]['status']='E';
			
			$OS->addInfo("Event handler enabled successfully");
		}
		else
		{
			$OS->addBoxError("Unable to enable event handler");
		}
	}
}

$availableApps=array();

$appOps=$OS->getAppOps();

if ($events)
{
	foreach ($events as $event_id=>$event_details)
	{
		if (!empty($event_details['_handlers']))
		{
			foreach ($event_details['_handlers'] as $handler_id=>$handler_details)
			{
				if ($handler_details['module']=='app')
				{
					if (!isset($availableApps[$handler_details['module_name']]))
					{
						$availableApps[$handler_details['module_name']]=$appOps->getAppByName($handler_details['module_name']);
					}
	
					if (isset($availableApps[$handler_details['module_name']]))
					{
						$handler_details['_module_title']=$availableApps[$handler_details['module_name']]->title;
					}
					else
					{
						$handler_details['_module_title']='Unknown application';
					}
				}
				else
				{
					$handler_details['_module_title']='CORE';
				}
				
				$handler_details['action_url']=($handler_details['status']=='E'?"?op=disable_event_handler&event_id={$event_id}&event_handler_id={$handler_id}":"?op=enable_event_handler&event_id={$event_id}&event_handler_id={$handler_id}");
				$handler_details['action_name']=($handler_details['status']=='E'?'Disable handler':'Enable handler');
				
				$event_details['_handlers'][$handler_id]=$handler_details;
			}
		}
		
		$event_details['action_url']=($event_details['status']=='E'?"?op=disable_event&event_id={$event_id}":"?op=enable_event&event_id={$event_id}");
		$event_details['action_name']=($event_details['status']=='E'?'Disable event':'Enable event');
		
		$events[$event_id]=$event_details;
	}
}
else
{
	$events=array();
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle("Manage Events");

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('events',$events);



$tpl->bodyTemplateName = "admin_events";

echo $tpl->mainTemplateRender();
?>