<?php
include "../../init.php";

class osAjaxAdminInteractionsManager
{
	public function __construct()
	{
		$this->permissionsRequired = array('checkUserLogged', 'checkUserAdmin');
	}
	
	public function getInteractionsDetails($params)
	{
		$OS = getOS();
		
		$result = false;
		
		$systemInteractions = OS_Interactions::getAllInteractions();
		
		//handle Interactions
		if($systemInteractions === false)
		{
			$systemInteractions=array();
		}

		
		//build Admin Boards
		$adminBoards = array();
		$parentItems = $OS->getMenu()->getParentItems('admin_apps_manager');
		if(!empty($parentItems))
		{
			foreach($parentItems as $item => $details)
			{
				$adminBoards[] = array('title' => $details['title'], 'name' => $item);
			}
		}
		
		$responseData =  array(
			'actionStatus' => $result,
			'actionData' => array('availableInteractions' => $systemInteractions,  'boards' => $adminBoards)
		);
			
		return $responseData;
	}
	
	public function updateInteractionsDetails($params)
	{
		$responseData = array('actionStatus' => false, 'actionData'=> array());
		
		if(isset($params['current_op']))
		{
			if($params['current_op']=='disable_interaction')
			{
				$interactionResult = $this->handleDisableInteraction($params);
				
				$responseData['actionStatus'] = $interactionResult['result'];
				$responseData['actionData'] = array_merge($responseData['actionData'], $interactionResult);
			}
			elseif($params['current_op']=='enable_interaction')
			{
				$interactionResult = $this->handleEnableInteraction($params);
				
				$responseData['actionStatus'] = $interactionResult['result'];
				$responseData['actionData'] = array_merge($responseData['actionData'], $interactionResult);
			}
		}
	
		return $responseData;
	}
	
	public function handleEnableInteraction($params)
	{
		$responseData = array('result'=> false);
		
		if ($result = OS_Interactions::enableInteraction($params['id']))	
		{
			$responseData['result'] = true;
			$responseData['modelDetails']['status'] = "A";
			$responseData['notifications'][] = array('type'=> 'success', 'message' => _("Interaction enabled successfully"));	
		}
		else
		{
			$responseData['notifications'][] = array('type'=> 'error', 'message' => _("Unable to enable interaction"));	
		}
		
		return $responseData;
	}

	public function handleDisableInteraction($params)
	{
		$responseData = array('result'=> false);
		
		if($result = OS_Interactions::disableInteraction($params['id']))	
		{
			$responseData['result'] = true;
			$responseData['modelDetails']['status'] = "D";
			$responseData['notifications'][] = array('type'=> 'success', 'message' => _("Interaction disabled successfully"));	
		}
		else
		{
			$responseData['notifications'][] = array('type'=> 'error', 'message' => _("Unable to disable interaction"));	
		}
		
		return $responseData;
	}	
}

//set the ajax server
$OS = getOS();
$osAjax = $OS->getAjax();
$osAjax->setClass("osAjaxAdminInteractionsManager");
$osAjax->handle();
?>