<?php
include "../../init.php";

class osAjaxProjectManager
{
	private $osProject;
	
	private $osUser;
	
	public function __construct()
	{
		$OS = getOS();
		
		$this->osUser = $OS->getUser();
		
		$this->osProject = $OS->getProject();
		
		$this->permissionsRequired = array('checkUserLogged', 'checkUserProject');
	}
		
	public function updateManagerDetails($params)
	{
		$responseData = array('actionStatus' => false, 'actionData'=> array());
		
		$valid_op = false;
		
		//check operations
		if(isset($params['current_op']))
		{
			$OS = getOS();
			
			if($params['current_op'] == 'change_project')
			{
				if(isset($params['project_id']))
				{
					$valid_op = true;
					
					$oneProject = $this->osProject;
					$loadResult = $oneProject->close();
					
					if($loadResult)
					{
						$oneProject->id = $params['project_id'];
						$oneProject->user_id = $this->osUser->id;
						$loadResult = $oneProject->open();
						
						if($loadResult)
						{
							$responseData['actionData']['notifications'][] = array("type" => "success", "message" => _("Project Changed"));
							$responseData['actionStatus'] = true;
							
							//get updated menu
							$osMenu = $OS->getMenu();
							
							$responseData['actionData']['modelDetails'] = array(
								'os_menu' => array(
									'options_menu' => $osMenu->getOptionsMenu(),
									'settings_menu' => $osMenu->getSettingsMenu(),
									)
								);
						}
						else
						{
							$responseData['actionData']['notifications'][] = array("type" => "error", "message" => _("Project cannot be changed"));
						}
					}
					else
					{
						$responseData['actionData']['notifications'][] = array("type" => "error", "message" => _("Project cannot be closed"));
					}
				}
			}
			
		}
		
		if(!$valid_op)
		{
			$responseData['actionData']['notifications'][] = array("type" => "error", "message" => _("Invalid Operation"));	
		}
		
		return $responseData;
	}		
			
}

//set the ajax server
$OS = getOS();
$osAjax = $OS->getAjax();
$osAjax->setClass("osAjaxProjectManager");
$osAjax->handle();