<?php
class OS_CRON_app_stats
{
	public function run()
	{
		$OS=getOS();
		$db=$OS->getDb();
		
		$log_path=os_join_path($OS->getConfigVar('storage_path'),'app_stats.log');
		
		$stats=array();
		$stats_by_name=array();
		$app_id_to_name=array();
		
		if (file_exists($log_path))
		{
			rename($log_path,$log_path.'.old');
			$log_path.='.old';
			
			if ($file_handler=fopen($log_path,'r'))
			{
				while (!feof($file_handler))
				{
					if ($line=fgets($file_handler))
					{
						$line=explode('|',trim($line));
						
						$date=date('Y-m-d',$line[2]);
						
						if (!isset($app_id_to_name[$line[0]]))
						{
							$app_id_to_name[$line[0]]=$line[1];
						}
						
						if (!isset($stats[$line[0]][$date]))
						{
							$stats[$line[0]][$date]=array('opens'=>0,'starts'=>0,'stops'=>0,'adds'=>0,'removes'=>0);
						}
						if (!isset($stats_by_name[$line[0]][$date]))
						{
							$stats_by_name[$line[1]][$date]=array('opens'=>0,'starts'=>0,'stops'=>0,'adds'=>0,'removes'=>0);
						}
						
						if ($line[3]=='open')
						{
							$stats[$line[0]][$date]['opens']++;
							$stats_by_name[$line[1]][$date]['opens']++;
						}
						if ($line[3]=='start')
						{
							$stats[$line[0]][$date]['starts']++;
							$stats_by_name[$line[1]][$date]['starts']++;
						}
						if ($line[3]=='stop')
						{
							$stats[$line[0]][$date]['stops']++;
							$stats_by_name[$line[1]][$date]['stops']++;
						}
						if ($line[3]=='add')
						{
							$stats[$line[0]][$date]['adds']++;
							$stats_by_name[$line[1]][$date]['adds']++;
						}
						if ($line[3]=='remove')
						{
							$stats[$line[0]][$date]['removes']++;
							$stats_by_name[$line[1]][$date]['removes']++;
						}
					}
				}
				
				fclose($file_handler);
			}
			
			unlink($log_path);
		}
		
		$appStatsObjs=array();
		
		$appStatsOps=$OS->getAppStatsOps();
		
		foreach ($stats as $app_id=>$dates)
		{
			foreach ($dates as $date=>$details)
			{
				if ($oneAppStats=$appStatsOps->getAppStatsDate($app_id,$date))
				{
					foreach ($details as $type=>$value)
					{
						if ($value>0)
						{
							$oneAppStats->$type+=$value;
						}
					}
				}
				else
				{
					$details['app_id']=$app_id;
					$details['stats_d']=$date;
					
					$oneAppStats=new OS_AppStats();
					$oneAppStats->set($details);
					$oneAppStats->name=$app_id_to_name[$app_id];
				}
			}
		}
		
		$db->query("LOCK TABLES ".$db->dbPrefix()."apps_stats WRITE");
		foreach ($appStatsObjs as $oneAppStats)
		{
			$oneAppStats->save();
		}
		$db->query("UNLOCK TABLES");
		
		if ($OS->getSettingsVar('community_stats')=='Y')
		{
			$appstoreAPI=$OS->getAppStoreApi();
			
			$appstoreAPI->pushAppStats(array('stats'=>$stats_by_name));
		}
		
		return true;
	}
}
?>