<?php
class OS_CRON_autoupdate
{
	public function run()
	{
		$OS=getOS();
		$appOps=$OS->getAppOps();
		
		$autoupdateableApps=array();
		$apps=$appOps->getAvailableApps();
		foreach ($apps as $app)
		{
			if (isset($app->autoupdate))
			{
				if ($app->autoupdate=='Y')
				{
					$autoupdateableApps[$app->name]=$app->version;
				}
			}
		}
		
		if ($autoupdateableApps)
		{
			$appstore=$OS->getAppStoreApi();
			
			$appVersions=$appstore->getAppsVersions(array('apps'=>array_keys($autoupdateableApps)));
			
			if ($appstore->success)
			{
				$toUpdate=array();
				
				foreach ($appVersions as $app=>$version)
				{
					if (version_compare($autoupdateableApps[$app],$version)==-1)
					{
						$toUpdate[]=$app;
					}
				}
				
				if ($toUpdate)
				{
					$http=$OS->getHttp();
					$utils=$OS->getUtils();
					
					foreach ($toUpdate as $app)
					{
						$download_url=$appstore->getAppDownloadUrl(array('app_name'=>$app));
						
						if ($appstore->success)
						{
							if ($app_kit_contents=$http->get($download_url['download_url']))
							{
								$temp_kit_path=$utils->getTempFile('tar.gz');
								
								$utils->fileWrite($temp_kit_path,$app_kit_contents);
								
								$extract=$appOps->extractAppFromArchive($temp_kit_path,"{$app}.".$appVersions[$app].".tar.gz");
								
								if ($extract['status'])
								{
									$app_path=$appOps->getUninstalledAppPath($app);
									
									$appOps->installApp($app_path);
								}
							}
						}
					}
				}
			}
		}
		
		return true;
	}
}
?>