<?php
class OS_CRON_widget_stats
{
	public function run()
	{
		$OS=getOS();
		$db=$OS->getDb();
		
		$log_path=os_join_path($OS->getConfigVar('storage_path'),'widget_stats.log');
		
		$stats=array();
		$stats_by_name=array();
		$widget_id_to_name=array();
		
		if (file_exists($log_path))
		{
			rename($log_path,$log_path.'.old');
			$log_path.='.old';
			
			if ($file_handler=fopen($log_path,'r'))
			{
				while (!feof($file_handler))
				{
					if ($line=fgets($file_handler))
					{
						$line=explode('|',trim($line));
						
						$date=date('Y-m-d',$line[2]);
						
						if (!isset($widget_id_to_name[$line[0]]))
						{
							$widget_id_to_name[$line[0]]=$line[1];
						}
						
						if (!isset($stats[$line[0]][$date]))
						{
							$stats[$line[0]][$date]=array('opens'=>0,'adds'=>0,'removes'=>0);
						}
						if (!isset($stats_by_name[$line[1]][$date]))
						{
							$stats_by_name[$line[1]][$date]=array('opens'=>0,'adds'=>0,'removes'=>0);
						}
		
						if ($line[3]=='open')
						{
							$stats[$line[0]][$date]['opens']++;
							$stats_by_name[$line[1]][$date]['opens']++;
						}
						if ($line[3]=='add')
						{
							$stats[$line[0]][$date]['adds']++;
							$stats_by_name[$line[1]][$date]['adds']++;
						}
						if ($line[3]=='remove')
						{
							$stats[$line[0]][$date]['removes']++;
							$stats_by_name[$line[1]][$date]['removes']++;
						}
					}
				}
				
				fclose($file_handler);
			}
			
			unlink($log_path);
		}
		
		$widgetStatsObjs=array();
		
		$widgetStatsOps=$OS->getWidgetStatsOps();
		
		foreach ($stats as $widget_id=>$dates)
		{
			foreach ($dates as $date=>$details)
			{
				if ($oneWidgetStats=$widgetStatsOps->getWidgetStatsDate($widget_id,$date))
				{
					foreach ($details as $type=>$value)
					{
						if ($value>0)
						{
							$oneWidgetStats->$type+=$value;
						}
					}
				}
				else
				{
					$details['widget_id']=$widget_id;
					$details['stats_d']=$date;
					
					$oneWidgetStats=new OS_WidgetStats();
					$oneWidgetStats->set($details);
					$oneWidgetStats->name=$widget_id_to_name[$widget_id];
				}
			}
		}
		
		$db->query("LOCK TABLES ".$db->dbPrefix()."widgets_stats WRITE");
		foreach ($widgetStatsObjs as $oneWidgetStats)
		{
			$oneWidgetStats->save();
		}
		$db->query("UNLOCK TABLES");
		
		if ($OS->getSettingsVar('community_stats')=='Y')
		{
			$appstoreAPI=$OS->getAppStoreApi();
			$appstoreAPI->pushWidgetStats(array('stats'=>$stats_by_name));
		}
		
		return true;
	}
}
?>