<?php
include('../init.php');

$OS = getOS();

$osUser = $OS->getUser();
$osUser->forceUserLogin();
$osUser->forcePerm('core','is_developer');

if (!empty($_GET['app_id']))
{
	$app_id=$_GET['app_id'];
}
elseif (!empty($_POST['app_id']))
{
	$app_id=$_POST['app_id'];
}
else
{
	$OS->redirectTO('/developers/');
}

$appDevOps=$OS->getAppDeveloperOps();
$appOps=$OS->getAppOps();

if (!$app=$appDevOps->getAppByID($app_id))
{
	$OS->redirectTO('/developers/');
}

$app_path=$appDevOps->getAppDevPath($app);

$appDevOps->syncAppVersion($app);

if ($_SERVER['REQUEST_METHOD']=='POST')
{
	$checkResult=$appOps->installApp($app_path);
	
	$installOK=true;
	foreach($checkResult as $message)
	{
		if ($message['result']['type']=='error')
		{
			$installOK=false;
		}
	}
	
	if ($installOK)
	{
		$appDevOps->createAppBuild($app);
		
		$OS->redirectTO('/developer/?msg=install_ok');
	}
}
else
{
	$checkResult=$appOps->validateAppKit($app_path);
}

$has_errors=false;
$can_install=true;
if ($checkResult['result']!=true)
{
	$has_errors=true;
	
	foreach ($checkResult['tests'] as $test)
	{
		if ($test['result']['type']!='success')
		{
			if ($test['result']['type']=='error')
			{
				$can_install=false;
				break;
			}
		}
	}
}

$tpl = $OS->getTemplate();

$tpl->setTopSectionTitle("Install application");

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('ptitle',"Install Application");


$tpl->setVar('back_link',$OS->getConfigVar('root_url').'/developers/');

if ($has_errors)
{
	$tpl->setVar('recheck_link','?app_id='.$app->id);
}
else
{
	$tpl->setVar('recheck_link',false);
}

$tpl->setVar('canInstall',$can_install);

$checkResult=array(
	array(
		'title'=>"Install application",
		'tests'=>$checkResult['tests']
	)
);

$tpl->setVar('testDetails',$checkResult);
$tpl->setVar('app_id',$app->id);

$tpl->bodyTemplateName = "developers_apps_install";

echo $tpl->mainTemplateRender();
?>