<?php
include('../init.php');

$OS = getOS();

$osUser = $OS->getUser();
$osUser->forceUserLogin();
$osUser->forcePerm('core','is_developer');

$appDevOps=$OS->getAppDeveloperOps();

$apps=$appDevOps->getApps();

if (!empty($_GET['op']))
{
	if ($_GET['op']=='delete' AND isset($_GET['app_id']) AND isset($apps[$_GET['app_id']]))
	{
		if ($apps[$_GET['app_id']]->delete())
		{
			$OS->addInfo("Application successfully removed");
			
			unset($apps[$_GET['app_id']]);
		}
		else
		{
			$OS->addBoxError("Unable to remove application");
		}
	}
	elseif ($_GET['op']=='finish' AND isset($_GET['app_id']) AND isset($apps[$_GET['app_id']]) AND $apps[$_GET['app_id']]->status=='W')
	{
		if ($apps[$_GET['app_id']]->finish())
		{
			$OS->addInfo("Application marked as finished");
			$apps[$_GET['app_id']]->status='F';
		}
		else
		{
			$OS->addBoxError("Unable to mark application as finished");
		}
	}
	elseif ($_GET['op']=='work' AND isset($_GET['app_id']) AND isset($apps[$_GET['app_id']]) AND $apps[$_GET['app_id']]->status=='F')
	{
		if ($apps[$_GET['app_id']]->work())
		{
			$OS->addInfo("Application marked as work in progress");
			$apps[$_GET['app_id']]->status='W';
		}
		else
		{
			$OS->addBoxError("Unable to mark application as work in progress");
		}
	}
}

$devApps=array();
if (!empty($apps))
{
	foreach ($apps as $app_id=>$app)
	{
		$devApps[$app_id]=array(
			'name'=>$app->name,
			'title'=>$app->title,
			'description'=>$app->description,
			'status'=>$app->status
		);
		
		$devApps[$app_id]['details_link']=$OS->getConfigVar('root_url').'/developers/apps_details.php?app_id='.$app_id;
		$devApps[$app_id]['download_link']=$OS->getConfigVar('root_url').'/developers/apps_download.php?app_id='.$app_id;
		
		if ($app->status=='W')
		{
			$devApps[$app_id]['install_link']=$OS->getConfigVar('root_url').'/developers/apps_install.php?app_id='.$app_id;
			$devApps[$app_id]['finish_link']='?op=finish&app_id='.$app_id;
			$devApps[$app_id]['remove_link']='?op=delete&app_id='.$app_id;
		}
		elseif ($app->status=='F')
		{
			$devApps[$app_id]['work_link']='?op=work&app_id='.$app_id;
		}
	}
}

$tpl = $OS->getTemplate();

$tpl->setTopSectionTitle("Developer Applications");
$tpl->addTopSectionOption('create_app',array('type'=>'link','name'=>"New App",'url'=>$OS->getConfigVar('root_url')."/developers/apps_add.php"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('apps',$devApps);

$tpl->selectedMenuItem = "developers";

$tpl->bodyTemplateName = "developers_index";

echo $tpl->mainTemplateRender();
?>