<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include "../init.php";

@set_time_limit(0);

$OS = getOS();

$db = $OS->getDb();

$OSInstaller = getOSInstaller();

$OSInstaller->processSubmit();

$currentInstallStep = $OSInstaller->getCurrentInstallStep();

$maxInstallSteps = $OSInstaller->getMaxInstallSteps();

//check if templates compile dir is writable
$storage_path = os_join_path($OSInstaller->getInternalOption('os_root_path'), "storage");

$ersMessages = array();
if(@!is_dir($storage_path)) $ersMessages[] = array('message' => sprintf("Directory %s does not exists. It must be created", $storage_path)); 
elseif(@!is_writable($storage_path)) $ersMessages[] = array('message' => sprintf("No permission to write in directory `%s`.<br> This could be caused by file permissions and ownership.",$storage_path));
else
{
	$template_compile_path = os_join_path($OSInstaller->getInternalOption('os_root_path'), "storage", "templates_compiled");
	
	$osUtils = $OS->getUtils();
	$osUtils->createDir($template_compile_path, 0777);

	if(@!is_dir($template_compile_path)) $ersMessages[] = array('message' => sprintf("Directory %s does not exists. It must be created", $template_compile_path)); 
	elseif(@!is_writable($template_compile_path)) $ersMessages[] = array('message' => sprintf("No permission to write in directory `%s`.<br> This could be caused by file permissions and ownership.",$template_compile_path));
}


if(!empty($ersMessages))
{
	$templates_path = os_join_path($OSInstaller->getInternalOption('os_install_path'), "templates");
	
	if(is_dir($templates_path))
	{
		$os_root_url = $OSInstaller->getInternalOption('os_root_url');
		$before_install_tpl_path =  os_join_path($templates_path, "beforeinstall.php");
		if(file_exists($before_install_tpl_path)) {include($before_install_tpl_path);exit;}
	}
}


$osInstallerStep = $OSInstaller->getInstallStepDetails($currentInstallStep);

//gather data for current install step
$stepDetails  = $osInstallerStep->prepareStepDetails();

$root_url = $OSInstaller->getInternalOption('os_root_url');

//Set external messages
if(isset($_GET['msg']))
	if($_GET['msg'] == 'badauthcode') $OS->addBoxError("Invalid Auth Code");


//show install template
$tpl = $OS->getTemplate();

//render templates from install dir 
$tpl->setTemplateDir(os_join_path($OSInstaller->getInternalOption('os_install_path'), "templates"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$step=$OSInstaller->getCurrentInstallStep();

$tpl->setVar('currentInstallStep', $step);

$tpl->setVar('install_menu', $OSInstaller->getInternalOption('install_menu'));

//$stepDetails  = $oSInstallerStep->prepareStepDetails();

$tpl->setVar('installParams', $OSInstaller->getInstallParamsEncrypted());

$tpl->setVar('stepDetails', $stepDetails);

if(isset($stepDetails['tests']))
{
	$tpl->setVar('testDetails', $stepDetails['tests']);
}

$show_prev_btn = (isset($stepDetails['show_prev_btn'])? $stepDetails['show_prev_btn'] : ($currentInstallStep == "1"? false : true));

$show_retry_btn = (isset($stepDetails['show_retry_btn'])? $stepDetails['show_retry_btn'] : ($currentInstallStep == $maxInstallSteps? false : true));

$show_next_btn = (isset($stepDetails['show_next_btn']) ? $stepDetails['show_next_btn'] : ($currentInstallStep == $maxInstallSteps? false : true));

$install_success = (isset($stepDetails['install_success']) ? $stepDetails['install_success'] : false);


$tpl->setVar('show_prev_btn', $show_prev_btn);
$tpl->setVar('show_retry_btn', $show_retry_btn);
$tpl->setVar('show_next_btn', $show_next_btn);
$tpl->setVar('install_success', $install_success);

$tpl->setVar('root_url', $root_url);

//set current step template
$installStepContents = $osInstallerStep->render();
$tpl->setVar('installStepContents',$installStepContents);

//set base template
$bodyContents = $tpl->getInstallTemplate('base');

$tpl->setBodyContents($bodyContents);

echo $tpl->mainTemplateRender('main');
?>