<?php
class OS_APP_AdjacentKws extends OS_AppBase
{
	private static $_instance;
	
	protected function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
		$this->addMenuItem('analyze', array("name" => _("Analyze"), 'routerOption'=> "handleAnalyzeView"));
		
		$this->setRouterOption('report','handleReportView');
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_AdjacentKws();
		}
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('adjacentkws','view');
		
		$viewData=new OS_APPVIEW_AdjacentKws_Main();
		
		return $viewData->render();
	}
	
	public function handleAnalyzeView()
	{
		getOS()->getUser()->forcePerm('adjacentkws','view');
		
		$viewData=new OS_APPVIEW_AdjacentKws_Analyze();
		
		return $viewData->render();
	}
	
	public function handleReportView()
	{
		getOS()->getUser()->forcePerm('adjacentkws','view');
		
		$viewData=new OS_APPVIEW_AdjacentKws_Report();
		
		return $viewData->render();
	}
	
	public function eventSearchEngineQueried($params)
	{
		$result=false;
		
		$kwOps=OS_APP_AdjacentKws_ReportOperations::get_instance();
		$result=$kwOps->eventSearchEngineQueried($params);
		
		return $result;
	}
	
	public function eventProjectDeleted($params)
	{
		$ops=OS_APP_AdjacentKws_ReportOperations::get_instance();
		
		return $ops->deleteDataByProjectID($params['project_id']);
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'adjacentkws'=>array(
				'view'=>array('name'=>_("View and perform adjacent keywords reports")),
			)
		);
	}
}
?>