<?php
class OS_APPVIEW_AdjacentKws_Main extends OS_AppViewBase
{
	private $urlsPerPage;
	
	public function __construct()
	{
		parent::__construct();
		
		$this->urlsPerPage=10;
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_AdjacentKws_ReportOperations::get_instance();
		
		$requestParams=$appPlugin->getRequestParams();
		$processedRequest=array();
		
		$processedRequest['reportsCount']=$ops->getReportsCount();
		$processedRequest['page']=1;
		
		if (!empty($requestParams['page']) AND ($requestParams['page']>0) AND (($requestParams['page']-1)*$this->urlsPerPage<$processedRequest['reportsCount']))
		{
			$processedRequest['page']=$requestParams['page'];
		}
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='delete')
			{
				if (!empty($requestParams['report_id']))
				{
					if ($report=$ops->getReportByID($requestParams['report_id']))
					{
						if ($report->delete())
						{
							$requestParams['msg']='delete_ok';
						}
						else
						{
							$requestParams['msg']='delete_err';
						}
					}
				}
			}
			elseif ($requestParams['op']=='rerun')
			{
				if (!empty($requestParams['report_id']))
				{
					if ($report=$ops->getReportByID($requestParams['report_id']) AND $report->status!='W')
					{
						$report->status='W';
						$report->save();
						
						$forked=OS_FORK::fork('app','adjacentkws','generate_report',array('project_id'=>$report->project_id,'report_id'=>$report->id));
						
						if ($forked)
						{
							$requestParams['msg']='rerun_ok';
						}
						else
						{
							$requestParams['msg']='rerun_err';
						}
					}
				}
			}
		}
		
		if (!empty($requestParams['msg']))
		{
			if ($requestParams['msg']=='analyze_ok')
			{
				$OS->addInfo(_("Analysis started successfully. Please check back in a few minutes to view the report."));
			}
			elseif ($requestParams['msg']=='analyze_err')
			{
				$OS->addBoxError(_("Unable to start analysis. Try again later."));
			}
			elseif ($requestParams['msg']=='delete_ok')
			{
				$OS->addInfo(_("Report deleted successfully"));
			}
			elseif ($requestParams['msg']=='delete_err')
			{
				$OS->addBoxError(_("Unable to delete report"));
			}
			elseif ($requestParams['msg']=='running')
			{
				$OS->addBoxError(_("Analysis still undergoing. Please check back in a few minutes to view the report."));
			}
			elseif ($requestParams['msg']=='rerun_ok')
			{
				$OS->addInfo(_("Report regeneration started. Please check back in a few minutes to view the new data."));
			}
			elseif ($requestParams['msg']=='rerun_err')
			{
				$OS->addBoxError(_("Unable to start regeneration. Try again later."));
			}
		}
		
		return $processedRequest;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_AdjacentKws_ReportOperations::get_instance();
		
		$viewDataVars=array();

		if ($this->processedRequest['reportsCount'])
		{
			$viewDataVars['reportsCount']=$this->processedRequest['reportsCount'];
			
			$viewDataVars['reports']=$ops->getReports($project->id,($this->processedRequest['page']-1)*$this->urlsPerPage,$this->urlsPerPage);
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array();
		
		if (!empty($viewData['reports']))
		{
			foreach ($viewData['reports'] as $report_id=>$report)
			{
				$tplVars['reports'][$report_id]=$report->toTemplate();
			}
			
			if ($this->processedRequest['page']>1)
			{
				$tplVars['prev_page_url']=$appPlugin->getAppActionUrl('main',array('page'=>$this->processedRequest['page']-1));
			}
			else
			{
				$tplVars['prev_page_url']=false;
			}
			
			if (($this->processedRequest['page']*$this->urlsPerPage)<$viewData['reportsCount'])
			{
				$tplVars['next_page_url']=$appPlugin->getAppActionUrl('main',array('page'=>$this->processedRequest['page']+1));
			}
			else
			{
				$tplVars['next_page_url']=false;
			}
		}
		
		$tplVars['analyzeURL']=$appPlugin->getAppActionUrl('analyze');
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('main',$tplVars);
	}
}
?>