<?php
class OS_APPVIEW_AdjacentKws_Report extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['report_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$ops=OS_APP_AdjacentKws_ReportOperations::get_instance();
		
		$processedRequest=array();
		
		if (!$processedRequest['report']=$ops->getReportByID($requestParams['report_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if ($processedRequest['report']->status=='W')
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view',array('msg'=>'running')),true);
		}
		elseif ($processedRequest['report']->status=='F')
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view',array('msg'=>'failed')),true);
		}
		
		return $processedRequest;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$viewDataVars=array();
		
		$viewDataVars['report']=$this->processedRequest['report'];
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$utils=$OS->getUtils();
		
		$viewData=$this->buildViewData();
		
		$tplVars=array(
			'report_details'=>$viewData['report']->toTemplate(),
			'competitors'=>array(
			),
			'adjacent_keywords'=>$viewData['report']->result['adjacent_keywords']
		);
		
		$position=0;
		
		foreach ($viewData['report']->result['competitors'] as $competitor)
		{
			$position++;
			
			$tplVars['competitors'][$position]=array(
				'title'=>$competitor['title'],
				'url'=>$competitor['url'],
				'url_safe'=>$utils->getSafeURL($competitor['url'])
			);
		}

		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('report',$tplVars);
	}
}
?>