<?php
include "../../../../init.php";

class osAjaxAppLinks
{
	private $osProject;
	
	private $osUser;
	
	public function __construct() {}
	
	public function addLink($params)
	{
		if (!$this->isValidRequest()) return false;
		else
		{
			$OS = getOS();
			
			$user = $OS->getUser();
			
			if (!$user->checkPerm('backlinks','supervise') AND !$user->checkPerm('backlinks','view')) return false;
			else
			{
				$project = $OS->getProject();
				
				$links_app=$OS->getAppHandler('backlinks')->getAppPlugin();
				
				$link=$links_app->getLink();
				
				$int_source_pr=range(1,10);
				
				$labels=$links_app->getLabelOperations()->getLabels();
				
				$validator=$OS->getValidator();
				
				$ers=array();
				
				if ($labels)
				{
					if (empty($params['label'])) $ers['label']="Label missing";
					elseif (!isset($labels[$params['label']])) $ers['label']="Invalid label";
				}
				else
				{
					$params['label']=0;
				}
				
				if (empty($params['source_url'])) $ers['source_url']="URL missing";
				elseif (!$validator->is_url($params['source_url'])) $ers['source_url']="Invalid URL";
				
				if (empty($params['source_pr'])) $ers['source_pr']="PageRank missing";
				elseif (!in_array($params['source_pr'],$int_source_pr)) $ers['source_pr']="Invalid PageRank value";
				
				if (empty($params['target_url'])) $ers['target_url']="Target URL missing";
				elseif (!$validator->is_url($params['target_url'])) $ers['target_url']="Invalid target URL";
				
				if (empty($params['anchor'])) $ers['anchor']="Anchor missing";
				
				if (count($ers)==0)
				{
					$link->label_id=$params['label'];
					$link->source_url=$params['source_url'];
					$link->source_pr=$params['source_pr'];
					$link->target_url=$params['target_url'];
					$link->anchor=$params['anchor'];
					$link->source_host=$link->extractHost($params['source_url']);
					$link->target_host=$link->extractHost($params['target_url']);
					
					$link_exists=$link->exists();
					
					if (!$link_exists['href']) return array('actionStatus'=>false,'notification'=>array('type'=>'error','message'=>"Link not found"));
					elseif (!$link_exists['anchor']) return array('actionStatus'=>false,'notification'=>array('type'=>'error','message'=>"Link anchor is different"));
					else
					{
						if ($link->save())
						{
							$link->load();
							$link_arr=$link->toTemplate();
							return array('actionStatus'=>true,'actionData'=>$link_arr);
						}
						else return array('actionStatus'=>false,'notification'=>array('type'=>'error','message'=>"Unable to add link. Try again later"));
					}
				}
				else return array('actionStatus'=>false,'actionErrors'=>$ers);
			}
		}
	}

	public function isValidRequest()
	{
		$OS = getOS();
		
		$osUser = $OS->getUser();
		
		$osProject = $OS->getProject();
		
		$result = false;
		
		//check if user is logged
		//check if project is selected
		if($osUser->isUserLogged() && $osProject->selectedProject())
		{
			$this->osUser = $osUser;
			$this->osProject = $osProject;
			
			$result = true;
		}
		
	return $result;	
	}
}

$OS = getOS();
$osAjax = $OS->getAjax();
$osAjax->setClass("osAjaxAppLinks");
$osAjax->handle();
?>