<?php
class OS_APPCRON_backlinks_check_links
{
	public function run()
	{
		$OS=getOS();
		$db=$OS->getDb();
		
		$appOps=$OS->getAppOps();
		$app=$appOps->getAppByName('backlinks');
		
		$projectOps=$OS->getProjectOps();
		
		if ($projects=$appOps->getProjectsByAppID($app->id))
		{
			$appHandler=$OS->getAppHandler('backlinks');
			$appPlugin=$appHandler->getAppPlugin();
			$ops=$appPlugin->getOperations();
			
			foreach ($projects as $project_id)
			{
				if ($project=$projectOps->getProjectByID($project_id) AND $project->isActive())
				{
					if ($links_to_check=$ops->getLinksForChecking($project_id))
					{
						$OS->initTimezone($project->timezone);
						
						foreach ($links_to_check as $link)
						{
							$link_exists=$link->exists();
							
							$time = $db->DBTimeStamp(time());
							
							if (!$link_exists['href'])
							{
								$link->check_status='E';
								$link->check_ers++;
								$link->check_er_dt=$time;
							}
							elseif (!$link_exists['anchor'])
							{
								$link->check_status='W';
								$link->check_ers++;
								$link->check_er_dt=$time;
							}
							else
							{
								$link->check_status='S';
								$link->check_oks++;
								$link->check_ok_dt=$time;
							}
							
							$link->check_dt=$time;
							
							$link->markAsChecked();
						}
					}
				}
			}
		}
		
		return true;
	}
}
?>