<?php
class OS_APPFORK_Backlinks_Import_Links
{
	public function run($params)
	{
		$result=false;
		
		if (!empty($params[0]))
		{
			$project_id=$params[0];
			
			$OS=getOS();
			
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($project_id))
			{
				$appOps=$OS->getAppOps();
				$app=$appOps->getAppByName('backlinks');
				
				if ($appOps->isProjectApp($project_id,$app->id))
				{
					$OS->initTimezone($project->timezone);
					
					$appHandler=$OS->getAppHandler('backlinks');
					$appPlugin=$appHandler->getAppPlugin();
					$db=$OS->getDb();
					$osBacklinks=$OS->getBacklinks();
					
					if ($engines=$osBacklinks->getUsableEngines())
					{
						$osUtils=$OS->getUtils();
						$labelOps=OS_APP_Backlinks_LabelOperations::get_instance();
						$linkOps=OS_APP_Backlinks_LinkOperations::get_instance();
						
						$project_host=parse_url($project->url,PHP_URL_HOST);
						$url_to_engines=$osUtils->prependHTTP($project_host);
						
						foreach ($engines as $engine=>$engineDetails)
						{
							if ($engineBacklinks=$osBacklinks->getBacklinks($url_to_engines,$engine))
							{
								if (!$label=$labelOps->getLabelByName($engineDetails['engineDetails']['title'],$project_id))
								{
									$label=new OS_APP_Backlinks_Label();
									
									$label->project_id=$project_id;
									$label->name=$engineDetails['engineDetails']['title'];
									
									if ($label->save())
									{
										$label_id=$label->id;
									}
									else
									{
										$label_id=0;
									}
								}
								else
								{
									$label_id=$label->id;
								}
								
								foreach ($engineBacklinks as $link)
								{
									if (!$linkOps->getLinkByDetails($link['source'],$link['target'],$link['anchor'],$project_id))
									{
										$newLink=new OS_APP_Backlinks_Link();
										
										$newLink->project_id=$project_id;
										$newLink->user_id=0;
										$newLink->label_id=$label_id;
										
										$newLink->source_url=$link['source'];
										$newLink->source_pr=0;
										$newLink->target_url=$link['target'];
										$newLink->anchor=$link['anchor'];
										$newLink->source_host=parse_url($link['source'],PHP_URL_HOST);
										$newLink->target_host=(empty($link['target'])?$project_host:parse_url($link['target'],PHP_URL_HOST));
										
										$newLink->save();
									}
								}
							}
						}
					}
				}
			}
		}
	}
}
?>