<?php
class OS_APP_backlinks_label
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $name;
	public $insert_dt;
	public $insert_ip;
	public $insert_by;
	public $update_dt;
	public $update_ip;
	public $update_by;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_backlinks_label();
		}
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->name='';
		$this->insert_dt='';
		$this->insert_ip='';
		$this->insert_by=0;
		$this->update_dt='';
		$this->update_ip='';
		$this->update_by=0;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=getOS()->getAppHandler()->getAppPlugin()->getLabelOperations();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertLabel($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateLabel($this);
		}
		
		return $result;
	}
	
	public function set($label_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($label_data[$key]))
			{
				$this->$key = $label_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getLabelOperations();
			
			if ($label=$ops->getLabelByID($this->id))
			{
				$this->set(get_object_vars($label));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getLabelOperations();
		
			$result=$ops->deleteLabelByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		$result=false;
		
		if ($this->id)
		{
			$utils=getOS()->getUtils();
		
			$result=array(
				'id'=>$this->id,
				'name'=>$this->name,
				'insert_dt_human'=>$utils->humanizeDate($this->insert_dt),
				'update_dt_human'=>$utils->humanizeDate($this->update_dt),
			);
			
			$app=getOS()->getAppHandler()->getAppPlugin();
			
			$result['edit_link']=$app->getAppActionUrl('labelsmanage',array('op'=>'edit','label_id'=>$this->id));
			$result['delete_link']=$app->getAppActionUrl('labels',array('op'=>'delete','label_id'=>$this->id));
		}
		
		return $result;
	}
}
?>