<?php
class OS_APP_backlinks_labeloperations
{
	private static $_instance;
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_backlinks_labeloperations();
		}
		
		return self::$_instance;
	}
	
	public function getLabels()
	{
		$result=false;
		
		$OS=getOS();
		$project=$OS->getProject();
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."labels WHERE project_id=? ORDER BY name ASC",array($project->id));
		while ($row=$db->fetchRow($dbresult))
		{
			$label=new OS_APP_backlinks_label();
			
			$label->set($row);
			
			$result[$label->id]=$label;
		}
		
		return $result;
	}
	
	public function getLabelByID($label_id,$project_id=false)
	{
		$result=false;
		
		$OS=getOS();
		$project=$OS->getProject();
		
		if (!$project_id)
		{
			$project_id=$project->id;
		}
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."labels WHERE id=? AND project_id=?",array($label_id,$project->id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_Backlinks_Label();
			
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getLabelByName($label_name,$project_id=false)
	{
		$result=false;
		
		$OS=getOS();
		$project=$OS->getProject();
		
		if (!$project_id)
		{
			$project_id=$project->id;
		}
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."labels WHERE project_id=? AND name=?",array($project_id,$label_name));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_Backlinks_Label();
			
			$result->set($row);
		}
		
		return $result;
	}
	
	public function insertLabel($label)
	{
		$result=false;
		
		$OS=getOS();
		$user=$OS->getUser();
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		if (empty($label->project_id))
		{
			$label->project_id=$OS->getProject()->id;
		}
		
		$time=$db->DBTimeStamp(time());
		$ip=$OS->getRemoteAddr();
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."labels (project_id,name,insert_dt,insert_ip,insert_by) VALUES (?,?,?,?,?)";
		$dbresult=$db->query($query,array($label->project_id,$label->name,$time,$ip,(empty($user->id)?0:$user->id)));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateLabel($label)
	{
		$result=false;
		
		if ($current_label=$this->getLabelByID($label->id))
		{
			$OS=getOS();
			$project=$OS->getProject();
			$user=$OS->getUser();
			$db=$OS->getDb();
			$appHandler=getOS()->getAppHandler();
			
			$time=$db->DBTimeStamp(time());
			$ip=$OS->getRemoteAddr();
			
			$query="UPDATE ".$appHandler->dbPrefix()."labels SET name=?,update_dt=?,update_ip=?,update_by=? WHERE id=? AND project_id=?";
			$dbresult=$db->query($query,array($label->name,$time,$ip,$user->id,$label->id,$project->id));
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function deleteLabelByID($label_id)
	{
		$result=false;
		
		if ($current_label=$this->getLabelByID($label_id))
		{
			$OS=getOS();
			$project=$OS->getProject();
			$db=$OS->getDb();
			$appHandler=getOS()->getAppHandler();
			
			$query="DELETE FROM ".$appHandler->dbPrefix()."labels WHERE id=? AND project_id=?";
			$dbresult=$db->query($query,array($label_id,$project->id));
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
}
?>