<?php
class OS_APP_backlinks_linkoperations
{
	private static $_instance;
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_backlinks_linkoperations();
		}
		return self::$_instance;
	}
	
	public function getLinks()
	{
		$project=getOS()->getProject();
		$user=getOS()->getUser();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$links=array();
		$query="SELECT * FROM ".$appHandler->dbPrefix()."links WHERE project_id=? ORDER BY insert_dt DESC";
		$result=$db->query($query,array($project->id));
		while ($row=$db->fetchRow($result))
		{
			$link=new OS_APP_backlinks_link();
			
			$link->id=$row['id'];
			$link->project_id=$row['project_id'];
			$link->label_id=$row['label_id'];
			$link->user_id=$row['user_id'];
			$link->source_host=$row['source_host'];
			$link->source_url=$row['source_url'];
			$link->target_host=$row['target_host'];
			$link->target_url=$row['target_url'];
			$link->anchor=$row['anchor'];
			$link->source_pr=$row['source_pr'];
			$link->status=$row['status'];
			$link->check_status=$row['check_status'];
			$link->check_oks=$row['check_oks'];
			$link->check_ok_dt=$row['check_ok_dt'];
			$link->check_ers=$row['check_ers'];
			$link->check_er_dt=$row['check_er_dt'];
			$link->check_dt=$row['check_dt'];
			
			$links[$link->id]=$link;
		}
		
		return $links;
	}
	
	public function getLinksForChecking($project_id=false)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		if (!$project_id)
		{
			$project_id=$OS->getProject()->id;
		}
		
		$links=array();
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."links WHERE project_id=? AND status=? ORDER BY check_dt DESC LIMIT 20",array($project_id,'A'));
		while ($row=$db->fetchRow($dbresult))
		{
			$link=new OS_APP_backlinks_link();
			
			$link->id=$row['id'];
			$link->project_id=$row['project_id'];
			$link->label_id=$row['label_id'];
			$link->user_id=$row['user_id'];
			$link->source_host=$row['source_host'];
			$link->source_url=$row['source_url'];
			$link->target_host=$row['target_host'];
			$link->target_url=$row['target_url'];
			$link->anchor=$row['anchor'];
			$link->source_pr=$row['source_pr'];
			$link->status=$row['status'];
			$link->check_status=$row['check_status'];
			$link->check_oks=$row['check_oks'];
			$link->check_ok_dt=$row['check_ok_dt'];
			$link->check_ers=$row['check_ers'];
			$link->check_er_dt=$row['check_er_dt'];
			$link->check_dt=$row['check_dt'];
			
			$result[$link->id]=$link;
		}
		
		return $result;
	}
	
	public function getLinksByUserID()
	{
		$project=getOS()->getProject();
		$user=getOS()->getUser();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$links=array();
		$query="SELECT * FROM ".$appHandler->dbPrefix()."links WHERE project_id=? AND user_id=? ORDER BY insert_dt DESC";
		$result=$db->query($query,array($project->id,$user->id));
		while ($row=$db->fetchRow($result))
		{
			$link=new OS_APP_backlinks_link();
			
			$link->id=$row['id'];
			$link->project_id=$row['project_id'];
			$link->label_id=$row['label_id'];
			$link->user_id=$row['user_id'];
			$link->source_host=$row['source_host'];
			$link->source_url=$row['source_url'];
			$link->target_host=$row['target_host'];
			$link->target_url=$row['target_url'];
			$link->anchor=$row['anchor'];
			$link->source_pr=$row['source_pr'];
			$link->status=$row['status'];
			$link->check_status=$row['check_status'];
			$link->check_oks=$row['check_oks'];
			$link->check_ok_dt=$row['check_ok_dt'];
			$link->check_ers=$row['check_ers'];
			$link->check_er_dt=$row['check_er_dt'];
			$link->check_dt=$row['check_dt'];
			
			$links[$link->id]=$link;
		}
		
		return $links;
	}
	
	public function getLinkByID($link_id)
	{
		$project=getOS()->getProject();
		$user=getOS()->getUser();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."links WHERE id=?".($user->checkPerm('backlinks','supervise')?'':" AND user_id=?")." AND project_id=?";
		$result=$db->query($query,($user->checkPerm('backlinks','supervise')?array($link_id,$project->id):array($link_id,$user->id,$project->id)));
		if (!$row=$db->fetchRow($result)) return false;
		
		$link=new OS_APP_backlinks_link();
		
		$link->id=$row['id'];
		$link->user_id=$row['user_id'];
		$link->project_id=$row['project_id'];
		$link->label_id=$row['label_id'];
		$link->source_host=$row['source_host'];
		$link->source_url=$row['source_url'];
		$link->target_host=$row['target_host'];
		$link->target_url=$row['target_url'];
		$link->anchor=$row['anchor'];
		$link->source_pr=$row['source_pr'];
		$link->status=$row['status'];
		$link->check_status=$row['check_status'];
		$link->check_oks=$row['check_oks'];
		$link->check_ok_dt=$row['check_ok_dt'];
		$link->check_ers=$row['check_ers'];
		$link->check_er_dt=$row['check_er_dt'];
		$link->check_dt=$row['check_dt'];
		
		return $link;
	}
	
	public function getLinkByDetails($source_url,$target_url,$anchor,$project_id=false)
	{
		$result=false;
		
		$OS=getOS();
		$project=$OS->getProject();
		
		if (!$project_id)
		{
			$project_id=$project->id;
		}
		
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."links WHERE project_id=? AND source_url=? AND target_url=? AND anchor=?";
		$dbresult=$db->query($query,array($project_id,$source_url,$target_url,$anchor));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_Backlinks_Link();
			
			$link->id=$row['id'];
			$link->user_id=$row['user_id'];
			$link->project_id=$row['project_id'];
			$link->label_id=$row['label_id'];
			$link->source_host=$row['source_host'];
			$link->source_url=$row['source_url'];
			$link->target_host=$row['target_host'];
			$link->target_url=$row['target_url'];
			$link->anchor=$row['anchor'];
			$link->source_pr=$row['source_pr'];
			$link->status=$row['status'];
			$link->check_status=$row['check_status'];
			$link->check_oks=$row['check_oks'];
			$link->check_ok_dt=$row['check_ok_dt'];
			$link->check_ers=$row['check_ers'];
			$link->check_er_dt=$row['check_er_dt'];
			$link->check_dt=$row['check_dt'];
		}
		
		return $result;
	}
	
	public function insertLink($link)
	{
		$user=getOS()->getUser();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		if (empty($link->project_id))
		{
			$link->project_id=getOS()->getProject()->id;
		}
		
		$time=$db->DBTimeStamp(time());
		$ip=getOS()->getRemoteAddr();
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."links (project_id,label_id,user_id,source_host,source_url,source_pr,target_host,target_url,anchor,insert_dt,insert_ip,status,status_dt,status_ip,check_status,check_oks,check_ok_dt) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		$result=$db->query($query,array($link->project_id,$link->label_id,(empty($user->id)?0:$user->id),$link->source_host,$link->source_url,$link->source_pr,$link->target_host,$link->target_url,$link->anchor,$time,$ip,'W',$time,$ip,'S','1',$time));
		
		if ($result===false) return false;
		
		return $db->getInsertId();
	}
	
	public function updateLink($link)
	{
		$project=getOS()->getProject();
		$user=getOS()->getUser();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."links WHERE id=? AND user_id=? AND project_id=? AND status=?";
		$result=$db->query($query,array($link->id,$user->id,$project->id,'W'));
		if (!$link_row=$db->fetchRow($result)) return false;
		
		$time = $db->DBTimeStamp(time());
		$query="UPDATE ".$appHandler->dbPrefix()."links SET label_id=?,source_host=?,source_url=?,source_pr=?,target_host=?,target_url=?,anchor=?,updates=updates+1,update_dt=?,update_ip=? WHERE id=?";
		$result=$db->query($query,array($link->label_id,$link->source_host,$link->source_url,$link->source_pr,$link->target_host,$link->target_url,$link->anchor,$time,$_SERVER['REMOTE_ADDR'],$link->id));
		
		if ($result!==false) return true;
		
		return false;
	}
	
	public function deleteLinkByID($link_id)
	{
		$project=getOS()->getProject();
		$user=getOS()->getUser();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."links WHERE id=? AND user_id=? AND project_id=?";
		$result=$db->query($query,array($link_id,$user->id,$project->id));
		
		if ($result===false) return false;
		
		return true;
	}
	
	public function deleteDataByProjectID($project_id)
	{
		$result=true;
		
		$tables=array('labels','links');
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		foreach ($tables as $table)
		{
			$dbresult=$db->query("DELETE FROM ".$appHandler->dbPrefix().$table." WHERE project_id=?",array($project_id));
			
			if ($dbresult===false)
			{
				$result=false;
				break;
			}
		}
		
		return $result;
	}
	
	public function approveLinkByID($link_id)
	{
		$project=getOS()->getProject();
		$user=getOS()->getUser();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		
		$query="UPDATE ".$appHandler->dbPrefix()."links SET status=?,status_dt=?,status_ip=?,status_by=? WHERE id=? AND project_id=?";
		$result=$db->query($query,array('A',$time,$_SERVER['REMOTE_ADDR'],$user->id,$link_id,$project->id));
		
		if ($result===false) return false;
		
		return true;
	}
	
	public function rejectLinkByID($link_id)
	{
		$project=getOS()->getProject();
		$user=getOS()->getUser();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		
		$query="UPDATE ".$appHandler->dbPrefix()."links SET status=?,status_dt=?,status_ip=?,status_by=? WHERE id=? AND project_id=?";
		$result=$db->query($query,array('R',$time,$_SERVER['REMOTE_ADDR'],$user->id,$link_id,$project->id));
		
		if ($result===false) return false;
		
		return true;
	}
	
	public function markLinkAsChecked($link)
	{
		
	}
	
	public function getUserLinksNumberByStatus()
	{
		$result=array('W'=>0,'A'=>0,'R'=>0);
		
		$project=getOS()->getProject();
		$user=getOS()->getUser();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT COUNT(id) AS total_links,status FROM ".$appHandler->dbPrefix()."links WHERE project_id=? AND user_id=? GROUP BY status";
		$dbresult=$db->query($query,array($project->id,$user->id));
		
		if ($row=$db->fetchRow($dbresult))
		{
			$result[$row['status']]=$row['total_links'];
		}
		
		return $result;
	}
	
	public function getLinksNumberByStatus()
	{
		$result=array('W'=>0,'A'=>0,'R'=>0);
		
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT COUNT(id) AS total_links,status FROM ".$appHandler->dbPrefix()."links WHERE project_id=? GROUP BY status";
		$dbresult=$db->query($query,array($project->id));
		
		if ($row=$db->fetchRow($dbresult))
		{
			$result[$row['status']]=$row['total_links'];
		}
		
		return $result;
	}
	
	public function getLinksNumber()
	{
		$result=false;
		
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT COUNT(id) AS total_links FROM ".$appHandler->dbPrefix()."links WHERE project_id=?";
		$dbresult=$db->query($query,array($project->id));
		
		if ($row=$db->fetchRow($dbresult))
		{
			$result=$row['total_links'];
		}
		
		return $result;
	}
	
	public function getWaitingLinksNumber()
	{
		$result=false;
		
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT COUNT(id) AS waiting_links FROM ".$appHandler->dbPrefix()."links WHERE project_id=? AND status=?";
		$dbresult=$db->query($query,array($project->id,'W'));
		
		if ($row=$db->fetchRow($dbresult))
		{
			$result=$row['waiting_links'];
		}
		
		return $result;
	}
	
	public function getUsersWithAccessNumber()
	{
		$result=0;
		
		$project=getOS()->getProject();
		$departmentOps=getOS()->getDepartmentOps();
		
		$user_ids=array();
		$departments=$departmentOps->getDepartmentsByProjectID($project->id);
		
		foreach ($departments as $department_id)
		{
			$dep_users=$departmentOps->getUsersByDepartmentID($department_id);
			
			foreach ($dep_users as $user_id)
			{
				$user_ids[$user_id]=true;
			}
		}
		
		foreach ($user_ids as $user_id=>$dummy)
		{
			$oneUser=new OS_User();
			
			$oneUser->id=$user_id;
			
			if ($oneUser->load())
			{
				$oneUser->loadPerms();
				
				if ($oneUser->checkPerm('backlinks','view',$project->id))
				{
					$result++;
				}
			}
		}
		
		return $result;
	}
}
?>