<?php
class OS_APPVIEW_Backlinks_Labels extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_Backlinks_LabelOperations::get_instance();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='delete')
			{
				if (!empty($requestParams['label_id']))
				{
					if ($label=$ops->getLabelByID($requestParams['label_id']))
					{
						if ($label->delete())
						{
							$requestParams['msg']='delete_ok';
						}
						else
						{
							$requestParams['msg']='delete_err';
						}
					}
				}
			}
		}
		
		if (!empty($requestParams['msg']))
		{
			switch ($requestParams['msg'])
			{
				case 'delete_ok':
				{
					$OS->addInfo(_("Label deleted successfully"));
					break;
				}
				
				case 'delete_err':
				{
					$OS->addBoxError(_("Unable to delete label"));
					break;
				}
				
				case 'add_ok':
				{
					$OS->addInfo(_("Label added successfully"));
					break;
				}
				
				case 'add_err':
				{
					$OS->addBoxError(_("Unable to add label"));
					break;
				}
				
				case 'edit_ok':
				{
					$OS->addInfo(_("Label edited successfully"));
					break;
				}
				
				case 'edit_err':
				{
					$OS->addBoxError(_("Unable to edit label"));
					break;
				}
			}
		}
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$ops=OS_APP_Backlinks_LabelOperations::get_instance();
		
		$viewDataVars['labels']=$ops->getLabels();
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=array();
		
		$viewData=$this->buildViewData();
		
		$tplVars['labels']=array();
		if ($viewData['labels'])
		{
			foreach ($viewData['labels'] as $label_id=>$label)
			{
				$tplVars['labels'][$label_id]=$label->toTemplate();
			}
		}
		
		$tplVars['add_link']=$appPlugin->getAppActionUrl('labelsmanage');
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('labels',$tplVars);
	}
}
?>