<?php
class OS_APPVIEW_Backlinks_LabelsManage extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_Backlinks_LabelOperations::get_instance();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['op']))
		{
			$requestParams['op']='add';
		}
		
		if ($requestParams['op']=='edit')
		{
			if (empty($requestParams['label_id']))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
			
			if (!$label=$ops->getLabelByID($requestParams['label_id']))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
		}
		else
		{
			$requestParams['label_id']=false;
			$label=OS_APP_Backlinks_Label::get_instance();
		}
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			if (empty($requestParams['name_box']))
			{
				$OS->addFieldError(_("Name missing"),'name');
			}
			else
			{
				$requestParams['name_box']=trim($requestParams['name_box']);
				
				if (strlen($requestParams['name_box'])<3)
				{
					$OS->addFieldError(_("Name too short. Minimum length: 3 chars"),'name');
				}
			}
			
			if (!isset($OS->errorMessages))
			{
				$label->name=$requestParams['name_box'];
				
				if ($label->save())
				{
					$msg_type='ok';
				}
				else
				{
					$msg_type='err';
				}
				
				$OS->redirectTO($appPlugin->getAppActionUrl('labels',array('msg'=>$requestParams['op'].'_'.$msg_type)),true);
			}
		}
		elseif ($requestParams['op']=='edit')
		{
			$requestParams['name_box']=$label->name;
		}
		else
		{
			$requestParams['name_box']='';
		}
		
		return $requestParams;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$tplVars['appURL']=$appPlugin->getAppUrl();
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('labels_add_edit',$tplVars);
	}
}
?>