<?php
class OS_APPVIEW_Backlinks_LinkBuilding extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		$ops=OS_APP_Backlinks_LinkOperations::get_instance();
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='delete')
			{
				if (!empty($requestParams['link_id']))
				{
					if ($link=$ops->getLinkByID($requestParams['link_id']))
					{
						if ($link->delete())
						{
							$requestParams['msg']='delete_ok';
						}
						else
						{
							$requestParams['msg']='delete_err';
						}
					}
				}
			}
		}
		
		if (!empty($requestParams['msg']))
		{
			switch ($requestParams['msg'])
			{
				case 'approve_ok':
				{
					$OS->addInfo(_("Link approve successfully"));
					break;
				}
				
				case 'approve_err':
				{
					$OS->addBoxError(_("Unable to approve link"));
					break;
				}
				
				case 'reject_ok':
				{
					$OS->addInfo(_("Link rejected successfully"));
					break;
				}
				
				case 'reject_err':
				{
					$OS->addBoxError(_("Unable to reject link"));
					break;
				}
				
				case 'delete_ok':
				{
					$OS->addInfo(_("Link deleted successfully"));
					break;
				}
				
				case 'delete_err':
				{
					$OS->addBoxError(_("Unable to delete link"));
					break;
				}
				
				case 'add_ok':
				{
					$OS->addInfo(_("Link added successfully"));
					break;
				}
				
				case 'edit_ok':
				{
					$OS->addInfo(_("Link edited successfully"));
					break;
				}
			}
		}
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$ops=OS_APP_Backlinks_LinkOperations::get_instance();
		$labelOps=OS_APP_Backlinks_LabelOperations::get_instance();
		
		$viewDataVars=array(
			'links'=>$ops->getLinksByUserID(),
			'linksCounts'=>$ops->getUserLinksNumberByStatus(),
			'labels'=>$labelOps->getLabels()
		);
		
		$viewDataVars['linksCounts']['total']=array_sum($viewDataVars['linksCounts']);
		$viewDataVars['linksCounts']['checked']=$viewDataVars['linksCounts']['A']+$viewDataVars['linksCounts']['R'];
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=array();
		$tplVars['add_link']=$appPlugin->getAppActionUrl('linksmanage');
		
		$headContents=array(
			'css'=>array('backlinks'=>$appPlugin->getAppHomeUrl()."/resources/style.css")
		);
		
		$viewData=$this->buildViewData();
		
		$tplVars['linksCounts']=$viewData['linksCounts'];
		$tplVars['qualityScore']=($viewData['linksCounts']['checked']==0?0:round($viewData['linksCounts']['A']*10/$viewData['linksCounts']['checked']));		

		$links_processed=array();
		foreach ($viewData['links'] as $link)
		{
			$links_processed[$link->id]=$link->toTemplate();
		}
		
		$tplVars['labels']=array();
		if ($viewData['labels'])
		{
			foreach ($viewData['labels'] as $label)
			{
				$tplVars['labels'][$label->id]=$label->name;
			}
		}
		
		$tplVars['links']=$links_processed;
		
		$tpl=$OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('link_building',$tplVars);
	}
}
?>