<?php
class OS_APPVIEW_Backlinks_LinksManage extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_Backlinks_LinkOperations::get_instance();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['op']))
		{
			$requestParams['op']='add';
		}
		
		if ($requestParams['op']=='edit')
		{
			if (empty($requestParams['link_id']))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
			
			if (!$link=$ops->getLinkByID($requestParams['link_id']))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
		}
		else
		{
			$requestParams['link_id']=false;
			$link=OS_APP_Backlinks_Link::get_instance();
		}
		
		$int_source_pr=range(1,10);
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			$validator=$OS->getValidator();
			
			if (empty($requestParams['source_url_box']))
			{
				$OS->addFieldError(_("URL missing"),'source_url');
			}
			elseif (!$validator->is_url($requestParams['source_url_box']))
			{
				$OS->addFieldError(_("Invalid URL"),'source_url');
			}
			
			if (empty($requestParams['source_pr_box']))
			{
				$OS->addFieldError(_("PageRank missing"),'source_pr');
			}
			elseif (!in_array($requestParams['source_pr_box'],$int_source_pr))
			{
				$OS->addFieldError(_("Invalid PageRank value"),'source_pr');
			}
			
			if (empty($requestParams['target_url_box']))
			{
				$OS->addFieldError(_("Target URL missing"),'target_url');
			}
			elseif (!$validator->is_url($requestParams['target_url_box']))
			{
				$OS->addFieldError(_("Invalid target URL"),'target_url');
			}
			
			if (empty($requestParams['anchor_box']))
			{
				$OS->addFieldError(_("Anchor missing"),'anchor');
			}
			
			if (!isset($OS->errorMessages))
			{
				$link->source_url=$requestParams['source_url_box'];
				$link->source_pr=$requestParams['source_pr_box'];
				$link->target_url=$requestParams['target_url_box'];
				$link->anchor=$requestParams['anchor_box'];
				$link->source_host=$link->extractHost($requestParams['source_url_box']);
				$link->target_host=$link->extractHost($requestParams['target_url_box']);
				
				$link_exists=$link->exists();
				
				if (!$link_exists['href']) $OS->addFieldError(_("Link not found"),'source_url');
				elseif (!$link_exists['anchor']) $OS->addFieldError(_("Link anchor is different"),'source_url');
				else
				{
					$link->save();
					
					$OS->redirectTO($appPlugin->getAppActionUrl('linkbuilding',array('msg'=>$requestParams['op'].'_ok')),true);
				}
			}
		}
		elseif ($requestParams['op']=='edit')
		{
			$requestParams['source_url_box']=$link->source_url;
			$requestParams['source_pr_box']=$link->source_pr;
			$requestParams['target_url_box']=$link->target_url;
			$requestParams['anchor_box']=$link->anchor;
		}
		else
		{
			$requestParams['source_url_box']='';
			$requestParams['source_pr_box']='';
			$requestParams['target_url_box']='';
			$requestParams['anchor_box']='';
		}
		
		return $requestParams;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$tplVars['int_source_pr']=range(1,10);
		$tplVars['appURL']=$appPlugin->getAppUrl();
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('add_edit',$tplVars);
	}
}
?>