<?php
class OS_APPVIEW_Backlinks_Supervisor extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$user=$OS->getUser();
		$ops=OS_APP_Backlinks_LinkOperations::get_instance();
		
		$viewDataVars=array(
			'users'=>$ops->getUsersWithAccessNumber(),
			'links_total'=>$ops->getLinksNumber(),
			'links_waiting'=>$ops->getWaitingLinksNumber()
		);
		
		$viewDataVars['add_user_link']=($user->checkPerm('users_management','add_user')?$OS->getConfigVar('root_url').'/users/user_manage.php':false);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		
		$tplVars=array(
			'view_link'=>$appPlugin->getAppActionUrl('link_building'),
			'users'=>$viewData['users'],
			'add_user_link'=>$viewData['add_user_link'],
			'links_total'=>$viewData['links_total'],
			'links_waiting'=>$viewData['links_waiting'],
			'labels_link'=>$appPlugin->getAppActionUrl('labels'),
		);
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('supervise',$tplVars);
	}
}
?>