<?php
class OS_APP_compindexedurls extends OS_AppBase
{
	private static $_instance;
	
	protected function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
		
		$this->setRouterOption('competitor',"handleCompetitorView");
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_compindexedurls();
		}
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('compindexedurls','view');
		
		$viewData=new OS_APPVIEW_CompIndexedUrls_Main();
		
		return $viewData->render();
	}
	
	public function handleCompetitorView()
	{
		getOS()->getUser()->forcePerm('compindexedurls','view');
		
		$viewData=new OS_APPVIEW_CompIndexedUrls_Competitor();
		
		return $viewData->render();
	}
	
	public function eventProjectDeleted($params)
	{
		$ops=OS_APP_CompIndexedUrls_DayOperations::get_instance();
		
		return $ops->deleteDataByProjectID($params['project_id']);
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'compindexedurls'=>array(
				'view'=>array('name'=>_("View competition indexed URLs by day")),
			)
		);
	}
	
	public function &getDay()
	{
		return OS_APP_compindexedurls_day::get_instance();
	}
	
	public function &getOperations()
	{
		return OS_APP_compindexedurls_dayoperations::get_instance();
	}
}
?>