<?php
class OS_APPVIEW_CompIndexedUrls_Competitor extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$competitorOps=$OS->getCompetitorOps();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if ($viewDataVars['competitor']=$competitorOps->getCompetitorByID($requestParams['competitor_id']))
		{
			$ops=OS_APP_CompIndexedUrls_DayOperations::get_instance();
			
			$viewDataVars['days']=$ops->getDaysByCompetitorID($requestParams['competitor_id']);
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['competitor_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$viewData=$this->buildViewData();
		
		if (!$viewData['competitor'])
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$tplVars=array();
		$headContents=array();
		
		$tplVars['days']=array();
		$days_chart=array();
		foreach ($viewData['days'] as $day)
		{
			$tplVars['days'][$day->id]=$day->toTemplate();
			$days_chart[strtotime($day->date)]=$day->urls;
		}
		$days_chart=array_reverse(array_slice($days_chart,0,10,true),true);
		
		if (!empty($days_chart))
		{
			$chartValues=array();$chartTooltips=array();$chartLabels=array();
			foreach ($days_chart as $ts=>$urls)
			{
				$chartValues[]=$urls;
				$chartLabels[]=date('d M',$ts);
				$chartTooltips[]="{$urls} "._("indexed URLs");
			}
			
			$charts = $OS->getCharts();
			
			$chartOptions=array(
				'values'=>$chartValues,
				'labels'=>$chartLabels,
				'tooltips'=>$chartTooltips,
				'fill'=>true,
				'normalize'=>true
			);
			
			$chartData = $charts->getLineChart($chartOptions);

			$tplVars['competitor_name']=$viewData['competitor']->name;
			$tplVars['chart']=$chartData['html'];
			$headContents=$chartData['js'];
		}
		
		$tplVars['back_link']=$appPlugin->getAppActionUrl('view');
		
		$tpl=$OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('view_indexed',$tplVars);
	}
}
?>