<?php
class OS_APPCRON_ContentStrategy_Get_Performance
{
	public $contentsPerRun=20;
	
	public function run()
	{
		$OS=getOS();
		$db=$OS->getDb();
		
		$appOps=$OS->getAppOps();
		$app=$appOps->getAppByName('contentstrategy');
		
		$projectOps=$OS->getProjectOps();
		
		if ($projects=$appOps->getProjectsByAppID($app->id))
		{
			$appHandler=$OS->getAppHandler('contentstrategy');
			$appPlugin=$appHandler->getAppPlugin();
			$contentOps=OS_APP_ContentStrategy_ContentOperations::get_instance();
			
			$osSocialSignals=$OS->getSocialSignals();
			$osSocialSignals->setSocialNetwork('sharedcount');
			
			$osBacklinks=$OS->getBacklinks();
			
			$checkedContents=0;
			$affectedProjects=array();
			
			foreach ($projects as $project_id)
			{
				if ($project=$projectOps->getProjectByID($project_id) AND $project->isActive())
				{
					$OS->initTimezone($project->timezone);
					
					if ($contents=$contentOps->getPublishedContent($project->id))
					{
						foreach ($contents as $content_id=>$content)
						{
							if ($signals=$osSocialSignals->getSignals($content->url))
							{
								$signals['facebook']=$signals['facebook']['total'];
								$signals_total=array_sum($signals);
							}
							else
							{
								$signals_total=0;
							}
							
							if ($url_metrics=$osBacklinks->getUrlsMetrics($content->url))
							{
								$lrds=$url_metrics['rootdomains'];
							}
							else
							{
								$lrds=0;
							}
							
							$stats=array(
								'social'=>$signals_total,
								'lrds'=>$lrds
							);
							
							$content->stats=$stats;
							$content->goal_completion=$contentOps->computeContentGoalCompletion($content);
							
							if ($content->save())
							{
								$contentOps->logContentStats($content);
							}
						}
					}
				}
			}
		}
	}
}
?>