<?php
class OS_APP_ContentStrategy_FunnelStage
{
	public static $_instance;
	
	public $id;
	public $project_id;
	public $name;
	public $description;
	public $position;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_ContentStrategy_FunnelStage();
		}
			
		return	self::$_instance;
	}
	
		public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->name='';
		$this->description='';
		$this->position=0;
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_ContentStrategy_FunnelStageOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertFunnelStage($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateFunnelStage($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_ContentStrategy_FunnelStageOperations::get_instance();
			
			if ($data=$ops->getFunnelStageByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_ContentStrategy_FunnelStageOperations::get_instance();
			
			$result=$ops->deleteFunnelStageByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$result=array(
			'id'=>$this->id,
			'name'=>$this->name,
			'description'=>$this->description,
			'_editURL'=>$app->getAppActionUrl('audience_funnelstage_ae',array('op'=>'edit','funnelstage_id'=>$this->id)),
			'_deleteURL'=>$app->getAppActionUrl('audience',array('op'=>'delete_funnelstage','funnelstage_id'=>$this->id))
		);
		
		return $result;
	}
}
?>