<?php
class OS_APP_ContentStrategy_FunnelStageOperations
{
	public static $_instance;
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_ContentStrategy_FunnelStageOperations();
		}
			
		return	self::$_instance;
	}
	
	public function getFunnelStages($project_id=false)
	{
		$result=false;
		
		$OS=getOS();
		
		if (!$project_id)
		{
			$osProject=$OS->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."funnel_stages WHERE project_id=? ORDER BY `position` ASC",array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$onePersona=new OS_APP_ContentStrategy_FunnelStage();
			$onePersona->set($row);
			
			$result[$row['id']]=$onePersona;
		}
		
		return $result;
	}
	
	public function getFunnelStageByID($funnelstage_id)
	{
		$result=false;
		
		$OS=getOS();
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."funnel_stages WHERE id=?",array($funnelstage_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_ContentStrategy_FunnelStage();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function insertFunnelStage($funnelstage)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."funnel_stages (project_id,name,description,position) VALUES (?,?,?,?)";
		$dbresult=$db->query($query,array($funnelstage->project_id,$funnelstage->name,$funnelstage->description,$funnelstage->position));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateFunnelStage($funnelstage)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="UPDATE ".$appHandler->dbPrefix()."funnel_stages SET name=?,description=?,position=? WHERE id=?";
		$dbresult=$db->query($query,array($funnelstage->name,$funnelstage->description,$funnelstage->position,$funnelstage->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteFunnelStageByID($funnelstage_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."funnel_stages WHERE id=?";
		$dbresult=$db->query($query,array($funnelstage_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
		
	public function deleteFunnelStagesByProjectID($project_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."funnel_stages WHERE project_id=?";
		$dbresult=$db->query($query,array($project_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function createDefaultFunnelStages($project_id)
	{
		$default_stages=array(
			1=>array(
				'name'=>_("Awareness"),
				'description'=>_("Person doesn't know or is not aware of the product/service yet"),
			),
			2=>array(
				'name'=>_("Research"),
				'description'=>_("Person is looking for information about the product/service, but hasn't chosen a brand yet"),
			),
			3=>array(
				'name'=>_("Lead"),
				'description'=>_("Person is in the last stage of deciding and is looking to make a purchase"),
			)
		);
		
		foreach ($default_stages as $position=>$details)
		{
			$oneStage=new OS_APP_ContentStrategy_FunnelStage();
			
			$oneStage->project_id=$project_id;
			$oneStage->name=$details['name'];
			$oneStage->description=$details['description'];
			$oneStage->position=$position;
			
			$oneStage->save();
		}
	}	
}
?>