<?php
class OS_APP_ContentStrategy_Persona
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $name;
	public $age_min;
	public $age_max;
	public $gender;
	public $location;
	public $device;
	public $information;
	public $keywords;
	public $outcome;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_ContentStrategy_Persona();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->name='';
		$this->age_min=0;
		$this->age_max=0;
		$this->gender='';
		$this->location='';
		$this->device='';
		$this->information='';
		$this->keywords='';
		$this->outcome='';
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_ContentStrategy_PersonaOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertPersona($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updatePersona($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_ContentStrategy_PersonaOperations::get_instance();
			
			if ($data=$ops->getPersonaByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_ContentStrategy_PersonaOperations::get_instance();
			
			$result=$ops->deletePersonaByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		$personaOps=OS_APP_ContentStrategy_PersonaOperations::get_instance();
		
		$genders=$personaOps->getPersonaGenders();
		
		$result=array(
			'id'=>$this->id,
			'name'=>$this->name,
			'age_min'=>$this->age_min,
			'age_max'=>$this->age_max,
			'age_range'=>$this->age_min.' - '.$this->age_max,
			'gender'=>$genders[$this->gender],
			'location'=>$this->location,
			'device'=>$this->device,
			'information'=>$this->information,
			'keywords'=>implode('<br>',$this->keywords),
			'outcome'=>$this->outcome,
			'_editURL'=>$app->getAppActionUrl('audience_persona_ae',array('op'=>'edit','persona_id'=>$this->id)),
			'_deleteURL'=>$app->getAppActionUrl('audience',array('op'=>'delete_persona','persona_id'=>$this->id))
		);
		
		return $result;
	}
}
?>