<?php
class OS_APPVIEW_ContentStrategy_Audience extends OS_AppViewBase
{
	public function __constuct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$requestParams=$appPlugin->getRequestParams();
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='delete_persona')
			{
				if (!empty($requestParams['persona_id']))
				{
					$personaOps=OS_APP_ContentStrategy_PersonaOperations::get_instance();
					
					if ($persona=$personaOps->getPersonaByID($requestParams['persona_id']) AND $persona->project_id=$project->id)
					{
						if ($persona->delete())
						{
							$OS->addInfo(_("Persona deleted successfully"));
						}
						else
						{
							$OS->addBoxError(_("Unable to delete persona"));
						}
					}
				}
			}
			elseif ($requestParams['op']=='delete_funnelstage')
			{
				if (!empty($requestParams['funnelstage_id']))
				{
					$funnelStageOps=OS_APP_ContentStrategy_FunnelStageOperations::get_instance();
					
					if ($funnelstage=$funnelStageOps->getFunnelStageByID($requestParams['funnelstage_id']) AND $funnelstage->project_id=$project->id)
					{
						if ($funnelstage->delete())
						{
							$OS->addInfo(_("Funnel stage deleted successfully"));
						}
						else
						{
							$OS->addBoxError(_("Unable to delete funnel stage"));
						}
					}
				}
			}
		}
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$personaOps=OS_APP_ContentStrategy_PersonaOperations::get_instance();
		$funnelStageOps=OS_APP_ContentStrategy_FunnelStageOperations::get_instance();
		
		$viewDataVars=array(
			'personas'=>$personaOps->getPersonas(),
			'funnelstages'=>$funnelStageOps->getFunnelStages()
		);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array();
		
		if (empty($viewData['personas']))
		{
			$tplVars['personas']=false;
		}
		else
		{
			$tplVars['personaFields']=array(
				'age_range'=>array('name'=>_("Age range")),
				'gender'=>array('name'=>_("Gender")),
				'location'=>array('name'=>_("Location")),
				'device'=>array('name'=>_("Device")),
				'information'=>array('name'=>_("Information")),
				'keywords'=>array('name'=>_("Keywords")),
				'outcome'=>array('name'=>_("Outcome")),
			);
			
			foreach ($viewData['personas'] as $persona_id=>$persona)
			{
				$tplVars['personas'][$persona_id]=$persona->toTemplate();
			}
		}
		
		if (empty($viewData['funnelstages']))
		{
			$tplVars['funnelstages']=false;
		}
		else
		{
			foreach ($viewData['funnelstages'] as $funnelstage_id=>$funnelstage)
			{
				$tplVars['funnelstages'][$funnelstage_id]=$funnelstage->toTemplate();
			}
		}
		
		$tplVars['addPersonaURL']=$appPlugin->getAppActionUrl('audience_persona_ae');;
		$tplVars['addFunnelStageURL']=$appPlugin->getAppActionUrl('audience_funnelstage_ae');
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('audience',$tplVars);
	}
}
?>