<?php
class OS_APPVIEW_ContentStrategy_Audience_FunnelStage_AE extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		$funnelstageOps=OS_APP_ContentStrategy_FunnelStageOperations::get_instance();
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='edit')
			{
				if (empty($requestParams['funnelstage_id']))
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('view'));
				}
				elseif (!$oneFunnelStage=$personaOps->getFunnelStageByID($requestParams['funnelstage_id']))
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('view'));
				}
			}
			elseif ($requestParams['op']!='add')
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'));
			}
		}
		else
		{
			$requestParams['op']='add';
		}
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			if (empty($requestParams['name_box']))
			{
				$OS->addFieldError(_("Name missing"),'name');
			}
			else
			{
				$requestParams['name_box']=trim($requestParams['name_box']);
				
				if (empty($requestParams['name_box']))
				{
					$OS->addFieldError(_("Name missing"),'name');
				}
			}
			
			if (empty($requestParams['description_box']))
			{
				$OS->addFieldError(_("Description missing"),'description');
			}
			else
			{
				$requestParams['description_box']=trim($requestParams['description_box']);
				
				if (empty($requestParams['description_box']))
				{
					$OS->addFieldError(_("Description missing"),'description');
				}
			}
			
			if (empty($OS->errorMessages))
			{
				if ($requestParams['op']=='add')
				{
					$oneFunnelStage=new OS_APP_ContentStrategy_FunnelStage();
					
					$oneFunnelStage->project_id=$osProject->id;
				}
				
				$oneFunnelStage->name=$requestParams['name_box'];
				$oneFunnelStage->description=$requestParams['description_box'];
				
				if ($oneFunnelStage->save())
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('audience',array('msg'=>'funnelstage_'.$requestParams['op'].'_ok')),true);
				}
				else
				{
					$OS->addBoxError(_("Unable to save funnel stage. Try again later"));
				}
			}
		}
		else
		{
			if ($requestParams['op']=='edit')
			{
				$requestParams['name_box']=$oneFunnelStage->name;
				$requestParams['description_box']=$oneFunnelStage->description;
			}
			else
			{
				$requestParams['name_box']='';
				$requestParams['description_box']='';
			}
		}
	}
	
	public function render()
	{
		$OS=getOS();

		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$tplVars['appURL']=$appPlugin->getAppUrl();
		
		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('audience_funnelstage_ae',$tplVars);
	}
}
?>