<?php
class OS_APPVIEW_ContentStrategy_Audience_Persona_AE extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		$personaOps=OS_APP_ContentStrategy_PersonaOperations::get_instance();
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='edit')
			{
				if (empty($requestParams['persona_id']))
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('view'));
				}
				elseif (!$onePersona=$personaOps->getPersonaByID($requestParams['persona_id']))
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('view'));
				}
			}
			elseif ($requestParams['op']!='add')
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'));
			}
		}
		else
		{
			$requestParams['op']='add';
		}
		
		$processedRequest=array(
			'genders'=>$personaOps->getPersonaGenders(),
			'ages'=>range(13,99)
		);
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			if (empty($requestParams['name_box']))
			{
				$OS->addFieldError(_("Name missing"),'name');
			}
			else
			{
				$requestParams['name_box']=trim($requestParams['name_box']);
				
				if (empty($requestParams['name_box']))
				{
					$OS->addFieldError(_("Name missing"),'name');
				}
			}
			
			if (empty($requestParams['age_min_box']))
			{
				$OS->addFieldError(_("Age missing"),'age');
			}
			elseif (!in_array($requestParams['age_min_box'],$processedRequest['ages']))
			{
				$OS->addFieldError(_("Invalid age"),'age');
			}
			
			if (empty($requestParams['age_max_box']))
			{
				$OS->addFieldError(_("Age missing"),'age');
			}
			elseif (!in_array($requestParams['age_max_box'],$processedRequest['ages']))
			{
				$OS->addFieldError(_("Invalid age"),'age');
			}
			
			if (empty($requestParams['gender_box']))
			{
				$OS->addFieldError(_("Gender missing"),'gender');
			}
			elseif (!isset($processedRequest['genders'][$requestParams['gender_box']]))
			{
				$OS->addFieldError(_("Invalid gender"),'gender');
			}
			
			if (empty($requestParams['location_box']))
			{
				$OS->addFieldError(_("Location missing"),'location');
			}
			else
			{
				$requestParams['location_box']=trim($requestParams['location_box']);
				
				if (empty($requestParams['location_box']))
				{
					$OS->addFieldError(_("Location missing"),'location');
				}
			}
			
			if (empty($requestParams['device_box']))
			{
				$OS->addFieldError(_("Device missing"),'device');
			}
			else
			{
				$requestParams['device_box']=trim($requestParams['device_box']);
				
				if (empty($requestParams['device_box']))
				{
					$OS->addFieldError(_("Device missing"),'device');
				}
			}
			
			if (empty($requestParams['information_box']))
			{
				$OS->addFieldError(_("Information missing"),'information');
			}
			else
			{
				$requestParams['information_box']=trim($requestParams['information_box']);
				
				if (empty($requestParams['information_box']))
				{
					$OS->addFieldError(_("Information missing"),'information');
				}
			}
			
			if (empty($requestParams['keywords_box']))
			{
				$OS->addFieldError(_("Keywords missing"),'keywords');
			}
			else
			{
				$keywords=explode("\n",$requestParams['keywords_box']);
				$actual_keywords=array();
				
				foreach ($keywords as $pos=>$keyword)
				{
					$keyword=trim($keyword);
					
					if (strlen($keyword)>=3)
					{
						$actual_keywords[]=$keyword;
					}
				}
				
				if (empty($actual_keywords))
				{
					$OS->addFieldError(_("Keywords missing"),'keywords');
				}
				
				$requestParams['keywords_box']=implode("\n",$actual_keywords);
			}
			
			if (empty($requestParams['outcome_box']))
			{
				$OS->addFieldError(_("Outcome missing"),'outcome');
			}
			else
			{
				$requestParams['outcome_box']=trim($requestParams['outcome_box']);
				
				if (empty($requestParams['outcome_box']))
				{
					$OS->addFieldError(_("Outcome missing"),'outcome');
				}
			}
			
			if (empty($OS->errorMessages))
			{
				if ($requestParams['op']=='add')
				{
					$onePersona=new OS_APP_ContentStrategy_Persona();
					
					$onePersona->project_id=$osProject->id;
				}
				
				$onePersona->name=$requestParams['name_box'];
				$onePersona->age_min=$requestParams['age_min_box'];
				$onePersona->age_max=$requestParams['age_max_box'];
				$onePersona->gender=$requestParams['gender_box'];
				$onePersona->location=$requestParams['location_box'];
				$onePersona->device=$requestParams['device_box'];
				$onePersona->information=$requestParams['information_box'];
				$onePersona->keywords=$actual_keywords;
				$onePersona->outcome=$requestParams['outcome_box'];
				
				if ($onePersona->save())
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('audience',array('msg'=>'persona_'.$requestParams['op'].'_ok')),true);
				}
				else
				{
					$OS->addBoxError(_("Unable to save persona. Try again later"));
				}
			}
		}
		else
		{
			if ($requestParams['op']=='edit')
			{
				$requestParams['name_box']=$onePersona->name;
				$requestParams['age_min_box']=$onePersona->age_min;
				$requestParams['age_max_box']=$onePersona->age_max;
				$requestParams['gender_box']=$onePersona->gender;
				$requestParams['location_box']=$onePersona->location;
				$requestParams['device_box']=$onePersona->device;
				$requestParams['information_box']=$onePersona->information;
				$requestParams['keywords_box']=implode("\n",$onePersona->keywords);
				$requestParams['outcome_box']=$onePersona->outcome;
			}
			else
			{
				$requestParams['name_box']='';
				$requestParams['age_min_box']='13';
				$requestParams['age_max_box']='99';
				$requestParams['gender_box']='';
				$requestParams['location_box']='';
				$requestParams['device_box']='';
				$requestParams['information_box']='';
				$requestParams['keywords_box']='';
				$requestParams['outcome_box']='';
			}
		}
		
		$processedRequest['params']=$requestParams;
		
		return $processedRequest;
	}
	
	public function render()
	{
		$OS=getOS();

		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$tplVars['appURL']=$appPlugin->getAppUrl();
		
		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('audience_persona_ae',$tplVars);
	}
}
?>