<?php
class OS_APPVIEW_ContentStrategy_Inventory extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$contentOps=OS_APP_ContentStrategy_ContentOperations::get_instance();
		
		$requestParams=$appPlugin->getRequestParams();
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='delete')
			{
				if (!empty($requestParams['content_id']))
				{
					if ($contentOps->deleteContentByContentID($requestParams['content_id']))
					{
						$OS->addInfo(_("Content deleted successfully"));
					}
					else
					{
						$OS->addBoxError(_("Unable to delete content. Try again later"));
					}
				}
			}
		}
		
		if (!empty($requestParams['msg']))
		{
			if ($requestParams['msg']=='add_ok')
			{
				$OS->addInfo(_("Content added successfully"));
			}
			elseif ($requestParams['msg']=='edit_ok')
			{
				$OS->addInfo(_("Content edited successfully"));
			}
			elseif ($requestParams['msg']=='import_ok')
			{
				$OS->addInfo(_("Content imported successfully"));
			}
		}
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$contentOps=OS_APP_ContentStrategy_ContentOperations::get_instance();
		
		$viewDataVars=array(
			'queue'=>$contentOps->getContentQueue($project->id),
			'published'=>$contentOps->getPublishedContent($project->id)
		);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array();
		
		if (empty($viewData['queue']))
		{
			$tplVars['queue']=false;
		}
		else
		{
			foreach ($viewData['queue'] as $content_id=>$content)
			{
				$tplVars['queue'][$content_id]=$content->toTemplate();
			}
		}
		
		if (empty($viewData['published']))
		{
			$tplVars['published']=false;
		}
		else
		{
			foreach ($viewData['published'] as $content_id=>$content)
			{
				$tplVars['published'][$content_id]=$content->toTemplate();
			}
		}
		
		$tplVars['addQueuedURL']=$appPlugin->getAppActionUrl('inventory_ae',array('op'=>'add','status'=>'not_started'));
		$tplVars['addPublishedURL']=$appPlugin->getAppActionUrl('inventory_ae',array('op'=>'add','status'=>'published'));
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('inventory',$tplVars);
	}
}
?>