<?php
class OS_APPVIEW_ContentStrategy_Inventory_AE extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		$contentOps=OS_APP_ContentStrategy_ContentOperations::get_instance();
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='edit')
			{
				if (empty($requestParams['content_id']))
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('view'));
				}
				elseif (!$oneContent=$contentOps->getContentByID($requestParams['content_id']))
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('view'));
				}
			}
			elseif ($requestParams['op']!='add')
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'));
			}
		}
		else
		{
			$requestParams['op']='add';
		}
		
		$personaOps=OS_APP_ContentStrategy_PersonaOperations::get_instance();
		$funnelstageOps=OS_APP_ContentStrategy_FunnelStageOperations::get_instance();
		
		$processedRequest=array(
			'personas'=>array(),
			'funnelstages'=>array(),
			'types'=>$contentOps->getContentTypes(),
			'statuses'=>$contentOps->getContentStatuses(),
			'placements'=>$contentOps->getContentPlacements(),
			'goals'=>$contentOps->getContentGoalTypes()
		);
		
		if ($temp=$personaOps->getPersonas())
		{
			foreach ($temp as $id=>$obj)
			{
				$processedRequest['personas'][$id]=$obj->name;
			}
		}
		
		if ($temp=$funnelstageOps->getFunnelStages())
		{
			foreach ($temp as $id=>$obj)
			{
				$processedRequest['funnelstages'][$id]=$obj->name;
			}
		}
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			if (empty($requestParams['title_box']))
			{
				$OS->addFieldError(_("Title missing"),'title');
			}
			else
			{
				$requestParams['title_box']=trim($requestParams['title_box']);
				
				if (empty($requestParams['title_box']))
				{
					$OS->addFieldError(_("Title missing"),'title');
				}
			}
			
			if (empty($requestParams['author_box']))
			{
				$OS->addFieldError(_("Author missing"),'author');
			}
			else
			{
				$requestParams['author_box']=trim($requestParams['author_box']);
				
				if (empty($requestParams['author_box']))
				{
					$OS->addFieldError(_("Author missing"),'author');
				}
			}
			
			if (!empty($processedRequest['personas']))
			{
				if (empty($requestParams['persona_box']))
				{
					$requestParams['persona_box']=0;
				}
				elseif (!isset($processedRequest['personas'][$requestParams['persona_box']]))
				{
					$OS->addFieldError(_("Invalid persona"),'persona');
				}
			}
			else
			{
				$requestParams['persona_box']=0;
			}
			
			$url='';
			if (empty($requestParams['status_box']))
			{
				$OS->addFieldError(_("Status missing"),'status');
			}
			elseif (!isset($processedRequest['statuses'][$requestParams['status_box']]))
			{
				$OS->addFieldError(_("Invalid status"),'status');
			}
			else
			{
				if ($requestParams['status_box']=='published')
				{
					if (empty($requestParams['url_box']))
					{
						$OS->addFieldError(_("URL missing"),'url');
					}
					else
					{
						$osValidator=$OS->getValidator();
						
						if (!$osValidator->is_url($requestParams['url_box']))
						{
							$OS->addFieldError(_("Invalid URL"),'url');
						}
						else
						{
							$url=$requestParams['url_box'];
						}
					}
				}
			}
			
			if (empty($requestParams['placement_box']))
			{
				$OS->addFieldError(_("Placement missing"),'placement');
			}
			elseif (!isset($processedRequest['placements'][$requestParams['placement_box']]))
			{
				$OS->addFieldError(_("Invalid placement"),'placement');
			}
			
			if (empty($requestParams['type_box']))
			{
				$OS->addFieldError(_("Type missing"),'type');
			}
			elseif (!isset($processedRequest['types'][$requestParams['type_box']]))
			{
				$OS->addFieldError(_("Invalid type"),'type');
			}
			
			if (!empty($processedRequest['funnelstages']))
			{
				if (empty($requestParams['funnelstage_box']))
				{
					$requestParams['funnelstage_box']=0;
				}
				elseif (!isset($processedRequest['funnelstages'][$requestParams['funnelstage_box']]))
				{
					$OS->addFieldError(_("Invalid funnel stage"),'funnelstage');
				}
			}
			else
			{
				$requestParams['funnelstage_box']=0;
			}
			
			if (empty($requestParams['keywords_box']))
			{
				$OS->addFieldError(_("Keywords missing"),'keywords');
			}
			else
			{
				$keywords=explode("\n",$requestParams['keywords_box']);
				$actual_keywords=array();
				
				foreach ($keywords as $pos=>$keyword)
				{
					$keyword=trim($keyword);
					
					if (strlen($keyword)>=3)
					{
						$actual_keywords[]=$keyword;
					}
				}
				
				if (empty($actual_keywords))
				{
					$OS->addFieldError(_("Keywords missing"),'keywords');
				}
				
				$requestParams['keywords_box']=implode("\n",$actual_keywords);
			}
			
			if (empty($requestParams['due_date_box']))
			{
				$OS->addFieldError(_("Date missing"),'due_date');
			}
			elseif ($requestParams['due_date_box']!=date('Y-m-d',strtotime($requestParams['due_date_box'])))
			{
				$OS->addFieldError(_("Invalid date"),'due_date');
			}
			
			$goals=array();
			foreach ($processedRequest['goals'] as $goal_type=>$goal_name)
			{
				if (!empty($requestParams["goal_{$goal_type}_box"]))
				{
					if (!is_numeric($requestParams["goal_{$goal_type}_box"]))
					{
						$OS->addFieldError(_("Invalid goal value"),"goal_{$goal_type}");
					}
					elseif (abs($requestParams["goal_{$goal_type}_box"])!=floor($requestParams["goal_{$goal_type}_box"]))
					{
						$OS->addFieldError(_("Invalid goal value"),"goal_{$goal_type}");
					}
					else
					{
						$goals[$goal_type]=$requestParams["goal_{$goal_type}_box"];
					}
				}
				else
				{
					$requestParams["goal_{$goal_type}_box"]=0;
				}
			}

			if (empty($OS->errorMessages))
			{
				if ($requestParams['op']=='add')
				{
					$oneContent=OS_APP_ContentStrategy_Content::get_instance();
					
					$oneContent->project_id=$osProject->id;
				}
	
				$oneContent->title=$requestParams['title_box'];
				$oneContent->author=$requestParams['author_box'];
				if (!empty($url))
				{
					$oneContent->url=$url;
					$oneContent->host=parse_url($url,PHP_URL_HOST);
				}
				$oneContent->type=$requestParams['type_box'];
				$oneContent->keywords=$actual_keywords;
				$oneContent->persona_id=$requestParams['persona_box'];
				$oneContent->funnelstage_id=$requestParams['funnelstage_box'];
				$oneContent->placement=$requestParams['placement_box'];
				$oneContent->due_date=$requestParams['due_date_box'];
				$oneContent->status=$requestParams['status_box'];
				$oneContent->goals=$goals;
				
				if ($oneContent->save())
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('inventory',array('msg'=>$requestParams['op'].'_ok')),true);
				}
				else
				{
					$OS->addBoxError(_("Unable to save content piece. Try again later"));
				}
			}
		}
		else
		{
			if ($requestParams['op']=='edit')
			{
				$requestParams['title_box']=$oneContent->title;
				$requestParams['author_box']=$oneContent->author;
				$requestParams['persona_box']=$oneContent->persona_id;
				$requestParams['funnelstage_box']=$oneContent->funnelstage_id;
				$requestParams['status_box']=$oneContent->status;
				$requestParams['url_box']=$oneContent->url;
				$requestParams['placement_box']=$oneContent->placement;
				$requestParams['type_box']=$oneContent->type;
				$requestParams['keywords_box']=implode("\n",$oneContent->keywords);
				$requestParams['due_date_box']=$oneContent->due_date;
				foreach ($processedRequest['goals'] as $goal_type=>$goal_name)
				{
					if (isset($oneContent->goals[$goal_type]))
					{
						$requestParams["goal_{$goal_type}_box"]=$oneContent->goals[$goal_type];
					}
					else
					{
						$requestParams["goal_{$goal_type}_box"]='';
					}
				}
			}
			else
			{
				$requestParams['title_box']='';
				$requestParams['author_box']='';
				$requestParams['persona_box']='';
				$requestParams['funnelstage_box']='';
				$requestParams['status_box']='';
				$requestParams['url_box']='';
				$requestParams['placement_box']='';
				$requestParams['type_box']='';
				$requestParams['keywords_box']='';
				$requestParams['due_date_box']='';
				foreach ($processedRequest['goals'] as $goal_type=>$goal_name)
				{
					$requestParams["goal_{$goal_type}_box"]='';
				}
				
				if (isset($requestParams['status']))
				{
					if (isset($processedRequest['statuses'][$requestParams['status']]))
					{
						$requestParams['status_box']=$requestParams['status'];
					}
				}
				
				if (isset($requestParams['due_date']))
				{
					if ($requestParams['due_date']==date('Y-m-d',strtotime($requestParams['due_date'])))
					{
						$requestParams['due_date_box']=$requestParams['due_date'];
					}
				}
			}
		}
		
		$processedRequest['params']=$requestParams;
		
		return $processedRequest;
	}
	
	public function render()
	{
		$OS=getOS();

		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$tplVars['appURL']=$appPlugin->getAppUrl();
		
		$tpl = $OS->getTemplate();
		
		$headContents['contentstrategy_inventory_ae']="<script type='text/javascript'>
		function contentStatusUpdated(status)
		{
			$('#url_bar').css('display',(status=='published'?'block':'none'));
		}
		</script>";
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('inventory_ae',$tplVars);
	}
}
?>