<?php
class OS_APPVIEW_ContentStrategy_Inventory_Import_Crawl extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		$contentOps=OS_APP_ContentStrategy_ContentOperations::get_instance();
		
		if (empty($requestParams['op']))
		{
			$requestParams['op']='pattern';
		}
		elseif (!in_array($requestParams['op'],array('pattern','import')))
		{
			$requestParams['op']='pattern';
		}
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			if (empty($requestParams['pattern_box']))
			{
				$OS->addBoxError(_("Pattern missing"),'pattern');
			}
			else
			{
				$requestParams['pattern_box']=trim($requestParams['pattern_box']);
				
				if (empty($requestParams['pattern_box']))
				{
					$OS->addBoxError(_("Pattern missing"),'pattern');
				}
			}
			
			if (empty($requestParams['pattern_type_box']))
			{
				$OS->addBoxError(_("Pattern type missing"),'pattern_type');
			}
			elseif (!in_array($requestParams['pattern_type_box'],array('normal','regex')))
			{
				$OS->addBoxError(_("Invalid pattern type"),'pattern_type');
			}
			
			if (!empty($OS->errorMessages))
			{
				$requestParams['op']='pattern';
			}
			else
			{
				if (!$contentUrls=$contentOps->getContentUrlsByPattern($requestParams['pattern_box'],($requestParams['pattern_type_box']=='regex')))
				{
					$OS->addBoxError(_("Pattern did not match any URLs"),'pattern');
					
					$requestParams['op']='pattern';
				}
			}
			
			if ($requestParams['op']=='import')
			{
				$imported=false;
				
				$host=parse_url($osProject->url,PHP_URL_HOST);
				$today=date('Y-m-d');
				
				foreach ($contentUrls as $url_id=>$url)
				{
					if (!empty($requestParams["url_{$url_id}_box"]))
					{
						$oneContent=new OS_APP_ContentStrategy_Content();
						
						$oneContent->project_id=$osProject->id;
						$oneContent->title=$url['title'];
						$oneContent->author=$host;
						$oneContent->url=$url['url'];
						$oneContent->host=$host;
						$oneContent->type='generic';
						$oneContent->placement='local';
						$oneContent->status='published';
						$oneContent->due_date=$today;
						
						if ($oneContent->save())
						{
							$imported=true;
						}
					}
				}
				
				if (!$imported)
				{
					$OS->addBoxError(_("Select at least a piece of content to import"));
				}
			}
			
			if (empty($OS->errorMessages))
			{
				if ($requestParams['op']=='pattern')
				{
					$requestParams['op']='import';
				}
				else
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('inventory',array('msg'=>'import_ok')),true);
				}
			}
		}
		else
		{
			$requestParams['pattern_box']='';
			$requestParams['pattern_type_box']='normal';
		}
		
		$processedRequest=array(
			'params'=>$requestParams,
			'contentUrls'=>($requestParams['op']=='import'?$contentUrls:false)
		);
		
		return $processedRequest;
	}
	
	public function render()
	{
		$OS=getOS();

		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$tplVars['appURL']=$appPlugin->getAppUrl();
		
		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('inventory_import_crawl',$tplVars);
	}
}
?>