<?php
class OS_APPVIEW_ContentStrategy_Main extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$start_ts=mktime(0,0,0,date('m'),1,date('Y'));
		$end_ts=mktime(23,59,59,date('m'),date('t'),date('Y'));
		
		$requestParams=$appPlugin->getRequestParams();
		if (!empty($requestParams['month']))
		{
		}
		
		return array(
			'start_ts'=>$start_ts,
			'start_dt'=>date('Y-m-d',$start_ts),
			'end_ts'=>$end_ts,
			'end_dt'=>date('Y-m-d',$end_ts),
		);
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$contentOps=OS_APP_ContentStrategy_ContentOperations::get_instance();
		
		$viewDataVars=array(
			'calendar'=>$contentOps->getContentsByTimeframe($project->id,$this->processedRequest['start_dt'],$this->processedRequest['end_dt'])
		);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array();
		
		$start_ts=$this->processedRequest['start_ts'];
		$end_ts=$this->processedRequest['end_ts'];
		
		$cal_start_ts=$start_ts-date('w',$start_ts)*86400;
		$cal_end_ts=$end_ts+(6-date('w',$end_ts))*86400;
		
		$day_ts=$cal_start_ts;
		while ($day_ts<$cal_end_ts)
		{
			$is_active=($day_ts>=$start_ts AND $day_ts<=$end_ts);
			$day=date('Y-m-d',$day_ts);
		
			$tplVars['calendar'][$day]=array(
				'day'=>date('d M',$day_ts),
				'active'=>$is_active,
				'add_link'=>($is_active?$appPlugin->getAppActionUrl('inventory_ae',array('op'=>'add','due_date'=>$day)):false),
				'contents'=>array()
			);
			
			$day_ts+=86400;
		}
		
		if ($viewData['calendar'])
		{
			$osUtils=$OS->getUtils();
			
			foreach ($viewData['calendar'] as $content_id=>$content)
			{
				$day=date('Y-m-d',strtotime($content->due_date));
				$tplVars['calendar'][$day]['contents'][$content_id]=array(
					'title'=>$content->title,
					'status'=>$content->status,
					'type'=>$content->type,
					'edit_url'=>$appPlugin->getAppActionUrl('inventory_ae',array('op'=>'edit','content_id'=>$content_id)),
					'url'=>($content->status=='published'?$osUtils->getSafeURL($content->url):false)
				);
			}
		}
		
		$tplVars['current_month']=date("F Y",$cal_start_ts);
		$tplVars['prev_month']=array(
			'month'=>date('F Y',$cal_start_ts-86400),
			'url'=>$appPlugin->getAppActionUrl('view',array('month_ts'=>$cal_start_ts-86400))
		);
		$tplVars['next_month_url']=array(
			'month'=>date('F Y',$cal_end_ts+86400),
			'url'=>$appPlugin->getAppActionUrl('view',array('month_ts'=>$cal_end_ts+86400))
		);
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('overview',$tplVars);
	}
}
?>