<?php 

class OS_APP_copydetector extends OS_AppBase
{
	private static $_instance;
	
	protected function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
		$this->addMenuItem('pagecopiesview', array("name" => _("Page Copies"), 'routerOption'=> "handlePageCopyView", 'parent' => 'view', "show_in_menu" => false));
		$this->addMenuItem('type-content', array("name" => _("Text Copies"),'routerOption'=> "handleTypeViewContent"));
		$this->addMenuItem('type-img', array("name" => _("Image Copies"), 'routerOption'=> "handleTypeViewImg"));
		$this->addMenuItem('type-link', array("name" => _("Link Copies"), 'routerOption'=> "handleTypeViewLink"));
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_copydetector();
		}
		return self::$_instance;
	}	
	
	public function handleMainView()
	{
		require $this->getAppHomePath()."/views/mainview.php";
		$viewData = new OS_APP_copydetector_mainView();
		
		return $viewData->render();
	}
	
	public function handleCodeView()
	{
		require $this->getAppHomePath()."/views/codeview.php";
		$viewData = new OS_APP_copydetector_codeView();
		
		return $viewData->render();
	}
	
	
	public function handleTypeViewContent()
	{
		require $this->getAppHomePath()."/views/typeview_content.php";
		$viewData = new OS_APP_copydetector_typeView_Content();
		
		return $viewData->render();
	}
	
	public function handleTypeViewImg()
	{
		require $this->getAppHomePath()."/views/typeview_img.php";
		$viewData = new OS_APP_copydetector_typeView_Img();
		
		return $viewData->render();
	}
	
	public function handleTypeViewLink()
	{
		require $this->getAppHomePath()."/views/typeview_link.php";
		$viewData = new OS_APP_copydetector_typeView_Link();
		
		return $viewData->render();
	}
	
	public function handlePageCopyView()
	{
		require $this->getAppHomePath()."/views/pagecopiesview.php";
		$viewData = new OS_APP_copydetector_pageCopiesView();
		
		return $viewData->render();
	}
	
	public function eventProjectDeleted($params)
	{
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'copydetector'=>array(
				'view'=>array('name'=>_("View CopyDetector Details")),
			)
		);
	}
	
	public function trackEvent($eventDetails)
	{
		$OS = getOS();
		$osUtils = $OS->getUtils();
		
		$fpath = os_join_path($OS->getConfigVar('cache_path'), 'tmp', 'trk_endpoint.log');
		$osUtils->fileWrite($fpath, var_export($eventDetails, true)."\n");
		
		$copyDetectorTracker = new OS_APP_copydetector_Tracker_Actions();
		$copyDetectorTracker->setRequest($eventDetails);
		$copyDetectorTracker->handle();
		
		return false;	
	}
}
?>