var appTracker = {
		
	registeredEvents: [],
	
	prevSelectedText: '',
	
	prevSelectedImg: '',
	
	prevSelectedLnk: '',
		
	contentCopiesHandler: function(extraData)
	{
		var userSelection = '';
		if(window.getSelection)
		{
			var selObj = window.getSelection();
			userSelection = selObj.toString();
		}
		else if(document.selection)
		{
			range = document.selection.createRange();
			tmpHtml = range.htmlText;
			userSelection = range.text;
		}
			
		if(userSelection.selectedText!='')if(userSelection.length != this.prevSelectedText.length)
		{
			this.prevSelectedText = userSelection;
			return {'ct': userSelection, 'tp': 'txt'}
		}
		
		return false;
	},
	
	
	imgCopiesHandler: function(extraData)
	{
		var sourceElement,parentElement,tag, clickEvent;
		
		clickEvent = extraData.evt;
		
		if (typeof clickEvent == 'undefined') clickEvent = window.event;

		if (clickEvent.target)
		{
			sourceElement = clickEvent.target;
		}	
		else if (clickEvent.srcElement)
		{
			sourceElement = clickEvent.srcElement;
		}
		else return; 
		
		while ((parentElement = sourceElement.parentNode) && ((tag = sourceElement.tagName) != 'IMG')) sourceElement = parentElement;
				
		if(sourceElement.src)
		{
			return this.logImgCopy(sourceElement);
		}	
		
		return false;
	},
	
	logImgCopy: function(imgObj)
	{
		if(imgObj.src) 
		{
			if(this.prevSelectedImg != imgObj.src)
			{
				this.prevSelectedImg = imgObj.src;
				
				var imgValues =
				{
					'ct': (imgObj.title != ''? imgObj.title: ''),
					'ca': (imgObj.alt != ''? imgObj.alt: ''),
					'cu': imgObj.src,
					'tp': 'img', 
				};
				
				return imgValues;
			}	
		}
		
		return false;
	},
	
	lnkCopiesHandler: function(extraData)
	{
		var button, target, lastButton, lastTarget, evt;
		
		evt = extraData.evt;
		
		evt = evt || window.event;
		button = evt.which || evt.button;
		target = evt.target || evt.srcElement;
		
        if (evt.type === 'contextmenu')
        {
            if (target)
            {
            	return this.logLnkCopy(target);
            }
        }
        else if (evt.type === 'mousedown')
        {
            if ((button === 1 || button === 2) && target)
            {
                lastButton = button;
                lastTarget = target;
            }
            else
            {
                lastButton = lastTarget = null;
            }
        }
        else if (evt.type === 'mouseup')
        {
            if (button === lastButton && target === lastTarget)
            {
            	return this.logLnkCopy(target);
            }
            lastButton = lastTarget = null;
        }

		return false;
	},
	
	processLnkCopy: function(target)
	{
        var parentElement, tag, linkType;
        
	    while ((parentElement = sourceElement.parentNode) !== null && (typeof parentElement !=='undefined') && ((tag = sourceElement.tagName.toUpperCase()) !== 'A' && tag !== 'AREA'))
	    {
	        sourceElement = parentElement;
	    }
	
	    if (typeof sourceElement.href !== 'undefined')
	    {
	    	var originalSourceHostName = sourceElement.hostname || getHostName(sourceElement.href),
	            sourceHostName = originalSourceHostName.toLowerCase(),
	            sourceHref = sourceElement.href.replace(originalSourceHostName, sourceHostName),
	            scriptProtocol = new RegExp('^(javascript|vbscript|jscript|mocha|livescript|ecmascript|mailto):', 'i');
	
	        if (!scriptProtocol.test(sourceHref))
	        {
	        	return this.logLnkCopy(sourceElement);
	        }
	    }
	    
	    return false;
	},
	
	
	logLnkCopy: function(sourceElement)
	{
		var sourceHref, linkAnchor, linkTitle;
        
        sourceHref = (sourceElement.href ? this.urlDecode(sourceElement.href) : '');
        
        linkTitle = (sourceElement.title ? sourceElement.title : '');
        
        linkAnchor = (sourceElement.innerHTML ? sourceElement.innerHTML : '');
		
        if(sourceHref.length)
        {
        	if(this.prevSelectedLnk != sourceHref)
        	{
        		this.prevSelectedLnk = sourceHref;
        		
        		var lnkValues = {
        			'ca': linkAnchor,
        			'ct': linkTitle,
        			'cu': sourceHref,
        			'tp': 'lnk',
        		};
                return lnkValues;
        	}	
        }
        return false;
	},
	
	urlDecode: function(url)
	{
		return unescape(url);
	},
	
	call: function()
	{
		//track copy event
		var hookEvents = [],i,
			bodyAlias = document.getElementsByTagName('body').item(0),
			documentAlias = document,
			linkElements = documentAlias.links,
			imageElements = documentAlias.images;
		
		if(bodyAlias)
		{
			this.registeredEvents.push(['copiesTrackerContent', bodyAlias, 'copy', "contentCopiesHandler"]);	
		}
		
		var totalImagesCount = imageElements.length;
		
		if(totalImagesCount > 0)
		{
			for (i=0; i<totalImagesCount; i++)
			{
				this.registeredEvents.push(['copiesTrackerImages', imageElements[i], 'contextmenu', "imgCopiesHandler"]);
			}	
		}	
		
		var totalLinksCount = linkElements.length;
		
		if(totalLinksCount > 0)
		{
			for (i=0; i<totalLinksCount; i++)
			{
				this.registeredEvents.push(['copiesTrackerLinks', linkElements[i], 'contextmenu', "lnkCopiesHandler"]);
			}	
		}
		
        return {'hookEvents': this.registeredEvents};
	}
};
