<div class="section-center col_12">
	{if !empty($tvars.topCopiesPages)}
		<div class="col_12">
			<div class='simple-box'>
				<div class='title'>{t}Total Copies Evolution{/t}</div>
				<div class='content'>
					{if !empty($tvars.chart_html)}
						{$tvars.chart_html}
					{/if}	
					<div class="clear"></div>
				</div>
				<div class="clear"></div>
			</div>
		</div>
	{/if}
	
	{if !empty($tvars.totalCopiesByType)}
		<div class="col_12">
			<div class='simple-box'>
				<div class='title'>{t}Copies Overview{/t}</div>
				<div class='content'>
				
					<table class='striped' cellpadding='0' cellspacing='0'>
						<thead>
							<tr>
								{foreach from=$tvars.totalCopiesByType key=type item=details}
									<td class="center">
									{if isset($details.view_link)} 
										<a href="{$details.view_link}" title="{t}View Copies Distribution{/t}" class="statsInfoBoxText {$details.type_box_color}">{$details.type_title}</a>	
									{else}<span class="statsInfoBoxText {$details.type_box_color}">{$details.type_title}</span>{/if}
									</td>
								{/foreach}	
							</tr>
						</thead>
						
						<tbody>
							<tr align="center">
							{foreach from=$tvars.totalCopiesByType key=type item=details}
								<td>
									<div title="{t}View Copies Distribution{/t}" class="nofloat marginsCenter statsInfoBox {if $type != 'total'}fill{/if} {$details.type_box_color}" 
										{if isset($details.view_link)}
											onclick="window.location='{$details.view_link}'" style="cursor:pointer"
										{/if}	
										>
										<div class="statsInfoBoxInside">{$details.total_copies}
											<br><span class="statsInfoBoxInsidePercent">({$details.percentage}% {t}of total{/t})</span>
										</div>
									</div>
								</td>
							{/foreach}
							
							</tr>
			
							<tr align="center">
							{foreach from=$tvars.totalCopiesByType key=type item=details}
								<td class="center">
									{if $details.compare_evolution == 'up'}
										<span title="{t}Increased{/t}" data-icon="~" class="icon large green stats-change-icon"></span>
										<span class="stats-change-text green">(+{$details.compare_percentage}%)</span>
									{elseif $details.compare_evolution == 'down'}
										<span title="{t}Decreased{/t}" data-icon="|" class="icon large red stats-change-icon"></span>
										<span class="stats-change-text red">(-{$details.compare_percentage}%)</span>
									{elseif $details.compare_evolution == 'same'}
										<span title="{t}Constant{/t}" data-icon="-" class="icon gray stats-change-icon"></span>
										<span class="stats-change-text gray">({$details.compare_percentage}%)</span>
									{/if}
								</td>
							{/foreach}
							</tr>
						</tbody>
					</table>
	
					<div class="clear"></div>
				</div>
				<div class="clear"></div>
			</div>
		</div>
	{/if}
	
	<div class="col_12">
		<div class='simple-box'>
			<div class='title'>{t}Most Copied Pages{/t}</div>
			<div class='content'>
			
				<table class='striped responsive' cellpadding='0' cellspacing='0'>
					<thead> 
						<tr> 
							<th class="header" style="width:65%;text-align:left">{t}Title & URL{/t}</th>
							<th class="header center" style="width:50px">{t}Copies{/t}</th>
							<th class="header center" style="width:150px">{t}Change{/t}</th>
							<th class="header" style="width:150px">{t}Percentage{/t} <span class="icon gray smallest helper" data-icon="i" title="{t}This bar displays the percentage compared to the Average number of Total Copies found on your website{/t}"></span><br></th>
						</tr> 
					</thead>			
					<tbody id='keywordsList'>
						{if !empty($tvars.topCopiesPages)}
							{counter start=0 print=false}
							{foreach from=$tvars.topCopiesPages key=index item=details}
								<tr>
									<td>
										<div class="ellipsify urlTitle">
											<a href="{$details.view_link}" title='{$details.page_title}'>{$details.page_title}</a>
										</div>
										<div class="ellipsify urlDetails">
											{$details.page_url}
										</div>										
									</td>
									<td class='center'>{$details.total_copies}</td>
									<td class='center'>
										{if $details.compare_evolution == 'up'}
											<span title="{t}Increased{/t}" data-icon="~" class="icon large green stats-change-icon"></span>
											<span class="stats-change-text green">(+{$details.compare_percentage}%)</span>
										{elseif $details.compare_evolution == 'down'}
											<span title="{t}Decreased{/t}" data-icon="|" class="icon large red stats-change-icon"></span>
											<span class=""stats-change-text green" red">(-{$details.compare_percentage}%)</span>
										{elseif $details.compare_evolution == 'same'}
											<span title="{t}Constant{/t}" data-icon="-" class="icon gray stats-change-icon"></span>
											<span class=""stats-change-text green" gray">({$details.compare_percentage}%)</span>
										{/if}
									</td>	
									<td class='alignCenter'>
										<div class="percentageBar">
											<div class="percentageBarInside blue" style="width:{$details.percentage}%;"></div>
										</div>
										{$details.percentage}%
									</td>
								</tr>
							{/foreach}
						{else}
							<tr>
								<td colspan='5' align='center'>
									<div class="col_12 center">{t}No copies detected so far{/t}</div>
								</td>
							</tr>
						{/if}
					</tbody>
				</table>
			
				<div class="clear"></div>
			</div>
			<div class="clear"></div>
		</div>
	</div>
	
</div>