<?php
class OS_APP_CopyDetector_typeView_Content
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
	
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		$osProject = $OS->getProject();
		
		$copyDetectorOps = OS_APP_copydetector_CopyOperations::get_instance();
		
		$project_id = $osProject->id;
		
		//get copies by type
		
		//get gobal timeframe
		$osTimeframe = $OS->getTimeframe();
		$timeframe = $osTimeframe->getTimeframe();
		$start_d = $timeframe['first'];
		$end_d = $timeframe['last'];
				
		//cache results
		$cache_key = md5('copydetector'.$project_id.$start_d.$end_d.'typeview_content'); 
		$osCache = $OS->getCache();
		
		$viewDataVars = $osCache->get($cache_key);
		if($viewDataVars === false)
		{
			$copiesTimeframeByType = $copyDetectorOps->getCopiesTimeframeByType($project_id, $start_d, $end_d, 'content');
			if(!empty($copiesTimeframeByType))
			{
				$viewDataVars['copiesTimeframeByType'] = $copiesTimeframeByType;
			}
			
			$totalCopiesByType = $copyDetectorOps->getTotalCopiesByType($project_id, $start_d, $end_d);
			if(isset($totalCopiesByType['content']))
			{
				$viewDataVars['totalCopiesByType']['content'] = $totalCopiesByType['content'];
				$viewDataVars['totalCopiesByType']['total'] = $totalCopiesByType['total'];	
			}
			
			$topContentCopies = $copyDetectorOps->getTopCopiesByType($project_id, $start_d, $end_d, 'content');
			if(!empty($topContentCopies))
			{
				$viewDataVars['topContentCopies'] = $topContentCopies;
			}
			
			$contentCopiesByTime = $copyDetectorOps->getLatestCopiesByType($project_id, $start_d, $end_d, 'content');
			
			if(!empty($contentCopiesByTime))
			{
				$viewDataVars['contentCopiesByTime'] = $contentCopiesByTime;
			}
			
			$osCache->set($cache_key, $viewDataVars);
		}
		
		return $viewDataVars;
	}
	
	
	public function render()
	{
		$OS = getOS();
		
		$tplVars = array();
		
		$headContents = array();
		
		$viewData = $this->buildViewData();
		
		$osCharts = $OS->getCharts();
		
		$copyDetectorOps = OS_APP_copydetector_CopyOperations::get_instance();
		
		if(!empty($viewData['copiesTimeframeByType']))
		{
			foreach ($viewData['copiesTimeframeByType'] as $day => $copies)
			{
				$chartValues[] = $copies;
				if (date('N',strtotime($day)) == 6)
				{
					$chartLabels[] = date('d M', strtotime($day));
				}
				else
				{
					$chartLabels[] = false;
				}
				$chartTooltips[] = date('d M', strtotime($day))."\n{$copies} "._("copies");
			}
			
			$chartOptions = array(
				'values' => array_values($chartValues),
				'labels' => $chartLabels,
				'tooltips' => $chartTooltips,
				'fill' => true,
				'normalize' => true
			);
			
			$chartData = $osCharts->getLineChart($chartOptions);
			
			$tplVars['timeframe_chart_html'] = $chartData['html'];
			
			$headContents = array_merge($headContents, $chartData['js']);
		}		
		
		
		if(!empty($viewData['totalCopiesByType']))
		{
			$contentData = $viewData['totalCopiesByType']['content'];
			$totalContentData = $viewData['totalCopiesByType']['total'];
			
			$chartOptions = array(
				'radius' => 50,
				'values' => array($contentData['percentage'], (100-$contentData['percentage'])),
				'colors' => array('#c13a32', '#3498db')
				);
				
			$tplVars['pie_chart_values'] = array(
				'text_copies' => array(
					'title' =>  _("Text Copies"),
					'legend_custom_color' => '#C13A32',
					'percentage' => $contentData['percentage'],
					'total' => $contentData['total_copies'],
					'compare_percentage' => $contentData['compare_percentage'],
					'compare_evolution' => $contentData['compare_evolution'],
				),
				'other_copies' => array(
					'title' => _("Other Copies"),
					'legend_custom_color' => '#3498db',
					'percentage' =>  (100 - $contentData['percentage']),
					'total' => ($totalContentData['total_copies'] - $contentData['total_copies']),
				)
			);
				
			$chartData = $osCharts->getPieChart($chartOptions);

			$tplVars['pie_chart_html'] = $chartData['html'];
		
			$headContents = array_merge($headContents, $chartData['js']);
		}

		if(!empty($viewData['topContentCopies']))
		{
			$tplVars['topContentCopies'] = $viewData['topContentCopies'];
		}
		
		if(!empty($viewData['contentCopiesByTime']))
		{
			foreach($viewData['contentCopiesByTime'] as $index => $details)
			{
				$copy_ts = strtotime($details['copy_dt']);
				
				$tplVars['contentPageCopiesByTime'][$index] = array(
					'page_url' => $details['page_url'],
					'page_title' => $details['page_title'],
					'content_text' => $copyDetectorOps->textTruncate($details['content_text'], 120),
					'content_text_full' => $details['content_text'],
					'copy_dt' => date("d F Y H:i", $copy_ts),
					'copy_dt_human' => date("h:i A \- d M y", $copy_ts),
					'timeago_dt' =>	$copyDetectorOps->timeAgoMin($copy_ts),
					'copy_words' =>  $details['content_words'],
					'country_code_lower' =>  strtolower($details['location_country_code']),
					'country_name' =>  $details['location_country_name']
					);
			}
		}
		
		$headContents['flags.css'] ="<link href='".$OS->getConfigVar('root_url')."/lib/css/flags.css' rel='stylesheet' type='text/css' />";
		$headContents['jquery-table-expand'] ="<script src='".$OS->getConfigVar('root_url')."/lib/javascript/jquery/jquery.table-expand.js' type='text/javascript'></script>";
		$headContents['activate-table-expand'] = "<script type='text/javascript'>\$(document).ready(function(){\$('.striped.stats').jExpand();});</script>";
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('typeview_content', $tplVars);
	}
}
?>