<?php
class OS_APP_CopyDetector_typeView_Img
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
	
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		$osProject = $OS->getProject();
		
		$copyDetectorOps = OS_APP_copydetector_CopyOperations::get_instance();
		
		$project_id = $osProject->id;
		
		//get copies by type
		
		//get gobal timeframe
		$osTimeframe = $OS->getTimeframe();
		$timeframe = $osTimeframe->getTimeframe();
		$start_d = $timeframe['first'];
		$end_d = $timeframe['last'];
				
		//cache results
		$cache_key = md5('copydetector'.$project_id.$start_d.$end_d.'typeview_img'); 
		$osCache = $OS->getCache();
		
		$viewDataVars = $osCache->get($cache_key);
		if($viewDataVars === false)
		{
			$copiesTimeframeByType = $copyDetectorOps->getCopiesTimeframeByType($project_id, $start_d, $end_d, 'img');
			if(!empty($copiesTimeframeByType))
			{
				$viewDataVars['copiesTimeframeByType'] = $copiesTimeframeByType;
			}
			
			$totalCopiesByType = $copyDetectorOps->getTotalCopiesByType($project_id, $start_d, $end_d);
			if(isset($totalCopiesByType['content']))
			{
				$viewDataVars['totalCopiesByType']['img'] = $totalCopiesByType['link'];
				$viewDataVars['totalCopiesByType']['total'] = $totalCopiesByType['total'];	
			}
			
			$topImgCopies = $copyDetectorOps->getTopCopiesByType($project_id, $start_d, $end_d, 'img');
			
			if(!empty($topImgCopies))
			{
				$viewDataVars['topImgCopies'] = $topImgCopies;
			}
			
			$imageCopiesByTime = $copyDetectorOps->getLatestCopiesByType($project_id, $start_d, $end_d, 'img');
			if(!empty($imageCopiesByTime))
			{
				$viewDataVars['imageCopiesByTime'] = $imageCopiesByTime;
			}
			
			$osCache->set($cache_key, $viewDataVars);
		}	
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS = getOS();
		
		$tplVars = array();
		
		$viewData = $this->buildViewData();
		
		$headContents = array();
		
		$osCharts = $OS->getCharts();
		
		$copyDetectorOps = OS_APP_copydetector_CopyOperations::get_instance();
		
		if(!empty($viewData['copiesTimeframeByType']))
		{
			foreach ($viewData['copiesTimeframeByType'] as $day => $copies)
			{
				$chartValues[] = $copies;
				if (date('N',strtotime($day)) == 6)
				{
					$chartLabels[] = date('d M', strtotime($day));
				}
				else
				{
					$chartLabels[] = false;
				}
				$chartTooltips[] = date('d M', strtotime($day))."\n{$copies} "._("copies");
			}
			
			$chartOptions = array(
				'values' => array_values($chartValues),
				'labels' => $chartLabels,
				'tooltips' => $chartTooltips,
				'fill' => true,
				'normalize' => true
			);
			
			$chartData = $osCharts->getLineChart($chartOptions);
			
			$tplVars['timeframe_chart_html'] = $chartData['html'];
			
			$headContents = array_merge($headContents, $chartData['js']);
		}		
		
		
		if(!empty($viewData['totalCopiesByType']))
		{
			$contentData = $viewData['totalCopiesByType']['img'];
			$totalContentData =  $viewData['totalCopiesByType']['total'];
			
			$chartOptions = array(
				'radius' => 50,
				'values' => array($contentData['percentage'], (100-$contentData['percentage'])),
				'colors' => array('#f1c40f', '#3498db')
				);
				
			$tplVars['pie_chart_values'] = array(
				'text_copies' => array(
					'title' =>  _("Image Copies"),
					'legend_custom_color' => '#f1c40f',
					'percentage' => $contentData['percentage'],
					'total' => $contentData['total_copies'],
					'compare_percentage' => $contentData['compare_percentage'],
					'compare_evolution' => $contentData['compare_evolution'],
				),
				'other_copies' => array(
					'title' => _("Other Copies"),
					'legend_custom_color' => '#3498db',
					'percentage' =>  (100 - $contentData['percentage']),
					'total' => ($totalContentData['total_copies'] - $contentData['total_copies']),
				)
			);
				
			
			$chartData = $osCharts->getPieChart($chartOptions); 
			
			$tplVars['pie_chart_html'] = $chartData['html'];
			
			$headContents = array_merge($headContents, $chartData['js']);
		}

		if(!empty($viewData['topImgCopies']))
		{
			foreach($viewData['topImgCopies'] as $index => $details)
			{
				$img_filename = basename($details['content_url']);
				
				$tplVars['topImgCopies'][$index] = array(
					'img_src' => $details['content_url'],
					'img_filename' => $img_filename,
					'img_title' => $details['content_text'],
					'total_copies' =>  $details['total_copies'],
					'percentage' =>  $details['percentage'],
					'compare_percentage' =>  $details['compare_percentage'],
					'compare_evolution' =>  $details['compare_evolution']
				);
			}
		}
		
		if(!empty($viewData['imageCopiesByTime']))
		{
			foreach($viewData['imageCopiesByTime'] as $index => $details)
			{
				$img_filename = basename($details['content_url']);
				
				$copy_ts = strtotime($details['copy_dt']);
				
				$tplVars['imageCopiesByTime'][$index] = array(
					'page_url' => $details['page_url'],
					'page_title' => $details['page_title'],
					'img_src' => $details['content_url'],
					'img_filename' => $img_filename,
					'img_alt' => $details['content_alt'],
					'img_title' => $details['content_text'],
					'copy_dt' => date("d F Y H:i", $copy_ts),
					'copy_dt_human' => date("h:i A \- d M y", $copy_ts),
					'timeago_dt' =>	$copyDetectorOps->timeAgoMin($copy_ts),
					'country_code_lower' =>  strtolower($details['location_country_code']),
					'country_name' =>  $details['location_country_name']
					);	
			}
		}
		
		$headContents['flags.css'] ="<link href='".$OS->getConfigVar('root_url')."/lib/css/flags.css' rel='stylesheet' type='text/css' />";
		$headContents['jquery-table-expand'] ="<script src='".$OS->getConfigVar('root_url')."/lib/javascript/jquery/jquery.table-expand.js' type='text/javascript'></script>";
		
		$headContents['activate-table-expand'] ="<script type='text/javascript'>
        	\$(document).ready(function(){\$('.striped.stats').jExpand();});
		</script>";
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('typeview_img', $tplVars);
	}
}
?>