<?php
class OS_APPFORK_DuplContent_Generate_Report
{
	public function run($params)
	{
		$result=false;
		
		if (!empty($params[0]))
		{
			$project_id=$params[0];
			
			$similarUrls=(empty($params[1])?10:$params[1]);
			
			$OS=getOS();
			
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($project_id))
			{
				$appOps=$OS->getAppOps();
				$availableApp=$appOps->getAppByName('duplcontent');
				
				if ($appOps->isProjectApp($project_id,$availableApp->id))
				{
					$appHandler=$OS->getAppHandler('duplcontent');
					$app=$appHandler->getAppPlugin();
					$db=$OS->getDb();
					
					$OS->initTimezone($project->timezone);
					
					$dbresult=$db->query("SELECT * FROM ".$app->dbPrefix()."urls WHERE project_id=?",array($project_id));
					while ($url_row=$db->fetchRow($dbresult))
					{
						$skip_ids=array($url_row['id']=>true);
						
						//check if it has a canonical url
						if (!empty($url_row['canonical_url']) AND $url_row['url']!=$url_row['canonical_url'])
						{
							$dbresult_canonical=$db->query("SELECT * FROM ".$app->dbPrefix()."urls WHERE project_id=? AND url=?",array($project_id,$url_row['canonical_url']));
							if ($canonical_row=$db->fetchRow($dbresult_canonical))
							{
								$skip_ids[$canonical_row['id']]=true;
							}
						}
						
						//check if it is a canonical url for other urls
						$dbresult_canonical_reverse=$db->query("SELECT * FROM ".$app->dbPrefix()."urls WHERE project_id=? AND canonical_url=?",array($project_id,$url_row['url']));
						while ($canonical_reverse_row=$db->fetchRow($dbresult_canonical_reverse))
						{
							$skip_ids[$canonical_reverse_row['id']]=true;
						}
						
						//get trigrams and urls containing them
						$trigrams=array();
						$url_trigrams=array();
						
						$dbresult_urltrigrams=$db->query("SELECT * FROM ".$app->dbPrefix()."url_trigrams WHERE url_id=?",array($url_row['id']));
						while ($urltrigram_row=$db->fetchRow($dbresult_urltrigrams))
						{
							$trigram_id=$urltrigram_row['trigram_id'];
							
							$url_trigrams[]=$trigram_id;
							
							$dbresult_matching=$db->query("SELECT * FROM ".$app->dbPrefix()."url_trigrams WHERE trigram_id=?",array($trigram_id));
							while ($matching_row=$db->fetchRow($dbresult_matching))
							{
								if (!isset($skip_ids[$matching_row['url_id']]))
								{
									$trigrams[$trigram_id][]=$matching_row['url_id'];
								}
							}
						}
						
						if ($trigrams)
						{
							$matches=array();
							
							foreach ($trigrams as $trigram_id=>$urls)
							{
								foreach ($urls as $url_id)
								{
									if (empty($matches[$url_id]))
									{
										$matches[$url_id]=0;
									}
									
									$matches[$url_id]++;
								}
							}
							
							foreach ($matches as $url_id=>$actual_matches)
							{
								if ($actual_matches<5)
								{
									unset($matches[$url_id]);
								}
							}
							
							if (!empty($matches))
							{
								arsort($matches);
								
								if (count($matches)>10)
								{
									$matches=array_slice($matches,0,$similarUrls,true);
								}
								
								foreach ($trigrams as $trigram_id=>$urls)
								{
									foreach ($urls as $key=>$url_id)
									{
										if (!isset($matches[$url_id]))
										{
											unset($urls[$key]);
										}
									}
									
									if (empty($urls)) unset($trigrams[$trigram_id]);
								}
								
								$url_trigrams_count=count($url_trigrams);
								
								$max_common_trigrams=reset($matches);
								
								$similarity=round($max_common_trigrams*100/$url_trigrams_count);
								
								$similar_to=array();
								
								foreach ($matches as $url_id=>$actual_matches)
								{
									$dbresult_similar=$db->query("SELECT * FROM ".$app->dbPrefix()."urls WHERE id=?",array($url_id));
									if ($similar_row=$db->fetchRow($dbresult_similar))
									{
										$similar_to[]=array(
											'id'=>$similar_row['id'],
											'url'=>$similar_row['url'],
											'url_title'=>$similar_row['url_title'],
											'similarity'=>round($actual_matches*100/$url_trigrams_count)
										);
									}
								}
								
								if ($similarity==0)
								{
									$similarity_group=1;
								}
								else
								{
									$similarity_group=ceil($similarity/25);
								}
								
								$db->query("UPDATE ".$app->dbPrefix()."urls SET `similarity`=?,`similarity_group`=?,`similar_to`=? WHERE id=?",array($similarity,$similarity_group,json_encode($similar_to),$url_row['id']));
							}
						}
					}
					
					$urlOps=$app->getUrlOps();
					
					$urlCounts=$urlOps->getUrlsCounts($project_id);
		
					$report=$app->getReport();
					
					$report->project_id=$project_id;
					$report->urls_group_1=$urlCounts[1];
					$report->urls_group_2=$urlCounts[2];
					$report->urls_group_3=$urlCounts[3];
					$report->urls_group_4=$urlCounts[4];
					$report->report_dt=date('Y-m-d H:i:s');
					
					if ($report->save())
					{
						$result=true;
					}
				}
			}
		}
		
		return $result;
	}
}
?>