<?php
class OS_APP_DuplContent_Report
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $urls_group_1;
	public $urls_group_2;
	public $urls_group_3;
	public $urls_group_4;
	public $report_dt;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_DuplContent_Report();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=false;
		$this->project_id=0;
		$this->urls_group_1=0;
		$this->urls_group_2=0;
		$this->urls_group_3=0;
		$this->urls_group_4=0;
		$this->report_dt='';
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$ops=getOS()->getAppHandler()->getAppPlugin()->getReportOps();
		if (!$this->id)
			{
			if (!$this->id=$ops->insertReport($this)) return false;
			return true;
			}
		else return $ops->updateReport($this);
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getReportOps();
			
			if ($data=$ops->getReportByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$db=getOS()->getDb();
		
		$report_arr=array(
			'id'=>$this->id,
			'urls_group_1'=>$this->urls_group_1,
			'urls_group_2'=>$this->urls_group_2,
			'urls_group_3'=>$this->urls_group_3,
			'urls_group_4'=>$this->urls_group_4,
			'report_dt'=>$this->report_dt,
			'report_dt_human'=>$utils->humanizeDate($this->report_dt)
		);
		
		return $report_arr;
	}
}
?>