<?php
class OS_APP_DuplContent_ReportOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_DuplContent_ReportOperations();
		}
		
		return self::$_instance;
	}
	
	public function getReportByID($report_id)
	{
		$result=false;
		
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE id=? AND project_id=?",array($report_id,$project->id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_DuplContent_Report();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getReports($offset=0,$count=10)
	{
		$result=false;
		
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE project_id=? ORDER BY `report_dt` DESC LIMIT {$offset},{$count}";
		
		$dbresult=$db->query($query,array($project->id));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneReport=new OS_APP_DuplContent_Report();
			$oneReport->set($row);
			
			$result[$row['id']]=$oneReport;
		}
		
		return $result;
	}
	
	public function insertReport($report)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."reports (project_id,urls_group_1,urls_group_2,urls_group_3,urls_group_4,report_dt) VALUES (?,?,?,?,?,?)";
		$dbresult=$db->query($query,array($report->project_id,$report->urls_group_1,$report->urls_group_2,$report->urls_group_3,$report->urls_group_4,$report->report_dt));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateReport($report)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE id=? AND project_id=?";
		$dbresult=$db->query($query,array($report->id,$report->project_id));
		if ($report_row=$db->fetchRow($dbresult))
		{
			$query="UPDATE ".$appHandler->dbPrefix()."reports SET urls_group_1=?,urls_group_2=?,urls_group_3=?,urls_group_4=?,report_dt=? WHERE id=?";
			$dbresult=$db->query($query,array($report->urls_group_1,$report->urls_group_2,$report->urls_group_3,$report->urls_group_4,$report->report_dt,$report->id));
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
}
?>