<?php
class OS_APP_DuplContent_Url
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $url;
	public $url_title;
	public $canonical_url;
	public $similarity;
	public $similarity_group;
	public $similar_to;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_DuplContent_Url();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=false;
		$this->project_id=0;
		$this->url='';
		$this->similarity=0;
		$this->similarity_group=0;
		$this->similar_to=array();
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$ops=getOS()->getAppHandler()->getAppPlugin()->getUrlOps();
		if (!$this->id)
			{
			if (!$this->id=$ops->insertUrl($this)) return false;
			return true;
			}
		else return $ops->updateUrl($this);
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getUrlOps();
			
			if ($data=$ops->getUrlByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function loadByUrl()
	{
		$result = false;
		
		if ($this->url)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getUrlOps();
			
			if ($data=$ops->getUrlByUrl($this->url))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$db=getOS()->getDb();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$similar_to=array();
		
		foreach ($this->similar_to as $dummy=>$url)
		{
			$similar_to[$dummy]=array(
				'url'=>$url['url'],
				'url_safe'=>$utils->getSafeURL($url['url']),
				'similarity'=>$url['similarity']
			);
		}
		
		$similarityColors=array(1=>'green',2=>'yellow',3=>'orange',4=>'red');
		
		$url_arr=array(
			'id'=>$this->id,
			'url'=>$this->url,
			'url_safe'=>$utils->getSafeURL($this->url),
			'url_title'=>$this->url_title,
			'canonical_url'=>$this->canonical_url,
			'canonical_url_safe'=>$utils->getSafeURL($this->canonical_url),
			'similarity'=>$this->similarity,
			'similarity_group'=>$this->similarity_group,
			'similarity_color'=>$similarityColors[$this->similarity_group],
			'similar_to'=>$similar_to,
			'details_url'=>$app->getAppActionUrl('view_details',array('url_id'=>$this->id))
		);
		
		return $url_arr;
	}
}
?>