<?php
class OS_APP_DuplContent_UrlOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_DuplContent_UrlOperations();
		}
		
		return self::$_instance;
	}
	
	public function getUrlByID($url_id)
	{
		$result=false;
		
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."urls WHERE id=? AND project_id=?",array($url_id,$project->id));
		if ($row=$db->fetchRow($dbresult))
		{
			if (empty($row['similar_to']))
			{
				$row['similar_to']=array();
			}
			else
			{
				$row['similar_to']=json_decode($row['similar_to'],true);
			}
			
			$result=new OS_APP_DuplContent_Url();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getUrlByUrl($url)
	{
		$result=false;
		
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."urls WHERE project_id=? AND url=?",array($project->id,$url));
		if ($row=$db->fetchRow($dbresult))
		{
			if (empty($row['similar_to']))
			{
				$row['similar_to']=array();
			}
			else
			{
				$row['similar_to']=json_decode($row['similar_to'],true);
			}
			
			$result=new OS_APP_DuplContent_Url();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getUrls($offset=0,$count=10,$similarity_group=false)
	{
		$result=false;
		
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."urls WHERE project_id=?".($similarity_group?" AND similarity_group=?":'')." ORDER BY `similarity` DESC LIMIT {$offset},{$count}";
		if ($similarity_group)
		{
			$query_params=array($project->id,$similarity_group);
		}
		else
		{
			$query_params=array($project->id);
		}
		
		$dbresult=$db->query($query,$query_params);
		while ($row=$db->fetchRow($dbresult))
		{
			if (empty($row['similar_to']))
			{
				$row['similar_to']=array();
			}
			else
			{
				$row['similar_to']=json_decode($row['similar_to'],true);
			}
			
			$oneUrl=new OS_APP_DuplContent_Url();
			$oneUrl->set($row);
			
			$result[$row['id']]=$oneUrl;
		}
		
		return $result;
	}
	
	public function getUrlsCounts($project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT COUNT(id) AS urls,similarity_group FROM ".$appHandler->dbPrefix()."urls WHERE project_id=? GROUP BY similarity_group",array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			if ($row['similarity_group']=='0')
			{
				$row['similarity_group']=1;
			}
			
			$result[$row['similarity_group']]=$row['urls'];
		}
		
		$actual_groups=array(1,2,3,4);
		
		if (!$result)
		{
			$result=array();
		}
		
		foreach ($actual_groups as $group)
		{
			if (!isset($result[$group]))
			{
				$result[$group]=0;
			}
		}
		
		ksort($result);
		
		return $result;
	}
}
?>