<?php
class OS_APPVIEW_DuplContent_Url extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$ops=OS_APP_DuplContent_UrlOperations::get_instance();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		$viewDataVars=array();
		
		if ($viewDataVars['url']=$ops->getUrlByID($requestParams['url_id']))
		{
			$backUrlSettings['page']=(empty($requestParams['page'])?1:$requestParams['page']);
			
			if (!empty($requestParams['similarity_group']))
			{
				$backUrlSettings['similarity_group']=$requestParams['similarity_group'];
			}
			
			$viewDataVars['backUrlSettings']=$backUrlSettings;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['url_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$viewData=$this->buildViewData();
		
		if (!$viewData['url'])
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$utils=$OS->getUtils();
		
		$tplVars=array('back_url'=>$appPlugin->getAppActionUrl('view',$viewData['backUrlSettings']),'similar_urls'=>array(),'current_url'=>$viewData['url']->url,'current_url_safe'=>$utils->getSafeURL($viewData['url']->url));
		
		$similarityColors=array(1=>'green',2=>'yellow',3=>'orange',4=>'red');
		
		foreach ($viewData['url']->similar_to as $similar_url)
		{
			$tplVars['similar_urls'][]=array(
				'url'=>$similar_url['url'],
				'url_safe'=>$utils->getSafeURL($similar_url['url']),
				'url_title'=>$similar_url['url_title'],
				'details_url'=>$appPlugin->getAppActionUrl('url',array_merge($viewData['backUrlSettings'],array('url_id'=>$similar_url['id']))),
				'similarity'=>$similar_url['similarity'],
				'similarity_group'=>ceil($similar_url['similarity']/25),
				'similarity_color'=>$similarityColors[ceil($similar_url['similarity']/25)]
			);
		}
		
		$headContents['css']['duplcontent']=$appPlugin->getAppHomeUrl()."/resources/style.css";
		
		$tpl=$OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('view_details',$tplVars);
	}
}
?>