<?php
class OS_APPFORK_DuplContent2_Generate_Report
{
	public $minDifferentBits=1;
	
	public function run($params)
	{
		$result=false;
		
		if (!empty($params[0]))
		{
			$project_id=$params[0];
			
			$similarUrls=(empty($params[1])?10:$params[1]);
			
			$OS=getOS();
			
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($project_id))
			{
				$appOps=$OS->getAppOps();
				$availableApp=$appOps->getAppByName('duplcontent2');
				
				if ($appOps->isProjectApp($project_id,$availableApp->id))
				{
					$appHandler=$OS->getAppHandler('duplcontent2');
					$app=$appHandler->getAppPlugin();
					$db=$OS->getDb();
					
					$OS->initTimezone($project->timezone);
					
					$dbresult=$db->query("SELECT * FROM ".$app->dbPrefix()."hashes WHERE project_id=?",array($project_id));
					while ($hash_row=$db->fetchRow($dbresult))
					{
						$dbresult_url=$db->query("SELECT * FROM ".$db->dbPrefix()."projects_urls WHERE id=?",array($hash_row['url_id']));
						if ($url_row=$db->fetchRow($dbresult_url))
						{
							$skip_ids=array($url_row['id']);
							
							if (!empty($url_row['canonical_url']))
							{
								$dbresult_canonical=$db->query("SELECT * FROM ".$db->dbPrefix()."projects_urls WHERE project_id=? AND url=?",array($project_id,$url_row['canonical_url']));
								if ($canonical_url=$db->fetchRow($dbresult_canonical))
								{
									$skip_ids[]=$canonical_url['id'];
								}
							}
							
							$dbresult_revcanonical=$db->query("SELECT * FROM ".$db->dbPrefix()."projects_urls WHERE project_id=? AND canonical_url=?",array($project_id,$url_row['url']));
							while ($revcanonical_row=$db->fetchRow($dbresult_revcanonical))
							{
								$skip_ids[]=$revcanonical_row['id'];
							}
							
							$similars=array();
							
							$dbresult_similar=$db->query("SELECT url_id,BIT_COUNT(? ^ simhash_dec) AS hamming_distance FROM ".$app->dbPrefix()."hashes WHERE project_id=? AND ".(count($skip_ids)==1?"url_id<>".reset($skip_ids):"NOT url_id IN (".implode(',',$skip_ids).")")." HAVING hamming_distance < ? ORDER BY hamming_distance ASC LIMIT 10",array($hash_row['simhash_dec'],$project_id,$this->minDifferentBits));
							while ($similar_row=$db->fetchRow($dbresult_similar))
							{
								$similars[$similar_row['url_id']]=$similar_row['hamming_distance'];
							}
							
							if ($similars)
							{
								$db->query("UPDATE ".$app->dbPrefix()."hashes SET similars=? WHERE url_id=?",array(json_encode($similars),$hash_row['url_id']));
							}
							elseif (!empty($hash_row['similars']))
							{
								$db->query("UPDATE ".$app->dbPrefix()."hashes SET similars='' WHERE url_id=?",array($hash_row['url_id']));
							}
						}
					}
				}
			}
		}
		
		return $result;
	}
}
?>