<?php
class OS_APPFORK_DuplPages_Generate_Report
{
	public $maxDifferentBits=5;
	
	public function run($params)
	{
		$result=false;

		if (!empty($params[0]))
		{
			$project_id=$params[0];
			
			$OS=getOS();
			
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($project_id) AND $project->isActive())
			{
				$appOps=$OS->getAppOps();
				$availableApp=$appOps->getAppByName('duplpages');
				
				if ($appOps->isProjectApp($project_id,$availableApp->id))
				{
					$appHandler=$OS->getAppHandler('duplpages');
					$app=$appHandler->getAppPlugin();
					$db=$OS->getDb();
					
					$OS->initTimezone($project->timezone);
					
					$dbresult=$db->query("SELECT * FROM ".$app->dbPrefix()."urls WHERE project_id=?",array($project_id));
					while ($hash_row=$db->fetchRow($dbresult))
					{
						$dbresult_url=$db->query("SELECT * FROM ".$db->dbPrefix()."projects_urls WHERE project_id=? AND url_hash=?",array($project_id,$hash_row['url_hash']));
						if ($url_row=$db->fetchRow($dbresult_url))
						{
							$similars=array();
							
							$dbresult_similar=$db->query("SELECT url_hash,BIT_COUNT(b? ^ simhash_dec) AS hamming_distance FROM ".$app->dbPrefix()."urls WHERE project_id=? AND url_hash<>? HAVING hamming_distance <= ? ORDER BY hamming_distance ASC",array($hash_row['simhash'],$project_id,$hash_row['url_hash'],$this->maxDifferentBits));
							while ($similar_row=$db->fetchRow($dbresult_similar))
							{
								$similars[$similar_row['url_hash']]=$similar_row['hamming_distance'];
							}
							
							if ($similars)
							{
								$db->query("UPDATE ".$app->dbPrefix()."urls SET similars=?,similars_count=? WHERE id=?",array(json_encode($similars),count($similars),$hash_row['id']));
							}
							elseif (!empty($hash_row['similars']))
							{
								$db->query("UPDATE ".$app->dbPrefix()."urls SET similars='',similars_count=0 WHERE id=?",array($hash_row['id']));
							}
						}
					}
				}
			}
		}
		
		return $result;
	}
}
?>