<?php
class OS_APP_DuplPages_Cluster
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $main_url;
	public $main_url_hash;
	public $urls;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_DuplPages_Cluster();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		
		$this->main_url='';
		$this->main_url_hash='';
		$this->urls=0;
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_DuplPages_ClusterOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertCluster($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateCluster($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_DuplPages_ClusterOperations::get_instance();
			
			if ($data=$ops->getClusterByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_DuplPages_ClusterOperations::get_instance();
			
			$result=$ops->deleteClusterByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$result=array(
			'id'=>$this->id,
			'main_url'=>$this->main_url,
			'urls'=>$this->urls,
			'_details_url'=>$app->getAppActionUrl('cluster',array('cluster_id'=>$this->id))
		);
		
		return $result;
	}
}
?>