<?php
class OS_APP_DuplPages_ClusterOperations
{
	private static $_instance;
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_DuplPages_ClusterOperations();
		}
		
		return self::$_instance;
	}
	
	public function getClusterByID($cluster_id,$project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$osProject=getOS()->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."clusters WHERE id=? AND project_id=?",array($cluster_id,$project_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_DuplPages_Cluster();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getClustersCount($project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$osProject=getOS()->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT COUNT(*) AS total_clusters FROM ".$appHandler->dbPrefix()."clusters WHERE project_id=?",array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$result=$row['total_clusters'];
		}
		
		return $result;
	}
	
	public function getClusters($project_id=false,$offset=0,$limit=10,$order_by='urls')
	{
		$result=false;
		
		if (!$project_id)
		{
			$osProject=getOS()->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."clusters WHERE project_id=? ORDER BY `{$order_by}` DESC LIMIT {$offset},{$limit}",array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneCluster=new OS_APP_DuplPages_Cluster();
			$oneCluster->set($row);
			
			$result[$row['id']]=$oneCluster;
		}
		
		return $result;
	}
	
	public function insertCluster($cluster)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."clusters (project_id,main_url,main_url_hash,urls) VALUES (?,?,?,?)";
		$dbresult=$db->query($query,array($cluster->project_id,$cluster->main_url,$cluster->main_url_hash,$cluster->urls));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateCluster($cluster)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="UPDATE ".$appHandler->dbPrefix()."clusters SET urls=? WHERE id=?";
		$dbresult=$db->query($query,array($cluster->urls,$cluster->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteClusterByID($cluster_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."clusters WHERE id=?";
		$dbresult=$db->query($query,array($cluster_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteClustersByProjectID($project_id=false)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		if (!$project_id)
		{
			$osProject=$OS->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."clusters WHERE project_id=?";
		$dbresult=$db->query($query,array($project_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
}
?>