<?php
class OS_APP_DuplPages_ReportOperations
{
	private static $_instance;
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_DuplPages_ReportOperations();
		}
		
		return self::$_instance;
	}
	
	public function getReportByID($report_id,$project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE id=? AND project_id=?",array($report_id,$project_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_DuplPages_Report();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getReports($project_id=false,$offset=0,$limit=10,$order_by='report_dt')
	{
		$result=false;
		
		if (!$project_id)
		{
			$osProject=getOS()->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE project_id=? ORDER BY `{$order_by}` DESC LIMIT {$offset},{$limit}",array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneReport=new OS_APP_DuplPages_Report();
			$oneReport->set($row);
			
			$result[$row['id']]=$oneReport;
		}
		
		return $result;
	}
	
	public function insertReport($report)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		if (empty($report->report_dt))
		{
			$report->report_dt=$db->DBTimeStamp(time());
		}
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."reports (project_id,urls,unique_urls,duplication_clusters,report_dt) VALUES (?,?,?,?,?)";
		$dbresult=$db->query($query,array($report->project_id,$report->urls,$report->unique_urls,$report->duplication_clusters,$report->report_dt));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateReport($report)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="UPDATE ".$appHandler->dbPrefix()."reports SET urls=?,unique_urls=?,duplication_clusters=? WHERE id=?";
		$dbresult=$db->query($query,array($report->urls,$report->unique_urls,$report->duplication_clusters,$report->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteReportByID($report_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."reports WHERE id=?";
		$dbresult=$db->query($query,array($report_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteDataByProjectID($project_id)
	{
		$result=true;
		
		$tables=array('reports','urls','clusters');
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		foreach ($tables as $table)
		{
			$dbresult=$db->query("DELETE FROM ".$appHandler->dbPrefix().$table." WHERE project_id=?",array($project_id));
			
			if ($dbresult===false)
			{
				$result=false;
				break;
			}
		}
		
		return $result;
	}
}
?>