<?php
class OS_APP_DuplPages_Url
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $url;
	public $url_hash;
	public $simhash;
	public $status;
	public $cluster_id;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_DuplPages_Url();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		
		$this->url='';
		$this->url_hash='';
		$this->simhash='';
		$this->status='U';
		$this->cluster_id=0;
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_DuplPages_UrlOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertUrl($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateUrl($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_DuplPages_UrlOperations::get_instance();
			
			if ($data=$ops->getUrlByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_DuplPages_UrlOperations::get_instance();
			
			$result=$ops->deleteUrlByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$osUtils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$statuses=array('U'=>_('Unique'),'O'=>_('Original'),'C'=>_('Copy'));
		
		return array(
			'id'=>$this->id,
			'url'=>$this->url,
			'url_hash'=>$this->url_hash,
			'url_safe'=>$osUtils->getSafeURL($this->url),
			'status'=>$this->status,
			'status_human'=>$statuses[$this->status],
			'inlinks_url'=>$app->getAppActionUrl('inlinks',array('cluster_id'=>$this->cluster_id,'url_hash'=>$this->url_hash))
		);
	}
}
?>