<?php
class OS_APPVIEW_DuplPages_Cluster extends OS_AppViewBase
{
	public $urlsPerPage=10;
	
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$requestParams=$appPlugin->getRequestParams();
		
		$valid=false;
		if (!empty($requestParams['cluster_id']))
		{
			$ops=OS_APP_DuplPages_ClusterOperations::get_instance();

			if ($cluster=$ops->getClusterByID($requestParams['cluster_id'],$osProject->id))
			{
				$urlOps=OS_APP_DuplPages_UrlOperations::get_instance();
		
				if ($processedRequest['urlsCount']=$urlOps->getUrlsCountByClusterID($cluster->id))
				{
					$valid=true;
				}
			}
		}
		
		if (!$valid)
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('main'),true);
		}
		
		$processedRequest['cluster']=$cluster;
		$processedRequest['page']=1;
		
		if (!empty($requestParams['page']) AND ($requestParams['page']>0) AND (($requestParams['page']-1)*$this->urlsPerPage<$processedRequest['urlsCount']))
		{
			$processedRequest['page']=$requestParams['page'];
		}
		
		return $processedRequest;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewDataVars=array();
		
		$viewDataVars['cluster']=$this->processedRequest['cluster'];
		
		$urlOps=OS_APP_DuplPages_UrlOperations::get_instance();
		
		$viewDataVars['urlsCount']=$this->processedRequest['urlsCount'];
		
		$viewDataVars['urls']=$urlOps->getUrlsByClusterID($this->processedRequest['cluster']->id,($this->processedRequest['page']-1)*$this->urlsPerPage,$this->urlsPerPage);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		
		$tplVars=array();
		
		foreach ($viewData['urls'] as $url_id=>$url)
		{
			$tplVars['urls'][$url_id]=$url->toTemplate();
		}
		
		if ($this->processedRequest['page']>1)
		{
			$tplVars['prev_page_url']=$appPlugin->getAppActionUrl('cluster',array('cluster_id'=>$this->processedRequest['cluster']->id,'page'=>$this->processedRequest['page']-1));
		}
		else
		{
			$tplVars['prev_page_url']=false;
		}
		
		if (($this->processedRequest['page']*$this->urlsPerPage)<$viewData['urlsCount'])
		{
			$tplVars['next_page_url']=$appPlugin->getAppActionUrl('cluster',array('cluster_id'=>$this->processedRequest['cluster']->id,'page'=>$this->processedRequest['page']+1));
		}
		else
		{
			$tplVars['next_page_url']=false;
		}
		
		$appPlugin->setMenuBackLink(array('back_view'=>'view'));
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('cluster',$tplVars);
	}
}
?>