<?php
class OS_APPVIEW_DuplPages_Inlinks extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$requestParams=$appPlugin->getRequestParams();
		
		$valid=false;
		if (!empty($requestParams['cluster_id']))
		{
			$clusterOps=OS_APP_DuplPages_ClusterOperations::get_instance();

			if ($cluster=$clusterOps->getClusterByID($requestParams['cluster_id'],$osProject->id))
			{
				$urlOps=OS_APP_DuplPages_UrlOperations::get_instance();
				$valid=true;
			}
		}
		
		if (!$valid)
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if (empty($requestParams['url_hash']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('cluster',array('cluster_id'=>$cluster->id)),true);
		}
		
		if (!$url=$urlOps->getUrlByUrlHash($requestParams['url_hash'],$osProject->id))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('cluster',array('cluster_id'=>$cluster->id)),true);
		}
		
		$processedRequest['cluster']=$cluster;
		$processedRequest['url']=$url;
		
		return $processedRequest;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewDataVars=array();
		
		$viewDataVars['cluster']=$this->processedRequest['cluster'];
		$viewDataVars['url']=$this->processedRequest['url'];
		
		$db=$OS->getDb();
		$osUtils=$OS->getUtils();
		
		$viewDataVars['links']=array();
		
		$dbresult=$db->query("SELECT from_url,SUM(occurances) AS total_occurances FROM ".$db->dbPrefix()."projects_urls_links WHERE project_id=? AND to_url_hash=? GROUP BY from_url ORDER BY total_occurances DESC",array($osProject->id,$viewDataVars['url']->url_hash));
		while ($row=$db->fetchRow($dbresult))
		{
			$viewDataVars['links'][$row['from_url']]=array(
				'url_safe'=>$osUtils->getSafeURL($row['from_url']),
				'occurances'=>$row['total_occurances']
			);
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		
		$tplVars=array(
			'cluster'=>$viewData['cluster']->toTemplate(),
			'url'=>$viewData['url']->toTemplate(),
			'links'=>$viewData['links']
		);
		
		$appPlugin->setMenuBackLink(array('back_view'=>'cluster','cluster_id'=>$viewData['cluster']->id));
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('inlinks',$tplVars);
	}
}
?>