<?php
class OS_APPVIEW_DuplPages_Report extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_DuplPages_ReportOperations::get_instance();
		
		$viewDataVars=array('report'=>false);
		
		if ($report=$ops->getReports($project->id,0,1))
		{
			$report=reset($report);
			
			$osUtils=$OS->getUtils();
			
			$reportData=array(
				'filename'=>'duplication_overview.pdf',
				'title'=>_('Duplication Overview'),
				'sections'=>array()
			);
			
			$reportData['sections']['overview']=array(
				'title'=>_("Overview"),
				'icon'=>false,
				'type'=>'messages',
				'messages'=>array(
					array(
						'type'=>'label_value',
						'label'=>array(
							'text'=>_("Total URLs")
						),
						'value'=>array(
							'text'=>$report->urls
						),
					),
					array(
						'type'=>'label_value',
						'label'=>array(
							'text'=>_("Uniqueness")
						),
						'value'=>array(
							'text'=>round($report->unique_urls*100/$report->urls,2).'%'
						),
					),
					array(
						'type'=>'label_value',
						'label'=>array(
							'text'=>_("Unique URLs")
						),
						'value'=>array(
							'text'=>$report->unique_urls
						),
					),
					array(
						'type'=>'label_value',
						'label'=>array(
							'text'=>_("Duplication clusters")
						),
						'value'=>array(
							'text'=>$report->duplication_clusters
						),
					),
					array(
						'type'=>'label_value',
						'label'=>array(
							'text'=>_("Duplicate URLs")
						),
						'value'=>array(
							'text'=>$report->urls-$report->unique_urls
						),
					)
				)
			);
			
			if ($report->duplication_clusters>0)
			{
				$clusterOps=OS_APP_DuplPages_ClusterOperations::get_instance();
				
				if ($clusters=$clusterOps->getClusters())
				{
					$clusters_text='';
					
					foreach ($clusters as $cluster)
					{
						$clusters_text.="{$cluster->main_url} [{$cluster->urls} "._("URLs in cluster")."]\n";
					}
					
					$reportData['sections']['clusters']=array(
						'title'=>($report->duplication_clusters>10?_("Top 10 Duplication clusters"):_("Duplication clusters")),
						'icon'=>false,
						'type'=>'bulk_text',
						'text'=>$clusters_text
					);
				}
			}
			
			$viewDataVars['report']=$reportData;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$viewData=$this->buildViewData();
		
		if ($viewData['report'])
		{
			$osReport=$OS->getReport();
			
			$osReport->generateReport($viewData['report']);
		}
		else
		{
			return $OS->getTemplate()->fetchTemplate('report');
		}
	}
}
?>