<?php
class OS_APPCRON_Incomingkws_buffer_to_sql
{
	public function run()
	{
		$OS=getOS();
		$db=$OS->getDb();
		$projectOps=$OS->getProjectOps();
		$appHandler=$OS->getAppHandler('incomingkws');
		$app=$appHandler->getAppPlugin();
		$app_ops=$app->getOperations();
		
		$current_log=floor(time()/3600);
		$logs_path=os_join_path($appHandler->getAppStoragePath(),'buffer');
		
		$ctime=time();
		$files=glob($logs_path.'/*.log');
		$keywords=array();
		$keyword_to_id=array();
		$stats=array();
		$project_timezones=array();
		
		foreach ($files as $file_id=>$file)
		{
			$filename=basename($file,'.log');
			if ((int)$filename<$current_log)
			{
				rename($file,$file.'.old');
				$file.='.old';
				
				if ($file_handler=fopen($file,'r'))
				{
					while (!feof($file_handler))
					{
						if ($line=fgets($file_handler))
						{
							$line=explode('|',$line);
							
							if ($line[1]=base64_decode($line[1]) AND $line[1]=urldecode($line[1]))
							{
								if (!isset($project_timezones[$line[0]]))
								{
									if ($project=$projectOps->getProjectByID($line[0]))
									{
										$timezone=$project->timezone;
									}
									else
									{
										$timezone='UTC';
									}
									
									$project_timezones[$line[0]]=$timezone;
								}
								
								$OS->initTimezone($project_timezones[$line[0]]);
								
								if (!isset($keywords[$line[0]][$line[1]]))
								{
									$keyword_path=$app->keywordStoragePath($line[0],$line[1]);
									if (file_exists(os_join_path($keyword_path['dir'],$keyword_path['file'])))
									{
										$keyword_row=json_decode(file_get_contents(os_join_path($keyword_path['dir'],$keyword_path['file'])),true);
									}
									else
									{
										$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE project_id=? AND keyword=?",array($line[0],$line[1]));
										$keyword_row=$db->fetchRow($dbresult);
									}
		
									if ($keyword_row)
									{
										$keyword_id=$keyword_row['id'];
										
										$keyword_to_id[$line[0]][$line[1]]=$keyword_id;
										
										if (date('Y',$ctime)<>$keyword_row['year'])
										{
											$reset='year';
										}
										elseif (date('m',$ctime)<>$keyword_row['month'])
										{
											$reset='month';
										}
										elseif (date('W',$ctime)<>$keyword_row['week'])
										{
											$reset='week';
										}
										elseif (date('Y-m-d',$ctime)<>$keyword_row['day'])
										{
											$reset='day';
										}
										else
										{
											$reset=false;
										}
									}
									else
									{
										$keyword_id=false;
										$reset=false;
									}
									
									$keywords[$line[0]][$line[1]]=array('keyword_id'=>$keyword_id,'keyword_row'=>$keyword_row,'keyword_path'=>$keyword_path,'reset'=>$reset,'total'=>0,'last_time'=>0,'bulk'=>array());
								}
								
								$engine='';$referral='';
								if (!empty($line[4]) AND $line[4]=base64_decode($line[4]) AND $line[4]=urldecode($line[4]))
								{
									$referral=$line[4];
									
									if ($se_details=$app->parseSEReferral($line[4]))
									{
										$engine=$se_details['engine'];
									}
								}
								
								$landing_page='';
								if (!empty($line[5]) AND $line[5]=base64_decode($line[5]))
								{
									$landing_page=$line[5];
								}
								
								$keywords[$line[0]][$line[1]]['total']++;
								$keywords[$line[0]][$line[1]]['last_time']=$line[2];
								$keywords[$line[0]][$line[1]]['bulk'][]=array('time'=>$line[2],'ip'=>$line[3],'engine'=>$engine,'referral'=>$referral,'landing_page'=>$landing_page);
								
								$day=date('Y-m-d',$line[2]);
								
								if (!isset($stats[$line[0]][$day]))
								{
									$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."stats_project WHERE project_id=? AND stats_d=?",array($line[0],$day));
									if ($row=$db->fetchRow($dbresult))
									{
										$stats_id=$row['id'];
									}
									else
									{
										$stats_id=false;
									}
									
									$stats[$line[0]][$day]=array('stats_id'=>$stats_id,'visits'=>0,'keywords'=>array());
								}
								$stats[$line[0]][$day]['visits']++;
								
								if (!isset($stats[$line[0]][$day]['keywords'][$line[1]]))
								{
									if (isset($keyword_to_id[$line[0]][$line[1]]))
									{
										$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."stats_keyword WHERE keyword_id=? AND stats_d=?",array($keyword_to_id[$line[0]][$line[1]],$day));
										if ($row=$db->fetchRow($dbresult))
										{
											$stats_id=$row['id'];
										}
										else
										{
											$stats_id=false;
										}
									}
									else
									{
										$stats_id=false;
									}
									
									$stats[$line[0]][$day]['keywords'][$line[1]]=array('stats_id'=>$stats_id,'visits'=>0);
								}
								$stats[$line[0]][$day]['keywords'][$line[1]]['visits']++;
							}
						}
					}
					
					fclose($file_handler);
				}
			}
			
		}
		
		$db->query("LOCK TABLES ".$appHandler->dbPrefix()."keywords WRITE");
		foreach ($keywords as $project_id=>$actual_keywords)
		{
			$OS->initTimezone($project_timezones[$project_id]);
			
			foreach ($actual_keywords as $keyword=>$details)
			{
				if ($details['keyword_id'])
				{
					$query="UPDATE ".$appHandler->dbPrefix()."keywords SET last_dt=?,";
					if ($details['reset']=='year')
					{
						$query.="visits_day=?,day=?,visits_week=?,week=?,visits_month=?,month=?,visits_year=?,year=? WHERE id=?";
						$query_params=array(date('Y-m-d H:i:s',$ctime),$details['total'],date('Y-m-d',$ctime),$details['total'],date('W',$ctime),$details['total'],date('m',$ctime),$details['total'],date('Y',$ctime),$details['keyword_id']);
						$details['keyword_row']['last_dt']=date('Y-m-d H:i:s',$ctime);
						$details['keyword_row']['visits_day']=$details['total'];
						$details['keyword_row']['day']=date('Y-m-d',$ctime);
						$details['keyword_row']['visits_week']=$details['total'];
						$details['keyword_row']['week']=date('W',$ctime);
						$details['keyword_row']['visits_month']=$details['total'];
						$details['keyword_row']['month']=date('m',$ctime);
						$details['keyword_row']['visits_year']=$details['total'];
						$details['keyword_row']['year']=date('Y',$ctime);
					}
					elseif ($details['reset']=='month')
					{
						$query.="visits_day=?,day=?,visits_week=?,week=?,visits_month=?,month=?,visits_year=visits_year+? WHERE id=?";
						$query_params=array(date('Y-m-d H:i:s',$ctime),$details['total'],date('Y-m-d',$ctime),$details['total'],date('W',$ctime),$details['total'],date('m',$ctime),$details['total'],$details['keyword_id']);
						$details['keyword_row']['last_dt']=date('Y-m-d H:i:s',$ctime);
						$details['keyword_row']['visits_day']=$details['total'];
						$details['keyword_row']['day']=date('Y-m-d',$ctime);
						$details['keyword_row']['visits_week']=$details['total'];
						$details['keyword_row']['week']=date('W',$ctime);
						$details['keyword_row']['visits_month']=$details['total'];
						$details['keyword_row']['month']=date('m',$ctime);
						$details['keyword_row']['visits_year']+=$details['total'];
					}
					elseif ($details['reset']=='week')
					{
						$query.="visits_day=?,day=?,visits_week=?,week=?,visits_month=visits_month+?,visits_year=visits_year+? WHERE id=?";
						$query_params=array(date('Y-m-d H:i:s',$ctime),$details['total'],date('Y-m-d',$ctime),$details['total'],date('W',$ctime),$details['total'],$details['total'],$details['keyword_id']);
						$details['keyword_row']['last_dt']=date('Y-m-d H:i:s',$ctime);
						$details['keyword_row']['visits_day']=$details['total'];
						$details['keyword_row']['day']=date('Y-m-d',$ctime);
						$details['keyword_row']['visits_week']=$details['total'];
						$details['keyword_row']['week']=date('W',$ctime);
						$details['keyword_row']['visits_month']+=$details['total'];
						$details['keyword_row']['visits_year']+=$details['total'];
					}
					elseif ($details['reset']=='day')
					{
						$query.="visits_day=?,day=?,visits_week=visits_week+?,visits_month=visits_month+?,visits_year=visits_year+? WHERE id=?";
						$query_params=array(date('Y-m-d H:i:s',$ctime),$details['total'],date('Y-m-d',$ctime),$details['total'],$details['total'],$details['total'],$details['keyword_id']);
						$details['keyword_row']['last_dt']=date('Y-m-d H:i:s',$ctime);
						$details['keyword_row']['visits_day']=$details['total'];
						$details['keyword_row']['day']=date('Y-m-d',$ctime);
						$details['keyword_row']['visits_week']+=$details['total'];
						$details['keyword_row']['visits_month']+=$details['total'];
						$details['keyword_row']['visits_year']+=$details['total'];
					}
					else
					{
						$query.="visits_day=visits_day+?,visits_week=visits_week+?,visits_month=visits_month+?,visits_year=visits_year+? WHERE id=?";
						$query_params=array(date('Y-m-d H:i:s',$ctime),$details['total'],$details['total'],$details['total'],$details['total'],$details['keyword_id']);
						$details['keyword_row']['last_dt']=date('Y-m-d H:i:s',$ctime);
						$details['keyword_row']['visits_day']+=$details['total'];
						$details['keyword_row']['visits_week']+=$details['total'];
						$details['keyword_row']['visits_month']+=$details['total'];
						$details['keyword_row']['visits_year']+=$details['total'];
					}
					
					$keyword_id=$details['keyword_id'];
				}
				else
				{
					$query="INSERT INTO ".$appHandler->dbPrefix()."keywords (project_id,keyword,visits_day,day,visits_week,week,visits_month,month,visits_year,year,last_dt) VALUES (?,?,?,?,?,?,?,?,?,?,?)";
					$query_params=array($project_id,$keyword,$details['total'],date('Y-m-d',$ctime),$details['total'],date('W',$ctime),$details['total'],date('m',$ctime),$details['total'],date('Y',$ctime),date('Y-m-d H:i:s',$details['last_time']));
					$details['keyword_row']['project_id']=$project_id;
					$details['keyword_row']['keyword']=$keyword;
					$details['keyword_row']['visits_day']=$details['total'];
					$details['keyword_row']['day']=date('Y-m-d',$ctime);
					$details['keyword_row']['visits_week']=$details['total'];
					$details['keyword_row']['week']=date('W',$ctime);
					$details['keyword_row']['visits_month']=$details['total'];
					$details['keyword_row']['month']=date('m',$ctime);
					$details['keyword_row']['visits_year']=$details['total'];
					$details['keyword_row']['year']=date('Y',$ctime);
					$details['keyword_row']['last_dt']=date('Y-m-d H:i:s',$ctime);
				}
				
				$db->query($query,$query_params);
				
				if (!$details['keyword_id'])
				{
					$keyword_id=$db->getInsertId();
					
					$keyword_to_id[$project_id][$keyword]=$keyword_id;
					
					$details['keyword_row']['id']=$keyword_id;
					$details['keyword_id']=$keyword_id;
				}
				
				$keywords[$project_id][$keyword]=$details;
			}
		}
		$db->query("UNLOCK TABLES");
		
		$db->query("LOCK TABLES ".$appHandler->dbPrefix()."stats_project WRITE, ".$appHandler->dbPrefix()."stats_keyword WRITE");
		foreach ($stats as $project_id=>$dates)
		{
			$OS->initTimezone($project_timezones[$project_id]);
			
			foreach ($dates as $date=>$details)
			{
				if ($details['stats_id'])
				{
					$query="UPDATE ".$appHandler->dbPrefix()."stats_project SET visits=visits+? WHERE id=?";
					$query_params=array($details['visits'],$details['stats_id']);
				}
				else
				{
					$query="INSERT INTO ".$appHandler->dbPrefix()."stats_project (project_id,stats_d,visits) VALUES (?,?,?)";
					$query_params=array($project_id,$date,$details['visits']);
				}
				
				$db->query($query,$query_params);
				
				if (!$details['stats_id'])
				{
					$details['stats_id']=$db->getInsertId();
				}
				
				foreach ($details['keywords'] as $keyword=>$keyword_details)
				{
					if ($keyword_details['stats_id'])
					{
						$query="UPDATE ".$appHandler->dbPrefix()."stats_keyword SET visits=visits+? WHERE id=?";
						$query_params=array($keyword_details['visits'],$keyword_details['stats_id']);
					}
					else
					{
						$query="INSERT INTO ".$appHandler->dbPrefix()."stats_keyword (project_id,keyword_id,stats_d,visits) VALUES (?,?,?,?)";
						$query_params=array($project_id,$keyword_to_id[$project_id][$keyword],$date,$keyword_details['visits']);
					}
					
					$db->query($query,$query_params);
					
					if (!$keyword_details['stats_id'])
					{
						$keyword_details['stats_id']=$db->getInsertId();
					}
				}
			}
		}
		$db->query("UNLOCK TABLES");
		
		$db->query("LOCK TABLES ".$appHandler->dbPrefix()."visits WRITE");
		foreach ($keywords as $project_id=>$actual_keywords)
		{
			$OS->initTimezone($project_timezones[$project_id]);
			
			foreach ($actual_keywords as $keyword=>$details)
			{
				foreach ($details['bulk'] as $visit)
				{
					$query="INSERT INTO ".$appHandler->dbPrefix()."visits (project_id,keyword_id,keyword,engine,referral,landing_page,visit_dt,visit_ip) VALUES (?,?,?,?,?,?,?,?)";
					$db->query($query,array($project_id,$details['keyword_id'],$keyword,$visit['engine'],$visit['referral'],$visit['landing_page'],date("Y-m-d H:i:s",$visit['time']),$visit['ip']));
				}
			}
		}
		$db->query("UNLOCK TABLES");
		
		//update/create keyword files
		foreach ($keywords as $project_id=>$actual_keywords)
		{
			$OS->initTimezone($project_timezones[$project_id]);
			
			foreach ($actual_keywords as $keyword=>$details)
			{
				if (!file_exists($details['keyword_path']['dir']))
				{
					mkdir($details['keyword_path']['dir'],0755,true);
				}
				
				file_put_contents(os_join_path($details['keyword_path']['dir'],$details['keyword_path']['file']),json_encode($details['keyword_row']));
			}
		}
		
		return true;
	}
}
?>