<?php
class OS_APP_incomingkws_keyword
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $keyword;
	public $visits_day;
	public $visits_week;
	public $visits_month;
	public $visits_year;
	public $visits_timeframe;
	public $day;
	public $week;
	public $month;
	public $year;
	public $last_dt;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_incomingkws_keyword();
		}
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=false;
		$this->project_id='';
		$this->keyword='';
		$this->visits_day=0;
		$this->visits_week=0;
		$this->visits_month=0;
		$this->visits_year=0;
		$this->visits_timeframe=false;
		$this->day='';
		$this->week=0;
		$this->month='';
		$this->year='';
		$this->last_dt='';
	}
	
	public function set($keyword_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($keyword_data[$key]))
			{
				$this->$key = $keyword_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getOperations();
			
			if ($keyword_data=$ops->getKeywordByID($this->id))
			{
				$this->set(get_object_vars($keyword_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function loadByKeyword()
	{
		$result = false;
		
		if ($this->keyword)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getOperations();
			
			if ($keyword_data=$ops->getKeywordByKeyword($this->keyword))
			{
				$this->set(get_object_vars($keyword_data));
				
				$resultr=true;
			}
		}
		
		return $result;
	}
	
	public function getVisits()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getOperations();
			
			if ($visits=$ops->getKeywordVisits($this))
			{
				$result=$visits;
			}
		}
		
		return $result;
	}
	
	public function getVisitsByTimeframe($from_dt,$to_dt=false)
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getOperations();
			
			if ($visits=$ops->getKeywordVisitsByTimeframe($this,$from_dt,$to_dt))
			{
				$result=$visits;
			}
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$osUtils=getOS()->getUtils();
		
		$keyword_arr=array(
			'keyword'=>$this->keyword,
			'keyword_html'=>htmlentities($this->keyword),
			'visits_day'=>$this->visits_day,
			'visits_week'=>$this->visits_week,
			'visits_month'=>$this->visits_month,
			'visits_year'=>$this->visits_year,
			'visits_timeframe'=>$this->visits_timeframe,
			'last_dt_human'=>$osUtils->humanizeDate($this->last_dt),
		);
		
		$user=getOS()->getUser();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		if ($user->checkPerm('incomingkws','view_keyword'))
		{
			$keyword_arr['keyword_url']=$app->getAppActionUrl('keyword',array('keyword_id'=>$this->id));
		}
		else
		{
			$keyword_arr['keyword_url']=false;
		}
		
		return $keyword_arr;
	}
}
?>