var appTracker = {
		
	registeredEvents: [],

	SE_Rules: {
		"google.": {"engine":"Google","separator":"#"},
		"search.yahoo": {"engine":"Yahoo","q":"p"},
		"bing.com": {"engine":"Bing","q":"q"},"ask.com":{"engine":"Ask"},
		"hotbot.com": {"engine":"HotBot","q":"query"},
		"goo.ne.jp": {"engine":"Goo","q":"MT"},
		"search.icq.com": {"engine":"ICQ"},
		"search.ke.voila.fr": {"engine":"Voila.fr","q":"rdata"},
		"lemoteur.fr": {"engine":"LeMoteur.fr","q":"rdata"},
		"search.yippy.com": {"engine":"Yippy","q":"query"},
		"search.com": {"engine":"Search.com"},
		"surfy.com": {"engine":"Surfy","q":"key"},
		"websearch.cs.com": {"engine":"CompuServe","q":"query"},
		"search.aol.com": {"engine":"AOL"},
		"mamma.com": {"engine":"Mamma"},
		"dmoz.org": {"engine":"DMOZ"},
		"yandex.ru": {"engine":"Yandex.ru","q":"text"},
		"baidu.com": {"engine":"Baidu","q":"wd"},
		"wolframalpha.com": {"engine":"Wolfram Alpha","q":"i"},
		"search.lycos.com": {"engine":"Lycos","q":"query"},
		"gigablast.com": {"engine":"GigaBlast"},
		"galaxy.com": {"engine":"Galaxy"},
		"alexa.com": {"engine":"Alexa"},
		"nova.rambler.ru": {"engine":"Rambler.ru","q":"query"},
		"rediff.com": {"engine":"Rediff","q":"MT"},
		"najdi.si": {"engine":"Najdi.si"},
		"search.naver.com": {"engine":"Naver","q":"query"},
		"szukaj.onet.pl": {"engine":"Onet.pl","q":"qt"},
		"pesquisa.sapo.pt": {"engine":"Sapo.pt"},
		"search.walla.co.il": {"engine":"Walla.co.il"},
		"search.ch": {"engine":"Search.ch"},
		"alleba.com": {"engine":"Alleba"},
		"ansearch.com.au": {"engine":"Ansearch"},
		"search.daum.net": {"engine":"Daum"},
		"guruji.com": {"engine":"Guruji"},
		"blogscope.net": {"engine":"BlogScope"},
		"icerocket.com": {"engine":"IceRocket"},
		"surphace.com": {"engine":"Surphace"},
		"technorati.com": {"engine":"Technorati"},
		"info.com": {"engine":"Info.com","q":"qkw"}
		},

	parseURL: function(str, component)	
	{
		var key = ['source', 'scheme', 'authority', 'userInfo', 'user', 'pass', 'host', 'port', 'relative', 'path', 'directory', 'file', 'query', 'fragment'],
			parser = /^(?:([^:\/?#]+):)?(?:\/\/()(?:(?:()(?:([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?))?()(?:(()(?:(?:[^?#\/]*\/)*)()(?:[^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
			m = parser.exec(str),
			uri = {},
			i = 14;
		
		while (i--) if (m[i]) uri[key[i]] = m[i];  
		if (component) return uri[component.replace('PHP_URL_', '').toLowerCase()];
		delete uri.source;
		
		return uri;
	},
	
	getReferral: function()
	{
		var referral = '', re, rhost;
		
		try {referral=top.document.referrer;} catch (e) { if (parent) try {referral=parent.document.referrer;} catch (e2) {referral='';} }
		if (referral=='') referral = window.document.referrer;
		if (referral=='') return false;
		
		re = new RegExp('^(?:f|ht)tp(?:s)?\://([^/]+)', 'im');
		rhost = referral.match(re)[1].toString();
		
		if (rhost==window.location.host) return false;
		return referral;
	},
	
	extractKeywords: function(url)
	{
		url = this.parseURL(url);
		
		for (var i in this.SE_Rules)
		{
			if (url['host'].indexOf(i)>=0)
			{
				var query_keys = ['query'];
				
				if (this.SE_Rules[i]['separator']=='#') query_keys=['fragment','query'];
				for (var j in query_keys)
					if (url[query_keys[j]]!=undefined)
					{
						var q = (this.SE_Rules[i]['q'] == undefined ? 'q' : this.SE_Rules[i]['q']);
						
						if (url[query_keys[j]].indexOf(q+'=')==0 || url[query_keys[j]].indexOf('&'+q+'=')>0)
						{
							var start_pos=url[query_keys[j]].indexOf('&'+q+'=');
							if (start_pos<0) start_pos=2;
							else start_pos+=3;
							
							if (url[query_keys[j]].indexOf('&',start_pos)>0) var keyword=url[query_keys[j]].substr(start_pos,url[query_keys[j]].indexOf('&',start_pos)-start_pos);
							else var keyword=url[query_keys[j]].substr(start_pos);
							return keyword;
						}
					}
			}
		}	
		return false;
	},
	

	kwsTrackerHandler: function(extraData)
	{
		var detectedKws = false;
		
		var referral= this.getReferral();
		
		if (referral)
		{
			var keyword = this.extractKeywords(referral);
			
			if (keyword!==false)
			{
				detectedKws = {'keyword': keyword, 'referral': escape(referral)};	
			}	
		}	
		
		return detectedKws;
	},
	
	call: function()
	{
		var hookEvents = [],
			windowAlias = window;
		
		if(windowAlias)
		{
			this.registeredEvents.push(['kwsTracker', windowAlias, 'load', "kwsTrackerHandler"]);	
		}	
		
        return {'hookEvents': this.registeredEvents};
	}
};