<?php
class OS_APP_indexedurls extends OS_AppBase
{
	private static $_instance;
	
	protected function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_indexedurls();
		}
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('indexedurls','view');
		
		$viewData=new OS_APPVIEW_IndexedUrls_Main();
		
		return $viewData->render();
	}
	
	public function eventProjectDeleted($params)
	{
		$ops=OS_APP_IndexedUrls_DayOperations::get_instance();
		
		return $ops->deleteDataByProjectID($params['project_id']);
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'indexedurls'=>array(
				'view'=>array('name'=>_("View project indexed URLs by day")),
			)
		);
	}
	
	public function &getDay()
	{
		return OS_APP_indexedurls_day::get_instance();
	}
	
	public function &getOperations()
	{
		return OS_APP_indexedurls_dayoperations::get_instance();
	}
	
	public function eventAppAddedToProject($params)
	{
		$result=false;
		
		if ($params['app_name']=='indexedurls')
		{
			$result=OS_Fork::fork('app','indexedurls','get',array('project_id'=>$params['project_id']));
		}
		
		return $result;
	}
}
?>