<?php
class OS_APP_indexedurls_day
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $urls;
	public $date;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_indexedurls_day();
		}
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=false;
		$this->project_id=0;
		$this->urls=0;
		$this->date='';
	}
	
	public function set($day_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($day_data[$key]))
			{
				$this->$key = $day_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$ops=getOS()->getAppHandler()->getAppPlugin()->getOperations();
		if (!$this->id)
			{
			if (!$this->id=$ops->insertDay($this)) return false;
			return true;
			}
		else return $ops->updateDay($this);
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getOperations();
			
			if ($day_data=$ops->getDayByID($this->id))
			{
				$this->set(get_object_vars($day_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$day_arr=array(
			'id'=>$this->id,
			'urls'=>$this->urls,
			'date'=>getOS()->getUtils()->humanizeDate($this->date,'date'),
		);
		
		return $day_arr;
	}
}
?>