<?php
class OS_APP_indexedurls_dayoperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_indexedurls_dayoperations();
		}
		return self::$_instance;
	}
	
	public function getDays($params)
	{
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler = getOS()->getAppHandler();
		
		//use operations function here
		$current_set =  $params['set'];
		$max_rows = $params['max_rows'];
		
		$limit = (($current_set * $max_rows) - $max_rows);
				
		$days=array();
		$query="SELECT * FROM ".$appHandler->dbPrefix()."days WHERE project_id=? ORDER BY `date` DESC LIMIT {$limit},{$max_rows}";
		$result=$db->query($query,array($project->id));
		while ($row=$db->fetchRow($result))
		{
			$day=new OS_APP_indexedurls_day();
			$day->set($row);
			
			$days[$day->id]=$day;
		}
		
		return $days;
	}
	
	public function getDayByID($day_id)
	{
		$project=getOS()->getProject();
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."days WHERE id=? AND project_id=?";
		$result=$db->query($query,array($day_id,$project->id));
		if (!$row=$db->fetchRow($result)) return false;
		
		$day=new OS_APP_indexedurls_day();
		$day->set($row);
		
		return $day;
	}
	
	public function insertDay($day)
	{
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."days (project_id,urls,`date`) VALUES (?,?,?)";
		$result=$db->query($query,array($day->project_id,$day->urls,$day->date));
		
		if ($result===false) return false;
		
		return $db->getInsertId();
	}
	
	public function updateDay($day)
	{
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."days WHERE id=? AND project_id=?";
		$result=$db->query($query,array($day->id,$day->project_id));
		if (!$day_row=$db->fetchRow($result)) return false;
		
		$query="UPDATE ".$appHandler->dbPrefix()."days SET urls=?,`date`=? WHERE id=?";
		$result=$db->query($query,array($day->urls,$day->date,$day->id));
		
		if ($result!==false) return true;
		
		return false;
	}
	
	public function deleteDataByProjectID($project_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("DELETE FROM ".$appHandler->dbPrefix()."days WHERE project_id=?",array($project_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function getNumberOfIndexedUrls($url)
	{
		$result=false;
		
		$http=getOS()->getHttp();
		$utils=getOS()->getUtils();
		
		$search_query='site:'.parse_url($url,PHP_URL_HOST);
		
		if ($response=$http->get("http://google.com/search?q=".urlencode($search_query)."&hl=en"))
		{
			if (preg_match('/([0-9\.,]+) results/si',$response,$match)) $results_string=$match[1];
			elseif (preg_match('/About ([0-9\.,]+) results/si',$response,$match)) $results_string=$match[1];
			else $results_string=false;

			if ($results_string)
			{
				$result=preg_replace("/[^\d]/",'',$results_string);
			}
			else
			{
				$result=0;
			}
			
			unset($results_string);
		}
		
		unset($response);

		return $result;
	}
}
?>