<?php
class OS_APP_InternalLinks extends OS_AppBase
{
	private static $_instance;
	
	public function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
		
		$this->setRouterOption("depth", "handleDepthView");
		$this->setRouterOption("url", "handleUrlView");
		$this->setRouterOption("anchorlinked", "handleAnchorLinkedView");
		$this->setRouterOption("anchorlinking", "handleAnchorLinkingView");
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_InternalLinks();
		}
		
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('internallinks','view');
		
		$viewData=new OS_APPVIEW_InternalLinks_Main();
		
		return $viewData->render();
	}
	
	public function handleDepthView()
	{
		getOS()->getUser()->forcePerm('internallinks','view');
		
		$viewData=new OS_APPVIEW_InternalLinks_Depth();
		
		return $viewData->render();
	}
	
	public function handleUrlView()
	{
		getOS()->getUser()->forcePerm('internallinks','view');
		
		$viewData=new OS_APPVIEW_InternalLinks_Url();
		
		return $viewData->render();
	}
	
	public function handleAnchorLinkedView()
	{
		getOS()->getUser()->forcePerm('internallinks','view');
		
		$viewData=new OS_APPVIEW_InternalLinks_AnchorLinked();
		
		return $viewData->render();
	}
	
	public function handleAnchorLinkingView()
	{
		getOS()->getUser()->forcePerm('internallinks','view');
		
		$viewData=new OS_APPVIEW_InternalLinks_AnchorLinking();
		
		return $viewData->render();
	}
	
	public function defineAppPermissions()
	{
		$this->appPermissions=array(
			'internallinks'=>array(
				'view'=>array('name'=>_("View internal links data")),
			)
		);
	}
}
?>