<?php
class OS_APPVIEW_InternalLinks_Url extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		$processedRequest=array();
		
		if (empty($requestParams['url_hash']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$ops=OS_APP_InternalLinks_Operations::get_instance();
		
		if (!$processedRequest['anchor_distribution']=$ops->getUrlInlinksDistribution($requestParams['url_hash']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if ($worker=OS_Interactions::getInteractions('worker','onpage_keywords'))
		{
			$worker=reset($worker);
			
			if ($processedRequest['suggested_anchors']=OS_Interactions::performInteraction($worker['id'],array('url_hash'=>$requestParams['url_hash'])))
			{
				$words=array();
				foreach ($processedRequest['suggested_anchors'] as $anchor=>$score)
				{
					$anchor=explode(' ',$anchor);
					foreach ($anchor as $word)
					{
						$words[$word]=true;
					}
				}
				$words=array_keys($words);
				
				foreach ($processedRequest['anchor_distribution']['anchors'] as $anchor=>$details)
				{
					$processedRequest['anchor_distribution']['anchors'][$anchor]['anchor_ok']=$ops->hasWordsFromList($anchor,$words);
				}
			}
		}
		
		return $processedRequest;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$requestParams=$appPlugin->getRequestParams();
		
		foreach ($tplVars['anchor_distribution']['anchors'] as $anchor=>$details)
		{
			$tplVars['anchor_distribution']['anchors'][$anchor]['_linked_url']=$appPlugin->getAppActionUrl('anchorlinked',array('anchor'=>$anchor));
			$tplVars['anchor_distribution']['anchors'][$anchor]['_linking_url']=$appPlugin->getAppActionUrl('anchorlinking',array('anchor'=>$anchor,'to_url_hash'=>$requestParams['url_hash']));
		}
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('url',$tplVars);
	}
}
?>