<?php
class OS_APP_KwAnalysis extends OS_AppBase
{
	private static $_instance;
	
	public function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
		$this->addMenuItem('keywords', array("name" => _("Add keywords"), 'routerOption'=> "handleKeywordsView"));
		
		$this->setRouterOption("export", "handleExportView");
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_KwAnalysis();
		}
		
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('kwanalysis','view');
		
		$viewData=new OS_APPVIEW_KwAnalysis_Main();
		
		return $viewData->render();
	}
	
	public function handleKeywordsView()
	{
		getOS()->getUser()->forcePerm('kwanalysis','view');
		
		$viewData=new OS_APPVIEW_KwAnalysis_Keywords();
		
		return $viewData->render();
	}
	
	public function handleExportView()
	{
		getOS()->getUser()->forcePerm('kwanalysis','view');
		
		$viewData=new OS_APPVIEW_KwAnalysis_Export();
		
		return $viewData->render();
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'kwanalysis'=>array(
				'view'=>array('name'=>_("Perform keyword analysis"))
			)
		);
	}
	
	public function eventProjectDeleted($params)
	{
		$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
		
		return $ops->deleteDataByProjectID($params['project_id']);
	}
	
	public function interactionReceiveKeyword($params)
	{
		
	}
	
	public function interactionWorkerKeywordDifficulty($params)
	{
		
	}
	
	public function interactionWorkerComputeKeywordDifficulty($params)
	{
		$result=false;
		
		if (!empty($params['url_metrics']) AND !empty($params['domain_metrics']))
		{
			$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
			
			$result=$ops->computeKeywordDifficulty($params['url_metrics'],$params['domain_metrics']);
		}
		
		return $result;
	}
}
?>