<?php
class OS_APP_KwAnalysis_Keyword
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $keyword;
	public $se;
	public $se_locale;
	public $se_title;
	public $difficulty;
	public $popularity;
	public $roi;
	public $insert_dt;
	public $insert_ip;
	public $status;
	public $status_dt;
	public $status_ip;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_KwAnalysis_Keyword();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=false;
		$this->project_id=0;
		$this->keyword='';
		$this->difficulty=0;
		$this->popularity=0;
		$this->roi=0;
		$this->insert_dt='';
		$this->insert_ip='';
		$this->status='';
		$this->status_dt='';
		$this->status_ip='';
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertKeyword($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateKeyword($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
			
			if ($data=$ops->getKeywordByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
			
			$result=$ops->deleteKeywordByID($this->id);
		}
		
		return $result;
	}
	
	public function getDifficulty()
	{
		$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
		$this->difficulty=$ops->fetchKeywordDifficulty($this);
		
		return $this->difficulty;
	}
	
	public function getPopularity()
	{
		$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
		$this->popularity=$ops->fetchKeywordPopularity($this);
		
		return $this->popularity;
	}
	
	public function getROI()
	{
		$this->roi=$this->popularity-$this->difficulty;
		
		return $this->roi;
	}
	
	public function getStats()
	{
		$result=false;
		
		if (false!==$this->getDifficulty())
		{
			sleep(rand(5,15));
			
			if (false!==$this->getPopularity())
			{
				$this->getROI();
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
		
		$statuses=array('W'=>_('Processing...'),'F'=>_('Failed'),'D'=>_('Done'));
		
		$reportArray=array(
			'id'=>$this->id,
			'keyword'=>$this->keyword,
			'search_engine'=>$this->se_title,
			'difficulty'=>$this->difficulty,
			'difficulty_human'=>($this->difficulty>100?'100+%':$this->difficulty.'%'),
			'popularity'=>$this->popularity,
			'popularity_human'=>($this->popularity>100?'100+%':$this->popularity.'%'),
			'roi'=>$this->roi,
			'roi_human'=>$this->roi.'%',
			'status'=>$this->status,
			'status_human'=>$statuses[$this->status],
			'status_dt_human'=>$utils->humanizeDate($this->status_dt),
			'insert_dt_human'=>$utils->humanizeDate($this->insert_dt)
		);
		
		return $reportArray;
	}
}
?>