<?php
class OS_APP_KwAnalysis_KeywordOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_KwAnalysis_KeywordOperations();
		}
		
		return self::$_instance;
	}
	
	public function getKeyword($keyword_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE id=?",array($keyword_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_KwAnalysis_Keyword();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getKeywordByKeyword($keyword,$project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE project_id=? AND keyword=?",array($project_id,$keyword));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_KwAnalysis_Keyword();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getKeywords($project_id=false,$offset=0,$limit=10,$order_by='status_dt',$order_type='DESC')
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE project_id=? ORDER BY {$order_by} {$order_type} ".($limit===false?'':"LIMIT {$offset},{$limit}"),array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneKeyword=new OS_APP_KwAnalysis_Keyword();
			$oneKeyword->set($row);
			
			$result[$row['id']]=$oneKeyword;
		}
		
		return $result;
	}
	
	public function getKeywordsForAnalysis($count=1)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE status=? ORDER BY status_dt ASC LIMIT {$count}",array('W'));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneKeyword=new OS_APP_KwAnalysis_Keyword();
			$oneKeyword->set($row);
			
			$result[$row['id']]=$oneKeyword;
		}
		
		return $result;
	}
	
	public function getPendingKeywords($project_id=false,$limit=3)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE project_id=? AND status=? ORDER BY status_dt ASC LIMIT {$limit}",array($project_id,'W'));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneKeyword=new OS_APP_KwAnalysis_Keyword();
			$oneKeyword->set($row);
			
			$result[$row['id']]=$oneKeyword;
		}
		
		return $result;
	}
	
	public function getFailedKeywords($project_id=false,$limit=3)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE project_id=? AND status=? ORDER BY status_dt ASC LIMIT {$limit}",array($project_id,'F'));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneKeyword=new OS_APP_KwAnalysis_Keyword();
			$oneKeyword->set($row);
			
			$result[$row['id']]=$oneKeyword;
		}
		
		return $result;
	}
	
	public function timeSinceLastFail()
	{
		$result=false;
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE status=? ORDER BY status_dt DESC LIMIT 1",array('F'));
		while ($row=$db->fetchRow($dbresult))
		{
			$result=time()-strtotime($row['status_dt']);
		}
		
		return $result;
	}
	
	public function getKeywordsCount($project_id=false,$status=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT COUNT(*) AS total_keywords FROM ".$appHandler->dbPrefix()."keywords WHERE project_id=?".($status?" AND status=?":''),($status?array($project_id,$status):array($project_id)));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=$row['total_keywords'];
		}
		
		return $result;
	}
	
	public function insertKeyword($keyword)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		$ip=$OS->getRemoteAddr();
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."keywords (project_id,keyword,se,se_locale,se_title,difficulty,popularity,roi,insert_dt,insert_ip,status,status_dt,status_ip) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
		$dbresult=$db->query($query,array($keyword->project_id,$keyword->keyword,$keyword->se,$keyword->se_locale,$keyword->se_title,$keyword->difficulty,$keyword->popularity,$keyword->roi,$time,$ip,'W',$time,$ip));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateKeyword($keyword)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		$ip=$OS->getRemoteAddr();
		
		$query="UPDATE ".$appHandler->dbPrefix()."keywords SET difficulty=?,popularity=?,roi=?,status=?,status_dt=?,status_ip=? WHERE id=?";
		$dbresult=$db->query($query,array($keyword->difficulty,$keyword->popularity,$keyword->roi,$keyword->status,$time,$ip,$keyword->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteKeywordByID($keyword_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."keywords WHERE id=?";
		$dbresult=$db->query($query,array($keyword_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteDataByProjectID($project_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."keywords WHERE project_id=?";
		$dbresult=$db->query($query,array($project_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function queueKeyword($keyword_id,$queue_id,$queue_type)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$dbresult=$db->query("INSERT INTO ".$appHandler->dbPrefix()."queue (keyword_id,queue_id,queue_type) VALUES (?,?,?)",array($keyword_id,$queue_id,$queue_type));
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function fetchKeywordDifficulty($keyword)
	{
		$result=false;
		
		$se=getOS()->getSearchEngine();
		if ($competitors=$se->getResults($keyword->keyword,$keyword->se,$keyword->se_locale))
		{
			if ($competitors['status']=='done')
			{
				$result=$this->processKeywordDifficulty($keyword,$competitors['data']);
			}
			elseif ($competitors['status']=='queued')
			{
				$result=$this->queueKeyword($keyword->id,$competitors['queue_id'],'difficulty');
			}
		}
		
		return $result;
	}
	
	public function processKeywordDifficulty($keyword,$competitors)
	{
		$result=false;
		
		$backlinks=$OS->getBacklinks();
		$osUtils=$OS->getUtils();
		
		$backlinks_engine=($backlinks->loadEngine('moz')?'moz':'majesticsimple');
		
		$urls=array();$position=1;
		foreach ($competitors as $competitor)
		{
			$urls[$position]=$osUtils->prependHTTP($competitor['url']);
			
			$position++;
		}
		if (count($urls)>10)
		{
			$urls=array_slice($urls,0,10,true);
		}
		
		if ($url_metrics=$backlinks->getUrlsMetrics($urls,$backlinks_engine))
		{
			$actual_url_metrics=array();
			$actual_domain_metrics=array();
			
			if ($backlinks_engine=='majesticsimple')
			{
				$domains=array();
				foreach ($urls as $position=>$url)
				{
					$domains[$position]=parse_url($url,PHP_URL_HOST);
					
					if (!empty($url_metrics[$url]))
					{
						$actual_url_metrics[$position]=$url_metrics[$url];
					}
				}
				
				if ($domain_metrics=$backlinks->getUrlsMetrics($domains,$backlinks_engine))
				{
					foreach ($domains as $position=>$domain)
					{
						if (!empty($domain_metrics[$domain]))
						{
							$actual_domain_metrics[$position]=$domain_metrics[$domain]['domain_authority'];
						}
					}
				}
			}
			elseif ($backlinks_engine=='moz')
			{
				$domains=array();
				
				foreach ($urls as $position=>$url)
				{
					if (!empty($url_metrics[$url]))
					{
						$actual_url_metrics[$position]=$url_metrics[$url]['page_authority'];
						$actual_domain_metrics[$position]=$url_metrics[$url]['domain_authority'];
					}
					else
					{
						$actual_url_metrics[$position]=0;
						
						$domains[$position]='http://'.parse_url($url,PHP_URL_HOST).'/';
					}
				}
				
				if (!empty($domains))
				{
					if ($domain_metrics=$backlinks->getUrlsMetrics($domains,$backlinks_engine))
					{
						foreach ($domains as $position=>$domain)
						{
							if (!empty($domain_metrics[$domain]))
							{
								$actual_domain_metrics[$position]=$domain_metrics[$domain]['domain_authority'];
							}
						}
					}
				}
			}
			
			$this->setKeywordDifficulty($keyword,$this->computeKeywordDifficulty($actual_url_metrics,$actual_domain_metrics));
		}
		
		return $result;
	}
	
	public function setKeywordDifficulty($keyword,$difficulty)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$dbresult=$db->query("UPDATE ".$appHandler->dbPrefix()."keywords SET difficulty=? WHERE id=?",array($difficulty,$keyword->id));
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function computeKeywordDifficulty($url_metrics,$domain_metrics)
	{
		$url_sum=0;$url_divider=0;
		$domain_sum=0;$domain_divider=0;
		
		foreach ($url_metrics as $pos=>$metric)
		{
			$url_multiplier=11-$pos;
			$url_divider+=$url_multiplier;
			$url_sum+=$url_multiplier*$metric;
		}
		
		foreach ($domain_metrics as $pos=>$metric)
		{
			$domain_multiplier=11-$pos;
			$domain_divider+=$domain_multiplier;
			$domain_sum+=$domain_multiplier*$metric;
		}
		
		$result=0.8*$url_sum/$url_divider+0.2*$domain_sum/$domain_divider;
		
		if ($result==0)
		{
			$result=1;
		}
		
		return $result;
	}
	
	public function fetchKeywordPopularity($keyword)
	{
		$result=false;
		
		$se=getOS()->getSearchEngine();
		if ($popularity=$se->getResultsNumber('"'.$keyword->keyword.'"',$keyword->se,$keyword->se_locale))
		{
			if ($popularity['status']=='done')
			{
				$result=$this->processKeywordPopularity($keyword,$popularity['data']);
			}
			elseif ($popularity['status']=='queued')
			{
				$result=$this->queueKeyword($keyword->id,$popularity['queue_id'],'popularity');
			}
		}
		
		return $result;
	}
	
	public function processKeywordPopularity($keyword,$results)
	{
		$popularity=round(log10($results)*100/9,2);
		
		return $this->setKeywordPopularity($keyword,$popularity);
	}
	
	public function setKeywordPopularity($keyword,$popularity)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		//TODO: also check if diff, update status, use updateKeyword function
		$dbresult=$db->query("UPDATE ".$appHandler->dbPrefix()."keywords SET popularity=? WHERE id=?",array($difficulty,$keyword->id));
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function eventSearchEngineQueried($params)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$project_ids=array();
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."queue WHERE queue_id=?",array($params['queue_id']));
		while ($row=$db->fetchRow($dbresult))
		{
			$keyword_ids[$row['keyword_id']]=$row['queue_type'];
		}
		
		if (!empty($keyword_ids))
		{
			foreach ($keyword_ids as $keyword_id=>$type)
			{
				if ($oneKeyword=$this->getKeyword($keyword_id))
				{
					if ($params['status']=='done')
					{
						if ($type=='difficulty')
						{
							$result=$this->processKeywordDifficulty($oneKeyword,$params['data']['getResults']);
						}
						elseif ($type=='popularity')
						{
							$result=$this->processKeywordPopularity($oneKeyword,$params['data']['getResultsNumber']);
						}
					}
					elseif ($params['status']=='failed')
					{
						if ($type=='difficulty')
						{
							$result=$this->fetchKeywordDifficulty($oneKeyword);
						}
						elseif ($type=='popularity')
						{
							$result=$this->fetchKeywordPopularity($oneKeyword);
						}
					}
				}
			}
		}
		
		return $result;
	}
	
	public function getKeywordMarketSize($keyword)
	{
		$result=false;
		
		$OS=getOS();
		
		$se=$OS->getSearchEngine();
		
		$se->setOffset(990,$keyword->se,$keyword->se_locale);
		$se->setOption('filter',0,$keyword->se,$keyword->se_locale);
		
//		$intitle=$se->getResultsNumber('intitle:"'.$keyword->keyword.'"',$keyword->se,$keyword->se_locale);
//		
//		if ($intitle!==false)
//		{
//			sleep(rand(10,25));
//			$inanchor=$se->getResultsNumber('inanchor:"'.$keyword->keyword.'"',$keyword->se,$keyword->se_locale);
//			
//			if (!$inanchor!==false)
//			{
//				//exact matching score
//				$exact_score=round((2*min($intitle,$inanchor)+$intitle+$inanchor)/1000,2);
//				
//				sleep(rand(10,25));
				$allintitle=$se->getResultsNumber("allintitle:{$keyword->keyword}",$keyword->se,$keyword->se_locale);
				
				if ($allintitle!==false)
				{
					sleep(rand(10,25));
					$allinanchor=$se->getResultsNumber("allinanchor:{$keyword->keyword}",$keyword->se,$keyword->se_locale);
					
					if ($allinanchor!==false)
					{
						//broad matching score
//						$allintitle-=$intitle;
//						$allinanchor-=$inanchor;
//						
//						$broad_score=round((2*min($allintitle,$allinanchor)+$allintitle+$allinanchor)/1000,2);
//						
//						$market=$exact_score+$broad_score;
//						$result=$market+$market*($exact_score*100/$market);
						$result=round(log10(3*min($allintitle,$allinanchor)+max($allintitle,$allinanchor))*100/9,2);
					}
				}
//			}
//		}
		
		return $result;
	}
}
?>