<?php
class OS_APPVIEW_KwAnalysis_Export extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
		
		$viewDataVars=array();

		$viewDataVars['keywords']=$ops->getKeywords($project->id,0,false,'roi');
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array();
		
		if (!empty($viewData['keywords']))
		{
			$keywords=array();
			
			foreach ($viewData['keywords'] as $keyword)
			{
				if ($keyword->status=='D')
				{
					$keywords[$keyword->id]=$keyword->toTemplate();
				}
			}
			
			if (!empty($keywords))
			{
				$csv_headers=array('keyword'=>_("Keyword"),'difficulty'=>_("Difficulty"),'difficulty_grade'=>_("Difficulty Grade"),'popularity'=>_("Popularity"),'popularity_grade'=>_("Popularity Grade"),'roi'=>_("ROI"),'roi_human'=>_("ROI Grade"));
				
				header('Content-Type: text/csv');
				header('Content-Disposition: attachment; filename="keyword_analysis.csv"');
				
				$osUtils=$OS->getUtils();
				
				echo $osUtils->csvify($csv_headers,$keywords);
				
				exit;
			}
		}
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('export_failed',$tplVars);
	}		
}
?>