<?php
class OS_APPVIEW_KwAnalysis_Main extends OS_AppViewBase
{
	public $keywordsPerPage=50;
	
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
		
		$requestParams=$appPlugin->getRequestParams();
		$processedRequest=array();
		
		$processedRequest['keywordsCount']=$ops->getKeywordsCount();
		$processedRequest['page']=1;
		
		if (!empty($requestParams['page']) AND ($requestParams['page']>0) AND (($requestParams['page']-1)*$this->keywordsPerPage<$processedRequest['keywordsCount']))
		{
			$processedRequest['page']=$requestParams['page'];
		}
		
		if (!empty($requestParams['msg']))
		{
			if ($requestParams['msg']=='keywords_ok')
			{
				$OS->addInfo(_("Analysis started successfully. Please check back in a few minutes to view the results."));
			}
		}
		
		return $processedRequest;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_KwAnalysis_KeywordOperations::get_instance();
		
		$viewDataVars=array();

		if ($this->processedRequest['keywordsCount'])
		{
			$viewDataVars['keywordsCount']=$this->processedRequest['keywordsCount'];
			
			$viewDataVars['keywords']=$ops->getKeywords($project->id,($this->processedRequest['page']-1)*$this->keywordsPerPage,$this->keywordsPerPage);
			
			$viewDataVars['completedCount']=$ops->getKeywordsCount($project->id,'D');
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array();
		$tplVars['export_url']=false;
		
		if (!empty($viewData['keywords']))
		{
			foreach ($viewData['keywords'] as $keyword_id=>$keyword)
			{
				$tplVars['keywords'][$keyword_id]=$keyword->toTemplate();
			}
			
			if ($this->processedRequest['page']>1)
			{
				$tplVars['prev_page_url']=$appPlugin->getAppActionUrl('main',array('page'=>$this->processedRequest['page']-1));
			}
			else
			{
				$tplVars['prev_page_url']=false;
			}
			
			if (($this->processedRequest['page']*$this->keywordsPerPage)<$viewData['keywordsCount'])
			{
				$tplVars['next_page_url']=$appPlugin->getAppActionUrl('main',array('page'=>$this->processedRequest['page']+1));
			}
			else
			{
				$tplVars['next_page_url']=false;
			}
			
			if ($viewData['completedCount'])
			{
				$tplVars['export_url']=$appPlugin->getAppActionUrl('export');
			}
		}
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('main',$tplVars);
	}
}
?>