<?php
class OS_APP_KwExtractor_Report
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $url;
	public $min_word_length;
	public $words_min;
	public $words_max;
	public $stop_words_list;
	public $stop_words;
	public $insert_dt;
	public $insert_ip;
	public $status;
	public $status_dt;
	public $status_ip;
	public $result;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_KwExtractor_Report();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=false;
		$this->project_id=0;
		$this->url='';
		$this->min_word_length=0;
		$this->words_min=0;
		$this->words_max=0;
		$this->stop_words_list='';
		$this->stop_words=array();
		$this->insert_dt='';
		$this->insert_ip='';
		$this->status='';
		$this->status_dt='';
		$this->status_ip='';
		$this->result=array();
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_KwExtractor_ReportOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertReport($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateReport($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_KwExtractor_ReportOperations::get_instance();
			
			if ($data=$ops->getReportByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_KwExtractor_ReportOperations::get_instance();
			
			$result=$ops->deleteReportByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$statuses=array('W'=>_('Processing...'),'F'=>_('Failed'),'D'=>_('Done'));
		
		if ($this->stop_words_list)
		{
			$stopWords=getOS()->getStopWords();
			
			if ($stop_words_list_human=$stopWords->getListDetails($this->stop_words_list))
			{
				$stop_words_list_human=$stop_words_list_human['name'];
			}			
		}
		else
		{
			$stop_words_list_human='';
		}

		$result=array(
			'url'=>$this->url,
			'url_safe'=>$utils->getSafeURL($this->url),
			'min_word_length'=>$this->min_word_length,
			'words_min'=>$this->words_min,
			'words_max'=>$this->words_max,
			'stop_words_list'=>$this->stop_words_list,
			'stop_words_list_human'=>$stop_words_list_human,
			'stop_words'=>$this->stop_words,
			'stop_words_human'=>implode(', ',$this->stop_words),
			'insert_dt_human'=>$utils->humanizeDate($this->insert_dt),
			'status'=>$this->status,
			'status_human'=>$statuses[$this->status],
			'status_dt_human'=>$utils->humanizeDate($this->status_dt),
			'result'=>$this->result,
			'details_url'=>($this->status=='D'?$app->getAppActionUrl('report',array('report_id'=>$this->id)):false),
			'edit_url'=>($this->status!='W'?$app->getAppActionUrl('addedit',array('op'=>'edit','report_id'=>$this->id)):false)
		);
		
		return $result;
	}
}
?>