<?php
class OS_APP_KwExtractor_ReportOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_KwExtractor_ReportOperations();
		}
		
		return self::$_instance;
	}
	
	public function getReportByID($report_id,$project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE id=? AND project_id=?",array($report_id,$project_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$row['stop_words']=json_decode($row['stop_words'],true);
			$row['result']=json_decode($row['result'],true);
			
			$result=new OS_APP_KwExtractor_Report();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getReports($project_id=false,$offset=0,$count=10)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE project_id=? ORDER BY `insert_dt` DESC LIMIT {$offset},{$count}";
		
		$dbresult=$db->query($query,array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$row['stop_words']=json_decode($row['stop_words'],true);
			$row['result']=json_decode($row['result'],true);
			
			$oneReport=new OS_APP_KwExtractor_Report();
			$oneReport->set($row);
			
			$result[$row['id']]=$oneReport;
		}
		
		return $result;
	}
	
	public function getReportsCount($project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT COUNT(id) AS total_reports FROM ".$appHandler->dbPrefix()."reports WHERE project_id=?";
		
		$dbresult=$db->query($query,array($project_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=$row['total_reports'];
		}
		
		return $result;
	}
	
	public function insertReport($report)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		$ip=$OS->getRemoteAddr();
		
		$json_result=json_encode($report->result);
		$stop_words=json_encode($report->stop_words);
		
		if (empty($report->status))
		{
			$report->status='W';
		}
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."reports (project_id,url,min_word_length,words_min,words_max,stop_words_list,stop_words,insert_dt,insert_ip,status,status_dt,status_ip,result) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
		$dbresult=$db->query($query,array($report->project_id,$report->url,$report->min_word_length,$report->words_min,$report->words_max,$report->stop_words_list,$stop_words,$time,$ip,$report->status,$time,$ip,$json_result));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateReport($report)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		$ip=$OS->getRemoteAddr();
		
		$json_result=json_encode($report->result);
		$stop_words=json_encode($report->stop_words);
		
		$query="UPDATE ".$appHandler->dbPrefix()."reports SET url=?,min_word_length=?,words_min=?,words_max=?,stop_words_list=?,stop_words=?,result=?,status=?,status_dt=?,status_ip=? WHERE id=?";
		$dbresult=$db->query($query,array($report->url,$report->min_word_length,$report->words_min,$report->words_max,$report->stop_words_list,$stop_words,$json_result,$report->status,$time,$ip,$report->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteReportByID($report_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."reports WHERE id=?";
		$dbresult=$db->query($query,array($report_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteDataByProjectID($project_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."reports WHERE project_id=?";
		$dbresult=$db->query($query,array($project_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
}
?>