<?php
class OS_APP_KwLab_Competitor
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $report_id;
	public $keyword_id;
	public $position;
	public $host;
	public $host_moz_da;
	public $host_moz_pa;
	public $host_majestic_cf;
	public $host_majestic_tf;
	public $host_majestic_backlinks;
	public $host_majestic_rootdomains;
	public $url;
	public $title;
	public $social_facebook;
	public $social_gplus;
	public $social_twitter;
	public $moz_da;
	public $moz_pa;
	public $majestic_cf;
	public $majestic_tf;
	public $majestic_backlinks;
	public $majestic_rootdomains;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_KwLab_Competitor();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->report_id=0;
		$this->keyword_id=0;
		$this->position=0;
		$this->host='';
		$this->host_moz_da=0;
		$this->host_moz_pa=0;
		$this->host_majestic_cf=0;
		$this->host_majestic_tf=0;
		$this->host_majestic_backlinks=0;
		$this->host_majestic_rootdomains=0;
		$this->url='';
		$this->title='';
		$this->social_facebook=0;
		$this->social_gplus=0;
		$this->social_twitter=0;
		$this->moz_da=0;
		$this->moz_pa=0;
		$this->majestic_cf=0;
		$this->majestic_tf=0;
		$this->majestic_backlinks=0;
		$this->majestic_rootdomains=0;
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_KwLab_CompetitorOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertCompetitor($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateCompetitor($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_KwLab_CompetitorOperations::get_instance();
			
			if ($data=$ops->getCompetitorByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_KwLab_CompetitorOperations::get_instance();
			
			$result=$ops->deleteCompetitorByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$result=array(
			'position'=>$this->position,
			'host'=>$this->host,
			'url'=>$this->url,
			'url_safe'=>$utils->getSafeURL($this->url),
			'title'=>$this->title,
			'social_facebook'=>$this->social_facebook,
			'social_gplus'=>$this->social_gplus,
			'social_twitter'=>$this->social_twitter,
			'moz_da'=>$this->moz_da,
			'moz_pa'=>$this->moz_pa,
			'majestic_cf'=>$this->majestic_cf,
			'majestic_tf'=>$this->majestic_tf,
			'majestic_backlinks'=>$this->majestic_backlinks,
			'majestic_rootdomains'=>$this->majestic_rootdomains,
		);
		
		return $result;
	}
}
?>