<?php
class OS_APP_KwLab_Keyword
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $report_id;
	public $keyword;
	public $source;
	public $related;
	public $autosuggest;
	public $analyzed;
	public $competitors;
	public $difficulty;
	public $original_id;
	public $should_discover;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_KwLab_Keyword();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->report_id=0;
		$this->keyword='';
		$this->source='';
		$this->related='';
		$this->autosuggest='';
		$this->analyzed='';
		$this->competitors='';
		$this->difficulty=0;
		$this->original_id=0;
		$this->should_discover='';
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_KwLab_KeywordOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertKeyword($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateKeyword($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_KwLab_KeywordOperations::get_instance();
			
			if ($data=$ops->getKeywordByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_KwLab_KeywordOperations::get_instance();
			
			$result=$ops->deleteKeywordByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$sources=array('O'=>_('Original'),'R'=>_('Related'),'A'=>_('Autosuggest'));
		
		$result=array(
			'keyword'=>$this->keyword,
			'difficulty'=>$this->difficulty,
			'source'=>$this->source,
			'source_human'=>$sources[$this->source],
			'related'=>$this->related,
			'related_human'=>$utils->humanizeYesNo($this->related),
			'autosuggest'=>$this->related,
			'autosuggest_human'=>$utils->humanizeYesNo($this->autosuggest),
			'analyzed'=>$this->related,
			'analyzed_human'=>$utils->humanizeYesNo($this->analyzed),
			'competitors'=>$this->competitors,
			'competitors_human'=>$utils->humanizeYesNo($this->competitors),
			'should_discover'=>$this->should_discover,
			'discover_url'=>($this->should_discover==''?$app->getAppActionUrl('keywords',array('report_id'=>$this->report_id,'op'=>'discover','keyword_id'=>$this->id)):false),
			'competitors_url'=>($this->competitors=='Y'?$app->getAppActionUrl('competitors',array('report_id'=>$this->report_id,'keyword_id'=>$this->id)):false),
			'delete_url'=>$app->getAppActionUrl('keywords',array('report_id'=>$this->report_id,'op'=>'delete','keyword_id'=>$this->id))
		);
		
		return $result;
	}
}
?>