<?php
class OS_APPVIEW_KwLab_Competitors extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$requestParams=$appPlugin->getRequestParams();
		$export=false;
		
		$valid=false;
		if (!empty($requestParams['report_id']) AND !empty($requestParams['keyword_id']))
		{
			$ops=OS_APP_KwLab_ReportOperations::get_instance();

			if ($report=$ops->getReportByID($requestParams['report_id'],$project->id))
			{
				$valid='report';
				$kwOps=OS_APP_KwLab_KeywordOperations::get_instance();
				
				if ($keyword=$kwOps->getKeywordByID($requestParams['keyword_id'],$project->id))
				{
					if ($keyword->report_id==$report->id AND $keyword->competitors=='Y')
					{
						$compOps=OS_APP_KwLab_CompetitorOperations::get_instance();
						
						if ($competitors=$compOps->getCompetitorsByKeywordID($requestParams['keyword_id'],$project->id))
						{
							$valid=true;
						}
					}
				}
			}
		}
		
		if (isset($requestParams['export']))
		{
			$export=true;
		}
		
		if (!$valid)
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('main'),true);
		}
		elseif ($valid==='report')
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('keywords',array('report_id'=>$requestParams['report_id'])),true);
		}
		
		return array('report'=>$report,'keyword'=>$keyword,'competitors'=>$competitors,'export'=>$export);
	}
	
	public function render()
	{
		$OS=getOS();
		
		if ($this->processedRequest['export'])
		{
			$csv="Position,Host,URL,Title,Facebook,Google+,Twitter,Moz DA,Moz PA";
			
			foreach ($this->processedRequest['competitors'] as $competitor)
			{
				$csv.="\n{$competitor->position},{$competitor->host},{$competitor->url},\"{$competitor->title}\",{$competitor->social_facebook},{$competitor->social_gplus},{$competitor->social_twitter},{$competitor->moz_da},{$competitor->moz_pa}";
			}
			
			header('Content-Type: text/csv');
			header('Content-Disposition: attachment; filename="'.str_replace(' ','-',$this->processedRequest['report']->name).'_'.str_replace(' ','-',$this->processedRequest['keyword']->keyword).'_competitors.csv"');
			
			echo $csv;
			
			exit;
		}
		else
		{
			$appPlugin=$OS->getAppHandler()->getAppPlugin();
			
			$tplVars['report']=$this->processedRequest['report']->toTemplate();
			$tplVars['keyword']=$this->processedRequest['keyword']->toTemplate();
			$tplVars['competitors']=array();
			foreach ($this->processedRequest['competitors'] as $competitor_id=>$competitor)
			{
				$tplVars['competitors'][$competitor_id]=$competitor->toTemplate();
			}
			
			$appPlugin->setMenuBackLink(array('back_view'=>'keywords','report_id'=>$this->processedRequest['report']->id));
			
			$tplVars['exportURL']=$appPlugin->getAppActionUrl('competitors',array('report_id'=>$this->processedRequest['report']->id,'keyword_id'=>$this->processedRequest['keyword']->id,'export'=>'yes'));
			$tplVars['imagesURL']=$appPlugin->getAppHomeUrl().'/resources/images';
			
			$tpl=$OS->getTemplate();
			
			return $tpl->fetchTemplate('competitors',$tplVars);
		}
	}
}
?>