<?php
class OS_APPVIEW_KwLab_Main extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (!empty($requestParams['op']))
		{
			$ops=OS_APP_KwLab_ReportOperations::get_instance();
			
			if ($requestParams['op']=='delete')
			{
				if (!empty($requestParams['report_id']) AND $report=$ops->getReportByID($requestParams['report_id']))
				{
					if ($report->delete())
					{
						$OS->addInfo(_("Report deleted successfully"));
					}
					else
					{
						$OS->addBoxError(_("Unable to delete report"));
					}
				} 
			}
		}
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_KwLab_ReportOperations::get_instance();
		
		$viewDataVars=array();

		$viewDataVars['reports']=$ops->getReports($project->id);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars['reports']=array();
		
		if ($viewData['reports'])
		{
			foreach ($viewData['reports'] as $report_id=>$report)
			{
				$tplVars['reports'][$report_id]=$report->toTemplate();
			}
		}
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('view',$tplVars);
	}
}
?>