<?php
class OS_APPFORK_KwTracker_Complete_Report
{
	public function run($params)
	{
		$result=false;
		
		if (!empty($params[0]) AND !empty($params[1]))
		{
			$project_id=$params[0];
			$report_id=$params[1];
			
			$OS=getOS();
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($project_id))
			{
				$appOps=$OS->getAppOps();
				$app=$appOps->getAppByName('kwtracker');
				
				if ($appOps->isProjectApp($project_id,$app->id))
				{
					$OS->initTimezone($project->timezone);
					
					$appHandler=$OS->getAppHandler('kwtracker');
					
					$reportOps=OS_APP_KwTracker_ReportOperations::get_instance();
					if ($report=$reportOps->getReportByID($report_id))
					{
						$db=$OS->getDb();
						$osCompetitorOps=$OS->getCompetitorOps();
						$osProjectTopicOps=$OS->getProjectTopicOps();
						
						$topics=array();
						$report_results=array('p1'=>0,'t10'=>0,'t30'=>0,'others'=>0);
						
						$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE report_id=?",array($report_id));
						while ($row=$db->fetchRow($dbresult))
						{
							if (!isset($topics[$row['topic_id']]))
							{
								if ($topic=$osProjectTopicOps->getProjectTopicByID($row['topic_id']))
								{
									$topics[$row['topic_id']]=array(
										'se_id'=>$topic->se_id,
										'project'=>array('p1'=>0,'t10'=>0,'t30'=>0,'others'=>0),
										'competitors'=>array()
									);
									
									if ($competitors=$osCompetitorOps->getCompetitorsByTopicID($row['topic_id']))
									{
										foreach ($competitors as $competitor_id=>$details)
										{
											$topics[$row['topic_id']]['competitors'][$competitor_id]=array('p1'=>0,'t10'=>0,'t30'=>0,'others'=>0);
										}
									}
								}
								else
								{
									continue;
								}
							}
							
							if (!empty($row['project_pos']))
							{
								if ($row['project_pos']==1)
								{
									$topics[$row['topic_id']]['project']['p1']++;
									$report_results['p1']++;
								}
								elseif ($row['project_pos']<=10)
								{
									$topics[$row['topic_id']]['project']['t10']++;
									$report_results['t10']++;
								}
								elseif ($row['project_pos']<=30)
								{
									$topics[$row['topic_id']]['project']['t30']++;
									$report_results['t30']++;
								}
							}
							else
							{
								$topics[$row['topic_id']]['project']['others']++;
								$report_results['others']++;
							}
							
							$row['competitors_pos']=json_decode($row['competitors_pos'],true);
							foreach ($row['competitors_pos'] as $competitor_id=>$pos)
							{
								if (isset($topics[$row['topic_id']]['competitors'][$competitor_id]))
								{
									if (!empty($pos))
									{
										if ($pos==1)
										{
											$topics[$row['topic_id']]['competitors'][$competitor_id]['p1']++;
										}
										elseif ($pos<=10)
										{
											$topics[$row['topic_id']]['competitors'][$competitor_id]['t10']++;
										}
										elseif ($pos<=30)
										{
											$topics[$row['topic_id']]['competitors'][$competitor_id]['t30']++;
										}
									}
									else
									{
										$topics[$row['topic_id']]['competitors'][$competitor_id]['others']++;
									}
								}
							}
						}
						
						foreach ($topics as $topic_id=>$details)
						{
							$db->query("INSERT INTO ".$appHandler->dbPrefix()."topics (project_id,report_id,se_id,topic_id,project_pos,competitors_pos) VALUES (?,?,?,?,?,?)",array($project_id,$report_id,$details['se_id'],$topic_id,json_encode($details['project']),json_encode($details['competitors'])));
						}
						
						$report->pos_p1=$report_results['p1'];
						$report->pos_t10=$report_results['t10'];
						$report->pos_t30=$report_results['t30'];
						$report->pos_others=$report_results['others'];
						$report->status='D';
						
						if ($report->save())
						{
							$result=true;
						}
					}
				}
			}
		}
		
		return $result;
	}
}
?>