<?php
class OS_APPFORK_KwTracker_New_Report
{
	public function run($params)
	{
		$result=false;
		
		if (!empty($params[0]))
		{
			$project_id=$params[0];
			
			$OS=getOS();
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($project_id))
			{
				$appOps=$OS->getAppOps();
				$app=$appOps->getAppByName('kwtracker');
				
				if ($appOps->isProjectApp($project_id,$app->id))
				{
					$OS->initTimezone($project->timezone);
					
					$appHandler=$OS->getAppHandler('kwtracker');
					
					$reportOps=OS_APP_KwTracker_ReportOperations::get_instance();
					
					if ($reportOps->shouldTrackProject($project_id))
					{
						$osProjectKeywordOps=$OS->getProjectKeywordOps();
						
						if ($projectKeywords=$osProjectKeywordOps->getProjectKeywords($project_id))
						{
							$toTrack=array();						
							foreach ($projectKeywords as $keyword_id=>$keyword)
							{
								if (empty($toTrack[$keyword->topic_id]))
								{
									$toTrack[$keyword->topic_id]=array(
										'se'=>false,
										'topic'=>false,
										'keywords'=>array()
									);
								}
								
								$toTrack[$keyword->topic_id]['keywords'][$keyword_id]=$keyword->keyword;
							}
							
							if ($toTrack)
							{
								$osProjectTopicOps=$OS->getProjectTopicOps();
								
								$searchEngines=array();
								
								foreach ($toTrack as $topic_id=>$details)
								{
									if ($topic=$osProjectTopicOps->getProjectTopicByID($topic_id))
									{
										if ($topic->competitors=='Y')
										{
											$toTrack[$topic_id]['topic']=$topic->topic;
											
											$osProjectSEOps=$OS->getProjectSearchEngineOps();
											
											if (isset($searchEngines[$topic->se_id]))
											{
												$toTrack[$topic_id]['se']=array(
													'id'=>$topic->se_id,
													'engine'=>$searchEngines[$topic->se_id]->engine,
													'locale'=>$searchEngines[$topic->se_id]->locale
												);
											}
											elseif ($se=$osProjectSEOps->getProjectSearchEngineByID($topic->se_id))
											{
												$toTrack[$topic_id]['se']=array(
													'id'=>$se->id,
													'engine'=>$se->engine,
													'locale'=>$se->locale
												);
											}
											else
											{
												unset($toTrack[$topic_id]);
											}
										}
										else
										{
											unset($toTrack[$topic_id]);
										}
									}
									else
									{
										unset($toTrack[$topic_id]);
									}
								}
								
								if ($toTrack)
								{
									$oneReport=new OS_APP_KwTracker_Report();
									
									$oneReport->project_id=$project_id;
									
									if ($oneReport->save())
									{
										$reportOps->trackKeywords($oneReport->id,$toTrack);
									}
								}
							}
						}
					}
				}
			}
		}
	}
}
?>