<?php
class OS_APP_KwTracker extends OS_AppBase
{
	private static $_instance;

	public function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Overview"), 'routerOption'=> "handleMainView"));
		$this->addMenuItem('analyze_now', array("name" => _("Analyze now"), 'routerOption'=> "handleNowView"));
		
		$this->setRouterOption('competitors',"handleCompetitorsView");
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_KwTracker();
		}
		
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		$viewData=new OS_APPVIEW_KwTracker_Main();
		
		return $viewData->render();
	}
	
	public function handleCompetitorsView()
	{
		$viewData=new OS_APPVIEW_KwTracker_Competitors();
		
		return $viewData->render();
	}
	
	public function handleNowView()
	{
		$viewData=new OS_APPVIEW_KwTracker_Now();
		
		return $viewData->render();
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'kwtracker'=>array(
				'view'=>array('name'=>_("Access Keyword Tracking")),
			)
		);
	}
	
	public function eventProjectDeleted($params)
	{
		
	}
	
	public function eventSearchEngineQueried($params)
	{
		$result=false;
		
		$kwOps=OS_APP_KwTracker_ReportOperations::get_instance();
		$result=$kwOps->eventSearchEngineQueried($params);
		
		return $result;
	}
}
?>