<?php
class OS_APPVIEW_KwTracker_Competitors extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['se_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		else
		{
			$osProjectSearchEngineOps=$OS->getProjectSearchEngineOps();
			
			if (!$se=$osProjectSearchEngineOps->getProjectSearchEngineByID($requestParams['se_id']))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
			elseif ($se->project_id!=$project->id)
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
		}
		
		if (empty($requestParams['topic_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		else
		{
			$osProjectTopicOps=$OS->getProjectTopicOps();
			
			if (!$topic=$osProjectTopicOps->getProjectTopicByID($requestParams['topic_id']))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
			elseif ($topic->project_id!=$project->id)
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
			elseif ($topic->se_id!=$se->id)
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
		}
		
		$osProjectKeywordOps=$OS->getProjectKeywordOps();
		if (!$keywords=$osProjectKeywordOps->getProjectKeywordsByTopicID($topic->id))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		return array(
			'se'=>$se,
			'topic'=>$topic,
			'keywords'=>$keywords
		);
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_KwTracker_ReportOperations::get_instance();
		$osProjectCompetitorOps=$OS->getCompetitorOps();
		
		$viewDataVars=array();
		$topic_id=$this->processedRequest['topic']->id;
		
		if ($competitors=$osProjectCompetitorOps->getCompetitorsByTopicID($topic_id))
		{
			$competitors_stats=array();
			$displayable_competitors=array();
			$your_stats=array();
			$latest_stats=array(
				'your'=>array(),
				'competitors'=>array()
			);
			$prev_stats=array(
				'your'=>array(),
				'competitors'=>array()
			);
			$dates=array();
			$latest_2_reports=array();
			
			if ($reports=$ops->getReports($project->id))
			{
				foreach ($reports as $report_id=>$report)
				{
					if ($topic=$ops->getReportTopic($report_id,$topic_id))
					{
						if (count($latest_2_reports)<2)
						{
							$latest_2_reports[]=$report_id;
						}
						
						$your_stats[$report_id]=$topic['project_pos'];
						
						if (empty($latest_stats['your']))
						{
							if ($report_keywords=$ops->getReportKeywordsByTopicID($report_id,$topic_id))
							{
								foreach ($report_keywords as $id=>$keyword_stats)
								{
									$latest_stats['your'][$keyword_stats['keyword_id']]=$keyword_stats['project_pos'];
								}
							}
						}
						elseif (empty($prev_stats['your']))
						{
							if ($report_keywords=$ops->getReportKeywordsByTopicID($report_id,$topic_id))
							{
								foreach ($report_keywords as $id=>$keyword_stats)
								{
									$prev_stats['your'][$keyword_stats['keyword_id']]=$keyword_stats['project_pos'];
								}
							}
						}
						
						foreach ($competitors as $competitor_id=>$dummy)
						{
							if (isset($topic['competitors_pos'][$competitor_id]))
							{
								$displayable_competitors[$competitor_id]=true;
								$competitors_stats[$competitor_id][$report_id]=$topic['competitors_pos'][$competitor_id];
								
								if (empty($latest_stats['competitors'][$competitor_id]))
								{
									if ($report_keywords=$ops->getReportKeywordsByTopicID($report_id,$topic_id))
									{
										foreach ($report_keywords as $id=>$keyword_stats)
										{
											$latest_stats['competitors'][$competitor_id][$keyword_stats['keyword_id']]=$keyword_stats['competitors_pos'][$competitor_id];
										}
									}
								}
								elseif (empty($prev_stats['competitors'][$competitor_id]))
								{
									if ($report_keywords=$ops->getReportKeywordsByTopicID($report_id,$topic_id))
									{
										foreach ($report_keywords as $id=>$keyword_stats)
										{
											$prev_stats['competitors'][$competitor_id][$keyword_stats['keyword_id']]=$keyword_stats['competitors_pos'][$competitor_id];
										}
									}
								}
							}
							else
							{
								$competitors_stats[$competitor_id][$report_id]=array('p1'=>0,'t10'=>0,'t30'=>0,'others'=>0);
							}
						}
					}
					
					$dates[$report_id]=date("d M",strtotime($report->report_dt));
				}
				
				foreach ($latest_2_reports as $report_id)
				{
					if ($report_keywords=$ops->getReportKeywordsByTopicID($report_id,$topic_id))
					{
						
					}
				}
			}
			
			foreach ($latest_stats['your'] as $keyword_id=>$value)
			{
				$latest_stats['your'][$keyword_id]=array(
					'value'=>$value,
					'change'=>(isset($prev_stats['your'][$keyword_id])?$value-$prev_stats['your'][$keyword_id]:0)
				);
			}
			
			foreach ($latest_stats['competitors'] as $competitor_id=>$positions)
			{
				foreach ($positions as $keyword_id=>$value)
				{
					$latest_stats['competitors'][$competitor_id][$keyword_id]=array(
						'value'=>$value,
						'change'=>(isset($prev_stats['competitors'][$competitor_id][$keyword_id])?$value-$prev_stats['competitors'][$competitor_id][$keyword_id]:0)
					);
				}
			}

			$viewDataVars=array(
				'keywords'=>$latest_stats,
				'your_stats'=>$your_stats,
				'dates'=>$dates,
				'competitors'=>array()
			);
			
			foreach ($competitors as $competitor_id=>$competitor)
			{
				$viewDataVars['competitors'][$competitor_id]=array(
					'host'=>$competitor->host,
					'display_stats'=>(isset($displayable_competitors[$competitor_id])?true:false),
					'stats'=>(isset($displayable_competitors[$competitor_id])?$competitors_stats[$competitor_id]:array())
				);
			}
		}
		else
		{
			$viewDataVars['competitors']=false;
		}
		
		return $viewDataVars;
	}
	
	private function computeIndexesWithLabels($total_values)
	{
		$result=array(1,$total_values);

		$total_values-=($total_values%3);
		if ($total_values>2)
		{
			for ($i=2;$i<=$total_values;$i++)
			{
				if ($i%3==1)
				{
					$result[]=$i;
				}
			}
		}
		
		sort($result);
		
		return $result;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array(
			'topic_title'=>ucfirst($this->processedRequest['se']->engine).' '.strtoupper($this->processedRequest['se']->locale).' - '.$this->processedRequest['topic']->topic,
			'keywordStats'=>$viewData['keywords']
		);
		$competitorColors=array('#C13A32','#bd5e18','#f87d2c','#f8d42c','#2ce7f8','#1e87d7','#8049b9','#c329ba','#4bdbe0','#3e7e8e');
		
		$headContents=array();
		
		if ($viewData['competitors'])
		{
			$tplVars['has_competitors']=true;
			$competitor_count=0;
			$colorsCount=count($competitorColors);
			$selected_competitors=array();
			
			foreach ($viewData['competitors'] as $competitor_id=>$competitor)
			{
				$competitor_count++;
				
				$tplVars['competitors'][$competitor_id]=array(
					'is_selected'=>($competitor_count>3?false:true),
					'color'=>$competitorColors[$competitor_count % $colorsCount],
					'host'=>$competitor['host']
				);
				
				if ($competitor_count<=3)
				{
					$selected_competitors[]=$competitor_id;
				}
			}
			
//			print_r($viewData['competitors']);
			
			foreach ($this->processedRequest['keywords'] as $keyword_id=>$keyword)
			{
				$tplVars['keywords'][$keyword_id]=array(
					'keyword'=>$keyword->keyword,
					'link'=>$appPlugin->getAppActionUrl('keyword',array('keyword_id'=>$keyword_id))
				);
			}
			
			$headContents['kwtracker_competitors']="<script type='text/javascript'>
				var competitors=".json_encode($tplVars['competitors']).";
				var selectedCompetitors=[".(implode(',',$selected_competitors))."];
				var graphJeywordType='all';

				function toggleCompetitor(competitor_id)
				{
					selectedCompetitors=[];
					$('.competitor:checked').each(function (pos,element) { selectedCompetitors.push($(element).data('competitorid')); });
					var tableCellDisplay=($('#competitor_'+competitor_id).is(':checked')?'table-cell':'none');
					$('.competitor_'+competitor_id).css('display',tableCellDisplay);
				}
			</script>";
		}
		else
		{
			$tplVars['has_competitors']=false;
		}
		
		$appPlugin->setMenuBackLink(array('back_view'=>'view','view_type'=>'topic','se_id'=>$this->processedRequest['se']->id,'topic_id'=>$this->processedRequest['topic']->id));
		
		$tpl=$OS->getTemplate();
		
		if (!empty($headContents))
		{
			$tpl->setHeadContents($headContents);
		}
		
		return $tpl->fetchTemplate('competitors',$tplVars);
	}
}
?>