<?php
class OS_APPVIEW_KwTracker_Now extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (isset($requestParams['analyze']))
		{
			$ops=OS_APP_KwTracker_ReportOperations::get_instance();
			
			if ($report=$ops->getReports($project->id,false,0,1))
			{
				$report=reset($report);
				
				if ($report->status=='W')
				{
					$OS->addBoxError(_("A tracking report is already running. You cannot run two tracking reports for the same project at once."));
				}
				else
				{
					if (OS_Fork::fork('app','kwtracker','new_report',array('project_id'=>$project->id)))
					{
						$OS->redirectTO($appPlugin->getAppActionUrl('view',array('analyze_ok'=>true)),true);
					}
					else
					{
						$OS->addBoxError(_("Unable to generate a new tracking report. Try again later"));
					}
				}
			}
		}
	}
	
	public function render()
	{
		$OS=getOS();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars['analyzeURL']=$appPlugin->getAppActionUrl('analyze_now',array('analyze'=>'Y'));
		
		return $OS->getTemplate()->fetchTemplate('now',$tplVars);
	}
}
?>