<?php

class OS_APP_LinkRequest_Keywords_Operations
{
	private static $_instance;

	private $appHandler;
	
	
	public function __construct()
	{
		$this->appHandler = getOS()->getAppHandler('linkrequest');
	}

	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_LinkRequest_Keywords_Operations();
		}
		return self::$_instance;
	}

	public function getKeywordByID($partner_id)
	{
		if( $id < 1 ) return false;
		else return $this->getKeywordByDetail(array('id'=>$partner_id));
	}
	
	public function getKeywordByName($keyword)
	{
		if( $id < 1 ) return false;
		else return $this->getKeywordByDetail(array('keyword'=>$keyword));
	}
	
	
	public function getKeywordByDetail($details)
	{
		$result = false;
		$query  = false;

 		$OS = getOS();
		$db = $OS->getDb();
		
		if(isset($details['id']))  $query = "SELECT * FROM ".$this->appHandler->dbPrefix()."keywords WHERE `id` = ?";	
		elseif(isset($details['keyword']))  $query = "SELECT * FROM ".$this->appHandler->dbPrefix()."keywords WHERE `keyword` = ?";
		
		if($query)
		{
			$dbresult = $db->query($query, array_values($details));
			
			if ($row = $db->fetchRow($dbresult))
			{
				$oneKeyword = new OS_APP_LinkRequest_Keywords();
				$oneKeyword->set($row);
							
				$result = $oneKeyword;
			}
				
		}
		return $result;
	}	
	
	public function insertKeyword($oneKeyword)
	{
		$result=false;
		
 		$OS = getOS();

		$db = $OS->getDb();
		
		$insert_dt = $db->DBTimeStamp(time());
		
		$keyword_ts_utc = gmmktime();
		
		$insertData = array(
			'insert_dt' =>$insert_dt,
			'visitor_dt' => $oneKeyword->visitor_dt,
			'visitor_d' => date("Y-m-d", strtotime($oneKeyword->visitor_dt)),
			'visitor_ts_utc' => $keyword_ts_utc,

		);
		
		$query = "INSERT INTO ".$this->appHandler->dbPrefix()."keywords (`".implode("`,`", array_keys($insertData))."`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		$dbresult = $db->query($query, array_values($insertData));
		
		return $result;
	}

	public function updateKeyword($oneKeyword)
	{
		$result=false;
		
		return $result;
	}
	
	public function deleteKeywordByID($keyword_id)
	{
		if( $keyword_id < 1 ) return false;

 		$result = false;
 		$OS = getOS();
		$db = $OS->getDb();
		
		$query = "DELETE FROM ".$this->appHandler->dbPrefix()."keywords WHERE `id` = ?";
		$dbresult = $db->query($query, array($keyword_id));

		if ($dbresult !== false)
		{
			$result = true;
		}

		return $result;
	}
}
?>