<?php
class OS_APP_OnPage_Report
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $urls;
	public $errors;
	public $warnings;
	public $notices;
	public $insert_dt;
	
	public $failed_tests;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_OnPage_Report();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=false;
		$this->project_id=0;
		$this->urls=0;
		$this->errors=0;
		$this->warnings=0;
		$this->notices=0;
		$this->insert_dt='';
		
		$this->failed_tests=array();
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_OnPage_ReportOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertReport($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateReport($this);
		}
		
		if ($result)
		{
			$this->saveDetails();
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_OnPage_ReportOperations::get_instance();
			
			if ($data=$ops->getReportByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function saveDetails()
	{
		$result=false;
		
		if ($this->id AND $this->failed_tests)
		{
			$ops=OS_APP_OnPage_ReportOperations::get_instance();
			
			$result=$ops->saveReportDetails($this);
		}
		
		return $result;
	}
	
	public function getDetails()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=OS_APP_OnPage_ReportOperations::get_instance();
			
			$this->failed_tests=$ops->getReportDetails($this);
			
			$result=$this->failed_tests;
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		
		$report_arr=array(
			'id'=>$this->id,
			'urls'=>$this->urls,
			'errors'=>$this->errors,
			'warnings'=>$this->warnings,
			'notices'=>$this->notices,
			'insert_dt'=>$this->insert_dt,
			'insert_dt_human'=>$utils->humanizeDate($this->insert_dt)
		);
		
		return $report_arr;
	}
}
?>