<?php
class OS_APPVIEW_OnPage_Main extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$db=$OS->getDb();
		$ops=OS_APP_OnPage_ReportOperations::get_instance();
		
//		$osTimeframe=$OS->getTimeframe();
//		
//		$timeframe=$osTimeframe->getTimeframe();
//		
//		$viewDataVars=array();
//		
//		if ($timeframe)
//		{
//			if (!$reports=$ops->getReportsByTimeframe($timeframe['first'].' 00:00:00',$timeframe['last'].' 23:59:59'))
//			{
//				$reports=$ops->getReports(0,1);
//			}
//		}
//		else
//		{
//			$reports=$ops->getReports(0,1);
//		}

		$reports=$ops->getReports(0,10);

		$viewDataVars['stats']=array(
			'errors'=>array(),
			'warnings'=>array(),
			'notices'=>array()
		);
		
		if ($reports)
		{
			$viewDataVars['report']=reset($reports);
			
			$viewDataVars['report']->getDetails();
			
			$reports=array_reverse($reports,true);
			
			$actual_days=0;
			
			foreach ($reports as $report)
			{
				$day=date('Y-m-d',strtotime($report->insert_dt));
				
				$viewDataVars['stats']['errors'][$day]=$report->errors;
				$viewDataVars['stats']['warnings'][$day]=$report->warnings;
				$viewDataVars['stats']['notices'][$day]=$report->notices;
			}
			
			$viewDataVars['actual_stats']=(count($viewDataVars['stats']['errors'])>2);
		}
		else
		{
			$viewDataVars['report']=false;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array();
		
		if ($viewData['report'])
		{
			$tplVars['hasData']=true;
			
			$tplVars['messageTypes']=array(
				'error'=>array(
					'plural'=>'errors',
					'color'=>'red',
					'pages'=>0,
					'occurances'=>0
				),
				'warning'=>array(
					'plural'=>'warnings',
					'color'=>'yellow',
					'pages'=>0,
					'occurances'=>0
				),
				'notice'=>array(
					'plural'=>'notices',
					'color'=>'blue',
					'pages'=>0,
					'occurances'=>0
				),
			);
			
			if ($viewData['actual_stats'])
			{
				$chartValues=array();$chartTooltips=array();$chartLabels=array();
				foreach ($viewData['stats'] as $type=>$stats)
				{
					foreach ($stats as $day=>$actions)
					{
						$chartValues[$type][]=$actions;
						
						if ($type=='errors')
						{
							$chartLabels[]=date('d M',strtotime($day));
						}
						
						$chartTooltips[$type][]=date('d M',strtotime($day))."\n{$actions} {$type}";
					}
				}
				
				$charts = $OS->getCharts();
				
				$chartColors=array('#C13A32','#f1c40f','#3498db');
				
				$chartOptions=array(
					'values'=>array_values($chartValues),
					'labels'=>$chartLabels,
					'tooltips'=>array_values($chartTooltips),
					'normalize'=>true,
					'color'=>$chartColors,
				);
				
				$chartData = $charts->getLineChart($chartOptions);
				
				$tplVars['chart']=$chartData['html'];
			}
			else
			{
				$tplVars['chart']=false;
			}
			
			$tplVars['messages']=array();
			
			if (!empty($viewData['report']->failed_tests))
			{
				$failed_tests=$viewData['report']->failed_tests;
				
				$analyzer=OS_APP_OnPage_Analyzer::get_instance();
				$analyzer_rules=$analyzer->getRules();
				
				foreach ($analyzer_rules as $element=>$element_details)
				{
					if (!empty($element_details['not_found']) AND isset($failed_tests[$element]['overall']['not_found']))
					{
						$tplVars['messages'][$element_details['not_found']['level']][]=array(
							'element'=>$element,
							'test_type'=>'overall',
							'test_name'=>'not_found',
							'pagelist_url'=>$appPlugin->getAppActionUrl('pagelist',array('element'=>$element,'test_type'=>'overall','test_name'=>'not_found')),
							'message'=>array(
								'pages'=>$failed_tests[$element]['overall']['not_found']['pages'],
								'occurances'=>$failed_tests[$element]['overall']['not_found']['occurances'],
								'desc'=>$element_details['not_found']['list_message']
							)
						);
						
						$tplVars['messageTypes'][$element_details['not_found']['level']]['pages']+=$failed_tests[$element]['overall']['not_found']['pages'];
						$tplVars['messageTypes'][$element_details['not_found']['level']]['occurances']+=$failed_tests[$element]['overall']['not_found']['occurances'];
					}
					
					if (!empty($element_details['tests_overall']))
					{
						foreach ($element_details['tests_overall'] as $test_name=>$test_details)
						{
							if (isset($failed_tests[$element]['overall'][$test_name]))
							{
								$tplVars['messages'][$test_details['level']][]=array(
									'element'=>$element,
									'test_type'=>'overall',
									'test_name'=>$test_name,
									'pagelist_url'=>$appPlugin->getAppActionUrl('pagelist',array('element'=>$element,'test_type'=>'overall','test_name'=>$test_name)),
									'message'=>array(
										'pages'=>$failed_tests[$element]['overall'][$test_name]['pages'],
										'occurances'=>$failed_tests[$element]['overall'][$test_name]['occurances'],
										'desc'=>$test_details['list_message']
									)
								);
								
								$tplVars['messageTypes'][$test_details['level']]['pages']+=$failed_tests[$element]['overall'][$test_name]['pages'];
								$tplVars['messageTypes'][$test_details['level']]['occurances']+=$failed_tests[$element]['overall'][$test_name]['occurances'];
							}
						}
					}
					
					if (!empty($element_details['tests_element']))
					{
						foreach ($element_details['tests_element'] as $test_name=>$test_details)
						{
							if (isset($failed_tests[$element]['element'][$test_name]))
							{
								$tplVars['messages'][$test_details['level']][]=array(
									'element'=>$element,
									'test_type'=>'element',
									'test_name'=>$test_name,
									'pagelist_url'=>$appPlugin->getAppActionUrl('pagelist',array('element'=>$element,'test_type'=>'element','test_name'=>$test_name)),
									'message'=>array(
										'pages'=>$failed_tests[$element]['element'][$test_name]['pages'],
										'occurances'=>$failed_tests[$element]['element'][$test_name]['occurances'],
										'desc'=>$test_details['list_message']
									)
								);
								
								$tplVars['messageTypes'][$test_details['level']]['pages']+=$failed_tests[$element]['element'][$test_name]['pages'];
								$tplVars['messageTypes'][$test_details['level']]['occurances']+=$failed_tests[$element]['element'][$test_name]['occurances'];
							}
						}
					}
				}
			}
		}
		else
		{
			$tplVars['hasData']=false;
			
			$tplVars['crawl_now_url']=$appPlugin->getAppActionUrl('crawl_now');
		}
		
		$tpl=$OS->getTemplate();
		
		$headContents=array(
			'css'=>array('onpage_page'=>$appPlugin->getAppHomeUrl()."/resources/view.css")
		);
		
		if ($tplVars['hasData'] AND $viewData['actual_stats'])
		{
			$headContents=array_merge($headContents,$chartData['js']);
		}
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('view',$tplVars);
	}
}
?>