<?php
class OS_APPVIEW_OnPage_Pagelist extends OS_AppViewBase
{
	private $urlsPerPage=10;
	
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['element']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if (empty($requestParams['test_type']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if (empty($requestParams['test_name']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$analyzer=OS_APP_OnPage_Analyzer::get_instance();
		$analyzer_rules=$analyzer->getRules();
		
		if (!isset($analyzer_rules[$requestParams['element']]))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$processedRequest=array();
		
		if ($requestParams['test_type']=='overall' AND $requestParams['test_name']=='not_found')
		{
			if (!isset($analyzer_rules[$requestParams['element']]['not_found']))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
			else
			{
				$processedRequest['test_title']=$analyzer_rules[$requestParams['element']]['not_found']['list_message'];
			} 
		}
		elseif (!isset($analyzer_rules[$requestParams['element']]['tests_'.$requestParams['test_type']][$requestParams['test_name']]))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		else
		{
			$processedRequest['test_title']=$analyzer_rules[$requestParams['element']]['tests_'.$requestParams['test_type']][$requestParams['test_name']]['list_message'];
		}
		
		$ops=OS_APP_OnPage_ReportOperations::get_instance();
		
		if (!$processedRequest['total_pages']=$ops->getPagesCount($requestParams['element'],$requestParams['test_type'],$requestParams['test_name']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$page=1;
		if (!empty($requestParams['page']) AND ($requestParams['page']>0) AND (($requestParams['page']-1)*$this->urlsPerPage<$processedRequest['total_pages']))
		{
			$page=$requestParams['page'];
		}
		$processedRequest['page']=$page;
		
		$processedRequest['test_details']=array(
			'element'=>$requestParams['element'],
			'test_type'=>$requestParams['test_type'],
			'test_name'=>$requestParams['test_name'],
			'page'=>$page
		);
		
		return $processedRequest;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_OnPage_ReportOperations::get_instance();
		
		$viewDataVars=array();
		
		if ($this->processedRequest['page']*$this->urlsPerPage<$this->processedRequest['total_pages'])
		{
			$viewDataVars['next_page_url']=$appPlugin->getAppActionUrl('pagelist',array_merge($this->processedRequest['test_details'],array('page'=>$this->processedRequest['page']+1)));
		}
		else
		{
			$viewDataVars['next_page_url']=false;
		}
		
		if ($this->processedRequest['page']>1)
		{
			$viewDataVars['prev_page_url']=$appPlugin->getAppActionUrl('pagelist',array_merge($this->processedRequest['test_details'],array('page'=>$this->processedRequest['page']-1)));
		}
		else
		{
			$viewDataVars['prev_page_url']=false;
		}
		
		$viewDataVars['pages']=$ops->getPages($this->processedRequest['test_details']['element'],$this->processedRequest['test_details']['test_type'],$this->processedRequest['test_details']['test_name'],($this->processedRequest['page']-1)*$this->urlsPerPage,$this->urlsPerPage);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array(
			'test_title'=>$this->processedRequest['test_title'],
			'next_page_url'=>$viewData['next_page_url'],
			'prev_page_url'=>$viewData['prev_page_url']
		);
		
		$appPlugin->setMenuBackLink(array('back_view'=>'view'));
		
		if ($viewData['pages'])
		{
			$osUtils=$OS->getUtils();
			
			foreach ($viewData['pages'] as $url_hash=>$page_details)
			{
				$tplVars['pages'][$url_hash]=array(
					'url'=>$page_details['url'],
					'url_safe'=>$osUtils->getSafeURL($page_details['url']),
					'title'=>$page_details['title'],
					'page_report_url'=>$appPlugin->getAppActionUrl('page',array_merge($this->processedRequest['test_details'],array('url_hash'=>$url_hash)))
				);
			}
		}
		else
		{
			$tplVars['pages']=false;
		}
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('pagelist',$tplVars);
	}
}
?>