<?php
class OS_APPVIEW_OnPage_Report extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_Onpage_ReportOperations::get_instance();
		
		$viewDataVars=array();
		
		if ($report=$ops->getReports(0,1))
		{
			$report=reset($report);
			
			$report->getDetails();
			
			$analyzer=OS_APP_OnPage_Analyzer::get_instance();
			$analyzer_rules=$analyzer->getRules();
			
			$osUtils=$OS->getUtils();
			
			if ($report->failed_tests)
			{
				$failed_tests=$report->failed_tests;
				
				$reportData=array(
					'filename'=>'onpage_seo_audit.pdf',
					'title'=>_('OnPage SEO Audit'),
					'sections'=>array()
				);
				
				$status_importance=array('ok'=>0,'notice'=>1,'warning'=>2,'error'=>3);
				$status_colors=array(
					'ok'=>'#a1c132',
					'notice'=>'#3498db',
					'warning'=>'#f1c40f',
					'error'=>'#C13A32'
				);
				
				$sections=array();
				
				$appHomeUrl=$appPlugin->getAppHomeUrl();
				$appHomePath=$appPlugin->getAppHomePath();
				
				foreach ($analyzer_rules as $element=>$element_details)
				{
//					$section_status='ok';
					$extraText=false;
					$section_messages=array();
					
					if (!empty($element_details['not_found']) AND empty($element_details['not_found']['requires_keyword']))
					{
						if (isset($failed_tests[$element]['overall']['not_found']))
						{
							$value=$osUtils->humanizeInteger($failed_tests[$element]['overall']['not_found']['pages']).' '.($failed_tests[$element]['overall']['not_found']['pages']==1?'page':'pages');
							$addAdvice=true;
						}
						else
						{
							$value='0 pages';
							$addAdvice=false;
						}
						
						$message=(empty($element_details['not_found']['report_message'])?$element_details['not_found']['list_message']:$element_details['not_found']['report_message']);
						
						$section_messages[$element.'_overall_not_found']=array(
							'type'=>'label_value',
							'label'=>array(
								'color'=>$status_colors[$element_details['not_found']['level']],
								'text'=>$message
							),
							'separator'=>' - ',
							'value'=>array(
								'text'=>$value
							)
						);
						
						if (isset($element_details['not_found']['advice']) AND $addAdvice)
						{
							$extraText.=(empty($extraText)?'':"\n\n").$element_details['not_found']['list_message'].' - '.$element_details['not_found']['advice'];
						}
						
//						$section_status=array_search(max($status_importance[$section_status],$status_importance[$element_details['not_found']['level']]),$status_importance);
					}
					
					if (!empty($element_details['tests_overall']))
					{
						foreach ($element_details['tests_overall'] as $test_name=>$test_details)
						{
							if (empty($test_details['requires_keyword']))
							{
								if (isset($failed_tests[$element]['overall'][$test_name]))
								{
									$value=$osUtils->humanizeInteger($failed_tests[$element]['overall'][$test_name]['pages']).' '.($failed_tests[$element]['overall'][$test_name]['pages']==1?'page':'pages');
									$addAdvice=true;
								}
								else
								{
									$value='0 pages';
									$addAdvice=false;								
								}
								
								$message=(empty($test_details['report_message'])?$test_details['list_message']:$test_details['report_message']);
								
								$section_messages[$element.'_overall_'.$test_name]=array(
									'type'=>'label_value',
									'label'=>array(
										'color'=>$status_colors[$test_details['level']],
										'text'=>$message
									),
									'separator'=>' - ',
									'value'=>array(
										'text'=>$value
									)
								);
								
								if (isset($test_details['advice']) AND $addAdvice)
								{
									$extraText.=(empty($extraText)?'':"\n\n").$test_details['list_message'].' - '.$test_details['advice'];
								}
								
//								$section_status=array_search(max($status_importance[$section_status],$status_importance[$test_details['level']]),$status_importance);
							}
						}
					}
					
					if (!empty($element_details['tests_element']))
					{
						foreach ($element_details['tests_element'] as $test_name=>$test_details)
						{
							if (empty($test_details['requires_keyword']))
							{
								if (isset($failed_tests[$element]['element'][$test_name]))
								{
									$value=$osUtils->humanizeInteger($failed_tests[$element]['element'][$test_name]['pages']).' '.($failed_tests[$element]['element'][$test_name]['pages']==1?'page':'pages');
									$addAdvice=true;
								}
								else
								{
									$value='0 pages';
									$addAdvice=false;
								}
								
								$message=(empty($test_details['report_message'])?$test_details['list_message']:$test_details['report_message']);
								
								$section_messages[$element.'_element_'.$test_name]=array(
									'type'=>'label_value',
									'label'=>array(
										'color'=>$status_colors[$test_details['level']],
										'text'=>$message
									),
									'separator'=>' - ',
									'value'=>array(
										'text'=>$value
									)
								);
								
								if (isset($test_details['advice']) AND $addAdvice)
								{
									$extraText.=(empty($extraText)?'':"\n\n").$test_details['list_message'].' - '.$test_details['advice'];
								}
								
//								$section_status=array_search(max($status_importance[$section_status],$status_importance[$test_details['level']]),$status_importance);
							}
						}
					}
					
					if (!empty($section_messages))
					{
						$section=(empty($element_details['report_section'])?$element:$element_details['report_section']);
						$title=(empty($element_details['report_section_human'])?$element_details['human_name']:$element_details['report_section_human']);
						
//						if (empty($sections[$section_status][$section]))
//						{
//							$sections[$section_status][$section]=array(
//								'title'=>$title,
////								'title_color'=>$status_colors[$section_status],
//								'type'=>'messages',
//								'messages'=>array(),
//								'extraText'=>''
//							);
//							
//							$icon_path=os_join_path($appHomePath,'resources','images','report',"{$section}.png");
//							if (file_exists($icon_path))
//							{
//								$sections[$section_status][$section]['icon']="{$appHomeUrl}/resources/images/report/{$section}.png";
//							}
//						}
//						
//						foreach ($section_messages as $key=>$val)
//						{
//							$sections[$section_status][$section]['messages'][$key]=$val;
//						}
//						
//						$sections[$section_status][$section]['extraText'].=(empty($sections[$section_status][$section]['extraText'])?'':"\n").$extraText;
						
						if (empty($sections[$section]))
						{
							$sections[$section]=array(
								'title'=>$title,
//								'title_color'=>$status_colors[$section_status],
								'type'=>'messages',
								'messages'=>array(),
								'extraText'=>''
							);
							
							$icon_path=os_join_path($appHomePath,'resources','images','report',"{$section}.png");
							if (file_exists($icon_path))
							{
								$sections[$section]['icon']="{$appHomeUrl}/resources/images/report/{$section}.png";
							}
						}
						
						foreach ($section_messages as $key=>$val)
						{
							$sections[$section]['messages'][$key]=$val;
						}
						
						$sections[$section]['extraText'].=(empty($sections[$section]['extraText'])?'':"\n").$extraText;
					}
				}

				$score_distribution=array('low'=>0,'below_average'=>0,'above_average'=>0,'high'=>0);
				
				$db=$OS->getDb();
				
				$score_sum=0;
				$total=0;
				$dbresult=$db->query("SELECT * FROM ".$appPlugin->dbPrefix()."pages_error_profiles WHERE project_id=?",array($project->id));
				while ($row=$db->fetchRow($dbresult))
				{
					$total++;
					$score_sum+=$row['score'];
					
					$score_cat=($row['score']<25?'low':($row['score']<50?'below_average':($row['score']<75?'above_average':'high')));
					$score_distribution[$score_cat]++;
				}
				
				if ($total<$report->urls)
				{
					$score_sum+=($report->urls-$total)*100;
					$score_distribution['high']+=$report->urls-$total;
				}
				
				$overall_seo_score=round($score_sum/$report->urls,2);
				$overall_seo_score_status=$score_cat=($overall_seo_score<25?'error':($overall_seo_score<50?'warning':($overall_seo_score<75?'notice':'ok')));
				
				$osChartsImage=$OS->getChartsImage();
				
				$overviewChartData=array();
				if ($report->errors>0)
				{
					$overviewChartData[]=array('label'=>_('Errors'),'value'=>$report->errors,'color'=>$status_colors['error']);
				}
				if ($report->warnings>0)
				{
				$overviewChartData[]=array('label'=>_('Warnings'),'value'=>$report->warnings,'color'=>$status_colors['warning']);
				}
				if ($report->notices>0)
				{
				$overviewChartData[]=array('label'=>_('Notices'),'value'=>$report->notices,'color'=>$status_colors['notice']);
				}
				
				if (!empty($overviewChartData))
				{
					$overviewChartUrl=$osChartsImage->getChartUrl('pie',$overviewChartData);
				}
				else
				{
					$overviewChartUrl=false;
				}
				
				$reportData['sections']['overview']=array(
					'title'=>_("Overview"),
					'icon'=>"{$appHomeUrl}/resources/images/report/overview.png",
					'type'=>'messages',
					'messages'=>array(
						array(
							'type'=>'label_value',
							'label'=>array(
								'text'=>'URL'
							),
							'value'=>array(
								'text'=>$project->url
							)
						),
						array(
							'type'=>'label_value',
							'label'=>array(
								'text'=>_('OnPage SEO score')
							),
							'value'=>array(
								'color'=>$status_colors[$overall_seo_score_status],
								'text'=>$overall_seo_score.' / 100'
							)
						),
						array(
							'type'=>'label_value',
							'label'=>array(
								'text'=>_('Pages analyzed')
							),
							'value'=>array(
								'text'=>$osUtils->humanizeInteger($report->urls)
							)
						),
						array(
							'type'=>'label_value',
							'label'=>array(
								'color'=>$status_colors['error'],
								'text'=>_('Errors')
							),
							'value'=>array(
								'text'=>$osUtils->humanizeInteger($report->errors)
							)
						),
						array(
							'type'=>'label_value',
							'label'=>array(
								'color'=>$status_colors['warning'],
								'text'=>_('Warnings')
							),
							'value'=>array(
								'text'=>$osUtils->humanizeInteger($report->warnings)
							)
						),
						array(
							'type'=>'label_value',
							'label'=>array(
								'color'=>$status_colors['notice'],
								'text'=>_('Notices')
							),
							'value'=>array(
								'text'=>$osUtils->humanizeInteger($report->notices)
							)
						),
					),
					'sectionChart'=>$overviewChartUrl,
					'sectionChartWidth'=>60
				);
				
				$scoreChartData=array();
				if ($score_distribution['low']>0)
				{
					$scoreChartData[]=array('label'=>'Low','value'=>$score_distribution['low'],'color'=>$status_colors['error']);
				}
				if ($score_distribution['below_average']>0)
				{
					$scoreChartData[]=array('label'=>'Below average','value'=>$score_distribution['below_average'],'color'=>$status_colors['warning']);
				}
				if ($score_distribution['above_average']>0)
				{
					$scoreChartData[]=array('label'=>'Above average','value'=>$score_distribution['above_average'],'color'=>$status_colors['notice']);
				}
				if ($score_distribution['high']>0)
				{
					$scoreChartData[]=array('label'=>'High','value'=>$score_distribution['high'],'color'=>$status_colors['ok']);
				}
				
				if (!empty($scoreChartData))
				{
					$scoreChartUrl=$osChartsImage->getChartUrl('pie',$scoreChartData);
				}
				else
				{
					$scoreChartUrl=false;
				}
				
				$reportData['sections']['score_distribution']=array(
					'title'=>_("OnPage SEO Score Distribution"),
					'icon'=>"{$appHomeUrl}/resources/images/report/seo_score.png",
					'type'=>'messages',
					'messages'=>array(
						array(
							'type'=>'label_value',
							'label'=>array(
								'color'=>$status_colors['error'],
								'text'=>_('Low (<25)')
							),
							'value'=>array(
								'text'=>$osUtils->humanizeInteger($score_distribution['low']).' '.($score_distribution['low']==1?'page':'pages')
							)
						),
						array(
							'type'=>'label_value',
							'label'=>array(
								'color'=>$status_colors['warning'],
								'text'=>_('Below average (25-50)')
							),
							'value'=>array(
								'text'=>$osUtils->humanizeInteger($score_distribution['below_average']).' '.($score_distribution['below_average']==1?'page':'pages')
							)
						),
						array(
							'type'=>'label_value',
							'label'=>array(
								'color'=>$status_colors['notice'],
								'text'=>_('Above average (50-75)')
							),
							'value'=>array(
								'text'=>$osUtils->humanizeInteger($score_distribution['above_average']).' '.($score_distribution['above_average']==1?'page':'pages')
							)
						),
						array(
							'type'=>'label_value',
							'label'=>array(
								'color'=>$status_colors['ok'],
								'text'=>_('High (>75)')
							),
							'value'=>array(
								'text'=>$osUtils->humanizeInteger($score_distribution['high']).' '.($score_distribution['high']==1?'page':'pages')
							)
						),
					),
					'sectionChart'=>$scoreChartUrl,
					'sectionChartWidth'=>60
				);
				
				$projectCrawlOps=$OS->getProjectCrawlOps();
				
				if ($lastCrawl=$projectCrawlOps->getProjectCrawls(array('project_id'=>$project->id,'status'=>'D','set'=>'1','max_rows'=>1)))
				{
					$lastCrawl=reset($lastCrawl);
					
					$reportData['sections']['url_types']=array(
						'title'=>_("Content type distribution"),
						'icon'=>"{$appHomeUrl}/resources/images/report/content_type.png",
						'type'=>'messages',
						'messages'=>array()
					);
					
					$contentTypes=array('html'=>'HTML','xml'=>'RSS/XML','txt'=>_('Plain text'),'css'=>'CSS','js'=>'JavaScript','img'=>_('Images'),'other'=>_('Other'));
					foreach ($contentTypes as $type=>$name)
					{
						$contentVar='urls_'.$type;

						if (!empty($lastCrawl->$contentVar))
						{
							$reportData['sections']['url_types']['messages'][]=array(
								'type'=>'label_value',
								'label'=>array(
									'text'=>$name
								),
								'value'=>array(
									'text'=>$osUtils->humanizeInteger($lastCrawl->$contentVar)
								)
							);
						}
					}
					
					if (empty($reportData['sections']['url_types']['messages']))
					{
						unset($reportData['sections']['url_types']);
					}
					
					$httpChartData=array();
					if ($lastCrawl->urls_5xx>0)
					{
						$httpChartData[]=array('label'=>_('Server Errors (5xx)'),'value'=>$lastCrawl->urls_5xx,'color'=>$status_colors['error']);
					}
					if ($lastCrawl->urls_4xx>0)
					{
						$httpChartData[]=array('label'=>_('URLs Errors (4xx)'),'value'=>$lastCrawl->urls_4xx,'color'=>$status_colors['warning']);
					}
					if ($lastCrawl->urls_3xx>0)
					{
						$httpChartData[]=array('label'=>_('Redirects (3xx)'),'value'=>$lastCrawl->urls_3xx,'color'=>$status_colors['notice']);
					}
					if ($lastCrawl->urls_2xx>0)
					{
						$httpChartData[]=array('label'=>_('Successful (2xx)'),'value'=>$lastCrawl->urls_2xx,'color'=>$status_colors['ok']);
					}
					
					if (!empty($httpChartData))
					{
						$httpChartUrl=$osChartsImage->getChartUrl('pie',$httpChartData);
					}
					else
					{
						$httpChartUrl=false;
					}
					
					$reportData['sections']['http_codes']=array(
						'title'=>_("HTTP status codes (all content types)"),
						'icon'=>"{$appHomeUrl}/resources/images/report/http.png",
						'type'=>'messages',
						'messages'=>array(
							array(
								'type'=>'label_value',
								'label'=>array(
									'color'=>$status_colors['ok'],
									'text'=>_('Successful (2xx)')
								),
								'value'=>array(
									'text'=>$osUtils->humanizeInteger($lastCrawl->urls_2xx)
								)
							),
							array(
								'type'=>'label_value',
								'label'=>array(
									'color'=>$status_colors['notice'],
									'text'=>_('Redirects (3xx)')
								),
								'value'=>array(
									'text'=>$osUtils->humanizeInteger($lastCrawl->urls_3xx)
								)
							),
							array(
								'type'=>'label_value',
								'label'=>array(
									'color'=>$status_colors['warning'],
									'text'=>_('URLs Errors (4xx)')
								),
								'value'=>array(
									'text'=>$osUtils->humanizeInteger($lastCrawl->urls_4xx)
								)
							),
							array(
								'type'=>'label_value',
								'label'=>array(
									'color'=>$status_colors['error'],
									'text'=>_('Server Errors (5xx)')
								),
								'value'=>array(
									'text'=>$osUtils->humanizeInteger($lastCrawl->urls_5xx)
								)
							),
						),
						'sectionChart'=>$httpChartUrl,
						'sectionChartWidth'=>60
					);
					
					$dbresult=$db->query("SELECT SUM(links_external_nofollow) AS total_links_external_nofollow, SUM(links_external_dofollow) AS total_links_external_dofollow FROM ".$db->dbPrefix()."projects_urls WHERE project_id=?",array($project->id));
					$row=$db->fetchRow($dbresult);
					
					$outgoingLinksChartData=array();
					if ($row['total_links_external_nofollow']>0)
					{
						$outgoingLinksChartData[]=array('label'=>'Nofollow','value'=>$row['total_links_external_nofollow'],'color'=>$status_colors['ok']);
					}
					if ($row['total_links_external_dofollow']>0)
					{
						$outgoingLinksChartData[]=array('label'=>'Dofollow','value'=>$row['total_links_external_dofollow'],'color'=>$status_colors['error']);
					}
					
					if (!empty($outgoingLinksChartData))
					{
						$outgoingLinksChartUrl=$osChartsImage->getChartUrl('pie',$outgoingLinksChartData);
					}
					else
					{
						$outgoingLinksChartUrl=false;
					}
					
					$reportData['sections']['outgoing_links']=array(
						'title'=>_("Outgoing Links Distribution"),
						'icon'=>"{$appHomeUrl}/resources/images/report/outgoing_links.png",
						'type'=>'messages',
						'messages'=>array(
							array(
								'type'=>'label_value',
								'label'=>array(
									'color'=>$status_colors['ok'],
									'text'=>_('Nofollow links')
								),
								'value'=>array(
									'text'=>$osUtils->humanizeInteger($row['total_links_external_nofollow'])
								)
							),
							array(
								'type'=>'label_value',
								'label'=>array(
									'color'=>$status_colors['error'],
									'text'=>_('Dofollow links')
								),
								'value'=>array(
									'text'=>$osUtils->humanizeInteger($row['total_links_external_dofollow'])
								)
							),
						),
						'sectionChart'=>$outgoingLinksChartUrl,
						'sectionChartWidth'=>60
					);
					
					$reachability=array();
					$prev_clicks=0;
					$dbresult=$db->query("SELECT depth,COUNT(*) AS urls FROM ".$db->dbPrefix()."projects_urls WHERE project_id=? AND file_type=? GROUP BY depth ORDER BY depth ASC",array($project->id,'html'));
					while ($row=$db->fetchRow($dbresult))
					{
						$clicks=$row['depth']-1;
						
						if ($clicks>$prev_clicks+1)
						{
							for ($i=$prev_clicks+1;$i<$clicks;$i++)
							{
								$reachability[$i]=0;
							}
						}
						
						$reachability[$clicks]=$row['urls'];
						
						$prev_clicks=$clicks;
					}
					
					if ($reachability)
					{
						$chartData=array(
							'x_name'=>_("Clicks"),
							'y_name'=>_("Pages"),
							'labels'=>array_keys($reachability),
							'bars'=>array(
								array(
									'name'=>_("Reachability"),
									'values'=>array_values($reachability),
									'color'=>$status_colors['notice']
								)
							)
						);
						
						$reportData['sections']['reachability']=array(
							'title'=>_("Page reachability"),
							'icon'=>"{$appHomeUrl}/resources/images/report/page_reachability.png",
							'type'=>'image',
							'image_url'=>$osChartsImage->getChartUrl('bar',$chartData),
							'image_data'=>$reachability
						);
					}
				}
				
//				foreach ($sections as $status=>$status_sections)
//				{
//					foreach ($status_sections as $section=>$sectionData)
//					{
//						$reportData['sections'][$section]=$sectionData;
//					}
//				}

				foreach ($sections as $section=>$sectionData)
				{
					$reportData['sections'][$section]=$sectionData;
				}
				
				$viewDataVars['report']=$reportData;
			}
			else
			{
				$viewDataVars['report']=false;
			}
		}
		else
		{
			$viewDataVars['report']=false;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$viewData=$this->buildViewData();
		
		if ($viewData['report'])
		{
			$osReport=$OS->getReport();
			
			$osReport->generateReport($viewData['report']);
		}
		else
		{
			return $OS->getTemplate()->fetchTemplate('report');
		}
	}
}
?>