<?php
class OS_APPVIEW_OnPage_ReportEvolution extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_Onpage_ReportOperations::get_instance();
		
		$viewDataVars=array();
		
		if ($reports=$ops->getReports(0,10))
		{
			if (count($reports)>=2)
			{
				$stats=array('errors'=>array(),'warnings'=>array(),'notices'=>array());
				$stats_names=array('errors'=>_('Errors'),'warnings'=>_('Warnings'),'notices'=>_('Notices'));
				
				foreach ($reports as $report)
				{
					$day=date('d M',strtotime($report->insert_dt));
					
					foreach ($stats as $type=>$dummy)
					{
						$stats[$type][$day]=$report->$type;
					}
				}
				
				foreach ($stats as $type=>$actual_stats)
				{
					$stats[$type]=array_reverse($actual_stats);
				}
				
				$stats_colors=array(
					'notices'=>'#3498db',
					'warnings'=>'#f1c40f',
					'errors'=>'#C13A32'
				);
				
				$osChartsImage=$OS->getChartsImage();
				$appHomeUrl=$appPlugin->getAppHomeUrl();
				
				$reportData=array(
					'filename'=>'onpage_seo_evolution.pdf',
					'title'=>_('OnPage SEO Evolution'),
					'sections'=>array()
				);
				
				foreach ($stats as $type=>$actual_stats)
				{
					$chartData=array(
						'y_name'=>$stats_names[$type],
						'labels'=>array_keys($actual_stats),
						'lines'=>array(
							array(
								'name'=>$stats_names[$type],
								'values'=>array_values($actual_stats),
								'color'=>$stats_colors[$type]
							)
						)
					);
					
					$reportData['sections'][$type]=array(
						'title'=>$stats_names[$type],
						'title_color'=>$stats_colors[$type],
						'icon'=>"{$appHomeUrl}/resources/images/report/{$type}.png",
						'type'=>'image',
						'image_url'=>$osChartsImage->getChartUrl('line',$chartData)
					);
				}
				
				$viewDataVars['report']=$reportData;
			}
			else
			{
				$viewDataVars['report']=false;
			}
		}
		else
		{
			$viewDataVars['report']=false;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$viewData=$this->buildViewData();
		
		if ($viewData['report'])
		{
			$osReport=$OS->getReport();
			
			$osReport->generateReport($viewData['report']);
		}
		else
		{
			return $OS->getTemplate()->fetchTemplate('report');
		}
	}
}
?>