<?php
class OS_APPVIEW_OnPage_Urls extends OS_AppViewBase
{
	private $urlsPerPage=10;
	
	private $orderBy='depth';
	
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$db=$OS->getDb();
		$project=$OS->getProject();
		
		$requestParams=$appPlugin->getRequestParams();
		
		$dbresult=$db->query("SELECT COUNT(*) AS total_pages FROM ".$db->dbPrefix()."projects_urls WHERE project_id=? AND file_type=? AND http_code>=? AND http_code<?",array($project->id,'html',100,300));
		$processedRequest=$db->fetchRow($dbresult);
		
		if (!$processedRequest['total_pages'])
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$page=1;
		if (!empty($requestParams['page']) AND ($requestParams['page']>0) AND (($requestParams['page']-1)*$this->urlsPerPage<$processedRequest['total_pages']))
		{
			$page=$requestParams['page'];
		}
		$processedRequest['page']=$page;
		
		$processedRequest['urls']=array();
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."projects_urls WHERE project_id=? AND file_type=? AND http_code>=? AND http_code<? ORDER BY {$this->orderBy} LIMIT ".(($page-1)*$this->urlsPerPage).",{$this->urlsPerPage}",array($project->id,'html',100,300));
		while ($row=$db->fetchRow($dbresult))
		{
			$processedRequest['urls'][$row['id']]=$row;
		}
		
		return $processedRequest;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_OnPage_ReportOperations::get_instance();
		
		$viewDataVars=array();
		
		if ($this->processedRequest['page']*$this->urlsPerPage<$this->processedRequest['total_pages'])
		{
			$viewDataVars['next_page_url']=$appPlugin->getAppActionUrl('urls',array('page'=>$this->processedRequest['page']+1));
		}
		else
		{
			$viewDataVars['next_page_url']=false;
		}
		
		if ($this->processedRequest['page']>1)
		{
			$viewDataVars['prev_page_url']=$appPlugin->getAppActionUrl('urls',array('page'=>$this->processedRequest['page']-1));
		}
		else
		{
			$viewDataVars['prev_page_url']=false;
		}
		
		$osUtils=$OS->getUtils();
		
		$viewDataVars['urls']=array();
		foreach ($this->processedRequest['urls'] as $url_id=>$details)
		{
			$viewDataVars['urls'][$url_id]=$details;
			$viewDataVars['urls'][$url_id]['url_safe']=$osUtils->getSafeURL($details['url']);
			$viewDataVars['urls'][$url_id]['_details_url']=$appPlugin->getAppActionUrl('page',array('url_hash'=>$details['url_hash'],'page'=>$this->processedRequest['page']));
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->buildViewData();
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('urls',$tplVars);
	}
}
?>