<?php
class OS_APPCRON_OrganicImages_CronBuilder
{
	private $appHandler;
	
	private $appPlugin;
	
	private $db;
	
	private $projectOps;
	
	private $bufferData;

	public function __construct() 
	{
		$OS = getOS();
		$this->appHandler = $OS->getAppHandler('organicimages');
		$this->bufferData = array();
	}
	
	public function run()
	{
		$fpath = os_join_path(getOS()->getConfigVar('cache_path'), 'tmp', 'trk_appcron_organicimages_cronbuilder.log');
		$dirname = dirname($fpath);
		
		if(file_exists($fpath)) unlink($fpath);
		if(!is_dir($dirname)) mkdir($dirname, 0755, true);
		
		
		$current_log = floor(time()/3600);
		$logs_path = os_join_path($this->appHandler->getAppStoragePath(),'buffer');
		
		$ctime = time();
		$files = glob($logs_path.'/*.log');
		
		foreach($files as $file_id=>$file)
		{
			$filename = basename($file,'.log');
			if ((int)$filename < $current_log)
			{
				$renameResult = rename($file,$file.'.old');
				$file.='.old';
				
				if ($file_handler = fopen($file,'r'))
				{
					while (!feof($file_handler))
					{
						if ($line=fgets($file_handler))
						{
							$this->handleBufferData(str_replace("\n","",$line));		
						}
					}
					
					fclose($file_handler);
				}
			}
		}
		
		$this->updateBufferData();
		
		return true;
	}
	
	private function handleBufferData($bufferData)
	{
		$this->bufferData[] = json_decode($bufferData, true);
	}
	
	
	private function updateBufferData()
	{
		$fpath = os_join_path(getOS()->getConfigVar('cache_path'), 'tmp', 'trk_appcron_organicimages_cronbuilder.log');
		
		if(!empty($this->bufferData))
		{
			//lock DB table
			foreach($this->bufferData as $details)
			{
				$oneImage = new OS_APP_organicimages_Image();
				$oneImage->set($details);
				$oneImage->save();
				file_put_contents($fpath, var_export(get_object_vars($oneImage), true)."\n", FILE_APPEND);
			}
			//unlock DB table
		}
	}
}
?>