<?php

class OS_APP_OrganicImages_Image
{
	public $id;
	public $project_id;
	public $insert_dt;
	public $visitor_dt;
	public $content_url;
	public $content_filename;
	public $content_filename_length;
	public $content_alt;
	public $content_title;
	public $content_width;
	public $content_height;
	public $referer_keywords;
	public $visitor_ip;
	public $page_url;
	public $page_url_hash;
	public $page_title;
	public $image_link_url;
	public $image_link_title;
	public $image_link_rel;
	public $image_link_target;
	public $location_continent_code;
	public $location_continent_name;
	public $location_country_code;
	public $location_country_name;
	public $content_id;
	public $referer_id;
	public $location_id;
	public $page_id;
	public $image_link_id;
	
	public function __construct(){}
	
	public function get($param)
	{
		$result = null;
		
		if(isset($this->$param))
		{
			$result = $this->$param; 
		}
		return $result;
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		if(is_object($data))
		{
			$data = get_object_vars($data);
		}
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result = false;
		
		$imageOps = OS_APP_organicimages_Operations::get_instance();
		
		if ($this->id ==  null)
		{
			$this->beforeInsertImage();
			
			$newid = $imageOps->insertImage($this);
			if ($newid > -1)
			{
				$this->id = $newid;
				$this->afterInsertImage();
				$result = true;
			}
		}

		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id > -1)
		{
			$OS = getOS();
			
			//Remove user record from the database
			$imageOps = OS_APP_organicimages_Operations::get_instance();
			
			$deleteResult = $imageOps->deleteImageByID($this->id);
			if ($deleteResult)
			{
				$result = true;
			}
		}

		return $result;
	}
	
	
	private function afterInsertImage() {}
	
	private function beforeInsertImage()
	{
		//add data into dimensions tables
		
		$requiredVals = array('content_url', 'content_alt', 'content_title', 'content_width' ,'content_height', 'referer_keywords','content_filename','content_filename_length','image_link_title','image_link_url','image_link_rel','image_link_target','image_link_id');
		foreach($requiredVals as $val)
		{
			if(is_null($this->$val)) $this->$val = "";
		}
		
		$imageOps = OS_APP_organicimages_Operations::get_instance();
		
		//handle content dimension
		$newImage = $imageOps->insertTrackContent($this);
		
		//handle page dimension
		$newImage = $imageOps->insertTrackPage($newImage);
		
		//handle location dimension
		$newImage = $imageOps->insertTrackLocation($newImage);
		
		//handle referer dimension
		$newImage = $imageOps->insertTrackReferer($newImage);
		
		//handle image link dimension
		$newImage = $imageOps->insertTrackLink($newImage);
		
		$this->set($newImage);
	}
}	
?>