<?php

class OS_APP_organicimages_Operations
{
	private static $_instance;

	private $appHandler;
	
	
	public function __construct()
	{
		$this->appHandler = getOS()->getAppHandler('organicimages');
	}

	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_organicimages_Operations();
		}
		return self::$_instance;
	}

	public function getImageByID($image_id)
	{
		if( $id < 1 ) return false;
		else return $this->getImageByDetail(array('id'=>$image_id));
	}
	
	public function getImageByDetail($details)
	{
		$result = false;
		$query  = false;

 		$OS = getOS();

		$db = $OS->getDb();
		
		if(isset($details['id']))  $query = "SELECT * FROM ".$this->appHandler->dbPrefix()."images WHERE `id` = ?";	
		
		if($query)
		{
			$dbresult = $db->query($query, array_values($details));
			
			if ($row = $db->fetchRow($dbresult))
			{
				$oneImage = new OS_APP_organicimages_Image();
				$oneImage->set($row);
							
				$result = $oneImage;
			}
				
		}
		return $result;
	}	
	
	public function insertImage($oneImage)
	{
		$result=false;
		
 		$OS = getOS();

		$db = $OS->getDb();
		
		$insert_dt = $db->DBTimeStamp(time());
		
		$image_ts_utc = gmmktime();
		
		$requiredVals = array('content_url', 'content_alt', 'content_title', 'content_width' ,'content_height', 'referer_keywords','content_filename','content_filename_length','image_link_title','image_link_url','image_link_rel','image_link_target');
		foreach($requiredVals as $val)
		{
			if(is_null($oneImage->$val)) $oneImage->$val = "";
		}
		
		$insertData = array(
			'insert_dt' =>$insert_dt,
			'visitor_dt' => $oneImage->visitor_dt,
			'visitor_d' => date("Y-m-d", strtotime($oneImage->visitor_dt)),
			'visitor_ts_utc' => $image_ts_utc,
			'project_id' => $oneImage->project_id,
			'content_url' => $oneImage->content_url,
			'content_filename' => $oneImage->content_filename,
			'content_filename_length' => $oneImage->content_filename_length,
			'referer_keywords' => $oneImage->referer_keywords,
			'content_alt' => $oneImage->content_alt,
			'content_title' => $oneImage->content_title,
			'content_width' => $oneImage->content_width,
			'content_height' => $oneImage->content_height,
			'visitor_ip' => $oneImage->visitor_ip,
			'page_url' => $oneImage->page_url,
			'page_url_hash' => $oneImage->page_url_hash,
			'page_title' => $oneImage->page_title,
			'image_link_url' => $oneImage->image_link_url,
			'image_link_title' => $oneImage->image_link_title,
			'image_link_rel' => $oneImage->image_link_rel,
			'image_link_target' => $oneImage->image_link_target,
			'location_continent_code' =>$oneImage->location_continent_code,
			'location_continent_name' =>$oneImage->location_continent_name,
			'location_country_code' =>$oneImage->location_country_code,
			'location_country_name' =>$oneImage->location_country_name
		);
		
		$query = "INSERT INTO ".$this->appHandler->dbPrefix()."images (`".implode("`,`", array_keys($insertData))."`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		$dbresult = $db->query($query, array_values($insertData));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		//Handle new visits (by dimesions)
		$insertData = array(
			'insert_dt' =>$insert_dt,
			'project_id' => $oneImage->project_id,
			'visitor_dt' => $oneImage->visitor_dt,
			'visitor_d' => date("Y-m-d", strtotime($oneImage->visitor_dt)),
			'visitor_ts_utc' => $image_ts_utc,
			'content_id' => $oneImage->content_id,
			'page_id' => $oneImage->page_id,
			'location_id' => $oneImage->location_id,
			'referer_id' => $oneImage->referer_id,
			'image_link_id' => $oneImage->image_link_id,
		);
		
		
		$query = "INSERT INTO ".$this->appHandler->dbPrefix()."track_visitor (`".implode("`,`", array_keys($insertData))."`) VALUES (?,?,?,?,?,?,?,?,?,?)";
		$dbresult = $db->query($query, array_values($insertData));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		
		return $result;
	}

	public function updateImage($oneImage)
	{
		$result=false;
		
		return $result;
	}
	
	public function deleteImageByID($image_id)
	{
		if( $image_id < 1 ) return false;

 		$result = false;
 		$OS = getOS();

		$db = $OS->getDb();
		$appHandler = $OS->getAppHandler('organicimages');
 		
		$query = "DELETE FROM ".$appHandler->dbPrefix()."images WHERE `id` = ?";
		$dbresult = $db->query($query, array($image_id));

		if ($dbresult !== false)
		{
			$result = true;
		}

		return $result;
	}
	
	
	public function insertTrackContent($oneImage)
	{
 		$OS = getOS();

		$db = $OS->getDb();
		
		$insertData = array(
			'content_url' => $oneImage->content_url,
			'content_filename' =>  $oneImage->content_filename,
			'content_filename_length' =>  $oneImage->content_filename_length,
			'content_alt' =>  $oneImage->content_alt,
			'content_title' =>  $oneImage->content_title,
			'content_width' =>  $oneImage->content_width,
			'content_height' =>   $oneImage->content_height,
			);
			
		$content_hash = md5(implode(".", array_values($insertData)));	
		
		$query = "SELECT id FROM `".$this->appHandler->dbPrefix()."track_content` WHERE project_id = ? AND content_hash = ?";
		$dbresult = $db->query($query, array($oneImage->project_id, $content_hash));
		if(!$row = $db->fetchRow($dbresult))
		{
			//insert data
			$insertData['content_hash'] = $content_hash;
			$insertData['occurances'] = 1;
			$insertData['project_id'] = $oneImage->project_id;
			
			$query = "INSERT INTO ".$this->appHandler->dbPrefix()."track_content (`".implode("`,`", array_keys($insertData))."`) VALUES (?,?,?,?,?,?,?,?,?,?)";
			$dbresult = $db->query($query, array_values($insertData));
			$oneImage->content_id = $db->getInsertId(); 
			
		}
		else
		{
			//update occurances
			$oneImage->content_id = $row['id'];
		}
		
		return $oneImage;
	}
	
	public function insertTrackPage($oneImage)
	{
 		$OS = getOS();

		$db = $OS->getDb();

		$insertData = array(
			'page_url' => $oneImage->page_url,
			'page_url_hash' =>  $oneImage->page_url_hash,
			'page_title' =>  $oneImage->page_title,
			);
			
		$page_hash = md5(implode(".", array_values($insertData)));	
		
		$query = "SELECT id FROM `".$this->appHandler->dbPrefix()."track_page` WHERE project_id = ? AND page_hash = ?";
		$dbresult = $db->query($query, array($oneImage->project_id, $page_hash));
		if(!$row = $db->fetchRow($dbresult))
		{
			//insert data
			$insertData['page_hash'] = $page_hash;
			$insertData['occurances'] = 1;
			$insertData['project_id'] = $oneImage->project_id;
			
			$query = "INSERT INTO ".$this->appHandler->dbPrefix()."track_page (`".implode("`,`", array_keys($insertData))."`) VALUES (?,?,?,?,?,?)";
			$dbresult = $db->query($query, array_values($insertData));
			$oneImage->page_id = $db->getInsertId(); 
		}
		else
		{
			//update occurances
			$oneImage->page_id = $row['id'];
		}
		
		return $oneImage;
	}
	
	public function insertTrackLocation($oneImage)
	{
 		$OS = getOS();

		$db = $OS->getDb();

		$insertData = array(
			'continent_name' => $oneImage->location_continent_name,
			'continent_code' =>  $oneImage->location_continent_code,
			'country_name' =>  $oneImage->location_country_name,
			'country_code' =>  $oneImage->location_country_code,
			);
			
		$location_hash = md5(implode(".", array_values($insertData)));	
		
		$query = "SELECT id FROM `".$this->appHandler->dbPrefix()."track_location` WHERE project_id = ? AND location_hash = ?";
		$dbresult = $db->query($query, array($oneImage->project_id, $location_hash));
		if(!$row = $db->fetchRow($dbresult))
		{
			//insert data
			$insertData['location_hash'] = $location_hash;
			$insertData['occurances'] = 1;
			$insertData['project_id'] = $oneImage->project_id;
			
			$query = "INSERT INTO ".$this->appHandler->dbPrefix()."track_location (`".implode("`,`", array_keys($insertData))."`) VALUES (?,?,?,?,?,?,?)";
			$dbresult = $db->query($query, array_values($insertData));
			$oneImage->location_id = $db->getInsertId(); 
		}
		else
		{
			//update occurances
			$oneImage->location_id = $row['id'];
		}
		
		return $oneImage;
	}
	
	public function insertTrackReferer($oneImage)
	{
 		$OS = getOS();

		$db = $OS->getDb();
		
		$insertData = array(
			'referer_keywords' =>  $oneImage->referer_keywords,
			);
			
		$referer_hash = md5(implode(".", array_values($insertData)));	
		
		$query = "SELECT id FROM `".$this->appHandler->dbPrefix()."track_referer` WHERE project_id = ? AND referer_hash = ?";
		$dbresult = $db->query($query, array($oneImage->project_id, $referer_hash));
		if(!$row = $db->fetchRow($dbresult))
		{
			//insert data
			$insertData['referer_hash'] = $referer_hash;
			$insertData['occurances'] = 1;
			$insertData['project_id'] = $oneImage->project_id;
			
			$query = "INSERT INTO ".$this->appHandler->dbPrefix()."track_referer (`".implode("`,`", array_keys($insertData))."`) VALUES (?,?,?,?)";
			$dbresult = $db->query($query, array_values($insertData));
			$oneImage->referer_id = $db->getInsertId(); 
		}
		else
		{
			//update occurances
			$oneImage->referer_id = $row['id'];
		}
		
		return $oneImage;		
	}
	
	public function insertTrackLink($oneImage)
	{
 		$OS = getOS();

		$db = $OS->getDb();
		
		$insertData = array(
			'image_link_url' =>  $oneImage->image_link_url,
			'image_link_title' =>  $oneImage->image_link_title,
			'image_link_rel' =>  $oneImage->image_link_rel,
			'image_link_target' =>  $oneImage->image_link_target,
		);
			
		$image_link_hash = md5(implode(".", array_values($insertData)));	
		
		$query = "SELECT id FROM `".$this->appHandler->dbPrefix()."track_link` WHERE project_id = ? AND image_link_hash = ?";
		$dbresult = $db->query($query, array($oneImage->project_id, $image_link_hash));
		if(!$row = $db->fetchRow($dbresult))
		{
			//insert data
			$insertData['image_link_hash'] = $image_link_hash;
			$insertData['occurances'] = 1;
			$insertData['project_id'] = $oneImage->project_id;
			
			$query = "INSERT INTO ".$this->appHandler->dbPrefix()."track_link (`".implode("`,`", array_keys($insertData))."`) VALUES (?,?,?,?,?,?,?)";
			$dbresult = $db->query($query, array_values($insertData));
			$oneImage->image_link_id = $db->getInsertId(); 
		}
		else
		{
			//update occurances
			$oneImage->image_link_id = $row['id'];
		}

		return $oneImage;
	}
	
	
	public function getProjectImagesTimeframe($params)
	{
		$result = array();
		
		$organicImagesConsolidation = OS_APP_organicimages_Consolidation::get_instance();
		
		$datesRange = $this->createDateRangeArray($params['start_d'], $params['end_d']);
		
		foreach($datesRange as $cdate)
		{
			$result[$cdate] = 0;
		}
		
		$reportParams = array(
			'project_id'=> $params['project_id'], 
			'start_d'=> $params['start_d'], 
			'end_d'=> $params['end_d'],
			'primary_dimension'=> 'visitor_d'
			);
			
		$consolidationData = $organicImagesConsolidation->getData('getCustomReport', $reportParams);
		
		if(!empty($consolidationData))
		{
			foreach($consolidationData as $index => $details)
			{
				$result[$details['primary_metric']] = $details['total'];	
			}
		}
		
		return $result;
	}
	
	
	public function getProjectImagesTimeframeUnit($params)
	{
		$result = array();
		
		$organicImagesConsolidation = OS_APP_organicimages_Consolidation::get_instance();
		
		$datesRange = $this->createDateRangeArray($params['start_d'], $params['end_d']);
		
		foreach($datesRange as $cdate)
		{
			$result[$cdate] = 0;
		}
		
		$reportParams = array(
			'project_id'=> $params['project_id'], 
			'start_d'=> $params['start_d'], 
			'end_d'=> $params['end_d'],
			'primary_dimension'=> 'visitor_d',
			'main_dimension_name' => $params['main_dimension_name'],
			'main_dimension_value' => $params['main_dimension_value']
			);
		
		$consolidationData = $organicImagesConsolidation->getData('getCustomReportUnit', $reportParams);
		
		if(!empty($consolidationData))
		{
			foreach($consolidationData as $statd => $details)
			{
				$result[$details['primary_metric']] = $details['total'];	
			}
		}
		
		return $result;
	}

	public function getCustomReport($params)
	{
		$OS = getOS();
		$db = $OS->getDb();
		$appHandler = $OS->getAppHandler('organicimages');
		
		$result = array();
		
		$project_id = $params['project_id'];
		$start_d = $params['start_d'];
		$end_d = $params['end_d'];
		
		$consolidationHasLimits = false;
		if(isset($params['set'], $params['max_rows']))
		{
			$consolidationHasLimits = true;
			$current_set =  $params['set'];
			$max_rows = $params['max_rows'];
			$limit = (($current_set * $max_rows) - $max_rows);
		}
				
		$dimensionsData = array();
		if(!empty($params['primary_dimension']))
		{
			$dimensionsData['primary_dimension'] = $params['primary_dimension']; 
		}
		
		if(!empty($params['secondary_dimension']))
		{
			$dimensionsData['secondary_dimension'] = $params['secondary_dimension'];
		}
		
		//select from main table values by time periods
		$consolidationData = array();
		
		$selectValues = array_merge(array('COUNT(id) AS total'), $dimensionsData);
		$groupValues = array_values($dimensionsData);
		
		$cpData = array();
		$limitValues = ($consolidationHasLimits ?  "ORDER BY total DESC LIMIT {$limit},{$max_rows}": "");
		$query = sprintf("SELECT %s FROM ".$appHandler->dbPrefix()."images WHERE `project_id`=? AND `visitor_d`>=? AND `visitor_d`<=? GROUP BY %s %s", implode(", ", $selectValues), implode(", ", $groupValues), $limitValues);
		
		$dbresult = $db->query($query, array($project_id, $start_d, $end_d));
		while($row = $db->fetchRow($dbresult))
		{
			$primary_dimension = (isset($dimensionsData['primary_dimension']) ? $dimensionsData['primary_dimension'] : "");
			$secondary_dimension = (isset($dimensionsData['secondary_dimension']) ? $dimensionsData['secondary_dimension'] : "");
			$primary_metric = (isset($dimensionsData['primary_dimension']) ? (empty($row[$dimensionsData['primary_dimension']]) ? "n/a" : $row[$dimensionsData['primary_dimension']]) : "");
			$secondary_metric = (isset($dimensionsData['secondary_dimension']) ? (empty($row[$dimensionsData['secondary_dimension']]) ? "n/a" : $row[$dimensionsData['secondary_dimension']]) : "");
			
			$metric_hash = $primary_metric.$secondary_metric;
			
			$cpData[$metric_hash] = array(
				'primary_dimension' => $primary_dimension,
				'secondary_dimension' => $secondary_dimension,
				'primary_metric' => $primary_metric,
				'secondary_metric' => $secondary_metric,	
				'primary_metric_hash' => md5($primary_metric),
				'secondary_metric_hash' => md5(md5($secondary_metric)),
				'total_value' => $row['total']
				);
		}

		
		//calculate total_value
		$total_value = 0;
		$query = sprintf("SELECT COUNT(id) AS total FROM ".$appHandler->dbPrefix()."images WHERE `project_id`=? AND `visitor_d`>=? AND `visitor_d`<=?");
		$dbresult = $db->query($query, array($project_id, $start_d, $end_d));
		if($row = $db->fetchRow($dbresult))
		{
			$total_value = $row['total'];	
		}
		
		//add percentage and change to type copies
		if(!empty($cpData))
		{
			foreach($cpData as $copy_hash => $details)
			{
				$cpData[$copy_hash]['percentage'] = ($total_value == 0 ? 0 : round((($details['total_value']/$total_value)*100),2));
			}
			
			$result = $cpData;
		}
		
		return $result;
	}
	
	public function getCustomReportOld($params)
	{
		$result = array();
		
		$organicImagesConsolidation = OS_APP_organicimages_Consolidation::get_instance();
		
		$paramsBuild = array();
		$optionsParams = array('project_id', 'start_d', 'end_d', 'primary_dimension', 'secondary_dimension', 'set', 'max_rows');

		foreach($optionsParams as $optParam)
		{
			if(isset($params[$optParam])) 
			{
				$paramsBuild[$optParam] = $params[$optParam]; 	
			}
		}
		
		$total_value = 0; $cpData = array();
		
		$consolidationData = $organicImagesConsolidation->getData('getCustomReport', $paramsBuild);
		
		if(!empty($consolidationData))
		{
			foreach($consolidationData as $index => $consolidationDetails)
			{
				$metric_hash = $consolidationDetails['primary_metric'].$consolidationDetails['secondary_metric'];
				
				$total_value += $consolidationDetails['total'];
				
				if(empty($consolidationDetails['secondary_metric']))
				{
					$consolidationDetails['secondary_metric'] = "n/a";
				}
				
				if(empty($consolidationDetails['primary_metric']))
				{
					$consolidationDetails['primary_metric'] = "n/a";
				}
				
				$cpData[$metric_hash] = array(
					'primary_dimension' => $consolidationDetails['primary_dimension'],
					'secondary_dimension' => $consolidationDetails['secondary_dimension'],
					'primary_metric' => $consolidationDetails['primary_metric'],
					'secondary_metric' => $consolidationDetails['secondary_metric'],	
					'primary_metric_hash' => $consolidationDetails['primary_metric_hash'],
					'secondary_metric_hash' => $consolidationDetails['secondary_metric_hash'],
					'total_value' => $consolidationDetails['total']
					);
			}
			
			//add percentage and change to type copies
			if(!empty($cpData))
			{
				foreach($cpData as $copy_hash => $details)
				{
					$cpData[$copy_hash]['percentage'] = ($total_value == 0 ? 0 : round((($details['total_value']/$total_value)*100),2));
				}
				
				$result = $cpData;
			}
		}
		
		return $result;
	}
	
	public function getCustomReportUnit($params)
	{
		$OS = getOS();
		$db = $OS->getDb();
		$appHandler = $OS->getAppHandler('organicimages');
		
		$result = array();
		
		$project_id = $params['project_id'];
		$start_d = $params['start_d'];
		$end_d = $params['end_d'];
		
		$consolidationHasLimits = false;
		if(isset($params['set'], $params['max_rows']))
		{
			$consolidationHasLimits = true;
			$current_set =  $params['set'];
			$max_rows = $params['max_rows'];
			$limit = (($current_set * $max_rows) - $max_rows);
		}
				
		$dimensionsData = array();
		if(!empty($params['primary_dimension']))
		{
			$dimensionsData['primary_dimension'] = $params['primary_dimension']; 
		}
		
		if(!empty($params['secondary_dimension']))
		{
			$dimensionsData['secondary_dimension'] = $params['secondary_dimension'];
		}
		
		$main_dimension_name = $params['main_dimension_name'];
		$main_dimension_value = $params['main_dimension_value'];
		
		//select from main table values by time periods
		$consolidationData = array();
		
		$selectValues = array_merge(array('COUNT(id) AS total'), $dimensionsData);
		$groupValues = array_values($dimensionsData);
		
		$cpData = array();
		$limitValues = ($consolidationHasLimits ?  "ORDER BY total DESC LIMIT {$limit},{$max_rows}": "");
		$query = sprintf("SELECT %s FROM ".$appHandler->dbPrefix()."images WHERE `project_id`=? AND `visitor_d`>=? AND `visitor_d`<=? AND `{$main_dimension_name}` = ? GROUP BY %s %s", implode(", ", $selectValues), implode(", ", $groupValues), $limitValues);
		$dbresult = $db->query($query, array($project_id, $start_d, $end_d, $main_dimension_value));
		
		while($row = $db->fetchRow($dbresult))
		{
			$primary_dimension = (isset($dimensionsData['primary_dimension']) ? $dimensionsData['primary_dimension'] : "");
			$secondary_dimension = (isset($dimensionsData['secondary_dimension']) ? $dimensionsData['secondary_dimension'] : "");
			$primary_metric = (isset($dimensionsData['primary_dimension']) ? (empty($row[$dimensionsData['primary_dimension']]) ? "n/a" : $row[$dimensionsData['primary_dimension']]) : "");
			$secondary_metric = (isset($dimensionsData['secondary_dimension']) ? (empty($row[$dimensionsData['secondary_dimension']]) ? "n/a" : $row[$dimensionsData['secondary_dimension']]) : "");
			
			$metric_hash = $primary_metric.$secondary_metric;
			
			$cpData[$metric_hash] = array(
				'primary_dimension' => $primary_dimension,
				'secondary_dimension' => $secondary_dimension,
				'primary_metric' => $primary_metric,
				'secondary_metric' => $secondary_metric,	
				'primary_metric_hash' => md5($primary_metric),
				'secondary_metric_hash' => md5(md5($secondary_metric)),
				'total_value' => $row['total']
				);
		}

		
		//calculate total_value
		$total_value = 0;
		$query = sprintf("SELECT COUNT(id) AS total FROM ".$appHandler->dbPrefix()."images WHERE `project_id`=? AND `visitor_d`>=? AND `visitor_d`<=?");
		$dbresult = $db->query($query, array($project_id, $start_d, $end_d));
		if($row = $db->fetchRow($dbresult))
		{
			$total_value = $row['total'];	
		}
		
		//add percentage and change to type copies
		if(!empty($cpData))
		{
			foreach($cpData as $copy_hash => $details)
			{
				$cpData[$copy_hash]['percentage'] = ($total_value == 0 ? 0 : round((($details['total_value']/$total_value)*100),2));
			}
			
			$result = $cpData;
		}
		
		return $result;
	}	
	
	public function getCustomReportUnitOld($params)
	{
		$result = array();
		
		$organicImagesConsolidation = OS_APP_organicimages_Consolidation::get_instance();
		
		$paramsBuild = array();
		$optionsParams = array('project_id', 'start_d', 'end_d', 'primary_dimension', 'main_dimension_name', 'main_dimension_value', 'secondary_dimension', 'set', 'max_rows');

		foreach($optionsParams as $optParam)
		{
			if(isset($params[$optParam])) 
			{
				$paramsBuild[$optParam] = $params[$optParam]; 	
			}
		}
			
		$total_value = 0; $cpData = array();
		$consolidationData = $organicImagesConsolidation->getData('getCustomReportUnit', $paramsBuild);
		
		if(!empty($consolidationData))
		{
			foreach($consolidationData as $index => $consolidationDetails)
			{
				$metric_hash =  $consolidationDetails['primary_metric_hash'].$consolidationDetails['secondary_metric_hash'];
				
				$total_value += $consolidationDetails['total'];
				
				if(empty($consolidationDetails['secondary_metric']))
				{
					$consolidationDetails['secondary_metric'] = "n/a";
				}
				
				if(empty($consolidationDetails['primary_metric']))
				{
					$consolidationDetails['primary_metric'] = "n/a";
				}
				
				$cpData[$metric_hash] = array(
					'primary_metric' => $consolidationDetails['primary_metric'],
					'secondary_metric' => $consolidationDetails['secondary_metric'],	
					'primary_metric_hash' => $consolidationDetails['primary_metric_hash'],
					'secondary_metric_hash' => $consolidationDetails['secondary_metric_hash'],
					'total_value' => $consolidationDetails['total']
					);
			}
			
			//add percentage data
			if(!empty($cpData))
			{
				foreach($cpData as $copy_hash => $details)
				{
					$cpData[$copy_hash]['percentage'] = ($total_value == 0 ? 0 : round((($details['total_value']/$total_value)*100),2));
				}
				
				$result = $cpData;
			}
		}
		
		return $result;
	}

	
	public function getImagesStatsReports($params)
	{
		$project_id = $params['project_id'];
		
		$OS = getOS();
		$db = $OS->getDb();
		
		$tmpCounts = array();
		$query = "SELECT * FROM `".$this->appHandler->dbPrefix()."stats_report_details` WHERE project_id = ?";
		$dbresult = $db->query($query, array($project_id));
		while($row = $db->fetchRow($dbresult))
		{
			$tmpCounts['drilldown'][$row['type']][$row['group']][$row['name']] = $row['total'];
			
			if(!isset($tmpCounts['structured']['types'][$row['type']])) $tmpCounts['structured']['types'][$row['type']] = 0;
			$tmpCounts['structured']['types'][$row['type']] += $row['total'];
			
			if(!isset($tmpCounts['structured']['groups'][$row['group']])) $tmpCounts['structured']['groups'][$row['group']] = 0;
			$tmpCounts['structured']['groups'][$row['group']] += $row['total'];
			
			$tmpName =  $row['type'].'_'.$row['group'].'_'.$row['name'];
			if(!isset($tmpCounts['structured']['names'][$tmpName])) $tmpCounts['structured']['names'][$tmpName] = 0;
			$tmpCounts['structured']['names'][$tmpName] += $row['total'];
		}
		
		return $tmpCounts;
	}
	
	public function getImagesStatsTimeFrame($params)
	{
		$project_id = $params['project_id'];
		$start_d = $params['start_d'];
		$end_d = $params['end_d'];
		
		$OS = getOS();
		$db = $OS->getDb();
		
		$tmpCounts = array();
		$query = "SELECT * FROM `".$this->appHandler->dbPrefix()."stats_report` WHERE project_id = ? AND report_d>= ? AND report_d<= ?";
		$dbresult = $db->query($query, array($project_id, $start_d, $end_d));
		while($row = $db->fetchRow($dbresult))
		{
			$tmpCounts[$row['report_d']] = array('errors' => $row['errors'], 'warnings'=> $row['warnings'], 'notices' => $row['notices']);
		}
		
		return $tmpCounts;
	}
	
	public function getImagesStatsByScore($params)
	{
		$project_id = $params['project_id'];
		$current_set =  $params['set'];
		$max_rows = $params['max_rows'];
		
		$limit = (($current_set * $max_rows) - $max_rows);
		
		$OS = getOS();
		$db = $OS->getDb();
		
		$tmpDetails = array();
		$query = "SELECT *,COUNT(id) AS total FROM `".$this->appHandler->dbPrefix()."seo_report` WHERE project_id = ? GROUP BY image_url_hash ORDER BY total DESC LIMIT {$limit},{$max_rows}";
		$dbresult = $db->query($query, array($project_id));
		while($row = $db->fetchRow($dbresult))
		{
			$tmpDetails[$row['id']] = $row;
			$tmpDetails[$row['id']]['total_pages'] = $row['total'];
		}
		
		return $tmpDetails;
	}
	
	public function getImagesStatsByPage($params)
	{
		$project_id = $params['project_id'];
		$current_set =  $params['set'];
		$max_rows = $params['max_rows'];
		
		$limit = (($current_set * $max_rows) - $max_rows);
		
		$OS = getOS();
		$db = $OS->getDb();
		
		$tmpDetails = array();
		$query = "SELECT *,COUNT(id) AS total FROM `".$this->appHandler->dbPrefix()."seo_report` WHERE project_id = ? GROUP BY page_url_hash ORDER BY total DESC LIMIT {$limit},{$max_rows}";
		$dbresult = $db->query($query, array($project_id));
		while($row = $db->fetchRow($dbresult))
		{
			$tmpDetails[$row['id']] = $row;
			$tmpDetails[$row['id']]['total_images'] = $row['total'];
		}
		
		return $tmpDetails;
	}
	
	
	public function getImagesReportsByImage($params)
	{
		$project_id = $params['project_id'];
		$current_set =  $params['set'];
		$max_rows = $params['max_rows'];
		$group_name = $params['group_name']; 
		$group_value = $params['group_value'];
		
		$limit = (($current_set * $max_rows) - $max_rows);
		
		$OS = getOS();
		$db = $OS->getDb();
		
		$tmpDetails = array();
		$query = "SELECT * FROM `".$this->appHandler->dbPrefix()."seo_report` WHERE project_id = ? AND `{$group_name}` =?  ORDER BY score DESC LIMIT {$limit},{$max_rows}";
		$dbresult = $db->query($query, array($project_id, $group_value));
		while($row = $db->fetchRow($dbresult))
		{
			$tmpDetails[$row['id']] = $row;
		}
		
		return $tmpDetails;
	}
	
	public function getImageReportData($params)
	{
		$project_id = $params['project_id'];
		$image_url_hash = $params['image_url_hash'];
		$page_url_hash = $params['page_url_hash'];
		
		$OS = getOS();
		$db = $OS->getDb();
		
		$tmpDetails = array();
		$query = "SELECT * FROM `".$this->appHandler->dbPrefix()."seo_report` WHERE `project_id` = ? AND `image_url_hash` = ?  AND `page_url_hash`= ?";
		$dbresult = $db->query($query, array($project_id, $image_url_hash, $page_url_hash));
		if($row = $db->fetchRow($dbresult))
		{
			$tmpDetails[$row['id']] = $row;
			
			$query2 = "SELECT * FROM `".$this->appHandler->dbPrefix()."seo_report_tests` WHERE `project_id`= ? AND `image_id` = ?";
			$dbresult2 = $db->query($query2, array($project_id, $row['id']));
			while($row2 = $db->fetchRow($dbresult2))
			{
				$tmpDetails[$row['id']]['tests'][] = $row2;
			}
			
			$query3 = "SELECT * FROM `".$this->appHandler->dbPrefix()."seo_report_changes` WHERE `project_id`= ? AND `image_id` = ? AND `image_details_hash` = ?";
			$dbresult3 = $db->query($query3, array($project_id, $row['id'], $row['image_details_hash']));
			if($row3 = $db->fetchRow($dbresult3))
			{
				$tmpDetails[$row['id']]['image_details'] = $row3;
			}
		}
		
		return $tmpDetails;
	}
	
	public function getImagesReportsByProblem($params)
	{
		$project_id = $params['project_id'];
		$grup_name = $params['group_name'];
		$problem_name = $params['problem_name'];
		$current_set =  $params['set'];
		$max_rows = $params['max_rows'];
		
		$limit = (($current_set * $max_rows) - $max_rows);

		$OS = getOS();
		$db = $OS->getDb();
		
		$dbTblName = $this->appHandler->dbPrefix()."seo_report";
		$dbTblName2 = $this->appHandler->dbPrefix()."seo_report_tests";
		
		$tmpDetails = array();
		$query = "SELECT {$dbTblName}.* FROM `{$dbTblName}`,`{$dbTblName2}` WHERE {$dbTblName}.project_id = ? AND  {$dbTblName}.id = {$dbTblName2}.image_id AND {$dbTblName2}.group = ? AND {$dbTblName2}.name = ? ORDER BY score ASC LIMIT {$limit},{$max_rows}";
		$dbresult = $db->query($query, array($project_id, $grup_name, $problem_name));
		while($row = $db->fetchRow($dbresult))
		{
			$tmpDetails[$row['id']] = $row;
		}		
			
		return $tmpDetails;
	}
	
	public function createDateRangeArray($strDateFrom, $strDateTo)
	{
	    $aryRange = array();
	
	    $iDateFrom = mktime(1,0,0,substr($strDateFrom,5,2), substr($strDateFrom,8,2),substr($strDateFrom,0,4));
	    $iDateTo = mktime(1,0,0,substr($strDateTo,5,2), substr($strDateTo,8,2),substr($strDateTo,0,4));
	
	    if ($iDateTo >= $iDateFrom)
	    {
	        $aryRange[] = date('Y-m-d',$iDateFrom);
	        while ($iDateFrom<$iDateTo)
	        {
	            $iDateFrom += 86400;
	            $aryRange[] = date('Y-m-d',$iDateFrom);
	        }
	    }
	    return $aryRange;
	}	
}
?>