var appTracker = {
		
	registeredEvents: [],
	
	refUrlParams: null,
	
	imageTrackerHandler: function(extraData)
	{
		var refurl, imageDetails;
		
		refurl = this.getReferral();
		
		if (refurl)
		{
			imageDetails = this.extractDetails(refurl);
			
			if (imageDetails !== false)
			{
				return imageDetails;
			}	
		}	
		
		return false;
	},
	
	getReferral: function()
	{
		var referral = '', re, rhost;
		
		try {referral=top.document.referrer;} catch (e) { if (parent) try {referral=parent.document.referrer;} catch (e2) {referral='';} }
		if (referral=='') referral = window.document.referrer;
		if (referral=='') return false;
		
		re = new RegExp('^(?:f|ht)tp(?:s)?\://([^/]+)', 'im');
		rhost = referral.match(re)[1].toString();
		
		if (rhost==window.location.host) return false;
		return referral;
	},
	
	extractDetails: function(refurl)
	{
		var keywords, imgurl, imgrefurl, queryParams, index, totalImagesCount, imgObj, tmpImg, activeImage, linkObj,
		processImageDimensions = false,
		validSearch = false,
		imageDetails = [],
		tmpDetails = {},
		documentAlias = document,
		imageElements = documentAlias.images;
		
		this.refUrlParams = this.parseUrl(refurl);
		
		if(this.refUrlParams['query'] && this.refUrlParams['path'])
		{
			if(this.refUrlParams['path'].indexOf('/imgres') >= 0)
			{
				validSearch = true;
			}	
		}
		
		//check if imgres
		if(validSearch)
		{
			queryParams = this.getParametersFromQueryString(this.refUrlParams['query']);
			
			if(queryParams !== false)
			{
				this.queryParams = queryParams;
				
				//check if has keywords
				if(this.queryParams['q'])
				{
					imageDetails.push(['keyword', this.queryParams['q']]); 
				}
				
				//check for imgurl
				if(this.queryParams['imgurl'])
				{
					imageDetails.push(['imgurl', this.queryParams['imgurl']]);
				
					//get images information
					totalImagesCount = imageElements.length;
					
					if(totalImagesCount > 0)
					{
						for (index=0; index<totalImagesCount; index++)
						{
							imgObj = imageElements[index];
							
							if(imgObj.src)
							{
								if(imgObj.src == this.queryParams['imgurl'])
								{
									activeImage = imgObj;
									processImageDimensions = true;
								}	
							}
						}	
					}	
				}
				
				//check for imgrefurl
				if(this.queryParams['imgrefurl'])
				{
					imageDetails.push(['imgrefurl', this.queryParams['imgrefurl']]);
				}
			}
		}
		
		if(processImageDimensions)
		{
			//get image title
			if(activeImage.title)
			{
				imageDetails.push(['imgurl_title', activeImage.title]);
			}	
			
			//get image alt
			if(activeImage.alt)
			{
				imageDetails.push(['imgurl_alt', activeImage.alt]);
			}	
			
			//get image width, height	
			if(activeImage.clientWidth && activeImage.clientHeight)
			{
				imageDetails.push(['imgurl_width', activeImage.clientWidth]);
				
				imageDetails.push(['imgurl_height', activeImage.clientHeight]);
			}
			
			linkObj = this.getElementHyperLink(activeImage);
			
			if(linkObj !== false)
			{
				if(linkObj.href)
				{
					imageDetails.push(['link_href', linkObj.href]);
				}
				
				if(linkObj.title)
				{
					imageDetails.push(['link_title', linkObj.title]);
				}	
				
				if(linkObj.rel)
				{
					imageDetails.push(['link_rel', linkObj.rel]);
				}
			}	
		}	
		
		if(imageDetails.length > 0)
		{
			for(index in imageDetails)
			{
				tmpDetails[imageDetails[index][0]] = imageDetails[index][1];
			}	
			
			return tmpDetails;
		}
		else
		{
			return false;
		}	
	},
	
	getElementHyperLink: function(element)
	{
        var parentElement = element.parentNode, 
        	isHyperLinked = false;
        
        while (parentElement.nodeName !== 'A' && parentElement.nodeName !== 'BODY')
        {
            parentElement = parentElement.parentNode;
            
            if(parentElement.nodeName == 'A')
            {
            	isHyperLinked = true;
            }	
        }

        if(isHyperLinked)
        {
        	return parentElement;	
        }
        else
        {
        	return false;	
        }
	},
	
	getParametersFromQueryString: function(urlQuery)
	{
		var nameToValue = [], 
			tmpParams = {}, 
			k, 
			tmpK, 
			hasParams = false;
		
		this.parseStr(urlQuery, nameToValue);
		
		if(nameToValue !== false)
		{
			hasParams = true;
			
			for(k in nameToValue)
			{
				tmpK = k.replace(/\?/gi, '');
				tmpParams[tmpK] = nameToValue[k];
			}	
		}
		
		if(hasParams) return tmpParams;
		return false;
	},
	
	parseStr: function(str, array)
	{
	    // http://kevin.vanzonneveld.net
	    // +   original by: Cagri Ekin
	    // +   improved by: Michael White (http://getsprink.com)
	    // +    tweaked by: Jack
	    // +   bugfixed by: Onno Marsman
	    // +   reimplemented by: stag019
	    // +   bugfixed by: Brett Zamir (http://brett-zamir.me)
	    // +   bugfixed by: stag019
	    // +   input by: Dreamer
	    // +   bugfixed by: Brett Zamir (http://brett-zamir.me)
	    // +   bugfixed by: MIO_KODUKI (http://mio-koduki.blogspot.com/)
	    // +   input by: Zaide (http://zaidesthings.com/)
	    // +   input by: David Pesta (http://davidpesta.com/)
	    // +   input by: jeicquest
	    // +   improved by: Brett Zamir (http://brett-zamir.me)
	    // %        note 1: When no argument is specified, will put variables in global scope.
	    // %        note 1: When a particular argument has been passed, and the returned value is different parse_str of PHP. For example, a=b=c&d====c
	    // *     example 1: var arr = {};
	    // *     example 1: parse_str('first=foo&second=bar', arr);
	    // *     results 1: arr == { first: 'foo', second: 'bar' }
	    // *     example 2: var arr = {};
	    // *     example 2: parse_str('str_a=Jack+and+Jill+didn%27t+see+the+well.', arr);
	    // *     results 2: arr == { str_a: "Jack and Jill didn't see the well." }
	    // *     example 3: var abc = {3:'a'};
	    // *     example 3: parse_str('abc[a][b]["c"]=def&abc[q]=t+5');
	    // *     results 3: JSON.stringify(abc) === '{"3":"a","a":{"b":{"c":"def"}},"q":"t 5"}';


	    var strArr = String(str).replace(/^&/, '').replace(/&$/, '').split('&'),
	        sal = strArr.length,
	        i, j, ct, p, lastObj, obj, lastIter, undef, chr, tmp, key, value,
	        postLeftBracketPos, keys, keysLen,
	        fixStr = function (str)
	        {
	            return decodeURIComponent(str.replace(/\+/g, '%20'));
	        };

	    if (!array)
	    {
	        array = this.window;
	    }

	    for (i = 0; i < sal; i++)
	    {
	        tmp = strArr[i].split('=');
	        key = fixStr(tmp[0]);
	        value = (tmp.length < 2) ? '' : fixStr(tmp[1]);

	        while (key.charAt(0) === ' ')
	        {
	            key = key.slice(1);
	        }
	        
	        if (key.indexOf('\x00') > -1)
	        {
	            key = key.slice(0, key.indexOf('\x00'));
	        }
	        
	        if (key && key.charAt(0) !== '[')
	        {
	            keys = [];
	            postLeftBracketPos = 0;
	            for (j = 0; j < key.length; j++)
	            {
	                if (key.charAt(j) === '[' && !postLeftBracketPos)
	                {
	                    postLeftBracketPos = j + 1;
	                }
	                else if (key.charAt(j) === ']')
	                {
	                    if (postLeftBracketPos)
	                    {
	                        if (!keys.length)
	                        {
	                            keys.push(key.slice(0, postLeftBracketPos - 1));
	                        }
	                        
	                        keys.push(key.substr(postLeftBracketPos, j - postLeftBracketPos));
	                        postLeftBracketPos = 0;
	                        if (key.charAt(j + 1) !== '[')
	                        {	
	                            break;
	                        }
	                    }
	                }
	            }
	            
	            if (!keys.length)
	            {
	                keys = [key];
	            }
	            
	            for (j = 0; j < keys[0].length; j++)
	            {
	                chr = keys[0].charAt(j);
	                if (chr === ' ' || chr === '.' || chr === '[')
	                {
	                    keys[0] = keys[0].substr(0, j) + '_' + keys[0].substr(j + 1);
	                }
	                
	                if (chr === '[')
	                {
	                    break;
	                }
	            }

	            obj = array;
	            for (j = 0, keysLen = keys.length; j < keysLen; j++)
	            {
	                key = keys[j].replace(/^['"]/, '').replace(/['"]$/, '');
	                lastIter = j !== keys.length - 1;
	                lastObj = obj;
	                if ((key !== '' && key !== ' ') || j === 0)
	                {
	                    if (obj[key] === undef)
	                    {
	                        obj[key] = {};
	                    }
	                    obj = obj[key];
	                }
	                else
	                { // To insert new dimension
	                    ct = -1;
	                    for (p in obj)
	                    {
	                        if (obj.hasOwnProperty(p))
	                        {
	                            if (+p > ct && p.match(/^\d+$/g))
	                            {
	                                ct = +p;
	                            }
	                        }
	                    }
	                    key = ct + 1;
	                }
	            }
	            lastObj[key] = value;
	        }
	    }
	},		


	parseUrl: function(str, component)
	{
	    // http://kevin.vanzonneveld.net
	    // +      original by: Steven Levithan (http://blog.stevenlevithan.com)
	    // + reimplemented by: Brett Zamir (http://brett-zamir.me)
	    // + input by: Lorenzo Pisani
	    // + input by: Tony
	    // + improved by: Brett Zamir (http://brett-zamir.me)
	    // %          note: Based on http://stevenlevithan.com/demo/parseuri/js/assets/parseuri.js
	    // %          note: blog post at http://blog.stevenlevithan.com/archives/parseuri
	    // %          note: demo at http://stevenlevithan.com/demo/parseuri/js/assets/parseuri.js
	    // %          note: Does not replace invalid characters with '_' as in PHP, nor does it return false with
	    // %          note: a seriously malformed URL.
	    // %          note: Besides function name, is essentially the same as parseUri as well as our allowing
	    // %          note: an extra slash after the scheme/protocol (to allow file:/// as in PHP)
	    // *     example 1: parse_url('http://username:password@hostname/path?arg=value#anchor');
	    // *     returns 1: {scheme: 'http', host: 'hostname', user: 'username', pass: 'password', path: '/path', query: 'arg=value', fragment: 'anchor'}
	    var key = ['source', 'scheme', 'authority', 'userInfo', 'user', 'pass', 'host', 'port',
	        'relative', 'path', 'directory', 'file', 'query', 'fragment'],
	        ini = (this.php_js && this.php_js.ini) || {},
	        mode = (ini['phpjs.parse_url.mode'] && ini['phpjs.parse_url.mode'].local_value) || 'php',
	        parser = {
	            php: /^(?:([^:\/?#]+):)?(?:\/\/()(?:(?:()(?:([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?))?()(?:(()(?:(?:[^?#\/]*\/)*)()(?:[^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
	            strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
	            loose: /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/\/?)?((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/ // Added one optional slash to post-scheme to catch file:/// (should restrict this)
	        };

	    var m = parser[mode].exec(str),
	        uri = {},
	        i = 14;
	    
	    while (i--)
	    {
	        if (m[i])
	        {
	            uri[key[i]] = m[i];
	        }
	    }

	    if (component)
	    {
	        return uri[component.replace('PHP_URL_', '').toLowerCase()];
	    }
	    
	    if (mode !== 'php')
	    {
	        var name = (ini['phpjs.parse_url.queryKey'] && ini['phpjs.parse_url.queryKey'].local_value) || 'queryKey';
	        parser = /(?:^|&)([^&=]*)=?([^&]*)/g;
	        uri[name] = {};
	        uri[key[12]].replace(parser, function ($0, $1, $2)
	        {
	            if ($1)
	            {
	                uri[name][$1] = $2;
	            }
	        });
	    }
	    delete uri.source;
	    return uri;
	},	

	
	call: function()
	{
		var hookEvents = [],
			windowAlias = window;
		
		if(windowAlias)
		{
			this.registeredEvents.push(['organicImagesTracker', windowAlias, 'load', "imageTrackerHandler"]);	
		}	
		
        return {'hookEvents': this.registeredEvents};
	}
};
