{if isset($tvars.imagesStatsReports.groupsView)}

<div class="col_12">

	<ul class="tabs">
		{foreach from=$tvars.imagesStatsReports.groupsView key=typeName item=typeDetails}
		<li>
			<a href="javascript:void(0);" target="#list-image-{$typeName}" title="{$typeDetails.typeTitle}">
				{$typeDetails.typeName} <span class="statsInfoBoxText {$typeDetails.typeColor}">[{$typeDetails.total}]</span>
			</a>
		</li>
		{/foreach}
	</ul>
	
	{foreach from=$tvars.imagesStatsReports.groupsView key=typeName item=typeDetails}
		<div id="list-image-{$typeName}" class="tab-content">
			<div class="col_12">
				{$tvars.chartData.html.$typeName}
			</div>
			
			<div class="col_12">
				<div class='simple-box'>
					<div class='content'>
						{foreach from=$typeDetails.groups key=index item=details}
							<div style="display:inline-block; float:left; width: 33%; text-align: center">
								<p>
									{if isset($details.view_link)}
										<a class="statsInfoBoxText {$typeDetails.typeColor}" title="{$details.title}" href="{$details.view_link}">{$details.title}</a>
									{else}	
										<span class="statsInfoBoxText {$typeDetails.typeColor}">{$details.title}</span>
									{/if}	
								</p>	
								
								{if isset($details.view_link)}
									<div style="cursor:pointer;" onclick="window.location='{$details.view_link}'" class="nofloat marginsCenter statsInfoBoxSlim fill {$typeDetails.typeColor}" title="{$details.title}">
										<div class="statsInfoBoxSlimInside">{$details.total}</div>
									</div>
								{else}
									<div class="nofloat marginsCenter statsInfoBoxSlim {$typeDetails.typeColor}" title="{$details.title}">
										<div class="statsInfoBoxSlimInside">{$details.total}</div>
									</div>
								{/if}	
							</div>
						{/foreach}
						<div class="clear"></div>
					</div>	
					<div class="clear"></div>
				</div>
			</div>	
		</div>
	{/foreach}	
	<div class="clear"></div>
</div>	
{/if}

<div class="col_12">

	<ul class="tabs">
		<li {if $tvars.currentListTab == 'score_images'}class="current"{/if}>
			<a href="javascript:void(0);" target="#list-image-score-by-image" title="{t}Score By Images{/t}">{t}Score By Images{/t}</a>
		</li>
		<li {if $tvars.currentListTab == 'score_pages'}class="current"{/if}>
			<a href="javascript:void(0);" target="#list-image-score-by-page" title="{t}Score By Pages{/t}">{t}Score By Pages{/t}</a>
		</li>
	</ul>
	
	<div id="list-image-score-by-image" class="tab-content">
	
		<div class='simple-box'>
			<div class='content'>
				<table class='striped' cellpadding='0' cellspacing='0'>
					<thead> 
						<tr> 
							<th class="header" style="width:20px">#</th>
							<th class="header" style="width:40%;text-align:left">{t}Image URL{/t}</th>
							<th class="header" style="width:60px;">{t}Total Pages{/t}</th>
							<th class="header" style="width:60px;">{t}Errors{/t}</th>
							<th class="header" style="width:60px;">{t}Warnings{/t}</th>
							<th class="header" style="width:60px;">{t}Notices{/t}</th>
							<th class="header" style="width:60px;">
								Score
								<span class="icon gray smallest helper" data-icon='i' title="{t}OpenS Optimization score for each image, based on number and type of issues found{/t}" style="display:inline-block"></span>
							</th>
						</tr>
					</thead>
					<tbody>
					{if isset($tvars.imagesScoreStats)}				
						{counter start=$tvars.startCounter.score_images print=false}
						{foreach from=$tvars.imagesScoreStats key=index item=details}
							<tr>
								<td class="center">{counter}</td> 
								<td class="left stable-row-fix">
									<a href="{$details.image_details_link}" title = "{$details.image_url}">
										{$details.image_url}
									</a>
								</td>
								<td class="center">
									<span>{$details.total_pages}</span>
								</td>
								<td class="center">
									<span {if $details.errors > 0}class="statsInfoBoxText red"{/if}>{$details.errors}</span>
								</td>
								<td class="center">
									<span {if $details.warnings > 0}class="statsInfoBoxText yellow"{/if}>{$details.warnings}</span>
								</td>
								<td class="center">
									<span {if $details.notices > 0}class="statsInfoBoxText blue"{/if}>{$details.notices}</span>
								</td>
								<td class="center">{$details.score}</td>
							</tr>
						{/foreach}
						<tr>
							<td colspan="7">
								<div style="float:right; display:inline-block; padding:0px 10px;">		
									<button class="small blue" onclick="window.location='{$tvars.prev_link_images}'" title="{t}Previous Entries{/t}">&laquo;</button>
									<button class="small blue" onclick="window.location='{$tvars.next_link_images}'" title="{t}Next Entries{/t}">&raquo;</button>
								</div>
								<div style="float:right; display:inline-block; padding:0px 10px;">
									<label>Rows</label>
									<form name="tableset-images-rows-selector" id="tableset-images-rows-selector" method='GET' action="?" style="display:inline;">
										{foreach from=$tvars.linkParamsImages key=name item=value}
											<input type='hidden' name="{$name}" value="{$value}">
										{/foreach}
										
		
										<select name="rows" onchange='osKernel.submitForm("tableset-images-rows-selector")'><option value=""></option>
											{foreach from=$tvars.availableTotalRows item=rowsRange}
												<option value="{$rowsRange}" {if $tvars.maxRows.score_images == $rowsRange}selected{/if}>{$rowsRange}</option>
											{/foreach}
										</select>
									</form>
								</div>	
							</td>
						</tr>	
					{else}
						<tr>
							<td colspan="6" class="center">{t}No problematic images found (Yet){/t}</td>
						</tr>	
					{/if}	
					</tbody>	
				</table>			
				<div class="clear"></div>
			</div>
			<div class="clear"></div>
		</div>
		<div class="clear"></div>
	</div>
	
	<div id="list-image-score-by-page" class="tab-content">
	
		<div class='simple-box'>
			<div class='content'>
				<table class='striped' cellpadding='0' cellspacing='0'>
					<thead> 
						<tr> 
							<th class="header" style="width:20px">#</th>
							<th class="header" style="width:40%;text-align:left">{t}Page URL{/t}</th>
							<th class="header" style="width:60px;">{t}Total Images{/t}</th>
							<th class="header" style="width:60px;">{t}Errors{/t}</th>
							<th class="header" style="width:60px;">{t}Warnings{/t}</th>
							<th class="header" style="width:60px;">{t}Notices{/t}</th>
							<th class="header" style="width:60px;">
								Score
								<span class="icon gray smallest helper" data-icon='i' title="{t}OpenS Optimization score for each image, based on number and type of issues found{/t}" style="display:inline-block"></span>
							</th>
						</tr>
					</thead>
					<tbody>
					{if isset($tvars.imagesPageStats)}				
						{counter start=$tvars.startCounter.score_pages print=false}
						{foreach from=$tvars.imagesPageStats key=index item=details}
							<tr>
								<td class="center">{counter}</td> 
								<td class="left stable-row-fix">
									<a href="{$details.image_details_link}" title = "{$details.page_url}">
										{$details.page_url}
									</a>
								</td>
								<td class="center">
									<span>{$details.total_images}</span>
								</td>
								<td class="center">
									<span {if $details.errors > 0}class="statsInfoBoxText red"{/if}>{$details.errors}</span>
								</td>
								<td class="center">
									<span {if $details.warnings > 0}class="statsInfoBoxText yellow"{/if}>{$details.warnings}</span>
								</td>
								<td class="center">
									<span {if $details.notices > 0}class="statsInfoBoxText blue"{/if}>{$details.notices}</span>
								</td>
								<td class="center">{$details.score}</td>
							</tr>
						{/foreach}
						<tr>
							<td colspan="7">
								<div style="float:right; display:inline-block; padding:0px 10px;">		
									<button class="small blue" onclick="window.location='{$tvars.prev_link_pages}'" title="{t}Previous Entries{/t}">&laquo;</button>
									<button class="small blue" onclick="window.location='{$tvars.next_link_pages}'" title="{t}Next Entries{/t}">&raquo;</button>
								</div>
								<div style="float:right; display:inline-block; padding:0px 10px;">
									<label>Rows</label>
									<form name="tableset-pages-rows-selector" id="tableset-pages-rows-selector" method='GET' action="?" style="display:inline;">
										{foreach from=$tvars.linkParamsPages key=name item=value}
											<input type='hidden' name="{$name}" value="{$value}">
										{/foreach}
		
										<select name="rows" onchange='osKernel.submitForm("tableset-pages-rows-selector")'><option value=""></option>
											{foreach from=$tvars.availableTotalRows item=rowsRange}
												<option value="{$rowsRange}" {if $tvars.maxRows.score_pages == $rowsRange}selected{/if}>{$rowsRange}</option>
											{/foreach}
										</select>
									</form>
								</div>	
							</td>
						</tr>	
					{else}
						<tr>
							<td colspan="6" class="center">{t}No problematic images found (Yet){/t}</td>
						</tr>	
					{/if}	
					</tbody>	
				</table>			
				<div class="clear"></div>
			</div>
			<div class="clear"></div>
		</div>
		<div class="clear"></div>
	
	</div>
</div>