<?php
class OS_APP_OrganicImages_CrawlNow extends OS_AppViewBase
{
	private $appPlugin;
	
	private $crawlStatus;
	
	public function __construct()
	{
		$this->appPlugin = getOS()->getAppHandler()->getAppPlugin();
		
		$this->crawlStatus = false;
		
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS = getOS();
		$requestParams = $this->appPlugin->getRequestParams();
		
		if(isset($_GET['op']))
		{
			if($_GET['op'] == 'start_crawl')
			{
				$osProject = $OS->getProject();
				$crawlStatus = $this->appPlugin->requestProjectCrawl($osProject->id);
				
				if($crawlStatus)
				{
					$this->crawlStatus = true;
					$OS->addInfo(_("Project Crawler started"));
				}
				else
				{
					$OS->addInfo(_("Project Crawler is aleady working"));	
				}
			}
		}
	}
	
	public function render()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		
		$tplVars = array();
		
		$tplVars['backUrl']= $this->appPlugin->getAppActionUrl('view');
		
		$tplVars['crawl_url']= $this->appPlugin->getAppActionUrl('crawl_now', array('op' => 'start_crawl'));
		
		$tplVars['startCrawl'] = $this->crawlStatus;
		
		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('crawlnow', $tplVars);
	}
}
?>