<?php
class OS_APPFORK_OutgoingLinks_Generate_Report
{
	public function run($params)
	{
		$result=false;
		
		if (!empty($params[0]))
		{
			$project_id=$params[0];
			
			$OS=getOS();
			
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($project_id))
			{
				$appOps=$OS->getAppOps();
				$app=$appOps->getAppByName('outgoinglinks');
				
				if ($appOps->isProjectApp($project_id,$app->id))
				{
					$OS->initTimezone($project->timezone);
					
					$appHandler=$OS->getAppHandler('outgoinglinks');
					$appPlugin=$appHandler->getAppPlugin();
					$db=$OS->getDb();
					
					$report_start_dt=$db->DBTimeStamp(time());
					
					$report=OS_APP_OutgoingLinks_Report::get_instance();
					
					$report->project_id=$project_id;
					
					$linking_urls=array();
					$linked_urls=array();
					
					$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."projects_urls_links_external WHERE project_id=?",array($project_id));
					while ($row=$db->fetchRow($dbresult))
					{
						if (!isset($linking_urls[$row['from_url']]))
						{
							$report->linking_urls++;
							$linking_urls[$row['from_url']]=true;
						}
						
						if (!isset($linked_urls[$row['to_url']]))
						{
							$report->linked_urls++;
							$linked_urls[$row['to_url']]=array('url_hash'=>$row['to_url_hash'],'occurances'=>0);
						}
						$linked_urls[$row['to_url']]['occurances']+=$row['occurances'];
						
						if (empty($row['nofollow']))
						{
							$report->occurances_dofollow+=$row['occurances'];
						}
						else
						{
							$report->occurances_nofollow+=$row['occurances'];
						}
						
						$report->occurances_total+=$row['occurances'];
					}
					
					$linkOps=OS_APP_OutgoingLinks_LinkOperations::get_instance();
					
					$existingLinks=$linkOps->getLinks($project_id,0,0,'url_hash');
					
					$osHttp=$OS->getHttp();
					foreach ($linked_urls as $url=>$details)
					{
						$shouldCheck=true;
						
						if (isset($existingLinks[$details['url_hash']]))
						{
							$oneLink=$existingLinks[$details['url_hash']];
							unset($existingLinks[$details['url_hash']]);
							
							if (time()-strtotime($oneLink->check_dt)<86400)
							{
								$shouldCheck=false;
								$httpCode=$oneLink->http_code;
							}
							
							$oneLink->occurances=$details['occurances'];
						}
						else
						{
							$oneLink=new OS_APP_OutgoingLinks_Link();
							$oneLink->project_id=$project_id;
							$oneLink->url=$url;
							$oneLink->url_hash=$details['url_hash'];
							$oneLink->occurances=$details['occurances'];
						}
						
						$dt=$db->DBTimeStamp(time());
						
						if ($shouldCheck)
						{
							$osHttp->get($url);
							
							$httpCode=$osHttp->responseCode;
							
							$oneLink->http_code=$osHttp->responseCode;
							$oneLink->check_dt=$dt;
						}
						
						$oneLink->seen_dt=$dt;
						
						$oneLink->save();
						
						if ($httpCode==0 OR $httpCode>400)
						{
							$report->broken_linked_urls++;
						}
					}
					
					if (!empty($existingLinks))
					{
						$linkOps->deleteObsoleteLinks($project_id,$report_start_dt);
					}
					
					$report->save();
				}
			}
		}
		
		return $result;
	}
}
?>