<?php
class OS_APP_OutgoingLinks extends OS_AppBase
{
	private static $_instance;
	
	public function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
		
		$this->setRouterOption("urls", "handleUrlsView");
		$this->setRouterOption("url", "handleUrlView");
		$this->setRouterOption("export", "handleExportView");
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_OutgoingLinks();
		}
		
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('outgoinglinks','view');
		
		$viewData=new OS_APPVIEW_OutgoingLinks_Main();
		
		return $viewData->render();
	}
	
	public function handleUrlsView()
	{
		getOS()->getUser()->forcePerm('outgoinglinks','view');
		
		$viewData=new OS_APPVIEW_OutgoingLinks_Urls();
		
		return $viewData->render();
	}
	
	public function handleUrlView()
	{
		getOS()->getUser()->forcePerm('outgoinglinks','view');
		
		$viewData=new OS_APPVIEW_OutgoingLinks_Url();
		
		return $viewData->render();
	}
	
	public function handleExportView()
	{
		getOS()->getUser()->forcePerm('outgoinglinks','view');
		
		$viewData=new OS_APPVIEW_OutgoingLinks_Export();
		
		return $viewData->render();
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'outgoinglinks'=>array(
				'view'=>array('name'=>"View outgoing links data"),
			)
		);
	}
	
	public function eventProjectCrawlEnd($params)
	{
		$result=false;

		$result=OS_Fork::fork('app','outgoinglinks','generate_report',array('project_id'=>$params['project_id']));
		
		return $result;
	}
	
	public function eventProjectDeleted($params)
	{
		$ops=OS_APP_OutgoingLinks_ReportOperations::get_instance();
		
		return $ops->deleteDataByProjectID($params['project_id']);
	}
}
?>