<?php
class OS_APP_OutgoingLinks_Link
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $url;
	public $url_hash;
	public $http_code;
	public $occurances;
	public $check_dt;
	public $seen_dt;
		
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_OutgoingLinks_Link();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		
		$this->linking_urls=0;
		$this->linked_urls=0;
		$this->broken_linked_urls=0;
		$this->occurances_nofollow=0;
		$this->occurances_dofollow=0;
		$this->occurances_total=0;
		
		$this->insert_dt='';
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_OutgoingLinks_LinkOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertLink($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateLink($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_OutgoingLinks_LinkOperations::get_instance();
			
			if ($data=$ops->getLinkByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_OutgoingLinks_LinkOperations::get_instance();
			
			$result=$ops->deleteLinkByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
	}
}
?>