<?php
class OS_APP_OutgoingLinks_Report
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $linking_urls;
	public $linked_urls;
	public $broken_linked_urls;
	public $occurances_nofollow;
	public $occurances_dofollow;
	public $occurances_total;
	public $insert_dt;
		
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_OutgoingLinks_Report();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		
		$this->linking_urls=0;
		$this->linked_urls=0;
		$this->broken_linked_urls=0;
		$this->occurances_nofollow=0;
		$this->occurances_dofollow=0;
		$this->occurances_total=0;
		
		$this->insert_dt='';
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_OutgoingLinks_ReportOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertReport($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateReport($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_OutgoingLinks_ReportOperations::get_instance();
			
			if ($data=$ops->getReportByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_OutgoingLinks_ReportOperations::get_instance();
			
			$result=$ops->deleteReportByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$osUtils=getOS()->getUtils();
		
		$report_arr=array(
			'id'=>$this->id,
			'project_id'=>$this->project_id,
			'linking_urls'=>$this->linking_urls,
			'linked_urls'=>$this->linked_urls,
			'broken_linked_urls'=>$this->broken_linked_urls,
			'occurances_nofollow'=>$this->occurances_nofollow,
			'occurances_dofollow'=>$this->occurances_dofollow,
			'occurances_total'=>$this->occurances_total,
			'insert_dt'=>$this->insert_dt,
			'insert_dt_human'=>$osUtils->humanizeDate($this->insert_dt)
		);
		
		return $report_arr;
	}
}
?>