<?php
class OS_APPVIEW_OutgoingLinks_Main extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$ops=OS_APP_OutgoingLinks_ReportOperations::get_instance();
		
		$viewDataVars=array();
		
		if ($reports=$ops->getLatestReports($project->id,10))
		{
			$report=reset($reports);
			
			$viewDataVars['report']=$report->toTemplate();
			
			if (count($reports)>1)
			{
				foreach ($reports as $report)
				{
					$viewDataVars['stats'][date('Y-m-d',strtotime($report->insert_dt))]=array(
						'total'=>$report->occurances_total,
						'dofollow'=>$report->occurances_dofollow,
						'nofollow'=>$report->occurances_nofollow,
						'broken'=>$report->broken_linked_urls
					);
				}
				
				$viewDataVars['stats']=array_reverse($viewDataVars['stats'],true);
			}
			else
			{
				$viewDataVars['stats']=false;
			}
		}
		else
		{
			$viewDataVars['report']=false;
			$viewDataVars['stats']=false;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->buildViewData();
		$headContents=array();
		
		if ($tplVars['stats'])
		{
			$tplVars['charts']=array(
				'legend'=>array('broken'=>_("Broken linked pages"),'total'=>_("Total links"),'dofollow'=>_("Dofollow links"),'nofollow'=>_("Nofollow links")),
				'actualCharts'=>array()
			);
			
			$osCharts = $OS->getCharts();
			
			foreach ($tplVars['charts']['legend'] as $type=>$name)
			{
				$chartValues=array();$chartTooltips=array();$chartLabels=array();
				foreach ($tplVars['stats'] as $day=>$details)
				{
					$stats_value=$details[$type];
					$chartValues[]=$stats_value;
					$chartLabels[]=date('d M',strtotime($day));
					$chartTooltips[]=date('d M',strtotime($day))."\n{$stats_value} "._("URLs");
				}
				
				$chartOptions=array(
					'values'=>array_values($chartValues),
					'labels'=>$chartLabels,
					'tooltips'=>$chartTooltips,
					'fill'=>true,
					'normalize'=>true
				);
				
				$chartData = $osCharts->getLineChart($chartOptions);
					
				$tplVars['charts']['actualCharts'][$type]=$chartData['html'];
				$headContents = array_merge($headContents, $chartData['js']);
			}
			
			$headContents['chartSwitcher']="<script type='text/javascript'>
				function switchChart(selectedIndex)
				{
					$('#chartsContainer').css('margin-top',(-selectedIndex*150)+'px')
				}
			</script>";
		}
		else
		{
			$tplVars['charts']=false;
		}
		
		unset($tplVars['stats']);
		
		$tplVars['urls']=array(
			'total'=>$appPlugin->getAppActionUrl('urls',array('url_type'=>'from')),
			'dofollow'=>$appPlugin->getAppActionUrl('urls',array('url_type'=>'from','filters'=>'dofollow')),
			'nofollow'=>$appPlugin->getAppActionUrl('urls',array('url_type'=>'from','filters'=>'nofollow')),
			'broken'=>$appPlugin->getAppActionUrl('urls',array('url_type'=>'broken')),
			'linking'=>$appPlugin->getAppActionUrl('urls',array('url_type'=>'from')),
			'linked'=>$appPlugin->getAppActionUrl('urls',array('url_type'=>'to')),
		);
		
		$tpl=$OS->getTemplate();
		
		if (!empty($headContents))
		{
			$tpl->setHeadContents($headContents);
		}
		
		return $tpl->fetchTemplate('view',$tplVars);
	}
}
?>