<?php
class OS_APPFORK_QuickComparison_Compare
{
	public function run($params)
	{
		$result=false;

		if (!empty($params[0]) AND !empty($params[1]))
		{
			$project_id=$params[0];
			$comparison_id=$params[1];
			
			$OS=getOS();
			$appHandler=$OS->getAppHandler('quickcomparison');
			$appPlugin=$appHandler->getAppPlugin();
			
			$ops=OS_APP_QuickComparison_ComparisonOperations::get_instance();
			
			if ($comparison=$ops->getComparisonByID($comparison_id,$project_id))
			{
				$urls=array();
				
				for ($i=1;$i<=5;$i++)
				{
					$var='url_'.$i;
					$result_var='url_'.$i.'_results';
					
					if (!empty($comparison->$var) AND empty($comparison->$result_var))
					{
						$urls[$comparison->$var]=$i;
					}
				}
				
				if ($urls)
				{
					$changesMade=false;
					
					$osBacklinks=$OS->getBacklinks();
					$osUtils=$OS->getUtils();
					
					//Moz metrics
					if ($comparison->has_moz)
					{
						$results['moz']=$osBacklinks->getUrlsMetrics(array_keys($urls),'moz');
					}
					else
					{
						$results['moz']=false;
					}
					
					//Majestic URL metrics
					$results['majestic']=$osBacklinks->getUrlsMetrics(array_keys($urls),'majesticsimple');
					
					//Majestic subdomain metrics
					$subdomains=array();$subdomains_to_check=array();
					foreach ($urls as $url=>$index)
					{
						$subdomain=parse_url($url,PHP_URL_HOST);
						
						$subdomains[$url]=$subdomain;
						$subdomains_to_check[$subdomain]=true;
					}
					if ($temp=$osBacklinks->getUrlsMetrics(array_keys($subdomains_to_check),'majesticsimple'))
					{
						foreach ($subdomains as $url=>$subdomain)
						{
							$subdomain_data=(empty($temp[$subdomain])?false:$temp[$subdomain]);
							
							$results['majestic_subdomains'][$url]=$subdomain_data;
						}
					}
					
					//Majestic root domain metrics
					$roots=array();$roots_to_check=array();
					foreach ($subdomains as $url=>$subdomain)
					{
						$root=$osUtils->extractRootDomainFromHost($subdomain);
						$roots[$url]=$root;
						
						if ($root!=$subdomain)
						{
							$roots_to_check[$root]=$url;
						}
					}
					if ($roots_to_check)
					{
						if ($temp=$osBacklinks->getUrlsMetrics(array_keys($roots_to_check),'majesticsimple'))
						{
							foreach ($roots as $url=>$root)
							{
								if (isset($temp[$root]))
								{
									$root_data=(empty($temp[$root])?false:$temp[$root]);
									
									$results['majestic_roots'][$url]=$root_data;
								}
							}
						}
					}
					foreach ($roots as $url=>$root)
					{
						if (!isset($results['majestic_roots'][$url]))
						{
							$results['majestic_roots'][$url]=$results['majestic_subdomains'][$url];
						}
					}
					
					$osSocialSignals=$OS->getSocialSignals();
					
					$osSocialSignals->setSocialNetwork('sharedcount');
					
					foreach ($urls as $url=>$index)
					{
						$url_result=array(
							'moz'=>($results['moz']?(isset($results['moz'][$url])?$results['moz'][$url]:false):false),
							'majestic'=>array(
								'url'=>($results['majestic']?(isset($results['majestic'][$url])?$results['majestic'][$url]:false):false),
								'subdomain'=>($results['majestic_subdomains']?(isset($results['majestic_subdomains'][$url])?$results['majestic_subdomains'][$url]:false):false),
								'root'=>($results['majestic_roots']?(isset($results['majestic_roots'][$url])?$results['majestic_roots'][$url]:false):false)
							),
							'social'=>$osSocialSignals->getSocialSignals($url)
						);
						
						if ($url_result['majestic']['url']==false AND $url_result['majestic']['subdomain']==false AND $url_result['majestic']['root']==false)
						{
							$url_result['majestic']=false;
						} 
						
						if ($url_result['moz']!=false OR $url_result['majestic']!=false OR $url_result['social']!=false)
						{
							$result_var='url_'.$index.'_results';
							
							$comparison->$result_var=$url_result;
							
							$changesMade=true;
						}
					}
					
					if ($changesMade)
					{
						$comparison->status=$ops->getComparisonStatus($comparison);
						
						if ($comparison->save())
						{
							$result=true;
						}
					}
				}
				else
				{
					$result=true;
				}
			}
		}
		
		return $result;
	}
}
?>