<?php
class OS_APP_QuickComparison extends OS_AppBase
{
	private static $_instance;
	
	public function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
		$this->addMenuItem('compare', array("name" => _("Compare"), 'routerOption'=> "handleCompareView"));
		
		$this->setRouterOption("comparison", "handleComparisonView");
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_QuickComparison();
		}
		
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('quickcomparison','view');
		
		$viewData=new OS_APPVIEW_QuickComparison_Main();
		
		return $viewData->render();
	}
	
	public function handleCompareView()
	{
		getOS()->getUser()->forcePerm('quickcomparison','view');
		
		$viewData=new OS_APPVIEW_QuickComparison_Compare();
		
		return $viewData->render();
	}
	
	public function handleComparisonView()
	{
		getOS()->getUser()->forcePerm('quickcomparison','view');
		
		$viewData=new OS_APPVIEW_QuickComparison_Comparison();
		
		return $viewData->render();
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'quickcomparison'=>array(
				'view'=>array('name'=>_("View and run comparisons")),
			)
		);
	}
	
	public function eventProjectDeleted($params)
	{
		$ops=OS_APP_QuickComparison_ComparisonOperations::get_instance();
		
		return $ops->deleteDataByProjectID($params['project_id']);
	}
	
	public function eventProjectCompetitorsDetected($params)
	{
		$result=false;
		
		$OS=getOS();
		$appOps=$OS->getAppOps();
		
		if ($appOps->isProjectApp($params['project_id'],$this->getAppDetail('app_id')))
		{
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($params['project_id']) AND $project->isActive())
			{
				$osUtils=$OS->getUtils();
				
				$urls=array(
					'url_1'=>$osUtils->prependHTTP(parse_url($project->url,PHP_URL_HOST)),
				);
				
				$i=1;
				$compareTo=array_slice($params['competitors'],0,4,true);
				foreach ($compareTo as $host)
				{
					$i++;
					
					$urls["url_{$i}"]=$osUtils->prependHTTP($host);
				}
				
				$oneComparison=new OS_APP_QuickComparison_Comparison();
				
				$oneComparison->project_id=$project->id;
				foreach ($urls as $var=>$value)
				{
					$oneComparison->$var=$value;
				}
				
				$osBacklinks=$OS->getBacklinks();
				if ($osBacklinks->loadEngine('moz'))
				{
					$oneComparison->has_moz='Y';
				}
				
				if ($oneComparison->save())
				{
					OS_Fork::fork('app','quickcomparison','compare',array('project_id'=>$oneComparison->project_id,'comparison_id'=>$oneComparison->id));
				}
			}
		}
	}
}
?>