<?php
class OS_APP_QuickComparison_Comparison
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $url_1;
	public $url_1_results;
	public $url_2;
	public $url_2_results;
	public $url_3;
	public $url_3_results;
	public $url_4;
	public $url_4_results;
	public $url_5;
	public $url_5_results;
	public $has_moz;
	public $status;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_QuickComparison_Comparison();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		
		$this->url_1='';
		$this->url_1_results=array();
		
		$this->url_2='';
		$this->url_2_results=array();
		
		$this->url_3='';
		$this->url_3_results=array();
		
		$this->url_4='';
		$this->url_4_results=array();
		
		$this->url_5='';
		$this->url_5_results=array();
		
		$this->has_moz='';
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_QuickComparison_ComparisonOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertComparison($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateComparison($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_QuickComparison_ComparisonOperations::get_instance();
			
			if ($data=$ops->getComparisonByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_QuickComparison_ComparisonOperations::get_instance();
			
			$result=$ops->deleteComparisonByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$statuses=array('W'=>_('Working...'),'D'=>_('Done'),'F'=>_('Failed'));
		
		$result=array(
			'id'=>$this->id,
			'project_id'=>$this->project_id,
			'url_1'=>$this->url_1,
			'url_1_host'=>(empty($this->url_1)?'-':parse_url($this->url_1,PHP_URL_HOST)),
			'url_1_results'=>$this->url_1_results,
			'url_2'=>$this->url_2,
			'url_2_host'=>(empty($this->url_2)?'-':parse_url($this->url_2,PHP_URL_HOST)),
			'url_2_results'=>$this->url_2_results,
			'url_3'=>$this->url_3,
			'url_3_host'=>(empty($this->url_3)?'-':parse_url($this->url_3,PHP_URL_HOST)),
			'url_3_results'=>$this->url_3_results,
			'url_4'=>$this->url_4,
			'url_4_host'=>(empty($this->url_4)?'-':parse_url($this->url_4,PHP_URL_HOST)),
			'url_4_results'=>$this->url_4_results,
			'url_5'=>$this->url_5,
			'url_5_host'=>(empty($this->url_5)?'-':parse_url($this->url_5,PHP_URL_HOST)),
			'url_5_results'=>$this->url_5_results,	
			'has_moz'=>$this->has_moz,
			'status'=>$this->status,
			'status_human'=>$statuses[$this->status],
			'view_url'=>($this->status=='D'?$app->getAppActionUrl('comparison',array('comparison_id'=>$this->id)):false),
			'delete_url'=>$app->getAppActionUrl('view',array('op'=>'delete','comparison_id'=>$this->id))
		);
		
		return $result;
	}
}
?>