<?php
class OS_APP_QuickComparison_ComparisonOperations
{
	private static $_instance;
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_QuickComparison_ComparisonOperations();
		}
		
		return self::$_instance;
	}
	
	public function getComparisons($project_id=false,$offset=0,$count=10)
	{
		$result=false;
		
		$OS=getOS();
		
		if (!$project_id)
		{
			$osProject=$OS->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."comparisons WHERE project_id=?".(($offset!==false AND $count!==false)?" LIMIT {$offset},{$count}":''),array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			for ($i=1;$i<=5;$i++)
			{
				$row["url_{$i}_results"]=json_decode($row["url_{$i}_results"],true);
			}
			
			$oneComparison=new OS_APP_QuickComparison_Comparison();
			$oneComparison->set($row);
			
			$result[$row['id']]=$oneComparison;
		}
		
		return $result;
	}
	
	public function getComparisonsCount($project_id=false)
	{
		$result=false;
		
		$OS=getOS();
		
		if (!$project_id)
		{
			$osProject=$OS->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT COUNT(id) AS comparisons FROM ".$appHandler->dbPrefix()."comparisons WHERE project_id=?",array($project_id));
		$row=$db->fetchRow($dbresult);
		$result=$row['comparisons'];
		
		return $result;
	}
	
	public function getComparisonByID($comparison_id,$project_id=false)
	{
		$result=false;
		
		$OS=getOS();
		
		if (!$project_id)
		{
			$osProject=$OS->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."comparisons WHERE id=? AND project_id=?",array($comparison_id,$project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			for ($i=1;$i<=5;$i++)
			{
				$row["url_{$i}_results"]=json_decode($row["url_{$i}_results"],true);
			}
			
			$result=new OS_APP_QuickComparison_Comparison();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function insertComparison($comparison)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		$ip=$OS->getRemoteAddr();
		
		for ($i=1;$i<=5;$i++)
		{
			$temp="url_{$i}_results";
			$comparison->$temp=json_encode($comparison->$temp);
		}
		
		$comparison->status='W';
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."comparisons (project_id,url_1,url_1_results,url_2,url_2_results,url_3,url_3_results,url_4,url_4_results,url_5,url_5_results,has_moz,status) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
		$dbresult=$db->query($query,array($comparison->project_id,$comparison->url_1,$comparison->url_1_results,$comparison->url_2,$comparison->url_2_results,$comparison->url_3,$comparison->url_3_results,$comparison->url_4,$comparison->url_4_results,$comparison->url_5,$comparison->url_5_results,$comparison->has_moz,$comparison->status));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateComparison($comparison)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		$ip=$OS->getRemoteAddr();
		
		for ($i=1;$i<=5;$i++)
		{
			$temp="url_{$i}_results";
			$comparison->$temp=json_encode($comparison->$temp);
		}
		
		$query="UPDATE ".$appHandler->dbPrefix()."comparisons SET url_1_results=?,url_2_results=?,url_3_results=?,url_4_results=?,url_5_results=?,status=? WHERE id=?";
		$dbresult=$db->query($query,array($comparison->url_1_results,$comparison->url_2_results,$comparison->url_3_results,$comparison->url_4_results,$comparison->url_5_results,$comparison->status,$comparison->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteComparisonByID($comparison_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."comparisons WHERE id=?";
		$dbresult=$db->query($query,array($comparison_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function getComparisonStatus($comparison)
	{
		$result=false;
		
		$urls=array();
				
		for ($i=1;$i<=5;$i++)
		{
			$var='url_'.$i;
			$result_var='url_'.$i.'_results';
			
			if (!empty($comparison->$var) AND empty($comparison->$result_var))
			{
				$urls[$comparison->$var]=$i;
			}
		}
		
		if (empty($urls))
		{
			$result='D';
		}
		else
		{
			$result='W';
		}
		
		return $result;
	}
	
	public function deleteDataByProjectID($project_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."comparisons WHERE project_id=?";
		$dbresult=$db->query($query,array($project_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
}
?>