<?php
class OS_APPVIEW_QuickComparison_Compare extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			$osUtils=$OS->getUtils();
			$osValidator=$OS->getValidator();
			
			$urls=array();
			
			for ($i=1;$i<=5;$i++)
			{
				if (!empty($requestParams["url_{$i}_box"]))
				{
					$url=$osUtils->prependHTTP($requestParams["url_{$i}_box"]);
					
					if ($osValidator->is_url($url))
					{
						$urls[]=$url;
					}
					else
					{
						$OS->addFieldError(_("Invalid URL"),"url_{$i}");
					}
				}
				else
				{
					$requestParams["url_{$i}_box"]='';
				}
			}
			
			if (count($urls)<2)
			{
				$OS->addFieldError(_("At least 2 URLs required for a comparison"),'url_1');
			}
			
			if (!isset($OS->errorMessages))
			{
				$oneComparison=new OS_APP_QuickComparison_Comparison();
				
				$oneComparison->project_id=$OS->getProject()->id;
				
				$i=0;
				foreach ($urls as $url)
				{
					$i++;
					$var='url_'.$i;
					
					$oneComparison->$var=$url;
				}
				
				$osBacklinks=$OS->getBacklinks();
				
				if ($osBacklinks->loadEngine('moz'))
				{
					$oneComparison->has_moz='Y';
				}
				
				if ($oneComparison->save())
				{
					OS_Fork::fork('app','quickcomparison','compare',array('project_id'=>$oneComparison->project_id,'comparison_id'=>$oneComparison->id));
					
					$OS->redirectTO($appPlugin->getAppActionUrl('main',array('msg'=>'compare_ok')),true);
				}
			}
		}
		else
		{
			$requestParams['url_1_box']=$OS->getProject()->url;
			$requestParams['url_2_box']='';
			$requestParams['url_3_box']='';
			$requestParams['url_4_box']='';
			$requestParams['url_5_box']='';
		}
		
		return $requestParams;
	}
	
	public function render()
	{
		$OS=getOS();

		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$tplVars['appURL']=$appPlugin->getAppUrl();
		
		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('compare',$tplVars);
	}
}
?>