<?php
class OS_APPVIEW_QuickComparison_Comparison extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['comparison_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$ops=OS_APP_QuickComparison_ComparisonOperations::get_instance();
		
		if (!$comparison=$ops->getComparisonByID($requestParams['comparison_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		elseif ($comparison->status!='D')
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if (isset($requestParams['export']))
		{
			$export=true;
		}
		else
		{
			$export=false;
		}
		
		return array('comparison'=>$comparison,'export'=>$export);
	}
	
	public function render()
	{
		$OS=getOS();

		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$osUtils=$OS->getUtils();
		
		$viewData=$this->buildViewData();
		
		$appPlugin->setMenuBackLink(array('back_view'=>'view'));
		
		$tplVars=array();
		$comparison=$this->processedRequest['comparison']->toTemplate();
		
		$niceSideNames=array('url'=>"URL",'subdomain'=>_("Subdomain"),'root'=>_("Root domain"));
		
		$tplVars=array(
			'urls'=>array(),
			'max_wins'=>0,
			'details'=>array(
				'url'=>array(
					'moz_pa'=>array(
						'info'=>array(
							'title'=>"Moz Page Authority",
							'short'=>"Moz PA"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'majestic_cf'=>array(
						'info'=>array(
							'title'=>"Majestic CitationFlow",
							'short'=>"Majestic CF"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'majestic_tf'=>array(
						'info'=>array(
							'title'=>"Majestic TrustFlow",
							'short'=>"Majestic TF"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'backlinks'=>array(
						'info'=>array(
							'title'=>_("Incoming links"),
							'short'=>_("Backlinks")
						),
						'values'=>array(),
						'max_value'=>0
					),
					'rootdomains'=>array(
						'info'=>array(
							'title'=>_("Linking root domains"),
							'short'=>_("Root domains")
						),
						'values'=>array(),
						'max_value'=>0
					),
					'facebook'=>array(
						'info'=>array(
							'title'=>_("Facebook signals (likes+shares+comments)"),
							'short'=>"Facebook"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'twitter'=>array(
						'info'=>array(
							'title'=>_("Tweets"),
							'short'=>"Twitter"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'gplus'=>array(
						'info'=>array(
							'title'=>_("+1s"),
							'short'=>"Google+"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'social_total'=>array(
						'info'=>array(
							'title'=>_("Total social signals (Facebook, Twitter, Google+, Pinterest, etc)"),
							'short'=>_("Social overall")
						),
						'values'=>array(),
						'max_value'=>0
					)
				),
				'subdomain'=>array(
					'majestic_cf'=>array(
						'info'=>array(
							'title'=>"Majestic CitationFlow",
							'short'=>"Majestic CF"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'majestic_tf'=>array(
						'info'=>array(
							'title'=>"Majestic TrustFlow",
							'short'=>"Majestic TF"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'backlinks'=>array(
						'info'=>array(
							'title'=>_("Incoming links"),
							'short'=>_("Backlinks")
						),
						'values'=>array(),
						'max_value'=>0
					),
					'rootdomains'=>array(
						'info'=>array(
							'title'=>_("Linking root domains"),
							'short'=>_("Root domains")
						),
						'values'=>array(),
						'max_value'=>0
					),
				),
				'root'=>array(
					'moz_da'=>array(
						'info'=>array(
							'title'=>"Moz Domain Authority",
							'short'=>"Moz DA"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'majestic_cf'=>array(
						'info'=>array(
							'title'=>"Majestic CitationFlow",
							'short'=>"Majestic CF"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'majestic_tf'=>array(
						'info'=>array(
							'title'=>"Majestic TrustFlow",
							'short'=>"Majestic TF"
						),
						'values'=>array(),
						'max_value'=>0
					),
					'backlinks'=>array(
						'info'=>array(
							'title'=>_("Incoming links"),
							'short'=>_("Backlinks")
						),
						'values'=>array(),
						'max_value'=>0
					),
					'rootdomains'=>array(
						'info'=>array(
							'title'=>_("Linking root domains"),
							'short'=>_("Root domains")
						),
						'values'=>array(),
						'max_value'=>0
					),
				)
			)
		);
		
		if ($comparison['has_moz']!='Y')
		{
			unset($tplVars['details']['root']['moz_da'],$tplVars['details']['url']['moz_pa']);
		}
		
		$showSubdomains=false;
		$i=1;
		while (!empty($comparison["url_{$i}"]))
		{
			$nicePath=parse_url($comparison["url_{$i}"],PHP_URL_PATH);
			
			if ($nicePath!='/')
			{
				$nicePath='/...';
			}	
			
			$tplVars['urls'][$i]=array(
				'url'=>$comparison["url_{$i}"],
				'url_safe'=>$osUtils->getSafeURL($comparison["url_{$i}"]),
				'url_nice'=>$comparison["url_{$i}_host"].$nicePath,
				'host'=>$comparison["url_{$i}_host"],
				'root'=>$osUtils->extractRootDomainFromHost($comparison["url_{$i}_host"]),
				'wins'=>0
			);
			
			if ($tplVars['urls'][$i]['host']!=$tplVars['urls'][$i]['root'])
			{
				$showSubdomains=true;
			}
			
			if ($comparison['has_moz']=='Y')
			{
				$tplVars['details']['root']['moz_da']['values'][$i]=(isset($comparison["url_{$i}_results"]['moz']['domain_authority'])?round($comparison["url_{$i}_results"]['moz']['domain_authority']):'n/a');
				$tplVars['details']['url']['moz_pa']['values'][$i]=(isset($comparison["url_{$i}_results"]['moz']['page_authority'])?round($comparison["url_{$i}_results"]['moz']['page_authority']):'n/a');
			}
			
			$tplVars['details']['url']['majestic_cf']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['url']['citation_flow'])?$comparison["url_{$i}_results"]['majestic']['url']['citation_flow']:'n/a');
			$tplVars['details']['url']['majestic_tf']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['url']['trust_flow'])?$comparison["url_{$i}_results"]['majestic']['url']['trust_flow']:'n/a');
			$tplVars['details']['url']['backlinks']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['url']['backlinks'])?$comparison["url_{$i}_results"]['majestic']['url']['backlinks']:'n/a');
			$tplVars['details']['url']['rootdomains']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['url']['rootdomains'])?$comparison["url_{$i}_results"]['majestic']['url']['rootdomains']:'n/a');
			
			$tplVars['details']['subdomain']['majestic_cf']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['subdomain']['citation_flow'])?$comparison["url_{$i}_results"]['majestic']['subdomain']['citation_flow']:'n/a');
			$tplVars['details']['subdomain']['majestic_tf']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['subdomain']['trust_flow'])?$comparison["url_{$i}_results"]['majestic']['subdomain']['trust_flow']:'n/a');
			$tplVars['details']['subdomain']['backlinks']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['subdomain']['backlinks'])?$comparison["url_{$i}_results"]['majestic']['subdomain']['backlinks']:'n/a');
			$tplVars['details']['subdomain']['rootdomains']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['subdomain']['rootdomains'])?$comparison["url_{$i}_results"]['majestic']['subdomain']['rootdomains']:'n/a');
			
			$tplVars['details']['root']['majestic_cf']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['root']['citation_flow'])?$comparison["url_{$i}_results"]['majestic']['root']['citation_flow']:'n/a');
			$tplVars['details']['root']['majestic_tf']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['root']['trust_flow'])?$comparison["url_{$i}_results"]['majestic']['root']['trust_flow']:'n/a');
			$tplVars['details']['root']['backlinks']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['root']['backlinks'])?$comparison["url_{$i}_results"]['majestic']['root']['backlinks']:'n/a');
			$tplVars['details']['root']['rootdomains']['values'][$i]=(isset($comparison["url_{$i}_results"]['majestic']['root']['rootdomains'])?$comparison["url_{$i}_results"]['majestic']['root']['rootdomains']:'n/a');
			
			if (!empty($comparison["url_{$i}_results"]['social']))
			{
				if (isset($comparison["url_{$i}_results"]['social']['facebook']['total']))
				{
					$comparison["url_{$i}_results"]['social']['facebook']=$comparison["url_{$i}_results"]['social']['facebook']['total'];
				}
				
				$tplVars['details']['url']['facebook']['values'][$i]=$comparison["url_{$i}_results"]['social']['facebook'];
				$tplVars['details']['url']['twitter']['values'][$i]=$comparison["url_{$i}_results"]['social']['twitter'];
				$tplVars['details']['url']['gplus']['values'][$i]=$comparison["url_{$i}_results"]['social']['gplus'];
				$tplVars['details']['url']['social_total']['values'][$i]=array_sum($comparison["url_{$i}_results"]['social']);
			}
			else
			{
				$tplVars['details']['url']['facebook']['values'][$i]='n/a';
				$tplVars['details']['url']['twitter']['values'][$i]='n/a';
				$tplVars['details']['url']['gplus']['values'][$i]='n/a';
				$tplVars['details']['url']['social_total']['values'][$i]='n/a';
			}
			
			$i++;
		}
		
		if ($this->processedRequest['export'])
		{
			$csv=_("URLs");
			
			foreach ($tplVars['urls'] as $index=>$url)
			{
				$csv.=",\"{$url['url']}\"";
			}
			
			foreach ($tplVars['details'] as $side=>$actual_details)
			{
				if ($side=='subdomain' AND !$showSubdomains)
				{
					continue;
				}
				else
				{
					foreach ($actual_details as $type=>$details)
					{
						$csv.="\n{$niceSideNames[$side]} {$details['info']['short']}";
						
						foreach ($details['values'] as $index=>$value)
						{
							$csv.=",{$value}";
						}
					}
				}
			}
		}
		
		foreach ($tplVars['details'] as $side=>$actual_details)
		{
			if ($side=='subdomain' AND !$showSubdomains)
			{
				continue;
			}
			else
			{
				foreach ($actual_details as $type=>$details)
				{
					$max_value=max($details['values']);
					
					foreach ($details['values'] as $url_index=>$value)
					{
						if ($value=='n/a')
						{
							$tplVars['details'][$side][$type]['values'][$url_index]=array(
								'actual_value'=>$value,
								'is_max'=>false
							);
						}
						else
						{
							$tplVars['details'][$side][$type]['values'][$url_index]=array(
								'actual_value'=>$osUtils->humanizeInteger($value),
								'is_max'=>($value==$max_value?true:false)
							);
							
							if ($value==$max_value)
							{
								$tplVars['urls'][$url_index]['wins']++;
								
								if ($tplVars['urls'][$url_index]['wins']>$tplVars['max_wins'])
								{
									$tplVars['max_wins']=$tplVars['urls'][$url_index]['wins'];
								}
							}
						}
					}
					
					$tplVars['details'][$side][$type]['max_value']=$max_value;
				}
			}
		}
		
		if ($this->processedRequest['export'])
		{
			$csv.="\nWins #";
			
			foreach ($tplVars['urls'] as $index=>$url)
			{
				$csv.=",{$url['wins']}";
			}
			
			header('Content-Type: text/csv');
			header('Content-Disposition: attachment; filename="quick_comparison_'.$this->processedRequest['comparison']->id.'.csv"');
			
			echo $csv;
			
			exit;
		}
		
		$wins=array();
		foreach ($tplVars['urls'] as $index=>$url)
		{
			$wins[$url['host']]=$url['wins'];
		}
		arsort($wins);
		
		$chartOptions=array(
			'values'=>array_values($wins),
			'legend'=>array_keys($wins),
			'legend_position'=>'right'
		);
		
		$osCharts=$OS->getCharts();
		
		$chart=$osCharts->getPieChart($chartOptions);
		
		$tplVars['showRoots']=$showSubdomains;		
		$tplVars['chart_html'] = $chart['html'];
		$tplVars['exportURL']=$appPlugin->getAppActionUrl('comparison',array('comparison_id'=>$this->processedRequest['comparison']->id,'export'=>'yes'));
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($chart['js']);
		
		return $tpl->fetchTemplate('comparison',$tplVars);
	}
}
?>