<?php
class OS_APPVIEW_QuickComparison_Main extends OS_AppViewBase
{
	public $comparisonsPerPage=10;
	
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		$processedRequest=array();
		
		$ops=OS_APP_QuickComparison_ComparisonOperations::get_instance();
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='delete')
			{
				if (!empty($requestParams['comparison_id']) AND $comparison=$ops->getComparisonByID($requestParams['comparison_id']))
				{
					if ($comparison->delete())
					{
						$OS->addInfo(_("Comparison deleted successfully"));
					}
					else
					{
						$OS->addBoxError(_("Unable to delete comparison"));
					}
				} 
			}
		}
		
		$processedRequest['comparisonsCount']=$ops->getComparisonsCount();
		$processedRequest['page']=1;
		
		if (!empty($requestParams['page']) AND ($requestParams['page']>0) AND (($requestParams['page']-1)*$this->comparisonsPerPage<$processedRequest['comparisonsCount']))
		{
			$processedRequest['page']=$requestParams['page'];
		}
		
		return $processedRequest;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewDataVars=array();
				
		if ($this->processedRequest['comparisonsCount'])
		{
			$ops=OS_APP_QuickComparison_ComparisonOperations::get_instance();
			
			$viewDataVars['comparisonsCount']=$this->processedRequest['comparisonsCount'];
			
			$viewDataVars['comparisons']=$ops->getComparisons($osProject->id,($this->processedRequest['page']-1)*$this->comparisonsPerPage,$this->comparisonsPerPage);
		}
		else
		{
			$viewDataVars=array(
				'comparisonsCount'=>0,
				'comparisons'=>array()
			);
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();

		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		
		$tplVars=array();
		
		if ($viewData['comparisons'])
		{
			foreach ($viewData['comparisons'] as $comparison_id=>$comparison)
			{
				$tplVars['comparisons'][$comparison_id]=$comparison->toTemplate();
			}
		}
		else
		{
			$tplVars['comparisons']=false;
		}
		
		if ($this->processedRequest['page']>1)
		{
			$tplVars['prev_page_url']=$appPlugin->getAppActionUrl('main',array('page'=>$this->processedRequest['page']-1));
		}
		else
		{
			$tplVars['prev_page_url']=false;
		}
		
		if (($this->processedRequest['page']*$this->comparisonsPerPage)<$viewData['comparisonsCount'])
		{
			$tplVars['next_page_url']=$appPlugin->getAppActionUrl('main',array('page'=>$this->processedRequest['page']+1));
		}
		else
		{
			$tplVars['next_page_url']=false;
		}

		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('view',$tplVars);
	}
}
?>