<?php
class OS_APP_RelatedKws_Extract
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_RelatedKws_Extract();
		}
		
		return self::$_instance;
	}
	
	public function queueKeyword()
	{
	}
	
	public function getBingRelatedSearches($keyword,$options)
	{
		$result=false;
		
		$osSearchEngine=getOS()->getSearchEngine();
		
		if ($serp=$osSearchEngine->getSerp($keyword,'bing',$options['locale']))
		{
			if ($serp['status']=='done')
			{
				$result=array();
				
				$dom=new DOMDocument();
				
				libxml_use_internal_errors(true);
				$domLoaded=$dom->loadHTML($serp['data']);
				libxml_use_internal_errors(false);
				
				if ($domLoaded)
				{
					$xpath=new DOMXPath($dom);
					
					$entries=$xpath->query("//li[@class='rrrs_itm']");
					
					foreach ($entries as $entry)
					{
						$result[]=$entry->nodeValue;
					}
				}
			}
			else
			{
				$this->queueKeyword();
			}
		}
		
		return $result;
	}
	
	public function getGoogleRelatedSearches($keyword,$options)
	{
		$result=false;
		
		$osSearchEngine=getOS()->getSearchEngine();
		
		if ($serp=$osSearchEngine->getSerp($keyword,'google',$options['locale']))
		{
			if ($serp['status']=='done')
			{
				$result=array();
				
				$dom=new DOMDocument();
				
				libxml_use_internal_errors(true);
				$domLoaded=$dom->loadHTML($serp['data']);
				libxml_use_internal_errors(false);
				
				if ($domLoaded)
				{
					$xpath=new DOMXPath($dom);
					
					$entries=$xpath->query("//p[@class='msrl']");
					
					if (!$entries->item(0))
					{
						$entries=$xpath->query("//div[@class='brs_col']/p");
					}
					
					foreach ($entries as $entry)
					{
						$result[]=$entry->nodeValue;
					}
				}
			}
			else
			{
				$this->queueKeyword();
			}
		}
		
		return $result;
	}
	
	public function getGoogleSuggest($keyword,$options)
	{
		$result=false;
		
		$http=getOS()->getHttp();
		$ops=OS_APP_RelatedKws_ReportOperations::get_instance();
		
		if (!empty($options['language']))
		{
			if (!isset($ops->googleSuggestLanguages[$options['language']]))
			{
				return false;
			}
			else
			{
				$options['tld']=$ops->googleSuggestLanguages[$options['language']]['tld'];
				$options['hl']=$ops->googleSuggestLanguages[$options['language']]['hl'];
			}
		}
		
		$sources=array();
		
		if (empty($options['sources']))
		{
			$options['sources']=array('web');
		}
		
		foreach ($options['sources'] as $source)
		{
			if (isset($ops->googleSuggestSources[$source]))
			{
				$sources[$source]=$ops->googleSuggestSources[$source]['ds'];
			}
		}
		
		if (empty($dss))
		{
			$sources['web']=false;
		}
		
		if (empty($options['domain']))
		{
			if (empty($options['tld']))
			{
				$options['domain']='google.com';
			}
			else
			{
				$options['domain']='google.'.$options['tld'];
			}
		}
		
		$url="http://{$options['domain']}/complete/search?output=chrome&q=".urlencode($keyword).(!empty($options['hl'])?"&hl={$options['hl']}":'');

		foreach ($sources as $source=>$ds)
		{
			$actual_url=$url.($ds?"&ds={$ds}":'');
			
			$response=$http->get($actual_url);
			
			if ($response AND $http->success())
			{
				$result[$source]=array();
				
				if ($response=json_decode($response,true))
				{
					if (!empty($response[1]))
					{
						foreach ($response[1] as $position=>$keyword)
						{
							if (!empty($response[4]['google:suggesttype'][$position]) AND $response[4]['google:suggesttype'][$position]=='QUERY')
							{
								$result[$source][]=$keyword;
							}
						}
					}
				}
			}
		}
		
		return $result;
	}
	
	public function getAll($keyword,$options)
	{
		$result=false;
		
		if (!empty($options['google']))
		{
			$result['google']=$this->getGoogleRelatedSearches($keyword,$options['google']);
		}
		
		if (!empty($options['bing']))
		{
			$result['bing']=$this->getBingRelatedSearches($keyword,$options['bing']);
		}
		
		if (!empty($options['google_suggest']))
		{
			$result['google_suggest']=$this->getGoogleSuggest($keyword,$options['google_suggest']);
		}
		
		return $result;
	}
}
?>