<?php
class OS_APPVIEW_RelatedKws_Main extends OS_AppViewBase
{
	private $reportsPerPage=10;
	
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_RelatedKws_ReportOperations::get_instance();
		
		$requestParams=$appPlugin->getRequestParams();
		$processedRequest=array();
		
		$processedRequest['reportsCount']=$ops->getReportsCount();
		$processedRequest['page']=1;
		
		if (!empty($requestParams['page']) AND ($requestParams['page']>0) AND (($requestParams['page']-1)*$this->reportsPerPage<$processedRequest['reportsCount']))
		{
			$processedRequest['page']=$requestParams['page'];
		}
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='delete')
			{
				if (!empty($requestParams['report_id']))
				{
					if ($report=$ops->getReportByID($requestParams['report_id']))
					{
						if ($report->delete())
						{
							$requestParams['msg']='delete_ok';
						}
						else
						{
							$requestParams['msg']='delete_err';
						}
					}
				}
			}
		}
		
		if (!empty($requestParams['msg']))
		{
			if ($requestParams['msg']=='delete_ok')
			{
				$OS->addInfo(_("Report deleted successfully"));
			}
			elseif ($requestParams['msg']=='delete_err')
			{
				$OS->addBoxError(_("Unable to delete report"));
			}
		}
		
		return $processedRequest;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_RelatedKws_ReportOperations::get_instance();
		
		$viewDataVars=array();

		if ($this->processedRequest['reportsCount'])
		{
			$viewDataVars['reportsCount']=$this->processedRequest['reportsCount'];
			
			$viewDataVars['reports']=$ops->getReports($project->id,($this->processedRequest['page']-1)*$this->reportsPerPage,$this->reportsPerPage);
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array();
		
		if (!empty($viewData['reports']))
		{
			foreach ($viewData['reports'] as $report_id=>$report)
			{
				$tplVars['reports'][$report_id]=$report->toTemplate();
			}
			
			if ($this->processedRequest['page']>1)
			{
				$tplVars['prev_page_url']=$appPlugin->getAppActionUrl('main',array('page'=>$this->processedRequest['page']-1));
			}
			else
			{
				$tplVars['prev_page_url']=false;
			}
			
			if (($this->processedRequest['page']*$this->reportsPerPage)<$viewData['reportsCount'])
			{
				$tplVars['next_page_url']=$appPlugin->getAppActionUrl('main',array('page'=>$this->processedRequest['page']+1));
			}
			else
			{
				$tplVars['next_page_url']=false;
			}
		}

		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('view',$tplVars);
	}
}
?>