<?php
class OS_APP_Reporting extends OS_AppBase
{
	private static $_instance;
	
	public function __construct()
	{
		parent::__construct();
		
		$user=getOS()->getUser();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
		$this->addMenuItem('new', array("name" => _("Generate report"), 'routerOption'=> "handleNewView"));
		
		if ($user->checkPerm('reporting','manage_templates'))
		{
			$this->addMenuItem('templates', array("name" => "Templates", 'routerOption'=> "handleTemplatesView"));
			$this->setRouterOption("templates_ae", "handleTemplatesAEView");
		}

		$this->setRouterOption("generate", "handleGenerateView");
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_Reporting();
		}
		
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('reporting','view');
		
		$viewData=new OS_APPVIEW_Reporting_Main();
		
		return $viewData->render();
	}
	
	public function handleNewView()
	{
		getOS()->getUser()->forcePerm('reporting','view');
		
		$viewData=new OS_APPVIEW_Reporting_New();
		
		return $viewData->render();
	}
	
	public function handleGenerateView()
	{
		getOS()->getUser()->forcePerm('reporting','view');
		
		$viewData=new OS_APPVIEW_Reporting_Generate();
		
		return $viewData->render();
	}
	
	public function handleTemplatesView()
	{
		getOS()->getUser()->forcePerm('reporting','manage_templates');
		
		$viewData=new OS_APPVIEW_Reporting_Templates();
		
		return $viewData->render();
	}
	
	public function handleTemplatesAEView()
	{
		getOS()->getUser()->forcePerm('reporting','manage_templates');
		
		$viewData=new OS_APPVIEW_Reporting_Templates_AE();
		
		return $viewData->render();
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'reporting'=>array(
				'view'=>array('name'=>_("Generate project reports")),
				'manage_templates'=>array('name'=>_("Manage report templates"))
			)
		);
	}
	
	public function interactionWorkerGetDefaultTemplate($params)
	{
		
	}
}
?>