<?php
class OS_APP_Reporting_ReportOperations
{
	private static $_instance;
	
	public $dataOrder=array('websiteaudit','duplpages','onpage');
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_Reporting_ReportOperations();
		}
		
		return self::$_instance;
	}
	
	public function getAvailableReportData($reportType='overview')
	{
		$result=false;
		
		$OS=getOS();
		
		$osUser = $OS->getUser();
		$osProject = $OS->getProject();
		$osAppOps = $OS->getAppOps();
		
		$osUserAvailableApps=$osUser->getAvailableApps($osProject->id);
		$osUserApps = $osUser->getApps($osProject->id);
		$osAvailableApplications = $osAppOps->getAvailableApps();
		
		$appReports=array();
		
		foreach($osAvailableApplications as $app_id=>$oneApp)
		{
			if(in_array($oneApp->name,$osUserAvailableApps) AND isset($osUserApps[$app_id]))
			{
				$oneAppPlugin=$OS->getAppHandler($oneApp->name)->getAppPlugin();
				
				if ($appReportData=$oneAppPlugin->getReportingData($reportType))
				{
					$appReports[$oneApp->name]=array(
						'title'=>$osUserApps[$app_id]['app_title'],
						'report'=>$appReportData
					);
				}
			}
		}
		
		if ($appReports)
		{
			foreach ($this->dataOrder as $app)
			{
				if (isset($appReports[$app]))
				{
					$result[$app]=$appReports[$app];
					unset($appReports[$app]);
				}
			}
			
			foreach ($appReports as $app=>$appData)
			{
				$result[$app]=$appData;
			}
		}
		
		$OS->getAppHandler('reporting');
		
		return $result;
	}
	
	public function generateReport($structure)
	{
		$availableData=$this->getAvailableReportData();
		
		$reportData=array();
		
		foreach ($availableData as $app=>$details)
		{
			if (isset($structure[$app]))
			{
				foreach ($details['report']['sections'] as $section=>$sectionData)
				{
					if (isset($structure[$app][$section]))
					{
						if (!isset($reportData['main_sections'][$app]))
						{
							$reportData['main_sections'][$app]=array(
								'title'=>$details['title'],
								'sections'=>array()
							);
						}
						
						$reportData['main_sections'][$app]['sections'][$section]=$sectionData;
					}
				}
			}
		}
		
		if (!empty($reportData))
		{
			$reportData['filename']='seo_report.pdf';
			
			$osReport=getOS()->getReport();
			
			$osReport->generateReport($reportData);
		}
		else
		{
			return false;
		}
	}
}
?>