<?php
class OS_APP_Reporting_Template
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $name;
	public $default;
	public $insert_dt;
	public $insert_ip;
	public $update_dt;
	public $update_ip;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_Reporting_Template();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->name='';
		$this->insert_dt='';
		$this->insert_ip='';
		$this->update_dt='';
		$this->update_ip='';
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_Reporting_TemplateOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertTemplate($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateTemplate($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_Reporting_TemplateOperations::get_instance();
			
			if ($data=$ops->getTemplateByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_Reporting_TemplateOperations::get_instance();
			
			$result=$ops->deleteTemplateByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$result=array(
			'id'=>$this->id,
			'name'=>$this->name,
			'default'=>($this->default=='Y'?true:false),
			'make_default_url'=>($this->default=='Y'?false:$app->getAppActionUrl('templates',array('op'=>'make_default','template_id'=>$this->id))),
			'edit_url'=>$app->getAppActionUrl('templates_ae',array('op'=>'edit','template_id'=>$this->id)),
			'delete_url'=>$app->getAppActionUrl('templates',array('op'=>'delete','template_id'=>$this->id)),
		);
		
		return $result;
	}
}
?>