<?php
class OS_APPVIEW_Reporting_Templates extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (!empty($requestParams['op']))
		{
			$ops=OS_APP_Reporting_TemplateOperations::get_instance();
			
			if ($requestParams['op']=='delete')
			{
				if (!empty($requestParams['template_id']) AND $template=$ops->getTemplateByID($requestParams['template_id']))
				{
					if ($template->delete())
					{
						$OS->addInfo(_("Template deleted successfully"));
					}
					else
					{
						$OS->addBoxError(_("Unable to delete template"));
					}
				} 
			}
		}
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_Reporting_TemplateOperations::get_instance();
		
		$viewDataVars=array();

		$viewDataVars['templates']=$ops->getTemplates($project->id);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars['templates']=array();
		
		if ($viewData['templates'])
		{
			foreach ($viewData['templates'] as $template_id=>$template)
			{
				$tplVars['templates'][$template_id]=$template->toTemplate();
			}
		}
		
		$tplVars['addTemplateURL']=$appPlugin->getAppActionUrl('templates_ae',array('op'=>'add'));
		
		$tpl=$OS->getTemplate();
				
		return $tpl->fetchTemplate('templates',$tplVars);
	}
}
?>