<?php
class OS_APPVIEW_Reporting_Templates_AE extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$ops=OS_APP_Reporting_TemplateOperations::get_instance();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['op']))
		{
			$requestParams['op']='add';
		}
		elseif ($requestParams['op']=='edit')
		{
			$valid=false;
			
			if (!empty($requestParams['template_id']))
			{
				if ($template=$ops->getTemplateByID($requestParams['template_id'],$project->id))
				{
					$valid=true;
				}
			}
			
			if (!$valid)
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('templates'),true);
			}
		}
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			if (empty($requestParams['name_box']))
			{
				$OS->addFieldError(_("Name missing"),'name');
			}
			else
			{
				$requestParams['name_box']=trim($requestParams['name_box']);
				if (strlen($requestParams['name_box'])<3)
				{
					$OS->addFieldError(_("Name too short. Minimum length: 3 chars"),'name');
				}
			}
			
			$files=array('header','cover','footer');
			$actual_files=array();
			$files_found=false;
			
			foreach ($files as $file)
			{
				if (!empty($_FILES["{$file}_box"]['tmp_name']))
				{
					$files_found=true;
					
					if (!is_uploaded_file($_FILES["{$file}_box"]['tmp_name']))
					{
						$OS->addFieldError(_("Image upload failed"),$file);
					}
					elseif(($_FILES["{$file}_box"]["size"]>1024000) OR ($_FILES["{$file}_box"]['error']==UPLOAD_ERR_FORM_SIZE))
					{
						$OS->addFieldError(_("Image file too big. Maximum size: 1MB"),$file);
					}
					elseif($_FILES["{$file}_box"]['error']==UPLOAD_ERR_PARTIAL)
					{
						$OS->addFieldError(_("Image upload failed"),$file);
					}
					elseif($_FILES["{$file}_box"]['error']==UPLOAD_ERR_CANT_WRITE)
					{
						$OS->addFieldError(_("Image upload failed"),$file);
					}
			        else
		          	{
			             list($photo_width, $photo_height, $photo_type, $photo_attr)=getimagesize($_FILES["{$file}_box"]['tmp_name']);
			             if($photo_type!=2)
			             {
			             	$OS->addFieldError(_("Invalid image type. Only JPEG images allowed"),$file);
			             }
			             else
			             {
			             	$actual_files[$file]=$_FILES["{$file}_box"]['tmp_name'];
			             }
		          	}
				}
			}
			
			if ($requestParams['op'] AND !$files_found)
			{
				$OS->addFieldError(_("You need to upload at least on image to the template"),'header');
			}
			
			if (!isset($OS->errorMessages))
			{
				if ($requestParams['op']=='add')
				{
					$template=OS_APP_Reporting_Template::get_instance();
					
					$template->project_id=$project->id;
				}
				
				$template->name=$requestParams['name_box'];
				if (!empty($requestParams['default_box']))
				{
					$template->default='Y';
				}
				
				if ($template->save())
				{
					if (!empty($requestParams['default_box']))
					{
						$ops->setTemplateAsDefault($template);
					}
					
					$osUtils=$OS->getUtils();
					
					$template_path=$ops->getTemplateStoragePath($template);
					
					if ($requestParams['op']=='add')
					{
						$osUtils->createDir($template_path);
					}
					
					foreach ($actual_files as $type=>$path)
					{
						$new_path=os_join_path($template_path,"{$type}.jpg");
						copy($path,$new_path);
					}
				}
				
				$OS->redirectTO($appPlugin->getAppActionUrl('templates',array('msg'=>"{$requestParams['op']}_ok")),true);
			}
		}
		
		return $requestParams;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$tplVars['appURL']=$appPlugin->getAppUrl();
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('templates_ae',$tplVars);
	}
}
?>