<?php
class OS_APP_SampleApp extends OS_AppBase
{
	private static $_instance;
	
	public function __construct()
	{
		$this->addMenuItem('view', array("name" => "Main", 'routerOption'=> "handleMainView"));
		$this->addMenuItem('sample_view', array("name" => "Sample", 'routerOption'=> "handleSampleView")); 
		
		$this->setRouterOption("sample_view_with_no_menu", "handleSample2View");
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_SampleApp();
		}
		
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('sampleapp','view');
		
		$viewData=new OS_APPVIEW_SampleApp_Main();
		
		return $viewData->render();
	}
	
	public function handleSampleView()
	{
		getOS()->getUser()->forcePerm('sampleapp','view');
		
		$viewData=new OS_APPVIEW_SampleApp_Sample();
		
		return $viewData->render();
	}
	
	public function handleSample2View()
	{
		getOS()->getUser()->forcePerm('sampleapp','view');
		
		$viewData=new OS_APPVIEW_SampleApp_Sample2();
		
		return $viewData->render();
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'sampleapp'=>array(
				'view'=>array('name'=>"View and perform sample actions")
			)
		);
	}
	
	public function eventSample($params)
	{
		//Handle event
	}
	
	public function interactionSample($params)
	{
		//Handle interaction
	}
}
?>