<?php
class OS_APPVIEW_SelfCrawl_Details extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$result=false;
		
		$OS=getOS();
		
		$project=$OS->getProject();
		$osAppPlugin=$OS->getAppHandler()->getAppPlugin();		
		
		$requestParams = $osAppPlugin->getRequestParams();
		
		$crawlOps=$OS->getProjectCrawlOps();
		
		if ($crawl=$crawlOps->getProjectCrawlByID($project->id,$requestParams['crawl_id']))
		{
			$allowedHttpCodeGroups=array(3,4,5);
			
			if (in_array($requestParams['http_code_group'],$allowedHttpCodeGroups))
			{
				if ($url_errors=$crawl->getUrlErrors($requestParams['http_code_group']))
				{
					$result=array(
						'crawl'=>$crawl,
						'url_errors'=>$url_errors
					);
				}
			}
		}
		
		return $result;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$osAppPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams = $osAppPlugin->getRequestParams();
		
		if (empty($requestParams['crawl_id']) OR empty($requestParams['http_code_group']))
		{
			$OS->redirectTO($osAppPlugin->getAppActionUrl('view'),true);
		}
		
		if (!$viewData=$this->buildViewData($requestParams['crawl_id'],$requestParams['http_code_group']))
		{
			$OS->redirectTO($osAppPlugin->getAppActionUrl('view'),true);
		}
		
		$utils=$OS->getUtils();
		
		$url_errors_tpl=array();
		foreach ($viewData['url_errors'] as $url_error)
		{
			$url_error['http_code_status']=$osAppPlugin->getHttpCodeStatus($url_error['http_code']);
			$url_error['url_safe']=$utils->getSafeURL($url_error['url']);
			$url_error['_links_url']=$osAppPlugin->getAppActionUrl('links',array('crawl_id'=>$viewData['crawl']->id,'http_code_group'=>$requestParams['http_code_group'],'url_hash'=>md5($url_error['url'])));
			
			$url_errors_tpl[$url_error['id']]=$url_error;
		}
		
		$osUtils=$OS->getUtils();
		
		$headContents['css']['selfcrawl']=$osAppPlugin->getAppHomeUrl()."/resources/style.css";
		
		$groupColors=array(3=>'blue',4=>'orange',5=>'red');
		
		$tplVars=array('backUrl'=>$osAppPlugin->getAppActionUrl('view'),'url_errors'=>$url_errors_tpl,'urlErrorGroup'=>$requestParams['http_code_group'].'xx','groupColor'=>$groupColors[$requestParams['http_code_group']],'crawlDate'=>$osUtils->humanizeDate($viewData['crawl']->start_dt,'date'));
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('view_details', $tplVars);
	}
}
?>