<?php
class OS_APPVIEW_SelfCrawl_Links extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		$processedRequest=array();
		
		if (empty($requestParams['crawl_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		else
		{
			$crawlOps=$OS->getProjectCrawlOps();
		
			if (!$crawl=$crawlOps->getProjectCrawlByID($project->id,$requestParams['crawl_id']))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
			}
		}
		
		if (empty($requestParams['url_hash']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		else
		{
			$db=$OS->getDb();
			$osUtils=$OS->getUtils();
			
			$processedRequest['links']=array();
			
			$dbresult=$db->query("SELECT from_url,SUM(occurances) AS total_occurances FROM ".$db->dbPrefix()."projects_urls_links WHERE project_id=? AND to_url_hash=? GROUP BY from_url ORDER BY total_occurances DESC",array($project->id,$requestParams['url_hash']));
			while ($row=$db->fetchRow($dbresult))
			{
				$processedRequest['links'][$row['from_url']]=array(
					'url_safe'=>$osUtils->getSafeURL($row['from_url']),
					'occurances'=>$row['total_occurances']
				);
			}
		}
		
		if (!empty($requestParams['http_code_group']))
		{
			$processedRequest['back_url_details']=array('back_view'=>'view_details','crawl_id'=>$requestParams['crawl_id'],'http_code_group'=>$requestParams['http_code_group']);
		}
		else
		{
			$processedRequest['back_url_details']=array('back_view'=>'view');
		}
		
		return $processedRequest;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest['links'];
		
		$appPlugin->setMenuBackLink($this->processedRequest['back_url_details']);
		
		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('links', $tplVars);
	}
}
?>