<?php
class OS_APPFORK_sitemapgen_generate_sitemap
{
	public function run($params)
	{
		$result=false;
		
		if (!empty($params[0]))
		{
			$project_id=$params[0];
			
			$OS=getOS();
			
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($project_id))
			{
				$appOps=$OS->getAppOps();
				$app=$appOps->getAppByName('sitemapgen');
				
				if ($appOps->isProjectApp($project_id,$app->id))
				{
					$appHandler=$OS->getAppHandler('sitemapgen');
					$appPlugin=$appHandler->getAppPlugin();
					$sitemap=$appPlugin->getSitemap();
					$sitemapOps=$appPlugin->getOperations();
					
					$OS->initTimezone($project->timezone);
					
					$sitemap->setInitialValues();
					
					$sitemap->project_id=$project_id;
					
					$db=$OS->getDb();
					
					$project_urls=array();
					$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."projects_urls WHERE project_id=? AND http_code=? AND file_type=? AND (canonical_url=? OR canonical_url=url) ORDER BY depth ASC",array($project_id,'200','html',''));
					while ($row=$db->fetchRow($dbresult))
					{
						$project_urls[$row['id']]=$row;
					}
					
					if ($project_urls)
					{
						$sitemap->_bulkUrls=$project_urls;
						$sitemap->urls=count($sitemap->_bulkUrls);
						$sitemap->generate_dt=$db->DBTimeStamp(time());
						
						if ($sitemap->save())
						{
							$sitemapOps->writeSitemapFile($sitemap);
							
							$result=true;
						}
					}
				}
			}
		}
		
		return $result;
	}
}
?>