<?php
class OS_APP_sitemapgen extends OS_AppBase
{
	private static $_instance;
	
	protected function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Main"), 'routerOption'=> "handleMainView"));
				
		$this->setRouterOption("filelist", "handleFileListView");
		$this->setRouterOption("download", "handleDownloadView");
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_sitemapgen();
		}
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		getOS()->getUser()->forcePerm('sitemapgen','view');
		
		$viewData=new OS_APPVIEW_SitemapGen_Main();
		
		return $viewData->render();
	}
	
	public function handleFileListView()
	{
		getOS()->getUser()->forcePerm('sitemapgen','download');
		
		$viewData=new OS_APPVIEW_SitemapGen_FileList();
		
		return $viewData->render();
	}
	
	public function handleDownloadView()
	{
		getOS()->getUser()->forcePerm('sitemapgen','download');
		
		$viewData=new OS_APPVIEW_SitemapGen_Download();
		
		return $viewData->render();
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'sitemapgen'=>array(
				'view'=>array('name'=>_("View generated sitemaps history")),
				'download'=>array('name'=>_("Download generated sitemap"))
			)
		);
	}
	
	public function eventProjectCrawlEnd($params)
	{
		$result=false;
		
		$result=OS_Fork::fork('app','sitemapgen','generate_sitemap',array('project_id'=>$params['project_id']));
		
		return $result;
	}
	
	public function eventProjectDeleted($params)
	{
		$ops=OS_APP_SitemapGen_SitemapOperations::get_instance();
		
		return $ops->deleteDataByProjectID($params['project_id']);
	}
	
	public function &getSitemap()
	{
		return OS_APP_sitemapgen_sitemap::get_instance();
	}
	
	public function &getOperations()
	{
		return OS_APP_sitemapgen_sitemapoperations::get_instance();
	}
}
?>