<?php
class OS_APP_sitemapgen_sitemap
{
	private static $_instance;
	
	public $_bulkUrls;
	
	public $id;
	public $project_id;
	public $urls;
	public $generate_dt;
	public $ping;
	public $ping_dt;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_APP_sitemapgen_sitemap();
		}
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->_bulkUrls=array();
		
		$this->id=false;
		$this->project_id=0;
		$this->urls=0;
		$this->generate_dt='';
		$this->ping='';
		$this->ping_dt='';
	}
	
	public function set($sitemap_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($sitemap_data[$key]))
			{
				$this->$key = $sitemap_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getOperations();
			
			if ($sitemap_data=$ops->getSitemapByID($this->id))
			{
				$this->set(get_object_vars($sitemap_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$ops=getOS()->getAppHandler()->getAppPlugin()->getOperations();
		if (!$this->id)
			{
			if (!$this->id=$ops->insertSitemap($this)) return false;
			return true;
			}
		else return $ops->updateSitemap($this);
	}
	
	public function delete()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppHandler()->getAppPlugin()->getOperations();
			
			$result=$ops->deleteSitemapByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$sitemap_arr=array(
			'id'=>$this->id,
			'urls'=>$this->urls,
			'generate_dt'=>$utils->humanizeDate($this->generate_dt),
			'ping_human'=>$utils->humanizeYesNo($this->ping),
			'ping_dt'=>($this->ping_dt=='0000-00-00 00:00:00'?'-':$utils->humanizeDate($this->ping_dt)),
			'delete_url'=>$app->getAppActionUrl('view',array('op'=>'delete','sitemap_id'=>$this->id))
		);
		
		$user=getOS()->getUser();
		
		if ($user->checkPerm('sitemapgen','download'))
		{
			if ($this->urls>10000)
			{
				$sitemap_arr['filelist_url']=$app->getAppActionUrl('filelist',array('sitemap_id'=>$this->id));
				$sitemap_arr['download_xml_url']=false;
			}
			else
			{
				$sitemap_arr['filelist_url']=false;
				$sitemap_arr['download_xml_url']=$app->getAppActionUrl('download',array('type'=>'xml','sitemap_id'=>$this->id));
			}
			
			$sitemap_arr['download_txt_url']=$app->getAppActionUrl('download',array('type'=>'txt','sitemap_id'=>$this->id));
		}
		else
		{
			$sitemap_arr['filelist_url']=false;
			$sitemap_arr['download_xml_url']=false;
			$sitemap_arr['download_txt_url']=false;
		}
		
		return $sitemap_arr;
	}
}
?>