<?php
class OS_APPVIEW_SitemapGen_Download extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		$downloadTypes=array('txt','xml');
		
		if (empty($requestParams['type']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if (!in_array($requestParams['type'],$downloadTypes))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if (empty($requestParams['sitemap_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$ops=OS_APP_SitemapGen_SitemapOperations::get_instance();
		
		if (!$sitemap=$ops->getSitemapByID($requestParams['sitemap_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if ($sitemap->urls>10000 AND $requestParams['type']=='xml')
		{
			if (empty($requestParams['sitemap_file']))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('filelist',array('sitemap_id'=>$requestParams['sitemap_id'])),true);
			}
			
			if ($requestParams['sitemap_file']!='index' AND $requestParams['sitemap_file']<ceil($sitemap->urls/10000))
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('filelist',array('sitemap_id'=>$requestParams['sitemap_id'])),true);
			}
			
			$multifile=true;
		}
		else
		{
			$multifile=false;
		}
		
		$requestData=array('sitemap'=>$sitemap,'sitemap_type'=>$requestParams['type'],'multifile'=>$multifile);
		
		if ($multifile)
		{
			$requestData['sitemap_file']=$requestParams['sitemap_file'];
		}
		
		return $requestData;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$ops=OS_APP_SitemapGen_SitemapOperations::get_instance();
		
		if ($this->processedRequest['multifile'])
		{
			$filename='sitemap'.($this->processedRequest['sitemap_file']=='index'?'':'_'.$this->processedRequest['sitemap_file']).'.xml';
			$sitemap_path=os_join_path($ops->getSitemapPath($this->processedRequest['sitemap']),$filename);
		}
		else
		{
			$filename='sitemap.'.($this->processedRequest['sitemap_type']=='xml'?'xml':'txt');
			$sitemap_path=os_join_path($ops->getSitemapPath($this->processedRequest['sitemap']),$filename);
		}
		
		if (!file_exists($sitemap_path))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		header('Content-Type: '.($this->processedRequest['sitemap_type']=='xml'?'text/xml':'text/plain'));
		header('Content-Disposition: attachment; filename="'.$filename.'"');
		
		readfile($sitemap_path);
		
		exit;
	}
}
?>