<?php
class OS_APPVIEW_SitemapGen_FileList extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		$viewDataVars=array();
		
		$ops=OS_APP_SitemapGen_SitemapOperations::get_instance();
		
		$viewDataVars['sitemap']=$ops->getSitemapByID($requestParams['sitemap_id']);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (empty($requestParams['sitemap_id']))
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		$viewData=$this->buildViewData();
		
		if (!$viewData['sitemap'])
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('view'),true);
		}
		
		if ($viewData['sitemap']->urls<=10000)
		{
			$OS->redirectTO($appPlugin->getAppActionUrl('download',array('sitemap_id'=>$viewData['sitemap']->id)),true);
		}
		
		$tplVars=array(
			'sitemap_files'=>ceil($viewData['sitemap']->urls/10000),
			'total_urls'=>$viewData['sitemap']->urls,
			'file_download_xml_base_url'=>$this->getAppActionUrl('download',array('type'=>'xml','sitemap_id'=>$viewData['sitemap']->id)),
			'file_download_txt_base_url'=>$this->getAppActionUrl('download',array('type'=>'txt','sitemap_id'=>$viewData['sitemap']->id))
		);
		
		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('download_list', $tplVars);
	}
}
?>