<?php
class OS_APPVIEW_SitemapGen_Main extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$result=false;
		
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='delete')
			{
				if (isset($requestParams['sitemap_id']))
				{
					$ops=OS_APP_SitemapGen_SitemapOperations::get_instance();
					
					if ($sitemap=$ops->getSitemapByID($requestParams['sitemap_id']))
					{
						if ($sitemap->delete())
						{
							$OS->addInfo(_("Sitemap deleted successfully"));
							
							$result=true;
						}
					}
				}
			}
		}
		
		return $result;
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$user=$OS->getUser();
		
		$ops=OS_APP_SitemapGen_SitemapOperations::get_instance();
		
		$viewDataVars['sitemaps']=$ops->getSitemaps();
		$viewDataVars['canDownload']=$user->checkPerm('sitemapgen','download');
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		
		$viewData=$this->buildViewData();
		$tplVars=array();$headContents=array();
		
		$sitemaps_processed=array();$sitemaps_urls=array();
		foreach ($viewData['sitemaps'] as $sitemap)
		{
			$sitemaps_processed[$sitemap->id]=$sitemap->toTemplate();
			$sitemaps_urls[strtotime($sitemap->generate_dt)]=$sitemap->urls;
		}
		$sitemaps_urls=array_reverse(array_slice($sitemaps_urls,0,10,true),true);
		
		$chartValues=array();$chartTooltips=array();$chartLabels=array();
		foreach ($sitemaps_urls as $ts=>$value)
		{
			$chartLabels[]=date('d M',$ts);
			$chartValues[]=$value;
			$chartTooltips[]="{$value} "._("URLs");
		}
		
		$tplVars=array('sitemaps'=>$sitemaps_processed,'hasActions'=>$viewData['canDownload']);
		
		if (!empty($sitemaps_urls))
		{
			$charts = $OS->getCharts();
			
			$chartOptions=array(
				'values'=>$chartValues,
				'labels'=>$chartLabels,
				'tooltips'=>$chartTooltips,
				'fill'=>true,
				'normalize'=>true
			);
			
			$chartData=$charts->getLineChart($chartOptions);
			
			$tplVars['chart']=$chartData['html'];
			$headContents=$chartData['js'];
		}
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('view', $tplVars);
	}
}
?>