<?php
class OS_APPCRON_SocialSignals_Fetcher
{
	public $urlsPerRun=20;
	
	public function run()
	{
		$OS=getOS();
		$db=$OS->getDb();
		
		$projectOps=$OS->getProjectOps();
		
		$appOps=$OS->getAppOps();
		$app=$appOps->getAppByName('socialsignals');
		
		if ($projects=$appOps->getProjectsByAppID($app->id))
		{
			$appHandler=$OS->getAppHandler('socialsignals');
			$appPlugin=$appHandler->getAppPlugin();
			$ops=OS_APP_SocialSignals_UrlOperations::get_instance();
			
			$checkedUrls=0;
			$affectedProjects=array();
			
			foreach ($projects as $project_id)
			{
				if ($project=$projectOps->getProjectByID($project_id) AND $project->isActive())
				{
					$OS->initTimezone($project->timezone);
					
					if ($checkUrls=$ops->getUrlsPendingRefresh($project->id,$this->urlsPerRun-$checkedUrls))
					{
						foreach ($checkUrls as $url_id=>$url)
						{
							if ($signals=$ops->getUrlSocialSignals($url->url))
							{
								$url->signals=$signals;
								
								$signals_total=0;
								
								foreach ($signals as $network=>$value)
								{
									if ($network!='facebook')
									{
										$signals_prop='signals_'.$network;
										$url->$signals_prop=$value;
										$signals_total+=$value;
									}
									else
									{
										foreach ($value as $network_action=>$actual_value)
										{
											$signals_prop='signals_facebook_'.$network_action;
											$url->$signals_prop=$actual_value;
										}
										
										$signals_total+=$value['total'];
									}
								}
								
								$url->signals_total=$signals_total;
								
								$ts=time();
								$url->signals_dt=date('Y-m-d H:i:s',$ts);
								$url->timeout=$ops->getRefreshTimeout($url);
								$url->refresh_dt=date('Y-m-d H:i:s',$ts+$url->timeout);
								
								if ($url->save())
								{
									$affectedProjects[$url->project_id]=true;
								}
							}
						}
						
						$checkedUrls+=count($checkUrls);
					}
				}
				
				if ($checkedUrls>=$this->urlsPerRun)
				{
					break;
				}
			}
			
			if ($affectedProjects)
			{
				foreach ($affectedProjects as $project_id=>$dummy)
				{
					OS_Fork::fork('app','socialsignals','generate_report',array('project_id'=>$project_id));
				}
			}
			
			unset($appHandler,$appPlugin);
		}
		
		return true;
	}
}
?>