<?php
class OS_APPFORK_SocialSignals_Generate_Report
{
	public function run($params)
	{
		$result=false;

		if (!empty($params[0]))
		{
			$project_id=$params[0];
			
			$OS=getOS();
			
			$projectOps=$OS->getProjectOps();
			
			if ($project=$projectOps->getProjectByID($project_id))
			{
				$appOps=$OS->getAppOps();
				$availableApp=$appOps->getAppByName('socialsignals');
				
				if ($appOps->isProjectApp($project_id,$availableApp->id))
				{
					$appHandler=$OS->getAppHandler('socialsignals');
					$app=$appHandler->getAppPlugin();
					
					$reportOps=OS_APP_SocialSignals_ReportOperations::get_instance();
					
					if (!$report=$reportOps->getReportByProjectID($project_id))
					{
						$report=new OS_APP_SocialSignals_Report();
						
						$report->project_id=$project_id;
					}
					
					$report->signals=array(
						'stumbleupon'=>0,
						'reddit'=>0,
						'facebook'=>array(
							'comments'=>0,
							'likes'=>0,
							'shares'=>0,
							'total'=>0,
						),
						'delicious'=>0,
						'gplus'=>0,
						'twitter'=>0,
						'diggs'=>0,
						'pinterest'=>0,
						'linkedin'=>0
					);
					
					$urlOps=OS_APP_SocialSignals_UrlOperations::get_instance();
					
					if ($urls=$urlOps->getUrls($project_id))
					{
						foreach ($urls as $url_id=>$url)
						{
							foreach ($report->signals as $network=>$value)
							{
								if ($network!='facebook')
								{
									$report->signals[$network]+=$url->signals[$network];
								}
								else
								{
									foreach ($value as $action=>$dummy)
									{
										$report->signals[$network][$action]+=$url->signals[$network][$action];
									}
								}
							}
						}
					}
					
					$result=$report->save();
				}
			}
		}
		
		return $result;
	}
}
?>