<?php
class OS_APP_SocialSignals_Report
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $signals;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_SocialSignals_Report();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->signals=array();
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_SocialSignals_ReportOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertReport($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateReport($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_SocialSignals_ReportOperations::get_instance();
			
			if ($data=$ops->getReportByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_SocialSignals_ReportOperations::get_instance();
			
			$result=$ops->deleteReportByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$result=array(
			'id'=>$this->id,
			'signals'=>$this->signals
		);
		
		return $result;
	}
}
?>