<?php
class OS_APP_SocialSignals_Url
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $url;
	public $title;
	public $url_hash;
	public $signals;
	public $signals_stumbleupon;
	public $signals_reddit;
	public $signals_facebook_comments;
	public $signals_facebook_likes;
	public $signals_facebook_shares;
	public $signals_facebook_total;
	public $signals_delicious;
	public $signals_gplus;
	public $signals_twitter;
	public $signals_diggs;
	public $signals_pinterest;
	public $signals_linkedin;
	public $signals_total;
	public $signals_dt;
	public $timeout;
	public $refresh_dt;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_SocialSignals_Url();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->url='';
		$this->title='';
		$this->url_hash='';
		$this->signals=array();
		
		$this->signals_stumbleupon=0;
		$this->signals_reddit=0;
		$this->signals_facebook_comments=0;
		$this->signals_facebook_likes=0;
		$this->signals_facebook_shares=0;
		$this->signals_facebook_total=0;
		$this->signals_delicious=0;
		$this->signals_gplus=0;
		$this->signals_twitter=0;
		$this->signals_diggs=0;
		$this->signals_pinterest=0;
		$this->signals_linkedin=0;
		$this->signals_total=0;
		
		$this->signals_dt=0;
		$this->timeout=0;
		$this->refresh_dt=0;
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_SocialSignals_UrlOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertUrl($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateUrl($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_SocialSignals_UrlOperations::get_instance();
			
			if ($data=$ops->getUrlByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_SocialSignals_UrlOperations::get_instance();
			
			$result=$ops->deleteUrlByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$statuses=array('W'=>_('Processing...'),'F'=>_('Failed'),'D'=>_('Done'));
		
		$path=parse_url($this->url,PHP_URL_PATH);
		if (empty($path))
		{
			$path='/';
		}
		
		$result=array(
			'id'=>$this->id,
			'url'=>$this->url,
			'path'=>$path,
			'title'=>$this->title,
			'url_hash'=>$this->url_hash,
			'signals'=>$this->signals,
			'signals_stumbleupon'=>$this->signals_stumbleupon,
			'signals_reddit'=>$this->signals_reddit,
			'signals_facebook_comments'=>$this->signals_facebook_comments,
			'signals_facebook_likes'=>$this->signals_facebook_likes,
			'signals_facebook_shares'=>$this->signals_facebook_shares,
			'signals_facebook_total'=>$this->signals_facebook_total,
			'signals_delicious'=>$this->signals_delicious,
			'signals_gplus'=>$this->signals_gplus,
			'signals_twitter'=>$this->signals_twitter,
			'signals_diggs'=>$this->signals_diggs,
			'signals_pinterest'=>$this->signals_pinterest,
			'signals_linkedin'=>$this->signals_linkedin,
			'signals_total'=>$this->signals_total,
			'_details_url'=>$app->getAppActionUrl('url',array('url_id'=>$this->id))
		);
		
		return $result;
	}
}
?>