<?php
class OS_APP_TimeTrack extends OS_AppBase
{
	private static $_instance;

	public function __construct()
	{
		parent::__construct();
		
		$this->addMenuItem('view', array("name" => _("Overview"), 'routerOption'=> "handleMainView"));
		$this->addMenuItem('addedit', array("name" => _("Add action"), 'routerOption'=> "handleAddEditView"));
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_TimeTrack();
		}
		
		return self::$_instance;
	}
	
	public function handleMainView()
	{
		$viewData=new OS_APPVIEW_TimeTrack_Main();
		
		return $viewData->render();
	}
	
	public function handleAddEditView()
	{
		$viewData=new OS_APPVIEW_TimeTrack_AddEdit();
		
		return $viewData->render();
	}
	
	public function interactionWorkerGetProjectActions($params)
	{
		$result=false;
		
		if (!empty($params['project_id']))
		{
			if (empty($params['end_dt']))
			{
				$params['end_dt']=date('Y-m-d H:i:s');
			}
			
			if (empty($params['start_dt']))
			{
				$params['start_dt']=date('Y-m-d H:i:s',time()-7*86400);
			}
			
			$actionOps=OS_APP_TimeTrack_ActionOperations::get_instance();
			
			$result=$actionOps->getActionsInTimeframe($params['start_dt'],$params['end_dt'],$params['project_id']);
		}
		
		return $result;
	}
	
	protected function defineAppPermissions()
	{
		$this->appPermissions=array(
			'timetrack'=>array(
				'view'=>array('name'=>_("Access time tracking application")),
				'supervisor'=>array('name'=>_("Supervise time tracking activity"))
			)
		);
	}
	
	public function eventProjectDeleted($params)
	{
		$result=false;
		
		$actionOps=OS_APP_TimeTrack_ActionOperations::get_instance();
		if ($actionOps->deleteActionsByProjectID($params['project_id']))
		{
			$result=true;
		}
		
		return $result;
	}
}
?>