<?php
class OS_APP_TimeTrack_Action
{
	public static $_instance;
	
	public $id;
	public $project_id;
	public $user_id;
	public $user;
	public $action_d;
	public $duration;
	public $description;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_TimeTrack_Action();
		}
			
		return	self::$_instance;
	}
	
		public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->action_d='';
		$this->duration=0;
		$this->description='';
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_TimeTrack_ActionOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertAction($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateAction($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_TimeTrack_ActionOperations::get_instance();
			
			if ($data=$ops->getActionByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_TimeTrack_ActionOperations::get_instance();
			
			$result=$ops->deleteActionByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$duration=($this->duration==floor($this->duration)?floor($this->duration):($this->duration==round($this->duration,1)?round($this->duration,1):$this->duration));
		
		$result=array(
			'id'=>$this->id,
			'description'=>$this->description,
			'user'=>$this->user,
			'user_id'=>$this->user_id,
			'action_d'=>$this->action_d,
			'action_d_human'=>$utils->humanizeDate($this->action_d,'day'),
			'duration'=>$this->duration,
			'duration_human'=>$duration.' '.($duration==1?_("hour"):_("hours")),
			'_editURL'=>$app->getAppActionUrl('addedit',array('op'=>'edit','action_id'=>$this->id)),
			'_deleteURL'=>$app->getAppActionUrl('view',array('op'=>'delete','action_id'=>$this->id))
		);
		
		return $result;
	}
}
?>