<?php
class OS_APP_TimeTrack_ActionOperations
{
	public static $_instance;
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_TimeTrack_ActionOperations();
		}
			
		return	self::$_instance;
	}
	
	public function getActions($project_id=false,$user_id=false)
	{
		$result=false;
		
		$OS=getOS();
		
		if (!$project_id)
		{
			$osProject=$OS->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."actions WHERE project_id=? ".($user_id?" AND user_id=?":'')." ORDER BY `action_d` ASC",($user_id?array($project_id,$user_id):array($project_id)));
		while ($row=$db->fetchRow($dbresult))
		{
			$onePersona=new OS_APP_TimeTrack_Action();
			$onePersona->set($row);
			
			$result[$row['id']]=$onePersona;
		}
		
		return $result;
	}
	
	public function getActionsInTimeframe($start_dt,$end_dt=false,$project_id=false)
	{
		$result=false;
		
		$OS=getOS();
		
		if (!$project_id)
		{
			$osProject=$OS->getProject();
			
			if (empty($osProject->id))
			{
				return false;
			}
			
			$project_id=$osProject->id;
		}
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		if (!$end_dt)
		{
			$end_dt=$db->DBTimeStamp(time());
		}
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."actions WHERE project_id=? AND action_d>=? AND action_d<=? ORDER BY `action_d` ASC",array($project_id,$start_dt,$end_dt));
		while ($row=$db->fetchRow($dbresult))
		{
			$onePersona=new OS_APP_TimeTrack_Action();
			$onePersona->set($row);
			
			$result[$row['id']]=$onePersona;
		}
		
		return $result;
	}
	
	public function getActionByID($action_id)
	{
		$result=false;
		
		$OS=getOS();
		
		$db=$OS->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."actions WHERE id=?",array($action_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_APP_TimeTrack_Action();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function insertAction($action)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."actions (project_id,user_id,user,action_d,duration,description) VALUES (?,?,?,?,?,?)";
		$dbresult=$db->query($query,array($action->project_id,$action->user_id,$action->user,$action->action_d,$action->duration,$action->description));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateAction($action)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="UPDATE ".$appHandler->dbPrefix()."actions SET action_d=?,description=?,duration=? WHERE id=?";
		$dbresult=$db->query($query,array($action->action_d,$action->description,$action->duration,$action->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteActionByID($action_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."actions WHERE id=?";
		$dbresult=$db->query($query,array($action_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
		
	public function deleteActionsByProjectID($project_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."actions WHERE project_id=?";
		$dbresult=$db->query($query,array($project_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
}
?>