<?php
class OS_APPVIEW_TimeTrack_AddEdit extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$osProject=$OS->getProject();
		$osUser=$OS->getUser();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$requestParams=$appPlugin->getRequestParams();
		$actionOps=OS_APP_TimeTrack_ActionOperations::get_instance();
		
		if (!empty($requestParams['op']))
		{
			if ($requestParams['op']=='edit')
			{
				if (empty($requestParams['action_id']))
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('view'));
				}
				elseif (!$oneAction=$actionOps->getActionByID($requestParams['action_id']))
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('view'));
				}
			}
			elseif ($requestParams['op']!='add')
			{
				$OS->redirectTO($appPlugin->getAppActionUrl('view'));
			}
		}
		else
		{
			$requestParams['op']='add';
		}
		
		$year=date('Y');
		$days=range(1,31);
		$months=array(1=>_("January"),2=>_("February"),3=>_("March"),4=>_("April"),5=>_("May"),6=>_("June"),7=>_("July"),8=>_("August"),9=>_("September"),10=>_("Octomber"),11=>_("November"),12=>_("December"));
		$years=array($year-1,$year,$year+1);
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			if (empty($requestParams['description_box']))
			{
				$OS->addFieldError(_("Description missing"),'description');
			}
			else
			{
				$requestParams['description_box']=trim($requestParams['description_box']);
				
				if (strlen($requestParams['description_box'])<16)
				{
					$OS->addFieldError(_("Enter a more descriptive description. Minimum length: 16 chars"),'description');
				}
			}
			
			if (empty($requestParams['duration_box']))
			{
				$OS->addFieldError(_("Duration missing"),'duration');
			}
			elseif (!is_numeric($requestParams['duration_box']) OR $requestParams['duration_box']<=0)
			{
				$OS->addFieldError(_("Invalid duration"),'duration');
			}
			
			if (empty($requestParams['day_box']))
			{
				$OS->addFieldError(_("Day missing"),'date');
			}
			elseif (!in_array($requestParams['day_box'],$days))
			{
				$OS->addFieldError(_("Invalid day"),'date');
			}
			elseif (empty($requestParams['month_box']))
			{
				$OS->addFieldError(_("Month missing"),'date');
			}
			elseif (!isset($months[$requestParams['month_box']]))
			{
				$OS->addFieldError(_("Invalid month"),'date');
			}
			elseif (empty($requestParams['year_box']))
			{
				$OS->addFieldError(_("Year missing"),'date');
			}
			elseif (!in_array($requestParams['year_box'],$years))
			{
				$OS->addFieldError(_("Invalid year"),'date');
			}
			elseif (!checkdate($requestParams['month_box'],$requestParams['day_box'],$requestParams['year_box']))
			{
				$OS->addFieldError(_("Invalid date"),'date');
			}
			
			if (empty($OS->errorMessages))
			{
				$date=date('Y-m-d',mktime(0,0,0,$requestParams['month_box'],$requestParams['day_box'],$requestParams['year_box']));
				
				if ($requestParams['op']=='add')
				{
					$oneAction=new OS_APP_TimeTrack_Action();
					
					$oneAction->project_id=$osProject->id;
					$oneAction->user_id=$osUser->id;
					$oneAction->user=$osUser->user;
				}
				
				$oneAction->action_d=$date;
				$oneAction->duration=$requestParams['duration_box'];
				$oneAction->description=$requestParams['description_box'];
				
				if ($oneAction->save())
				{
					$OS->redirectTO($appPlugin->getAppActionUrl('view',array('msg'=>$requestParams['op'].'_ok')),true);
				}
				else
				{
					$OS->addBoxError(_("Unable to save action. Try again later!"));
				}
			}
		}
		elseif ($requestParams['op']=='edit')
		{
			$action_ts=strtotime($oneAction->action_d);
			
			$duration=($oneAction->duration==floor($oneAction->duration)?floor($oneAction->duration):($oneAction->duration==round($oneAction->duration,1)?round($oneAction->duration,1):$oneAction->duration));
			
			$requestParams['description_box']=$oneAction->description;
			$requestParams['duration_box']=$duration;
			$requestParams['day_box']=date('d',$action_ts);
			$requestParams['month_box']=date('m',$action_ts);
			$requestParams['year_box']=date('Y',$action_ts);
		}
		else
		{
			$requestParams['description_box']='';
			$requestParams['duration_box']='';
			$requestParams['day_box']=date('d');
			$requestParams['month_box']=date('m');
			$requestParams['year_box']=date('Y');
		}
		
		return array(
			'days'=>$days,
			'months'=>$months,
			'years'=>$years,
			'params'=>$requestParams
		);
	}
	
	public function render()
	{
		$OS=getOS();

		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$tplVars=$this->processedRequest;
		$tplVars['appURL']=$appPlugin->getAppUrl();
		
		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('addedit',$tplVars);
	}
}
?>