<?php
class OS_APPVIEW_TimeTrack_Main extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function processRequest()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		
		$requestParams=$appPlugin->getRequestParams();
		$osUser=$OS->getUser();
		
		$supervisor=$osUser->checkPerm('timetrack','supervisor');
		
		if (!empty($requestParams['op']))
		{
			$actionOps=OS_APP_TimeTrack_ActionOperations::get_instance();
			
			if ($requestParams['op']=='delete')
			{
				if (!empty($requestParams['action_id']))
				{
					if ($oneAction=$actionOps->getActionByID($requestParams['action_id']))
					{
						$can_delete=true;
						if (!$supervisor AND $oneAction->user_id!=$osUser->id)
						{
							$can_delete=false;
						}
						
						if ($can_delete)
						{
							if ($oneAction->delete())
							{
								$OS->addInfo(_("Action deleted successfully"));
							}
							else
							{
								$OS->addBoxError(_("Unable to delete action"));
							}
						}
					}
				}
			}
		}
		
		return array(
			'supervisor'=>$supervisor
		);
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$user=$OS->getUser();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$actionOps=OS_APP_TimeTrack_ActionOperations::get_instance();
		
		$viewDataVars=array(
			'actions'=>($this->processedRequest['supervisor']?$actionOps->getActions():$actionOps->getActions($project->id,$user->id))
		);
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();
		$tplVars=array(
			'supervisor'=>$this->processedRequest['supervisor'],
			'actions'=>array(),
			'worked_hours'=>0
		);
		
		foreach ($viewData['actions'] as $action_id=>$action)
		{
			$tplVars['actions'][$action_id]=$action->toTemplate();
			$tplVars['worked_hours']+=$action->duration;
		}
		
		$tpl=$OS->getTemplate();
		
		return $tpl->fetchTemplate('view',$tplVars);
	}
}
?>