<?php
class OS_APPCRON_WebsiteAudit_Regenerate_Audit
{
	public function run()
	{
		$OS=getOS();
		$db=$OS->getDb();
		
		$projectOps=$OS->getProjectOps();
		
		$appOps=$OS->getAppOps();
		$app=$appOps->getAppByName('websiteaudit');
		
		if ($projects=$appOps->getProjectsByAppID($app->id))
		{
			$appHandler=$OS->getAppHandler('websiteaudit');
			$appPlugin=$appHandler->getAppPlugin();
			$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
			
			foreach ($projects as $project_id)
			{
				if ($project=$projectOps->getProjectByID($project_id) AND $project->isActive())
				{
					$shouldRegenerate=false;
					
					if ($report=$ops->getLatestReports($project_id))
					{
						$report=reset($report);
						
						if (time()-strtotime($report->status_dt)>7*86400)
						{
							$shouldRegenerate=true;
						}
					}
					else
					{
						$shouldRegenerate=true;
					}
					
					if ($shouldRegenerate)
					{
						$OS->initTimezone($project->timezone);
						
						$report=new OS_APP_WebsiteAudit_Report();
						
						$report->project_id=$project_id;
						
						if ($report->save())
						{
							OS_Fork::fork('app','websiteaudit','generate_audit',array('project_id'=>$project_id,'report_id'=>$report->id));
						}
					}
				}
				
				unset($project);
			}
			
			unset($appHandler,$appPlugin);
		}
		
		return true;
	}
}
?>