<?php
class OS_APP_WebsiteAudit_Auditor
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_WebsiteAudit_Auditor();
		}
		
		return self::$_instance;
	}
	
	public function queueSearch($report_id,$queue_id,$queue_type)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$dbresult=$db->query("INSERT INTO ".$appHandler->dbPrefix()."queue (report_id,queue_id,queue_type) VALUES (?,?,?)",array($report_id,$queue_id,$queue_type));
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function eventSearchEngineQueried($params)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$project_ids=array();
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."queue WHERE queue_id=?",array($params['queue_id']));
		while ($row=$db->fetchRow($dbresult))
		{
			$report_ids[$row['report_id']][$row['queue_type']]=true;
		}
		
		$types=array('bing','google');
		
		if (!empty($report_ids))
		{
			$db->query("DELETE FROM ".$appHandler->dbPrefix()."queue WHERE queue_id=?",array($params['queue_id']));
			
			foreach ($report_ids as $report_id=>$details)
			{
				$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
				
				if ($oneReport=$ops->getReportByID($report_id))
				{
					foreach ($details as $type=>$dummy)
					{
						if ($type=='reverse')
						{
							if ($params['status']=='done')
							{
								$project=$OS->getProjectOps()->getProjectByID($oneReport->project_id);
								$url_host=parse_url($project->url,PHP_URL_HOST);
								
								$reverse_ip_hosts=array();
								if (!empty($params['data']['getResults']))
								{
									foreach ($params['data']['getResults'] as $rip)
									{
										$rip_host=parse_url($rip['url'],PHP_URL_HOST);
										
										if ($rip_host!=$url_host)
										{
											$reverse_ip_hosts[$rip_host]=true;
										}
									}
								}
								
								$oneReport->result['server']['reverse_ip']=array_keys($reverse_ip_hosts);
								sort($oneReport->result['server']['reverse_ip']);
								
								$rip_hosts_count=count($oneReport->result['server']['reverse_ip']);
								
								if ($rip_hosts_count==0)
								{
									$oneReport->grade+=10;
								}
								elseif ($rip_hosts_count<5)
								{
									$oneReport->grade+=7;
								}
								elseif ($rip_hosts_count<10)
								{
									$oneReport->grade+=5;
								}
								elseif ($rip_hosts_count<20)
								{
									$oneReport->grade+=3;
								}
								
								$oneReport->save();
							}
							else
							{
								$this->fetchReverseIP($report_id);
							}
						}
						elseif (empty($oneReport->result['indexed']["{$type}_done"]))
						{
							if ($params['status']=='done')
							{
								$oneReport->result['indexed'][$type]=$params['data']['getResultsNumber'];
								$oneReport->result['indexed'][$type.'_done']=true;
								
								$allDone=true;
								$idx_pgs=0;
								foreach ($types as $type)
								{
									if (empty($oneReport->result['indexed']["{$type}_done"]))
									{
										$allDone=false;
										break;
									}
									
									$idx_pgs+=$oneReport->result['indexed'][$type];
								}
								
								if ($allDone)
								{
									$idx_pgs=$idx_pgs/count($type);
									
									if ($idx_pgs>1000000)
									{
										$oneReport->grade+=10;
									}
									elseif ($idx_pgs>500000)
									{
										$oneReport->grade+=7;
									}
									elseif ($idx_pgs>100000)
									{
										$oneReport->grade+=5;
									}
									elseif ($idx_pgs>10000)
									{
										$oneReport->grade+=3;
									}
									elseif ($idx_pgs>1000)
									{
										$oneReport->grade+=2;
									}
									elseif ($idx_pgs>100)
									{
										$oneReport->grade+=1;
									}
								}
								
								$oneReport->save();
							}
							elseif ($params['status']=='failed')
							{
								$this->fetchIndexedPages($report_id,$type);
							}
						}
					}
				}
			}
			
			$result=true;
		}
	}
	
	public function fetchIndexedPages($report_id,$engine,$url=false)
	{
		$result=false;
		
		$OS=getOS();
		
		if (!$url)
		{
			$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
			if ($oneReport=$ops->getReportByID($report_id))
			{
				$project=$OS->getProjectOps()->getProjectByID($oneReport->project_id);
				$osUtils=$OS->getUtils();
				
				$url=$osUtils->stripifyURL($project->url);
			}	
		}
		
		if ($url)
		{
			$osSearchEngine=$OS->getSearchEngine();
					
			if ($indexed=$osSearchEngine->getResultsNumber("site:".$url,$engine,'com'))
			{
				if ($indexed['status']=='queued')
				{
					$this->queueSearch($report_id,$indexed['queue_id'],$engine);
				}
				
				$result=$indexed;
			}
		}
		
		return $result;
	}
	
	public function fetchReverseIP($report_id,$ip=false)
	{
		$result=false;
		
		$OS=getOS();
		
		if (!$ip)
		{
			$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
			if ($oneReport=$ops->getReportByID($report_id))
			{
				$project=$OS->getProjectOps()->getProjectByID($oneReport->project_id);
				$osUtils=$OS->getUtils();
				
				$ip=gethostbyname(parse_url($project->url,PHP_URL_HOST));
			}
		}
		
		if ($ip)
		{
			$osSearchEngine=$OS->getSearchEngine();
			$osSearchEngine->setResultsPerPage(50,'bing','com');
			
			if ($reverse_ip=$osSearchEngine->getResults("ip:{$ip}",'bing','com'))
			{
				if ($reverse_ip['status']=='queued')
				{
					$this->queueSearch($report_id,$reverse_ip['queue_id'],'reverse');
				}
				
				$result=$reverse_ip;
			}
		}
		
		return $result;
	}
	
	public function performAudit($project_id,$report_id)
	{
		$result=false;
		
		$OS=getOS();
		
		$projectOps=$OS->getProjectOps();
		
		if ($project=$projectOps->getProjectByID($project_id))
		{
			$osHttp=$OS->getHttp();
			
			$grade=0;
			
			$scoring=array();
			
			$response=$osHttp->get($project->url);

			if ($response OR $osHttp->success())
			{
				$audit=array('site_available'=>true);
				
				$audit['server']['load_time']=$osHttp->getRequestTime()/1000;
				
				if ($audit['server']['load_time']<1)
				{
					$grade+=10;
				}
				elseif ($audit['server']['load_time']<=2)
				{
					$grade+=7;
				}
				elseif ($audit['server']['load_time']<=3)
				{
					$grade+=5;
				}
				elseif ($audit['server']['load_time']<=5)
				{
					$grade+=3;
				}
				
				$cmsDetector=$OS->getCMSDetector();
				
				$audit['server']['cms']=$cmsDetector->detectFromContent($response);
				
				$audit['onsite']['url']=$project->url;
				
				$osUtils=$OS->getUtils();
				
				$dom=new DOMDocument();
				
				libxml_use_internal_errors(true);
				$domLoaded=$dom->loadHTML($response);
				libxml_use_internal_errors(false);
				
				if ($domLoaded)
				{
					$audit['onsite']['analyzed']=true;

					$xpath=new DOMXPath($dom);
					
					$entries=$xpath->query("//title");
					if (!$entries->item(0))
					{
						$audit['onsite']['title']=false;
					}
					else
					{
						$title=$entries->item(0)->nodeValue;
						
						if (!empty($title))
						{
							if (strlen($title)<30)
							{
								$grade+=5;
							}
							elseif (strlen($title)<50)
							{
								$grade+=7;
							}
							elseif (strlen($title)<=70)
							{
								$grade+=10;
							}
							elseif (strlen($title)<=100)
							{
								$grade+=7;
							}
							else
							{
								$grade+=5;
							}
						}
						
						$audit['onsite']['title']=$title;
					}
					
					$entries=$xpath->query("//meta[@name='description']");
					if (!$entries->item(0))
					{
						$audit['onsite']['description']=false;
					}
					else
					{
						$desc=$entries->item(0)->getAttribute('content');
						
						if (!empty($desc))
						{
							if (strlen($desc)<100)
							{
								$grade+=2.5;
							}
							elseif (strlen($desc)<140)
							{
								$grade+=3.5;
							}
							elseif (strlen($desc)<=160)
							{
								$grade+=5;
							}
							elseif (strlen($desc)<=200)
							{
								$grade+=3.5;
							}
							else
							{
								$grade+=2.5;
							}
						}
						
						$audit['onsite']['description']=$desc;
					}
					
					$headings=array('h1','h2','h3','h4','h5','h6');
					foreach ($headings as $heading)
					{
						$entries=$xpath->query("//{$heading}");
						
						$audit['onsite']['headings'][$heading]=$entries->length;
					}
					
					if (!empty($audit['onsite']['headings']['h1']))
					{
						$grade+=7;
					}
					if (!empty($audit['onsite']['headings']['h2']))
					{
						$grade+=3;
					}
					
					$audit['onsite']['images']=array('total'=>0,'no_alt'=>0);
					
					$entries=$xpath->query("//img");
					foreach ($entries as $entry)
					{
						$audit['onsite']['images']['total']++;
						
						$alt=$entry->getAttribute('alt');
						if (empty($alt))
						{
							$audit['onsite']['images']['no_alt']++;
						}
					}
					
					if ($audit['onsite']['images']['total']!=0)
					{
						$grade+=10-$audit['onsite']['images']['no_alt']*10/$audit['onsite']['images']['total'];
					}
					
					$entries=$xpath->query("//link[@rel='shortcut icon']");
					if ($entries->item(0))
					{
						if ($favicon_url=$entries->item(0)->getAttribute('href'))
						{
							$favicon_url=$osUtils->makeAbsoluteUrl($project->url,$favicon_url);
						}
					}
					else
					{
						$entries=$xpath->query("//link[@rel='icon']");
						if ($entries->item(0))
						{
							if ($favicon_url=$entries->item(0)->getAttribute('href'))
							{
								$favicon_url=$osUtils->makeAbsoluteUrl($project->url,$favicon_url);
							}
						}
					}
				}
				else
				{
					$audit['onsite']['analyzed']=false;
				}
				
				if (empty($favicon_url))
				{
					$favicon_url=$osUtils->stripEndingSlash($project->url).'/favicon.ico';
				}
				
				$favicon_response=$osHttp->get($favicon_url);
				if ($favicon_response AND $osHttp->success())
				{
					$audit['usability']['favicon']=$favicon_url;
					$grade+=2.5;
				}
				else
				{
					$audit['usability']['favicon']=false;
				}
				
				$robots_url=$osUtils->stripEndingSlash($project->url).'/robots.txt';
				$robots_response=$osHttp->get($robots_url);
				$robots_sitemap=false;
				if ($robots_response AND $osHttp->success())
				{
					$audit['compliance']['robots']=true;
					$grade+=2.5;
					
					$osRobotsTxt=$OS->getRobotsTxt();
					$robots_sitemap=$osRobotsTxt->getSitemap($project->url);
				}
				else
				{
					$audit['compliance']['robots']=false;
				}
				
				$sitemap_found=false;
				if ($robots_sitemap)
				{
					$sitemap_response=$osHttp->get($robots_sitemap);
					if ($sitemap_response AND $osHttp->success())
					{
						$sitemap_found=true;
					}
				}
				
				if (!$sitemap_found)
				{
					$sitemap_files=array('sitemap.xml','sitemap_index.xml','Sitemap.xml','Sitemap_index.xml','Sitemap_Index.xml');
					$audit['compliance']['sitemap']=false;
					foreach ($sitemap_files as $file)
					{
						$sitemap_url=$osUtils->stripEndingSlash($project->url).'/'.$file;
						$sitemap_response=$osHttp->get($sitemap_url);
						if ($sitemap_response AND $osHttp->success())
						{
							$sitemap_found=true;
							break;
						}
					}
				}
				
				if ($sitemap_found)
				{
					$audit['compliance']['sitemap']=true;
					$grade+=2.5;
				}
				
				if (preg_match("/UA-[0-9]{5,}-[0-9]{1,}/",$response))
				{
					$audit['compliance']['ga']=true;
					$grade+=2.5;
				}
				else
				{
					$audit['compliance']['ga']=false;
				}
				
				$stripped_url=$osUtils->stripifyURL($project->url);
				
				$osRankings=$OS->getRankings();
				
				$osRankings->setRanking('alexa');
				$audit['rankings']['alexa']=$osRankings->getRank($project->url);
				
				if (!empty($audit['rankings']['alexa']))
				{
					if ($audit['rankings']['alexa']<500)
					{
						$grade+=5;
					}
					elseif ($audit['rankings']['alexa']<1000)
					{
						$grade+=3.5;
					}
					elseif ($audit['rankings']['alexa']<10000)
					{
						$grade+=2.5;
					}
					elseif ($audit['rankings']['alexa']<100000)
					{
						$grade+=1.5;
					}
				}
				
				$osRankings->setRanking('pagerank');
				$audit['rankings']['pagerank']=$osRankings->getRank($project->url);
				
				if (!empty($audit['rankings']['pagerank']))
				{
					$grade+=$audit['rankings']['pagerank'];
				}
				
				$osBacklinks=$OS->getBacklinks();
				if ($urlmetrics=$osBacklinks->getUrlsMetrics($stripped_url,'majesticsimple'))
				{
					$audit['rankings']['majestic_cf']=$urlmetrics['citation_flow'];
					$audit['rankings']['majestic_tf']=$urlmetrics['trust_flow'];
				}
				
				if ($urlmetrics=$osBacklinks->getUrlsMetrics($project->url,'moz'))
				{
					$audit['rankings']['moz_da']=floor($urlmetrics['domain_authority']);
					$audit['rankings']['moz_pa']=floor($urlmetrics['page_authority']);
				}
				
				$idxDone=true;$idx_pgs_avg=0;
				$get_idx_from=array('bing','google');
				foreach ($get_idx_from as $engine)
				{
					$audit['indexed'][$engine]=0;
					$audit['indexed']["{$engine}_done"]=false;
						
					if ($idx=$this->fetchIndexedPages($report_id,$engine,$stripped_url))
					{
						if ($idx['status']=='done')
						{
							$audit['indexed'][$engine]=$idx['data'];
							$idx_pgs_avg+=$idx['data'];
							$audit['indexed']["{$engine}_done"]=true;
						}
						else
						{
							$idxDone=false;
						}
					}
					else
					{
						$idxDone=false;
					}
				}
				
				if ($idxDone)
				{
					$idx_pgs_avg=$idx_pgs_avg/count($get_idx_from);
					
					if ($idx_pgs_avg>1000000)
					{
						$grade+=10;
					}
					elseif ($idx_pgs_avg>500000)
					{
						$grade+=7;
					}
					elseif ($idx_pgs_avg>100000)
					{
						$grade+=5;
					}
					elseif ($idx_pgs_avg>10000)
					{
						$grade+=3;
					}
					elseif ($idx_pgs_avg>1000)
					{
						$grade+=2;
					}
					elseif ($idx_pgs_avg>100)
					{
						$grade+=1;
					}
				}
				
				$osSocialSignals=$OS->getSocialSignals();
				
				$osSocialSignals->setSocialNetwork('facebook');
				$audit['social']['facebook']=$osSocialSignals->getSocialSignals($project->url);
				
				$osSocialSignals->setSocialNetwork('twitter');
				$audit['social']['twitter']=$osSocialSignals->getSocialSignals($project->url);
				
				$social_signals_avg=($audit['social']['facebook']['total']+$audit['social']['twitter']['tweets'])/2;
				
				if ($social_signals_avg>5000)
				{
					$grade+=10;
				}
				elseif ($social_signals_avg>1000)
				{
					$grade+=7;
				}
				elseif ($social_signals_avg>500)
				{
					$grade+=5;
				}
				elseif ($social_signals_avg>100)
				{
					$grade+=3;
				}
				elseif ($social_signals_avg>10)
				{
					$grade+=1;
				}
				elseif ($social_signals_avg>1)
				{
					$grade+=0.5;
				}
				
				$osGeoIP=$OS->getGeoIP();
				
				$url_host=parse_url($project->url,PHP_URL_HOST);
				
				$audit['server']['ip']=gethostbyname($url_host);
				$audit['server']['location']=$osGeoIP->getLocation($audit['server']['ip']);
				$audit['server']['reverse_ip']=array();
				
				$reverse_ip_hosts=array();
				
				if ($reverse_ip=$this->fetchReverseIP($report_id,$audit['server']['ip']))
				{
					if ($reverse_ip['status']=='done')
					{
						if ($reverse_ip['data'])
						{
							foreach ($reverse_ip['data'] as $rip)
							{
								$rip_host=parse_url($rip['url'],PHP_URL_HOST);
								
								if ($rip_host!=$url_host)
								{
									$reverse_ip_hosts[$rip_host]=true;
								}
							}
						}
								
						$audit['server']['reverse_ip']=array_keys($reverse_ip_hosts);
						sort($audit['server']['reverse_ip']);
						
						$rip_hosts_count=count($audit['server']['reverse_ip']);
						
						if ($rip_hosts_count==0)
						{
							$grade+=10;
						}
						elseif ($rip_hosts_count<5)
						{
							$grade+=7;
						}
						elseif ($rip_hosts_count<10)
						{
							$grade+=5;
						}
						elseif ($rip_hosts_count<20)
						{
							$grade+=3;
						}
					}
				}
				
				exec("whois {$stripped_url}",$whois_output,$whois_return);
				
				if (!$whois_return AND !empty($whois_output))
				{
					$audit['whois']=implode("\n",$whois_output);
				}
				else
				{
					$audit['whois']=false;
				}
				
				$result=array('grade'=>$grade,'audit'=>$audit);
			}
		}
		
		return $result;
	}
}
?>