<?php
class OS_APP_WebsiteAudit_Report
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $grade;
	public $insert_dt;
	public $insert_ip;
	public $status;
	public $status_dt;
	public $status_ip;
	public $result;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_WebsiteAudit_Report();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=false;
		$this->project_id=0;
		$this->grade=0;
		$this->insert_dt='';
		$this->insert_ip='';
		$this->status='';
		$this->status_dt='';
		$this->status_ip='';
		$this->result=array();
	}
	
	public function set($data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($data[$key]))
			{
				$this->$key = $data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertReport($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateReport($this);
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
			
			if ($data=$ops->getReportByID($this->id))
			{
				$this->set(get_object_vars($data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
			
			$result=$ops->deleteReportByID($this->id);
		}
		
		return $result;
	}
	
	public function toTemplate()
	{
		if (!$this->id) return false;
		
		$utils=getOS()->getUtils();
		$app=getOS()->getAppHandler()->getAppPlugin();
		
		$statuses=array('W'=>_('Generating...'),'F'=>_('Failed'),'D'=>_('Done'));
		
		if (!empty($this->result['server']['location']))
		{
			$location_text='';
			$location=$this->result['server']['location'];
			
			if (!empty($location['city']))
			{
				$location_text.=$location['city'];
			}
			
			if (!empty($location['region_name']))
			{
				$location_text.=(empty($location_text)?'':', ').$location['region_name'];
			}
			
			if (!empty($location['country_name']))
			{
				$location_text.=(empty($location_text)?'':', ').$location['country_name'];
			}
			
			if (!empty($location['continent_name']))
			{
				$location_text.=(empty($location_text)?'':', ').$location['continent_name'];
			}
		}
		else
		{
			$location_text=false;
		}
		
		$this->result['server']['location_text']=$location_text;
		
		if ($this->result['server']['cms'])
		{
			$cmsDetector=getOS()->getCMSDetector();

			$this->result['server']['cms_details']=$cmsDetector->getCMSDetails($this->result['server']['cms']);
		}
		
		$reportArray=array(
			'id'=>$this->id,
			'grade'=>$this->grade,
			'status'=>$this->status,
			'status_human'=>$statuses[$this->status],
			'insert_dt_human'=>$utils->humanizeDate($this->insert_dt),
			'result'=>$this->result
		);
		
		return $reportArray;
	}
}
?>