<?php
class OS_APP_WebsiteAudit_ReportOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_APP_WebsiteAudit_ReportOperations();
		}
		
		return self::$_instance;
	}
	
	public function getReportByID($report_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE id=?",array($report_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$row['result']=json_decode($row['result'],true);
			
			$result=new OS_APP_WebsiteAudit_Report();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getReports($project_id=false,$offset=0,$count=10)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE project_id=? ORDER BY `insert_dt` DESC LIMIT {$offset},{$count}";
		
		$dbresult=$db->query($query,array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$row['result']=json_decode($row['result'],true);
			
			$oneReport=new OS_APP_WebsiteAudit_Report();
			$oneReport->set($row);
			
			$result[$row['id']]=$oneReport;
		}
		
		return $result;
	}
	
	public function getReportsCount($project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$query="SELECT COUNT(id) AS total_reports FROM ".$appHandler->dbPrefix()."reports WHERE project_id=?";
		
		$dbresult=$db->query($query,array($project_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=$row['total_reports'];
		}
		
		return $result;
	}
	
	public function getLatestReports($project_id=false,$count=2)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project_id=getOS()->getProject()->id;
		}
		
		$db=getOS()->getDb();
		$appHandler=getOS()->getAppHandler();
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."reports WHERE project_id=? ORDER BY `insert_dt` DESC LIMIT {$count}",array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$row['result']=json_decode($row['result'],true);
			
			$oneReport=new OS_APP_WebsiteAudit_Report();
			$oneReport->set($row);
			
			$result[$row['id']]=$oneReport;
		}
		
		return $result;
	}
	
	public function insertReport($report)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		$ip=$OS->getRemoteAddr();
		
		$json_result=json_encode($report->result);
		
		$query="INSERT INTO ".$appHandler->dbPrefix()."reports (project_id,grade,insert_dt,insert_ip,status,status_dt,status_ip,result) VALUES (?,?,?,?,?,?,?,?)";
		$dbresult=$db->query($query,array($report->project_id,$report->grade,$time,$ip,'W',$time,$ip,$json_result));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateReport($report)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$time=$db->DBTimeStamp(time());
		$ip=$OS->getRemoteAddr();
		
		$json_result=json_encode($report->result);
		
		$query="UPDATE ".$appHandler->dbPrefix()."reports SET grade=?,result=?,status=?,status_dt=?,status_ip=? WHERE id=?";
		$dbresult=$db->query($query,array($report->grade,$json_result,$report->status,$time,$ip,$report->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteReportByID($report_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."reports WHERE id=?";
		$dbresult=$db->query($query,array($report_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteDataByProjectID($project_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$appHandler=$OS->getAppHandler();
		
		$query="DELETE FROM ".$appHandler->dbPrefix()."reports WHERE project_id=?";
		$dbresult=$db->query($query,array($project_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
}
?>