<?php
class OS_APPVIEW_WebsiteAudit_Main extends OS_AppViewBase
{
	private $reportsPerPage=10;
	
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$project=$OS->getProject();
		$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
		
		$viewDataVars=array();
		
		$viewDataVars['reports']=$ops->getLatestReports($project->id,10);

		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();

		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		
		$viewData=$this->buildViewData();

		if ($viewData['reports'])
		{
			$osUtils=$OS->getUtils();
			
			if (count($viewData['reports'])>=2)
			{
				$stats=array();
				foreach ($viewData['reports'] as $report_id=>$report)
				{
					$day=date('Y-m-d',strtotime($report->status_dt));
					$stats[$report->status_dt]=$report->grade;
				}
				$stats=array_reverse($stats,true);
				
				$chartValues=array();$chartTooltips=array();$chartLabels=array();
				foreach ($stats as $day=>$grade)
				{
					$chartValues[]=$grade;
					
					$chartLabels[]=date('d M',strtotime($day));
					
					$chartTooltips[]=date('d M',strtotime($day))."\n"._("Grade").": {$grade}";
				}
				
				$charts = $OS->getCharts();
				
				$chartOptions=array(
					'values'=>array_values($chartValues),
					'labels'=>$chartLabels,
					'tooltips'=>array_values($chartTooltips),
					'fill'=>true,
					'normalize'=>true
				);
				
				$chartData = $charts->getLineChart($chartOptions);
				
				$tplVars['chart']=$chartData['html'];
			}
			else
			{
				$tplVars['chart']=false;
			}
			
			$latest=reset($viewData['reports']);
			
			$tplVars['latestReport']=$latest->toTemplate();
			
			$tplVars['reports']=true;
		}
		else
		{
			$tplVars['reports']=false;
		}
		
		$tpl=$OS->getTemplate();

		if (!empty($tplVars['chart']))
		{
			$tpl->setHeadContents($chartData['js']);
		}
		
		return $tpl->fetchTemplate('main',$tplVars);
	}
}
?>