<?php
class OS_APPVIEW_WebsiteAudit_ReportEvolution extends OS_AppViewBase
{
	public function __construct()
	{
		parent::__construct();
	}
	
	public function buildViewData()
	{
		$OS=getOS();
		
		$project=$OS->getProject();
		$appPlugin=$OS->getAppHandler()->getAppPlugin();
		$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
		
		$viewDataVars=array('report'=>false);
		
		if ($reports=$ops->getLatestReports($project->id,10))
		{
			if (count($reports)>=2)
			{
				$stats=array();
				
				foreach ($reports as $report)
				{
					$stats[date('d M',strtotime($report->status_dt))]=$report->grade;
				}
				
				$stats=array_reverse($stats);
				
				$osChartsImage=$OS->getChartsImage();
				$appHomeUrl=$appPlugin->getAppHomeUrl();
				
				$reportData=array(
					'filename'=>'website_audit_evolution.pdf',
					'title'=>_('Website Audit Evolution'),
					'sections'=>array()
				);
				
				$chartData=array(
					'y_name'=>_("Score"),
					'labels'=>array_keys($stats),
					'lines'=>array(
						array(
							'name'=>_("Score"),
							'values'=>array_values($stats),
							'color'=>'#a1c132'
						)
					)
				);
				
				$reportData['sections']['grade']=array(
					'title'=>_("Score"),
					'icon'=>"{$appHomeUrl}/resources/images/report/seo_score.png",
					'type'=>'image',
					'image_url'=>$osChartsImage->getChartUrl('line',$chartData)
				);
				
				$viewDataVars['report']=$reportData;
			}
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$viewData=$this->buildViewData();
		
		if ($viewData['report'])
		{
			$osReport=$OS->getReport();
			
			$osReport->generateReport($viewData['report']);
		}
		else
		{
			return $OS->getTemplate()->fetchTemplate('report');
		}
	}
}
?>