<?php
class OS_WIDGET_CompIdxUrlsStats_mainView
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
	
	}
	
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		

		return $viewDataVars;
	}
	
	public function render()
	{
		$OS = getOS();
		
		$tplVars = array();
		
		$headContents = array();
		
		$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
		
		$viewData = $this->buildViewData();
		
		$osProject = $OS->getProject();
		$competitorOps = $OS->getCompetitorOps();
		
		if ($competitors=$competitorOps->getCompetitors($osProject->id))
		{
			$appHandler=$OS->getAppHandler('compindexedurls');
			$utils=$OS->getUtils();
			$db=$OS->getDb();
			
			$competitorsArray=array();
			$stats=array();
			
			$chartColors=array(
				'green'=>'#27ae60',
				'blue'=>'#3498db',
				'orange'=>'#d35400',
				'red'=>'#c13a32'
			);

			
			foreach ($competitors as $competitor_id=>$oneCompetitor)
			{
				$competitorsArray[$competitor_id]=array(
					'host'=>$oneCompetitor->host,
				);
				
				$stats[$competitor_id]=array();
				
				$day_start=strtotime(date('Y-m-d'));
				$from=$day_start-86400*9;
				$current=$from;
				$to=$day_start;
				
				while ($current<=$to)
				{
					$stats[$competitor_id][date('Y-m-d',$current)]=0;
					$current+=86400;
				}
				
				$has_data=false;

				$query="SELECT * FROM ".$appHandler->dbPrefix()."days WHERE project_id=? AND competitor_id=? AND `date`>=? ORDER BY `date` DESC LIMIT 10";
				$dbresult=$db->query($query,array($osProject->id,$competitor_id,date('Y-m-d',$from)));
				while ($row=$db->fetchRow($dbresult))
				{
					$stats[$competitor_id][$row['date']]=$row['urls'];
					$has_data=true;
				}
				
				if ($has_data)
				{
					$day_index=0;
					$chartValues=array();$chartTooltips=array();$chartLabels=array();
					foreach ($stats[$competitor_id] as $day=>$urls)
					{
						$chartValues[]=$urls;
						if ($day_index%3==0)
						{
							$chartLabels[]=date('d M',strtotime($day));
						}
						else
						{
							$chartLabels[]=false;
						}
						$chartTooltips[]=date('d M',strtotime($day))."\n{$urls} "._("URLs");
						$day_index++;
					}
					
					$charts = $OS->getCharts();
					
					$length=count($chartValues);
					$difs_sum=0;
					for ($i=1;$i<=$length-1;$i++)
					{
						$difs_sum+=($chartValues[$i]-$chartValues[$i-1]);
					}
					$heads_dif=abs($chartValues[$length-1]-$chartValues[0]);
					
					if ($difs_sum<0)
					{
						if ($heads_dif>abs(round($chartValues[0]/10)))
						{
							$color='green';
						}
						else
						{
							$color='blue';
						}
					}
					elseif ($difs_sum==0)
					{
						$color='blue';
					}
					elseif ($difs_sum>0)
					{
						if ($heads_dif>abs(round($chartValues[0]/10)))
						{
							$color='red';
						}
						else
						{
							$color='orange';
						}
					}
					
					$chartOptions=array(
						'values'=>array_values($chartValues),
						'labels'=>$chartLabels,
						'tooltips'=>$chartTooltips,
						'fill'=>true,
						'color'=>$chartColors[$color]
					);
					
					$chartData = $charts->getLineChart($chartOptions);
					
					$tplVars['charts'][$competitor_id]=$chartData['html'];
					$headContents = array_merge($headContents, $chartData['js']);
				}
			}
			
			if (!empty($tplVars))
			{
				foreach ($competitorsArray as $competitor_id=>$competitor_name)
				{
					if (isset($tplVars['charts'][$competitor_id]))
					{
						$tplVars['competitors'][$competitor_id]=$competitor_name;
					}
				}
				
				reset($tplVars['competitors']);
				$tplVars['currentCompetitor']=key($tplVars['competitors']);
				
				$headContents['compidxurlsstats']="<script type='text/javascript'>
					var currentCompetitor={$tplVars['currentCompetitor']};

					function compidxurlsstatsChangeCompetitor(selectedIndex)
					{
						$('#chartsContainer').css('margin-top',(-selectedIndex*150)+'px')
					}
				</script>";
				
				$headContents['css']['compidxurlsstats']=$osWidgetPlugin->getWidgetHomeUrl()."/resources/style.css";
			}
		}
		
		
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('mainview', $tplVars);
	}
}
?>