<?php
class OS_WIDGET_DuplContentEvo_mainView
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
	
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		$project = $OS->getProject();
		
		$appHandler = $OS->getAppHandler('duplcontent');
		
		$app = $appHandler->getAppPlugin();
		
		$reportOps=$app->getReportOps();
		
		$reports=$reportOps->getReports();
		$stats = array();
		$has_data = false;
		
		if ($reports)
		{
			foreach ($reports as $report)
			{
				$stats[]=$report->toTemplate();
			}
		}

		$stats = array_reverse($stats,true);

		if (count($stats)>=2)
		{
			$viewDataVars['stats'] = $stats;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS = getOS();
		
		$tplVars = array();
		
		$headContents = array();
		
		$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
		
		$viewData = $this->buildViewData();
		
		if (!empty($viewData['stats']))
		{
			$day_index=0; $has_data = true;
			$chartValues=array();$chartLabels=array();$chartTooltips=array();
			foreach ($viewData['stats'] as $stats_entry)
			{
				$chartValues[1][]=$stats_entry['urls_group_1'];
				$chartValues[2][]=$stats_entry['urls_group_2'];
				$chartValues[3][]=$stats_entry['urls_group_3'];
				$chartValues[4][]=$stats_entry['urls_group_4'];
				
				if ($day_index%3==0)
				{
					$chartLabels[]=date('d M',strtotime($stats_entry['report_dt']));
				}
				else
				{
					$chartLabels[]=false;
				}
				
				$chartTooltips[1][]=date('d M',strtotime($stats_entry['report_dt']))."\n{$stats_entry['urls_group_1']} URLs";
				$chartTooltips[2][]=date('d M',strtotime($stats_entry['report_dt']))."\n{$stats_entry['urls_group_2']} URLs";
				$chartTooltips[3][]=date('d M',strtotime($stats_entry['report_dt']))."\n{$stats_entry['urls_group_3']} URLs";
				$chartTooltips[4][]=date('d M',strtotime($stats_entry['report_dt']))."\n{$stats_entry['urls_group_4']} URLs";
				
				$day_index++;
			}
			
			foreach ($chartValues as $group=>$group_stats)
			{
				if (array_sum($group_stats)==0)
				{
					unset($chartValues[$group]);
					unset($chartTooltips[$group]);
				}
			}
			
			if (empty($chartValues))
			{
				$has_data=false;
			}

			if ($has_data)
			{
				$chartColors=array(
					'1'=>'#a1c132',
					'2'=>'#F3D645',
					'3'=>'#ec7f36',
					'4'=>'#C13A32'
				);
				$chartLegend=array(
					'1'=>"<25%",
					'2'=>"25-50%",
					'3'=>"50-75%",
					'4'=>">75%"
				);
				
				$colors=array();
				$legend=array();
				
				foreach ($chartValues as $group=>$dummy)
				{
					$colors[]=$chartColors[$group];
					$legend[$group]=array(
						'color'=>$chartColors[$group],
						'title'=>$chartLegend[$group]
					);
				}
				
				$osCharts = $OS->getCharts();
				
				$chartOptions=array(
					'values'=>array_values($chartValues),
					'labels'=>$chartLabels,
					'tooltips'=>array_values($chartTooltips),
					'fill'=>false,
					'color'=>$colors
				);
				
				$chartData = $osCharts->getLineChart($chartOptions);
				
				$tplVars['chart_html'] = $chartData['html'];
				$tplVars['legend_details'] = $legend;
				
				$headContents = array_merge($headContents, $chartData['js']);
				
				$headContents['css']['duplcontentevo']=$osWidgetPlugin->getWidgetHomeUrl()."/resources/style.css";
			}
		}
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('mainview', $tplVars);
	}
}
?>