<?php
class OS_WIDGETVIEW_OnpageEvo_Main extends OS_WidgetViewBase
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
	
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		$project = $OS->getProject();
		
		$appHandler = $OS->getAppHandler('onpage');
		
		$ops=OS_APP_Onpage_ReportOperations::get_instance();
		
		if ($reports=$ops->getReports(0,10) AND count($reports)>1)
		{
			foreach ($reports as $report)
			{
				$day=date('Y-m-d',strtotime($report->insert_dt));
				
				$viewDataVars['stats']['errors'][$day]=$report->errors;
				$viewDataVars['stats']['warnings'][$day]=$report->warnings;
				$viewDataVars['stats']['notices'][$day]=$report->notices;
			}
			
			foreach ($viewDataVars['stats'] as $type=>$stats)
			{
				$viewDataVars['stats'][$type]=array_reverse($stats,true);
			}
		}
		else
		{
			$viewDataVars['stats']=false;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$tplVars=$this->buildViewData();
		$headContents=array();
		
		if ($tplVars['stats'])
		{
			$chartColors=array(
				'errors'=>'#C13A32',
				'warnings'=>'#f1c40f',
				'notices'=>'#3498db'
			);
			
			$tplVars['charts']=array(
				'legend'=>array('errors'=>_("Errors"),'warnings'=>_("Warnings"),'notices'=>_("Notices")),
				'actualCharts'=>array()
			);
			
			$osCharts = $OS->getCharts();
			
			foreach ($tplVars['charts']['legend'] as $type=>$name)
			{
				$chartValues=array();$chartTooltips=array();$chartLabels=array();
				$day_index=0;
				foreach ($tplVars['stats'][$type] as $day=>$value)
				{
					$chartValues[]=$value;
					if ($day_index%3==0)
					{
						$chartLabels[]=date('d M',strtotime($day));
					}
					else
					{
						$chartLabels[]=false;
					}
					$day_index++;
					$chartTooltips[]=date('d M',strtotime($day))."\n{$value} {$name}";
				}
				
				$chartOptions=array(
					'values'=>array_values($chartValues),
					'labels'=>$chartLabels,
					'tooltips'=>$chartTooltips,
					'fill'=>true,
					'normalize'=>true,
					'color'=>$chartColors[$type]
				);
				
				$chartData = $osCharts->getLineChart($chartOptions);
					
				$tplVars['charts']['actualCharts'][$type]=$chartData['html'];
				$headContents = array_merge($headContents, $chartData['js']);
			}
			
			$headContents['chartSwitcher']="<script type='text/javascript'>
				function switchChart(selectedIndex)
				{
					$('#chartsContainer').css('margin-top',(-selectedIndex*150)+'px')
				}
			</script>";
		}
		else
		{
			$tplVars['charts']=false;
		}
		
		$tpl=$OS->getTemplate();
		
		if (!empty($headContents))
		{
			$tpl->setHeadContents($headContents);
		}
		
		return $tpl->fetchTemplate('view',$tplVars);
	}
}
?>