<?php
class OS_WIDGETVIEW_OutgoingLinksEvo_Main extends OS_WidgetViewBase
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
	
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		$project = $OS->getProject();
		
		$appHandler = $OS->getAppHandler('outgoinglinks');
		
		$ops=OS_APP_OutgoingLinks_ReportOperations::get_instance();
		
		if ($reports=$ops->getLatestReports($project->id,10) AND count($reports)>1)
		{
			foreach ($reports as $report)
			{
				$viewDataVars['stats'][date('Y-m-d',strtotime($report->insert_dt))]=array(
					'total'=>$report->occurances_total,
					'dofollow'=>$report->occurances_dofollow,
					'nofollow'=>$report->occurances_nofollow,
					'broken'=>$report->broken_linked_urls
				);
			}
			
			$viewDataVars['stats']=array_reverse($viewDataVars['stats'],true);
		}
		else
		{
			$viewDataVars['stats']=false;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$tplVars=$this->buildViewData();
		$headContents=array();
		
		if ($tplVars['stats'])
		{
			$tplVars['charts']=array(
				'legend'=>array('broken'=>_("Broken linked pages"),'total'=>_("Total links"),'dofollow'=>_("Dofollow links"),'nofollow'=>_("Nofollow links")),
				'actualCharts'=>array()
			);
			
			$osCharts = $OS->getCharts();
			
			foreach ($tplVars['charts']['legend'] as $type=>$name)
			{
				$chartValues=array();$chartTooltips=array();$chartLabels=array();
				$day_index=0;
				foreach ($tplVars['stats'] as $day=>$details)
				{
					$stats_value=$details[$type];
					$chartValues[]=$stats_value;
					if ($day_index % 3 == 0)
					{
						$chartLabels[]=date('d M',strtotime($day));
					}
					else
					{
						$chartLabels[]=false;
					}
					$chartTooltips[]=date('d M',strtotime($day))."\n{$stats_value} "._("URLs");
					$day_index++;
				}
				
				$chartOptions=array(
					'values'=>array_values($chartValues),
					'labels'=>$chartLabels,
					'tooltips'=>$chartTooltips,
					'fill'=>true,
					'normalize'=>true
				);
				
				$chartData = $osCharts->getLineChart($chartOptions);
					
				$tplVars['charts']['actualCharts'][$type]=$chartData['html'];
				$headContents = array_merge($headContents, $chartData['js']);
			}
			
			$headContents['chartSwitcher']="<script type='text/javascript'>
				function switchChart(selectedIndex)
				{
					$('#chartsContainer').css('margin-top',(-selectedIndex*150)+'px')
				}
			</script>";
		}
		else
		{
			$tplVars['charts']=false;
		}
		
		$tpl=$OS->getTemplate();
		
		if (!empty($headContents))
		{
			$tpl->setHeadContents($headContents);
		}
		
		return $tpl->fetchTemplate('view',$tplVars);
	}
}
?>