<?php
class OS_WIDGET_selftcrawllast_mainView
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
	
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		$osProject = $OS->getProject();
		$crawlOps = $OS->getProjectCrawlOps();
		
		if ($viewDataVars['lastCrawl']=$crawlOps->getProjectCrawls(array('project_id'=>$osProject->id,'set'=>1,'max_rows'=>1)))
		{
			$viewDataVars['lastCrawl']=reset($viewDataVars['lastCrawl']);
			
			if ($viewDataVars['lastCrawl']->status=='D')
			{
				if ($viewDataVars['prevCrawl']=$crawlOps->getProjectCrawls(array('project_id'=>$osProject->id,'status'=>'D','set'=>2,'max_rows'=>1)))
				{
					$viewDataVars['prevCrawl']=reset($viewDataVars['prevCrawl']);
				}
			}
		}
		
//		if ($crawlData = $crawlOps->getProjectCrawls(array('project_id' => $osProject->id, 'status' => 'D', 'set'=> 1, 'max_rows' => 2)))
//		{
//			$viewDataVars['lastCrawl'] = current($crawlData);
//			
//			if(count($crawlData) > 1)
//			{
//				$viewDataVars['prevCrawl'] = next($crawlData);	
//			}
//		}

		return $viewDataVars;
	}
	
	public function render()
	{
		$OS = getOS();
		
		$tplVars = array();
		
		$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
		
		$viewData = $this->buildViewData();

		if ($viewData['lastCrawl'])
		{
			$osUtils=$OS->getUtils();
			
			$tplVars['breakdownLegend']=array(
				'2xx'=>_("URLs that were successfully loaded"),
				'3xx'=>_("URLs that initiated a redirection"),
				'4xx'=>_("URLs that were not available"),
				'5xx'=>_("URLs on which the server encountered an error")
			);
			
			$appBaseURL=$OS->getConfigVar('root_url').'/livedash/index.php#apps/selfcrawl/view_details/crawl_id='.$viewData['lastCrawl']->id;
			
			$tplVars['crawlData']=array(
				'crawl_d'=>$osUtils->humanizeDate($viewData['lastCrawl']->start_dt,'date'),
				'status'=>$viewData['lastCrawl']->status,
				'status_dt_human'=>$osUtils->humanizeDate($viewData['lastCrawl']->status_dt),
				'runtime'=>$osUtils->humanizeTime(strtotime($viewData['lastCrawl']->end_dt)-strtotime($viewData['lastCrawl']->start_dt)),
				'urls'=>$viewData['lastCrawl']->urls,
				'urls_errors'=>$viewData['lastCrawl']->urls_4xx+$viewData['lastCrawl']->urls_5xx,
				'urls_breakdown'=>array(
					'2xx'=>array(
						'urls'=>$viewData['lastCrawl']->urls_2xx,
						'details_url'=>false,
						'trend'=>false,
						'desired_trend'=>'asc'
					),
					'3xx'=>array(
						'urls'=>$viewData['lastCrawl']->urls_3xx,
						'details_url'=>($viewData['lastCrawl']->urls_3xx==0?false:"{$appBaseURL}&http_code_group=3"),
						'trend'=>false,
						'desired_trend'=>false
					),
					'4xx'=>array(
						'urls'=>$viewData['lastCrawl']->urls_4xx,
						'details_url'=>($viewData['lastCrawl']->urls_4xx==0?false:"{$appBaseURL}&http_code_group=4"),
						'trend'=>false,
						'desired_trend'=>'desc'
					),
					'5xx'=>array(
						'urls'=>$viewData['lastCrawl']->urls_5xx,
						'details_url'=>($viewData['lastCrawl']->urls_5xx==0?false:"{$appBaseURL}&http_code_group=5"),
						'trend'=>false,
						'desired_trend'=>'desc'
					)
				)
			);
			
			if (!empty($viewData['prevCrawl']))
			{
				foreach ($tplVars['crawlData']['urls_breakdown'] as $group=>&$details)
				{
					$var="urls_{$group}";
					$prev_urls=$viewData['prevCrawl']->$var;
					
					if ($details['urls']>$prev_urls)
					{
						$details['trend']='asc';
					}
					elseif ($details['urls']<$prev_urls)
					{
						$details['trend']='desc';
					}
					else
					{
						$details['trend']='static';
					}
				}
			}
		}
		
		$refresh_url=$osWidgetPlugin->getWidgetActionUrl('view',array('cache_buster'=>time().'_'.rand(1000,9999)));
		
		$headContents['selfcrawllast_refresh']="<meta http-equiv='refresh' content='120;url={$refresh_url}'>";
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('mainview', $tplVars);
	}
}
?>