<?php
class OS_WIDGET_SEVisitors_mainView
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
	
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		$stats=array();
		
		$osProject = $OS->getProject();
		$db = $OS->getDb();
		
		$appHandler = $OS->getAppHandler('incomingkws');

		$day_start = strtotime(date('Y-m-d'));
		$from = $day_start-86400*9;
		$current = $from;
		$to = $day_start;
		
		while ($current<=$to)
		{
			$stats[date('Y-m-d',$current)]=0;
			$current+=86400;
		}		
		
		$has_data = false;
		
		$dbresult=$db->query("SELECT * FROM ".$appHandler->dbPrefix()."stats_project WHERE project_id=? AND stats_d>=? ORDER BY stats_d",array($osProject->id,date('Y-m-d',$from)));
		while ($row=$db->fetchRow($dbresult))
		{
			$stats[$row['stats_d']]=$row['visits'];
			$has_data=true;
		}
		
		if($has_data)
		{
			$viewDataVars['stats'] = $stats;	
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS = getOS();
		
		$tplVars = array();
		
		$headContents = array();
		
		$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
		
		$viewData = $this->buildViewData();
		
		
		if(isset($viewData['stats']))
		{
			$chartColors=array(
				'green'=>'#27ae60',
				'blue'=>'#3498db',
				'orange'=>'#d35400',
				'red'=>'#c13a32'
			);
		
			$day_index=0;
			$chartValues=array();$chartTooltips=array();$chartLabels=array();
			foreach ($viewData['stats'] as $day=>$visits)
			{
				$chartValues[]=$visits;
				if ($day_index%3==0)
				{
					$chartLabels[]=date('d M',strtotime($day));
				}
				else
				{
					$chartLabels[]=false;
				}
				$chartTooltips[]=date('d M',strtotime($day))."\n{$visits} "._("visits");
				$day_index++;
			}
			
			$charts = $OS->getCharts();
			
			$length=count($chartValues);
			$difs_sum=0;
			for ($i=1;$i<=$length-1;$i++)
			{
				$difs_sum+=($chartValues[$i]-$chartValues[$i-1]);
			}
			$heads_dif=abs($chartValues[$length-1]-$chartValues[0]);
			
			if ($difs_sum>0)
			{
				if ($heads_dif>abs(round($chartValues[0]/10)))
				{
					$color='green';
				}
				else
				{
					$color='blue';
				}
			}
			elseif ($difs_sum==0)
			{
				$color='blue';
			}
			elseif ($difs_sum<0)
			{
				if ($heads_dif>abs(round($chartValues[0]/10)))
				{
					$color='red';
				}
				else
				{
					$color='orange';
				}
			}
			
			$chartOptions=array(
				'values'=>array_values($chartValues),
				'labels'=>$chartLabels,
				'tooltips'=>$chartTooltips,
				'fill'=>true,
				'normalize'=>true,
				'color'=>$chartColors[$color]
			);
			
			$chartData = $charts->getLineChart($chartOptions);
			
			$tplVars['chart_html'] = $chartData['html'];
			$headContents = array_merge($headContents, $chartData['js']);
		}
		
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('mainview', $tplVars);
	}
}
?>