<?php
class OS_WIDGET_SocialSignalsEvo_mainView
{
	public $chartTypes;
	
	public function __construct()
	{
		$this->chartTypes=array(
			'overall'=>array('name'=>_("Overall")),
			'facebook'=>array('name'=>"Facebook",'signal_name'=>_("Actions")),
			'gplus'=>array('name'=>"Google+",'signal_name'=>_("+1s")),
			'twitter'=>array('name'=>"Twitter",'signal_name'=>_("Tweets")),
			'pinterest'=>array('name'=>"Pinterest",'signal_name'=>_("Pins")),
			'linkedin'=>array('name'=>"LinkedIN",'signal_name'=>_("Shares")),
			'delicious'=>array('name'=>"Delicious",'signal_name'=>_("Shares")),
			'stumbleupon'=>array('name'=>"StumbleUpon",'signal_name'=>_("Stumbles")),
			'diggs'=>array('name'=>"Digg",'signal_name'=>_("Diggs")),
			'reddit'=>array('name'=>"Reddit",'signal_name'=>_("Actions"))
		);
	}
	
	public function processRequest()
	{
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$appHandler = $OS->getAppHandler('socialsignals');

		$appOps=OS_APP_SocialSignals_ReportOperations::get_instance();
		$viewDataVars=array();
		
		if ($viewDataVars['report']=$appOps->getReportByProjectID())
		{
			$viewDataVars['evolution']=$appOps->getReportEvolution($viewDataVars['report']);
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS = getOS();
		
		$tplVars=array();$headContents=array();
		$viewData=$this->buildViewData();
		
		if ($viewData['report'])
		{
			$tplVars['report']=true;
			
			if ($viewData['evolution'] AND count($viewData['evolution'])>=2)
			{
				$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
				
				$tplVars['chartTypes']=$this->chartTypes;
				
				$charts = $OS->getCharts();
				
				$stats=array_reverse($viewData['evolution'],true);
				
				$prev_signals_overall=false;$prev_signals=array();
				
				foreach ($this->chartTypes as $type=>$details)
				{
					$prev_signals[$type]=false;
				}
				
				$day_index=0;
				$chartValues=array();$chartTooltips=array();$chartLabels=array();
				foreach ($stats as $day=>$signals)
				{
					$signals['facebook']=$signals['facebook']['total'];
					$signals_overall=array_sum($signals);
					
					if ($day_index%3==0)
					{
						$chartLabels[]=date('d M',strtotime($day));
					}
					else
					{
						$chartLabels[]=false;
					}
					$day_index++;
					
					$chartValues['overall'][]=$signals_overall;
					$chartTooltips['overall'][]=date('d M',strtotime($day))."\n"._("Signals").": {$signals_overall}".($prev_signals_overall!==false?"\n"._("Change").": ".($signals_overall-$prev_signals_overall):'');
					$prev_signals_overall=$signals_overall;
					
					foreach ($this->chartTypes as $type=>$details)
					{
						if ($type!='overall')
						{
							$chartValues[$type][]=$signals[$type];
							$chartTooltips[$type][]=date('d M',strtotime($day))."\n{$details['signal_name']}: {$signals[$type]}".($prev_signals[$type]!==false?"\n"._("Change").": ".($signals[$type]-$prev_signals[$type]):'');
							$prev_signals[$type]=$signals[$type];
						}
					}
				}
				
				foreach ($this->chartTypes as $type=>$details)
				{
					$chartOptions=array(
						'values'=>array_values($chartValues[$type]),
						'labels'=>$chartLabels,
						'tooltips'=>array_values($chartTooltips[$type]),
						'fill'=>true,
						'normalize'=>true
					);
					$chartData = $charts->getLineChart($chartOptions);
					
					$tplVars['evolution'][$type]=$chartData['html'];
				}
				
				$headContents['chartJS']=implode("\n",$chartData['js']);
				$headContents['css']['socialsignalsnow']=$osWidgetPlugin->getWidgetHomeUrl()."/resources/style.css";
				
				$headContents['socialsignalsnow']="<script type='text/javascript'>
					var currentType='all';
	
					function socialSignalsNowChangeType(selectedIndex)
					{
						$('#chartsContainer').css('margin-top',(-selectedIndex*150)+'px')
					}
				</script>";
			}
			else
			{
				$tplVars['evolution']=false;
			}
		}
		else
		{
			$tplVars['report']=false;
		}
		
		$tpl = $OS->getTemplate();
		
		if (!empty($headContents))
		{
			$tpl->setHeadContents($headContents);
		}
		
		return $tpl->fetchTemplate('mainview', $tplVars);
	}
}
?>