<?php
class OS_WIDGET_WatchKw extends OS_WidgetBase
{
	public function __construct()
	{
		parent::__construct();
		
		$this->setRouterOption("view", "handleMainView");
		$this->setRouterOption("settings", "handleSettingsView");
	}
	
	public function handleMainView()
	{
		require $this->getWidgetHomePath()."/views/mainview.php";
		$viewData = new OS_WIDGET_watchkw_mainView();
		
		return $viewData->render();
	}
	
	public function handleSettingsView()
	{
		require $this->getWidgetHomePath()."/views/settings.php";
		$viewData = new OS_WIDGET_watchkw_settingsView();
		
		return $viewData->render();
	}
	
	public function processRequestOld($request)
	{
		$OS=getOS();
		$user=$OS->getUser();
		
		if (empty($request['view'])) $request['view']='view';
		
		switch ($request['view'])
		{
			case 'view':
			{
				$this->widgetTemplate='view';
				
				$headContents=false;
				
				$keyword=$this->getWidgetSetting('keyword');
				$this->widgetData=array('keyword'=>$keyword);
				
				if (!empty($request['params']['msg']))
				{
					if ($request['params']['msg']=='keyword_ok')
					{
						$OS->addInfo(_("Keyword saved successfully"));
					}
				}
				
				$chartColors=array(
					'green'=>'#27ae60',
					'blue'=>'#3498db',
					'orange'=>'#d35400',
					'red'=>'#c13a32'
				);
				
				if ($keyword)
				{
					$appHandler=$OS->getAppHandler('incomingkws');
					$db=$OS->getDb();
					$project=$OS->getProject();
					
					$query="SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE project_id=? AND keyword=?";
					$dbresult_keywords=$db->query($query,array($project->id,$keyword));
					if ($row_keywords=$db->fetchRow($dbresult_keywords))
					{
						$stats=array();
						
						$day_start=strtotime(date('Y-m-d'));
						$from=$day_start-86400*9;
						$current=$from;
						$to=$day_start;
						
						while ($current<=$to)
						{
							$stats[date('Y-m-d',$current)]=0;
							$current+=86400;
						}
						
						$has_data=false;
						
						$query="SELECT * FROM ".$appHandler->dbPrefix()."stats_keyword WHERE keyword_id=? AND stats_d>=?";
						$dbresult_stats=$db->query($query,array($row_keywords['id'],date('Y-m-d',$from)));
						while ($row_stats=$db->fetchRow($dbresult_stats))
						{
							$stats[$row_stats['stats_d']]=$row_stats['visits'];
							$has_data=true;
						}
						
						if ($has_data)
						{
							$day_index=0;
							$chartValues=array();$chartTooltips=array();$chartLabels=array();
							foreach ($stats as $day=>$visits)
							{
								$chartValues[]=$visits;
								if ($day_index%3==0)
								{
									$chartLabels[]=date('d M',strtotime($day));
								}
								else
								{
									$chartLabels[]=false;
								}
								$chartTooltips[]=date('d M',strtotime($day))."\n{$visits} "._("visits");
								$day_index++;
							}
							
							$charts = $OS->getCharts();
							
							$length=count($chartValues);
							$difs_sum=0;
							for ($i=1;$i<=$length-1;$i++)
							{
								$difs_sum+=($chartValues[$i]-$chartValues[$i-1]);
							}
							$heads_dif=abs($chartValues[$length-1]-$chartValues[0]);
							
							if ($difs_sum>0)
							{
								if ($heads_dif>abs(round($chartValues[0]/10)))
								{
									$color='green';
								}
								else
								{
									$color='blue';
								}
							}
							elseif ($difs_sum==0)
							{
								$color='blue';
							}
							elseif ($difs_sum<0)
							{
								if ($heads_dif>abs(round($chartValues[0]/10)))
								{
									$color='red';
								}
								else
								{
									$color='orange';
								}
							}
							
							$chartOptions=array(
								'values'=>array_values($chartValues),
								'labels'=>$chartLabels,
								'tooltips'=>$chartTooltips,
								'fill'=>true,
								'normalize'=>true,
								'color'=>$chartColors[$color]
							);
							
							$chartData = $charts->getLineChart($chartOptions);
							
							$this->widgetData['chart']=$chartData['html'];
							$headContents=$chartData['js'];
						}
					}
				}
				
				$this->widgetData['settings_url']= $osWidgetPlugin->getWidgetActionUrl('settings');
				
				$response=array('data'=>$this->widgetData,'template'=>$this->widgetTemplate);
				
				if ($headContents)
				{
					$response['headContents']=$headContents;
				}
				
				return $response;
				
				break;
			}
			
			case 'settings':
			{
				if ($_SERVER['REQUEST_METHOD']=='POST')
				{
					if (empty($_POST['keyword_box']))
					{
						$OS->addFieldError(_("Keyword missing"),'keyword');
					}
					else
					{
						$_POST['keyword_box']=trim($_POST['keyword_box']);
						
						if (strlen($_POST['keyword_box'])<3)
						{
							$OS->addFieldError(_("Keyword too short. Minimum length: 3 chars"),'keyword');
						}
					}
					
					if (!isset($OS->errorMessages))
					{
						$settings=array(
							'keyword'=>array('type'=>'str','value'=>$_POST['keyword_box'])
						);
						
						if ($this->saveWidgetSettings($settings))
						{
							return $this->processRequest(array('view'=>'view','params'=>array('msg'=>'keyword_ok')));
							break;
						}
						else
						{
							$OS->addBoxError(_("Unable to save widget settings"));
						}
					}
				}
				else
				{
					$_POST['keyword_box']=$this->getWidgetSetting('keyword');
				}
				
				$this->widgetTemplate='settings';
				$this->widgetData=array();
				
				return array('data'=>$this->widgetData,'template'=>$this->widgetTemplate);
				
				break;
			}
			
			default:
			{
				return false;
				break;
			}
		}
	}
}
?>