<?php
class OS_WIDGET_watchkw_mainView
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
		$OS = getOS();
		$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
		
		$requestParams = $osWidgetPlugin->getRequestParams();
		
		if (!empty($requestParams['msg']))
		{
			if ($requestParams['msg']=='keyword_ok')
			{
				$OS->addInfo("Keyword saved successfully");
			}
		}
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
		
		$keyword = $osWidgetPlugin->getWidgetSetting('keyword');
		
		$viewDataVars['keyword'] = array('keyword'=>$keyword);
		
		if($viewDataVars['keyword'])
		{
			$appHandler = $OS->getAppHandler('incomingkws');
			$db = $OS->getDb();
			$osProject = $OS->getProject();
			
			$query = "SELECT * FROM ".$appHandler->dbPrefix()."keywords WHERE project_id=? AND keyword=?";
			$dbresult_keywords = $db->query($query,array($osProject->id,$keyword));
			if ($row_keywords = $db->fetchRow($dbresult_keywords))
			{
				$stats=array();
				
				$day_start=strtotime(date('Y-m-d'));
				$from=$day_start-86400*9;
				$current=$from;
				$to=$day_start;
				
				$viewDataVars['keyword_url']=$OS->getConfigVar('root_url')."/livedash/index.php#apps/incomingkws/view_keyword/keyword_id={$row_keywords['id']}";
				
				while ($current<=$to)
				{
					$stats[date('Y-m-d',$current)]=0;
					$current+=86400;
				}
				
				$has_data=false;
				
				$query = "SELECT * FROM ".$appHandler->dbPrefix()."stats_keyword WHERE keyword_id=? AND stats_d>=?";
				$dbresult_stats=$db->query($query,array($row_keywords['id'],date('Y-m-d',$from)));
				while ($row_stats=$db->fetchRow($dbresult_stats))
				{
					$stats[$row_stats['stats_d']]=$row_stats['visits'];
					$has_data=true;
				}
				
				if($has_data)
				{
					$viewDataVars['stats'] = $stats;	
				}
			}			
		}
		

		return $viewDataVars;
	}
	
	public function render()
	{
		$OS = getOS();
		
		$tplVars = array();
		
		$headContents = array();
		
		$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
		
		$viewData = $this->buildViewData();
		
		$tplVars['keyword_url']=false;
		
		if($viewData['keyword'])
		{
			$tplVars['keyword']=$viewData['keyword']['keyword'];
			
			$chartColors = array(
				'green'=>'#27ae60',
				'blue'=>'#3498db',
				'orange'=>'#d35400',
				'red'=>'#c13a32'
			);
			
			if (isset($viewData['keyword_url']))
			{
				$tplVars['keyword_url']=$viewData['keyword_url'];
			}
	
			if(isset($viewData['stats']))
			{
				$day_index=0;
				$chartValues=array(); $chartTooltips=array(); $chartLabels=array();
				foreach ($viewData['stats'] as $day=>$visits)
				{
					$chartValues[]=$visits;
					if ($day_index%3==0)
					{
						$chartLabels[]=date('d M',strtotime($day));
					}
					else
					{
						$chartLabels[]=false;
					}
					$chartTooltips[] = date('d M',strtotime($day))."\n{$visits} "._("visits");
					$day_index++;
				}
				
				$length=count($chartValues);
				$difs_sum=0;
				for ($i=1;$i<=$length-1;$i++)
				{
					$difs_sum+=($chartValues[$i]-$chartValues[$i-1]);
				}
				$heads_dif=abs($chartValues[$length-1]-$chartValues[0]);
				
				if ($difs_sum>0)
				{
					if ($heads_dif>abs(round($chartValues[0]/10)))
					{
						$color='green';
					}
					else
					{
						$color='blue';
					}
				}
				elseif ($difs_sum==0)
				{
					$color='blue';
				}
				elseif ($difs_sum<0)
				{
					if ($heads_dif>abs(round($chartValues[0]/10)))
					{
						$color='red';
					}
					else
					{
						$color='orange';
					}
				}
				
				$chartOptions = array(
					'values'=>array_values($chartValues),
					'labels'=>$chartLabels,
					'tooltips'=>$chartTooltips,
					'fill'=>true,
					'normalize'=>true,
					'color'=>$chartColors[$color]
				);
				
				$osCharts=getOS()->getCharts();
				$chartData = $osCharts->getLineChart($chartOptions);
				
				$tplVars['chart_html'] = $chartData['html'];
				
				$headContents = array_merge($headContents, $chartData['js']);				
			}
		}
		
		
		$tplVars['settings_url'] = $osWidgetPlugin->getWidgetActionUrl('settings');
		
		
		$tpl = $OS->getTemplate();
		
		$tpl->setHeadContents($headContents);
		
		return $tpl->fetchTemplate('mainview', $tplVars);
	}
}
?>