<?php
class OS_WIDGET_watchkw_settingsView
{
	private $requestParams;
	
	public function __construct()
	{
		$this->processRequest();
	}
	
	public function processRequest()
	{
		//handle get & post requests
		$OS = getOS();
		$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
		
		$this->requestParams = $_POST;
		
		if ($_SERVER['REQUEST_METHOD']=='POST')
		{
			if (empty($this->requestParams['keyword_box']))
			{
				$OS->addFieldError(_("Keyword missing"),'keyword');
			}
			else
			{
				$this->requestParams['keyword_box'] = trim($this->requestParams['keyword_box']);
				
				if (strlen($this->requestParams['keyword_box'])<3)
				{
					$OS->addFieldError(_("Keyword too short. Minimum length: 3 chars"),'keyword');
				}
			}
			
			if (!isset($OS->errorMessages))
			{
				$settings=array(
					'keyword'=>array('type'=>'str','value'=> $this->requestParams['keyword_box'])
				);
				
				if ($osWidgetPlugin->saveWidgetSettings($settings))
				{
					return $OS->redirectTO($osWidgetPlugin->getWidgetActionUrl('view').'&cache_time=1',true);
					break;
				}
				else
				{
					$OS->addBoxError(_("Unable to save widget settings"));
				}
			}
		}
		else
		{
			$this->requestParams['keyword_box'] = $osWidgetPlugin->getWidgetSetting('keyword');
		}		
	}
	
	public function render()
	{
		$OS = getOS();
		
		$osWidgetPlugin = $OS->getWidgetHandler()->getWidgetPlugin();
		
		$tplVars = array();
		
		$tplVars['keyword'] = (isset($this->requestParams['keyword_box']) ? $this->requestParams['keyword_box'] : '');

		$formUrl = $osWidgetPlugin->getWidgetActionUrl('settings');
		
		//$formUrl = str_replace('/widget.php', '/widget2.php', $formUrl);
		
		$tplVars['formUrl'] = $formUrl;
		
		
		$tpl = $OS->getTemplate();
		
		return $tpl->fetchTemplate('settings', $tplVars);
	}
}
?>