<?php
class OS_WIDGETVIEW_WebsiteAuditEvo_Main extends OS_WidgetViewBase
{
	public function __construct(){}
	
	public function processRequest()
	{
		//handle get & post requests
	
	}
	
	public function buildViewData()
	{
		$OS = getOS();
		
		$viewDataVars = array();
		
		$project = $OS->getProject();
		
		$appHandler = $OS->getAppHandler('websiteaudit');
		
		$ops=OS_APP_WebsiteAudit_ReportOperations::get_instance();
		
		if ($reports=$ops->getLatestReports($project->id,10) AND count($reports)>1)
		{
			foreach ($reports as $report)
			{
				$viewDataVars['stats'][date('Y-m-d',strtotime($report->status_dt))]=$report->grade;
			}
			
			$viewDataVars['stats']=array_reverse($viewDataVars['stats'],true);
		}
		else
		{
			$viewDataVars['stats']=false;
		}
		
		return $viewDataVars;
	}
	
	public function render()
	{
		$OS=getOS();
		
		$tplVars=$this->buildViewData();
		
		if ($tplVars['stats'])
		{
			$osCharts = $OS->getCharts();
			
			$day_index=0;
			foreach ($tplVars['stats'] as $day=>$grade)
			{
				$chartValues[]=$grade;
				if ($day_index%3==0)
				{
					$chartLabels[]=date('d M',strtotime($day));
				}
				else
				{
					$chartLabels[]=false;
				}
				$chartTooltips[]=date('d M',strtotime($day))."\n"._("Grade").": {$grade}";
				$day_index++;
			}
			
			$chartOptions=array(
				'values'=>array_values($chartValues),
				'labels'=>$chartLabels,
				'tooltips'=>$chartTooltips,
				'fill'=>true,
				'normalize'=>true
			);
			
			$chartOptions=array(
				'values'=>array_values($chartValues),
				'labels'=>$chartLabels,
				'tooltips'=>array_values($chartTooltips),
				'fill'=>true,
				'normalize'=>true
			);
			
			$chartData = $osCharts->getLineChart($chartOptions);
			
			$tplVars['chart']=$chartData['html'];
		}
		else
		{
			$tplVars['chart']=false;
		}
		
		$tpl=$OS->getTemplate();
		
		if ($tplVars['chart'])
		{
			$tpl->setHeadContents($chartData['js']);
		}
		
		return $tpl->fetchTemplate('view',$tplVars);
	}
}
?>