<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

class OS_installStep6
{
	private static $_instance;
	
	
	//os installStep6 constructor
	public function __construct()
	{
	
	}
	
	public static function &get_instance()
	{
		if( !self::$_instance  )
		{
			self::$_instance = new OS_installStep6();
		}
		return self::$_instance;
	}
	
	public function processRequest()
	{
		$submitData = array();
		
		return $submitData;
	}
	
	public function prepareStepDetails()
	{
		$stepDetails = array(); 
		
		$OS = getOS();
		
		$OSInstaller = getOSInstaller();
		
		$installType = $OSInstaller->getInternalOption('install_type');
		
		$installParams = $OSInstaller->getInstallParams();
		
		//os Dabase Creation Section
		
	    if($installType == 'install')
	    {
	    	$stepInstallParams = $installParams[3];	
	    }
	    elseif($installType == 'update')
	    {
	    	$stepInstallParams = array(
		    	'db_driver' => $OS->getConfigVar('db_driver'),
		    	'db_host' => $OS->getConfigVar('db_hostname'),
		    	'db_name' => $OS->getConfigVar('db_name'),
		    	'db_user' => $OS->getConfigVar('db_username'),
		    	'db_password' => $OS->getConfigVar('db_password')
		    	);
	    				
	    	$stepInstallParams['db_tbl_prefix'] = $OS->getConfigVar('db_prefix');
	    	$stepInstallParams['create_tables'] = "Y";
	    }
	    

	    if($stepInstallParams['create_tables'] == "Y")
		{
		    $dbConnectionDetails = array(
		    	'db_driver' => $stepInstallParams['db_driver'],
		    	'db_hostname' => $stepInstallParams['db_host'],
		    	'db_name' => $stepInstallParams['db_name'],
		    	'db_username' => $stepInstallParams['db_user'],
		    	'db_password' => $stepInstallParams['db_password']
		    	);
			
		    $db = $OS->getDb();
		    $dbPrefix = $db->dbPrefix();
		    $osDbOps = $OS->getDbOps();
		    $osUtils = $OS->getUtils();
			
			$db->addDBConnection('default',$dbConnectionDetails);
			$db->setCurrentDbConnection('default');			
		    $db->setDbPrefix($stepInstallParams['db_tbl_prefix']);

		    //compare local database with SQL our schema
		    
			//get schema sql info
			$schemaPath = os_join_path($OSInstaller->getInternalOption('os_install_path'), "schema/sql_schema.php");
			
			$sqlBatchResponse = $osDbOps->compareCoreTablesBySchema($schemaPath);
			
			$stepDetails['sqlBatchTests'] = array();
			foreach($sqlBatchResponse as $tblName => $operationTypes)
			{
				$fullTblName = $dbPrefix.$tblName;
				
				foreach($operationTypes as $operationType => $operations)
				{
					if(!empty($operations['sql']))
					{
						foreach($operations['sql'] as $index => $queryString)
						{
							$stepDetails['sqlBatchTests'][] = array('message'=> $operations['details'][$index]); 
						}
					}
				}
			}
		}
	    
	    
		if(isset($installParams[4]))
		{
			$stepInstallParams = $installParams[4];
			
			$stepDetails['userDetailsResponse'] = array(
				'username' => $stepInstallParams['username'],
				'email' => $stepInstallParams['email']
				);
		}
		
		if(isset($installParams[5]))
		{
			$stepDetails['projectDetailsResponse'] = $installParams[5];	
		}
		
		return $stepDetails;
	}
	
	public function render()
	{
		$OS = getOS();
		
		$tpl = $OS->getTemplate();
		
		return $tpl->getTemplate('installstep6');
	}
}
?>