<div class="section-center col_6">
	<div class='simple-box'>
		<div class='title'>{t}Database Information{/t}</div>
		<div class='content'>
	
				<div class="col_12">
					<p>{t}Make sure you have created your database and granted full privileges to a user to use that database.{/t}</p>
					<p>{t}For MySQL, use the following{/t}:</p>
					<p>{t}Log in to mysql from a console and run the following commands{/t}:</p>
					
					<ol>
						<li>create opens database; ({t}use whatever name you want here but make sure to remember it, you'll need to enter it on this page{/t})</li>
						<li>grant all privileges on opens.* to os_user@localhost identified by 'os_pass';</li>
					</ol>
				</div>
					
				<div class="clear"></div>
				
				
				<div class="col_4">
					<label for="db_driver_box">{t}Database type{/t}</label>
				</div>
				
				<div class="col_8">
					<select name="db_driver_box" id="db_driver_box"><option>-- {t}Choose{/t} --</option>
						{foreach from=$tvars.stepDetails.dbDrivers key=cdriver  item=cdata}
							<option value='{$cdriver}' {if $cdata.is_selected} selected {/if}>{$cdata.name}</option>
						{/foreach}
					</select>
				</div>
				<div class="clear"></div>
					
			
				<div class="col_4">
					<label for="db_host_box">{t}Database host address{/t}</label>
				</div>
				
				<div class="col_8">
					<input type="text" name="db_host_box"  id="db_host_box" value="{$tvars.stepDetails.db_host}">
				</div>
				<div class="clear"></div>
			
			
				<div class="col_4">
					<label for="db_name_box">{t}Database Name{/t}</label>
				</div>
				
				<div class="col_8">
					<input type="text" name="db_name_box"  id="db_name_box" value="{$tvars.stepDetails.db_name}">
				</div>
				<div class="clear"></div>
			
			
				<div class="col_4">
					<label for="db_user_box">{t}Username{/t}</label>
				</div>
				
				<div class="col_8">
					<input type="text" name="db_user_box"  id="db_user_box" value="{$tvars.stepDetails.db_user}">
				</div>
				<div class="clear"></div>
			
			
				<div class="col_4">
					<label for="db_password_box">{t}Password{/t}</label>
				</div>
				
				<div class="col_8">
					<input type="password" name="db_password_box"  id="db_password_box" value="{$tvars.stepDetails.db_password}">
				</div>
				<div class="clear"></div>
			
			
				<div class="col_4">
					<label for="db_port_box">{t}Database Port{/t}</label>
				</div>
				
				<div class="col_8">
					<input type="text" name="db_port_box"  id="db_port_box" value="{$tvars.stepDetails.db_port}">
					<p>{t}If you don't know use default settings{/t}</p>
				</div>
				<div class="clear"></div>
			
			
				<div class="col_4">
					<label for="db_tbl_prefix_box">{t}Table Prefix{/t}</label>
				</div>
				
				<div class="col_8">
					<input type="text" name="db_tbl_prefix_box"  id="db_tbl_prefix_box" value="{$tvars.stepDetails.db_tbl_prefix}">
				</div>
				<div class="clear"></div>
			
			
				<div class="col_4">
					<label for="create_tables_box">{t}Create Tables{/t}</label>
				</div>
				
				<div class="col_8">
					<input type="checkbox" name="create_tables_box"  id="create_tables_box" value="Y" {if $tvars.stepDetails.create_tables == "Y"}checked{/if}>
				</div>
				
				<div class='clear'></div>
		</div>
	</div>
</div>	



<div class="section-center col_6">
	<div class='simple-box'>
		<div class='title'>{t}Configuration Details{/t}</div>
		<div class='content'>
	
			<div class="col_12 center">
				<p>{t}Now let's continue to setup your configuration file, we already have most of the stuff we need.{/t}</p>
				<p>{t}Chances are you can leave all these values alone, so when you are ready, click Continue.{/t}</p>
			</div>
		
			<div class="col_4">
				<label for="root_url_box">{t}OpenS Document root (as seen from the webserver){/t}</label>
			</div>
			
			<div class="col_8">
				<input type="text" name="root_url_box"  id="root_url_box" value="{$tvars.stepDetails.root_url}" class="col_8">
			</div>
			<div class="clear"></div>
			
			<div class="col_4">
				<label for="root_path_box">{t}Path to the Document root{/t}</label>
			</div>
			
			<div class="col_8">
				<input type="text" name="root_path_box"  id="root_path_box" value="{$tvars.stepDetails.root_path}" class="col_8">
			</div>
			<div class="clear"></div>
		
		
			<div class="col_4">
				<label for="admin_language_box">{t}Default language for the inside zone.{/t}</label>
			</div>
			
			<div class="col_8">
				<select name='admin_language_box'><option>-- {t}Choose{/t} --</option>
					{foreach from=$tvars.stepDetails.lngList key=lng  item=cdata}
						<option value='{$lng}' {if $cdata.is_selected} selected {/if}>{$cdata.name}</option>
					{/foreach}
				</select>
			</div>
			
			<div class='clear'></div>
		</div>
	</div>
</div>