<?php
class OS_AppDeveloper
{
	private static $_instance;
	
	public $id;
	
	public $user_id;
	
	public $category;
	
	public $name;
	
	public $title;
	
	public $description;
	
	public $version;
	
	public $webscope;
	
	public $status;
	
	public $status_dt;
	
	public $status_ip;
	
	public $status_by;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	private function setInitialValues()
	{
		$initialValues = array(
			'id' => -1,
			'category'=> "",
			'name' => "",
			'title' => "",
			'description' => "",
			'version' => "",
			'status' => ""
			);
			
		$this->set($initialValues);	
	}
	
	public static function &get_instance()
	{
		if( !is_object(self::$_instance) )
		{
			self::$_instance = new OS_AppDeveloper();
		}
		return self::$_instance;
	}
	
	public function set($app_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($app_data[$key]))
			{
				$this->$key = $app_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppDeveloperOps();
			
			if ($app_data=$ops->getAppByID($this->id))
			{
				$this->set(get_object_vars($app_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function loadByName()
	{
		$result = false;
		
		if ($this->name)
		{
			$ops=getOS()->getAppDeveloperOps();
			
			if ($app_data=$ops->getAppByName($this->name))
			{
				$this->set(get_object_vars($app_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result = false;
		
		$ops = getOS()->getAppDeveloperOps();
		
		if ($this->id > -1)
		{
			$result = $ops->updateApp($this);
			
			$ops->updateAppManifest($this);
		}
		else
		{
			$newid = $ops->insertApp($this);
			
			if ($newid > -1)
			{
				$this->id = $newid;
				
				$ops->createAppStructure($this);
				
				$result = true;
			}

		}

		return $result;
	}
	
	public function delete()
	{
		$result=false;
		
		if ($this->id > -1)
		{
			$ops=getOS()->getAppDeveloperOps();
			
			$result=$ops->deleteApp($this);
		}
		
		return $result;
	}
	
	public function finish()
	{
		$result=false;
		
		if ($this->id > -1 AND $this->status=='W')
		{
			$ops=getOS()->getAppDeveloperOps();
			
			$result=$ops->markAppAsFinished($this);
		}
		
		return $result;
	}
	
	public function work()
	{
		$result=false;
		
		if ($this->id > -1 AND $this->status=='F')
		{
			$ops=getOS()->getAppDeveloperOps();
			
			$result=$ops->markAppAsWork($this);
		}
		
		return $result;
	}
}
?>