<?php
/*
 * Created on Mar 12, 2012
 *
 * Owner: George
 */
class OS_AppHandlerOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if( !is_object(self::$_instance) )
		{
			self::$_instance = new OS_AppHandlerOperations();
		}
		return self::$_instance;
	}
	
	//get apps ids links by User ID
	public function getAppsByUserID($user_id,$project_id=false)
	{
		$result =  array();
		
		if($user_id >= 1)
		{
			$db = getOS()->getDb();
			
			$query = "SELECT * FROM ".$db->dbPrefix()."apps_users WHERE `user_id`= ?".($project_id?" AND `project_id`=?":'');
			$dbresult = $db->query($query,($project_id?array($user_id,$project_id):array($user_id)));
			while($row = $db->fetchRow($dbresult))
			{
				$result[$row['app_id']] = $row;
			}
		}
		
		return $result;		
	}
	
	public function getAppHandlersByUserID($user_id,$project_id=false)
	{
		$result =  array();
		
		if($user_id >= 1)
		{
			$db = getOS()->getDb();
			
			$query = "SELECT * FROM ".$db->dbPrefix()."apps_users WHERE `user_id`= ?".($project_id?" AND `project_id`=?":'');
			$dbresult = $db->query($query,($project_id?array($user_id,$project_id):array($user_id)));
			while($row = $db->fetchRow($dbresult))
			{
				$row['name']=$row['app_name'];
				$row['title']=$row['app_title'];
				$oneHandler=new OS_AppHandler();
				$oneHandler->set($row);
				$result[$row['id']]=$oneHandler;
			}
		}
		
		return $result;
	}
	
	//get users ids links by App ID
	public function getUsersByAppID($app_id)
	{
		$result =  array();
		
		if($app_id >= 1)
		{
			$db = getOS()->getDb();
			
			$query = "SELECT * FROM ".$db->dbPrefix()."apps_users WHERE `app_id`= ?";
			$dbresult = $db->query($query,array($app_id));
			while($row = $db->fetchRow($dbresult))
			{
				$result[] = $row['user_id'];
			}
		}
		
		return $result;		
	}
	
	public function getAppHandlerByID($handler_id)
	{
		$result=false;
		
		if ($handler_id >= 1)
		{
			$db=getOS()->getDb();
			$user=getOS()->getUser();
			$user_id=$user->id;
			
			$query = "SELECT * FROM ".$db->dbPrefix()."apps_users WHERE `id`=? AND `user_id`=?";
			$dbresult = $db->query($query,array($handler_id,$user_id));
			if ($row = $db->fetchRow($dbresult))
			{
				$row['name']=$row['app_name'];
				$row['title']=$row['app_title'];
				$result=new OS_AppHandler();
				$result->set($row);
			}
		}
		
		return $result;
	}
	
	public function getAppHandlerByAppName($app_name)
	{
		$result=array();
		
		if ($app_name != '')
		{
			$db=getOS()->getDb();
			$user=getOS()->getUser();
			$project=getOS()->getProject();
			$user_id=$user->id;
			
			$query = "SELECT * FROM ".$db->dbPrefix()."apps_users WHERE `app_name`=? AND `user_id`=? AND `project_id`=?";
			$dbresult = $db->query($query,array($app_name,$user_id,$project->id));
			if ($row = $db->fetchRow($dbresult))
			{
				$row['name']=$row['app_name'];
				$row['title']=$row['app_title'];
				$result=new OS_AppHandler();
				$result->set($row);
			}
		}
		
		return $result;
	}
	
	//get apps ids links by Project ID
	public function getAppHandlersByProjectID($project_id)
	{
		$result =  array();
		
		if($project_id >= 1)
		{
			$db = getOS()->getDb();
			
			$query = "SELECT * FROM ".$db->dbPrefix()."apps_users WHERE `project_id`= ?";
			$dbresult = $db->query($query,array($project_id));
			while($row = $db->fetchRow($dbresult))
			{
				if(!isset($result[$row['app_name']]))
				{
					$oneApp = new OS_AppHandler();
					
					$row['name'] = $row['app_name'];
					$row['title'] = $row['app_title'];
					
					$oneApp->set($row);
					
					$result[$row['app_name']] = $oneApp;
				}
			}
		}
		
		return $result;		
	}	
	
	public function getAppHandlerByAppID($app_id)
	{
		$result=array();
		
		if ($app_id >= 1)
		{
			$db=getOS()->getDb();
			$user=getOS()->getUser();
			$project=getOS()->getProject();
			$user_id=$user->id;
			
			$query = "SELECT * FROM ".$db->dbPrefix()."apps_users WHERE `app_id`=? AND `user_id`=? AND `project_id`=?";
			$dbresult = $db->query($query,array($app_id,$user_id,$project->id));
			if ($row = $db->fetchRow($dbresult))
			{
				$row['name']=$row['app_name'];
				$row['title']=$row['app_title'];
				$result=new OS_AppHandler();
				$result->set($row);
			}
		}
		
		return $result;
	}
	
	public function saveAppHandler($appHandler)
	{
		$result=false;
		
		if ($testHandler=$this->getAppHandlerByID($appHandler->id))
		{
			$db=getOS()->getDb();
			$user=getOS()->getUser();
			
			$time = $db->DBTimeStamp(time());
			
			$query="UPDATE ".$db->dbPrefix()."apps_users SET app_title=?,status=?,status_dt=?,status_ip=?,status_by=? WHERE id=?";
			$dbresult = $db->query($query,array($appHandler->title,$appHandler->status,$time,$_SERVER['REMOTE_ADDR'],$user->id,$appHandler->id));
			$result=true;
		}
		
		return $result;
	}
	
	public function moveUserApp($old_position,$new_position)
	{
		$result=false;

		if ($old_position<$new_position)
		{
			$from=$old_position+1;
			$to=$new_position;
			$op='dec';
		}
		elseif ($old_position>$new_position)
		{
			$from=$new_position;
			$to=$old_position-1;
			$op='inc';
		}
		else
		{
			$op=false;
			$result=true;
		}
		
		if ($op)
		{
			$db=getOS()->getDb();
			$user=getOS()->getUser();
			$project=getOS()->getProject();
			
			$query="SELECT * FROM ".$db->dbPrefix()."apps_users WHERE user_id=? AND project_id=? AND position=?";
			$dbresult=$db->query($query,array($user->id,$project->id,$old_position));
			if ($movedAppRow=$db->fetchRow($dbresult))
			{
				$query="UPDATE ".$db->dbPrefix()."apps_users SET position=position".($op=='inc'?'+':'-')."1 WHERE user_id=? AND project_id=? AND position>=? AND position<=?";
				$dbresult=$db->query($query,array($user->id,$project->id,$from,$to));
				
				$query="UPDATE ".$db->dbPrefix()."apps_users SET position=? WHERE id=?";
				$dbresult=$db->query($query,array($new_position,$movedAppRow['id']));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function getAppPluginByName($appHandler)
	{
		if (!$appHandler->name)
		{
			return false;
		}
		
		$OS=getOS();
		$db=$OS->getDb();
		$appClass='OS_APP_'.strtolower($appHandler->name);
		
		$app=call_user_func(array($appClass,'get_instance'));
//		$app=$appClass::get_instance();
		
		$app_details=array(
			'id'=>$appHandler->id,
			'name'=>$appHandler->name,
			'title'=>$appHandler->title
		);

		return $app;
	}
	
	public function saveAppSettings($app,$settings)
	{
		$result=false;
		
		if ($this->removeAppSettings($app))
		{
			$db=getOS()->getDb();
			$user_id=getOS()->getUser()->id;
			$project_id=getOS()->getProject()->id;
			
			foreach ($settings as $var=>$details)
			{
				$query="INSERT INTO ".$db->dbPrefix()."apps_users_settings (app_id,user_id,project_id,handler_id,var,type,val_".$details['type'].") VALUES (?,?,?,?,?,?,?)";
				$dbresult=$db->query($query,array($app->app_id,$user_id,$project_id,$app->id,$var,$details['type'],$details['value']));
				
				if ($dbresult!==false)
				{
					$result[$var]=$details['value'];
				}
			}
		}
		
		return $result;
	}
	
	public function getAppSettings($app)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$user_id=getOS()->getUser()->id;
		
		$query="SELECT * FROM ".$db->dbPrefix()."apps_users_settings WHERE handler_id=? AND user_id=?";
		$dbresult=$db->query($query,array($app->id,$user_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$result[$row['var']]=$row['val_'.$row['type']];
		}
		
		return $result;
	}
	
	public function removeAppSettings($app)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$user_id=getOS()->getUser()->id;
		
		$query="DELETE FROM ".$db->dbPrefix()."apps_users_settings WHERE handler_id=? AND user_id=?";
		$dbresult=$db->query($query,array($app->id,$user_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function startUserApp($appHandler,$project_id,$user_id)
	{
		$result =  false;

		$db = getOS()->getDb();
		
		$app_ops=getOS()->getAppOps();

		$time = $db->DBTimeStamp(time());
		
		$app_id=$appHandler->app_id;
		
		if ($app_ops->isAvailableApp($app_id))
		{
			OS_Events::triggerEvent('beforeStartUserApp',array('app_name'=>$appHandler->name,'app_id'=>$app_id,'project_id'=>$project_id,'user_id'=>$user_id));
			
			$apps=$this->getAppsByUserID($user_id,$project_id);
			
			$newApp=false;
			
			if (!isset($apps[$app_id]))
			{
				//Check if app exists inside the project
				$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."apps_users WHERE project_id=? AND app_id=? LIMIT 1",array($project_id,$app_id));
				if (!$row=$db->fetchRow($dbresult))
				{
					$newApp=true;
				}
				
				$query="SELECT * FROM ".$db->dbPrefix()."apps_users WHERE user_id=? AND project_id=? ORDER BY position DESC LIMIT 1";
				$dbresult=$db->query($query,array($user_id,$project_id));
				if ($row=$db->fetchRow($dbresult))
				{
					$position=$row['position']+1;
				}
				else
				{
					$position=1;
				}
				$query = "INSERT INTO ".$db->dbPrefix()."apps_users (`project_id`,`user_id`,`app_id`,`app_name`,`app_title`,`position`,`insert_dt`,`insert_ip`,`insert_by`,`status`,`status_dt`,`status_ip`,`status_by`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
				$dbresult = $db->query($query, array($project_id, $user_id, $app_id, $appHandler->name, $appHandler->title, $position, $time, $_SERVER['REMOTE_ADDR'],$user_id, 'E', $time, $_SERVER['REMOTE_ADDR'], $user_id));
				
				if ($dbresult !== false)
				{
					$appStatsOps=getOS()->getAppStatsOps();
					$appStatsOps->log($app_id,$appHandler->name,'add');
					
					$oneUser=new OS_User();
					$oneUser->id=$user_id;
					
					if ($oneUser->load())
					{
						if ($availableWidgets=getOS()->getWidgetOps()->getAvailableWidgetsDetails())
						{
							$addedWidgets=getOS()->getWidgetHandlerOps()->getAddedWidgetsDetails($user_id,$project_id);
							
							$newAppWidgets=array();
							
							foreach ($availableWidgets as $widget_id=>$widget)
							{
								if (isset($widget['manifest']['dependencies'][$appHandler->name]) AND !isset($addedWidgets[$widget['name']]))
								{
									$newAppWidgets[$widget_id]=$widget;
								}
							}
														
							if ($newAppWidgets)
							{
								$firstSectionID=false;
								
								$ops=getOS()->getSectionOps();
								
								$temp=$ops->getSectionsByUserID($user_id);
								
								foreach ($temp as $section_id=>$section)
								{
									if ($section->project_id==$project_id)
									{
										$firstSectionID=$section_id;
										break;
									}
								}
								
								if ($firstSectionID)
								{
									if ($availableApps=$this->getAppsByUserID($user_id))
									{
										$availableAppsNames=array();
										
										foreach ($availableApps as $app_id=>$app)
										{
											$availableAppsNames[$app['app_name']]=true;
										}
										
										foreach ($newAppWidgets as $widget_id=>$widget)
										{
											$can_add=true;
											
											foreach ($widget['manifest']['dependencies'] as $app=>$version)
											{
												if (!isset($availableAppsNames[$app]))
												{
													$can_add=false;
													break;
												}
											}
											
											if ($can_add)
											{
												$column_id=$ops->getEmptiestColumn($firstSectionID,$user_id,$project_id);
												
												$osWidgetHandler = new OS_WidgetHandler();
												
												$osWidgetHandler->main_widget_id = $widget_id;
												$osWidgetHandler->project_id = $project_id;
												$osWidgetHandler->user_id = $user_id;
												$osWidgetHandler->section_id = $firstSectionID;
												$osWidgetHandler->column_id = $column_id;
												$osWidgetHandler->position = $ops->getNextPosition($firstSectionID,$column_id);
												$osWidgetHandler->background_color = 'white';
												$osWidgetHandler->collapsed = "";
												$osWidgetHandler->name = $widget['name'];
												$osWidgetHandler->title = $widget['title'];
												
												$osWidgetHandler->save();
												$position++;
											}
										}
									}
								}
							}
						}					
					}
					
					$result = true;
				}
			}
			elseif ($apps[$app_id]['status']!='E')
			{
				$query = "UPDATE ".$db->dbPrefix()."apps_users SET status=?,status_dt=?,status_ip=?,status_by=? WHERE project_id=? AND user_id=? AND app_id=?";
				$dbresult = $db->query($query, array('E',$time,$_SERVER['REMOTE_ADDR'],$user_id,$project_id,$user_id,$app_id));
				
				if ($dbresult !== false)
				{
					$appStatsOps=getOS()->getAppStatsOps();
					$appStatsOps->log($app_id,$appHandler->name,'start');
					
					$result = true;
				}
			}
			
			if ($result)
			{
				OS_Events::triggerEvent('afterStartUserApp',array('app_name'=>$appHandler->name,'app_id'=>$app_id,'project_id'=>$project_id,'user_id'=>$user_id));
				
				if ($newApp)
				{
					OS_Events::triggerEvent('appAddedToProject',array('app_name'=>$appHandler->name,'app_id'=>$app_id,'project_id'=>$project_id));
				}
			}
		}
		
		return $result;
	}
	
	public function stopUserApp($appHandler,$project_id,$user_id)
	{
		$result =  false;

		$db = getOS()->getDb();
		
		$app_ops=getOS()->getAppOps();

		$time = $db->DBTimeStamp(time());
		
		$app_id=$appHandler->app_id;
		
		if ($app_ops->isAvailableApp($app_id))
		{
			$apps=$this->getAppsByUserID($user_id,$project_id);
			 
			if (isset($apps[$app_id]) && $apps[$app_id]['status']=='E')
			{
				OS_Events::triggerEvent('beforeStopUserApp',array('app_name'=>$appHandler->name,'app_id'=>$app_id,'project_id'=>$project_id,'user_id'=>$user_id));
				
				$query = "UPDATE ".$db->dbPrefix()."apps_users SET status=?,status_dt=?,status_ip=?,status_by=? WHERE project_id=? AND user_id=? AND app_id=?";
				$dbresult = $db->query($query, array('D',$time,$_SERVER['REMOTE_ADDR'],$user_id,$project_id,$user_id,$app_id));
				
				if ($dbresult !== false)
				{
					OS_Events::triggerEvent('afterStopUserApp',array('app_name'=>$appHandler->name,'app_id'=>$app_id,'project_id'=>$project_id,'user_id'=>$user_id));
					
					$appStatsOps=getOS()->getAppStatsOps();
					$appStatsOps->log($app_id,$appHandler->name,'stop');
					
					$result = true;
				}
			}
		}
		
		return $result;
	}
	
	public function removeUserApp($appHandler,$project_id,$user_id)
	{
		$result =  false;

		$db = getOS()->getDb();

		$app_ops=getOS()->getAppOps();

		$time = $db->DBTimeStamp(time());
		
		$app_id=$appHandler->app_id;
		
		if ($app_ops->isAvailableApp($app_id))
		{
			$apps=$this->getAppsByUserID($user_id,$project_id);
			 
			if (isset($apps[$app_id]))
			{
				OS_Events::triggerEvent('beforeRemoveUserApp',array('app_name'=>$appHandler->name,'app_id'=>$app_id,'project_id'=>$project_id,'user_id'=>$user_id));
				
				$query = "DELETE FROM ".$db->dbPrefix()."apps_users WHERE project_id=? AND user_id=? AND app_id=?";
				$dbresult = $db->query($query, array($project_id,$user_id,$app_id));
				
				if ($dbresult !== false)
				{
					OS_Events::triggerEvent('afterRemoveUserApp',array('app_name'=>$appHandler->name,'app_id'=>$app_id,'project_id'=>$project_id,'user_id'=>$user_id));
					
					$appStatsOps=getOS()->getAppStatsOps();
					$appStatsOps->log($app_id,$appHandler->name,'remove');
					
					$osWidgetandlerOps=getOS()->getWidgetHandlerOps();
					
					if ($addedWidgets=$osWidgetandlerOps->getAddedWidgetsDetails($user_id,$project_id))
					{
						$appWidgets=array();
						
						foreach ($addedWidgets as $widget_name=>$widget)
						{
							if (in_array($appHandler->name,$widget['apps']))
							{
								$appWidgets[$widget['id']]=$widget;
							}
						}
						
						if ($appWidgets)
						{
							foreach ($appWidgets as $widget_id=>$widget)
							{
								$oneWidget=new OS_WidgetHandler();
								$oneWidget->id=$widget_id;
								
								if ($oneWidget->load())
								{
									if ($oneWidget->delete())
									{
										$osWidgetandlerOps->refreshWidgetsPositions($oneWidget);
									}
								}
							}
						}
					}
					
					$result = true;
				}
			}
		}
		
		return $result;
	}
	
	public function removeUsersAppByAppID($app_id)
	{
		$result=false;
		
		$db = getOS()->getDb();
		
		$user_ids=$this->getUsersByAppID($app_id);
		
		$dbresult=$db->query("DELETE FROM ".$db->dbPrefix()."apps_users_settings WHERE app_id=?",array($app_id));
		
		if ($dbresult!==false)
		{
			$dbresult=$db->query("DELETE FROM ".$db->dbPrefix()."apps_users WHERE app_id=?",array($app_id));
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
}
?>