<?php
class OS_AppProposed
{
	private static $_instance;
	
	public $id;
	
	public $category;
	
	public $name;
	
	public $title;
	
	public $description;
	
	public $version;
	
	public $webscope;
	
	public $status;
	
	public $status_reason;
	
	public $status_dt;
	
	public $status_ip;
	
	public $status_by;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_AppProposed();
		}
		
		return self::$_instance;
	}
	
	public function set($app_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($app_data[$key]))
			{
				$this->$key = $app_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getAppProposedOps();
			
			if ($app_data=$ops->getAppProposedByID($this->id))
			{
				$this->set(get_object_vars($app_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function loadByName()
	{
		$result = false;
		
		if ($this->name)
		{
			$ops=getOS()->getAppProposedOps();
			
			if ($app_data=$ops->getAppProposedByName($this->name))
			{
				$this->set(get_object_vars($app_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result = false;
		
		$ops = getOS()->getAppProposedOps();
		
		if ($this->id)
		{
			$result = $ops->updateAppProposed($this);
		}
		else
		{
			$newid = $ops->insertAppProposed($this);

			if ($newid)
			{
				$this->id = $newid;
				
				$result = true;
			}
		}

		return $result;
	}
	
	public function delete()
	{
		$result=false;
		
		if ($this->id > -1)
		{
			$ops=getOS()->getAppProposedOps();
			
			$result=$ops->deleteAppProposed($this);
		}
		
		return $result;
	}
	
	public function deny()
	{
		$result=false;
		
		if ($this->id > -1)
		{
			$ops=getOS()->getAppProposedOps();
			
			$result=$ops->denyAppProposed($this);
		}
		
		return $result;
	}
	
	public function approve()
	{
		$result=false;
		
		if ($this->id > -1)
		{
			$ops=getOS()->getAppProposedOps();
			
			$result=$ops->approveAppProposed($this);
		}
		
		return $result;
	}
}
?>