<?php
class OS_AppProposedOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_AppProposedOperations();
		}
		
		return self::$_instance;
	}
	
	public function getAppsProposed()
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."apps_proposed ORDER BY insert_dt ASC";
		$dbresult=$db->query($query);
		while ($row=$db->fetchRow($dbresult))
		{
			$oneApp=new OS_AppProposed();
			$oneApp->set($row);
			
			$result[$row['id']]=$oneApp;
		}
		
		return $result;
	}
	
	public function getAppProposedByID($proposed_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."apps_proposed WHERE id=?";
		$dbresult=$db->query($query,array($proposed_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_AppProposed();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getAppProposedByName($proposed)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."apps_proposed WHERE name=?";
		$dbresult=$db->query($query,array($proposed));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_AppProposed();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function insertAppProposed($proposed)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$time = $db->DBTimeStamp(time());
		$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
		$user_id=getOS()->getUser()->id;
		
		$query="INSERT INTO ".$db->dbPrefix()."apps_proposed (name,title,description,category,webscope,version,insert_dt,insert_ip,insert_by,status,status_dt,status_ip,status_by) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";
		$dbresult=$db->query($query,array($proposed->name,$proposed->title,$proposed->description,$proposed->category,$proposed->webscope,$proposed->version,$time,$ip,$user_id,'W',$time,$ip,$user_id));

		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateAppProposed($proposed)
	{
		$result=false;

		$db=getOS()->getDb();
		$time = $db->DBTimeStamp(time());
		$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
		$user_id=getOS()->getUser()->id;
		
		$query="UPDATE ".$db->dbPrefix()."apps_proposed SET name=?,title=?,description=?,category=?,webscope=?,version=?,updates=updates+1,update_dt=?,update_ip=?,update_by=? WHERE id=?";
		$dbresult=$db->query($query,array($proposed->name,$proposed->title,$proposed->description,$proposed->category,$proposed->webscope,$proposed->version,$time,$ip,$user_id,$proposed->id));

		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteAppProposed($proposed)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="DELETE FROM ".$db->dbPrefix()."apps_proposed WHERE id=?";
		$dbresult=$db->query($query,array($proposed->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function denyAppProposed($proposed)
	{
		$result=false;
		
		if ($this->deleteAppProposed($proposed))
		{
			$appDev=getOS()->getAppDev();
			
			$appDev->name=$proposed->name;
			
			if ($appDev->loadByName())
			{
				$appDev->status='R';
				$appDev->status_by=getOS()->getUser()->id;
				
				$result=$appDev->save();
			}
			else
			{			
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function approveAppProposed($proposed)
	{
		$result=false;

		//TODO: complete $appstore_details & activate!
		
		$appDev=getOS()->geAppDeveloper;
		
		$appDev->name=$proposed->name;
		
		if ($appDev->loadByName)
		{
			$appDevOps=getOS()->getAppDeveloperOps();
			
			if ($buildPath=$appDevOps->getAppBuildPath($appDev,$proposed->version) AND file_exists($buildPath))
			{
				$appstoreApi=getOS()->getAppStoreApi();
				
				$appstore_details=array(
					'app_name'=>$proposed->name,
					'kit_contents'=>base64_encode(file_get_contents($buildPath))
				);
				
				$appstoreApi->uploadApp($appstore_details);
				
				if ($appStoreApi->success)
				{
					if ($this->deleteAppProposed($proposed))
					{
						$appDev=getOS()->getAppDev();
						
						$appDev->name=$proposed->name;
						
						if ($appDev->loadByName())
						{
							$appDev->status='A';
							$appDev->status_by=getOS()->getUser()->id;
							
							$result=$appDev->save();
						}
						else
						{
							$result=true;
						}
					}
				}
			}
		}
		
		return $result;
	}
}
?>