<?php
class OS_AppStats
{
	private static $_instance;
	
	public $id;
	
	public $app_id;
	
	public $app_name;
	
	public $stats_d;
	
	public $opens;
	
	public $starts;
	
	public $stops;
	
	public $adds;
	
	public $removes;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if( !is_object(self::$_instance) )
		{
			self::$_instance = new OS_AppStats();
		}
		return self::$_instance;
	}
	
	public function set($stats_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($stats_data[$key]))
			{
				$this->$key = $stats_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function loadByDate()
	{
		$result=false;
		
		if ($this->app_id AND $this->stats_d)
		{
			$ops=getOS()->getAppStatsOps();
			
			if ($stats_data=$ops->getAppStatsByAppDate($this->app_id,$this->stats_d))
			{
				$this->set(get_object_vars($stats_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=true;
		
		$ops=getOS()->getAppStatsOps();
		
		if ($this->id)
		{
			$result=$ops->updateAppStats($this);
		}
		else
		{
			$new_id=$ops->insertAppStats($this);
			
			if ($new_id)
			{
				$this->id=$new_id;
				
				$result=true;
			}
		}
		
		return $result;
	}
}
?>