<?php
class OS_AppStatsOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_AppStatsOperations();
		}
		
		return self::$_instance;
	}
	
	public function getAppStats($app_id,$start_d=false)
	{
		$result=false;
		
		if (!$start_d)
		{
			$start_d=date('Y-m-d',time()-7*86400);
		}
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."apps_stats WHERE app_id=? AND stats_d>=?";
		$dbresult=$db->query($query,array($app_id,$start_d));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneDay=new OS_AppStats();
			$oneDay->set($row);
			
			$result[$row['id']]=$oneDay;
		}
		
		return $result;
	}
	
	public function getAppStatsDate($app_id,$stats_d)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."apps_stats WHERE app_id=? AND stats_d=?";
		$dbresult=$db->query($query,array($app_id,$stats_d));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_AppStats();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function insertAppStats($appStats)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$time = $db->DBTimeStamp(time());
		$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
		
		$query="INSERT INTO ".$db->dbPrefix()."apps_stats (app_id,app_name,stats_d,opens,starts,stops,adds,removes) VALUES (?,?,?,?,?,?,?,?)";
		$dbresult=$db->query($query,array($appStats->app_id,$appStats->app_name,$appStats->stats_d,$appStats->opens,$appStats->starts,$appStats->stops,$appStats->adds,$appStats->removes));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateAppStats($appStats)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$time = $db->DBTimeStamp(time());
		$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
		
		$query="UPDATE ".$db->dbPrefix()."apps_stats SET opens=?,starts=?,stops=?,adds=?,removes=? WHERE `id`=?";
		$dbresult=$db->query($query,array($appStats->opens,$appStats->starts,$appStats->stops,$appStats->adds,$appStats->removes,$appStats->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteAppStatsFull($app_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="DELETE FROM ".$db->dbPrefix()."apps_stats WHERE app_id=?";
		$dbresult=$db->query($query,array($app_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function log($app_id,$app_name,$action)
	{
		$result=false;
		
		$log_path=os_join_path(getOS()->getConfigVar('storage_path'),'app_stats.log');
		
		if ($file=fopen($log_path,'a+'))
		{
			$log_line="{$app_id}|{$app_name}|".time()."|{$action}\n";
			
			$result=fwrite($file,$log_line);
			
			fclose($file);
		}
		
		return $result;
	}
}
?>