<?php
class OS_Audit
{
	private static $_instance;
	
	public $id;
	public $type;
	public $message;
	public $occurances;
	public $last_dt;
	public $hour;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_Audit();
		}
		
		return self::$_instance;
	}
	
	public function set($app_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($app_data[$key]))
			{
				$this->$key = $app_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getAuditOps();
			
			if ($app_data=$ops->getAuditByID($this->id))
			{
				$this->set(get_object_vars($app_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result = false;
		
		$ops = getOS()->getAuditOps();
		
		if ($this->id)
		{
			$result = $ops->updateAudit($this);
		}
		else
		{
			$newid = $ops->insertAudit($this);
			
			if ($newid > -1)
			{
				$this->id = $newid;
				
				$result = true;
			}
		}

		return $result;
	}
	
	public function getDetails()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getAuditOps();
			
			$result=$ops->getAuditDetails($this);
		}
		
		return $result;
	}
	
	public function saveDetails($details)
	{
		$ops=getOS()->getAuditOps();
		
		return $ops->saveAuditDetails($this,$details);
	}
}
?>