<?php
class OS_BacklinksOperations
{
	private static $_instance;
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_BacklinksOperations();
		}
		
		return self::$_instance;
	}
	
	public function getEngineAuthData($engine)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."connectors_auth WHERE connector_type=? AND connector_name=?",array('backlinks',$engine));
		while ($row=$db->fetchRow($dbresult))
		{
			$result[$row['name']]=$row['value'];
		}
		
		return $result;
	}
	
	public function setEngineAuthData($engine,$auth_data)
	{
		$result=true;
		
		$db=getOS()->getDb();
		
		$currentAuth=$this->getEngineAuthData($engine);
		
		foreach ($auth_data as $name=>$value)
		{
			if (isset($currentAuth[$name]))
			{
				if ($currentAuth[$name]!=$value)
				{
					$dbresult=$db->query("UPDATE ".$db->dbPrefix()."connectors_auth SET value=? WHERE connector_type=? AND connector_name=? AND name=?",array($value,'backlinks',$engine,$name));
					
					if ($dbresult===false)
					{
						$result=false;
						
						break;
					}
				}
			}
			else
			{
				$dbresult=$db->query("INSERT INTO ".$db->dbPrefix()."connectors_auth (connector_type,connector_name,name,value) VALUES (?,?,?,?)",array('backlinks',$engine,$name,$value));
				
				if ($dbresult===false)
				{
					$result=false;
					
					break;
				}
			}
		}
		
		return $result;
	}
	
	public function deleteEngineAuthData($engine)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("DELETE FROM ".$db->dbPrefix()."connectors_auth WHERE connector_type=? AND connector_name=?",array('backlinks',$engine));
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function getEnginesAuthData()
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."connectors_auth WHERE connector_type=?",array('backlinks'));
		while ($row=$db->fetchRow($dbresult))
		{
			$result[$row['connector_name']][$row['name']]=$row['value'];
		}
		
		return $result;
	}
}
?>