<?php
class OS_Cache
{
	private static $_instance;
	
	private $engine;
	
	public function __construct()
	{
		$cacheEngine=getOS()->getSettingsVar('cache_engine');
		
		if ($cacheEngine)
		{
			$cacheClass="OS_PLUGIN_Cache_{$cacheEngine}";
			
			$this->engine=call_user_func(array($cacheClass,'get_instance'));
//			$this->engine=$cacheClass::get_instance();
		}
		else
		{
			$this->engine=false;
		}
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_Cache();
		}
		
		return self::$_instance;
	}
	
	public function getCacheType()
	{
		$result=false;
		
		if ($this->engine)
		{
			$result=$this->engine->cacheType;
		}
		
		return $result;
	}
	
	public function setBucket($bucket)
	{
		$result=false;
		
		if ($this->engine)
		{
			$result=$this->engine->setBucket($bucket);
		}
		
		return $result;
	}
	
	public function set($key,$value,$expire=0)
	{
		$result=false;
		
		if ($this->engine)
		{
			$result=$this->engine->set($key,$value,$expire);
		}
		
		return $result;
	}
	
	public function get($key)
	{
		$result=false;
		
		if ($this->engine)
		{
			$result=$this->engine->get($key);
		}
		
		return $result;
	}
	
	public function delete($key)
	{
		$result=false;
		
		if ($this->engine)
		{
			$result=$this->engine->delete($key);
		}
		
		return $result;
	}
	
	public function purge()
	{
		$result=false;
		
		if ($this->engine)
		{
			$result=$this->engine->purge();
		}
		
		return $result;
	}
}
?>