<?php
class OS_Client
{
	public static $_instance;
	
	public $id;
	public $name;
	public $email;
	
	function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if(!is_object(self::$_instance))
		{
			self::$_instance = new OS_Client();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->name='';
		$this->email='';
	}
	
	public function load()
	{
		$result = false;
		
		if($this->isValid())
		{
			$clientOps = getOS()->getClientOps();
			
			$oneClient = $clientOps->getClientByID($this->id);
			
			if($oneClient !== false)
			{
				$this->set($oneClient);
				
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function set($clientDetails)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		if(is_object($clientDetails))
		{
			$clientDetails = get_object_vars($clientDetails);
		}
		
		foreach($objVars as $field=>$val)
		{
			if(isset($clientDetails[$field]))
			{
				$this->$field = $clientDetails[$field];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=getOS()->getClientOps();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertClient($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateClient($this);
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getClientOps();
			
			$result=$ops->deleteClientByID($this->id);
		}
		
		return $result;
	}
}
?>