<?php
class OS_ClientOperations
{
	public static $_instance;
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_ClientOperations();
		}
			
		return	self::$_instance;
	}
	
	public function getClients()
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."clients ORDER BY `name` ASC",array());
		while ($row=$db->fetchRow($dbresult))
		{
			$oneClient=new OS_Client();
			$oneClient->set($row);
			
			$result[$row['id']]=$oneClient;
		}
		
		return $result;
	}
	
	public function getClientByID($client_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."clients WHERE id=?",array($client_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_Client();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getClientByName($client_name)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."clients WHERE `name`=?",array($client_name));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_Client();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function insertClient($client)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		
		$query="INSERT INTO ".$db->dbPrefix()."clients (name,email) VALUES (?,?)";
		$dbresult=$db->query($query,array($client->name,$client->email));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateClient($client)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		
		$query="UPDATE ".$db->dbPrefix()."clients SET name=?,email=? WHERE id=?";
		$dbresult=$db->query($query,array($client->name,$client->email,$client->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteClientByID($client_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		
		$query="UPDATE ".$db->dbPrefix()."projects SET `client_id`=? WHERE `client_id`=?";
		$dbresult=$db->query($query,array('0',$client_id));
		
		if ($dbresult!==false)
		{
			$query="DELETE FROM ".$db->dbPrefix()."clients WHERE id=?";
			$dbresult=$db->query($query,array($client_id));
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
}
?>