<?php
class OS_Competitor
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $topic_id;
	public $host;
	public $manual;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_Competitor();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->topic_id=0;
		$this->host='';
		$this->manual='';
	}
	
	public function set($app_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($app_data[$key]))
			{
				$this->$key = $app_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getCompetitorOps();
			
			if ($app_data=$ops->getCompetitorByID($this->id))
			{
				$this->set(get_object_vars($app_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$result=false;

		$ops = getOS()->getCompetitorOps();
		
		if ($this->id)
		{
			$result = $ops->updateCompetitor($this);
		}
		else
		{
			$newid = $ops->insertCompetitor($this);
			
			if ($newid)
			{
				$this->id = $newid;
				
				$result = true;
			}
		}

		return $result;
	}
	
	public function delete()
	{
		$ops=getOS()->getCompetitorOps();
		
		return $ops->deleteCompetitor($this);
	}
}
?>