<?php
class OS_CompetitorOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_CompetitorOperations();
		}
		
		return self::$_instance;
	}
	
	public function getCompetitorByID($competitor_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."competitors WHERE id=?";
		$dbresult=$db->query($query,array($competitor_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_Competitor();
			$result->set($row);
		}
		
		return $result;			
	}
	
	public function getCompetitorByURL($host,$project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project=getOS()->getProject();
			
			if ($project->id)
			{
				$project_id=$project->id;
			}
		}
		
		if ($project_id)
		{
			$db=getOS()->getDb();
			
			$query="SELECT * FROM ".$db->dbPrefix()."competitors WHERE project_id=? AND host=?";
			$dbresult=$db->query($query,array($project_id,$host));
			if ($row=$db->fetchRow($dbresult))
			{
				$result=new OS_Competitor();
				$result->set($row);
			}
		}
		
		return $result;
	}
	
	public function getCompetitorsByTopicID($topic_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."competitors WHERE topic_id=?";
		$dbresult=$db->query($query,array($topic_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneCompetitor=new OS_Competitor();
			$oneCompetitor->set($row);
			
			$result[$row['id']]=$oneCompetitor;
		}
		
		return $result;
	}
	
	public function getCompetitors($project_id=false)
	{
		$result=false;
		
		if (!$project_id)
		{
			$project=getOS()->getProject();
			
			if ($project->id)
			{
				$project_id=$project->id;
			}
		}
		
		if ($project_id)
		{
			$db=getOS()->getDb();
			
			$query="SELECT * FROM ".$db->dbPrefix()."competitors WHERE project_id=?";
			$dbresult=$db->query($query,array($project_id));
			while ($row=$db->fetchRow($dbresult))
			{
				$oneCompetitor=new OS_Competitor();
				$oneCompetitor->set($row);
				
				$result[$row['id']]=$oneCompetitor;
			}
		}
		
		return $result;
	}
	
	public function getCompetitorsCount($project_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
			
		$query="SELECT COUNT(*) AS project_competitors FROM ".$db->dbPrefix()."competitors WHERE project_id=?";
		$dbresult=$db->query($query,array($project_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=$row['project_competitors'];
		}
		
		return $result;
	}
	
	public function insertCompetitor($competitor)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="INSERT INTO ".$db->dbPrefix()."competitors (project_id,topic_id,host,manual) VALUES (?,?,?,?)";
		$dbresult=$db->query($query,array($competitor->project_id,$competitor->topic_id,$competitor->host,$competitor->manual));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateCompetitor($competitor)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="UPDATE ".$db->dbPrefix()."competitors SET host=? WHERE id=?";
		$dbresult=$db->query($query,array($competitor->host,$competitor->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteCompetitor($competitor)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="DELETE FROM ".$db->dbPrefix()."competitors WHERE id=?";
		$dbresult=$db->query($query,array($competitor->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteCompetitorsByTopicID($topic_id,$including_manual=true)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		
		$query="DELETE FROM ".$db->dbPrefix()."competitors WHERE topic_id=?".($including_manual?'':" AND manual=''");
		$dbresult=$db->query($query,array($topic_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteCompetitorsByProjectID($project_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="DELETE FROM ".$db->dbPrefix()."competitors WHERE project_id=?";
		$dbresult=$db->query($query,array($project_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
}
?>