<?php
/*
 * Created on Mar 12, 2012
 *
 * Owner: George
 */
class OS_Events
{
	public static function createEvent($event_name,$module,$module_name='')
	{
		$result=false;
		
		if (!$row=self::getEventByName($event_name))
		{
			$db=getOS()->getDb();
			$time = $db->DBTimeStamp(time());
			$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
			
			$query="INSERT INTO ".$db->dbPrefix()."events (name,module,module_name,insert_dt,insert_ip,insert_by,status,status_dt,status_ip,status_by) VALUES (?,?,?,?,?,?,?,?,?,?)";
			$dbresult=$db->query($query,array($event_name,$module,$module_name,$time,$ip,-1,'E',$time,$ip,-1));
			
			if ($dbresult!==false)
			{
				self::addEventHandler($event_name,'core','os_auditoperations','eventAudit');
				
				$result=true;
			}
		}
		else
		{
			$result=true;
		}
		
		return $result;
	}
	
	public static function removeEvent($event_name)
	{
		$result=false;
		
		if ($row=self::getEventByName($event_name))
		{
			self::removeAllEventHandlers($event_name);
			
			$db=getOS()->getDb();
			
			$query="DELETE FROM ".$db->dbPrefix()."events WHERE name=?";
			$dbresult=$db->query($query,array($event_name));
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
	
	public static function disableEvent($event_name)
	{
		$result=false;
		
		if ($row=self::getEventByName($event_name) AND $row['status']=='E')
		{
			self::removeAllEventHandlers($event_name);
			
			$db=getOS()->getDb();
			
			$time=$db->DBTimeStamp(time());
			$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
			
			$query="UPDATE ".$db->dbPrefix()."events SET status='D',status_dt=?,status_ip=? WHERE name=?"; //TODO: status_by
			$dbresult=$db->query($query,array($time,$ip,$event_name));
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
	
	public static function enableEvent($event_name)
	{
		$result=false;
		
		if ($row=self::getEventByName($event_name) AND $row['status']=='D')
		{
			self::removeAllEventHandlers($event_name);
			
			$db=getOS()->getDb();
			
			$time=$db->DBTimeStamp(time());
			$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
			
			$query="UPDATE ".$db->dbPrefix()."events SET status='E',status_dt=?,status_ip=? WHERE name=?"; //TODO: status_by
			$dbresult=$db->query($query,array($time,$ip,$event_name));
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
	
	public static function addEventHandler($event_name,$module,$module_name,$method,$timelimit=5)
	{
		$result=false;
		
		if ($event_row=self::getEventByName($event_name))
			if ($event_row['status']=='E')
				if (!$handler_row=self::getEventHandler($event_name,$module,$module_name,$method))
				{
					$db=getOS()->getDb();
					$time = $db->DBTimeStamp(time());
					$ip=(empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
					
					$query="INSERT INTO ".$db->dbPrefix()."events_handlers (event_id,module,module_name,method,timelimit,insert_dt,insert_ip,insert_by,status,status_dt,status_ip,status_by) VALUES (?,?,?,?,?,?,?,?,?,?,?,?)";
					$dbresult=$db->query($query,array($event_row['id'],$module,$module_name,$method,$timelimit,$time,$ip,-1,'E',$time,$ip,-1));
					
					if ($dbresult!==false)
					{
						$result=true;
					}
				}
				else
				{
					$result=true;
				}
		
		return $result;
	}
	
	public static function removeEventHandler($event_name,$module,$module_name,$method)
	{
		$result=false;
		
		if ($event_row=self::getEventByName($event_name))
			if ($handler_row=self::getEventHandler($event_name,$module,$module_name,$method))
			{
				$db=getOS()->getDb();
				
				$query="DELETE FROM ".$db->dbPrefix()."events_handlers WHERE id=?";
				$dbresult=$db->query($query,array($handler_row['id']));
				
				if ($dbresult!==false)
				{
					$result=true;
				}
			}
		
		return $result;
	}
	
	public static function removeAllEventHandlers($event_name)
	{
		$result=false;
		
		if ($event_row=self::getEventByName($event_name))
		{
			$db=getOS()->getDb();
			
			$query="DELETE FROM ".$db->dbPrefix()."events_handlers WHERE event_id=?";
			$dbresult=$db->query($query,array($event_row['id']));
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
	
	public static function removeEventHandlersByModule($module,$module_name=false)
	{
		$result=false;
		
		if ($events_handlers=self::getEventHandlersByModule($module,$module_name))
		{
			$db=getOS()->getDb();
			
			$query="DELETE FROM ".$db->dbPrefix()."events_handlers WHERE module=?".($module_name?" AND module_name=?":'');
			$query_params=array($module);
			if ($module_name)
			{
				$query_params[]=$module_name;
			}
			$dbresult=$db->query($query,$query_params);
			
			if ($dbresult!==false)
			{
				$result=true;
			}
		}
		
		return $result;
	}
	
	public static function disableEventHandler($event_name,$module,$module_name,$method,$reason='')
	{
		$result=false;
		
		if ($event_row=self::getEventByName($event_name))
			if ($handler_row=self::getEventHandler($event_name,$module,$module_name,$method) AND $handler_row['status']=='E')
			{
				$db=getOS()->getDb();
				
				$time=$db->DBTimeStamp(time());
				$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
				
				$query="UPDATE ".$db->dbPrefix()."events_handlers SET status='D',status_dt=?,status_ip=?,status_reason=? WHERE id=?"; //TODO: status_by
				$dbresult=$db->query($query,array($time,$ip,$reason,$handler_row['id']));
				
				if ($dbresult!==false)
				{
					$result=true;
				}
			}
		
		return $result;
	}
	
	public static function enableEventHandler($event_name,$module,$module_name,$method)
	{
		$result=false;
		
		if ($event_row=self::getEventByName($event_name))
			if ($handler_row=self::getEventHandler($event_name,$module,$module_name,$method) AND $handler_row['status']=='D')
			{
				$db=getOS()->getDb();
				
				$time=$db->DBTimeStamp(time());
				$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
				
				$query="UPDATE ".$db->dbPrefix()."events_handlers SET status='E',status_dt=?,status_ip=? WHERE id=?"; //TODO: status_by
				$dbresult=$db->query($query,array($time,$ip,$handler_row['id']));
				
				if ($dbresult!==false)
				{
					$result=true;
				}
			}
		
		return $result;
	}
	
	public static function getEventByName($event_name)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."events WHERE name=?";
		$dbresult=$db->query($query,array($event_name));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=$row;
		}
		
		return $result;
	}
	
	public static function getEventByID($event_id)
	{
		$result = false;
		
		$db = getOS()->getDb();
		
		$query = "SELECT * FROM ".$db->dbPrefix()."events WHERE id=?";
		$dbresult = $db->query($query,array($event_id));
		if($row = $db->fetchRow($dbresult))
		{
			$result = $row;
		}
		
		return $result;
	}	
	
	public static function getEvents()
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."events");
		while ($row=$db->fetchRow($dbresult))
		{
			$result[$row['id']]=$row;
		}
		
		return $result;
	}
	
	public static function getEventsByModule($module,$module_name='')
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."events WHERE module=?".($module_name?" AND module_name=?":'');
		$query_params=array($module);
		if ($module_name)
		{
			$query_params[]=$module_name;
		}
		$dbresult=$db->query($query,$query_params);
		while ($row=$db->fetchRow($dbresult))
		{
			$result[$row['id']]=$row;
		}
		
		return $result;
	}
	
	public static function getEventHandler($event_name,$module,$module_name,$method)
	{
		$result=false;
		
		if ($event_row=self::getEventByName($event_name))
		{
			$db=getOS()->getDb();
			
			$query="SELECT * FROM ".$db->dbPrefix()."events_handlers WHERE event_id=? AND module=? AND module_name=? AND method=?";
			$dbresult=$db->query($query,array($event_row['id'],$module,$module_name,$method));
			if ($row=$db->fetchRow($dbresult))
			{
				$result=$row;
			}
		}
		
		return $result;
	}
	
	public static function getEventHandlers($event_name,$scope=array())
	{
		$result=false;
		
		if ($event_row=self::getEventByName($event_name))
		{
			$db=getOS()->getDb();
			
			$query="SELECT * FROM ".$db->dbPrefix()."events_handlers WHERE event_id=? ORDER BY `module`='core' DESC";
			$dbresult=$db->query($query,array($event_row['id']));
			while ($row=$db->fetchRow($dbresult))
			{
				if ($row['module']=='core' AND (empty($scope) OR (isset($scope['core']) AND in_array($row['module_name'],$scope['core']))))
				{
					$handlerInScope=true;
				}
				elseif ($row['module']=='app' AND (empty($scope) OR (isset($scope['apps']) AND in_array($row['module_name'],$scope['apps']))))
				{
					$handlerInScope=true;
				}
				else
				{
					$handlerInScope=false;
				}
				
				if ($handlerInScope)
				{
					$result[$row['id']]=$row;
				}
			}
		}
		
		return $result;
	}
	
	public static function getEventHandlersByModule($module,$module_name=false)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."events_handlers WHERE module=?".($module_name?" AND module_name=?":'');
		$query_params=array($module);
		if ($module_name)
		{
			$query_params[]=$module_name;
		}
		$dbresult=$db->query($query,$query_params);
		while ($row=$db->fetchRow($dbresult))
		{
			$result[$row['id']]=$row;
		}
		
		return $result;
	}
	
	public static function triggerEvent($event_name,$params=array(),$scope=array())
	{
		$result=false;

		$triggeredBy=getOS()->getAppHandler()->name;
		
		if ($event_row=self::getEventByName($event_name))
			if ($event_row['status']=='E')
			{
				if ($handlers=self::getEventHandlers($event_name,$scope))
				{
					$params['_event']=$event_name;
					
					foreach ($handlers as $handler_id=>&$handler)
					{
						$run_time=false;
						
						if ($handler['module']=='core')
						{
							$start_time=microtime(true);
							
							$handlerObj=new $handler['module_name'];
							
							if ($handlerObj)
							{
								if (method_exists($handlerObj,$handler['method']))
								{
									$handlerObj->$handler['method']($params);
								}
							}
			
							$run_time=microtime(true)-$start_time;
						}
						elseif ($handler['module']=='app')
						{
							$appHandler = getOS()->getAppHandler($handler['module_name']);
							$appHandler->name=$handler['module_name'];
			
							$start_time=microtime(true);
							
							$handlerObj=$appHandler->getAppPlugin();
							
							if ($handlerObj)
							{
								if (method_exists($handlerObj,$handler['method']))
								{
									$handlerObj->$handler['method']($params);
								}
							}
							
							$run_time=microtime(true)-$start_time;
						}
						
						if ($run_time AND $run_time>$handler['timelimit'])
						{
							self::disableEventHandler($event_name,$handler['module'],$handler['module_name'],$handler['method'],"Run time exceeded");
						}
					}
				}
				$result=true;
			}
		
		if ($triggeredBy)
		{
			getOS()->getAppHandler($triggeredBy);
		}
		
		return $result;
	}
	
	public static function defineCoreEvents($events)
	{
		$result=true;
		$responseData=array('tests'=>array(),'notifications'=>array());
		
		foreach ($events as $event)
		{
			if (!self::createEvent($event['name'],'core',$event['triggeredBy']))
			{
				$returnType=array('type'=>'error',_('Unable to define event'));
				$result=false;
			}
			else
			{
				$returnType=array('type'=>'success');
			}
			
			$responseData['tests'][]=array('test'=>array('message'=>_("Defining")." `{$event['name']}`"._(" event")),'result'=>$returnType);
		}
		
		$responseData['result']=$result;
		
		return $responseData;
	}
	
	public static function defineCoreEventHandlers($event_handlers)
	{
		$result=true;
		$responseData=array('tests'=>array(),'notifications'=>array());
		
		foreach ($event_handlers as $event_handler)
		{
			if (!self::addEventHandler($event_handler['event'],'core',$event_handler['class'],$event_handler['method']))
			{
				$returnType=array('type'=>'error',_('Unable to add event handler'));
				$result=false;
			}
			else
			{
				$returnType=array('type'=>'success');
			}
			
			$responseData['tests'][]=array('test'=>array('message'=>_("Adding event handler for")." `{$event_handler['event']}`"),'result'=>$returnType);
		}
		
		$responseData['result']=$result;
		
		return $responseData;
	}
}
?>