<?php
require_once(dirname(__FILE__).'/../fpdf/fpdf.php');

class OS_PDF extends FPDF
{
	private static $_instance;
	
	private $templateFiles;
	
	public function __construct()
	{
		parent::FPDF();
		
		$this->templateFiles=false;
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PDF();
		}
		
		return self::$_instance;
	}
	
	public function setTemplateFiles($templateFiles)
	{
		$this->templateFiles=$templateFiles;
	}
	
	public function Header()
	{
		$OS=getOS();
		if ($this->PageNo()==1)
		{
			if (!empty($this->templateFiles['cover']))
			{
				$cover_url=$this->templateFiles['cover'];
			}
			else
			{
				$cover_url=$OS->getConfigVar('root_url').'/lib/imgs/report/cover.png';
			}
			
			$this->Image($cover_url,0,0,210,0);
			
			$this->AddPage();
		}
		
		if (!empty($this->templateFiles['header']))
		{
			$header_url=$this->templateFiles['header'];
		}
		else
		{	
			$header_url=$OS->getConfigVar('root_url').'/lib/imgs/report/header.png';
		}
		
		$this->Image($header_url,0,0,210,0);
		$this->SetXY(10,36);
	}
	
	public function Footer()
	{
		if ($this->PageNo()!=1)
		{
			$OS=getOS();
			
			if (!empty($this->templateFiles['footer']))
			{
				$footer_url=$this->templateFiles['footer'];
			}
			else
			{	
				$footer_url=$OS->getConfigVar('root_url').'/lib/imgs/report/footer.png';
			}
			
		    $this->Image($footer_url,0,297-29,210,29);
		}
	}
}
?>