<?php
class OS_ProjectCrawl
{
	private static $_instance;
	
	private $_urlErrors;
	
	public $id;
	public $project_id;
	public $urls;
	public $urls_html;
	public $urls_xml;
	public $urls_txt;
	public $urls_css;
	public $urls_js;
	public $urls_img;
	public $urls_other;
	public $urls_2xx;
	public $urls_3xx;
	public $urls_4xx;
	public $urls_5xx;
	public $start_dt;
	public $end_dt;
	public $status;
	public $status_dt;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_ProjectCrawl();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->_urlErrors=false;
		
		$this->id=false;
		$this->project_id='';
		$this->urls=0;
		$this->urls_html=0;
		$this->urls_xml=0;
		$this->urls_txt=0;
		$this->urls_css=0;
		$this->urls_js=0;
		$this->urls_img=0;
		$this->urls_other=0;
		$this->urls_2xx=0;
		$this->urls_3xx=0;
		$this->urls_4xx=0;
		$this->urls_5xx=0;
		$this->start_dt='';
		$this->end_dt='';
		$this->status='';
		$this->status_dt='';
	}
	
	public function set($crawl_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($crawl_data[$key]))
			{
				$this->$key = $crawl_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function save()
	{
		$ops=getOS()->getProjectCrawlOps();
		if (!$this->id)
			{
			if (!$this->id=$ops->insertProjectCrawl($this)) return false;
			return true;
			}
		else return $ops->updateProjectCrawl($this);
	}
	
	public function load()
	{
		$result = false;
		
		if ($this->id)
		{
			$ops=getOS()->getProjectCrawlOps();
			
			if ($crawl_data=$ops->getProjectCrawlByID($this->id))
			{
				$this->set(get_object_vars($crawl_data));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getProjectCrawlOps();
			
			if ($ops->deleteProjectCrawlUrlErrors($this))
			{
				$result=$ops->deleteProjectCrawlByID($this->id);
			}
		}
		
		return $result;
	}
	
	public function logUrlError($depth,$url,$http_code,$title='',$size=0,$file_type='')
	{
		$ops=getOS()->getProjectCrawlOps();
		
		return $ops->insertProjectCrawlUrlError($this,$depth,$url,$http_code,$title,$size,$file_type);
	}
	
	public function getUrlErrors($http_code_group=false)
	{
		$result=false;
		
		if ($this->id)
		{
			if ($this->_urlErrors===false OR ($http_code_group AND !isset($this->_urlErrors[$http_code_group])))
			{
				$ops=getOS()->getProjectCrawlOps();
				
				if ($http_code_group)
				{
					$this->_urlErrors[$http_code_group]=$ops->getProjectCrawlUrlErrors($this,$http_code_group);
				}
				else
				{
					$this->_urlErrors=$ops->getProjectCrawlUrlErrors($this,$http_code_group);
				}
			}
			
			$result=($http_code_group?$this->_urlErrors[$http_code_group]:$this->_urlErrors);
		}
				
		return $result;
	}
}
?>