<?php
class OS_ProjectKeyword
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $topic_id;
	public $keyword;
	public $competitors;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_ProjectKeyword();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->topic_id=0;
		$this->keyword='';
		$this->competitors='';
	}
	
	public function save()
	{
		$result=false;
		
		$ops=getOS()->getProjectKeywordOps();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertProjectKeyword($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateProjectKeyword($this);
		}
		
		return $result;
	}
	
	public function set($label_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($label_data[$key]))
			{
				$this->$key = $label_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getProjectKeywordOps();
			
			if ($label=$ops->getProjectKeywordByID($this->id))
			{
				$this->set(get_object_vars($label));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getProjectKeywordOps();
		
			$result=$ops->deleteProjectKeywordByID($this->id);
		}
		
		return $result;
	}
}
?>