<?php
class OS_ProjectKeywordCompetitor
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $keyword_id;
	public $url;
	public $position;
	
	public function __construct()
	{
		$this->setInitialValues();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_ProjectKeywordCompetitor();
		}
		
		return self::$_instance;
	}
	
	public function setInitialValues()
	{
		$this->id=0;
		$this->project_id=0;
		$this->keyword_id=0;
		$this->url='';
		$this->position=0;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=getOS()->getProjectKeywordCompetitorOps();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertProjectKeywordCompetitor($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateProjectKeywordCompetitor($this);
		}
		
		return $result;
	}
	
	public function set($label_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($label_data[$key]))
			{
				$this->$key = $label_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getProjectKeywordCompetitorOps();
			
			if ($label=$ops->getProjectKeywordCompetitorByID($this->id))
			{
				$this->set(get_object_vars($label));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getProjectKeywordCompetitorOps();
		
			$result=$ops->deleteProjectKeywordCompetitorByID($this->id);
		}
		
		return $result;
	}
}
?>