<?php
class OS_ProjectKeywordCompetitorOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_ProjectKeywordCompetitorOperations();
		}
		
		return self::$_instance;
	}
	
	public function getProjectKeywordCompetitorByID($keyword_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."project_keywords_competitors WHERE id=?",array($keyword_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_ProjectKeywordCompetitor();
			
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getProjectKeywordCompetitorsByKeywordID($keyword_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."project_keywords_competitors WHERE keyword_id=?",array($keyword_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneKeyword=new OS_ProjectKeywordCompetitor();
			
			$oneKeyword->set($row);
			
			$result[$row['id']]=$oneKeyword;
		}
		
		return $result;
	}
	
	public function getProjectKeywordCompetitors($project_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."project_keywords_competitors WHERE project_id=?",array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneKeyword=new OS_ProjectKeywordCompetitor();
			
			$oneKeyword->set($row);
			
			$result[$row['id']]=$oneKeyword;
		}
		
		return $result;
	}
	
	public function deleteProjectKeywordCompetitorByID($keyword_id)
	{
		$result=false;
		
		if ($keyword=$this->getProjectKeywordCompetitorByID($keyword_id))
		{
			$db=getOS()->getDb();
			
			$dbresult=$db->query("DELETE FROM ".$db->dbPrefix()."project_keywords_competitors WHERE id=?",array($keyword_id));
		}
		
		return $result;
	}
	
	public function deleteKeywordCompetitorsByKeywordID($keyword_id)
	{
		$result=true;
		
		if ($kw_competitors=$this->getProjectKeywordCompetitorsByKeywordID($keyword_id))
		{
			foreach ($kw_competitors as $kw_competitor)
			{
				if (!$kw_competitor->delete())
				{
					$result=false;
					break;
				}
			}
		}
		
		return $result;
	}
	
	public function deleteKeywordCompetitorsByProjectID($project_id)
	{
		$result=true;
		
		if ($kw_competitors=$this->getProjectKeywordCompetitors($project_id))
		{
			foreach ($kw_competitors as $kw_competitor)
			{
				if (!$kw_competitor->delete())
				{
					$result=false;
					break;
				}
			}
		}
		
		return $result;
	}
	
	public function insertProjectKeywordCompetitor($kw_competitor)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		
		$query="INSERT INTO ".$db->dbPrefix()."project_keywords_competitors (project_id,keyword_id,url,`position`) VALUES (?,?,?,?)";
		$dbresult=$db->query($query,array($kw_competitor->project_id,$kw_competitor->keyword_id,$kw_competitor->url,$kw_competitor->position));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateProjectKeywordCompetitor($kw_competitor)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		
		$dbresult=$db->query("UPDATE ".$db->dbPrefix()."project_keywords_competitors SET url=?,`position`=? WHERE id=?",array($kw_competitor->url,$kw_competitor->position,$kw_competitor->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
}
?>