<?php
class OS_ProjectSearchEngine
{
	private static $_instance;
	
	public $id;
	public $project_id;
	public $engine;
	public $locale;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_ProjectSearchEngine();
		}
		
		return self::$_instance;
	}
	
	public function save()
	{
		$result=false;
		
		$ops=getOS()->getProjectSearchEngineOps();
		
		if (!$this->id)
		{
			if ($this->id=$ops->insertProjectSearchEngine($this))
			{
				$result=true;
			}
		}
		else
		{
			$result=$ops->updateProjectSearchEngine($this);
		}
		
		return $result;
	}
	
	public function set($label_data)
	{
		$result = false;
		
		$objVars = get_object_vars($this);
		
		foreach($objVars as $key=>$val)
		{
			if(isset($label_data[$key]))
			{
				$this->$key = $label_data[$key];
				$result = true;
			}
		}
		
		return $result;
	}
	
	public function load()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getProjectSearchEngineOps();
			
			if ($label=$ops->getProjectSearchEngineByID($this->id))
			{
				$this->set(get_object_vars($label));
				
				$result=true;
			}
		}
		
		return $result;
	}
	
	public function delete()
	{
		$result=false;
		
		if ($this->id)
		{
			$ops=getOS()->getProjectSearchEngineOps();
		
			$result=$ops->deleteProjectSearchEngineByID($this->id);
		}
		
		return $result;
	}
}
?>