<?php
class OS_ProjectSearchEngineOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_ProjectSearchEngineOperations();
		}
		
		return self::$_instance;
	}
	
	public function getProjectSearchEngineByID($se_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."project_search_engines WHERE id=?",array($se_id));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_ProjectSearchEngine();
			
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getProjectSearchEngineByEngine($project_id,$engine,$locale='')
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."project_search_engines WHERE project_id=? AND `engine`=? AND `locale`=?",array($project_id,$engine,$locale));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_ProjectSearchEngine();
			
			$result->set($row);
		}
		
		return $result;
	}
	
	public function getProjectSearchEngines($project_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("SELECT * FROM ".$db->dbPrefix()."project_search_engines WHERE project_id=?",array($project_id));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneSE=new OS_ProjectSearchEngine();
			
			$oneSE->set($row);
			
			$result[$row['id']]=$oneSE;
		}
		
		return $result;
	}
	
	public function deleteSearchEnginesByProjectID($project_id)
	{
		$result=true;
		
		if ($ses=$this->getProjectSearchEngines($project_id))
		{
			foreach ($ses as $se)
			{
				if (!$se->delete())
				{
					$result=false;
					break;
				}
			}
		}
		
		return $result;
	}
	
	public function insertProjectSearchEngine($pse)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("INSERT INTO ".$db->dbPrefix()."project_search_engines (`project_id`,`engine`,`locale`) VALUES (?,?,?)",array($pse->project_id,$pse->engine,$pse->locale));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateProjectSearchEngine($pse)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$dbresult=$db->query("UPDATE ".$db->dbPrefix()."project_search_engines SET `engine`=?,locale=? WHERE id=?",array($pse->engine,$pse->locale,$pse->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteProjectSearchEngineByID($pse_id)
	{
		$result=false;
		
		$OS=getOS();
		$db=$OS->getDb();
		$osProjectTopicOps=$OS->getProjectTopicOps();
		
		if ($topics=$osProjectTopicOps->getProjectTopicsBySearchEngineID($pse_id))
		{
			foreach ($topics as $topic_id=>$topic)
			{
				$topic->delete();
			}
		}
		
		$dbresult=$db->query("DELETE FROM ".$db->dbPrefix()."project_search_engines WHERE id=?",array($pse_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
}
?>