<?php
class OS_Rankings
{
	private static $_instance;
	
	private $ranking;
	private $rankingName;
	
	public function __construct()
	{
		$this->ranking=false;
		$this->rankingName=false;
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_Rankings();
		}
		
		return self::$_instance;
	}
	
	public function setRanking($network)
	{
		$old=$this->rankingName;
		
		if (!$old)
		{
			$old=true;
		}
		
		$this->rankingName=$network;
		
		$rankingClass="OS_PLUGIN_Rankings_{$network}";
		
		$this->ranking=call_user_func(array($rankingClass,'get_instance'));	
//		$this->ranking=$rankingClass::get_instance();
		
		return $old;
	}
	
	public function getRanking()
	{
		return $this->rankingName;
	}
	
	public function getAvailableRankings()
	{
		$result=false;
		
		$OS=getOS();
		
		$plugins_path=os_join_path($OS->getConfigVar('root_path'),'lib','classes','plugins','rankings');
		
		$plugins=glob(os_join_path($plugins_path,'*'),GLOB_ONLYDIR);
		
		foreach ($plugins as $plugin)
		{
			$result[]=str_replace($plugins_path,'',$plugin);
		}
		
		return $result;
	}
	
	public function getRank($url)
	{
		$result=false;
		
		if ($this->ranking)
		{
			$result=$this->ranking->getRank($url);
		}
		
		return $result;
	}
	
	public function getAllRanks($url)
	{
		$result=false;
		
		if ($plugins=$this->getAvailableRankings())
		{
			foreach ($plugins as $plugin)
			{
				if ($this->setRanking($plugin))
				{
					$result[$plugin]=$this->getRank($url);
				}
			}
		}
		
		return $result;
	}
}
?>