<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_settings.php 2012-01-09$
 */

class OS_Settings
{
	private static $_instance;
	
	private $data = array();
	
	//constructor
	function __construct()
	{
	
	}
	
	public static function &get_instance()
	{
		if(!is_object(self::$_instance))
    	{
			self::$_instance = new OS_Settings();

      		// now load the settings
      		self::$_instance->load();
    	}
    	
    	return self::$_instance;
	}
	
	public function getSettingsItems()
	{
		$settingsItems = array('community_stats', 'osc_user', 'osc_api_key');
		
		return $settingsItems;
	}
	
	public function save($filepath = false)
	{
	    $OS = getOS();
		
		if( !$filepath )
		{
			$filepath = $OS->getConfigVar('settings_file_path');
		}
	      
	    // backup the original settings.php file (just in case)
	    if( file_exists($filepath) )
		{
			@copy($filepath, os_join_path($OS->getConfigVar('cache_path'),basename($filepath).time().'.bak'));
		}
	      
		//output header to the config file.
		$osUtils = $OS->getUtils();
		
		$result = $osUtils->confWrite($filepath, $this->data);
		
		return ($result === false ?  false : true);
	}
	
	public function load()
	{
		$result = false;
		if(empty($this->data))
		{
	    	$OS = getOS();
	    	
	    	$osUtils = $OS->getUtils();
	    	
			$configFilePath = $OS->getConfigVar('settings_file_path');
			
			$configData = $osUtils->confRead($configFilePath);
			
			if($configData !== false)
			{
				$this->data = $configData;
				$result = $this->data;	
			}
    	}
    	else
    	{
    		$result = $this->data;
    	}
    	
    	return $result;
	}
	
	public function getParam($key)
	{
		$result = false;
		
		if(isset($this->data[$key]))
		{
			$result = $this->data[$key];
		}

		return $result;
	}
	
	public function flush()
	{
		if(!empty($this->data))
		{
			$this->data = array();
		}
	}
	
	public function setParam($key, $value)
	{
		$this->data[$key] = $value;
	}
}
?>