<?php
class OS_SocialSignals
{
	private static $_instance;
	
	private $socialNetwork;
	private $socialNetworkName;
	
	public function __construct()
	{
		$this->socialNetwork=false;
		$this->socialNetworkName=false;
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_SocialSignals();
		}
		
		return self::$_instance;
	}
	
	public function setSocialNetwork($network)
	{
		$old=$this->socialNetworkName;
		
		if (!$old)
		{
			$old=true;
		}
		
		$this->socialNetworkName=$network;
		
		$socialNetworkClass="OS_PLUGIN_SocialSignals_{$network}";
		
		$this->socialNetwork=call_user_func(array($socialNetworkClass,'get_instance'));	
//		$this->socialNetwork=$socialNetworkClass::get_instance();
		
		return $old;
	}
	
	public function getSocialNetwork()
	{
		return $this->socialNetworkName;
	}
	
	public function getAvailableSocialNetworks()
	{
		$result=false;
		
		$OS=getOS();
		
		$plugins_path=os_join_path($OS->getConfigVar('root_path'),'lib','classes','plugins','socialsignals');
		
		$plugins=glob(os_join_path($plugins_path,'*'),GLOB_ONLYDIR);
		
		foreach ($plugins as $plugin)
		{
			$result[]=str_replace(os_join_path($plugins_path,''),'',$plugin);
		}
		
		return $result;
	}
	
	public function getSocialSignals($url)
	{
		$result=false;
		
		if ($this->socialNetwork)
		{
			$result=$this->socialNetwork->getSignals($url);
		}
		
		return $result;
	}
	
	public function getAllSocialSignals($url)
	{
		$result=false;
		
		if ($plugins=$this->getAvailableSocialNetworks())
		{
			foreach ($plugins as $plugin)
			{
				if ($this->setSocialNetwork($plugin))
				{
					$result[$plugin]=$this->getSocialSignals($url);
				}
			}
		}
		
		return $result;
	}
}
?>