<?php
class OS_StopWords
{
	private static $_instance;
	
	private $lists;
	
	public function __construct()
	{
		$this->lists=false;
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_StopWords();
		}
		
		return self::$_instance;
	}
	
	public function loadList($list)
	{
		$result=false;
		
		if (!isset($this->lists[$list]))
		{
			if ($this->isListAvailable($list))
			{
				$listClass="OS_PLUGIN_StopWords_{$list}";
				
				$this->lists[$list]=call_user_func(array($listClass,'get_instance'));
//				$this->lists[$list]=$listClass::get_instance();
					
				if (is_object($this->lists[$list]))
				{
					$result=true;
				}
			}
		}
		else
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function loadLists($lists)
	{
		$result=true;
		
		foreach ($lists as $list)
		{
			if (!$this->loadList($list))
			{
				$result=false;
			}
		}
		
		return $result;
	}
	
	public function isListAvailable($list)
	{
		$result=false;
		
		$plugin_path=os_join_path(getOS()->getConfigVar('root_path'),'lib','classes','plugins','stopwords',$list);
		
		if (file_exists($plugin_path))
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function getAvailableLists($order_by='language')
	{
		$result=false;
		
		$lists=array();
		
		$plugins_path=os_join_path(getOS()->getConfigVar('root_path'),'lib','classes','plugins','stopwords');
		$plugins=glob(os_join_path($plugins_path,'*'),GLOB_ONLYDIR);
		
		foreach ($plugins as $plugin)
		{
			$lists[]=str_replace(os_join_path($plugins_path,''),'',$plugin);
		}
		
		foreach ($lists as $list)
		{
			if ($this->loadList($list))
			{
				$result[$list]=$this->lists[$list]->getListDetails();
			}
		}
		
		if ($order_by)
		{
			$sorter=getOS()->getSorter();
			
			$sorter->setSortBy($order_by);
			$sorter->setSortType('STRING');
			
			$sorter->sort($result);
		}
		
		return $result;
	}
	
	public function getListDetails($list)
	{
		$result=false;
		
		if ($this->loadList($list))
		{
			$result=$this->lists[$list]->getListDetails();
		}
		
		return $result;
	}
	
	public function getWords($list=false)
	{
		$result=array();
		
		if ($list)
		{
			if ($this->loadList($list))
			{
				$result=$this->lists[$list]->getWords();
			}
		}
		else
		{
			if ($this->lists)
			{
				foreach ($this->lists as $list)
				{
					$result=array_merge($result,$list->getWords());
				}
			}
		}
		
		if (empty($result))
		{
			$result=false;
		}
		
		return $result;
	}
}
?>