<?php
class OS_WidgetStatsOperations
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_WidgetStatsOperations();
		}
		
		return self::$_instance;
	}
	
	public function getWidgetStats($widget_id,$start_d=false)
	{
		$result=false;
		
		if (!$start_d)
		{
			$start_d=date('Y-m-d',time()-7*86400);
		}
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."widgets_stats WHERE widget_id=? AND stats_d>=?";
		$dbresult=$db->query($query,array($widget_id,$start_d));
		while ($row=$db->fetchRow($dbresult))
		{
			$oneDay=new OS_WidgetStats();
			$oneDay->set($row);
			
			$result[$row['id']]=$oneDay;
		}
		
		return $result;
	}
	
	public function getWidgetStatsDate($widget_id,$stats_d)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="SELECT * FROM ".$db->dbPrefix()."widgets_stats WHERE widget_id=? AND stats_d=?";
		$dbresult=$db->query($query,array($widget_id,$stats_d));
		if ($row=$db->fetchRow($dbresult))
		{
			$result=new OS_WidgetStats();
			$result->set($row);
		}
		
		return $result;
	}
	
	public function insertWidgetStats($widgetStats)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$time = $db->DBTimeStamp(time());
		$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
		
		$query="INSERT INTO ".$db->dbPrefix()."widgets_stats (widget_id,widget_name,stats_d,opens,adds,removes) VALUES (?,?,?,?,?,?,?,?)";
		$dbresult=$db->query($query,array($widgetStats->widget_id,$widgetStats->widget_name,$widgetStats->stats_d,$widgetStats->opens,$widgetStats->adds,$widgetStats->removes));
		
		if ($dbresult!==false)
		{
			$result=$db->getInsertId();
		}
		
		return $result;
	}
	
	public function updateWidgetStats($widgetStats)
	{
		$result=false;
		
		$db=getOS()->getDb();
		$time = $db->DBTimeStamp(time());
		$ip=(!empty($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'0.0.0.0');
		
		$query="UPDATE ".$db->dbPrefix()."widgets_stats SET opens=?,adds=?,removes=? WHERE `id`=?";
		$dbresult=$db->query($query,array($widgetStats->opens,$widgetStats->adds,$widgetStats->removes,$widgetStats->id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function deleteWidgetStatsFull($widget_id)
	{
		$result=false;
		
		$db=getOS()->getDb();
		
		$query="DELETE FROM ".$db->dbPrefix()."widgets_stats WHERE widget_id=?";
		$dbresult=$db->query($query,array($widget_id));
		
		if ($dbresult!==false)
		{
			$result=true;
		}
		
		return $result;
	}
	
	public function log($widget_id,$widget_name,$action)
	{
		$result=false;

		$log_path=os_join_path(getOS()->getConfigVar('storage_path'),'widget_stats.log');
		
		if ($file=fopen($log_path,'a+'))
		{
			$log_line="{$widget_id}|{$widget_name}|".time()."|{$action}\n";
			
			$result=fwrite($file,$log_line);
			
			fclose($file);
		}
		
		return $result;
	}
}
?>