<?php
class OS_PLUGIN_Backlinks_MajesticSimple
{
	private static $_instance;
	
	private $authData=false;
	
	public $hasAuth=false;
	public $requireAuth=false;
	
	public $engineDetails=array(
		'name'=>'majesticsimple',
		'title'=>"MajesticSeo - Simple API",
		'cachingTime'=>2592000
	);
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_Backlinks_MajesticSimple();
		}
		
		return self::$_instance;
	}
	
	public function getEngineDetails()
	{
		$result=array(
			'hasAuth'=>$this->hasAuth,
			'requireAuth'=>$this->requireAuth,
			'engineDetails'=>$this->engineDetails
		);
		
		return $result;
	}
	
	public function getBacklinks($url)
	{
		return false;
	}
	
	public function getUrlsMetrics($urls)
	{
		$result=false;
		
		$majestic_to_nice=json_decode('{"TrustFlow":"trust_flow","CitationFlow":"citation_flow","ExtBackLinks":"backlinks","RefDomains":"rootdomains"}');

		$apiUrl = "http://simpleapi.majesticseo.com/sapi/GetBacklinkStats?sak=SMTHN6&datasource=Fresh";
		
		$osHttp=getOS()->getHttp();
		
		$urls=array_chunk($urls,3);
		
		foreach ($urls as $urls_chunk)
		{
			$counter=0;
			$callUrl=$apiUrl."&items=".count($urls_chunk);
			
			foreach ($urls_chunk as $url)
			{
				$url=trim($url);
				$result[$url]=false;
				$callUrl.="&item{$counter}={$url}";
				$counter++;
			}

			if ($response=$osHttp->get($callUrl) AND $osHttp->success())
			{
				if ($response=json_decode($response,true) AND $response['ResponseCode']=='OK')
				{
					foreach ($response['Data'] as $response_url)
					{
						if (isset($result[$response_url['Item']]))
						{
							foreach ($majestic_to_nice as $key=>$val)
							{
								if (isset($response_url[$key]))
								{
									$result[$response_url['Item']][$val]=$response_url[$key];
								}
							}
						}
					}
				}
			}
		}
		
		return $result;
	}
}
?>