<?php
class OS_PLUGIN_Backlinks_SEOkicks
{
	private static $_instance;
	
	private $authData=false;
	
	public $hasAuth=false;
	public $requireAuth=false;
	
	public $engineDetails=array(
		'name'=>'seokicks',
		'title'=>"SEOkicks",
		'cachingTime'=>2592000
	);

	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_Backlinks_SEOkicks();
		}
		
		return self::$_instance;
	}
	
	public function getEngineDetails()
	{
		$result=array(
			'hasAuth'=>$this->hasAuth,
			'requireAuth'=>$this->requireAuth,
			'engineDetails'=>$this->engineDetails
		);
		
		return $result;
	}
	
	public function getBacklinks($url)
	{
		$result=false;
		
		$osHttp=getOS()->getHttp();
		$osUtils=getOS()->getUtils();
		
		$callUrl='http://www.seokicks.de/export?domain='.urlencode($osUtils->stripHTTP($url)).'&src_tld=&anchortext=';
		
		if ($response=$osHttp->get($callUrl) AND $osHttp->success())
		{
			$response=explode("\n",$response);
			unset($response['0']); //discard the header
			
			foreach ($response as $line)
			{
				$line=explode('";"',trim($line));
				
				if (count($line)==5)
				{
					$result[]=array(
						'source'=>substr($line[0],1),
						'target'=>$line[1],
						'anchor'=>$line[2],
						'nofollow'=>($line[3]==0?false:true),
						'source_domain_rank'=>substr($line[4],0,-1)
					);
				}
			}
		}
		
		return $result;
	}
	
	public function getUrlsMetrics($urls)
	{
		$result=false;
		
		$apiUrl = "http://www.seokicks.de/SEOkicksService/V1/inlinkData?appid=OpenS&query=";
		
		$osHttp=getOS()->getHttp();
		$osUtils=getOS()->getUtils();
		
		foreach ($urls as $url)
		{
			$callUrl=$apiUrl.urlencode($osUtils->stripHTTP($url));
			
			if ($response=$osHttp->get($callUrl) AND $osHttp->success())
			{
				$response=trim($response);
				
				libxml_use_internal_errors(true);
				$xml=simplexml_load_string($response);
				libxml_use_internal_errors(false);
				
				if ($xml)
				{
					$result[$url]=array(
						'links'=>(isset($xml->attributes()->linkpop)?(int)$xml->attributes()->linkpop:0),
						'roots'=>(isset($xml->attributes()->domainpop)?(int)$xml->attributes()->domainpop:0),
						'ips'=>(isset($xml->attributes()->ippop)?(int)$xml->attributes()->ippop:0),
						'subnets'=>(isset($xml->attributes()->netpop)?(int)$xml->attributes()->netpop:0),
					);
				}
			}
		}
		
		return $result;
	}	
}
?>