<?php
class OS_PLUGIN_Backlinks_WebMeUp
{
	private static $_instance;
	
	private $authData=false;
	
	public $hasAuth=true;
	public $requireAuth=false;
	
	public $engineDetails=array(
		'name'=>'webmeup',
		'title'=>"WebMeUp",
		'auth'=>array(
			'type'=>'input',
			'external_link'=>array('text'=>"Register for a WebMeUp account - use standard NOT Facebook",'url'=>'http://webmeup.com/signup.html'),
			'fields'=>array(
				'email'=>array('name'=>"Email",'required'=>true),
				'password'=>array('name'=>"Password",'required'=>true)
			)
		),
		'cachingTime'=>2592000
	);

	public function __construct()
	{
		$this->engineDetails['auth']['external_link']['text']=_("Register for a WebMeUp account - use standard NOT Facebook");
		$this->engineDetails['auth']['fields']['email']['name']=_("Email");
		$this->engineDetails['auth']['fields']['password']['name']=_("Password");
	}

	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_Backlinks_WebMeUp();
		}
		
		return self::$_instance;
	}
	
	public function getEngineDetails()
	{
		$result=array(
			'hasAuth'=>$this->hasAuth,
			'requireAuth'=>$this->requireAuth,
			'engineDetails'=>$this->engineDetails
		);
		
		return $result;
	}
	
	public function setAuthData($auth)
	{
		$result=true;
		
		foreach ($this->engineDetails['auth']['fields'] as $field=>$details)
		{
			if (isset($auth[$field]))
			{
				$this->authData[$field]=$auth[$field];
			}
			elseif ($details['required'])
			{
				$result=false;
				break;
			}
		}
		
		return $result;
	}
	
	public function getAuthData()
	{
		return $this->authData;
	}
	
	public function getBacklinks($url)
	{
		$result=false;
		
		$OS=getOS();
		$osHttp=$OS->getHttp();
		
		$tryNonAuth=true;
		if ($this->authData)
		{
			$osHttp->useCookies();
			
			$response=$osHttp->post('http://webmeup.com/signin.html',array('LoginForm[email]'=>$this->authData['email'],'LoginForm[password]'=>$this->authData['password'],'LoginForm[rememberMe]'=>0));
			
			if ($response AND $osHttp->success())
			{
				if (false!==strpos($response,'<a href="http://webmeup.com/profile/">My Account</a>'))
				{
					$response=$osHttp->post('http://webmeup.com/backlink/download',array('count'=>true,'mode'=>2,'url'=>$url));
					
					if ($response AND $osHttp->success())
					{
						$tryNonAuth=false;
						
						$result=array();
						
						if ($response=explode("\n",$response))
						{
							unset($response[0]);
							
							foreach ($response as $line)
							{
								$line=trim($line);
								
								if ($line=explode(',',$line) AND count($line)==6)
								{
									$result[]=array(
										'source'=>substr($line[0],1,-1),
										'target'=>substr($line[2],1,-1),
										'anchor'=>substr($line[3],1,-1),
										'nofollow'=>(substr($line[4],1,-1)=='nofollow'?true:false),
										'source_title'=>substr($line[1],1,-1)
									);
								}
							}
						}
					}
				}
			}
			
			$osHttp->useCookies(false);
		}
		
		if ($tryNonAuth)
		{
			$response=$osHttp->post('http://webmeup.com/backlink/search',array('count'=>true,'mode'=>2,'url'=>$url));
			
			if ($response AND $osHttp->success())
			{
				if ($response=json_decode($response,true))
				{
					if (empty($response['error']))
					{
						$result=array();
						
						if (!empty($response['backlinks']))
						{
							foreach ($response['backlinks'] as $backlink)
							{
								$result[]=array(
									'source'=>$backlink['url'],
									'target'=>(empty($backlink['toUrl'])?'':$backlink['toUrl']),
									'anchor'=>(empty($backlink['anchorText'])?'':$backlink['anchorText']),
									'nofollow'=>($backlink['follow']=='nofollow'?true:false),
									'source_title'=>$backlink['title']
								);
							}
						}
					}
				}
			}
		}
		
		return $result;
	}
	
	public function getUrlsMetrics($urls)
	{
		return false;
	}	
}
?>