<?php
class OS_PLUGIN_Cache_memcached
{
	private static $_instance;
	
	private $memcache;
	
	private $bucket=false;
	
	public $cacheType='memory';
	
	public function __construct()
	{
		$OS=getOS();
		
		if ($OS->getSettingsVar('cache_engine')=='memcached')
		{
			$cacheSettings=array('host'=>$OS->getSettingsVar('memcahed_host'),'port'=>$OS->getSettingsVar('memcached_port'));
			
			if ($cacheSettings['host'] AND $cacheSettings['port'])
			{
				$this->memcache=new Memcache();
				$this->memcache->connect($cacheSettings['host'],$cacheSettings['port']);
			}
			else
			{
				$this->memcache=false;
			}
		}
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_Cache_memcached();
		}
		
		return self::$_instance;
	}
	
	public function setBucket($bucket)
	{
		$result=false;
		
		if ($this->memcache)
		{
			$this->bucket=(is_array($bucket)?$bucket:array($bucket));
			
			$result=true;
		}
		
		return $result;
	}
	
	public function set($key,$value,$expire)
	{
		$result=false;
		
		if ($this->memcache)
		{
			$key=$this->getCacheKey($key);
			
			$result=$this->memcache->set($key,$value,0,$expire);
		}
		
		return $result;
	}
	
	public function get($key)
	{
		$result=false;
		
		if ($this->memcache)
		{
			$key=$this->getCacheKey($key);
			
			$result=$this->memcache->get($key);
		}
		
		return $result;
	}
	
	public function delete($key)
	{
		$result=false;
		
		if ($this->memcache)
		{
			$key=$this->getCacheKey($key);
			
			$result=$this->memcache->delete($key);
		}
		
		return $result;
	}
	
	public function getCacheKey($key)
	{
		$result=false;
		
		if ($this->memcache)
		{
			if ($this->bucket)
			{
				$result=implode('_',$this->bucket).'_'.$key;
			}
			else
			{
				$result=$key;
			}
		}
		
		return $result;
	}
	
	public function purge()
	{
		$result=false;
		
		if ($this->memcache)
		{
			$result=$this->memcache->flush();
		}
		
		return $result;
	}
}
?>