<?php
class OS_PLUGIN_GeoIP_MaxMindFlatFile
{
	private static $_instance;
	
	public function __construct()
	{
		$plugin_path=dirname(__FILE__);
		
		$connectorPath=os_join_path($plugin_path,'resources','maxmindConnector.php');
		$databasePath=os_join_path($plugin_path,'resources','GeoIP.dat');
		
		require_once($connectorPath);
		
		$connector=new maxmindConnector();
		
		if ($connector->open($databasePath,GEOIP_STANDARD))
		{
			$this->connector=$connector;
		}
		else
		{
			$this->connector=false;
		}
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_GeoIP_MaxMindFlatFile();
		}
		
		return self::$_instance;
	}
	
	public function getLocation($host)
	{
		$result=array();
		
		if ($this->connector)
		{
			$result=$this->connector->geoip_record_by_name($host);
		}
		
		return $result;
	}
}
?>