<?php
class OS_PLUGIN_GeoIP_MaxMindPECL
{
	private static $_instance;
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_GeoIP_MaxMindPECL();
		}
		
		return self::$_instance;
	}
	
	public function getLocation($host)
	{
		$result=false;
		
		if (geoip_db_avail(GEOIP_CITY_EDITION_REV1))
		{
			if ($result=@geoip_record_by_name($host))
			{
				$result['region_code']=$result['region'];
				$result['region_name']=geoip_region_name_by_code($result['country_code'],$result['region_code']);
			}
		}
		else
		{
			if ($country_code=@geoip_country_code_by_name($host))
			{
				$result=array(
					'continent_code'=>@geoip_continent_code_by_name($host),
					'country_code'=>$country_code,
					'country_code3'=>@geoip_country_code3_by_name($host),
					'country_name'=>@geoip_country_name_by_name($host),
				);
				
				if ($region=@geoip_region_by_name($host))
				{
					$result['region_code']=$region['region'];
					$result['region_name']=geoip_region_name_by_code($result['country_code'],$result['region_code']);
				}
			}
		}
		
		return $result;
	}
}
?>