<?php
class OS_PLUGIN_Rankings_Alexa
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_Rankings_Alexa();
		}
		
		return self::$_instance;
	}
	
	public function buildRankUrl($url)
	{
		return "http://data.alexa.com/data?cli=10&dat=snbamz&url={$url}";
	}
	
	public function getRank($url)
	{
		$result=false;
		
		$osUtils=getOS()->getUtils();
		
		$url=$osUtils->stripifyURL($url);
		
		$signalsUrl=$this->buildRankUrl($url);
		
		$osHttp=getOS()->getHttp();
		
		$response=$osHttp->get($signalsUrl);
		
		if ($response AND $osHttp->success())
		{
			$dom=new DOMDocument();
			
			libxml_use_internal_errors(true);
			$domLoaded=$dom->loadXML($response);
			libxml_use_internal_errors(false);
			
			if ($domLoaded)
			{
				$xpath=new DOMXPath($dom);
				$entry=$xpath->query("//POPULARITY[@URL='".$url."/']");
				
				if ($entry->item(0))
				{
					$result=$entry->item(0)->getAttribute('TEXT');
				}
			}
		}
		
		return $result;
	}
}
?>