<?php
class OS_PLUGIN_Rankings_PageRank
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_Rankings_PageRank();
		}
		
		return self::$_instance;
	}
	
	public function buildRankUrl($url)
	{
		return 'http://toolbarqueries.google.com/tbr?client=navclient-auto&ch='.$this->_bs_get_ch($url).'&features=Rank&q=info:'.$url.'&num=100&filter=0';
	}
	
	public function getRank($url)
	{
		$result=false;
		
		$osUtils=getOS()->getUtils();
		$osHttp=getOS()->getHttp();
		
		$url = $osUtils->stripHttp($url);
		
		$rankUrl=$this->buildRankUrl($url);
		
		$response=$osHttp->get($rankUrl);
		
		if ($osHttp->success())
		{
			if (empty($response))
			{
				$result=-1;
			}
			else
			{
				$pos = strpos($response, 'Rank_');
				
				$pr = substr($response, $pos + 9);
				$pr = trim($pr);
				$pr = str_replace("\n", '', $pr);
				
				$result=$pr;
			}
		}
		
		return $result;
	}
	
	private function _bs_str_to_num($Str, $Check, $Magic)
	{
		$Int32Unit = 4294967296;
		$length = strlen($Str);
		
		for ($i = 0; $i < $length; $i++)
		{
			$Check *= $Magic; 
				
			if ($Check >= $Int32Unit)
			{
				$Check = ($Check - $Int32Unit * (int) ($Check / $Int32Unit));
				$Check = ($Check < -2147483648) ? ($Check + $Int32Unit) : $Check;
 			}
			$Check += ord($Str{$i}); 
		}
		
		return $Check;
	}
	
	private function _bs_hash_url($String)
	{
		$Check1 = $this->_bs_str_to_num($String, 0x1505, 0x21);
		$Check2 = $this->_bs_str_to_num($String, 0, 0x1003F);
		
		$Check1 >>= 2;
		 	
		$Check1 = (($Check1 >> 4) & 0x3FFFFC0 ) | ($Check1 & 0x3F);
		$Check1 = (($Check1 >> 4) & 0x3FFC00 ) | ($Check1 & 0x3FF);
		$Check1 = (($Check1 >> 4) & 0x3C000 ) | ($Check1 & 0x3FFF);
			
		$T1 = (((($Check1 & 0x3C0) << 4) | ($Check1 & 0x3C)) <<2 ) | ($Check2 & 0xF0F );
		$T2 = (((($Check1 & 0xFFFFC000) << 4) | ($Check1 & 0x3C00)) << 0xA) | ($Check2 & 0xF0F0000 );
		
		return ($T1 | $T2);
	}
	
	private function _bs_check_hash($Hashnum)
	{
		$CheckByte = 0;
		$Flag = 0;
		$HashStr = sprintf('%u', $Hashnum) ;
		$length = strlen($HashStr);
		
		for ($i = $length - 1;  $i >= 0;  $i --)
		{
			$Re = $HashStr{$i};
			
			if (1 === ($Flag % 2))
			{              
				$Re += $Re;     
				$Re = (int)($Re / 10) + ($Re % 10);
			}
			
			$CheckByte += $Re;
			$Flag ++;	
		}
		
		$CheckByte %= 10;
		
		if (0 !== $CheckByte)
		{
			$CheckByte = 10 - $CheckByte;
	
			if (1 === ($Flag % 2) )
			{
				if (1 === ($CheckByte % 2))
				{
					$CheckByte += 9;
				}
				$CheckByte >>= 1;
			}
		}
		return '7'.$CheckByte.$HashStr;
	}
	
	private function _bs_get_ch($url)
	{ 
		return $this->_bs_check_hash($this->_bs_hash_url($url)); 
	}
}
?>