<?php
class OS_PLUGIN_SearchEngine_baidu
{
	private static $_instance;
	
	public $searchUrlPattern="http://baidu.com/s?wd=##query##";
	
	public $serpReferral=array(
		'domain_pattern'=>'.baidu.com',
		'query_param'=>'wd'
	);
	
	public $title='Baidu';
	public $domain='baidu.com';
	
	public $hasLocales=false;
	
	public $cacheTime=86400;
	
	public function getSearchUrl($query,$offset=false,$results_per_page=false)
	{
		return str_replace('##query##',urlencode($query),$this->searchUrlPattern);
	}
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_SearchEngine_Baidu();
		}
		
		return self::$_instance;
	}
	
	public function getDomain()
	{
		return $this->domain;
	}
	
	public function getResults($serp)
	{
		$result=false;
		
		$dom=new DOMDocument();
		
		libxml_use_internal_errors(true);
		$dom->loadHTML($serp);
		libxml_use_internal_errors(false);
		
		$xpath=new DOMXPath($dom);
		
		$entries=$xpath->query("//td[@class='f']");

		foreach ($entries as $entry)
		{
			$title=$xpath->query("h3[@class='t']/a",$entry);
			
			if ($title->item(0))
			{
				$url=$title->item(0)->getAttribute('href');
				$title=$title->item(0)->nodeValue;
				
				$desc=$xpath->query("font[@size='-1']",$entry);
				
				if ($desc->item(0))
				{
					$desc=$desc->item(0)->nodeValue;
				}
				else
				{
					$desc='';
				}
					
				$result[]=array(
					'title'=>$title,
					'url'=>$url,
					'description'=>$desc
				);
			}
		}
		
		return $result;
	}

	public function getResultsNumber($serp)
	{
		$result=false;
		
		$dom=new DOMDocument();
		
		libxml_use_internal_errors(true);
		$dom->loadHTML($serp);
		libxml_use_internal_errors(false);
		
		$xpath=new DOMXPath($dom);
		
		$entries=$xpath->query("//span[@id='nums']");
		
		if ($entries->item(0))
		{
			$text=$entries->item(0)->nodeValue;
			
			$text=explode(' ',$text);
			
			foreach ($text as $txt)
			{
				$txt=str_replace(array('.',','),'',$txt);
				
				if (is_numeric($txt))
				{
					$result=$txt;
					
					break;
				}
			}
		}
		
		return $result;
	}
}
?>