<?php
class OS_PLUGIN_SearchEngine_bing_base
{
	public $offset=0;
	public $results_per_page=10;
	public $cacheTime=86400;
	
	public function getSearchUrl($query,$offset=false,$results_per_page=false)
	{
		return str_replace('##query##',urlencode($query),$this->searchUrlPattern)."&first=".($offset===false?$this->offset:$offset)."&count=".($results_per_page===false?$this->results_per_page:$results_per_page);
	}
	
	public function getDomain()
	{
		return $this->domain;
	}
	
	public function getResults($serp)
	{
		$result=false;
		
		$dom=new DOMDocument();
		
		libxml_use_internal_errors(true);
		$dom->loadHTML($serp);
		libxml_use_internal_errors(false);
		
		$xpath=new DOMXPath($dom);
		
		$entries=$xpath->query("//div[@id='results']//li[@class='sa_wr']//div[@class='sa_mc']");

		foreach ($entries as $entry)
		{
			$title=$xpath->query("div[@class='sb_tlst']/h3/a",$entry);
			
			if ($title->item(0))
			{
				$url=$title->item(0)->getAttribute('href');
				$title=$title->item(0)->nodeValue;
				
				$desc=$xpath->query("p",$entry);
				
				if ($desc->item(0))
				{
					$desc=$desc->item(0)->nodeValue;
				}
				else
				{
					$desc='';
				}
				
				$result[]=array(
					'title'=>$title,
					'url'=>$url,
					'description'=>$desc
				);
			}
		}
		
		return $result;
	}
	
	public function getResultsNumber($serp)
	{
		$result=false;
		
		$dom=new DOMDocument();
		
		libxml_use_internal_errors(true);
		$dom->loadHTML($serp);
		libxml_use_internal_errors(false);
		
		$xpath=new DOMXPath($dom);
		
		$entries=$xpath->query("//span[@class='sb_count']");
		
		if ($entries->item(0))
		{
			$text=$entries->item(0)->nodeValue;
			
			$text=explode(' ',$text);
			
			foreach ($text as $txt)
			{
				$txt=str_replace(array('.',','),'',$txt);
				
				if (is_numeric($txt))
				{
					$result=$txt;
					
					break;
				}
			}
		}
		
		return $result;
	}
	
	public function setResultsPerPage($results_per_page)
	{
		$this->results_per_page=$results_per_page;
		
		return true;
	}
	
	public function setOffset($offset)
	{
		$this->offset=$offset;
		
		return true;
	}
}
?>