<?php
class OS_PLUGIN_SearchEngine_google_base
{
	public $offset=0;
	public $options=array();
	public $results_per_page=10;
	public $cacheTime=86400;
	
	public function getSearchUrl($query,$offset=false,$results_per_page=false)
	{
		$url=str_replace('##query##',urlencode($query),$this->searchUrlPattern)."&start=".($offset===false?$this->offset:$offset)."&num=".($results_per_page===false?$this->results_per_page:$results_per_page);
		
		if ($this->options)
		{
			foreach ($this->options as $option=>$value)
			{
				$url.="&".urlencode($option)."=".urlencode($value);
			}
		}
		
		$url.="source=hp&oq=".urlencode($query)."&bav=on.2,or.&bvm=bv.47244034,d.ZWU&biw=1280&bih=911";
		
		return $url;
	}
	
	public function getDomain()
	{
		return $this->domain;
	}
	
	public function getResults($serp)
	{
		$result=array();
		
		$dom=new DOMDocument();
		
		libxml_use_internal_errors(true);
		$dom->loadHTML($serp);
		libxml_use_internal_errors(false);
		
		$xpath=new DOMXPath($dom);
		
		$testIfNoResults=$xpath->query("//div[@id='topstuff']/div[@class='med']");
		if ($testIfNoResults->item(0))
		{
			return false;
		}
		else
		{
			$testIfNoResults=$xpath->query("//div[@id='topstuff']/div[@class='e obp']");
			if ($testIfNoResults->item(0))
			{
				return false;
			}
		}

		$entries=$xpath->query("//li[@class='g']");
		$skip_ids=array('newsbox','imagebox_bigimages','videobox','productbox');

		foreach ($entries as $entry)
		{
			$skip=false;
			
			if ($id=$entry->getAttribute('id'))
			{
				if (in_array($id,$skip_ids))
				{
					$skip=true;
				}
			}
			
			if (!$skip)
			{
				$testNewDesign=$xpath->query(".//div[@class='vsc']",$entry);
				
				if ($testNewDesign->item(0))
				{
					$class=$testNewDesign->item(0)->getAttribute('class');
					
					if (false===strpos($class,'sld'))
					{
						$entry=$testNewDesign->item(0);
					}
				}
				
				$title=$xpath->query(".//h3[contains(concat(' ',@class,' '),' r ')]/a",$entry);
				
				if ($title->item(0))
				{
					$url=$this->getActualUrl($title->item(0)->getAttribute('href'));
					
					if (parse_url($url,PHP_URL_HOST))
					{
						$title=$title->item(0)->nodeValue;
						
						$desc=$xpath->query(".//span[@class='st']",$entry);
						
						if ($desc->item(0))
						{
							$desc=$desc->item(0)->nodeValue;
						}
						else
						{
							$desc='';
						}
						
						$result[]=array(
							'title'=>$title,
							'url'=>$url,
							'description'=>$desc
						);
					}
				}
			}
		}

		return $result;
	}
	
	public function getResultsNumber($serp)
	{
		$result=false;
		
		$dom=new DOMDocument();
		
		libxml_use_internal_errors(true);
		$dom->loadHTML($serp);
		libxml_use_internal_errors(false);
		
		$xpath=new DOMXPath($dom);
		
		$testIfNoResults=$xpath->query("//div[@id='topstuff']/div[@class='med']");
		if ($testIfNoResults->item(0))
		{
			return 0;
		}
		else
		{
			$testIfNoResults=$xpath->query("//div[@id='topstuff']/div[@class='e obp']");
			if ($testIfNoResults->item(0))
			{
				return 0;
			}
		}
		
		$entries=$xpath->query("//div[@id='resultStats']");
		
		if ($entries->item(0))
		{
			$text=$entries->item(0)->nodeValue;
			
			$text=explode(' ',$text);
			
			$numbers=array();
			
			foreach ($text as $txt)
			{
				$txt=str_replace(array('.',','),'',$txt);
				
				if (is_numeric($txt))
				{
					$numbers[]=$txt;
				}
			}

			if (count($numbers)==1)
			{
				$result=$numbers[0];
			}
			elseif (count($numbers)==2)
			{
				$result=$numbers[1];
			}
		}
		
		return $result;
	}
	
	public function setResultsPerPage($results_per_page)
	{
		$this->results_per_page=$results_per_page;
		
		return true;
	}
	
	public function setOffset($offset)
	{
		$this->offset=$offset;
		
		return true;
	}
	
	public function setOption($option,$value)
	{
		$this->options[$option]=$value;
		
		return true;
	}
	
	public function unsetOption($option)
	{
		$result=false;
		
		if (isset($this->options[$option]))
		{
			unset($this->options[$option]);
			
			$result=true;
		}
		
		return $result;
	}
	
	private function getListingType($entry)
	{
	}
	
	private function getActualUrl($url)
	{
		$result=false;
		
		if (0===strpos($url,'/url?'))
		{
			$url=substr($url,5);
			parse_str($url,$url);
			
			if (is_array($url))
			{
				if (isset($url['url']))
				{
					$result=urldecode($url['url']);
				}
				elseif (isset($url['q']))
				{
					$result=urldecode($url['q']);
				}
			}
		}
		else
		{
			$result=$url;
		}
		
		return $result;
	}
}
?>