<?php
class OS_PLUGIN_SearchEngine_rambler
{
	private static $_instance;
	
	public $searchUrlPattern="http://nova.rambler.ru/search?query=##query##";
	
	public $serpReferral=array(
		'domain_pattern'=>'.rambler.ru',
		'query_param'=>'query'
	);
	
	public $title='Rambler';
	public $domain='rambler.ru';
	
	public $hasLocales=false;
	
	public $cacheTime=86400;
	
	public function getSearchUrl($query,$offset=false,$results_per_page=false)
	{
		return str_replace('##query##',urlencode($query),$this->searchUrlPattern);
	}
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_SearchEngine_Rambler();
		}
		
		return self::$_instance;
	}
	
	public function getDomain()
	{
		return $this->domain;
	}
	
	public function getResults($serp)
	{
		$result=false;
		
		$dom=new DOMDocument();
		
		libxml_use_internal_errors(true);
		$dom->loadHTML($serp);
		libxml_use_internal_errors(false);
		
		$xpath=new DOMXPath($dom);
		
		$entries=$xpath->query("//ul[@class='b-serp__list']//li[@class='b-serp__list_item']");

		foreach ($entries as $entry)
		{
			$title=$xpath->query("h2[@class='b-serp__list_item_title']/a",$entry);
			
			if ($title->item(0))
			{
				$url=$title->item(0)->getAttribute('href');
				$title=$title->item(0)->nodeValue;
				
				$desc=$xpath->query("p[@class='b-serp__list_item_snippet']",$entry);
				
				if ($desc->item(0))
				{
					$desc=$desc->item(0)->nodeValue;
				}
				else
				{
					$desc='';
				}
				
				$result[]=array(
					'title'=>$title,
					'url'=>$url,
					'description'=>$desc
				);
			}
		}
		
		return $result;
	}
	
	public function getResultsNumber($serp)
	{
		return false;
	}
}
?>