<?php
class OS_PLUGIN_SearchEngine_yandex
{
	private static $_instance;
	
	public $searchUrlPattern="http://yandex.com/yandsearch?text=##query##";
	
	public $serpReferral=array(
		'domain_pattern'=>'.yandex.com',
		'query_param'=>'text'
	);
	
	public $title='Yandex';
	public $domain='yandex.com';
	
	public $hasLocales=false;
	
	public $cacheTime=86400;
	
	public function getSearchUrl($query,$offset=false,$results_per_page=false)
	{
		return str_replace('##query##',urlencode($query),$this->searchUrlPattern);
	}
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_SearchEngine_yandex();
		}
		
		return self::$_instance;
	}
	
	public function getDomain()
	{
		return $this->domain;
	}
	
	public function getResults($serp)
	{
		$result=false;
		
		$dom=new DOMDocument();
		
		libxml_use_internal_errors(true);
		$dom->loadHTML($serp);
		libxml_use_internal_errors(false);
		
		$xpath=new DOMXPath($dom);
		
		$entries=$xpath->query("//ol[@class='b-serp-list']//li[@class='b-serp-item']//div[@class='b-serp-item__wrapper']");

		foreach ($entries as $entry)
		{
			$title=$xpath->query("h2[@class='b-serp-item__title']/a[@class='b-serp-item__title-link']",$entry);
			
			if ($title->item(0))
			{
				$url=$title->item(0)->getAttribute('href');
				$title=$title->item(0)->nodeValue;
				
				$desc=$xpath->query("div[@class='b-serp-item__text']",$entry);
				
				if ($desc->item(0))
				{
					$desc=$desc->item(0)->nodeValue;
				}
				else
				{
					$desc='';
				}
					
				$result[]=array(
					'title'=>$title,
					'url'=>$url,
					'description'=>$desc
				);
			}
		}
		
		return $result;
	}
	
	public function getResultsNumber($serp)
	{
		$result=false;
		
		if ($start_pos=strpos($serp,'<div class="input__found">')+strlen('<div class="input__found">'))
		{
			if ($end_pos=strpos($serp,'</div>',$start_pos))
			{
				if ($number=substr($serp,$start_pos,$end_pos))
				{
					$replacements=array('&mdash;&nbsp;'=>'','answers'=>'','hundred'=>'00','thousand'=>'000','million'=>'000000','billion'=>'000000000',' '=>'');
					
					if ($number=trim(str_replace(array_keys($replacements),array_values($replacements),$number)))
					{
						if (is_numeric($number))
						{
							$result=$number;
						}
					}
				}
			}
		}
	}
	
	public function setResultsPerPage($results_per_page)
	{
		$this->results_per_page=$results_per_page;
		
		return true;
	}
	
	public function setOffset($offset)
	{
		$this->offset=$offset;
		
		return true;
	}
}
?>