<?php
class OS_PLUGIN_SocialSignals_SharedCount
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_SocialSignals_SharedCount();
		}
		
		return self::$_instance;
	}
	
	public function buildSignalsUrl($url)
	{
		return "http://api.sharedcount.com/?url=".rawurlencode($url);
	}
	
	public function getSignals($url)
	{
		$result=false;
		
		$signalsUrl=$this->buildSignalsUrl($url);
		
		$osHttp=getOS()->getHttp();
		
		$response=$osHttp->get($signalsUrl);
		
		if ($response AND $osHttp->success())
		{
			if ($response=json_decode($response,true))
			{
				$result=array(
					'stumbleupon'=>$response['StumbleUpon'],
					'reddit'=>$response['Reddit'],
					'facebook'=>array(
						'comments'=>(isset($response['Facebook']['comment_count'])?$response['Facebook']['comment_count']:0),
						'likes'=>(isset($response['Facebook']['like_count'])?$response['Facebook']['like_count']:0),
						'shares'=>(isset($response['Facebook']['share_count'])?$response['Facebook']['share_count']:0),
						'total'=>(isset($response['Facebook']['total_count'])?$response['Facebook']['total_count']:0)
					),
					'delicious'=>$response['Delicious'],
					'gplus'=>$response['GooglePlusOne'],
					'twitter'=>$response['Twitter'],
					'diggs'=>$response['Diggs'],
					'pinterest'=>$response['Pinterest'],
					'linkedin'=>$response['LinkedIn']
				);
			}
		}
		
		return $result;
	}
}
?>