<?php
class OS_PLUGIN_Textualizer_FullBody
{
	private static $_instance;
	
	private $contentAttributes=array(
		'a'=>array('title'),
		'img'=>array('title','alt')
	);
	
	private $ignoredTags=array('object','script','style','embed');
	
	private $options;
	
	public function __construct()
	{
		$this->options=array(
			'contentAttributes'=>true
		);
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_Textualizer_FullBody();
		}
		
		return self::$_instance;
	}
	
	public function setOption($option,$value)
	{
		$result=false;
		
		if (isset($this->options[$option]))
		{
			$this->options[$option]=$value;
			
			$result=true;
		}
		
		return $result;
	}
	
	public function extractText($dom)
	{
		$this->prepareDom($dom);
		
		return $this->getTextualContent($dom);
	}
	
	public function prepareDom(&$dom)
	{
		foreach ($this->ignoredTags as $tag)
		{
			$children=$dom->getElementsByTagName($tag);
			
			if (!empty($children))
			{
				for($i=$children->length-1;$i>=0;$i--)
				{
					$children->item($i)->parentNode->removeChild($children->item($i));
				}
			}
		}
		
		if ($this->options['contentAttributes'])
		{
			foreach ($this->contentAttributes as $tag=>$attributes)
			{
				$nodes=$dom->getElementsByTagName($tag);
				
				for ($i=$nodes->length-1;$i>=0;$i--)
				{
					$replace_with='';
					
					foreach ($attributes as $attribute)
					{
						if ($attribute_value=$nodes->item($i)->getAttribute($attribute))
						{
							$replace_with.=" {$attribute_value}";
						}
					}
					
					$replace_with=trim($replace_with);
					
					if (!empty($replace_with))
					{
						$nodes->item($i)->parentNode->replaceChild($dom->createTextNode($replace_with),$nodes->item($i));
					}
				}
			}
		}
	}
	
	public function getTextualContent($dom)
	{
		$result=false;
		
		$xpath=new DOMXPath($dom);
		
		$body=$xpath->query('//body');
		
		if (!empty($body))
		{
			$body=$body->item(0);
			
			if (!empty($body))
			{
				$result=$body->nodeValue;
			}
		}
		
		return $result;
	}
}
?>