<?php
class OS_PLUGIN_Textualizer_FullHead
{
	private static $_instance;
	
	public function __construct()
	{
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_Textualizer_FullHead();
		}
		
		return self::$_instance;
	}
	
	public function extractText($dom)
	{
		$result=false;
		
		$xpath=new DOMXPath($dom);
		
		$head=$xpath->query('//head');
		
		if ($head)
		{
			$head=$head->item(0);
			
			if ($head)
			{
				$result='';
				
				$title=$xpath->query('title',$head);
				
				if ($title)
				{
					$title=$title->item(0);
					
					if ($title)
					{
						$result.=' '.$title->nodeValue;
					}
				}
				
				
				$meta_desc=$xpath->query('meta[@name="description"]',$head);
				
				if ($meta_desc)
				{
					$meta_desc=$meta_desc->item(0);
					
					if ($meta_desc)
					{
						$result.=' '.$meta_desc->getAttribute('content');
					}
				}
				
				$meta_kws=$xpath->query('meta[@name="keywords"]',$head);
				
				if ($meta_kws)
				{
					$meta_kws=$meta_kws->item(0);
					
					if ($meta_kws)
					{
						$result.=' '.$meta_kws->getAttribute('content');
					}
				}
			}
		}
		
		return $result;
	}
}
?>