<?php
class OS_PLUGIN_Textualizer_FullHtml
{
	private static $_instance;
	
	private $options;
	
	public function __construct()
	{
		$this->options=array();
	}
	
	public static function &get_instance()
	{
		if (!is_object(self::$_instance))
		{
			self::$_instance=new OS_PLUGIN_Textualizer_FullHtml();
		}
		
		return self::$_instance;
	}
	
	public function setOption($option,$value)
	{
		$this->options[$option]=$value;
		
		return true;
	}
	
	public function extractText($dom)
	{
		$headExtractor=new OS_PLUGIN_Textualizer_FullHead();
		$bodyExtractor=new OS_PLUGIN_Textualizer_FullBody();
		
		if (!empty($this->options))
		{
			foreach ($this->options as $option=>$value)
			{
				if (method_exists($headExtractor,'setOption'))
				{
					$headExtractor->setOption($option,$value);
				}
				
				if (method_exists($bodyExtractor,'setOption'))
				{
					$bodyExtractor->setOption($option,$value);
				}
			}
		}
		
		$headText=$headExtractor->extractText($dom);
		$bodyText=$bodyExtractor->extractText($dom);
		
		return $headText.' '.$bodyText;
	}
}
?>