osDashboard = window.osDashboard || {};

$(function() {

// modal dialog init: custom buttons and a "close" callback reseting the form inside
var $dialog = $( "#dialog" ).dialog({
	autoOpen: false,
	modal: true,
	buttons: {
		Add: function() {
			
			osDashboard.addSection();
			console.log('add_tab_dialog');
			
			$( this ).dialog( "close" );
		},
		Cancel: function() {
			$( this ).dialog( "close" );
		}
	},
	open: function() {
		$( "#tab_title").focus();
	},
	close: function() {
		$form[ 0 ].reset();
	}
});

//addTab form: calls addTab function on submit and closes the dialog
var $form = $( "form", $dialog ).submit(function()
	{
	osDashboard.addSection();
	console.log('add_tab_form');
	
	$dialog.dialog( "close" );
	return false;
	});

// addTab button: just opens the dialog
$( "#add_tab" )
	.button()
	.click(function() {
		$dialog.dialog( "open" );
	});

// close icon: removing the tab on click
$( "#tabs span.ui-icon-close" ).live( "click", function(){

	//var index = $( "li", osDashboard.dashboardSections ).index( $( this ).parent() );
	
	var cSectionID = osDashboard.currentSectionID;
	
	osDashboard.showSectionOptions(cSectionID);
});		
	
});



var osDashboard = 
{
    settings : {
        columns : '.panel-column',
        widgetSelector: '.widget-container',
        handleSelector: '.widget-head',
        contentSelector: '.widget-content',
        widgetDefault : {
            movable: true,
            removable: true,
            collapsible: true,
            editable: true,
            colorClasses : ['color-yellow', 'color-red', 'color-blue', 'color-white', 'color-orange', 'color-green']
        },
        widgetIndividual : {
            intro : {
                movable: false,
                removable: false,
                collapsible: false,
                editable: false
            }
        }
    },	
		
    jQuery : $,
    
	dashSections : null,
	
	dashWidgets : null,
	
	dashboardSections: null,
	
	currentSectionID : null,
	
	currentSectionPanel : null,
	
	currentSectionTab: null,
	
	sectionsCounter : 0,
	
	widgetHeight : 200,
	
	sectionsData : null,
	
	sectionsLayout : null,
	
    moveNewColumnID : null,
    
    moveNewPosition : null,
		
	init : function()
	{
        this.activateDashBoard();
	},
	
	getDashboardDetails : function ()
	{
		xHttp.Post({section: 'dashboard', action:'getDashboardDetails',callback : this.getDashboardDetailsResponse});
	},

	getDashboardDetailsResponse : function(responseData)
	{
		if(responseData.actionStatus  ==  true)
			{
			var dashData =  responseData.actionData;
			
			osDashboard.sectionsData = dashData.sections;
			osDashboard.allWidgets = dashData.allwidgets;
			
			osDashboard.buildSectionsLayout();
			
			osDashboard.activateTabs();
			
			osDashboard.activateDialog();
			}
	},
	
	
	buildSectionsLayout : function()
	{
		var tmpData = {};
		
		if(osDashboard.allWidgets != null)
		{
		$.each(osDashboard.allWidgets, function(currentWidgetID,currentWidgetData)
			{
			cSectionID = currentWidgetData.section_id ;
			cColumnID = currentWidgetData.column_id ;
			
			if(typeof tmpData[cSectionID] == 'undefined') tmpData[cSectionID] = {'widgets':{},'maxWidgetsCount':0};
			
			if(typeof tmpData[cSectionID]['widgets'][cColumnID] == 'undefined') tmpData[cSectionID]['widgets'][cColumnID] = {}; 

			tmpData[cSectionID]['widgets'][cColumnID][currentWidgetData.position] = currentWidgetData.id;
				
			tmpLength = Object.keys(tmpData[cSectionID]['widgets'][cColumnID]).length;
			
			if(tmpLength > tmpData[cSectionID]['maxWidgetsCount'])
				{
				tmpData[cSectionID]['maxWidgetsCount'] = tmpLength; 
				}
			
			});
		}
		
		osDashboard.sectionsLayout = tmpData;
	},
	
	refreshPanelHeight : function()
	{
	
	var cSectionID = osDashboard.currentSectionID;
		
	//update current panel height
	tmpLength = $('#section-container-'+cSectionID).css('height');
	tmpLength = parseInt(tmpLength.replace(/[^\d]/g,""));
	tmpLength += 50;
		
	osDashboard.currentSectionPanel.css("height",tmpLength+"px");	
	},
	
	addSection : function()
	{
		var sectionTitle = $( "#tab_title").val() || "Section " + osDashboard.sectionsCounter;
		
		xHttp.Post({section: 'dashboard', action:'addSection', params:{'name':sectionTitle},callback: this.addSectionResponse});
	},
	
	
	addSectionResponse : function(responseData)
	{
		//take sectionTitle and sectionID from responseData;
		if(responseData.actionStatus  ==  true)
		{
			var sectionData = responseData.actionData;
			
			var sectionTitle = sectionData.name;
			var sectionID = sectionData.id
			
			if(osDashboard.sectionsData == null) osDashboard.sectionsData = {};
			
			osDashboard.sectionsData[sectionID] = sectionData;

			osDashboard.createSection(sectionID, sectionTitle);
		}
		else
		{
			//throw error
		}
	
	},
	
	removeSection : function(sectionID)
	{
		xHttp.Post({section: 'dashboard', action:'removeSection', params:{'sectionID':sectionID}, callback: this.removeSectionResponse});
		
	},
	
	removeSectionResponse : function(responseData)
	{
		if(responseData.actionStatus  ==  true)
			{
			var sectionID =  responseData.actionData.sectionID;
			
			var sections =  $( "li", osDashboard.dashboardSections ).find('a');

			$.each(sections, function(index,val)
				{
				if($(val).attr('href') == '#tabs-'+sectionID) osDashboard.dashboardSections.tabs( "remove", index );
				});
			}
		else{
			//throw error
			}
	},

	activateSidebar : function()
	{
		jQuery('#sidebar').show();
		jQuery('#main').css({width:'77%'});
	},
	
	deactivateSidebar : function ()
	{
		jQuery('#sidebar').hide();
		jQuery('#main').css({width:'100%'});
	},
	
    activateDashBoard : function ()
    {
    	//this.deactivateSidebar();
    	
    	if(this.dashSections !== null) this.buildDashBoardPanel();
    	else this.getDashboardDetails();
    },
    
    
    getWidgetByID : function(widgetID)
    {
    	var widgetData = false;
    	
    	if(osDashboard.allWidgets !== null)
    	{
    		if(typeof osDashboard.allWidgets[widgetID] != 'undefined')
			{
    			widgetData = osDashboard.allWidgets[widgetID];
			}
    	}
    		
    	return widgetData;
    },
    
    removeWidgetData : function(widgetID)
    {
    	var result = false;
    	
    	if(osDashboard.allWidgets !== null)
    	{
    		if(typeof osDashboard.allWidgets[widgetID] !== 'undefined')
			{
    			delete osDashboard.allWidgets[widgetID];
			
    			osDashboard.buildSectionsLayout();
    			
    			osDashboard.refreshPanelHeight();
			}
    	}
    	return result;
    },
    
    activateTabs : function()
    {
    	// tabs init with a custom tab template and an "add" callback filling in the content

    	osDashboard.dashboardSections = $("#tabs")
    		.tabs({
    		tabTemplate: "<li><a href='#{href}'>#{label}</a> <span class='ui-icon ui-icon-close' style='display:none'>Remove Tab</span></li>",
    		add: function( event, ui )
    			{
    			//osDashboard.dashboardSections.tabs('select', '#' + ui.panel.id);
    			},
    		show: osDashboard.handleTabShow,
    		remove: function(event,ui)
    			{
    			console.log('remove_tab_from_dashboard');
    			},
    		select: function(event,ui)
    			{
    			console.log('current_tab_select');
    			/*
    			console.log(ui.tab);
    			console.log(ui.panel);
    			console.log(ui.index);
    			*/
    			}
    		});
    	

    	if(osDashboard.sectionsData != null)
    		{
    		$.each(osDashboard.sectionsData, function(key,val)
    			{
    				osDashboard.createSection(key,val.name);
    			});
    		}
    },
    
    
    createSection : function(sectionID,sectionTitle)
    {
    	osDashboard.dashboardSections.tabs("add","#tabs-"+sectionID,sectionTitle);
		osDashboard.sectionsCounter++;
    },

    activateSectionPanel : function()
    {
    	var cSectionID = osDashboard.currentSectionID; 
    	
    	//build section panel (put it elsewhere)
    	
    	//build section options
    	var sectionOptionsHtml = jQuery('<div/>', {'id': 'panel-options-'+cSectionID, 'class': 'panel-options'});
    	
    	var cSectionData = osDashboard.sectionsData[cSectionID];
    	
    	sectionTitleBox = jQuery('<input>', {'type': 'text', id: 'section-name-box-'+osDashboard.currentSectionID, value: cSectionData.name});
    	
    	//handle sectionTitleBox change
    	sectionTitleBox.keyup(function(e){
    		osDashboard.currentSectionTab.html(this.value);
    		});
    	
    	//handle sectionTitleBox update
    	sectionTitleBox.blur(function(e){

    		var sSectionID = osDashboard.currentSectionID;
    		var sectionData = osDashboard.sectionsData[sSectionID];
    		var newSectionName = this.value;
    		
    		if(sectionData.name != newSectionName)
    			{
    			osDashboard.handleSectionEdit({name: newSectionName});
    			}
    		});
    	
    	
    	sectionLayout = jQuery('<div/>');
    	for(var i=1;i<=3;i++)
    		{
    		btnclass = (cSectionData.layout == i ? "green" : "red");
    		
    		var btnObj = jQuery('<button/>', {'class': 'btn', id: 'section-layout-btn-'+osDashboard.currentSectionID+'-'+i, html: "Layout "+i})
    		btnObj.addClass(btnclass);
    		sectionLayout.append(btnObj);
    		
    		btnObj.click(function(){
	    		parts = this.id.split('-');
	    		osDashboard.handleSectionEdit({layout: parts[4]});
	    		});
    		}
    			
    	
    	sectionDeleteBtn = jQuery('<button/>', {'class': 'btn red' , id: 'section-delete-btn-'+osDashboard.currentSectionID, html: "Delete Section"});
    	
    	sectionDeleteBtn.click(function(){osDashboard.handleSectionRemove();});
    	
    	//build section options container
    	sectionOptionsHtml.append(jQuery('<div/>', {'class': 'g4','html':sectionTitleBox}));
    	sectionOptionsHtml.append(jQuery('<div/>', {'class': 'g4','html':sectionLayout}));
    	sectionOptionsHtml.append(jQuery('<div/>', {'class': 'g4','html':sectionDeleteBtn}));
    	
    	//build columns container
    	var panelContainer = jQuery('<div/>', {'id': 'panel-container-'+cSectionID, 'class': 'panel-container'});
    	for(var i=1;i<=3;i++)
    		{
    		var columnObj = jQuery('<ul/>', {'id': 'column-'+cSectionID+'-'+i, 'class' : 'panel-column'});
    		//columnObj.addClass('panel-column-third');
    		panelContainer.append(columnObj);
    		}
    	
    	//show current panel view
    	tmpPanel = jQuery('<div/>', {'id': 'section-container-'+cSectionID, 'class': 'panel-container'});
    	tmpPanel.append(sectionOptionsHtml);
    	tmpPanel.append(panelContainer);
    	
    	osDashboard.currentSectionPanel.html(tmpPanel);
    },
    
    activateWidgets : function()
    {
    	//generate current panel html
    	osDashboard.activateSectionPanel();
    	
    	var cSectionID = osDashboard.currentSectionID;
    	
    	if(typeof osDashboard.sectionsLayout[cSectionID] != 'undefined')
    	{
    		var sectionWidgets = osDashboard.sectionsLayout[cSectionID]['widgets'];
    		
    		$.each(sectionWidgets, function(columnID,columnData)
				{
				items = []; 
				$.each(columnData, function(widgetPosition,widgetID)
					{		
					if(typeof osDashboard.allWidgets[widgetID] !== 'undefined')
						{
						var widgetData = osDashboard.allWidgets[widgetID];
						var widgetContainerHTML = osDashboard.buildWidgetContainer(widgetData);
						
						items.push(widgetContainerHTML);
						$('#column-'+cSectionID+'-'+columnID).append(widgetContainerHTML);
						}
					});
				
				//$('#column-'+cSectionID+'-'+columnID).html(items.join(''));
				});

    	
    	osDashboard.handleSectionLayout();
    	}
    },
    
    
    activateDialog : function()
    {
    	//generates dialog box to create another section
    },
    
    buildWidgetContainer : function(osWidgetHandler)
    {
    	//var iframe_src = '../users/widget.php?wid='+osWidgetHandler.id;
    	//var content = '<iframe src="'+iframe_src+'" width="100%" height="100%" frameborder="0" scrolling="no"></iframe>';
    	
    	content = 'IFRAMED CONTENT';
    	
    	html = '<li class="widget-container color-red" id="'+osWidgetHandler.id+'">';  
    	html += '<div class="widget-head">';
    	html += '<b>'+osWidgetHandler.name+'</b>';
    	html += '</div>'
    	html += '<div class="widget-content">'+content+'</div>';
    	html += '</li>';
    	
    	return html;
    },
    
    handleTabShow : function(event,ui)
    {
    	//Get currentSectionID
    	tmpVal = $(ui.tab).attr('href');
    	parts = tmpVal.split('-');
    	
    	var cSectionID = parts[1];
    	
    	osDashboard.currentSectionID  = cSectionID;
		
		osDashboard.currentSectionPanel = $(ui.panel);
		osDashboard.currentSectionTab = $(ui.tab);
		
		$(ui.tab.parentElement).find('span').css('display','block');
		
		if(typeof osDashboard.allWidgets != null)
		{
			osDashboard.activateWidgets();
			osDashboard.refreshPanelHeight();
		}
    },
    
    /*--Ajax calls--*/
    
    handleSectionEdit : function(sectionData)
    {
    	var cSectionID = osDashboard.currentSectionID;
    	
    	xHttp.Post({section: 'dashboard', action:'sectionEdit', params:{'sectionData':sectionData, 'sectionID':cSectionID}, callback: this.sectionEditResponse});
    },
    
    sectionEditResponse : function(responseData)
    {
    	if(responseData.actionStatus  ==  true)
    	{
    		cSectionID = osDashboard.currentSectionID;
    		
    		//get old and new section data
    		oldSectionData = osDashboard.sectionsData[cSectionID];
    		newSectionData = responseData.actionData.sectionData;
    		
    		//replace sectionData
    		osDashboard.sectionsData[cSectionID] = newSectionData; 
    		
    		oldLayout =  oldSectionData.layout;
    		newLayout =  newSectionData.layout;
    		
    		//check if layout has been changed
    		if(oldLayout != newLayout)
    		{
        		$('#section-layout-btn-'+cSectionID+'-'+oldLayout).removeClass().addClass("btn red");
        		$('#section-layout-btn-'+cSectionID+'-'+newLayout).removeClass().addClass("btn green");
        		
        		//TODO: change columns style to the corresponding layout
        		osDashboard.handleSectionLayout();
    		}
    	}
    },
    
    handleSectionLayout : function()
    {
		cSectionID = osDashboard.currentSectionID;
		
		if(typeof osDashboard.sectionsData[cSectionID] != 'undefined')
		{
			var layoutClasses = {
				1 : ['full','half','half'], 	
				2 : ['third','third','third'],
				3 : ['half','half','full']
				};
			
			var cSectionData = osDashboard.sectionsData[cSectionID];
			
			var newLayout =  cSectionData.layout; 
			
	    	for(var i=1;i<=3;i++)
			{
	    		$("#column-"+cSectionID+"-"+i).removeClass().addClass("panel-column ui-sortable panel-column-"+layoutClasses[newLayout][(i-1)]);
			}
	    	
    		osDashboard.refreshPanelHeight();
		}
    },
    
    addWidget2Section : function(widgetID)
    {
    	var cSectionID = osDashboard.currentSectionID;
    	
    	xHttp.Post({section: 'dashboard', action:'addWidget2Section', params:{'widgetID':widgetID, 'sectionID': cSectionID}, callback: this.addWidget2SectionResponse});
    },
    
    addWidget2SectionResponse : function(responseData)
    {
    	if(responseData.actionStatus  ==  true)
		{
    		var data = responseData.actionData;
    		
    		var osWidgetHandler = data.osWidgetHandler;
    		
    		var widgetHanderID = osWidgetHandler.id;
    		
    		osDashboard.allWidgets[widgetHanderID] = osWidgetHandler;
    		
    		osDashboard.buildSectionsLayout();
    		
    		osDashboard.activateWidgets();
    		osDashboard.refreshPanelHeight();
		}
    },
    
    showSectionOptions :  function(sectionID)
    {
    	
	  $('#panel-options-'+sectionID).slideToggle('slow', function() {
		  	console.log('showSectionOptions'+sectionID);
		  	
		  	osDashboard.refreshPanelHeight();
		  });
    	
    },
    
    hideSectionOptions :  function(sectionID)
    {
    	
    },
    
    
    /*inettuts code begin*/
    
    refreshPanel : function ()
    {
        this.addWidgetControls();
        this.makeSortable();
    },
    
    getWidgetSettings : function (id)
    {
        var $ = this.jQuery,
            settings = this.settings;
        return (id&&settings.widgetIndividual[id]) ? $.extend({},settings.widgetDefault,settings.widgetIndividual[id]) : settings.widgetDefault;
    },
    
    addWidgetControls : function ()
    {
        var iNettuts = this,
            $ = this.jQuery,
            settings = this.settings;
            
        $(settings.widgetSelector, $(settings.columns)).each(function () {
            var thisWidgetSettings = osDashboard.getWidgetSettings(this.id);
            
            if (thisWidgetSettings.removable) {
                $('<a href="#" class="remove">CLOSE</a>')
                .mousedown(function (e) {e.stopPropagation();})
                .click(osDashboard.handleWidgetRemove).appendTo($(settings.handleSelector, this));
            }
            
            if (thisWidgetSettings.editable) {
                $('<a href="#" class="edit">EDIT</a>').mousedown(function (e) {e.stopPropagation();})
                .toggle(function () {
                    $(this).css({backgroundPosition: '-66px 0', width: '55px'})
                        .parents(settings.widgetSelector)
                        .find('.edit-box').show().find('input').focus();
                    return false;
                },function () {
                    $(this).css({backgroundPosition: '', width: ''})
                        .parents(settings.widgetSelector)
                        .find('.edit-box').hide();
                    return false;
                }).appendTo($(settings.handleSelector,this));
                
                $('<div class="edit-box" style="display:none;"/>')
                    .append('<ul><li class="item"><label>Change the title?</label><input value="' + $('h3',this).text() + '"/></li>')
                    .append((function(){
                        var colorList = '<li class="item"><label>Available colors:</label><ul class="colors">';
                        $(thisWidgetSettings.colorClasses).each(function () {
                            colorList += '<li class="' + this + '"/>';
                        });
                        return colorList + '</ul>';
                    })())
                    .append('</ul>')
                    .insertAfter($(settings.handleSelector,this));
            }
            
            if (thisWidgetSettings.collapsible)
            	{
	                var osWidget = osDashboard.getWidgetByID(this.id);
	                var collapseBtn = $('<a href="#" class="collapse">COLLAPSE</a>');
	                var isCollapsed = false;

	                if(osWidget !== false) if(osWidget.collapsed == "Y") isCollapsed = true;
                
	                if(isCollapsed)
	                {
                    	collapseBtn.css({backgroundPosition: '-38px 0'});
        	            $(this).find(settings.contentSelector).hide();
        	            collapseBtn.toggle(osDashboard.handleCollapseShow,osDashboard.handleCollapseHide);
	                }
	                else
	                {
	                	collapseBtn.toggle(osDashboard.handleCollapseHide,osDashboard.handleCollapseShow);
	                }	
                	
	                collapseBtn.mousedown(function (e) {e.stopPropagation();})
	                	.prependTo($(settings.handleSelector,this));
            	}
        });
        
        $('.edit-box').each(function ()
        	{
            $('input',this).keyup(function ()
            	{
               	$(this).parents(settings.widgetSelector).find('h3').text( $(this).val().length>20 ? $(this).val().substr(0,20)+'...' : $(this).val() );
            	});
            
            $('ul.colors li',this).click(function ()
            	{
                
                var colorStylePattern = /\bcolor-[\w]{1,}\b/,
                    thisWidgetColorClass = $(this).parents(settings.widgetSelector).attr('class').match(colorStylePattern)
                    
                if (thisWidgetColorClass)
                	{
                    $(this).parents(settings.widgetSelector)
                        .removeClass(thisWidgetColorClass[0])
                        .addClass($(this).attr('class').match(colorStylePattern)[0]);
                	}
                return false;
                
            	});
        	});
        
    },
    
    attachStylesheet : function (href)
    {
        var $ = this.jQuery;
        return $('<link href="' + href + '" rel="stylesheet" type="text/css" />').appendTo('head');
    },
    
    makeSortable : function ()
    {
    	
    	var iNettuts = this,
            $ = this.jQuery,
            settings = this.settings,
            $sortableItems = (function () {
            	
            	var notSortable = '';
            	
            	$(settings.widgetSelector,$(settings.columns)).each(function (i) {
                    if (!osDashboard.getWidgetSettings(this.id).movable) {
                        if(!this.id) {
                            this.id = 'widget-no-id-' + i;
                        }
                        notSortable += '#' + this.id + ',';
                    }
                });
            	
            	var sortableID = (notSortable=='' ? '> li' : '> li:not(' + notSortable + ')');
            	
            	return $(sortableID, settings.columns);
            })();
        
        $sortableItems.find(settings.handleSelector).css({
            cursor: 'move'
        }).mousedown(function (e) {
            $sortableItems.css({width:''});
            $(this).parent().css({
                width: $(this).parent().width() + 'px'
            });
        }).mouseup(function () {
            if(!$(this).parent().hasClass('dragging')) {
                $(this).parent().css({width:''});
            } else {
                $(settings.columns).sortable('disable');
            }
        });
        

        $(settings.columns).sortable({
            items: $sortableItems,
            connectWith: $(settings.columns),
            handle: settings.handleSelector,
            placeholder: 'widget-placeholder',
            forcePlaceholderSize: true,
            revert: 300,
            delay: 100,
            opacity: 0.8,
            containment: 'document',
            start: osDashboard.handleWidgetStart,
            stop: osDashboard.handleWidgetStop,
            update: osDashboard.handleWidgetUpdate,
            over: osDashboard.handleWidgetOver,
            receive: osDashboard.handleWidgetReceive
        });
    },
    
    handleWidgetStart : function (e,ui)
    {
    	console.log('handleWidgetStart');
    	
    	jQuery(ui.helper).addClass('dragging');
    },

    handleWidgetStop : function (e,ui)
    {
    	console.log('handleWidgetStop');
    	
    	var widgetID = $(ui.item).attr("id");
    	
    	//check if widget moved from other column
    	if(osDashboard.moveNewColumnID == null || osDashboard.moveNewPosition == null)
    	{
	    	var columnIDParts = $(this).attr("id").split("-");
	    	var elements_order = $(this).find('li.widget');
	    	
	    	var position = 1; var flag = false;
	    	$.each(elements_order, function(index,widgetContainer)
	    		{
	    		if(!flag)
	    			{
	    			if(widgetContainer.id == widgetID) flag = true;
	    			else position++;
	    			}
	    		});

	    	osDashboard.moveNewColumnID = columnIDParts[2];
	    	osDashboard.moveNewPosition = position;
    	}

    	
    	if(osDashboard.moveNewColumnID != null && osDashboard.moveNewPosition != null)
    		{
        	xHttp.Post({
        		section: 'dashboard', 
        		action:'moveWidgetContainer',
        		params: {widgetID:widgetID, newColumnID: osDashboard.moveNewColumnID, newPosition: osDashboard.moveNewPosition}, 
        		callback : osDashboard.moveWidgetContainerResponse
        		});
        	
        	osDashboard.moveNewColumnID = null;
        	osDashboard.moveNewPosition = null;
    		}
    	
    	jQuery(ui.item).css({width:''}).removeClass('dragging');
    	jQuery(osDashboard.settings.columns).sortable('enable');
    },

    handleWidgetUpdate : function (e,ui)
    {
    	console.log('handleWidgetUpdate');
    },

    handleWidgetOver : function (e,ui)
    {
    	console.log('handleWidgetOver');
    },

    handleWidgetReceive : function (e,ui)
    {
    	console.log('handleWidgetReceive');
    	
    	var widgetID = $(ui.item).attr("id");
    	var columnIDParts = $(this).attr("id").split("-");
    	
    	var elements_order = $(this).find('li.widget');
    	
    	var position = 1; var flag = false;
    	$.each(elements_order, function(index,widgetContainer)
    		{
    		if(!flag)
    			{
    			if(widgetContainer.id == widgetID) flag = true;
    			else position++;
    			}
    		});
    	
    	osDashboard.moveNewColumnID = columnIDParts[2];
    	osDashboard.moveNewPosition = position;
    },
    
    moveWidgetContainerResponse : function(responseData)
    {
    	if(responseData.actionStatus === true)
		{
    		//update widgets data
    		var data = responseData.actionData;
    		osDashboard.allWidgets = data.dashboardData.allwidgets;
    		
    		osDashboard.buildSectionsLayout();
    		
    		osDashboard.refreshPanelHeight();
    		osDashboard.activateWidgets();
		}		
    },
    
    handleCollapseHide : function()
    {
    	var widgetID = $(this).parent().parent().attr("id");
    	
    	xHttp.Post({section: 'dashboard', action:'hideWidgetContainer',params: {widgetID:widgetID}, callback : osDashboard.hideWidgetContainerResponse});
    	
    	return false;
    },
    
    hideWidgetContainerResponse : function(responseData)
    {
    	if(responseData.actionStatus === true)
    		{
    		var widgetID = responseData.actionData.widgetID;
    		
    		var collapseBtn = $($('#'+widgetID).find('a.collapse'))[0];
    		
    		var settings = osDashboard.settings;

    		$(collapseBtn).css({backgroundPosition: '-38px 0'})
            .parents(settings.widgetSelector)
                .find(settings.contentSelector).hide();
    		}
    },
    
    handleCollapseShow : function()
    {
    	var widgetID = $(this).parent().parent().attr("id");
    	
    	xHttp.Post({section: 'dashboard', action:'showWidgetContainer',params: {widgetID:widgetID}, callback : osDashboard.showWidgetContainerResponse});
    	
    	return false;
    },
    
    showWidgetContainerResponse : function(responseData)
    {
    	if(responseData.actionStatus === true)
			{
    		var widgetID = responseData.actionData.widgetID;
    		
    		var collapseBtn = $($('#'+widgetID).find('a.collapse'))[0];
    		
    		var settings = osDashboard.settings;
	
	    	$(collapseBtn).css({backgroundPosition: ''})
	        .parents(settings.widgetSelector)
	            .find(settings.contentSelector).show();
	    	
			}
    },
    
    handleSectionRemove : function()
    {
    	if(confirm('Are you sure you want to remove this section ?'))
        {
    		var cSectionID = osDashboard.currentSectionID;
    		osDashboard.removeSection(cSectionID);
        }
        return false;
    },
    
    handleWidgetRemove : function()
    {
    	var widgetID = $(this).parent().parent().attr("id");
    	
        if(confirm('This widget will be removed, ok?'))
        {
        	xHttp.Post({section: 'dashboard', action:'removeWidget',params: {widgetID:widgetID}, callback : osDashboard.removeWidgetResponse});
        }
        return false;
    },

    removeWidgetResponse : function(responseData)
    {
    	if(responseData.actionStatus === true)
		{
			var widgetID = responseData.actionData.widgetID;
			
			var removeBtn = $($('#'+widgetID).find('a.remove'))[0];
			
			var settings = osDashboard.settings;
			
			//remove current widget data
			var removeResult = osDashboard.removeWidgetData(widgetID);
			
			$(removeBtn).parents(settings.widgetSelector).animate({
	            opacity: 0    
	        },function () {
	            $(this).wrap('<div/>').parent().slideUp(function () {
	                
	            	$(this).remove();
	            });
	        });		
		}
    }
    
    
}

osDashboard.init();