osLauncher = window.osLauncher || {};

var osLauncher =
{
	jQuery : $,
    
    appManagerData : null,
    
    appBoardData : null,
    
    init : function ()
    {
        this.deactivateSidebar();
        this.addAppManagerControls();
        this.activateAppBoard();
    },


    openAppPanel : function (app_id)
    {
    	var appData = this.appBoardData[app_id];
    	
    	//console.log(appData);
    	
    	jQuery("#content").window({
    		title : appData.title,
    		url : appData.panel_link,
    		width : 800,
    		height : 600,
    		resizable : true,
    		checkBoundary: true,
    		//dock: 'bottom',
    		icon : appData.app_icon_manager,
		    x: 80,
		    y: 80    		
    		});	
    	
    	//this.openWindow(appData.title,appData.panel_link);    	
    },

    openWindow : function (title,url)
    {
    	jQuery.window({title : title,url : url});	
    },
    
    activateSidebar : function()
    {
    	jQuery('#sidebar').show();
    	jQuery('#main').css({width:'77%'});
    	jQuery('#app-board-panel').hide();
    	jQuery('#app-manager-panel').show();
    },

    deactivateSidebar : function ()
    {
    	jQuery('#sidebar').hide();
    	jQuery('#main').css({width:'100%'});
    	jQuery('#app-board-panel').show();
    	jQuery('#app-manager-panel').hide();
    },
    
    activateAppBoard : function ()
    {
    	this.deactivateSidebar();
    	
    	if(this.appManagerData !== null) this.buildAppBoardPanel();
    	else{
    		xHttp.Post({section: 'app_board', action:'getAppBoardData',callback : osLauncher.getAppBoardDataResponse});
    		}
    	
    	//show all hidden windows
    	jQuery.window.showAll();	
    },
    
    getAppBoardDataResponse : function(responseData)
    {
    	osLauncher.appBoardData = responseData;
		
		osLauncher.buildAppBoardPanel();
    },
    
    activateAppManager : function ()
    {
    	this.activateSidebar();
    	
    	if(this.appManagerData !== null) this.buildAppManagerPanel();
    	else{
    		xHttp.Post({section: 'app_board', action:'getAppManagerData',callback: osLauncher.getAppManagerDataResponse});
    		}
    	
    	//show all hidden windows
    	jQuery.window.hideAll();	
    },
    
    getAppManagerDataResponse : function (responseData)
    {
		osLauncher.appManagerData = responseData;
		
		osLauncher.buildAppManagerPanel();
    },
    
    buildAppManagerPanel : function()
    {
    	items = []; 
    	
    	jQuery.each(this.appManagerData, function(key, val) {
	
		var html = ''; 	
		html += '<article class="module width_half">';
		html += '<header><h3>'+val.name+'</h3></header>';
		html += '<div class="module_content">';
		html += '<fieldset>';
		html += '<img src="'+val.app_icon_manager+'" width="32" height="32">';
		html += '<div class="submit_link">';
					
		if(val.not_installed || val.is_stopped)
			html += '<input type="submit" onclick='+val.add_link+' value="Add" class="alt_btn" title="Add '+val.name+' App"><br>';
			
		if(val.is_enabled) html += '<input type="submit" onclick='+val.stop_link+' value="Stop" class="alt_btn"  title="Stop '+val.name+' App"><br>';
		else if(val.is_stopped) html += '<input type="submit" onclick='+val.remove_link+' value="Remove" class="alt_btn" title="Remove '+val.name+' App"><br>';
			
		html += '</div>';				
		html += '</fieldset>';
		html += '</div>';
		html += '</article>';
		  
		items.push(html);
		
	  });

    	jQuery('#app-manager-panel').html(jQuery('<div/>', {'class': 'my-new-list',html: items.join('')}));
    },
    
    buildAppBoardPanel : function()
    {
    	lists = [];items = [];
    	
    	jQuery.each(this.appBoardData, function(key, val) 
   		{
    		var html = '';
    		html += '<div class="module_content width_quarter">';
    		html += '<fieldset style="text-align:center">';
    		html += '<img src="'+val.app_icon_board+'" style="width:64px;height:64px;cursor:pointer;" onclick="'+val.open_link+'">';
    		html += '<div style="color:black;cursor:pointer;" onclick="'+val.open_link+'">'+val.title+'</div>';
    		html += '</fieldset>';
    		html += '</div>';
    		
    		items.push(html);
   		});
    	
    	lists.push(jQuery('<ul/>', {'class': 'widget color-blue', html: items.join('')}).html());

    	jQuery('#app-board-panel').html(jQuery('<div/>', {'id': 'columns', html: lists.join('')}));
    },
    
    addAppManagerControls : function ()
    {
    	jQuery('#add-apps-btn')
    		.click(function () {
    		
    		jQuery('#add-apps-btn').toggleClass('edit_link');
    			
    		if(jQuery('#add-apps-btn').hasClass('edit_link')) osLauncher.activateAppManager();
    		else osLauncher.activateAppBoard();
    		});
    },
    
    
    /*Apps management */ 
    addApp : function(app_id)
    {
    	xHttp.Post({section: 'app_board',action:'addApp',params:{'app_id':app_id},callback: osLauncher.startAppResponse});
    },
    
    startAppResponse : function (responseData)
    {
    	osLauncher.appBoardData = null;
    	osLauncher.appManagerData = null;
    	osLauncher.activateAppManager();
    },

    stopApp : function(app_id)
    {
    	xHttp.Post({section: 'app_board',action:'stopApp',params:{'app_id':app_id},callback: osLauncher.stopAppResponse});
    },
    
    stopAppResponse : function (responseData)
    {
    	osLauncher.appBoardData = null;
    	osLauncher.appManagerData = null;
    	osLauncher.activateAppManager();
    },
    
    removeApp : function(app_id)
    {
    	xHttp.Post({section: 'app_board',action:'removeApp',params:{'app_id':app_id},callback: osLauncher.removeAppResponse});
    },
    
    removeAppResponse : function (responseData)
    {
    	osLauncher.appBoardData = null;
    	osLauncher.appManagerData = null;
    	osLauncher.activateAppManager();
    },
    
}

osLauncher.init();