$(document).ready(function() {
  var switched = false;
  var copy = false;
  var scrollWidth = false;
  
  function getScrollbarWidth() {
    var outer = document.createElement("div");
    outer.style.visibility = "hidden";
    outer.style.width = "100px";
    document.body.appendChild(outer);
    
    var widthNoScroll = outer.offsetWidth;
    // force scrollbars
    outer.style.overflow = "scroll";
    
    // add innerdiv
    var inner = document.createElement("div");
    inner.style.width = "100%";
    outer.appendChild(inner);        
    
    var widthWithScroll = inner.offsetWidth;
    
    // remove divs
    outer.parentNode.removeChild(outer);
    
    return widthNoScroll - widthWithScroll;
}

  function getActualWidth()
  {
  	var width=$(window).width();
  	
  	if ($(window).height() < $("body").height())
  	{
  		width+=scrollWidth;
  	}
  	
  	return width;
  }
  
  var updateTables = function() {
  	if (scrollWidth===false)
  	{
  		scrollWidth=getScrollbarWidth();
  	}
  	
    if ((getActualWidth() <= 767) && !switched ){
      switched = true;
      $("table.responsive").each(function(i, element) {
      	if ($(element).hasClass('striped'))
      	{
      		$(element).addClass('striped-simple');
      		$(element).removeClass('striped');
      	}
        splitTable($(element));
      });
      return true;
    }
    else if (switched && (getActualWidth() > 767)) {
      switched = false;
      $("table.responsive").each(function(i, element) {
      	if ($(element).hasClass('striped-simple'))
      	{
      		$(element).removeClass('striped-simple');
      		$(element).addClass('striped');
      	}
      	
        unsplitTable($(element));
      });
    }
  };
   
  $(window).load(updateTables);
  $(window).on("redraw",function(){switched=false;updateTables();}); // An event to listen for
  $(window).on("resize", updateTables);
   
	
	function splitTable(original)
	{
		original.wrap("<div class='table-wrapper' />");
		
		copy = original.clone();
		copy.find("td:not(:first-child), th:not(:first-child)").css("display", "none");
		copy.removeClass("responsive");
		
		original.closest(".table-wrapper").append(copy);
		copy.wrap("<div class='pinned' />");
		original.wrap("<div class='scrollable' />");

    setCellHeights(original, copy);
	}
	
	function unsplitTable(original) {
    original.closest(".table-wrapper").find(".pinned").remove();
    original.unwrap();
    original.unwrap();
	}

  function setCellHeights(original, copy) {
    var tr = original.find('tr'),
        tr_copy = copy.find('tr'),
        heights = [];

    tr.each(function (index) {
      var self = $(this),
          tx = self.find('th, td');

      tx.each(function () {
        var height = $(this).outerHeight(true);
        heights[index] = heights[index] || 0;
        if (height > heights[index]) heights[index] = height;
      });
      
      $(this).height(heights[index]);
    });

    tr_copy.each(function (index) {
      $(this).height(heights[index]);
    });
  }

});
