define([
  'underscore',
  'backbone'
], function(_, Backbone) {
  var PageModel = Backbone.Model.extend({
    
	url: "../controllers/admin_crons/index.php", 
	  
	defaults:
	{
	},
    
    initialize: function()
    {
    	Backbone.log("admin_crons pageModel initialized");

    	var methodMap = {'read': 'getCronsDetails'};

    	this._meta = {};

    	this.setMeta('methodMap',methodMap);
    },   
    
    
    setMeta: function(prop, value)
    {
    	if (value === undefined)
        {
            return this._meta[prop];
        } 
        else
        {
        	this._meta[prop] = value;
        }
    },
    
    /*Overwrite default Backbone.Model.parse*/
    parse: function(resp, xhr)
    {
    	var responseData = {};
    	
		if(resp.data.actionData.availableCrons)
		{
			responseData['availableCrons'] = resp.data.actionData.availableCrons;
		}

		
		if(resp.data.actionData.boards)
		{
			responseData['boards'] = resp.data.actionData.boards;
		}
    	
    	return responseData;
    }
    
  });
  return PageModel;

});