define([
  'underscore',
  'backbone'
], function(_, Backbone) {
  var appModel = Backbone.Model.extend({
  
    url: "../controllers/apps/index.php",
  
    initialize: function()
    {
    	Backbone.log("app Collection initialized");
    	
    	 this._meta = {};
    	 
    	 this.setMeta('methodMap',{'read': 'getAppDetails','update': 'updateAppDetails'});
    },
    
    setMeta: function(prop, value)
    {
    	if (value === undefined)
        {
            return this._meta[prop];
        } 
        else
        {
        	this._meta[prop] = value;
        }
    },
    
    parse: function(resp, xhr)
    {
    	return _.toArray(resp.data.actionData);
    },
  });
  return appModel;

});
