// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'jqueryui',
  'models/admin_apps_manager/page',
  'collections/admin_apps_manager/installedappset',
  'views/admin_apps_manager/installedappset',
  'collections/admin_apps_manager/uninstalledappset',
  'views/admin_apps_manager/uninstalledappset',
  'collections/admin_boardset/boardset',
  'views/admin_boardset/boardset',
  'models/admin_apps_manager/newappitem',
  'views/admin_apps_manager/newappitem',
  'text!templates/admin_apps_manager/page.html',
], function($, _, Backbone, jqueryUI, PageModel, installedAppSet, installedAppSetView, uninstalledAppSet, uninstalledAppSetView, boardSet, boardSetView, newAppModel, newAppView, appsManagerTemplate){

  var pageView = Backbone.View.extend(
  {
	    el: $('#page'),
	    
	    initialize : function ()
	    {
	    	Backbone.log("admin_apps_manager pageView init");
	    	
	    	var self = this;
	    	
	    	this.model = new PageModel();
	    	
	    	this.boardSet = new boardSet();
	    	this.boardSetView = null;
	    		
	    	this.installedAppSet = new installedAppSet();
	    	this.installedAppSetView = null;
	    	
	    	this.uninstalledAppSet = new uninstalledAppSet();
	    	this.uninstalledAppSetView = null;
	    	
	        this.newAppModel =  new newAppModel();
	        this.newAppView = null;
	        
	        this.model.bind("change", this.render, this);
	        
	        this.model.fetch();
	    },
	    
	    render : function ()
	    {
	    	var self = this;
	    	
	    	Backbone.log('admin_apps_manager pageView render');
	    	
	    	var  data = {};
	    	var compiledTemplate = _.template( appsManagerTemplate, data );
	        $(this.el).html(compiledTemplate);
	        
	        
	        //draw avaiable tabs list
	        if(this.model.has("boards"))
	        {
	        	this.activeBoardName = "apps_manager";
	        	
	        	if(this.boardSet.models.length == 0)
	        	{
	        		this.boardSet.add(_.toArray(this.model.get("boards")));	
	        	}

		        //create boardSetView and render it
		        this.boardSetView = new boardSetView({model: this.boardSet, page: this});
		        this.boardSetView.render();
	        }
	        
	        //handle app manager view ... 
	        
	        //add newapp form
	        this.newAppView = new newAppView({model: this.newAppModel, page: this});
	        this.newAppView.render();
	        
	        if(this.model.has("installedApps"))
	        {
		        //populate installedAppSet collection from pageModel
		        this.installedAppSet.add(_.toArray(this.model.get("installedApps")));
		        
		        //create installedAppSetView and render it
		        this.installedAppSetView = new installedAppSetView({model: this.installedAppSet, page: this});
		        this.installedAppSetView.render();
	        }
	        
     
	        //populate uninstalledAppSet collection from pageModel
	        if(this.model.has("uninstalledApps"))
	        {
	        	var  uninstallledApps = _.toArray(this.model.get("uninstalledApps"));
	        	
	        	if(uninstallledApps.length)
        		{
        			$('.uninstalled-apps-box').addClass('uninstalled-apps-box-show');
        		}
	        	
	        	this.uninstalledAppSet.add(uninstallledApps);
		        
		        //create uninstalledAppSetView and render it
		        this.uninstalledAppSetView = new uninstalledAppSetView({model: this.uninstalledAppSet, page: this});
		        this.uninstalledAppSetView.render();
	        }
	        
	    }
  });
  
  return pageView;
});