// Filename: views/admin_boardset/boarditem
define([
  'jquery',
  'underscore',
  'backbone',
], function($, _, Backbone){

	var boardItemView = Backbone.View.extend(
	{
	    tagName : "li",
	    
	    events :
	    {
	    
	    },
	    
	    initialize : function (options)
	    {
	        Backbone.log("boardItemView initialize");
	        
	        this.page = options["page"];
	        
	    	$(this.el).attr("id", "boarditem_" + this.model.get("name"));
	    },
	    
	    render : function ()
	    {
	    	Backbone.log("boardItemView render");
	    	
	    	var currentBoardName = this.model.get("name");
	    	
	        var boardItemHTML = $("<a/>",{ id: 'board_panel_'+currentBoardName, 'class': "board-option-item1", href: "#"+currentBoardName, html: '<span class="board-option-item">'+this.model.get("title")+'</span>'});
	        
	        $(this.el).html(boardItemHTML);
	        
	        if(currentBoardName == this.page.activeBoardName)
        	{
	        	$(this.el).addClass("current");
        	}
	        
	        return this;
	    }
	})

  return boardItemView;
});