// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'views/admin_boardset/boarditem'
], function($, _, Backbone, boardItemView){
	
  var boardSetView = Backbone.View.extend({
	  
	  el: '#manager-tabs-container',
	
	initialize: function(options)
	{
		Backbone.log("boardSetView initialize");
		
		this.page = options['page'];
		
		this.boardItemViews = {};
	},
	
    render: function()
    {
    	Backbone.log("boardSetView render");
    	
    	var self = this;
    	
    	$(this.el).empty();
    	$(this.el).parent().find('#manager-tabs-touch').empty();
        _.each(this.model.models, function (appItem, index)
        {
    		currentboardItemView = new boardItemView({model:appItem, page: self.page});
    		
    		self.boardItemViews[index] = currentboardItemView; 
    		
    		$(self.el).append(currentboardItemView.render().el);
    		$(self.el).parent().find('#manager-tabs-touch').append("<option value='/livedash/admin.php#"+currentboardItemView.model.get('name')+"' "+(currentboardItemView.model.get('name')==self.page.activeBoardName?'selected':'')+">"+currentboardItemView.model.get('title')+"</option>");
        });
        
        return this;
    }
  });
  return boardSetView;
});	