// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'views/admin_connectors/connectoritem'
], function($, _, Backbone, connectorItemView){
	
  var connectorSetView = Backbone.View.extend({
	  
	  el: '#admin-connectors-manager',
	
	initialize: function(options)
	{
		Backbone.log("connectorSetView initialize");
		
		this.page = options['page'];
		
		this.connectorItemViews = {};
	},
	
    render: function()
    {
    	Backbone.log("connectorSetView render");
    	
    	var self = this;
    	
    	var htmlTable = $('<table/>',{'width':'100%', 'class':'striped'}).css({'margin':'0px'});
    	
    	htmlTable.append($('<thead/>',{html:'<tr><th>Type</th><th width="100%" class="left">Name & details</th></tr>'}));
    	
    	if(this.model.models.length == 0)
    	{
    		htmlTable.append($('<td/>',{colspan:'3', html:'There are no connectors available'}));	
    	}
    	else
    	{
            _.each(this.model.models, function (connectorItem, index)
            {
        		currentConnectorItemView = new connectorItemView({model:connectorItem, page: self.page});
        		
        		self.connectorItemViews[index] = currentConnectorItemView; 
        		
        		htmlTable.append(currentConnectorItemView.render().el);
        		
        		if(index % 2 != 0)
        		{
        			htmlTable.find("#admin_connector_item_"+connectorItem.get("id")).addClass("alt");	
        		}	
            });
    	}
        
        $(this.el).empty().append(htmlTable);
        
        return this;
    }
  });
  return connectorSetView;
});	