// Filename: views/admin_connectors/page
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_connectors/page',
  'collections/admin_boardset/boardset',
  'views/admin_boardset/boardset',
  'collections/admin_connectors/connectorset',
  'views/admin_connectors/connectorset',
  'text!templates/admin_connectors/page.html',
], function($, _, Backbone, PageModel, boardSet, boardSetView, connectorSet, connectorSetView, pageTemplate){

  var adminConnectorsView = Backbone.View.extend(
  {
	    el: $('#page'),
	    
	    initialize : function ()
	    {
	    	Backbone.log("admin_connectors pageView init");
	    	
	    	var self = this;
	    	
	    	this.model = new PageModel();
	    	
	    	this.boardSet = new boardSet();
	    	this.boardSetView = null;
	    	
	    	this.connectorSet = new connectorSet();
	    	this.connectorSetView = null;
	    	
	    	//handle events
	    	this.model.bind("change", this.render, this);
	    	
	        this.model.fetch();
	    },
	    
	    render : function ()
	    {
	    	Backbone.log('admin_connectors pageView render');
	    	
	    	var self = this;
	    	
	    	$(this.el).empty();
	    	
	        //Draw admin connectors template
	    	var data = {};
	        var compiledTemplate = _.template( pageTemplate, data );
	        $(this.el).html( compiledTemplate );
	    	
	        //draw avaiable tabs list
	        if(this.model.has("boards"))
	        {
	        	this.activeBoardName = "connectors_manager";
	        	
	        	if(this.boardSet.models.length == 0)
	        	{
	        		this.boardSet.add(_.toArray(this.model.get("boards")));	
	        	}	
	        	
		        //create boardSetView and render it
		        this.boardSetView = new boardSetView({model: this.boardSet, page: this});
		        this.boardSetView.render();
	        }
	        
	    	//populate connectorSet collection from pageModel
	    	this.connectorSet.reset().add(_.toArray(this.model.get("availableConnectors")));

	    	//Render connectorSet collection
	        this.connectorSetView = new connectorSetView({model: this.connectorSet, page: this});
	        this.connectorSetView.render();
	    }
  });
  
  return adminConnectorsView;
});