// Filename: views/admin_credentials/page
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_credentials/page',
  'views/admin_credentials/sectionitem',
  'text!templates/admin_credentials/page.html',
], function($, _, Backbone, PageModel, sectionItemView, pageTemplate){

  var adminCredentialsView = Backbone.View.extend(
  {
	    el: $('#page'),
	    
	    initialize : function ()
	    {
	    	Backbone.log("admin_credentials pageView init");
	    	
	    	var self = this;
	    	
	    	this.model = new PageModel();
	    	
	    	this.sectionView = null;
	    	
	    	this.currentAction = null;
	    	
	    	//handle events
	    	this.model.bind("change", this.render, this);
	    	
	        this.model.fetch();
	    },
	    
	    render : function ()
	    {
	    	Backbone.log('admin_credentials pageView render');
	    	
	    	var self = this;
	    	
	    	if(this.model.has('current_op')) this.currentAction = this.model.get('current_op'); 
	    	
	    	$(this.el).empty();
	    	
	        //Draw admin crons template
	        var compiledTemplate = _.template( pageTemplate, {currentAction: this.currentAction});
	        $(this.el).html( compiledTemplate );
	        
        	//Render basic panel
	        this.sectionView = new sectionItemView({page: this});
	        this.sectionView.render();
	        
	        setTimeout(function(){self.buildTabs()}, 100);
	    },
	    
	    buildTabs: function()
	    {
	    	// tab setup
	    	$(this.el).find('.tab-content').addClass('clearfix').hide();
	    	
	    	$(this.el).find('ul.tabs').each(function(){
	    		var current = $(this).find('li.current');
	    		if(current.length < 1) { $(this).find('li:first').addClass('current'); }
	    		current = $(this).find('li.current a').attr('target');
	    		$(current).show();
	    	});

	    	$(this.el).find('ul.tabs a[target^="#"]').live('click', function(e){
	    		e.preventDefault();
	    		var tabs = $(this).parents('ul.tabs').find('li');
	    		var tab_next = $(this).attr('target');
	    		var tab_current = tabs.filter('.current').find('a').attr('target');
	    		$(tab_current).hide();
	    		tabs.removeClass('current');
	    		$(this).parent().addClass('current');
	    		$(tab_next).show();
	    		return false;
	    	});
	    	
	    	$(this.el).find(".appstore-credentials-tabs-container").addClass("tabs-visible");
	    }	    
  });
  
  return adminCredentialsView;
});