// Filename: views/admin_credentials/sectionitem
define([
  'jquery',
  'underscore',
  'backbone',
  'text!templates/admin_credentials/sectionitem.html'
], function($, _, Backbone, pageTemplate){

  var sectionView = Backbone.View.extend(
  {
  		el: "div.appstore-credentials-tabs-container",
  		
	  	events :
	  	{
	  		'click button#os_create_account_btn' : 'handleCreateAccount',
	  		'click button#os_check_account_btn' : 'handleCheckAccount',
  		},
  		
	    initialize : function(options)
	    {
	    	Backbone.log("appstore Credentials sectionView init");
	    	
	    	this.page = options['page'];
	    },

	    render : function ()
	    {
	    	Backbone.log("appstore Credentials sectionView render");
	    		
	        var compiledTemplate = _.template( pageTemplate, {} );
	        $(this.el).html( compiledTemplate );
	        
	        /*
	        var adminSettings = this.page.model.get('adminSettings');
	        
	        if(adminSettings['osc_api_key'])
	        {
	        	$(this.el).find('#api_user_box').val(adminSettings['osc_user']);
	        	$(this.el).find('#api_key_box').val(adminSettings['osc_api_key']);
	        }
	        */

	    	return this;
	    },
	    
	    handleCreateAccount: function()
	    {
	    	Backbone.log("handleCreateAccount trigerred");
	    	
	    	var profileUsrValue = $(this.el).find("#os_user_box").val();
	    	var profileEmailValue = $(this.el).find("#os_email_box").val();
	    	var profilePass1Value = $(this.el).find("#os_password_box").val();
	    	var profilePass2Value = $(this.el).find("#os_password2_box").val();
	    	
	    	//validate user input
	    	var errorsData = [];
	    	if(profileUsrValue.length == 0) errorsData.push("AppStore Username is missing");
	    	else if(profileUsrValue.length < 2)  errorsData.push("AppStore Username is missing");

	    	if(profileEmailValue.length == 0)  errorsData.push("AppStore Email is missing");
	    	else if(profileEmailValue.indexOf('@') == -1)  errorsData.push("Invalid AppStore Email");
	    	
	    	if(profilePass1Value.length == 0)  errorsData.push("AppStore Password is missing");
	    	else if(profilePass1Value.length < 6)  errorsData.push("AppStore Password must contain at least 6 characters");
	    	else if(profilePass2Value.length == 0)  errorsData.push("Verify password is missing");
	    	else if(profilePass1Value != profilePass2Value)  errorsData.push("Passwords don't match");
	    	
	    	if(errorsData.length > 0)
	    	{
	    		var message = errorsData.join("<br>");
	    		osKernel.showErrorSplash(message);
	    	}
	    	else
	    	{
	    		//create account details
	    		var createDetails = this.page.model.get('createDetails');
	    		
	    		createDetails['osc_username'] = profileUsrValue;
	    		createDetails['osc_email'] = profileEmailValue;
	    		createDetails['osc_password'] = profilePass1Value;
	    		createDetails['osc_password2'] = profilePass2Value;
	    		
	    		Backbone.log({'current_op': "create_account", 'createDetails': createDetails});
	    		
	    		this.page.model.set({'current_op': "create_account", 'createDetails': createDetails});
		    	this.page.model.save();
	    	}
	    },
	    
	    handleCheckAccount: function()
	    {
	    	Backbone.log("handleCheckAccount trigerred");
	    	
	    	var apiUsrValue = $(this.el).find("#os_check_user_box").val();
	    	var apiPasswordValue = $(this.el).find("#os_check_password_box").val();
	    	
	    	//validate user input
	    	var errorsData = [];
	    	if(apiUsrValue.length == 0) errorsData.push("AppStore Username is missing");
	    	else if(apiUsrValue.length < 3 )  errorsData.push("AppStore Username must contain at least 3 characters");
	    	
	    	if(apiPasswordValue.length == 0) errorsData.push("AppStore Password is missing");
	    	else if(apiPasswordValue.length < 6) errorsData.push("AppStore Password must contain at least 6 characters");
	    	
	    	if(errorsData.length > 0)
	    	{
	    		var message = errorsData.join("<br>");
	    		osKernel.showErrorSplash(message);
	    	}
	    	else
	    	{
	    		//check appstore details
	    		var checkDetails = this.page.model.get('checkDetails');
	    		
	    		checkDetails['osc_username'] = apiUsrValue;
	    		checkDetails['osc_password'] = apiPasswordValue;
	    		
	    		this.page.model.set({'current_op': "check_account", 'checkDetails': checkDetails});
		    	this.page.model.save();
	    	}
	    }	    
  });
  
  return sectionView;
});