// Filename: views/admin_crons/cronitem
define([
  'jquery',
  'underscore',
  'backbone',
], function($, _, Backbone){

	var cronItemView = Backbone.View.extend(
	{
	    tagName : "tr",
	    
	  	events :
	  	{
  			'click button#admin_enable_cron' : 'handleEnableCron',
  			'click button#admin_disable_cron' : 'handleDisableCron'
  		},
	    
	    initialize : function (options)
	    {
	        Backbone.log("cronItemView initialize");
	        
	        this.page = options["page"];
	        
	        $(this.el).attr("id","admin_cron_item_"+this.model.get("id"));
	        $(this.el).attr("align","center");
	        
	    	//set collection events
	        
	        this.model.bind("change", this.render, this);
	        //this.model.bind("all", this.eventAll, this);
	    },
	    
	    render : function ()
	    {
	    	Backbone.log("cronItemView render");
	    	
	    	if(this.model.get('status') == 'E')
	    	{
	    		var cronActionHtml = $("<button/>",{id:'admin_disable_cron', type:'button', 'class': 'small blue', html: 'Disable Cron'});
	    		var cronStatusHtml = '<span class="icon green medium" data-icon="C" style="display:inline;">C</span>';
	    	}
	    	else
	    	{
	    		var cronActionHtml = $("<button/>",{id:'admin_enable_cron', type:'button', 'class': 'small blue', html: 'Enable Cron'});
	    		var cronStatusHtml = '<span class="icon red medium" data-icon="x" style="display:inline;">x</span>';
	    	}
	    	
	    	$(this.el).empty();
	    	$(this.el).attr('class','first');
	    	$(this.el).append($("<td/>",{'class': 'alignCenter', html: cronStatusHtml}));
	    	$(this.el).append($("<td/>",{html: this.model.get('_module_title')+' - '+this.model.get('title') }));
	    	$(this.el).append($("<td/>",{'class': 'alignCenter', html: this.model.get('_interval_human') }));
	    	$(this.el).append($("<td/>",{'class': 'alignCenter', html: this.model.get('runs')+(this.model.get('runs')>0 ? ' ('+this.model.get('_run_dt_human')+')':'') }));
	    	$(this.el).append($("<td/>",{'class': 'alignCenter', html: this.model.get('fails')+(this.model.get('fails')>0 ? ' ('+this.model.get('_fail_dt_human')+')':'') }));
	    	$(this.el).append($("<td/>",{'class': 'alignCenter', html:  cronActionHtml}));
	    	
	        return this;
	    },
	    
	    
	    handleEnableCron : function()
	    {
	    	Backbone.log("handleEnableCron triggered");

	    	var self = this;
	    	this.handleActionOverlay('enable');
	    	this.model.set({'current_op': 'enable_cron'});
	    	this.model.save({}, {success: function() {self.handleModelSave()}});
	    },

	    handleDisableCron : function()
	    {
	    	Backbone.log("handleDisableCron triggered");
	    	
	    	var self = this;
	    	this.handleActionOverlay('enable');
	    	this.model.set({'current_op': 'disable_cron'});
	    	this.model.save({}, {success: function() {self.handleModelSave()}});
	    },
	    
	    handleModelSave: function()
	    {
	    	Backbone.log("handleModelSave triggered");
	    	this.handleActionOverlay('disable');
	    },
	    
	    eventAll : function(event, model, options)
	    {
	    	Backbone.log("boardModel  fired event "+event);
	    },
	    
	    handleActionOverlay: function(action)
	    {
	    	Backbone.log("handleActionOverlay triggered: "+action);
	    	
	    	if(action == 'enable')
	    	{
	    		//appdetails-container
	    		var tmpContainer = $(this.el);
	    		var tmpContainerOffset = tmpContainer.offset();
	    		
	    		$('#livedash-waiting-overlay').css({
	    			'visibility': 'visible', 
	    			'width': $(tmpContainer)[0].offsetWidth+'px', 
	    			'height': $(tmpContainer)[0].offsetHeight+'px', 
	    			'top': tmpContainerOffset.top, 
	    			'left': tmpContainerOffset.left
	    			});
	    	}
	    	else if(action == 'disable')
	    	{
	    		$('#livedash-waiting-overlay').css({visibility: 'hidden'});
	    	}
	    }
	})

  return cronItemView;
});