// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'views/admin_crons/cronitem'
], function($, _, Backbone, cronItemView){
	
  var cronSetView = Backbone.View.extend({
	  
	  el: '#admin-crons-manager',
	
	initialize: function(options)
	{
		Backbone.log("cronSetView initialize");
		
		this.page = options['page'];
		
		this.cronItemViews = {};
	},
	
    render: function()
    {
    	Backbone.log("cronSetView render");
    	
    	var self = this;
    	
    	var htmlTable = $('<table/>',{'width':'100%', 'class':'striped'}).css({'margin':'0px'});
    	
    	htmlTable.append($('<thead/>',{html:'<th>Status</th><th>Name</th><th>Interval</th><th>Runs</th><th>Fails</th><th>Actions</th>'}));
    	
    	if(this.model.models.length == 0)
    	{
    		htmlTable.append($('<td/>',{colspan:'6', html:'There are no crons defined'}));	
    	}
    	else
    	{
            _.each(this.model.models, function (cronItem, index)
            {
        		currentCronItemView = new cronItemView({model:cronItem, page: self.page});
        		
        		self.cronItemViews[index] = currentCronItemView; 
        		
        		htmlTable.append(currentCronItemView.render().el);
        		
        		if(index % 2 != 0)
        		{
        			htmlTable.find("#admin_cron_item_"+cronItem.get("id")).addClass("alt");	
        		}	
            });
    	}
        
        $(this.el).empty().append(htmlTable);
        
        return this;
    }
  });
  return cronSetView;
});	