// Filename: views/admin_crons/page
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_crons/page',
  'collections/admin_boardset/boardset',
  'views/admin_boardset/boardset',
  'collections/admin_crons/cronset',
  'views/admin_crons/cronset',
  'text!templates/admin_crons/page.html',
], function($, _, Backbone, PageModel, boardSet, boardSetView, cronSet, cronSetView, pageTemplate){

  var adminCronsView = Backbone.View.extend(
  {
	    el: $('#page'),
	    
	    initialize : function ()
	    {
	    	Backbone.log("admin_crons pageView init");
	    	
	    	var self = this;
	    	
	    	this.model = new PageModel();
	    	
	    	this.boardSet = new boardSet();
	    	this.boardSetView = null;
	    	
	    	this.cronSet = new cronSet();
	    	this.cronSetView = null;
	    	
	    	//handle events
	    	this.model.bind("change", this.render, this);
	    	
	        this.model.fetch();
	    },
	    
	    render : function ()
	    {
	    	Backbone.log('admin_crons pageView render');
	    	
	    	var self = this;
	    	
	    	$(this.el).empty();
	    	
	        //Draw admin crons template
	    	var data = {};
	        var compiledTemplate = _.template( pageTemplate, data );
	        $(this.el).html( compiledTemplate );
	    	
	        //draw avaiable tabs list
	        if(this.model.has("boards"))
	        {
	        	this.activeBoardName = "crons_manager";
	        	
	        	if(this.boardSet.models.length == 0)
	        	{
	        		this.boardSet.add(_.toArray(this.model.get("boards")));	
	        	}	
	        	
		        //create boardSetView and render it
		        this.boardSetView = new boardSetView({model: this.boardSet, page: this});
		        this.boardSetView.render();
	        }
	        
	    	//populate cronSet collection from pageModel
	    	this.cronSet.reset().add(_.toArray(this.model.get("availableCrons")));

	    	//Render cronSet collection
	        this.cronSetView = new cronSetView({model: this.cronSet, page: this});
	        this.cronSetView.render();
	    }
  });
  
  return adminCronsView;
});