// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'views/admin_datasources/datasourceitem'
], function($, _, Backbone, datasourceItemView){
	
  var datasourceSetView = Backbone.View.extend({
	  
	  el: '#admin-datasources-manager',
	
	initialize: function(options)
	{
		Backbone.log("datasourceSetView initialize");
		
		this.page = options['page'];
		
		this.datasourceItemViews = {};
	},
	
    render: function()
    {
    	Backbone.log("datasourceSetView render");
    	
    	var self = this;
    	
    	var htmlTable = $('<table/>',{'width':'100%', 'class':'striped'}).css({'margin':'0px'});
    	
    	htmlTable.append($('<thead/>',{html:'<th width="15%">Status</th><th width="70%">Datasource</th><th width="15%">Actions</th>' }));
    	
    	if(this.model.models.length == 0)
    	{
    		htmlTable.append($('<td/>',{colspan:'6', html:'There are no datasources defined'}));	
    	}
    	else
    	{
            _.each(this.model.models, function (datasourceItem, index)
            {
        		currentDatasourceItemView = new datasourceItemView({model:datasourceItem, page: self.page});
        		
        		self.datasourceItemViews[index] = currentDatasourceItemView; 
        		
        		htmlTable.append(currentDatasourceItemView.render().el);
        		
        		if(index % 2 != 0)
        		{
        			htmlTable.find("#admin_datasource_item_"+datasourceItem.get("name")).addClass("alt");	
        		}	
            });
    	}
        
        $(this.el).empty().append(htmlTable);
        
        return this;
    }
  });
  return datasourceSetView;
});	