// Filename: views/admin_datasources/page
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_datasources/page',
  'collections/admin_boardset/boardset',
  'views/admin_boardset/boardset',
  'collections/admin_datasources/datasourceset',
  'views/admin_datasources/datasourceset',
  'text!templates/admin_datasources/page.html',
], function($, _, Backbone, PageModel, boardSet, boardSetView, datasourceSet, datasourceSetView, pageTemplate){

  var adminDatasourcesView = Backbone.View.extend(
  {
	    el: $('#page'),
	    
	    initialize : function ()
	    {
	    	Backbone.log("admin_datasources pageView init");
	    	
	    	var self = this;
	    	
	    	this.model = new PageModel();
	    	
	    	this.boardSet = new boardSet();
	    	this.boardSetView = null;
	    	
	    	this.datasourceSet = new datasourceSet();
	    	this.datasourceSetView = null;
	    	
	    	//handle datasources
	    	this.model.bind("change", this.render, this);
	    	
	        this.model.fetch();
	    },
	    
	    render : function ()
	    {
	    	Backbone.log('admin_datasources pageView render');
	    	
	    	var self = this;
	    	
	    	$(this.el).empty();
	    	
	        //Draw boardset template
	    	var data = {};
	        var compiledTemplate = _.template( pageTemplate, data );
	        $(this.el).html( compiledTemplate );
	    	
	        //draw avaiable tabs list
	        if(this.model.has("boards"))
	        {
	        	this.activeBoardName = "datasources_manager";
	        	
	        	if(this.boardSet.models.length == 0)
	        	{
	        		this.boardSet.add(_.toArray(this.model.get("boards")));	
	        	}	
	        	
		        //create boardSetView and render it
		        this.boardSetView = new boardSetView({model: this.boardSet, page: this});
		        this.boardSetView.render();
	        }
	        
	        //handle admin datasources view ...
	        
	    	//populate dastasourceSet collection from pageModel
	    	this.datasourceSet.reset().add(_.toArray(this.model.get("availableDatasources")));
	    	
	    	//populate availableConnections from pageModel
	    	this.availableConnections = this.model.get("availableConnections");
	    	
	    	//Render datasourceSet collection
	        this.datasourceSetView = new datasourceSetView({model: this.datasourceSet, page: this});
	        this.datasourceSetView.render();
	    }
  });
  
  return adminDatasourcesView;
});