// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'views/admin_events/eventitem'
], function($, _, Backbone, eventItemView){
	
  var eventSetView = Backbone.View.extend({
	  
	  el: '#admin-events-manager',
	
	initialize: function(options)
	{
		Backbone.log("eventSetView initialize");
		
		this.page = options['page'];
		
		this.eventItemViews = {};
	},
	
    render: function()
    {
    	Backbone.log("eventSetView render");
    	
    	var self = this;
    	
    	var htmlTable = $('<table/>',{'width':'100%', 'class':'striped'}).css({'margin':'0px'});
    	
    	htmlTable.append($('<thead/>',{html:'<th>Status</th><th>Name</th><th>Actions</th>'}));
    	
    	if(this.model.models.length == 0)
    	{
    		htmlTable.append($('<td/>',{colspan:'6', html:'There are no events defined'}));	
    	}
    	else
    	{
            _.each(this.model.models, function (eventItem, index)
            {
        		currentEventItemView = new eventItemView({model:eventItem, page: self.page});
        		
        		self.eventItemViews[index] = currentEventItemView; 
        		
        		htmlTable.append(currentEventItemView.render().el);
        		
        		if(index % 2 != 0)
        		{
        			htmlTable.find("#admin_event_item_"+eventItem.get("id")).addClass("alt");	
        		}	
            });
    	}
        
        $(this.el).empty().append(htmlTable);
        
        return this;
    }
  });
  return eventSetView;
});	