// Filename: views/admin_events/page
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_events/page',
  'collections/admin_boardset/boardset',
  'views/admin_boardset/boardset',
  'collections/admin_events/eventset',
  'views/admin_events/eventset',
  'text!templates/admin_events/page.html',
], function($, _, Backbone, PageModel, boardSet, boardSetView, eventSet, eventSetView, pageTemplate){

  var adminEventsView = Backbone.View.extend(
  {
	    el: $('#page'),
	    
	    initialize : function ()
	    {
	    	Backbone.log("admin_events pageView init");
	    	
	    	var self = this;
	    	
	    	this.model = new PageModel();
	    	
	    	this.boardSet = new boardSet();
	    	this.boardSetView = null;
	    	
	    	this.eventSet = new eventSet();
	    	this.eventSetView = null;
	    	
	    	//handle events
	    	this.model.bind("change", this.render, this);
	    	
	        this.model.fetch();
	    },
	    
	    render : function ()
	    {
	    	Backbone.log('pageView render');
	    	
	    	var self = this;
	    	
	    	$(this.el).empty();
	    	
	        //Draw boardset template
	    	var data = {};
	        var compiledTemplate = _.template( pageTemplate, data );
	        $(this.el).html( compiledTemplate );
	    	
	        //draw avaiable tabs list
	        if(this.model.has("boards"))
	        {
	        	this.activeBoardName = "events_manager";
	        	
	        	if(this.boardSet.models.length == 0)
	        	{
	        		this.boardSet.add(_.toArray(this.model.get("boards")));	
	        	}	
	        	
		        //create boardSetView and render it
		        this.boardSetView = new boardSetView({model: this.boardSet, page: this});
		        this.boardSetView.render();
	        }
	        
	        
	    	//populate eventSet collection from pageModel
	    	this.eventSet.reset().add(_.toArray(this.model.get("availableEvents")));

	    	//Render eventSet collection
	        this.eventSetView = new eventSetView({model: this.eventSet, page: this});
	        this.eventSetView.render();	        
	    }
  });
  
  return adminEventsView;
});