// Filename: views/admin_interactions/interactionitem
define([
  'jquery',
  'underscore',
  'backbone',
], function($, _, Backbone){

	var interactionItemView = Backbone.View.extend(
	{
	    tagName : "tr",
	    
	  	events :
	  	{
  			'click button#admin_enable_interaction' : 'handleEnableInteraction',
  			'click button#admin_disable_interaction' : 'handleDisableInteraction'
  		},
	    
	    initialize : function (options)
	    {
	        Backbone.log("interactionItemView initialize");
	        
	        this.page = options["page"];
	        
	        $(this.el).attr("id","admin_interaction_item_"+this.model.get("id"));
	        $(this.el).attr("align","center");
	        
	    	//set collection events
	        
	        this.model.bind("change", this.render, this);
	        //this.model.bind("all", this.eventAll, this);
	    },
	    
	    render : function ()
	    {
	    	Backbone.log("interactionItemView render");
	    	
	    	if(this.model.get('status') == 'A')
	    	{
	    		var interactionActionHtml = $("<button/>",{id:'admin_disable_interaction', type:'button', 'class': 'small blue', html: 'Disable Interaction'});
	    		var interactionStatusHtml = '<span class="icon green medium" data-icon="C" style="display:inline;">C</span>';
	    	}
	    	else
	    	{
	    		var interactionActionHtml = $("<button/>",{id:'admin_enable_interaction', type:'button', 'class': 'small blue', html: 'Enable Interaction'});
	    		var interactionStatusHtml = '<span class="icon red medium" data-icon="x" style="display:inline;">x</span>';
	    	}
	    	
	    	$(this.el).empty();
	    	$(this.el).attr('class','first');
	    	$(this.el).append($("<td/>",{'class': 'alignCenter', html: interactionStatusHtml}));
	    	$(this.el).append($("<td/>",{html: this.model.get('module_title')+' - '+this.model.get('action_title') }));
	    	$(this.el).append($("<td/>",{'class': 'alignCenter', html:  interactionActionHtml}));
	    	
	        return this;
	    },
	    
	    
	    handleEnableInteraction : function()
	    {
	    	Backbone.log("handleEnableInteraction triggered");

	    	this.model.set({'current_op': 'enable_interaction'});
	    	this.model.save();
	    },

	    handleDisableInteraction : function()
	    {
	    	Backbone.log("handleDisableInteraction triggered");
	    	this.model.set({'current_op': 'disable_interaction'});
	    	this.model.save();
	    },
	    
	    eventAll : function(event, model, options)
	    {
	    	Backbone.log("boardModel  fired event "+event);
	    	//Backbone.log(model);
	    }
	})

  return interactionItemView;
});