// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'views/admin_interactions/interactionitem'
], function($, _, Backbone, interactionItemView){
	
  var interactionSetView = Backbone.View.extend({
	  
	  el: '#admin-interactions-manager',
	
	initialize: function(options)
	{
		Backbone.log("interactionSetView initialize");
		
		this.page = options['page'];
		
		this.interactionItemViews = {};
	},
	
    render: function()
    {
    	Backbone.log("interactionSetView render");
    	
    	var self = this;
    	
    	var htmlTable = $('<table/>',{'width':'100%', 'class':'striped'}).css({'margin':'0px'});
    	
    	htmlTable.append($('<thead/>',{html:'<th>Status</th><th>Name</th><th>Actions</th>'}));
    	
    	if(this.model.models.length == 0)
    	{
    		htmlTable.append($('<td/>',{colspan:'6', html:'There are no interactions defined'}));	
    	}
    	else
    	{
            _.each(this.model.models, function (interactionItem, index)
            {
        		currentInteractionItemView = new interactionItemView({model:interactionItem, page: self.page});
        		
        		self.interactionItemViews[index] = currentInteractionItemView; 
        		
        		htmlTable.append(currentInteractionItemView.render().el);
        		
        		if(index % 2 != 0)
        		{
        			htmlTable.find("#admin_interaction_item_"+interactionItem.get("id")).addClass("alt");	
        		}	
            });
    	}
        
        $(this.el).empty().append(htmlTable);
        
        return this;
    }
  });
  return interactionSetView;
});	