// Filename: views/admin_interactions/page
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_interactions/page',
  'collections/admin_boardset/boardset',
  'views/admin_boardset/boardset',
  'collections/admin_interactions/interactionset',
  'views/admin_interactions/interactionset',
  'text!templates/admin_interactions/page.html',
], function($, _, Backbone, PageModel, boardSet, boardSetView, interactionSet, interactionSetView, pageTemplate){

  var adminInteractionsView = Backbone.View.extend(
  {
	    el: $('#page'),
	    
	    initialize : function ()
	    {
	    	Backbone.log("admin_interactions pageView init");
	    	
	    	var self = this;
	    	
	    	this.model = new PageModel();
	    	
	    	this.boardSet = new boardSet();
	    	this.boardSetView = null;
	    	
	    	this.interactionSet = new interactionSet();
	    	this.interactionSetView = null;
	    	
	    	//handle events
	    	this.model.bind("change", this.render, this);
	    	
	        this.model.fetch();
	    },
	    
	    render : function ()
	    {
	    	Backbone.log('admin_interactions pageView render');
	    	
	    	var self = this;
	    	
	    	$(this.el).empty();
	    	
	        //Draw admin interactions template
	    	var data = {};
	        var compiledTemplate = _.template( pageTemplate, data );
	        $(this.el).html( compiledTemplate );
	    	
	        //draw avaiable tabs list
	        if(this.model.has("boards"))
	        {
	        	this.activeBoardName = "interactions_manager";
	        	
	        	if(this.boardSet.models.length == 0)
	        	{
	        		this.boardSet.add(_.toArray(this.model.get("boards")));	
	        	}	
	        	
		        //create boardSetView and render it
		        this.boardSetView = new boardSetView({model: this.boardSet, page: this});
		        this.boardSetView.render();
	        }
	        
	    	//populate interactionSet collection from pageModel
	    	this.interactionSet.reset().add(_.toArray(this.model.get("availableInteractions")));

	    	//Render interactionSet collection
	        this.interactionSetView = new interactionSetView({model: this.interactionSet, page: this});
	        this.interactionSetView.render();
	    }
  });
  
  return adminInteractionsView;
});