// Filename: views/admin_market/appitem
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_market/appitem',
  'text!templates/admin_market/appitem.html'
], function($, _, Backbone, storeItem, storeItemTemplate){

  var appItemView = Backbone.View.extend(
  {
	  tagName: "li",

	  events : {
  			'click button#install-btn' : 'showAppDetails',
  			'click img#app-item-icon' : 'showAppDetails',
  		},
  		
	    initialize: function (options)
	    {
	    	Backbone.log("appItemView initialize");
	    	
	    	$(this.el).addClass("col_6");
	    	
	    	this.model.bind('change',this.render,this);
	    	
	    	this.page = options['page'];
	    },
	    
	    render: function ()
	    {
	    	Backbone.log("appItemView render");
	    	
	    	var data = {
	    		id: this.model.get("name"),
	    		version: this.model.get("version"),
	    		title: this.model.get("title"),
	    		icon_board: this.model.get("icon_board"),
	    		icon_bar: this.model.get("icon_bar"),
	    		icon_manager: this.model.get("icon_manager"),
	    		review_stars: this.model.get("review_stars"),
	    		review_stars_total: (parseInt(this.model.get("review_stars"))*2),
	    		app_action: this.model.get("app_action"),
	    		review_total: this.model.get("review_total")
	    	};
	    	
	    	var compiledTemplate = _.template( storeItemTemplate, data );
	        
	        $(this.el).html(compiledTemplate);
	    	
	    	return this;
	    },
	    
	    showAppDetails: function()
	    {
	    	Backbone.log("showAppDetails fired");
	    	
	    	this.page.handleActionOverlay('enable');
	    	
	    	var appItemName = this.model.get("name");
	    	var self = this;
	    	
	    	//this must be changed
	    	this.page.appDetails.fetch(
	    		{
	    		data: {action: this.page.appDetails._meta.methodMap.read, params:{appName: appItemName}},
	    		success: function(model, resp) { self.handleappDetailsFetch(model, resp);}
	    		});
	    },
	    
	    handleappDetailsFetch: function(model, resp)
	    {
	    	this.page.currentView = 'appDetails';
	    	this.page.render();
	    	this.page.handleActionOverlay('disable');
	    }
	    
  });
  
  return appItemView;
});