// Filename: views/admin_market/appset
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_market/appitem',
  'views/admin_market/appitem'
], function($, _, Backbone, appItemModel, appItemView){
	
  var appSetView = Backbone.View.extend({
	  
	el : "#appstore-placeholder",
	
	initialize: function(options)
	{
		Backbone.log("appSetView initialize");
		
		this.page = options['page'];
		
		this.appItemViews = {};
        
        var self = this;
	},
	
    render: function()
    {
    	Backbone.log("appSetView render");
    	
    	var self = this;
    	
    	$(this.el).empty();
    	
    	if(this.model.models.length > 0)
    	{
    		var itemsContainer = $('<ul/>');
    		
    		_.each(this.model.models, function (appItem)
            {
        		var appItemId = appItem.get("id"); 
        		
        		var currentappItemView = new appItemView({model: appItem, page: self.page});
        		
        		self.appItemViews[appItemId] = currentappItemView;
        		
        		itemsContainer.append(currentappItemView.render().el);
            });
    		
    		$(self.el).append(itemsContainer);
    	}
    	else
    	{
    		$(self.el).append("<div class='col_12 center' style='margin:50px 0;'><p class='text bold'>There are no installed apps in this category !</p></div>");
    	}
    }
	
  });
  return appSetView;
});	