// Filename: views/admin_market/categoryitem
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_market/categoryitem'
], function($, _, Backbone, categoryItem){

  var categoryItemView = Backbone.View.extend(
  {
  		tagName: "li",
  		
	  	events :
	  	{
  			'click a.category-item' : 'changeCategory'
  		},
  		
	    initialize : function (options)
	    {
	    	Backbone.log("categoryItemView init");
	    	
	    	$(this.el).attr("id", 'category-item-'+this.model.get("name"));
	    	
	    	this.page = options['page'];
	    },
	    
	    changeCategory : function ()
	    {
	    	Backbone.log("changeCategory fired");
	    	
	    	var categoryItemName = this.model.get("name");
	    	
	    	this.page.viewCategoryDetails(categoryItemName);
	    },
	    
	    render : function ()
	    {
	    	Backbone.log("categoryItemView render");
	    	
	    	var categoryItem = $("<a/>",{ 'class': "category-item", href: "javascript:void(0)", html: this.model.get("title")});
	    	
	    	$(this.el).append(categoryItem);
	    	
	    	//set active category
    		if(this.page.currentCategory ==  this.model.get("name"))
			{
    			$(this.el).addClass("current");
			}
	    	
	    	return this;
	    }
  });
  
  return categoryItemView;
});