// Filename: views/admin_proxies/page
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_proxies/page',
  'collections/admin_boardset/boardset',
  'views/admin_boardset/boardset',
  'collections/admin_proxies/proxyset',
  'models/admin_proxies/newproxyitem',
  'views/admin_proxies/newproxyitem',
  'views/admin_proxies/proxyset',
  'text!templates/admin_proxies/page.html',
], function($, _, Backbone, PageModel, boardSet, boardSetView,  proxySet, newProxyModel, newProxyView, proxySetView, pageTemplate){

  var pageView = Backbone.View.extend(
  {
	    el: $('#page'),
	    
	    initialize : function ()
	    {
	    	Backbone.log("admin_proxies pageView init");
	    	
	    	var self = this;
	    	
	    	this.model = new PageModel();
	    	
	    	this.boardSet = new boardSet();
	    	this.boardSetView = null;
	    	
	    	this.proxySet = new proxySet();
	    	this.proxySetView = null;
	    	
	    	this.newProxyModel = new newProxyModel;
	    	
	    	//handle proxies
	    	this.model.bind("change", this.render, this);
	    	
	        this.model.fetch();
	    },
	    
	    render : function ()
	    {
	    	Backbone.log('admin_proxies pageView render');
	    	
	    	var self = this;
	    	
	    	$(this.el).empty();
	    	
	        //Draw boardset template
	    	var data = {};
	        var compiledTemplate = _.template( pageTemplate, data );
	        $(this.el).html( compiledTemplate );
	    	
	        //draw avaiable tabs list
	        if(this.model.has("boards"))
	        {
	        	this.activeBoardName = "proxies_manager";
	        	
	        	if(this.boardSet.models.length == 0)
	        	{
	        		this.boardSet.add(_.toArray(this.model.get("boards")));	
	        	}	
	        	
		        //create boardSetView and render it
		        this.boardSetView = new boardSetView({model: this.boardSet, page: this});
		        this.boardSetView.render();
	        }
	        
	        //handle admin proxies view ...
	        
	        //add newapp form
	        this.newProxyView = new newProxyView({model: this.newProxyModel, page: this});
	        this.newProxyView.render();
	        
	    	//populate dastasourceSet collection from pageModel
	    	this.proxySet.reset().add(_.toArray(this.model.get("availableProxies")));
	    	
	    	//Render proxySet collection
	        this.proxySetView = new proxySetView({model: this.proxySet, page: this});
	        this.proxySetView.render();
	    },
	    
	    getRnd: function()
	    {
	    	return Math.floor(Math.random()*11);	    	
	    }
  });
  
  return pageView;
});