// Filename: views/admin_proxies/proxyset
define([
  'jquery',
  'underscore',
  'backbone',
  'views/admin_proxies/proxyitem'
], function($, _, Backbone, proxyItemView){
	
  var proxySetView = Backbone.View.extend({
	  
	  el: '#admin-proxies-manager',
	
	initialize: function(options)
	{
		Backbone.log("proxySetView initialize");
		
		this.page = options['page'];
		
		this.proxyItemViews = {};
	},
	
    render: function()
    {
    	Backbone.log("proxySetView render");
    	
    	var self = this;
    	
    	var htmlTable = $('<table/>',{'width':'100%', 'class':'striped'}).css({'margin':'0px'});
    	
    	htmlTable.append($('<thead/>',{html:'<th width="15%">Status</th><th width="70%">Proxy</th><th width="15%">Actions</th>' }));
    	
    	if(this.model.models.length == 0)
    	{
    		htmlTable.append($('<td/>',{colspan:'6', html:'There are no proxies defined'}));	
    	}
    	else
    	{
            _.each(this.model.models, function (proxyItem, index)
            {
        		currentProxyItemView = new proxyItemView({model:proxyItem, page: self.page});
        		
        		self.proxyItemViews[index] = currentProxyItemView; 
        		
        		htmlTable.append(currentProxyItemView.render().el);
        		
        		if(index % 2 != 0)
        		{
        			htmlTable.find("#admin_proxy_item_"+proxyItem.get("name")).addClass("alt");	
        		}	
            });
    	}
        
        $(this.el).empty().append(htmlTable);
        
        return this;
    }
  });
  return proxySetView;
});	