// Filename: views/admin_settings/pageapi
define([
  'jquery',
  'underscore',
  'backbone',
  'text!templates/admin_settings/pageapi.html'
], function($, _, Backbone, pageTemplate){

  var apiSettingsView = Backbone.View.extend(
  {
  		tagName: "div",
  		
	  	events :
	  	{
	  		'click button#settings-api-btn' : 'handleApiSettings'	
  		},
  		
	    initialize : function(options)
	    {
	    	Backbone.log("apiSettingsView init");
	    	
	    	this.page = options['page'];
	    },

	    render : function ()
	    {
	    	Backbone.log("apiSettingsView render");
	    		
	        var compiledTemplate = _.template( pageTemplate, {} );
	        $(this.el).html( compiledTemplate );
	        
	        var adminSettings = this.page.model.get('adminSettings');
	        
	        if(adminSettings['osc_api_key'])
	        {
	        	$(this.el).find('#api_user_box').val(adminSettings['osc_user']);
	        	$(this.el).find('#api_key_box').val(adminSettings['osc_api_key']);
	        }

	    	return this;
	    },
	    
	    handleApiSettings: function()
	    {
	    	Backbone.log("handleApiSettings trigerred");
	    	
	    	var apiUsrValue = $(this.el).find("#api_user_box").val();
	    	var apiKeyValue = $(this.el).find("#api_key_box").val();
	    	
	    	if(apiUsrValue || apiKeyValue)
	    	{
	    		//update admin Settings
	    		var adminSettings = this.page.model.get('adminSettings');
	    		
	    		adminSettings['osc_user'] = apiUsrValue;
	    		adminSettings['osc_api_key'] = apiKeyValue;
	    		
	    		this.page.model.set({'current_op': "change_api", 'adminSetings': adminSettings});
		    	this.page.model.save();
	    	}
	    }	    
	    
  });
  
  return apiSettingsView;
});