// Filename: views/admin_settings/pagebasic
define([
  'jquery',
  'underscore',
  'backbone',
  'text!templates/admin_settings/pagebasic.html'
], function($, _, Backbone, pageTemplate){

  var basicSettingsView = Backbone.View.extend(
  {
  		tagName: "div",
  		
	  	events :
	  	{
	  		'click input#community_stats_box' : 'handleCommunityStats'  			
  		},
  		
	    initialize : function(options)
	    {
	    	Backbone.log("basicSettingsView init");
	    	
	    	this.page = options['page'];
	    },

	    render : function ()
	    {
	    	Backbone.log("basicSettingsView render");
	    		
	        var compiledTemplate = _.template( pageTemplate, {} );
	        $(this.el).html( compiledTemplate );
	        
	        var communityStatsBox = $(this.el).find('#community_stats_box');
	        
	        communityStatsBox.prop('checked', false);
	        
	        var adminSettings = this.page.model.get('adminSettings');
	        if(adminSettings['community_stats'])
	        {
	        	if(adminSettings['community_stats'] == "1")
        		{
	        		communityStatsBox.prop('checked', true); 
        		}
	        }	        

	    	return this;
	    },
	    
	    handleCommunityStats: function()
	    {
	    	Backbone.log("handleCommunityStats trigerred");
	    	
	    	var communityStatsBox = $(this.el).find("#community_stats_box");
	    	
	    	if(communityStatsBox)
	    	{
	    		//update admin Settings
	    		var adminSettings = this.page.model.get('adminSettings');
	    		
	    		adminSettings['community_stats'] = communityStatsBox.prop('checked');
	    		
	    		this.page.model.set({'current_op': "change_settings",	'adminSettings': adminSettings});
		    	this.page.model.save();
	    	}
	    }	    
  });
  
  return basicSettingsView;
});