// Filename: views/admin_settings/pagemail
define([
  'jquery',
  'underscore',
  'backbone',
  'text!templates/admin_settings/pagemail.html'
], function($, _, Backbone, pageTemplate){

  var mailSettingsView = Backbone.View.extend(
  {
  		tagName: "div",
  		
	  	events :
	  	{
	  		'change select#send_type_box' : 'handleMailTypeChange',
	  		'click button#settings-mail-smtp-btn' : 'handleSmtpSettings',
	  		'click button#settings-mail-sendmail-btn' : 'handleSendmailSettings'
  		},
  		
	    initialize : function(options)
	    {
	    	Backbone.log("mailSettingsView init");
	    	
	    	this.page = options['page'];
	    },

	    render : function ()
	    {
	    	Backbone.log("mailSettingsView render");
	    	
	    	var adminSettings = this.page.model.get('adminSettings');
	    	
	        var compiledTemplate = _.template(pageTemplate, {});
	        $(this.el).html( compiledTemplate );
	        
	        if(adminSettings['os_mail_type'])
	        {
	        	var El = $(this.el);
	        	var os_mail_type = adminSettings['os_mail_type'];
	        	var selectObj = El.find('#send_type_box');
	        	
	        	selectObj.find('option[value="'+os_mail_type+'"]').prop('selected', true);
	        	
	        	//set saved values for smtp mail
	        	if(adminSettings['os_mail_smtp_host'])  El.find('#smtp_host_box').val(adminSettings['os_mail_smtp_host']);
	        		
	        	if(adminSettings['os_mail_smtp_username']) El.find('#smtp_user_box').val(adminSettings['os_mail_smtp_username']);
	        		
	        	if(adminSettings['os_mail_smtp_password']) El.find('#smtp_password_box').val(adminSettings['os_mail_smtp_password']);
	        		
	        	if(adminSettings['os_mail_smtp_auth'])
	        	{
		        	if(adminSettings['os_mail_smtp_auth'] == "1")
	        		{
		        		El.find('#smtp_auth_box').prop('checked', true); 
	        		}
	        	}	
	        	
	        	//set saved values for sendmail
	        	if(adminSettings['os_mail_sendmail_path']) El.find('#sendmail_path_box').val(adminSettings['os_mail_sendmail_path']);
	        }	

	    	return this;
	    },
	    
	    handleSmtpSettings: function()
	    {
	    	Backbone.log("handleSmtpSettings triggered");
	    	
	    	var El = $(this.el);
	    	
	    	var smtpHostValue = El.find("#smtp_host_box").val();
	    	var smtpUserValue = El.find("#smtp_user_box").val();
	    	var smtpPasswordValue = El.find("#smtp_password_box").val();
	    	var smtpAuthValue = El.find("#smtp_auth_box");
	    	
	    	if(smtpHostValue || smtpUserValue || smtpPasswordValue || smtpAuthValue)
	    	{
	    		//update admin Settings
	    		var adminSettings = this.page.model.get('adminSettings');
	    		
	    		adminSettings['os_mail_smtp_host'] = smtpHostValue;
	    		adminSettings['os_mail_smtp_username'] = smtpUserValue;
	    		adminSettings['os_mail_smtp_password'] = smtpPasswordValue;
	    		adminSettings['os_mail_smtp_auth'] = smtpAuthValue.prop('checked');
	    		
	    		this.page.model.set({'current_op': "change_smtpmail", 'adminSetings': adminSettings});
		    	this.page.model.save();
	    	}
	    },
	    
	    handleSendmailSettings: function()
	    {
	    	Backbone.log("handleSendmailSettings triggered");
	    	
	    	var sendmailPathValue = $(this.el).find("#sendmail_path_box").val();
	    	
	    	if(sendmailPathValue)
	    	{
	    		//update admin Settings
	    		var adminSettings = this.page.model.get('adminSettings');
	    		
	    		adminSettings['os_mail_sendmail_path'] = sendmailPathValue;
	    		
	    		this.page.model.set({'current_op': "change_sendmail", 'adminSetings': adminSettings});
		    	this.page.model.save();
	    	}
	    },

	    handleMailTypeChange: function()
	    {
	    	Backbone.log("handleMailTypeChange triggered");

	    	var mailTypeValue = $(this.el).find("#send_type_box").val();
	    	
	    	if(mailTypeValue)
	    	{
	    		//update admin Settings
	    		var adminSettings = this.page.model.get('adminSettings');
	    		
	    		adminSettings['os_mail_type'] = mailTypeValue;
	    		
	    		this.page.model.set({'current_op': "change_mail_type", 'adminSetings': adminSettings});
		    	this.page.model.save();
	    	}
	    }
	    
  });
  
  return mailSettingsView;
});