// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone'
], function($, _, Backbone){

  var sectionItemView = Backbone.View.extend(
  {
  		tagName: "li",
  		
	  	events : {
  			'click a.section-item' : 'changeSection'
  		},
  		
	    initialize : function (options)
	    {
	    	Backbone.log("sectionItemView init");
	    	
	    	$(this.el).attr("id", 'section-item-'+this.model.get("id"));
	    	
	    	this.page = options['page'];
	    },
	    
	    changeSection : function ()
	    {
	    	Backbone.log("changeSection triggered");
	    	
	    	var sectionItemName = this.model.get("name");
	    	
	    	this.page.viewSectionDetails(sectionItemName);
	    },
	    
	    render : function ()
	    {
	    	Backbone.log("sectionItemView render");
	    	
	    	var sectionItem = $("<a/>",{ 'class': "section-item", href: "javascript:void(0)", html: this.model.get("title")});
	    	
	    	$(this.el).append(sectionItem);
	    	
	    	//set active section
    		if(this.page.currentSection ==  this.model.get("name"))
			{
    			$(this.el).addClass("current");
			}
	    	
	    	return this;
	    }
  });
  
  return sectionItemView;
});