// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_settings/sectionitem',
  'views/admin_settings/sectionitem'
], function($, _, Backbone, sectionItemModel, sectionItemView){
	
  var sectionSetView = Backbone.View.extend({
	  
	el : "#sections-placeholder",
	
	initialize: function(options)
	{
		Backbone.log("sectionSetView initialize");
		
		this.page = options['page'];
		
		this.sectionsItemViews = {};
	},
	
    render: function()
    {
    	Backbone.log("sectionSetView render");
    	
    	var self = this;
    	
    	var itemsContainer = $("<ul/>",{'class': "menu vertical right"});
    	
    	$(this.el).empty();
        _.each(this.model.models, function (sectionItem)
        {
    		var sectionItemName = sectionItem.get("name"); 
    		
    		var currentSectionItemView = new sectionItemView({model: sectionItem, page: self.page});
    		
    		self.sectionsItemViews[sectionItemName] = currentSectionItemView;
    		
    		itemsContainer.append(currentSectionItemView.render().el);
        });
        
        $(self.el).append(itemsContainer);
    }
	
  });
  return sectionSetView;
});	