// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'models/admin_settings/sectionitem',
  'views/admin_settings/sectionitemtouch'
], function($, _, Backbone, sectionItemModel, sectionItemTouchView){
	
  var sectionSetTouchView = Backbone.View.extend({
	  
	el : "#sections-placeholder-touch",
	
	events : {
		'change' : 'changeSection'
	},
	
	initialize: function(options)
	{
		Backbone.log("sectionSetTouchView initialize");
		
		this.page = options['page'];
		
		this.sectionsItemViews = {};
	},
	
	changeSection: function()
	{
		var currentSection=$(this.el).val();
		
		this.page.viewSectionDetails(currentSection);
	},
	
    render: function()
    {
    	Backbone.log("sectionSetTouchView render");
    	
    	var self = this;
    	
    	$(this.el).empty();
        _.each(this.model.models, function (sectionItem)
        {
    		var sectionItemName = sectionItem.get("name"); 
    		
    		var currentSectionItemView = new sectionItemTouchView({model: sectionItem, page: self.page});
    		
    		self.sectionsItemViews[sectionItemName] = currentSectionItemView;
    		
    		$(self.el).append(currentSectionItemView.render().el);
        });
    }
	
  });
  return sectionSetTouchView;
});	