// Filename: views/admin_settings/settings_item
define([
  'jquery',
  'underscore',
  'backbone',
  'text!templates/admin_settings/settings_item.html'
], function($, _, Backbone, settingsItemTemplate){

  var settingsItemView = Backbone.View.extend(
  {
  		el: '#admin-settings-items',
  		
	  	events :
	  	{	
	  		'click input#community_stats_box' : 'handleCommunityStats'
  		},
  		
	    initialize : function (options)
	    {
	    	Backbone.log("settingsItemView init");
	    	
	    	this.page = options['page'];
	    },
	    
	    render : function ()
	    {
	    	Backbone.log("settingsItemView render");
	    	
	    	var data = {};
	    	
	        var compiledTemplate = _.template( settingsItemTemplate, data );
	        $(this.el).html( compiledTemplate );
	        
	        if(this.page.model.has('community_stats'))
	        {
	        	if(this.page.model.get('community_stats') == 'Y')
        		{
	        		$(this.el).find('#community_stats_box').prop('checked', true); 
        		}
	        }
	        
	        if(this.page.model.has('osc_api_key'))
	        {
	        	$(this.el).find('#api_user_box').val(this.page.model.get('osc_user'));
	        	$(this.el).find('#api_key_box').val(this.page.model.get('osc_api_key'));
	        }
	        
	        return this;
	    },
	    
	    
	    handleCommunityStats: function()
	    {
	    	Backbone.log("handleCommunityStats trigerred");
	    	
	    	var communityStatsValue =  $(this.el).find("#community_stats_box").val();
	    	
	    	if(communityStatsValue)
	    	{
	    		var details = {
	    			'current_op': "change_settings", 
	    			'community_stats_box': communityStatsValue, 
	    			};
	    		
	    		this.page.model.set(details);
		    	this.page.model.save();
	    	}
	    }
	    
  });
  
  return settingsItemView;
});