// Filename: views/home/main
define([
  'jquery',
  'underscore',
  'backbone',
  'views/admin_widgets_manager/widgetitem'
], function($, _, Backbone, widgetItemView){
	
  var installedWidgetSetView = Backbone.View.extend({
	  
	  el: '#installed-widgets-container',
	
	initialize: function(options)
	{
		Backbone.log("installedWidgetSetView initialize");
		
		this.page = options['page'];
		
		this.widgetItemViews = {};
	},
	
    render: function()
    {
    	Backbone.log("installedWidgetSetView render");
    	
    	var self = this;
    	
    	var i=0; $(this.el).empty();
        _.each(this.model.models, function (widgetItem)
        {
    		i++;
    		
    		var widgetItemId = widgetItem.get("id");
    		
    		currentWidgetItemView = new widgetItemView({temp:i, model:widgetItem, page: self});
    		
    		self.widgetItemViews[widgetItemId] = currentWidgetItemView; 
    		
    		$(self.el).append(currentWidgetItemView.render().el);
        });
        
        return this;
    }
    
  });
  return installedWidgetSetView;
});	