// Filename: views/ajax_upload/fileitem
define([
  'jquery',
  'underscore',
  'backbone',
], function($, _, Backbone){

  var fileItemView = Backbone.View.extend({

	  tagName: 'li',

	  template: '<%= readonly ? "" : "<span class=delete>[delete]</span>"%><a href="<%=url%>"><%=filename%></a>',

	  events:
	  {
		  'click .delete': '_delete'
	  },

	  initialize: function(options)
	  {
		  Backbone.log("fileItemView initialize");
		  
		  options = options || {};

		  _.bindAll(this, 'readonly', 'remove');

		  this._readonly = options.readonly || false;

		  this.model.bind('destroy', this.destroy, this);

		  return this;
	  },

	  render: function()
	  {
		  Backbone.log("fileItemView render");
		  
		  $(this.el).html(_.template(this.template, this.serialize()));
		  
		  return this;
	  },

	  serialize: function()
	  {
		  return {
			  readonly: this._readonly,
			  url: this.model.get('url'),
			  filename: this.model.get('filename')
		  };
	  },

	  destroy: function()
	  {
		  this.model.off('destroy', this.destroy);
		  $(this.el).slideUp(this.remove);
	  },

	  _delete: function()
	  {
		  if (!this._readonly)
		  {
			  this.model.destroy();
		  }
	  },

	readonly: function(enabled)
	{
		if (this._readonly != enabled)
		{
			this._readonly = enabled;

			this.render();
		}
	}	
});
  
  return fileItemView;
});