// Filename: views/ajax_upload/fileinputitem
define([
  'jquery',
  'underscore',
  'backbone',
  'views/ajax_upload/fileinputitem'
], function($, _, Backbone, fileInputView){

  var fileLabelView = fileInputView.extend({

	  tagName: 'label',

	  className: 'file-upload',

	  events:
	  {
		  'change input[type=file]': 'handleInputChange'
	  },

	  template: '<%=text%><input type=file name=<%=name%> <%= enabled ? "" : "disabled=disabled" %> <%= multiple ? "multiple" : ""%> />',

	  initialize: function(options)
	  {
		  Backbone.log("fileLabelView initialize");
		  
		  options = options || {};
	      
		  this._text = options.text || 'Upload File';
	      
		  this.template = options.template || _.template(this.template);
		  
		  return fileInputView.prototype.initialize.call(this, options);		  
	  },
	  
	  serialize: function()
	  {
		  return {text: this._text,
			  name: this._name,
			  multiple: this._multiple,
			  enabled: this._enabled};
	  },
	  
	  render: function()
	  {
		  Backbone.log("fileLabelView render");
		  
		  this.$el.html(this.template(this.serialize()));

		  this.$input = this.$('input[type=file]');

		  if (!this._enabled)
		  {
			  this.$el.addClass('disabled');
		  }
		  return this;
	  },
	  

	  enable: function(enable)
	  {
		  if (this._enabled != enable)
		  {
			  $(this.el)[enable ? 'removeClass' : 'addClass']('disabled');
			  return fileInputView.prototype.enable.call(this, enable);
		  }
	  }
	  
  });
  
  return fileLabelView;
});