// Filename: views/ajax_upload/fileitem
define([
  'jquery',
  'underscore',
  'backbone',
  'views/ajax_upload/fileitem'
], function($, _, Backbone, fileItemView){

  var listItemView = Backbone.View.extend({

	  tagName: 'ul',

	  initialize: function(options)
	  {
		  Backbone.log("listItemView initialize");
		  
		  options = options || {};

		  _.bindAll(this, 'add');

		  this.collection.bind('reset', this.render, this);

		  this.collection.bind('add', this.add, this);

		  this.file_views = [];

		  this._readonly = options.readonly || false;

		  return this;
	  },

	  render: function()
	  {
		  Backbone.log("listItemView render");
		  
		  this.collection.each(this.add);

		  return this;
	  },

	  add: function(file)
	  {
		  var view = new fileItemView({model: file, readonly: this._readonly}).render();

		  $(this.el).append(view.el);

		  this.file_views.push(view);
	  },

	  readonly: function(enabled)
	  {
		  if (this._readonly != enabled)
		  {
			  this._readonly = enabled;

			  _.invoke(this.file_views, 'readonly', enabled);
		  }
	  },

	  toggle_readonly: function()
	  {
		  this.readonly(!this._readonly);
	  }	
});
  
  return listItemView;
});