// Filename: views/ajax_upload/mainitem
define([
  'jquery',
  'underscore',
  'backbone',
  'collections/ajax_upload/fileuploadset',
  'views/ajax_upload/filelableitem',
  'views/ajax_upload/listitem'
], function($, _, Backbone, fileUploadSet, fileLabelView, listItemView){

  var mainItemView = Backbone.View.extend({
	  el: "#main",
	  
	  url : "../controllers/ajax_upload/index.php",
  			
	  events:
	  {
		  'click .toggle-readonly': 'toggle_readonly'
	  },

	  initialize: function()
	  {
		  Backbone.log("mainItemView initialize");
		  
		  this.collection = new fileUploadSet();
		  //this.collection.fetch();
		  
		  return this;
	  },

	  render: function()
	  {
		  Backbone.log("mainItemView render");
		  
		  var uploadData = {'action': 'doFileUpload'};
		  
		  this.upload_view = new fileLabelView({collection: this.collection, text: '&#8853; Upload!', data: uploadData});
			  
		  this.upload_view.bind('uploading', this.uploading, this);

		  this.upload_view.bind('done', this.done, this);

		  this.upload_view.bind('fail', this.fail, this);

		  this.upload_view.bind('enabled', this.enable, this);

		  this.upload_view.render();

		  $(this.upload_view.el).insertAfter(this.$('.toggle-readonly'));

		  this.files_view = new listItemView({collection: this.collection}).render();
		  
		  $(this.files_view.el).insertBefore(this.$('.log'));
		  
		  return this;
	  },

	  uploading: function()
	  {
		  this.$('.file-upload').addClass('disabled');

		  this.$('.log').append('<li>Uploading...</li>');
	  },

	  enable: function(enabled)
	  {
		  this.$('.file-upload')[enabled ? 'removeClass' : 'addClass']('disabled');
	  },

	  fail: function(data)
	  {
		  console.error(data);

		  this.$('.log').append('<li>Error</li>');
	  },

	  done: function()
	  {
		  this.$('.log').append('<li>Success</li>');

		  this.$('.file-upload').removeClass('disabled');
	  },

	  toggle_readonly: function(ev)
	  {
		  ev.preventDefault();

		  this.upload_view.toggle_enable();

		  this.files_view.toggle_readonly();

		  this.$('.toggle-readonly').text('readonly: ' + this.files_view._readonly);
	  }	  
  });
  
  return mainItemView;
});