// Filename: views/apps/appset
define([
  'jquery',
  'underscore',
  'backbone',
  'models/apps/app',
  'views/apps/app',
], function($, _, Backbone, appItemModel, appItemView){

  var appSetView = Backbone.View.extend(
  {
	  	el: "ul#appBoardContainer",
	    
	    events:
	    {
	    },
	    
	    initialize: function (options)
	    {
	    	Backbone.log("appSetView initialize");
	    	
			var self = this;
			
	    	this.page = options['page'];
			
			this.appItemViews = {};

		 	$(this.el).sortable({
    			placeholder: 'appboard-item-placeholder',
    			distance: 20,
    			start: function(event,ui) {self.handleAppItemDragStart(event, ui, this)},
    			stop: function(event,ui) {self.handleAppItemDragStop(event, ui, this)}
    			
    		}).disableSelection();
			
			//this.model.bind("change", this.render, this);
	    },
	    
	    render: function()
	    {
	    	Backbone.log("appSetView render");
	    	
	    	var self = this;
	    	
	    	var i=0; 
	    	$(this.el).empty();
        	_.each(this.model.models, function (appItem) 
        	{
        		i++;
        		
        		var currentAppItemView = new appItemView({temp:i, model:appItem, page: self.page});
        		
        		self.appItemViews[appItem.get("id")] = currentAppItemView; 
        		
        		$(self.el).append(currentAppItemView.render().el);
        	});	    	
	    	
	        return this;
	    },
	    
	    handleAppItemDragStart: function(event, ui, el)
	    {
	    	Backbone.log('handleAppItemDragStart fired');
	    	
	    	//undelegate appItemView events to prevent onmouseover while dragging
	    	var currentAppItem = $(ui.item);
	    	var parts = currentAppItem.find(".appBoardItem").attr("id").split("_");
	    	var currentAppItemId = parts[1];
	    	
	    	if(this.appItemViews[currentAppItemId])
	    	{
	    		this.appItemViews[currentAppItemId].undelegateEvents();
	    	}
	    	
	    	currentAppItem.find('.app-icon-overlay').removeClass("show-overlay");
	    	currentAppItem.find('.app-icon-container').addClass('app-dragging-disabled');
	    },

	    handleAppItemDragStop: function(event, ui, el)
	    {
	    	Backbone.log('handleAppItemDragStop fired');
	    	
	    	var movedApp = $(ui.item).data('model');
	    	
	        var i = 1;
	        $(el).find("li.appBoardItemWrapper").each(function ()
	        {
	        	var model = $(this).data("model");
	        	model.set({"position" : i++});
	        });
	        
	        movedApp.save();
	        
	        //redelegate appItemView events
	    	var currentAppItem = $(ui.item);
	    	var parts = currentAppItem.find(".appBoardItem").attr("id").split("_");
	    	var currentAppItemId = parts[1];
	    	
	    	if(this.appItemViews[currentAppItemId])
	    	{
	    		this.appItemViews[currentAppItemId].delegateEvents();
	    	}
	    	
	    	currentAppItem.find('.app-icon-container').removeClass('app-dragging-disabled');
	    }
	    
  });
  return appSetView;
});