// Filename: views/apps/page
define([
  'jquery',
  'underscore',
  'backbone',
  'jqueryui',
  'collections/apps/appset',
  'models/apps/page',
  'views/apps/appset'
], function($, _, Backbone, jqueryUI, appSet, pageModel, appSetView){

  var pageView = Backbone.View.extend(
  {
	    el: $('#page'),
	    
	    initialize : function (options)
	    {
	    	var self = this;
	    	
	    	Backbone.log("appBoardView init");
	    	
	    	//check active app
	    	this.active_app = false;
	    	if(options)
	    	{
	    		if(options['active_app'])
	    		{
	    			this.active_app = options['active_app'];
	    			
	    			if (options['active_app_view'])
	    			{
	    				this.active_app_view = options['active_app_view'];
	    				
	    				if (options['active_app_params'])
	    				{
	    					this.active_app_params = options['active_app_params'];
	    				}
	    				else
	    				{
	    					this.active_app_params = false;
	    				}
	    			}
	    			else
	    			{
	    				this.active_app_view=false;
	    			}
	    		}
	    	}
	    	
	    	this.model = new pageModel();
	    	
	    	this.appSet = new appSet();
	    	
	    	this.appSet.bind("reset", this.handleAppsReset, this);
	    	
	    	this.model.bind("change", this.render, this);
	    	
	        this.model.fetch();
	    },
	    
	    render : function ()
	    {
	    	var self = this;
	    	
	    	Backbone.log('pageView render');
	    	
	    	//extend app-window-container
	    	$('#app-window-container').height($('#wrap').height()-$('.menu.menu-left').height()-50);
	    	
	    	//add available apps to the appSet
	    	if(this.model.has('availableApps'))
	    	{
		    	if(this.appSet.models.length == 0)
				{
		    		this.appSet.add(_.toArray(this.model.get('availableApps')));
				}				 
	    	}	
	    	
	    	//render appboard template
	    	$(self.el).html("<div class='tab-content tab-content-livedash clearfix tab-content-opens-margin-fix'><ul id='appBoardContainer'></ul></div>");
	    	
	        //Render  apps list
	        this.appSetView = new appSetView({model: this.appSet, page: this});
	        this.appSetView.render();
	    },
	    
	    handleAppsReset: function()
	    {
	    	Backbone.log("handleAppsReset triggered");
	    }
  });
  
  return pageView;
});