// Filename: views/market/categoryitem
define([
  'jquery',
  'underscore',
  'backbone',
  'models/market/categoryitem'
], function($, _, Backbone, categoryItem){

  var categoryItemView = Backbone.View.extend(
  {
  		tagName: "li",
  		
	  	events : {
  			'click a.category-item' : 'changeCategory'
  		},
  		
	    initialize : function (options)
	    {
	    	Backbone.log("categoryItemView init");
	    	
	    	$(this.el).attr("id", 'category-item-'+this.model.get("name"));
	    	
	    	this.page = options['page'];
	    },
	    
	    changeCategory : function (a)
	    {
	    	Backbone.log("changeCategory fired");

	    	var categoryItemName = this.model.get("name");
	    	console.log(this.page);
	    	this.page.viewCategoryDetails(categoryItemName);
	    },
	    
	    render : function ()
	    {
	    	Backbone.log("categoryItemView render");
	    	
	    	var categoryItem = $("<a/>",{ 'id': "category-link-"+this.model.get('name'), 'class': "category-item", href: "javascript:void(0)", html: this.model.get("title")});
	    	
	    	$(this.el).append(categoryItem);
	    	
	    	//set active category
    		if(this.page.currentCategory ==  this.model.get("name"))
			{
    			$(this.el).addClass("current");
			}
			
			//$('#categories-placeholder-touch').append("<option value='' id='category-touch-"+this.model.get('name')+"' "+(this.page.currentCategory==this.model.get('name')?"selected":'')+">"+this.model.get('title')+"</option>");
			//$('#category-touch-'+this.model.get('name')).click($('#category-link-'+this.model.get('name')).click);
	    	
	    	return this;
	    }
  });
  
  return categoryItemView;
});