// Filename: views/market/categoryset
define([
  'jquery',
  'underscore',
  'backbone',
  'models/market/categoryitem',
  'views/market/categoryitem'
], function($, _, Backbone, categoryItemModel, categoryItemView){
	
  var categorySetView = Backbone.View.extend({
	  
	el : "#categories-container",
	
	initialize: function(options)
	{
		Backbone.log("categorySetView initialize");
		
		this.page = options['page'];
		
		this.categoriesItemViews = {};
		
		this.model.bind("reset", this.render, this);
	},
	
    render: function()
    {
    	Backbone.log("categorySetView render");
    	
    	var self = this;
    	
    	$(this.el).find('#categories-placeholder').empty();
    	//$(this.el).parent().find('#categories-placeholder-touch').empty();
    	var itemsContainer = $('<ul/>', {'class': "menu vertical right"});
        _.each(this.model.models, function (categoryItem)
        {
    		var categoryItemId = categoryItem.get("name"); 
    		
    		var currentCategoryItemView = new categoryItemView({model: categoryItem, page: self.page});
    		
    		self.categoriesItemViews[categoryItemId] = currentCategoryItemView;
    		
    		itemsContainer.append(currentCategoryItemView.render().el);
        });
        
        $(self.el).find('#categories-placeholder').append(itemsContainer);
    }
	
  });
  return categorySetView;
});	