// Filename: views/market/categorysettouch
define([
  'jquery',
  'underscore',
  'backbone',
  'models/market/categoryitem',
  'views/market/categoryitemtouch'
], function($, _, Backbone, categoryItemModel, categoryItemTouchView){
	
  var categorySetTouchView = Backbone.View.extend({
	  
	el : "#categories-container-touch",
	
	events : {
		'change #categories-placeholder-touch' : 'changeCategory'
	},
	
	initialize: function(options)
	{
		Backbone.log("categorySetView initialize");
		
		this.page = options['page'];
		
		this.categoriesItemViews = {};
		
		this.model.bind("reset", this.render, this);
	},
	
	changeCategory: function()
	{
		var currentCategory=$(this.el).find('#categories-placeholder-touch').val();
		
		this.page.viewCategoryDetails(currentCategory);
	},
	
    render: function()
    {
    	Backbone.log("categorySetView render");
    	
    	var self = this;
    	
    	$(this.el).find('#categories-placeholder-touch').empty();
    	
        _.each(this.model.models, function (categoryItem)
        {
    		var categoryItemId = categoryItem.get("name"); 
    		
    		var currentCategoryItemTouchView = new categoryItemTouchView({model: categoryItem, page: self.page});
    		
    		self.categoriesItemViews[categoryItemId] = currentCategoryItemTouchView;
    		
    		$(self.el).find('#categories-placeholder-touch').append(currentCategoryItemTouchView.render().el);
        });
    }
	
  });
  return categorySetTouchView;
});	