// Filename: views/project_manager/project
define([
  'jquery',
  'underscore',
  'backbone',
  'models/project_manager/project',
  'text!templates/basic/menudisplay.html',
], function($, _, Backbone, projectModel, menuTemplate){

  var projectView = Backbone.View.extend(
  {
	    el: $('.top-menu'),
	    
	    initialize : function (options)
	    {
	    	Backbone.log("project_manager projectView init");
	    	
	    	var self = this;
	    	
	    	this.model = new projectModel();
	    	
	    	this.project_id = options.project_id;
	    	
	    	//handle events
	  		this.model.set({'current_op': 'change_project', 'project_id': this.project_id});
	  		this.model.save({},{success: function(newModel, resp)
	  		{
	  			self.render();
	  			self.handleProjectChange(newModel, resp);
	  		}});
	    },
	    
	    render : function ()
	    {
	    	Backbone.log("project_manager projectView render");
	    	
	    	if(this.model.has('os_menu'))
	    	{
	    		var data = {'menuDetails' : this.model.get('os_menu'), 'is_logged': true};
	    		
	    		var compiledTemplate = _.template( menuTemplate, data );
		        $(this.el).html(compiledTemplate);
		        this.activateMenus();
	    	}	
	    },
	    
	    handleProjectChange: function(newModel, resp)
	    {
  			if(resp)if(resp.data)if(resp.data.actionStatus)
  			{
  				Backbone.router.navigate('widgets', {trigger: true});		
  			}	
	    },
	    
	    activateMenus :function()
	    {
	    	//Activate MENU Dropdowns
	    	$('ul.menu').each(function(){
				// find menu items with children.
				$(this).find('li').has('ul').addClass('has-menu')
				.append('<span class="arrow">&nbsp;</span>');
			});
			
			$('ul.menu li').hover(function(){
				$(this).find('ul:first').stop(true, true).fadeIn('fast');
				$(this).addClass('hover');
			},
			function(){
				$(this).find('ul').stop(true, true).fadeOut('slow');
				$(this).removeClass('hover');
			});
			
			//Activate Icons
			$('.icon').each(function(){
				$(this).append('<span aria-hidden="true">'+$(this).attr('data-icon')+'</span>')
				.css('display', 'inline-block');
			});
	    }
	    
  });
  
  return projectView;
});