// Filename: views/widgets/boardset
define([
  'jquery',
  'underscore',
  'backbone',
  'models/widgets/board',
  'views/widgets/boarditem',
  'text!templates/widgets/boardset.html',
], function($, _, Backbone, boardItemModel, boardItemView, boardSetTemplate){

  var boardSetView = Backbone.View.extend(
  {
	  	el: "ul#dash-sections-container",
	    
	    events :
	    {
	        "click span#new_board_btn" : "new_board"
	    },
	    
	    initialize : function (options)
	    {
	    	Backbone.log("BoardSetView initialize");
	    	
	    	$(this.el).addClass("tabs");
	    	
			this.page = options['page'];
			
			this.boardsItemViews = {};
			
			this.model.bind("change", this.render, this);
	    },
	    
	    render: function()
	    {
	    	Backbone.log("BoardSetView render");
	    	
	    	var self = this;
	    	
	        //append new tab button
	        var addSectionTab = $("<li/>", {'class': "last", id: "new-board-btn",  html:"<span data-icon='+' title='Add New Board' id='new_board_btn' class='new_board icon green' style='display: inline-block;'><span aria-hidden='true'>+</span></span>"});
	        addSectionTab.css({paddingLeft:'10px'});
	    	
	    	$(this.el).empty();
	    	
	        _.each(this.model.models, function (boardsetItem)
	        {
	        	self.pushOneBoard(boardsetItem);
	        });
	        
	        $(this.el).append(addSectionTab);
	        
	        return this;
	    },
	   
	    new_board: function()
	    {
	    	Backbone.log("boardItemModel save");
	    	
	    	var board_title = window.prompt("Title ?");
	        if (!board_title) return;
	        
	        var self = this;
	        
	        var board = new boardItemModel();
	        
	        board.save({"name": board_title},{success:function(boardItemModel){
	        	
	        	var totalBoards = self.page.boards.models.length;
	        	
	        	$(self.el).find('#new-board-btn').remove();
	        	
	        	self.page.boards.add(boardItemModel);
	        	
	        	self.pushOneBoard(boardItemModel);
	        	
	        	//if first board make it active
	        	if(totalBoards == 0)
	        	{
	        		self.page.activeBoard = boardItemModel;
	        		self.page.render();
	        	}
	        	else
	        	{
	        		var addSectionTab = $("<li/>", {'class': "last", id: "new-board-btn",  html:"<span data-icon='+' title='Add New Board' id='new_board_btn' class='new_board icon green' style='display: inline-block;'><span aria-hidden='true'>+</span></span>"});
	        		addSectionTab.css({paddingLeft:'10px'});
	        		$(self.el).append(addSectionTab);
	        	}	
	        }});
	    },
	    
	    pushOneBoard: function(boardItemModel)
	    {
    		var page = this.page;
    		
	    	var boardItemId = boardItemModel.get("id"); 
    		
    		var currentBoardItemView = new boardItemView({model: boardItemModel, page: page});
    		
    		this.boardsItemViews[boardItemId] = currentBoardItemView;
    		
    		$(this.el).append(currentBoardItemView.render().el);
	    }
  });
  return boardSetView;
});