// Filename: views/widgets/widgetset
define([
  'jquery',
  'underscore',
  'backbone',
  'views/widgets/widgetitem',
], function($, _, Backbone, widgetItemView){


var widgetSetView = Backbone.View.extend({
	tagName : "ul",

	initialize: function(options)
	{
		Backbone.log("widgetSetView initialize");
		
		$(this.el).addClass("widgets-column");

		//hook to storySetView
		this.page = options['page'];
		
		//binding all 
		this.model.bind("all", this.eventAll, this);
	},
	  
    render: function()
    {
    	Backbone.log("widgetSetView render");
    	
    	var self = this;
    	
    	$(this.el).empty();
        _.each(this.model.models, function (widgetItem)
    	{
    		$(self.el).append(new widgetItemView({model:widgetItem, page: self.page}).render().el);
    	});
        return this;
    },

    eventAll: function(event, model, options)
    {
    	Backbone.log("widgetSetView trigger "+event);
    },
    
    handleToggleOptions: function()
    {
    	Backbone.log("widgetSetView handleToggleOptions triggered");
    	
    	$(this.el).parent().parent().slideToggle('slow');
    }
  });

  return widgetSetView;
});