<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */
include('../init.php');

$OS=getOS();
$user=$OS->getUser();$user->forceUserLogin();
$project=$OS->getProject();$project->forceProjectSelected();

if (!empty($_GET['app'])) $appName=$_GET['app'];
elseif (!empty($_POST['app'])) $appName=$_POST['app'];
else $appName=false;

$appHandler=$OS->getAppHandler();
$appHandler->name=$appName;
$appHandler->loadByName();

if ($app=$appHandler->getAppPlugin())
{
	if ($app_response = $appHandler->processAppRequest())
	{
		$first_open=true;
		if ($openedApps=$OS->getSessionVar('opened_apps',$project->id))
		{
			if (isset($openedApps[$appHandler->app_id]))
			{
				$first_open=false;
			}
		}
		
		if ($first_open)
		{
			$appStatsOps=$OS->getAppStatsOps();
			$appStatsOps->log($appHandler->app_id,$appHandler->name,'open');
			
			$OS->setSessionVar('opened_apps',array($project->id=>array($appHandler->app_id=>true)));
		}
		
		$appMenuOptions = $appHandler->getAppPlugin()->getMenuOptions();

		//set current app view template
		$appViewData = array(
			'appViewRender' => $app_response,
			'appMenuOptions' => $appMenuOptions
			);
		
		//show main template
		$tpl = $OS->getTemplate();
		
		//render templates from install dir 
		$tpl->setTemplateDir(os_join_path($OS->getConfigVar('root_path'), "themes", $OS->getConfigVar('theme_name')));
		
		//set base template
		$tpl->setVar('errors',$OS->errorMessages);
		$tpl->setVar('info',$OS->infoMessages);
		
		$bodyContents = $tpl->fetchTemplate('appbase', $appViewData);
		
		//set main template
		$tpl->setBodyContents($bodyContents);
				
		echo $tpl->mainTemplateRender('main_stripped');
	}
}
?>