<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

$osProject = $OS->getProject();

//check if user is logged
$osUser->forceUserLogin();

//check if project is selected
$osProject->forceProjectSelected();

$osProjectApps = $osUser->getAvailableApps($osProject->id);

$osUserApps = $osUser->getApps();

//get apps handler operations
$osAppOps = $OS->getAppOps();

$osAvailableApplications = $osAppOps->getAvailableApps();





$tpl = $OS->getTemplate();

$allUserApps = array();
foreach($osAvailableApplications as $app_id=>$oneAppHandler)
{
	if(in_array($oneAppHandler->name,$osProjectApps) && isset($osUserApps[$app_id]))
	{
		if($osUserApps[$app_id]['status'] == 'E')
		{
			$allUserApps[$app_id] = array(
				'app_icon_board' => $oneAppHandler->getAppUrl()."/resources/app_icon_board.png",
				'open_link' => $OS->getConfigVar('root_url')."/users/app.php?app=links",
				'remove_link' => $OS->getConfigVar('root_url')."/users/app_board.php?op=remove_app&app_id={$app_id}",
				'name'=>$oneAppHandler->name,
				'title'=>$oneAppHandler->title,
				'description'=>$oneAppHandler->description,
				'status'=>$oneAppHandler->status,
				);
		}
	}		
}

$allUserApps = array_chunk($allUserApps,5);

$tpl->setVar('allUserApps',$allUserApps);



$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);


$tpl->bodyTemplateName = 'app_board';

echo $tpl->mainTemplateRender();
?>