<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

$osProject = $OS->getProject();

//check if user is logged
$osUser->forceUserLogin();

//check if project is selected
$osProject->forceProjectSelected();

//get apps handler operations
$osAppOps = $OS->getAppOps();

$osAvailableApplications = $osAppOps->getAvailableApps();

//Get current project installed apps
$osProjectApps = $osUser->getAvailableApps($osProject->id);

//handle external operations
if(isset($_GET['op'],$_GET['app_id']))
{
	if($_GET['op'] == 'add_app' )
	{//current user adds a new app
		if(isset($osAvailableApplications[$_GET['app_id']]))
		{
			$oneAppHandler = new OS_AppHandler();
			$oneAppHandler->id = $_GET['app_id'];
			
			$addResult = $oneAppHandler->start($osProject->id,$osUser->id);
			
			if($addResult === true)
			{
				$OS->redirectTO("/users/app_manager.php?msg=app_added");
			}
			else
			{
				$OS->addBoxError(_("App cannot be added !"),'app_not_start');
			}
		}
		else
		{
			$OS->addBoxError(_("App not found !"),'app_not_found');
		}
	}
	elseif($_GET['op'] == 'stop_app' )
	{//current user adds a new app
		if(isset($osAvailableApplications[$_GET['app_id']]))
		{
			$oneAppHandler = $osAvailableApplications[$_GET['app_id']];
				
			$stopResult = $oneAppHandler->stop($osProject->id,$osUser->id);
				
			if($stopResult === true)
			{
				$OS->redirectTO("/users/app_manager.php?msg=app_stopped");
			}
			else
			{
				$OS->addBoxError(_("App cannot be stopped !"),'app_not_stop');
			}
		}
		else
		{
			$OS->addBoxError(_("App not found !"),'app_not_found');
		}
	}
	elseif($_GET['op'] == 'remove_app' )
	{//current user removes an app
		if(isset($osAvailableApplications[$_GET['app_id']]))
		{
			$oneAppHandler = $osAvailableApplications[$_GET['app_id']];
		
			$removeResult = $oneAppHandler->remove($osProject->id,$osUser->id);
		
			if($removeResult === true)
			{
				$OS->redirectTO("/users/app_manager.php?msg=app_removed");
			}
			else
			{
				$OS->addBoxError(_("App cannot be removed !"),'app_not_remove');
			}
		}
		else
		{
			$OS->addBoxError(_("App not found !"),'app_not_found');
		}
	}
}


//Get current user installed apps
$osUserApps = $osUser->getApps();

$allProjectApps = array();
foreach($osAvailableApplications as $app_id=>$oneAppHandler)
{
	
	if(in_array($oneAppHandler->name,$osProjectApps))
	{
		$appInstalled = false; $appEnabled =  false; $appStoppped =  false; $appStatus = '';
		
		if(isset($osUserApps[$app_id]))
		{
			$appInstalled =  true;
			$appStatus = $osUserApps[$app_id]['status'];
			
			if($appStatus == 'E')
			{
				$appEnabled =  true;
			}
			elseif($appStatus == 'D')
			{
				$appStoppped =  true;
			}
		}
		
		$allProjectApps[$app_id] = array(
			'app_icon_manager' => $oneAppHandler->getAppUrl()."/resources/app_icon_manager.png",
			'add_link' => $OS->getConfigVar('root_url')."/users/app_manager.php?op=add_app&app_id={$app_id}",
			'stop_link' => $OS->getConfigVar('root_url')."/users/app_manager.php?op=stop_app&app_id={$app_id}",
			'remove_link' => $OS->getConfigVar('root_url')."/users/app_manager.php?op=remove_app&app_id={$app_id}",
			'status'=>$appStatus,
			'not_installed'=> !$appInstalled ,
			'is_enabled'=> $appEnabled,
			'is_stopped'=> $appStoppped,
			'name'=>$oneAppHandler->name,
			'title'=>$oneAppHandler->title,
			'description'=>$oneAppHandler->description,
			);
	}
}

$allProjectApps = array_chunk($allProjectApps,2);


//handle external messages
if(isset($_GET['msg']))
	if($_GET['msg']== 'app_added') $OS->addInfo(_("App Added !"),'app_added');
	elseif($_GET['msg']== 'app_stopped') $OS->addInfo(_("App Stopped !"),'app_stopped');
	elseif($_GET['msg']== 'app_removed') $OS->addInfo(_("App Removed !"),'app_removed');



$tpl = $OS->getTemplate();


$tpl->setVar('allProjectApps',$allProjectApps);



$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);


$tpl->selectedMenuItem = 'app_board';

$tpl->bodyTemplateName = 'app_manager';

echo $tpl->mainTemplateRender();
?>