<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

//verify if user is logged
$osUser->forceUserLogin();

//verify user permissions
$osUser->forcePerm('clients_management','view_clients');

$clientOps=$OS->getClientOps();

$manage_permission=$osUser->checkPerm('clients_management','manage_clients');

if (!empty($_GET['op']))
{
	if ($_GET['op']=='delete')
	{
		if (!empty($_GET['client_id']) AND $manage_permission)
		{
			if ($oneClient=$clientOps->getClientByID($_GET['client_id']))
			{
				if ($oneClient->delete())
				{
					$OS->addInfo(_("Client deleted successfully"));
				}
				else
				{
					$OS->addBoxError(_("Unable to delete client"));
				}
			}
		}
	}
}

$allClients=array();
if ($clients=$clientOps->getClients())
{
	$projectOps=$OS->getProjectOps();
	
	foreach ($clients as $client_id=>$client)
	{
		$allClients[$client_id]=array(
			'name'=>$client->name,
			'email'=>$client->email,
			'projects_count'=>$projectOps->getProjectsCountByClientID($client_id),
			'projects_url'=>$OS->getConfigVar('root_url')."/users/projects_list.php?client_id={$client_id}",
			'edit_url'=>($manage_permission?$OS->getConfigVar('root_url')."/users/client_ae.php?op=edit&client_id={$client_id}":false),
			'delete_url'=>($manage_permission?$OS->getConfigVar('root_url')."/users/clients_list.php?op=delete&client_id={$client_id}":false)
		);
	}
}

if(!empty($_GET['msg']))
{
	if($_GET['msg']== 'client_add_ok')
	{
		$OS->addInfo(_("Client Created !"));
	}
	elseif($_GET['msg']== 'client_edit_ok')
	{
		$OS->addInfo(_("Client Details Saved !"));
	}
}

$tpl = $OS->getTemplate();

$tpl->setTopSectionTitle(_("Manage Clients"));

//check if current user can add project
if($manage_permission)
{
	$tpl->addTopSectionOption('add_client',array('type'=>'link','name'=>_("New Client"),'url'=>$OS->getConfigVar('root_url')."/users/client_ae.php"));
}

$tpl->setVar('allClients',$allClients);
$tpl->setVar('managePerm',$manage_permission);

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->bodyTemplateName = 'clients_list';

echo $tpl->mainTemplateRender();
?>