<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */
include "../init.php";

//include required files for login script

$OS = getOS();

$osUser = $OS->getUser();

$osProject = $OS->getProject();

//check if user is logged
$osUser->forceUserLogin();

//check if project is selected
$osProject->forceProjectSelected();


//get widget operations
$osWidgetOps = $OS->getWidgetOps();

$osAvailableWidgets = $osWidgetOps->getAvailableWidgets();


$osProjectWidgets = array();
foreach($osAvailableWidgets as $widget_id=>$oneWidget)
{
	$osProjectWidgets[$widget_id] = array(
		'app_icon_manager' => $oneWidget->getWidgetUrl()."/resources/app_icon_manager.png",
		'add_link' => "osDashboard.addWidget2Section({$widget_id})",
		'status'=>$oneWidget->status,
		'name'=>$oneWidget->name,
		'title'=>$oneWidget->title,
		'description'=>$oneWidget->description,
		);
}

$osProjectWidgets = array_chunk($osProjectWidgets,2);


$tpl = $OS->getTemplate();

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('osProjectWidgets',$osProjectWidgets);


$tpl->setVar('ptitle',_("Project Dashboard"));


$tpl->selectedMenuItem = "dashboard";

$tpl->bodyTemplateName = 'users_dashboard';

echo $tpl->mainTemplateRender();
?>