<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

//check if user is logged
$osUser->forceUserLogin();

//handle current operations
if(isset($_GET['op'])) $op = $_GET['op']; 
elseif(isset($_POST['op'])) $op = $_POST['op'];
else $op = 'add';

//handle user_id (if editing a user)
if($op == 'edit')
{
	if(isset($_GET['department_id'])) $department_id = $_GET['department_id']; 
	elseif(isset($_POST['department_id'])) $department_id = $_POST['department_id'];
	else {header("Location: ".$OS->getConfigVar('root_url')."/users/departments.php?msg=nodepid");exit;}
}


$osDepartmentOps = $OS->getDepartmentOps();

$departmentStatuses = $osDepartmentOps->getStatuses();


if ($_SERVER['REQUEST_METHOD']=='POST')
{
	$userOps = $OS->getUserOps();
	
	if (empty($_POST['name_box'])) 
	{
		$OS->addFieldError(_("Name missing"),'name');	
	}
	elseif (strlen($_POST['name_box'])<3) 
	{
		$OS->addFieldError(_("Name too short"),'name');	
	}
	elseif (!$userOps->isValidName($_POST['name_box'])) 
	{
		$OS->addFieldError(_("Invalid name"),'name');	
	}
	else
	{
		$department_name = $_POST['name_box'];
	} 
	
	if (empty($_POST['status_box'])) 
	{
		$OS->addFieldError(_("Status missing"),'name');	
	}
	elseif (!isset($departmentStatuses[$_POST['status_box']])) 
	{
		$OS->addFieldError(_("Invalid Status"),'name');	
	}
	else
	{
		$department_status = $_POST['status_box'];	
	}
	
	

	if(!isset($OS->errorMessages))
	{
		$osDepartment = $OS->getDepartment();
		if($op == 'edit') $osDepartment->id = $department_id;
		
		$osDepartment->name = $department_name;
		$osDepartment->status = $department_status;
		
		$response = $osDepartment->save();
		
		if($response!==false)
		{
			$OS->redirectTO("/users/departments.php?msg=dep_{$op}_ok");	
		}
		else
		{
			$OS->addBoxError(_("Department cannot be created"),'add_link_ok');
		}
	}
}
else
{	
	if($op == 'add')
	{
		$_POST['status_box'] = "A"; 
	}
	elseif($op == 'edit')
	{
		$departmentData = $osDepartmentOps->getDepartmentByID($department_id);
		
		if($departmentData !== false)
		{
			$_POST['name_box'] = $departmentData->name;
			$_POST['status_box'] = $departmentData->status;	
		}
	}
}	


//setup page title
$ptitle = ($op=='add'?_("Add New Department"):_("Edit Department"));


$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle($ptitle);
$tpl->addTopSectionOption('cancel',array('type'=>'link','name'=>_("Cancel"),'url'=>$OS->getConfigVar('root_url')."/users/departments.php"));


$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);



$tpl->setVar('op',$op);

if($op=='edit') $tpl->setVar('department_id',$department_id);

$tpl->setVar('departmentStatuses',$departmentStatuses);

$tpl->selectedMenuItem = "users_list";

$tpl->bodyTemplateName = 'department_manage';

echo $tpl->mainTemplateRender();
?>