<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

//check if user is logged
$osUser->forceUserLogin();

if(isset($_GET['department_id']))
{
	$department_id = $_GET['department_id'];
} 
elseif(isset($_POST['department_id']))
{
	$department_id = $_POST['department_id'];
}
else
{
	$OS->redirectTO("/users/departments.php?msg=nodepid");
}

$osDepartmentOps = $OS->getDepartmentOps();

if (!$osDepartment=$osDepartmentOps->getDepartmentByID($department_id))
{
	$OS->redirectTO("/users/departments.php?msg=baddep");
}

//get All System permission options
$osPermissions = $OS->getPermissions();
$PermissionsResponse = $osPermissions->getAppsPermissions();
$osAppOps=$OS->getAppOps();

$allPermissions = array();
if($PermissionsResponse !== false)
{
	foreach($PermissionsResponse as $module => $moduleData)	
	{
		if ($app=$osAppOps->getAppByName($module))
		{
			$human_module = $app->title;
			$allPermissions[$module] = array('name'=>$human_module);
	
			foreach($moduleData as $perm => $permData)
			{
				$allPermissions[$module]['permissions'][$perm] = array('name' => $permData['name']);
			}

			//put permissions on two columns
			$allPermissions[$module]['permissions'] = array_chunk($allPermissions[$module]['permissions'], 2, true);
		}
	}
}

//Load department permissions
$osDepartment->loadPerms();

if ($_SERVER['REQUEST_METHOD']=='POST')
{

	$tmpData = array();
	
	foreach($_POST as $key => $val)
	{
		if(strpos($key,"_check_box")!==false)
		{
			$tvar = str_replace("_check_box","_module_box",$key);
			$tvar2 = str_replace("_check_box","_perm_box",$key);
			
			if(isset($_POST[$tvar],$_POST[$tvar2]))
			{
				$tmpData[$_POST[$tvar]][$_POST[$tvar2]] = "Y";		
			}
		}
	}
	
	if(!isset($OS->errorMessages))
	{
		//get all department's permissions
		$tmpDepPermissions = $osDepartment->getPerms();

		foreach($tmpData as $module=>$moduleData)
		{
			foreach($moduleData as $perm=>$permValue)
			{
				$osDepartment->addPerm(0,$module,$perm);
			
				if(isset($tmpDepPermissions[0][$module][$perm]))
				{
					unset($tmpDepPermissions[0][$module][$perm]);
				} 
			}
		}
		
		//remove all permissions that are not checked
		if(!empty($tmpDepPermissions[0]))
		{
			foreach($tmpDepPermissions[0] as $module => $moduleData)
			{
				foreach($moduleData as $perm => $permValue)
				{
					if (isset($PermissionsResponse[$module][$perm]))
					{
						$osDepartment->removePerm(0,$module,$perm);
					}
				}	
			}
		}
		
		//jump to departments list
		$OS->redirectTO("/users/departments.php?msg=usrdep_ok");
	}
}
else
{

}

$osDepPermissions = $osDepartment->getPerms();

if($osDepPermissions !== false)
{
	if (!empty($osDepPermissions[0]))
	{
		foreach($osDepPermissions[0] as $module=>$moduleData)
		{
			foreach($moduleData as $perm=>$permData)
			{
				if(empty($_POST["{$module}_{$perm}_check_box"])) $_POST["{$module}_{$perm}_check_box"] = "Y";			
			}
		}
	}
}


$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Manage Department Global Applications"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);



$tpl->setVar('department_id',$department_id);

$tpl->setVar('allPermissions',$allPermissions);

$tpl->selectedMenuItem = "users_list";

$tpl->bodyTemplateName = "department_manage_apps_global";

echo $tpl->mainTemplateRender();
?>