<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

//check if user is logged
$osUser->forceUserLogin();

if(isset($_GET['department_id']))
{
	$department_id = $_GET['department_id'];
} 
elseif(isset($_POST['department_id']))
{
	$department_id = $_POST['department_id'];
}
else
{
	$OS->redirectTO("/users/departments.php?msg=nodepid");
}

$osDepartmentOps = $OS->getDepartmentOps();

if (!$osDepartment=$osDepartmentOps->getDepartmentByID($department_id))
{
	$OS->redirectTO("/users/departments.php?msg=nodepid");
}

if (isset($_GET['project_id']))
{
	$project_id=$_GET['project_id'];
}
elseif (isset($_POST['project_id']))
{
	$project_id=$_POST['project_id'];
}
else
{
	$OS->redirectTO("/users/department_manage_apps.php?department_id={$department_id}&msg=noprjid");
}

$departmentProjects=$osDepartmentOps->getProjectsByDepartmentID($department_id);
if (!in_array($project_id,$departmentProjects))
{
	$OS->redirectTO("/users/department_manage_apps.php?department_id={$department_id}&msg=noprjid");
}

//get All System permission options
$osPermissions = $OS->getPermissions();
$PermissionsResponse = $osPermissions->getAppsPermissions();
$osAppOps=$OS->getAppOps();

$allPermissions = array();
if($PermissionsResponse !== false)
{
	foreach($PermissionsResponse as $module => $moduleData)	
	{
		if ($app=$osAppOps->getAppByName($module))
		{
			$human_module = $app->title;
			$allPermissions[$module] = array('name'=>$human_module);
	
			foreach($moduleData as $perm => $permData)
			{
				$allPermissions[$module]['permissions'][$perm] = array('name' => $permData['name']);
			}
		}
	}
}

//Load department permissions
$osDepartment->loadPerms();

if ($_SERVER['REQUEST_METHOD']=='POST')
{

	$tmpData = array();

	foreach($_POST as $key => $val)
	{
		if(strpos($key,"_radio_box")!==false)
		{
			$tmodule = str_replace("_radio_box","_module_box",$key);
			$tperm = str_replace("_radio_box","_perm_box",$key);
			
			if(isset($_POST[$tmodule],$_POST[$tperm]))
			{
				$tmpData[$_POST[$tmodule]][$_POST[$tperm]] = $val;		
			}
		}
	}
	
	if(!isset($OS->errorMessages))
	{
		//get all department's permissions
		$tmpDepPermissions = $osDepartment->getPerms();

		foreach($tmpData as $module=>$moduleData)
		{
			foreach($moduleData as $perm=>$permValue)
			{
				if ($permValue!='I')
				{
					$osDepartment->addPerm($project_id,$module,$perm);
				
					if(isset($tmpDepPermissions[$project_id][$module][$perm]))
					{
						unset($tmpDepPermissions[$project_id][$module][$perm]);
					} 
				}
			}
		}
		
		//remove all permissions that are not checked
		if(!empty($tmpDepPermissions[$project_id]))
		{
			foreach($tmpDepPermissions[$project_id] as $module => $moduleData)
			{
				foreach($moduleData as $perm => $permValue)
				{
					if (isset($PermissionsResponse[$module][$perm]))
					{
						$osDepartment->removePerm($project_id,$module,$perm);
					}
				}	
			}
		}
		
		//jump to departments list
		$OS->redirectTO("/users/departments.php?msg=usrdep_ok");
	}
}
else
{

}

//Build initial permissions values
$tmpPermissions = array(); $realPermissions = array();

if(!empty($PermissionsResponse))
{
	foreach($PermissionsResponse as $module => $moduleData)
	{
		foreach($moduleData as $perm => $permData)
		{
			$tmpPermissions[$module][$perm] = "I";
			$realPermissions[$module][$perm] = "R";
		}
	}	
}

$osDepPermissions = $osDepartment->getPerms();

if($osDepPermissions !== false)
{
	if (!empty($osDepPermissions[0]))
	{
		foreach($osDepPermissions[0] as $module=>$moduleData)
		{
			foreach($moduleData as $perm=>$permData)
			{
				$realPermissions[$module][$perm] = "A";			
			}
		}
	}
	
	if (!empty($osDepPermissions[$project_id]))
	{
		foreach($osDepPermissions[$project_id] as $module=>$moduleData)
		{
			foreach($moduleData as $perm=>$permData)
			{
				$tmpPermissions[$module][$perm] = $permData;
				$realPermissions[$module][$perm] = $permData;			
			}
		}
	}
}

if(!empty($tmpPermissions))
{
	foreach($tmpPermissions as $module=>$moduleData)
	{
		foreach($moduleData as $perm => $op)
		{
			if(!isset($_POST["{$module}_{$perm}_radio_box"])) $_POST["{$module}_{$perm}_radio_box"] = $op;			
		}
	}
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Manage Department Project Applications"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('department_id',$department_id);
$tpl->setVar('project_id',$project_id);

$tpl->setVar('allPermissions',$allPermissions);
$tpl->setVar('realPermissions',$realPermissions);

$tpl->selectedMenuItem = "users_list";

$tpl->bodyTemplateName = "department_manage_apps_project";

echo $tpl->mainTemplateRender();
?>