<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

//check if user is logged
$osUser->forceUserLogin();

//handle current department_id
if(isset($_GET['department_id'])) $department_id = $_GET['department_id']; 
elseif(isset($_POST['department_id'])) $department_id = $_POST['department_id'];
else{header("Location: ".$OS->getConfigVar('root_url')."/users/departments.php?msg=baddepid");exit;}


//get All Core permission options
$osPermissions = $OS->getPermissions();
$PermissionsResponse = $osPermissions->getCorePermissions();

$allPermissions = array();
if($PermissionsResponse !== false)
{
	foreach($PermissionsResponse as $module => $moduleData)	
	{
		$human_module = ucwords(str_replace("_"," ",$module));
		$allPermissions[$module] = array('name'=>$human_module);

		foreach($moduleData as $perm => $permData)
		{
			$allPermissions[$module]['permissions'][$perm] = array('name' => $permData['name']);
		}
		
		//put permissions on two columns
		$allPermissions[$module]['permissions'] = array_chunk($allPermissions[$module]['permissions'], 2, true);
	}
}

//Get current department permissions
$osDepartmentOps = $OS->getDepartmentOps();

//get department data
$osDepartment = $osDepartmentOps->getDepartmentByID($department_id);
		
//Load department permissions
$osDepartment->loadPerms();


if ($_SERVER['REQUEST_METHOD']=='POST')
{

	$tmpData = array();
	
	foreach($_POST as $key => $val)
	{
		if(strpos($key,"_check_box")!==false)
		{
			$tvar = str_replace("_check_box","_module_box",$key);
			$tvar2 = str_replace("_check_box","_perm_box",$key);
			
			if(isset($_POST[$tvar],$_POST[$tvar2]))
			{
				$tmpData[$_POST[$tvar]][$_POST[$tvar2]] = "Y";		
			}
		}
	}
	
	if(!isset($OS->errorMessages))
	{

		//get all department's permissions
		$tmpDepPermissions = $osDepartment->getPerms();

		foreach($tmpData as $module=>$moduleData)
		{
			foreach($moduleData as $perm=>$permValue)
			{
				$osDepartment->addPerm(0,$module,$perm);
			
				if(isset($tmpDepPermissions[0][$module][$perm]))
				{
					unset($tmpDepPermissions[0][$module][$perm]);
				} 
			}
		}
		
		//remove all permissions that are not checked
		if(!empty($tmpDepPermissions[0]))
		{
			foreach($tmpDepPermissions[0] as $module => $moduleData)
			{
				foreach($moduleData as $perm => $permValue)
				{
					if (isset($PermissionsResponse[$module][$perm]))
					{
						$osDepartment->removePerm(0,$module,$perm);
					}
				}	
			}
		}
		
		//jump to departments list
		$OS->redirectTO("/users/departments.php?msg=usrdep_ok");
	}
}

$osDepPermissions = $osDepartment->getPerms();

if($osDepPermissions !== false)
{
	if (!empty($osDepPermissions[0]))
	{
		foreach($osDepPermissions[0] as $module=>$moduleData)
		{
			foreach($moduleData as $perm=>$permData)
			{
				if(empty($_POST["{$module}_{$perm}_check_box"])) $_POST["{$module}_{$perm}_check_box"] = "Y";			
			}
		}
	}
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Manage Department Permissions"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);



$tpl->setVar('department_id',$department_id);

$tpl->setVar('allPermissions',$allPermissions);

$tpl->selectedMenuItem = "users_list";

$tpl->bodyTemplateName = "department_manage_permissions";

echo $tpl->mainTemplateRender();
?>