<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

//check if user is logged
$osUser->forceUserLogin();

if(isset($_GET['department_id']))
{
	$department_id = $_GET['department_id'];
} 
elseif(isset($_POST['department_id']))
{
	$department_id = $_POST['department_id'];
}
else
{
	$OS->redirectTO("/users/departments.php?msg=nodepid");
}

$osDepartmentOps = $OS->getDepartmentOps();

if (!$osDepartment=$osDepartmentOps->getDepartmentByID($department_id))
{
	$OS->redirectTO("/users/departments.php?msg=nodepid");
}

$departmentProjects=$osDepartmentOps->getProjectsByDepartmentID($department_id);

$osProjectOps = $OS->getProjectOps();
$allProjects=$osProjectOps->getProjects();

if ($_SERVER['REQUEST_METHOD']=='POST')
{
	//handle project departments
	$newProjectsList = array();
	
	foreach($_POST as $key => $val)
	{
		if(strpos($key,"_prj_check_box")!==false)
		{
			$newProjectsList[$val] = true;
		}
	}
	
	if (empty($newProjectsList))
	{
		$OS->addBoxError(_("You have to select at least one project"),'dep_projects');
	}
	
	if(!isset($OS->errorMessages))
	{
		if (!empty($departmentProjects))
		{
			$oldProjectsList=array_flip($departmentProjects);
		}
		else
		{
			$oldProjectsList=array();
		}
		
		foreach($allProjects as $project_id => $projectData)
		{
			if(isset($newProjectsList[$project_id]))
			{
				$allProjects[$project_id]->addDepartment($department_id);
				
				if(isset($oldProjectsList[$project_id]))
				{
					unset($oldProjectsList[$project_id]);
				}
			}
		}
		
		//remove from old projects
		if(!empty($oldProjectsList))
		{
			foreach($oldProjectsList as $project_id => $dummy)
			{
				$allProjects[$project_id]->removeDepartment($department_id);
			}
		}
		
		$OS->redirectTO("/users/departments.php?msg=dep_projects_ok");
	}
}
else
{
	if (!empty($departmentProjects))
	{
		foreach ($departmentProjects as $project_id)
		{
			$_POST["{$project_id}_prj_check_box"]=$project_id;
		}
	}
}

$tplProjects=array();
foreach ($allProjects as $project)
{
	$tplProjects[$project->id]=array(
		'name'=>$project->name,
		'is_selected'=>(!empty($_POST["{$project->id}_prj_check_box"])?true:false)
	);
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Department Projects"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('allProjects',$tplProjects);
$tpl->setVar('department_id',$department_id);



$tpl->bodyTemplateName = 'department_manage_projects';

echo $tpl->mainTemplateRender();
?>