<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUtils = $OS->getUtils();

//check if user is logged
$osUser->forceUserLogin();

$osDepartmentOps = $OS->getDepartmentOps();

$osDepartments = $osDepartmentOps->getDepartments();

$depStatuses = $osDepartmentOps->getStatuses();

//handle external operations
if(isset($_GET['op'],$_GET['department_id']))
{
	if($_GET['op'] == 'delete' )
	{
		if(isset($osDepartments[$_GET['department_id']]))
		{
			$oneDepartment = new OS_Department();
			$oneDepartment->id = $_GET['department_id'];
			$deleteResult = $oneDepartment->delete();
			
			if($deleteResult === true)
			{
				unset($osDepartments[$_GET['department_id']]);
				$OS->addInfo(_("Department Deleted !"));
			}
			else
			{
				$OS->addBoxError(_("Department cannot be deteled !"),'delete_department');
			}
		}
		else
		{
			$OS->addBoxError(_("Department not found !"),'delete_department');
		}
	}
}



//Build users departments
$allDepartments = array();
if(!empty($osDepartments))
{
	foreach($osDepartments as $department_id=>$departmentData)
	{
	$allDepartments[$department_id] = array(
		'name' => $departmentData->name,
		'human_status' => $depStatuses[$departmentData->status],
		'created_date' => $osUtils->humanizeDate($departmentData->insert_dt,'date'),
		'edit_link' => $OS->getConfigVar('root_url')."/users/department_manage.php?op=edit&department_id={$department_id}",
		'perms_link' => $OS->getConfigVar('root_url')."/users/department_manage_permissions.php?department_id={$department_id}",
		'projects_link'=> $OS->getConfigVar('root_url')."/users/department_manage_projects.php?department_id={$department_id}",
		'apps_link'=> $OS->getConfigVar('root_url')."/users/department_manage_apps.php?department_id={$department_id}",
		'delete_link' => $OS->getConfigVar('root_url')."/users/departments.php?op=delete&department_id={$department_id}",
		);	
	}	
}


//handle external messages
if(isset($_GET['msg']))
	if($_GET['msg']== 'dep_add_ok') $OS->addInfo(_("Department Created !"));
	elseif($_GET['msg']== 'dep_edit_ok') $OS->addInfo(_("Department Details Saved !"));
	elseif($_GET['msg']== 'usrdep_ok') $OS->addInfo(_("Department Permissions Saved !"));
	elseif($_GET['msg']== 'dep_projects_ok') $OS->addInfo(_("Deparment Projects Saved !"));
	elseif($_GET['msg']== 'nodepid') $OS->addBoxError(_("Deparment ID missing !"),'nodepid');
	elseif($_GET['msg']== 'baddep') $OS->addBoxError(_("Deparment Not Found !"),'baddep');


$tpl = $OS->getTemplate();

//check if current user can add project
if($osUser->checkPerm('departments_management','add_department'))
{
	$tpl->addTopSectionOption('add_department',array('type'=>'link','name'=>_("New Department"),'url'=>$OS->getConfigVar('root_url')."/users/department_manage.php?op=add"));
}

$tpl->setTopSectionTitle(_("Manage Departments"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('allDepartments',$allDepartments);

$tpl->selectedMenuItem = "users_list";

$tpl->bodyTemplateName = 'departments';

echo $tpl->mainTemplateRender();
?>