<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: /users/forgot.php 2012-01-09$
 */

include "../init.php";

$OS = getOS();

$userOps = $OS->getUserOps();

if($_SERVER['REQUEST_METHOD']=='POST')
{
	$validator=$OS->getValidator();
	
	if (empty($_POST['email_box']))
	{
		$OS->addFieldError(_("Email missing"),'email');
	}
	elseif (!$validator->is_email($_POST['email_box']))
	{
		$OS->addFieldError(_("Invalid email"),'email');
	}
	elseif (!$oneUser = $userOps->getUserByEmail($_POST['email_box']))
	{
		$OS->addFieldError(_("Unknown email"),'email');
	}
	
	if (!isset($OS->errorMessages))
	{
		$user_id = $oneUser->id;
		$user = $oneUser->user;
		
		$db = $OS->getDb();
		$osUtils = $OS->getUtils();
		$time = $db->DBTimeStamp(time());
		$ip = $OS->getRemoteAddr();
		
		$osRootUrlDetails = parse_url($OS->getConfigVar('root_url'));
		
		$os_instance_host = (isset($osRootUrlDetails['host']) ? $osRootUrlDetails['host'] : $osRootUrlDetails);  
		
		//mark user as forgot
		$query = "UPDATE ".$db->dbPrefix()."users SET forgots = forgots+1, forgot_dt = ? , forgot_ip = ? WHERE id = ?";
		$results =  $db->query($query,array($time, $ip, $user_id));
		
		$message = '';
		$link = $OS->getConfigVar('root_url')."/users/recover.php?idcode={$user_id}_".$osUtils->generateHash(array($user_id, $oneUser->email),8);
		$message .= sprintf(_("You have requested a password reset for your account %s  on the OpenS instalation at %s.\nPlease confirm it by clicking on this link:\n %s"),$user, $os_instance_host, $link);
		
		$osMailOps = $OS->getMailOps();
		$osMailOps->pushMail(array('from_name'=>'Password Recovery', 'to_name'=>$oneUser->name, 'to_email'=>$oneUser->email, 'subject'=>"Password recovery", 'message'=>$message));
		
		$OS->addInfo(_("A password reset confirmation email has been sent.").'<br>'._("Please check your inbox shortly !"));
		$_POST["email_box"]='';
	}
}
else
{
	$_POST['email_box']='';
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Forgot password"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);
$tpl->setVar('preventDeviceZoom',true);

$tpl->selectedMenuItem = "login";

$tpl->bodyTemplateName = 'users_forgot';

echo $tpl->mainTemplateRender();
?>