<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$userOps = $OS->getUserOps();


//if user is looged force it inside
$osUser->forceIn();

//preset jumpto location
if(isset($_GET['jumpto'])) $_POST['jumpto'] = $_GET['jumpto'];

//autocomplete user box
if(isset($_GET['user_box'])) $_POST['user_box'] = $_GET['user_box'];


if($_SERVER['REQUEST_METHOD']=='POST')
{
	if(empty($_POST["user_box"]))
	{
		$OS->addFieldError(_("Username missing !"),'user');	
	} 
	elseif(!$userOps->isValidUsername($_POST["user_box"]))
	{
		$_POST["user_box"]='';
		$OS->addFieldError(_("Username is wrong !"),'user');
	}
	else
	{
		$user = $_POST['user_box'];
	} 	


	if(empty($_POST["password_box"]))
	{
		$OS->addFieldError(_("Password missing !"),'password');	
	} 
	elseif((strlen($_POST["password_box"])<3))
	{
		$OS->addFieldError(_("Password too short (min 3 characters)!"),'password');
	} 
	else
	{
		$password = $_POST['password_box'];	
	}
	
	if(!isset($OS->errorMessages))
	{
		$osUser = $OS->getUser();
		$osUser->user = $user;
		$osUser->setPassword($password) ;
		$userLogged = $osUser->login();
		
		if($userLogged === true)
		{
			if(!empty($_POST['jumpto']))
			{
				$jumpto = urldecode($_POST['jumpto']);	
			}
			else
			{
				$jumpto = $OS->getConfigVar('root_url')."/users/projects_list.php";	
			}
			
			header("Location: {$jumpto}"); exit;	
		}
	}	
}
	

//handle enternal messages
if(isset($_GET['msg']))
	if($_GET['msg'] == 'pass_changed') $OS->addInfo(_("Your Password has been successfully changed !"));
	
	
$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("User Login"));

//jump out of iframes
$tpl->setHeadContents("<script>if(location.href!=top.location.href) { top.location.href=location.href }</script>");

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);
$tpl->setVar('preventDeviceZoom',true);


$tpl->setVar('forgot_link',$OS->getConfigVar('root_url')."/users/forgot.php");

$tpl->selectedMenuItem = "login";

$tpl->bodyTemplateName = 'users_login';

echo $tpl->mainTemplateRender();
?>