<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUtils = $OS->getUtils();

//verify if user is logged
$osUser->forceUserLogin();

//get project operations
$osProjectOps = $OS->getProjectOps();

if(isset($_GET['project_id']))
{
	$project_id = $_GET['project_id'];
} 
elseif(isset($_POST['project_id']))
{
	$project_id = $_POST['project_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjid");
}

$osProjectSearchEngineOps=$OS->getProjectSearchEngineOps();
$projectSearchEngines=$osProjectSearchEngineOps->getProjectSearchEngines($project_id);

if (empty($projectSearchEngines))
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjse");
}

$osSearchEngineOps=$OS->getSearchEngineOps();
$allSearchEngines=$osSearchEngineOps->getAvailableSearchEnginesFull();

$osProjectTopicOps=$OS->getProjectTopicOps();

if (!empty($_GET['op']))
{
	if ($_GET['op']=='delete_topic')
	{
		if (!empty($_GET['topic_id']))
		{
			if ($topic=$osProjectTopicOps->getProjectTopicByID($_GET['topic_id'],$project_id))
			{
				if ($topic->delete())
				{
					$OS->addInfo(_("Topic deleted successfully"));
				}
				else
				{
					$OS->addBoxError(_("Unable to delete topic!"));
				}
			}
		}
	}
}

if (!empty($_GET['msg']))
{
	if ($_GET['msg']=='add_ok')
	{
		$OS->addInfo(_("Topic added successfully"));
	}
}

$seTopics=array();
if ($projectTopics=$osProjectTopicOps->getProjectTopics($project_id))
{
	foreach ($projectTopics as $topic_id=>$topic)
	{
		$seTopics[$topic->se_id][$topic_id]=$topic;
	}
	
	$osProjectKeywordOps=$OS->getProjectKeywordOps();
	
	$projectKeywordsCount=$osProjectKeywordOps->getProjectKeywordsCountGroupedByTopicID($project_id);
}

$projectCompetition=array();
foreach ($projectSearchEngines as $se_id=>$se)
{
	if (isset($allSearchEngines[$se->engine]) AND (($allSearchEngines[$se->engine]['has_locales']=='Y' AND isset($allSearchEngines[$se->engine]['_locales'][$se->locale])) OR $allSearchEngines[$se->engine]['has_locales']!='Y'))
	{
		$name=$allSearchEngines[$se->engine]['title'];
		
		if ($allSearchEngines[$se->engine]['has_locales']=='Y')
		{
			$name.=' '.$allSearchEngines[$se->engine]['_locales'][$se->locale]['title'];
		}
	
		$projectCompetition[$se_id]=array(
			'name'=>$name,
			'topics'=>array(),
			'new_topic_url'=>$OS->getConfigVar('root_url')."/users/project_manage_competition_add.php?project_id={$project_id}&se_id={$se_id}"
		);
		
		if (!empty($seTopics[$se_id]))
		{
			foreach ($seTopics[$se_id] as $topic_id=>$topic)
			{
				$projectCompetition[$se_id]['topics'][$topic_id]=array(
					'name'=>$topic->topic,
					'competitors'=>($topic->competitors=='Y'?true:false),
					'keywords'=>(empty($projectKeywordsCount[$topic_id])?0:$projectKeywordsCount[$topic_id]),
					'keywords_url'=>$OS->getConfigVar('root_url')."/users/project_manage_competition_keywords.php?project_id={$project_id}&topic_id={$topic_id}",
					'competitors_url'=>($topic->competitors=='Y'?$OS->getConfigVar('root_url')."/users/project_manage_competition_competitors.php?project_id={$project_id}&topic_id={$topic_id}":false),
					'delete_url'=>$OS->getConfigVar('root_url')."/users/project_manage_competition.php?project_id={$project_id}&op=delete_topic&topic_id={$topic_id}"
				);
			}
		}
	}
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Project Competition"));
$tpl->addTopSectionOption('manage_se',array('type'=>'link','name'=>_("Settings"),'url'=>$OS->getConfigVar('root_url')."/users/project_manage.php?op=edit&project_id={$project_id}"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('project_id',$project_id);

$tpl->setVar('projectCompetition',$projectCompetition);

$tpl->selectedMenuItem = 'projects_list';

$tpl->bodyTemplateName = 'project_manage_competition';

echo $tpl->mainTemplateRender();
?>