<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUtils = $OS->getUtils();

//verify if user is logged
$osUser->forceUserLogin();

//get project operations
$osProjectOps = $OS->getProjectOps();

if(isset($_GET['project_id']))
{
	$project_id = $_GET['project_id'];
} 
elseif(isset($_POST['project_id']))
{
	$project_id = $_POST['project_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjid");
}

if(isset($_GET['se_id']))
{
	$se_id = $_GET['se_id'];
} 
elseif(isset($_POST['se_id']))
{
	$se_id = $_POST['se_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjseid");
}

$osProjectSearchEngineOps=$OS->getProjectSearchEngineOps();

if (!$se=$osProjectSearchEngineOps->getProjectSearchEngineByID($se_id))
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjseid");
}
elseif ($se->project_id!=$project_id)
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjseid");
}

if ($_SERVER['REQUEST_METHOD']=='POST')
{
	if (empty($_POST["topic_box"]))
	{
		$OS->addFieldError(_("Topic name missing"),"topic");
	}
	else
	{
		$_POST["topic_box"]=trim($_POST["topic_box"]);
		
		if (strlen($_POST["topic_box"])<3)
		{
			$OS->addFieldError(_("Topic name too short. Minimum length: 3 characters"),"topic");
		}
	}
	
	if (empty($_POST["keywords_box"]))
	{
		$OS->addFieldError(_("Keywords missing"),"keywords");
	}
	else
	{
		$keywords=explode("\n",trim($_POST["keywords_box"]));
		
		if (empty($keywords))
		{
			$OS->addFieldError(_("Keywords missing"),"keywords");
		}
		else
		{
			$valid_keywords=array();
			foreach ($keywords as $pos=>$keyword)
			{
				$keyword=trim($keyword);
				
				if (empty($keyword))
				{
					unset($keywords[$pos]);
				}
				elseif (strlen($keyword)<3)
				{
					unset($keywords[$pos]);
				}
				elseif (!isset($valid_keywords[$keyword]))
				{
					$valid_keywords[$keyword]=$pos;
				}
			}
			
//			$keywords=array_reverse($valid_keywords);
			$keywords=array_keys($valid_keywords);
			
			if (empty($keywords))
			{
				$OS->addFieldError(_("Keywords missing"),"keywords");
			}
		}
		
		$_POST["keywords_box"]=implode("\n",$keywords);
	}
	
	if (empty($OS->errorMessages))
	{
		$oneTopic=new OS_ProjectTopic();
		
		$topic_data=array(
			'project_id'=>$project_id,
			'se_id'=>$se_id,
			'topic'=>$_POST['topic_box']
		);
		
		$oneTopic->set($topic_data);
		
		if ($oneTopic->save())
		{
			$osProjectKeywordOps=$OS->getProjectKeywordOps();
			
			foreach ($keywords as $keyword)
			{
				$oneKeyword=new OS_ProjectKeyword();
				
				$keyword_data=array(
					'project_id'=>$project_id,
					'topic_id'=>$oneTopic->id,
					'keyword'=>$keyword
				);
				
				$oneKeyword->set($keyword_data);
				
				if ($oneKeyword->save())
				{
					$osProjectKeywordOps->fetchCompetitors($oneKeyword,$se->engine,$se->locale);
				}
			}
			
			$eventParams=array(
				'project_id'=>$project_id,
				'search_engine'=>array(
					'engine'=>$se->engine,
					'locale'=>$se->locale
				),
				'topic'=>$_POST['topic_box'],
				'keywords'=>$keywords
			);
			
			OS_Events::triggerEvent('projectTopicAdded',$eventParams);
			
			$OS->redirectTO("/users/project_manage_competition.php?project_id={$project_id}&msg=add_ok");
		}
		else
		{
			$OS->addBoxError(_("Unable to save topic. Try again later"));
		}
	}
}
else
{
	$_POST['topic_box']='';
	$_POST['keywords_box']='';
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Add Project Topic"));
$tpl->addTopSectionOption('cancel',array('type'=>'link','name'=>_("Cancel"),'url'=>$OS->getConfigVar('root_url')."/users/project_manage_competition.php?project_id={$project_id}"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('project_id',$project_id);
$tpl->setVar('se_id',$se_id);

$tpl->selectedMenuItem = 'projects_list';

$tpl->bodyTemplateName = 'project_manage_competition_add';

echo $tpl->mainTemplateRender();
?>