<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUtils = $OS->getUtils();

//verify if user is logged
$osUser->forceUserLogin();

//get project operations
$osProjectOps = $OS->getProjectOps();

if(isset($_GET['project_id']))
{
	$project_id = $_GET['project_id'];
} 
elseif(isset($_POST['project_id']))
{
	$project_id = $_POST['project_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjid");
}

if(isset($_GET['topic_id']))
{
	$topic_id = $_GET['topic_id'];
} 
elseif(isset($_POST['topic_id']))
{
	$topic_id = $_POST['topic_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjtopicid");
}

$osProjectTopicOps=$OS->getProjectTopicOps();

if (!$topic=$osProjectTopicOps->getProjectTopicByID($topic_id,$project_id))
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjtopicid");
}

$osCompetitorOps=$OS->getCompetitorOps();

if ($topicCompetitors=$osCompetitorOps->getCompetitorsByTopicID($topic_id))
{
	foreach ($topicCompetitors as $competitor_id=>$competitor)
	{
		$topicCompetitors[$competitor_id]=$competitor->host;
	}
}
else
{
	$topicCompetitors=array();
}

if ($_SERVER['REQUEST_METHOD']=='POST')
{
	if (empty($_POST['competitor_box']))
	{
		$OS->addFieldError(_("Competitor missing"),'competitor');
	}
	else
	{
		$_POST['competitor_box']=trim($_POST['competitor_box']);
		
		$osUtils=$OS->getUtils();
		$osValidator=$OS->getValidator();
		
		$url=$osUtils->prependHTTP($_POST['competitor_box']);
		
		if (!$osValidator->is_url($url))
		{
			$OS->addFieldError(_("Invalid competitor"),'competitor');
		}
		elseif (!$host=parse_url($url,PHP_URL_HOST))
		{
			$OS->addFieldError(_("Invalid competitor"),'competitor');
		}
	}
	
	if (empty($OS->errorMessages))
	{
		$oneCompetitor=new OS_Competitor();
		
		$competitor_data=array(
			'project_id'=>$project_id,
			'topic_id'=>$topic_id,
			'host'=>$host
		);
		
		$oneCompetitor->set($competitor_data);
		
		if ($oneCompetitor->save())
		{
			$OS->redirectTO("/users/project_manage_competition_competitors.php?project_id={$project_id}&topic_id={$topic_id}&msg=add_ok");
		}
	}
}
else
{
	$_POST['keyword_box']='';
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Add Competitor"));
$tpl->addTopSectionOption('cancel',array('type'=>'link','name'=>_("Cancel"),'url'=>$OS->getConfigVar('root_url')."/users/project_manage_competition_competitors.php?project_id={$project_id}&topic_id={$topic_id}"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('project_id',$project_id);
$tpl->setVar('topic_id',$topic_id);

$tpl->selectedMenuItem = 'projects_list';

$tpl->bodyTemplateName = 'project_manage_competition_competitors_add';

echo $tpl->mainTemplateRender();
?>