<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUtils = $OS->getUtils();

//verify if user is logged
$osUser->forceUserLogin();

//get project operations
$osProjectOps = $OS->getProjectOps();

if(isset($_GET['project_id']))
{
	$project_id = $_GET['project_id'];
} 
elseif(isset($_POST['project_id']))
{
	$project_id = $_POST['project_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjid");
}

if(isset($_GET['topic_id']))
{
	$topic_id = $_GET['topic_id'];
} 
elseif(isset($_POST['topic_id']))
{
	$topic_id = $_POST['topic_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjtopicid");
}

$osProjectTopicOps=$OS->getProjectTopicOps();

if (!$topic=$osProjectTopicOps->getProjectTopicByID($topic_id,$project_id))
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjtopicid");
}

$osProjectKeywordOps=$OS->getProjectKeywordOps();

if ($topicKeywords=$osProjectKeywordOps->getProjectKeywordsByTopicID($topic_id))
{
	foreach ($topicKeywords as $keyword_id=>$keyword)
	{
		$topicKeywords[$keyword_id]=$keyword->keyword;
	}
}
else
{
	$topicKeywords=array();
}

if ($_SERVER['REQUEST_METHOD']=='POST')
{
	if (empty($_POST['keyword_box']))
	{
		$OS->addFieldError(_("Keyword missing"),'keyword');
	}
	else
	{
		$_POST['keyword_box']=trim($_POST['keyword_box']);
		
		if (strlen($_POST['keyword_box'])<3)
		{
			$OS->addFieldError(_("Keyword too short. Minimum length: 3 characters"),'keyword');
		}
		elseif (in_array($_POST['keyword_box'],$topicKeywords))
		{
			$OS->addFieldError(_("Keyword already defined in topic"),'keyword');
		}
	}
	
	if (empty($OS->errorMessages))
	{
		$oneKeyword=new OS_ProjectKeyword();
		
		$keyword_data=array(
			'project_id'=>$project_id,
			'topic_id'=>$topic_id,
			'keyword'=>$_POST['keyword_box']
		);
		
		$oneKeyword->set($keyword_data);
		
		if ($oneKeyword->save())
		{
			$topic->competitors='';
			
			$topic->save();
			
			$OS->redirectTO("/users/project_manage_competition_keywords.php?project_id={$project_id}&topic_id={$topic_id}&msg=add_ok");
		}
	}
}
else
{
	$_POST['keyword_box']='';
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Add Keyword"));
$tpl->addTopSectionOption('cancel',array('type'=>'link','name'=>_("Cancel"),'url'=>$OS->getConfigVar('root_url')."/users/project_manage_competition_keywords.php?project_id={$project_id}&topic_id={$topic_id}"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('project_id',$project_id);
$tpl->setVar('topic_id',$topic_id);

$tpl->selectedMenuItem = 'projects_list';

$tpl->bodyTemplateName = 'project_manage_competition_keywords_add';

echo $tpl->mainTemplateRender();
?>