<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUtils = $OS->getUtils();

//verify if user is logged
$osUser->forceUserLogin();
$osUser->forcePerm('projects_management','edit_project');

if(isset($_GET['project_id']))
{
	$project_id = $_GET['project_id'];
} 
elseif(isset($_POST['project_id']))
{
	$project_id = $_POST['project_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjid");
}

$osProjectOps=$OS->getProjectOps();

if (!$oneProject=$osProjectOps->getProjectByID($project_id))
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjid");
}

//get all system departments
$osDepartmentOps = $OS->getDepartmentOps();

$osDepartments = $osDepartmentOps->getDepartments();

if ($_SERVER['REQUEST_METHOD']=='POST')
{
	//handle project departments
	$newDepartmentsList = array();
	
	foreach($_POST as $key => $val)
	{
		if(strpos($key,"_dep_check_box")!==false)
		{
			$newDepartmentsList[$val] = true;
		}
	}
	
	if (empty($newDepartmentsList))
	{
		$OS->addBoxError(_("You have to select at least one department"),'prj_departments');
	}
	
	if(!isset($OS->errorMessages))
	{
		//get all project's department
		$oldDepartmentsList = array();
		
		$osProjectDepartments = $oneProject->getDepartments();
		if($osProjectDepartments !== false)
		{
			$oldDepartmentsList = array_flip($osProjectDepartments);
		}
		
		
		foreach($osDepartments as $dep_id => $departmentData)
		{
			if(isset($newDepartmentsList[$dep_id]))
			{
				$oneProject->addDepartment($dep_id);
				
				if(isset($oldDepartmentsList[$dep_id]))
				{
					unset($oldDepartmentsList[$dep_id]);
				}
			}
		}
		
		//remove old departments
		if(!empty($oldDepartmentsList))
		{
			foreach($oldDepartmentsList as $dep_id => $dummy)
			{
				$oneProject->removeDepartment($dep_id);
			}
		}
		
		$OS->redirectTO("/users/projects_list.php?msg=prj_departments_ok");
	}
}
else
{
	//get all project's department
	$osProjectDepartments = $oneProject->getDepartments();
	if($osProjectDepartments !== false)
	{
		foreach($osProjectDepartments as $department_id)
		{
			$_POST["{$department_id}_dep_check_box"] = $department_id;
		}
	}
}

//Build users departments
$allDepartments = array();
if(!empty($osDepartments))
{
	foreach($osDepartments as $department_id=>$departmentData) 
	{
		if($departmentData->isActive())
		{
			$allDepartments[$department_id] = array('name' => $departmentData->name,'is_selected'=>(isset($_POST["{$department_id}_dep_check_box"]) ? true : false));	
		}
	}	
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Project Departments"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('allDepartments',$allDepartments);
$tpl->setVar('project_id',$project_id);



$tpl->bodyTemplateName = 'project_manage_departments';

echo $tpl->mainTemplateRender();
?>