<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUtils = $OS->getUtils();

//verify if user is logged
$osUser->forceUserLogin();
$osUser->forcePerm('projects_management','manage_project_kws');

if(isset($_GET['project_id']))
{
	$project_id = $_GET['project_id'];
} 
elseif(isset($_POST['project_id']))
{
	$project_id = $_POST['project_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjid");
}

$osProjectOps=$OS->getProjectOps();

if (!$oneProject=$osProjectOps->getProjectByID($project_id))
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjid");
}

$osSearchEngineOps=$OS->getSearchEngineOps();
$allSearchEngines=$osSearchEngineOps->getAvailableSearchEnginesFull();
$osProjectSearchEngineOps=$OS->getProjectSearchEngineOps();
$prjSearchEngines=$osProjectSearchEngineOps->getProjectSearchEngines($project_id);

if (empty($prjSearchEngines))
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjse");
}
else
{
	$projectSearchEngines=array();
	$osProjectTopicOps=$OS->getProjectTopicOps();
	
	foreach ($prjSearchEngines as $prjSearchEngine)
	{
		if (!$osProjectTopicOps->getProjectTopicsCountBySearchEngineID($prjSearchEngine->id,$project_id))
		{
			if (isset($allSearchEngines[$prjSearchEngine->engine]) AND (($allSearchEngines[$prjSearchEngine->engine]['has_locales']=='Y' AND isset($allSearchEngines[$prjSearchEngine->engine]['_locales'][$prjSearchEngine->locale])) OR $allSearchEngines[$prjSearchEngine->engine]['has_locales']!='Y'))
			{
				$slug=$prjSearchEngine->engine;
				$name=$allSearchEngines[$prjSearchEngine->engine]['title'];
				
				if ($allSearchEngines[$prjSearchEngine->engine]['has_locales']=='Y')
				{
					$name.=' '.$allSearchEngines[$prjSearchEngine->engine]['_locales'][$prjSearchEngine->locale]['title'];
					$slug.='_'.$prjSearchEngine->locale;
				}
				
				$projectSearchEngines[$slug]=array(
					'id'=>$prjSearchEngine->id,
					'name'=>$name,
					'engine'=>$prjSearchEngine->engine,
					'locale'=>$prjSearchEngine->locale,
				);
			}
		}
	}
	
	if (empty($projectSearchEngines))
	{
		$OS->redirectTO("/users/projects_list.php?msg=noprjse");
	}
}

if ($_SERVER['REQUEST_METHOD']=='POST')
{
	$topics=array();
	
	foreach ($projectSearchEngines as $slug=>$details)
	{
		if (!empty($_POST["{$slug}_topics"]))
		{
			$pse_topics=$_POST["{$slug}_topics"];
		}
		else
		{
			$pse_topics=1;
		}
		
		$pse_valid_topics=0;
		for ($i=1;$i<=$pse_topics;$i++)
		{
			if (!empty($_POST["{$slug}_topic_{$i}_box"]) OR !empty($_POST["{$slug}_keywords_{$i}_box"]))
			{
				$keywords=array();
				
				if (empty($_POST["{$slug}_topic_{$i}_box"]))
				{
					$OS->addFieldError(_("Topic name missing"),"{$slug}_topic_{$i}");
				}
				else
				{
					$_POST["{$slug}_topic_{$i}_box"]=trim($_POST["{$slug}_topic_{$i}_box"]);
					
					if (strlen($_POST["{$slug}_topic_{$i}_box"])<3)
					{
						$OS->addFieldError(_("Topic name too short. Minimum length: 3 characters"),"{$slug}_topic_{$i}");
					}
				}
				
				if (empty($_POST["{$slug}_keywords_{$i}_box"]))
				{
					$OS->addFieldError(_("Keywords missing"),"{$slug}_keywords_{$i}");
				}
				else
				{
					$keywords=explode("\n",trim($_POST["{$slug}_keywords_{$i}_box"]));
					
					if (empty($keywords))
					{
						$OS->addFieldError(_("Keywords missing"),"{$slug}_keywords_{$i}");
					}
					else
					{
						foreach ($keywords as $pos=>$keyword)
						{
							$keyword=trim($keyword);
							
							if (empty($keyword))
							{
								unset($keywords[$pos]);
							}
							elseif (strlen($keyword)<3)
							{
								unset($keywords[$pos]);
							}
							else
							{
								$keywords[$pos]=$keyword;
							}
						}
						
						if (empty($keywords))
						{
							$OS->addFieldError(_("Keywords missing"),"{$slug}_keywords_{$i}");
						}
					}
				}
				
				$pse_valid_topics++;
				$topics[$slug][$pse_valid_topics]=array(
					'topic'=>$_POST["{$slug}_topic_{$i}_box"],
					'keywords'=>$keywords
				);
			}
			
			unset($_POST["{$slug}_topic_{$i}_box"],$_POST["{$slug}_keywords_{$i}_box"]);
		}
		
		if (empty($topics[$slug]))
		{
			$topics[$slug][1]=array('topic'=>'','keywords'=>array());
			
			$OS->addFieldError(_("Topic name missing"),"{$slug}_topic_1");
			$OS->addFieldError(_("Keywords missing"),"{$slug}_keywords_1");
		}
		
		foreach ($topics[$slug] as $pos=>$details)
		{
			$_POST["{$slug}_topic_{$pos}_box"]=$details['topic'];
			$_POST["{$slug}_keywords_{$pos}_box"]=implode("\n",$details['keywords']);
		}
		$projectSearchEngines[$slug]['topics']=count($topics[$slug]);
	}
	
	if (empty($OS->errorMessages))
	{
		$osProjectKeywordOps=$OS->getProjectKeywordOps();
		
		foreach ($topics as $slug=>$se_topics)
		{
			$se_id=$projectSearchEngines[$slug]['id'];
			
			foreach ($se_topics as $pos=>$topic)
			{
				$oneTopic=new OS_ProjectTopic();
				
				$topic_data=array(
					'project_id'=>$project_id,
					'se_id'=>$se_id,
					'topic'=>$topic['topic']
				);
				
				$oneTopic->set($topic_data);
				
				if ($oneTopic->save())
				{
					foreach ($topic['keywords'] as $keyword)
					{
						$oneKeyword=new OS_ProjectKeyword();
						
						$keyword_data=array(
							'project_id'=>$project_id,
							'topic_id'=>$oneTopic->id,
							'keyword'=>$keyword
						);
						
						$oneKeyword->set($keyword_data);
						
						$oneKeyword->save();
						
						if ($oneKeyword->save())
						{
							if ($se=$osProjectSearchEngineOps->getProjectSearchEngineByID($se_id))
							{
								$osProjectKeywordOps->fetchCompetitors($oneKeyword,$se->engine,$se->locale);
							}
						}
					}
					
					$eventParams=array(
						'project_id'=>$project_id,
						'search_engine'=>array(
							'engine'=>$projectSearchEngines[$slug]['engine'],
							'locale'=>$projectSearchEngines[$slug]['locale']
						),
						'topic'=>$topic['topic'],
						'keywords'=>$topic['keywords']
					);
					
					OS_Events::triggerEvent('projectTopicAdded',$eventParams);
				}
			}
		}
	}
}
else
{
	foreach ($projectSearchEngines as $slug=>$details)
	{
		$_POST["{$slug}_topic_1_box"]='';
		$_POST["{$slug}_keywords_1_box"]='';
		$projectSearchEngines[$slug]['topics']=1;
	}
}

$projectTopics=array();
foreach ($projectSearchEngines as $slug=>$details)
{
	$projectTopics[$slug]=$details['topics'];
}

$headContents="<script type='text/javascript'>
function addAnotherTopic(slug)
{
	var topicNumber=parseInt($('#'+slug+'_topics').val())+1;
	$('#'+slug+'_topics').val(topicNumber);

	$('#'+slug+'_topics_container').append('<label for=\"'+slug+'_topic_'+topicNumber+'_box\">Topic '+topicNumber+'</label><div><input type=\"text\"  class=\"col_12\" id=\"'+slug+'_topic_'+topicNumber+'_box\" name=\"'+slug+'_topic_'+topicNumber+'_box\" placeholder=\"Example: laptops\"></div><label for=\"'+slug+'_keywords_'+topicNumber+'_box\">Keywords for topic '+topicNumber+'</label><div><textarea style=\"width:100%;\" id=\"'+slug+'_keywords_'+topicNumber+'_box\" name=\"'+slug+'_keywords_'+topicNumber+'_box\" placeholder=\"One keyword per line\"></textarea></div><div class=\"clear\"></div>');
}
</script>";

$tpl = $OS->getTemplate();
$tpl->setHeadContents($headContents);
//handle page topSection
$tpl->setTopSectionTitle(_("Define project keywords"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('project_id',$project_id);

$tpl->setVar('projectSearchEngines',$projectSearchEngines);

$tpl->selectedMenuItem = 'projects_list';

$tpl->bodyTemplateName = 'project_manage_keywords_bulk';

echo $tpl->mainTemplateRender();
?>