<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: /users/project_tracker.php 2012-11-02$
 */

include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();
$osUtils = $OS->getUtils();

//verify if user is logged
$osUser->forceUserLogin();

//get project operations
$osProjectOps = $OS->getProjectOps();

if(isset($_GET['project_id']))
{
	$project_id = $_GET['project_id'];
} 
elseif(isset($_POST['project_id']))
{
	$project_id = $_POST['project_id'];
}
else
{
	$OS->redirectTO("/users/projects_list.php?msg=noprjid");
}


//check if is valid project
$oneProject = $osProjectOps->getProjectByID($project_id);

if($oneProject === false)
{
	$OS->redirectTO("/users/projects_list.php?msg=notfound");
}

$tagCodeSample = $osProjectOps->getProjectTagCode($oneProject->id);

//check if current user has rights to edit these settings
if(isset($_GET['op']))
{
	if($_GET['op'] == 'enable_app')
	{
		if(!empty($_GET['app_id']))
		{
			$osJsTracker = $OS->getJsTracker();
			$result = $osJsTracker->changeTrackerLinkStatus("E", $_GET['app_id'], $project_id);
			if($result == false)
			{
				$OS->addBoxError(_("Could not enable Tracker for this app !"));
			}
			else
			{
				$OS->addInfo(_("Tracker for app was enabled !"));
			}
		}
	}
	elseif($_GET['op'] == 'disable_app')
	{
		if(!empty($_GET['app_id']))
		{
			$osJsTracker = $OS->getJsTracker();
			$result = $osJsTracker->changeTrackerLinkStatus("D", $_GET['app_id'], $project_id);
			if($result == false)
			{
				$OS->addBoxError(_("Could not disable Tracker for this app !"));
			}
			else
			{
				$OS->addInfo(_("Tracker for app was disable !"));
			}
		}
	}
	elseif ($_GET['op']=='check')
	{
		$osHttp=$OS->getHttp();
		
		$response=$osHttp->get($oneProject->url);
		
		if (!empty($response) AND $osHttp->success())
		{
			$osUtils = $OS->getUtils();
		
			$obfuscated_project_id = $osUtils->codePack($project_id, $project_id);
			$obfuscated_project_id = str_replace(".", "-", $obfuscated_project_id);
			
			$search_for="storage/tracker/{$obfuscated_project_id}.js";
			 
			if (false===strpos($response,$search_for))
			{
				$OS->addBoxError(_("Tracking code not found !"));
			}
			else
			{
				$oneProject->js_tracking='Y';
				
				if ($oneProject->save())
				{
					$OS->addInfo(_("Tracking code found. Tracking is active"));
				}
			}
		}
		else
		{
			$OS->addBoxError(_("Unable to access project url !"));
		}
	}
}


$osAppOps = $OS->getAppOps();
$osAvailableApps = $osAppOps->getAvailableApps();

$osTrackerLinksData = array();

if(!empty($osAvailableApps))
{
	$osJsTracker = $OS->getJsTracker();
	$osTrackerLinks = $osJsTracker->getTrackerLinksByProjectId($oneProject->id);
	
	foreach($osTrackerLinks as $index => $linkDetails)
	{
		if(isset($osAvailableApps[$linkDetails['app_id']]))
		{
			$osTrackerLinksData[$index] = array(
				'title' => $osAvailableApps[$linkDetails['app_id']]->title,
				'status' => $linkDetails['status'],
				'enable_link' => ($linkDetails['status'] == 'D'? $OS->getConfigVar('root_url')."/users/project_tag_manager.php?op=enable_app&app_id=".$linkDetails['app_id']."&project_id=".$linkDetails['project_id'] : false),
				'disable_link' => ($linkDetails['status'] == 'E'? $OS->getConfigVar('root_url')."/users/project_tag_manager.php?op=disable_app&app_id=".$linkDetails['app_id']."&project_id=".$linkDetails['project_id']: false),
				);
		}
	}
}


$ptitle = _("Project Tag Manager");

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle($ptitle);

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);


$tpl->setVar('tagCodeSample', $tagCodeSample);

$tpl->setVar('trackingStatus', ($oneProject->js_tracking=='Y'?true:false));
$tpl->setVar('checkTrackingStatusURL', $OS->getConfigVar('root_url')."/users/project_tag_manager.php?op=check&project_id=".$project_id);

$tpl->setVar('trackerLinksData', $osTrackerLinksData);

$tpl->selectedMenuItem = 'projects_list';

$tpl->bodyTemplateName = 'project_tag_manager';

echo $tpl->mainTemplateRender();
?>