<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: /users/forgot.php 2012-01-09$
 */
include "../init.php";

$OS = getOS();

$osUserOps = $OS->getUserOps();
$osUtils = $OS->getUtils();

$show_form = false; $user_ok = false;

if(!empty($_GET['idcode']))
{
	$params = explode('_',$_GET['idcode']);

	if((!empty($params[0])) && (!empty($params[1])))
	{
		$code_ok = false;
		$id = $params[0]; $hash_code = $params[1];

		if($oneUser = $osUserOps->getUserByID($id))
		{
			if($osUtils->generateHash(array($id,$oneUser->email),8) == $hash_code)
			{
				$user_ok = true;		
			}	
		} 
	} 
} 


if($user_ok)
{
	if ($_SERVER['REQUEST_METHOD']=='POST')
	{
		if(empty($_POST["password_box"]))
		{
			$OS->addFieldError(_("Password missing !"),'password_box');	
		} 
		else
		{
			$_POST['password_box'] = $_POST['password_box'];
			
			if((strlen($_POST['password_box'])<3))
			{
				$OS->addFieldError(_("Password too short (min 3 characters)!"),'password_box');	
			}	
		} 
		
		if(!isset($OS->errorMessages))
		{
			$oneUser->setPassword($_POST['password_box']);
			$oneUser->save();
			
			$OS->redirectTO("/users/login.php?msg=pass_changed&user_box={$oneUser->user}");
		}
	}
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Recover password"));

if(!$user_ok)
{
	$OS->addBoxError(_("Bad password reset confirmation code !"));	
}
else
{
	$show_form = true;
	$tpl->setVar('username', $oneUser->user);
	$tpl->setVar('action_url', $OS->getConfigVar('root_url')."/users/recover.php?idcode={$id}_{$hash_code}");
}

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);



$tpl->setVar('show_form',$show_form);

$tpl->selectedMenuItem = "login";

$tpl->bodyTemplateName = 'users_recover';

echo $tpl->mainTemplateRender();
?>