<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */
include "../init.php";

//include required files for login script

$OS = getOS();

if ($_SERVER['REQUEST_METHOD']=='POST')
	{
	$osValidator = $OS->getValidator();
	
	$userOps = $OS->getUserOps();
	
	if (empty($_POST['name_box'])) $OS->addFieldError(_("Name missing"),'name');
	elseif (strlen($_POST['name_box'])<3) $OS->addFieldError(_("Name too short"),'name');
	elseif (!$userOps->isValidName($_POST['name_box'])) $OS->addFieldError(_("Invalid name"),'name');
	else $full_name = $_POST['name_box'];

	if (empty($_POST['email_box'])) $OS->addFieldError(_("Email missing"),'email');
	else{
		$email = trim(strtolower($_POST["email_box"]));
		if(strpos($_POST['email_box'],'www.')===0) $_POST['email_box']=substr($_POST['email_box'],4); 

		if (!$osValidator->is_email($email)) $OS->addFieldError(_("Invalid email")." (".$osValidator->ERROR.")",'email');
		else{
			$result = $userOps->getUserByEmail($email);
			if($result===false) $email_ok=true;
			else $OS->addFieldError(_("Email already registered !"),'email');
			}
		}

	if (empty($_POST['user_box'])) $OS->addFieldError(_("Username missing"),'user');
	elseif (!$userOps->isValidUsername($_POST['user_box'])) $OS->addFieldError(_("Invalid username"),'user');
	elseif (strlen($_POST['user_box'])<6) $OS->addFieldError(_("Username too short (min 6 chars)"),'user');
	else{
		$user = trim(strtolower($_POST["user_box"]));

		$result = $userOps->getUserByUsername($user);
		if($result===false) $user_ok=true;
		else{
			if($result['email']!=$_POST['email_box'])$OS->addFieldError(_("Username already registered !"),'user');
			else{header("Location: {$OS->getConfigVar('root_url')}/users/login.php?msg=user_exists&user_box={$result['user']}");exit;}
			}
		}

	if (empty($_POST['password1_box'])) $OS->addFieldError(_("Password missing"),'password');
	elseif ($_POST['password1_box']!=$_POST['password2_box']) $OS->addFieldError(_("Passwords do not match"),'password');
	elseif (strlen($_POST['password1_box'])<6) $OS->addFieldError(_("Password too short"),'password');
	else $password = $_POST['password1_box'];
	
	/*
	$timezone_ok=false;
	if(!isset($_POST['timezone_box'])) $OS->addFieldError("Timezone missing","timezone");
	elseif($_POST['timezone_box']=='') $OS->addFieldError("Timezone missing","timezone");
	elseif(!isset($tz[$_POST['timezone_box']])) $OS->addFieldError("Invalid timezone","timezone");
	else $timezone_ok=true;
	*/
	
	//add login user failed
	
	if(!isset($OS->errorMessages))
		{
		$oneUser->getUser();
		$oneUser->user = $user;
		$oneUser->setPassword($password);
		$oneUser->name = $full_name;
		$oneUser->email = $email;
		$response = $oneUser->save();
		}
	}
	
	
$template_name = 'default';

$tpl = $OS->getTemplate();

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('ptitle',_("User Register"));


$tpl->bodyTemplateName = 'users_register';

echo $tpl->mainTemplateRender();
?>