<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include "../init.php";

$OS = getOS();

$osUser =  $OS->getUser();

//verify if user is logged
$osUser->forceUserLogin();

$osUserOps = $OS->getUserOps();

//get users statuses
$userStatuses = $osUserOps->getStatuses();

//handle current operations
$available_ops = array('add','edit');
if(isset($_GET['op'])) $op = $_GET['op']; 
elseif(isset($_POST['op'])) $op = $_POST['op'];
else $op = 'add';
if(!in_array($op,$available_ops)) {header("Location: ".$OS->getConfigVar('root_url')."/users/users_list.php?msg=badop");exit;}

//handle user_id (if editing a user)
if($op == 'edit')
{
	if(isset($_GET['user_id'])) $user_id = $_GET['user_id']; 
	elseif(isset($_POST['user_id'])) $user_id = $_POST['user_id'];
	else {header("Location: ".$OS->getConfigVar('root_url')."/users/users_list.php?msg=nousrid");exit;}
}


//get timezone data
$osTimezonesList = $OS->getTimezonesList();

//get languages data
$osLanguagesList = $OS->getLanguagesList();

//get all system departments
$osDepartmentOps = $OS->getDepartmentOps();

$osDepartments = $osDepartmentOps->getDepartments();

if ($_SERVER['REQUEST_METHOD']=='POST')
{
	$osValidator = $OS->getValidator();
	
	if (empty($_POST['name_box'])) 
	{
		$OS->addFieldError(_("Name missing"),'name');	
	}
	elseif (strlen($_POST['name_box'])<3) 
	{
		$OS->addFieldError(_("Name too short"),'name');	
	}
	elseif (!$osUserOps->isValidName($_POST['name_box'])) 
	{
		$OS->addFieldError(_("Invalid name"),'name');	
	}
	else
	{
		$full_name = $_POST['name_box'];
	} 

	if (empty($_POST['email_box']))
	{
		$OS->addFieldError(_("Email missing"),'email');	
	} 
	else
	{
		$email = trim(strtolower($_POST["email_box"]));
		if(strpos($_POST['email_box'],'www.')===0) $_POST['email_box']=substr($_POST['email_box'],4);
		
		if (!$osValidator->is_email($email)) $OS->addFieldError(_("Invalid email")." (".$osValidator->ERROR.")",'email');
		else{
				$oneUser = $osUserOps->getUserByEmail($email);
				if($oneUser === false)
				{
					$email_ok = true;	
				} 
				else
				{
					if($op == 'add')
					{
						$OS->addFieldError(_("Email already registered !"),'email');
					}
					elseif($op == 'edit')
					{
						$oldUser = $osUserOps->getUserByID($user_id);
						if($oldUser !== false)
						{
							if($oneUser->id != $oldUser->id)
							{
								$OS->addFieldError(_("Email already registered !"),'email');	
							}
							else
							{
								$email_ok = true;
							}
						}
					}
				} 
			}
	}

	if (empty($_POST['user_box']))
	{
		$OS->addFieldError(_("Username missing"),'user');
	} 
	elseif (!$osUserOps->isValidUsername($_POST['user_box']))
	{
		$OS->addFieldError(_("Invalid username"),'user');	
	} 
	elseif (strlen($_POST['user_box'])<6) 
	{
		$OS->addFieldError(_("Username too short (min 6 chars)"),'user');	
	}
	else
	{
		$_POST["user_box"] = trim(strtolower($_POST["user_box"]));

		if($op == 'add')
		{
			$result = $osUserOps->getUserByUsername($_POST["user_box"]);
			if($result!==false)
			{
				$OS->addFieldError(_("Username already registered !"),'user');
			} 
			else
			{
				$user = $_POST["user_box"];
			}
		}
	}

	if (empty($_POST['password1_box'])) 
	{
		if($op=='add')
		{
			$OS->addFieldError(_("Password missing"),'password');	
		}
		else
		{
			$_POST['password1_box'] = '';
		}	
	}
	elseif ($_POST['password1_box'] != $_POST['password2_box']) 
	{
		$OS->addFieldError(_("Passwords do not match"),'password');	
	}
	elseif (strlen($_POST['password1_box'])<6)
	{
		$OS->addFieldError(_("Password too short"),'password');	
	} 
	else 
	{
		$password = $_POST['password1_box'];
	}


	if (empty($_POST['status_box'])) 
	{
		$OS->addFieldError(_("Status missing"),'status');	
	}
	elseif (!isset($userStatuses[$_POST['status_box']])) 
	{
		$OS->addFieldError(_("Invalid Status"),'status');	
	}
	else
	{
		$user_status = $_POST['status_box'];	
	}

	if(!isset($_POST['timezone_box'])) 
	{
		$OS->addFieldError(_("Timezone missing"),"timezone");
	}
	elseif($_POST['timezone_box']=='') 
	{
		$OS->addFieldError(_("Timezone missing"),"timezone");
	}
	elseif(!isset($osTimezonesList[$_POST['timezone_box']])) 
	{
		$OS->addFieldError(_("Invalid timezone"),"timezone");
	}
	else
	{
		$user_timezone = $_POST['timezone_box'];
	}

	if(empty($_POST['language_box'])) 
	{
		$OS->addFieldError(_("Language missing"),"language");
	}
	elseif(!isset($osLanguagesList[$_POST['language_box']])) 
	{
		$OS->addFieldError(_("Invalid language"),"language");
	}
	else
	{
		$user_language = $_POST['language_box'];
	}
	
	
	$user_admin  = (isset($_POST['is_admin_box'])? "Y" : "");
	
	//handle project departments
	$newDepartmentsList = array();
	
	foreach($_POST as $key => $val)
	{
		if(strpos($key,"_check_box")!==false)
		{
			$newDepartmentsList[$val] = true;
		}
	}
	
	if (empty($newDepartmentsList))
	{
		//TODO: Field not Box
		$OS->addBoxError(_("You must select at least one department"),'departments'); 
	}
	
	if(!isset($OS->errorMessages))
	{
		$oneUser = new OS_User();
		$oneUser->name = $full_name;
		$oneUser->email = $email;
		$oneUser->status = $user_status;
		$oneUser->timezone = $osTimezonesList[$user_timezone];
		$oneUser->language = $user_language;
		
		if($op == 'add')
		{
			$oneUser->user = $user;
			$oneUser->setPassword($password);
		}
		elseif($op == 'edit')
		{
			$oneUser->id = $user_id;
			if(!empty($password))
			{
				$oneUser->setPassword($password);
			} 
		}
		
		$response = $oneUser->save();

		if($response !== false)
		{
			//get all project's department
			$oldDepartmentsList = array();
			
			$osUserDepartments = $oneUser->getDepartments();
			if($osUserDepartments !== false)
			{
				$oldDepartmentsList = array_flip($osUserDepartments);
			}
			
			
			foreach($osDepartments as $dep_id => $departmentData)
			{
				if(isset($newDepartmentsList[$dep_id]))
				{
					$oneUser->addDepartment($dep_id);
					
					if(isset($oldDepartmentsList[$dep_id]))
					{
						unset($oldDepartmentsList[$dep_id]);
					}
				}
			}
			
			//remove old departments
			if(!empty($oldDepartmentsList))
				{
					foreach($oldDepartmentsList as $dep_id => $dummy)
					{
						$oneUser->removeDepartment($dep_id);
					}
				}
				
			$OS->redirectTO("/users/users_list.php?msg=usr_{$op}_ok");	
		}
		else
		{
			$OS->addBoxError(_("User cannot be modified"));
		}
	}
}
else
{
	if($op == 'add')
	{
		$_POST['status_box'] = "A"; 
	}
	elseif($op == 'edit')
	{
		$oneUser = $osUserOps->getUserByID($user_id);
		
		if($oneUser !== false)
		{
			$_POST['user_box'] = $oneUser->user;
			$_POST['name_box'] = $oneUser->name;
			$_POST['status_box'] = $oneUser->status;
			$_POST['email_box'] = $oneUser->email;
			$_POST['timezone_box'] = array_search($oneUser->timezone,$osTimezonesList);
			$_POST['language_box'] = $oneUser->language;
			//$_POST['admin_box'] = ($oneUser->isadmin?"Y":"");

			//get all users's departments
			$osUserDepartments = $oneUser->getDepartments();
			if($osUserDepartments !== false)
			{
				foreach($osUserDepartments as $department_id)
				{
					$_POST["{$department_id}_usr_check_box"] = $department_id;
				}
			}
		}
	}
}



//Build users departments
$allDepartments = array();
if(!empty($osDepartments))
{
	foreach($osDepartments as $department_id=>$departmentData) 
	{
		if($departmentData->isActive())
		{
			$allDepartments[$department_id] = array('name' => $departmentData->name,'is_selected'=>(isset($_POST["{$department_id}_usr_check_box"]) ? true : false));	
		}
	}	
}

$allDepartments = array_chunk($allDepartments, 2, true);

//Build timezones data
$allTimezones = array();
if(!empty($osTimezonesList))
{
	foreach($osTimezonesList as $identifier=>$tzname)
	{
		$selected = false;
		if(isset($_POST['timezone_box'])) if($_POST['timezone_box'] == $identifier) $selected = true; 
		
		$allTimezones[$identifier] = array('name'=>$tzname,'is_selected'=> $selected);
	}
}

//Build languages data
$allLanguages = array();
if(!empty($osLanguagesList))
{
	foreach($osLanguagesList as $identifier=>$cdata)
	{
		$allLanguages[$identifier] = array('name'=>$cdata['name'],'is_selected'=>(isset($_POST['language_box']) ? ($_POST['language_box'] == $identifier ? true:false) : false));
	}
}


//Build Languages data

//setup page title
$ptitle = ($op=='add'?_("Add New User"):_("Edit User"));
 

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle($ptitle);
$tpl->addTopSectionOption('cancel',array('type'=>'link','name'=>_("Cancel"),'url'=>$OS->getConfigVar('root_url')."/users/users_list.php"));


$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);



$tpl->setVar('op',$op);

$tpl->setVar('userStatuses',$userStatuses);

$tpl->setVar('allDepartments',$allDepartments);

$tpl->setVar('allTimezones',$allTimezones);

$tpl->setVar('allLanguages',$allLanguages);

if($op=='edit') $tpl->setVar('user_id',$user_id);

$tpl->selectedMenuItem = "users_list";

$tpl->bodyTemplateName = 'user_manage';

echo $tpl->mainTemplateRender();
?>