<?php
include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

//check if user is logged
$osUser->forceUserLogin();

if(isset($_GET['user_id']))
{
	$user_id = $_GET['user_id'];
} 
elseif(isset($_POST['user_id']))
{
	$user_id = $_POST['user_id'];
}
else
{
	$OS->redirectTO("/users/users_list.php?msg=badusrid");
}

$osUserOps=$OS->getUserOps();
if (!$user=$osUserOps->getUserByID($user_id))
{
	$OS->redirectTO("/users/users_list.php?msg=badusrid");
}

if (isset($_GET['project_id']))
{
	$project_id=$_GET['project_id'];
}
elseif (isset($_POST['project_id']))
{
	$project_id=$_POST['project_id'];
}
else
{
	$OS->redirectTO("/users/user_manage_apps.php?user_id={$user_id}&msg=noprjid");
}

if ($project_id!=0)
{
	$osProjectOps=$OS->getProjectOps();
	
	if (!$project=$osProjectOps->getProjectByID($project_id))
	{
		$OS->redirectTO("/users/user_manage_apps.php?user_id={$user_id}&msg=noprjid");
	}
	
	$userDepartments=$user->getDepartments();
	$projectDepartments=$project->getDepartments();
	
	if (!array_intersect($projectDepartments,$userDepartments))
	{
		$OS->redirectTO("/users/user_manage_apps.php?user_id={$user_id}&msg=noprjid");
	}
}

//get All System permission options
$osPermissions = $OS->getPermissions();
$PermissionsResponse = $osPermissions->getAppsPermissions();

$osAppOps=$OS->getAppOps();

$allPermissions = array();
if($PermissionsResponse !== false)
{
	foreach($PermissionsResponse as $module => $moduleData)	
	{
		if ($app=$osAppOps->getAppByName($module))
		{
			$human_module = $app->title;
			$allPermissions[$module] = array('name'=>$human_module);
	
			foreach($moduleData as $perm => $permData)
			{
				$allPermissions[$module]['permissions'][$perm] = array('name' => $permData['name']);
			}
		}
	}
}

$user->loadPerms();

if ($_SERVER['REQUEST_METHOD']=='POST')
{

	$tmpData = array();
	
	foreach($_POST as $key => $val)
	{
		if(strpos($key,"_radio_box")!==false)
		{
			$tmodule = str_replace("_radio_box","_module_box",$key);
			$tperm = str_replace("_radio_box","_perm_box",$key);
			
			if(isset($_POST[$tmodule],$_POST[$tperm]))
			{
				$tmpData[$_POST[$tmodule]][$_POST[$tperm]] = $val;		
			}
		}
	}
	
	if(!isset($OS->errorMessages))
	{

		//get all user's permissions
		$tmpUsrPermissions = $user->getPerms();
		
		
		foreach($tmpData as $module=>$moduleData)
		{
			foreach($moduleData as $perm=>$op)
			{
				if($op != 'I')
				{
					$user->addPerm($project_id,$module, $perm, $op);
					if(isset($tmpUsrPermissions['U'][$project_id][$module][$perm]))
					{
						unset($tmpUsrPermissions['U'][$project_id][$module][$perm]);	
					}
				}
			}
		}
		
		//remove all permissions that are not checked
		if(!empty($tmpUsrPermissions['U']))
		{
			foreach($tmpUsrPermissions['U'] as $module => $moduleData)
			{
				foreach($moduleData as $perm => $permValue)
				{
					if (isset($PermissionsResponse[$module][$perm]))
					{
						$user->removePerm($project_id,$module,$perm);
					}
				}	
			}
		}
		
		//jump to users list
		$OS->redirectTO("/users/users_list.php?msg=usrperm_ok");
	}
}

//Build initial permissions values
$tmpPermissions = array(); $realPermissions = array();

if(!empty($PermissionsResponse))
{
	foreach($PermissionsResponse as $module => $moduleData)
	{
		foreach($moduleData as $perm => $permData)
		{
			$tmpPermissions[$module][$perm] = "I";
			$realPermissions[$module][$perm] = "R";
		}
	}	
}


//get current user permissions
$userPermissions = $user->getPerms();

if(!empty($userPermissions))
{
	if(isset($userPermissions['D']))
	{
		foreach($userPermissions['D'] as $dep_id=>$depData)
		{
			if (!empty($depData[0]))
			{
				foreach($depData[0] as $module => $permData)
				{
					foreach($permData as $perm => $op)
					{
						$realPermissions[$module][$perm] = "A";	
					}
				}
			}
			
			if ($project_id!=0 AND !empty($depData[$project_id]))
			{
				foreach($depData[$project_id] as $module => $permData)
				{
					foreach($permData as $perm => $op)
					{
						$realPermissions[$module][$perm] = $op;	
					}
				}
			}
		}
	}
	
	
	if(isset($userPermissions['U']))
	{
		if (!empty($userPermissions['U'][0]))
		{
			foreach($userPermissions['U'][0] as $module => $permData)
			{
				foreach($permData as $perm => $op)
				{
					if ($project_id==0)
					{
						$tmpPermissions[$module][$perm] = $op;
					}
					
					$realPermissions[$module][$perm] = $op;
				}
			}
		}
		
		if ($project_id!=0 AND !empty($userPermissions['U'][$project_id]))
		{
			foreach($userPermissions['U'][$project_id] as $module => $permData)
			{
				foreach($permData as $perm => $op)
				{
					$tmpPermissions[$module][$perm] = $op;
					$realPermissions[$module][$perm] = $op;
				}
			}
		}
	}
}

if(!empty($tmpPermissions))
{
	foreach($tmpPermissions as $module=>$moduleData)
	{
		foreach($moduleData as $perm => $op)
		{
			if(!isset($_POST["{$module}_{$perm}_radio_box"])) $_POST["{$module}_{$perm}_radio_box"] = $op;			
		}
	}
}




$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(($project_id==0?_("Manage User Global Apps"):_("Manage User Project Apps")));

$tpl->setVar('errors',$OS->errorMessages);

$tpl->setVar('info',$OS->infoMessages);



$tpl->setVar('user_id',$user_id);
$tpl->setVar('project_id',$project_id);

$tpl->setVar('allPermissions',$allPermissions);

$tpl->setVar('realPermissions',$realPermissions);

$tpl->selectedMenuItem = "users_list";

$tpl->bodyTemplateName = 'user_manage_apps_project';

echo $tpl->mainTemplateRender();

?>