<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include "../init.php";

$OS = getOS();

$osUser = $OS->getUser();

//check if user is logged
$osUser->forceUserLogin();

//handle current department_id
if(isset($_GET['user_id'])) $user_id = $_GET['user_id']; 
elseif(isset($_POST['user_id'])) $user_id = $_POST['user_id'];
else{header("Location: ".$OS->getConfigVar('root_url')."/users/users_list.php?msg=badusrid");exit;}


//get All System permission options
$osPermissions = $OS->getPermissions();

$osAllPermissions = $osPermissions->getCorePermissions();

$allPermissions = array(); 
if($osAllPermissions !== false)
{
	foreach($osAllPermissions as $module => $moduleData)	
	{
		$human_module = ucwords(str_replace("_"," ",$module));
		$allPermissions[$module] = array('name'=>$human_module);

		foreach($moduleData as $perm => $permData)
		{
			$allPermissions[$module]['permissions'][$perm] = array('name' => $permData['name']);
		}
	}
}

//Get current department permissions
$osUsersOps = $OS->getUserOps();

//get user data
$oneUser = $osUsersOps->getUserByID($user_id);
		
//Load department permissions
$oneUser->loadPerms();


if ($_SERVER['REQUEST_METHOD']=='POST')
{

	$tmpData = array();
	
	foreach($_POST as $key => $val)
	{
		if(strpos($key,"_radio_box")!==false)
		{
			$tmodule = str_replace("_radio_box","_module_box",$key);
			$tperm = str_replace("_radio_box","_perm_box",$key);
			
			if(isset($_POST[$tmodule],$_POST[$tperm]))
			{
				$tmpData[$_POST[$tmodule]][$_POST[$tperm]] = $val;		
			}
		}
	}
	
	if(!isset($OS->errorMessages))
	{

		//get all user's permissions
		$tmpUsrPermissions = $oneUser->getPerms();
		
		
		foreach($tmpData as $module=>$moduleData)
		{
			foreach($moduleData as $perm=>$op)
			{
				if($op != 'I')
				{
					$oneUser->addPerm(0,$module, $perm, $op);
					if(isset($tmpUsrPermissions['U'][0][$module][$perm]))
					{
						unset($tmpUsrPermissions['U'][0][$module][$perm]);	
					}
				}
			}
		}
		
		//remove all permissions that are not checked
		if(!empty($tmpUsrPermissions['U'][0]))
		{
			foreach($tmpUsrPermissions['U'][0] as $module => $moduleData)
			{
				foreach($moduleData as $perm => $permValue)
				{
					if (isset($osAllPermissions[$module][$perm]))
					{
						$oneUser->removePerm(0,$module,$perm);
					}
				}	
			}
		}
		
		//jump to users list
		$OS->redirectTO("/users/users_list.php?msg=usrperm_ok");
	}
}

//Build initial permissions values
$tmpPermissions = array(); $realPermissions = array();

$isAdmin=$oneUser->isUserAdmin();

if(!empty($osAllPermissions))
{
	foreach($osAllPermissions as $module => $moduleData)
	{
		foreach($moduleData as $perm => $permData)
		{
			$tmpPermissions[$module][$perm] = "I";
			$realPermissions[$module][$perm] = ($isAdmin?"A":"R");
		}
	}	
}


//get current user permissions
$oneUserPermissions = $oneUser->getPerms();

if(!empty($oneUserPermissions))
{
	if(isset($oneUserPermissions['D']))
	{
		foreach($oneUserPermissions['D'] as $dep_id=>$depData)
		{
			foreach($depData[0] as $module => $permData)
			{
				foreach($permData as $perm => $op)
				{
					$realPermissions[$module][$perm] = "A";	
				}
			}
		}
	}
	
	
	if(isset($oneUserPermissions['U']))
	{
		foreach($oneUserPermissions['U'][0] as $module => $permData)
		{
			foreach($permData as $perm => $op)
			{
				$tmpPermissions[$module][$perm] = $op;
				$realPermissions[$module][$perm] = $op;
			}
		}
	}
}

if(!empty($tmpPermissions))
{
	foreach($tmpPermissions as $module=>$moduleData)
	{
		foreach($moduleData as $perm => $op)
		{
			if(!isset($_POST["{$module}_{$perm}_radio_box"])) $_POST["{$module}_{$perm}_radio_box"] = $op;			
		}
	}
}

$tpl = $OS->getTemplate();

//handle page topSection
$tpl->setTopSectionTitle(_("Manage User Permissions"));

$tpl->setVar('errors',$OS->errorMessages);
$tpl->setVar('info',$OS->infoMessages);

$tpl->setVar('user_id',$user_id);
$tpl->setVar('allPermissions',$allPermissions);
$tpl->setVar('realPermissions',$realPermissions);

$tpl->selectedMenuItem = "users_list";

$tpl->bodyTemplateName = 'user_manage_permissions';

echo $tpl->mainTemplateRender();
?>