<?php
/*                                                                                                                                                                                                    
 *+---------------------------------------------------------------------------+
 *| OpenS v0.1                                                                |
 *| ==========                                                                |
 *|                                                                           |
 *| Copyright (c) 2011-2012 OpenS                                             |
 *| For contact details, see: http://www.opens.org/                           |
 *|                                                                           |
 *| This program is free software; you can redistribute it and/or modify      |
 *| it under the terms of the GNU General Public License as published by      |
 *| the Free Software Foundation; either version 2 of the License, or         |
 *| (at your option) any later version.                                       |
 *|                                                                           |
 *| This program is distributed in the hope that it will be useful,           |
 *| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
 *| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
 *| GNU General Public License for more details.                              |
 *|                                                                           |
 *| You should have received a copy of the GNU General Public License         |
 *| along with this program; if not, write to the Free Software               |
 *| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
 *+---------------------------------------------------------------------------+
 *$Id: os_core.php 2012-01-09$
 */

include('../init.php');

$OS=getOS();
$user=$OS->getUser();$user->forceUserLogin();
$project=$OS->getProject();$project->forceProjectSelected();

if (!empty($_GET['wid'])) $widget_id = $_GET['wid'];
else $widget_id = false;

$widgetHandler = $OS->getWidgetHandler();
$widgetHandler->id = $widget_id;
$widgetHandler->load();

if ($widget=$widgetHandler->loadWidget())
{
	//show main template
	$tpl = $OS->getTemplate();
	
	$tpl->template_name = 'main_stripped';
	
	//default widget template cache time - 15 mins
	$widgetMaxCacheTime = (30);
	if (isset($_GET['cache_time']))
	{
		if(is_numeric($_GET['cache_time']))
		{
			if($_GET['cache_time'] >= 0)
			{
				$widgetMaxCacheTime = $_GET['cache_time'];
			}
		}	
	}
	
	if(!$tpl->cacheValid($widgetMaxCacheTime))
	{
		$root_url = $OS->getConfigVar('root_url');
		
		$headContents = array(
			'css' => array(
				'kickstart-buttons.css' => $root_url.'/lib/css/kickstart-buttons.css',
				'kickstart-forms.css' => $root_url.'/lib/css/kickstart-forms.css',
				'kickstart-menus.css' => $root_url.'/lib/css/kickstart-menus.css',
				'kickstart-grid.css' => $root_url.'/lib/css/kickstart-grid.css',
				'kickstart-icons.css' => $root_url.'/lib/css/kickstart-icons.css',
				'jquery.fancybox.css' => $root_url.'/lib/css/jquery.fancybox-1.3.4.css',
				'prettify.css' => $root_url.'/lib/css/prettify.css',
				'chosen.css' => $root_url.'/lib/css/chosen.css',
				'tiptip.css' => $root_url.'/lib/css/tiptip.css',
				'kickstart-strip.css' => $root_url.'/lib/css/kickstart-strip.css',
				'style.css' => $root_url.'/lib/css/style.css',
				'style_stripped.css' => $root_url.'/lib/css/style_stripped.css',
				),
			'js' => array(
				'jquery.min.js' => $root_url.'/lib/javascript/jquery/jquery-1.7.1.min.js',
				'prettify.js' => $root_url.'/lib/javascript/kickstart/prettify.js',
				'kickstart.js' => $root_url.'/lib/javascript/kickstart/kickstart.js',
				'kernel.boot.js' => $root_url.'/lib/javascript/core/kernel.boot.js',
				),
			'html5shiv.googlecode.com' => '<!--[if lt IE 9]><script src="http://html5shiv.googlecode.com/svn/trunk/html5.js"></script><![endif]-->'	
			);	
			
		$tpl->setHeadContents($headContents);
		
		$widgetResponse = $widgetHandler->processRequest();
		
		if ($widgetResponse)
		{
			$first_open = true;
			if ($openedWidgets=$OS->getSessionVar('opened_widgets',$widgetHandler->id))
			{
				$first_open = false;
			}
			
			if ($first_open)
			{
				$widgetStatsOps = $OS->getWidgetStatsOps();
				$widgetStatsOps->log($widgetHandler->main_widget_id,$widgetHandler->name,'open');
				
				$OS->setSessionVar('opened_widgets',array($widgetHandler->id=>true));
			}
			
			//set body contents
			$tpl->setBodyContents($widgetResponse);
		}
	}
	
	//render templates from themes dir 
	$tpl->setTemplateDir(os_join_path($OS->getConfigVar('root_path'), "themes", $OS->getConfigVar('theme_name')));
	
	echo $tpl->mainTemplateRender('main_stripped', true);
}
?>